/**
 * scratchblocks v3.6.3
 * https://scratchblocks.github.io/
 * Render scratchblocks code to SVG images.
 *
 * Copyright 2013–2023, Tim Radvan
 * @license MIT
 */

(function () {
  'use strict';

  var commands$1d = {
  	MOTION_MOVESTEPS: "ицатәуп %1 шьаҿак",
  	MOTION_TURNRIGHT: "иргьежьтәуп @turnRight %1 градус рыла",
  	MOTION_TURNLEFT: "иргьежьтәуп  @turnLeft %1 градус рыла",
  	MOTION_POINTINDIRECTION: "инарҳәтәуп %1 ахь",
  	MOTION_POINTTOWARDS: "%1 ахь инаҳәтәуп",
  	MOTION_GOTOXY: "ииастәуп x: %1 y: %2 ахь",
  	MOTION_GOTO: "ииастәуп %1 ахь",
  	MOTION_GLIDESECSTOXY: "иқәҵәраатәуп x: %2 y: %3 ахь %1 секундк",
  	MOTION_GLIDETO: "иқәҵәраатәуп %2 ахь %1 секундк",
  	MOTION_CHANGEXBY: "иԥсахтәуп x %1 ала",
  	MOTION_SETX: "иқәыргылатәуп x %1 аҟны",
  	MOTION_CHANGEYBY: "иԥсахтәуп y %1 ала",
  	MOTION_SETY: "иқәыргылатәуп y %1 аҟны",
  	MOTION_SETROTATIONSTYLE: "иқәыргылатәуп аргьежьра астиль %1",
  	LOOKS_SAYFORSECS: "иҳәалатәуп %1 %2 секундк",
  	LOOKS_SAY: "иҳәатәуп %1",
  	LOOKS_THINKFORSECS: "ахәыцра %1 %2  секундк",
  	LOOKS_THINK: "ахәыцра %1",
  	LOOKS_SHOW: "ацәырҵра",
  	LOOKS_HIDE: "аҽыҵәахра",
  	LOOKS_SWITCHCOSTUMETO: "иԥсахтәуп акостиум %1 ала",
  	LOOKS_NEXTCOSTUME: "анаҩстәи акостиум",
  	LOOKS_NEXTBACKDROP_BLOCK: "анаҩстәи аҿаԥшыра",
  	LOOKS_SWITCHBACKDROPTO: "иԥсахтәуп аҿаԥшыра %1 ала",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "иԥсахтәуп аҿаԥшыра %1 ала  нас иԥштәуп",
  	LOOKS_CHANGEEFFECTBY: "иԥсахтәуп аеффект %1  %2 ала",
  	LOOKS_SETEFFECTTO: "иқәыргылатәуп аеффект %1 %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "иқәгатәуп аграфикатә еффектқәа",
  	LOOKS_CHANGESIZEBY: "иԥсахтәуп ашәагаа %1 ала",
  	LOOKS_SETSIZETO: "иқәыргылатәуп ашәагаа  %1 %",
  	LOOKS_GOTOFRONTBACK: "ииастәуп %1 аҿыгҳара ахь",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ииастәуп %1 %2 ҿыгҳарак",
  	SOUND_PLAY: "иаҿактәуп абжьы %1",
  	SOUND_CHANGEEFFECTBY: "иԥсахтәуп  %1 аеффект %2 ала",
  	SOUND_SETEFFECTO: "иқәыргылатәуп аеффект %1  %2 аҟны",
  	SOUND_CLEAREFFECTS: "иқәгатәуп абжьы аеффектқәа",
  	SOUND_PLAYUNTILDONE: "иргатәуп абжьы %1 инҵәаанӡа",
  	SOUND_STOPALLSOUNDS: "иаанкылатәуп абжьқәа зегьы",
  	"music.playDrumForBeats": "ихәмартәуп адаулқәа %1 рҟны %2 битк",
  	"music.restForBeats": "ааҭгылара аамҭала %1 битк",
  	"music.playNoteForBeats": "анота %1 ихәмартәуп %2 тактк",
  	"music.setInstrument": "иқәыргылатәуп амаруга %1",
  	SOUND_CHANGEVOLUMEBY: "иԥсахтәуп абжьы %1 ала",
  	SOUND_SETVOLUMETO: "иқәыргылатәуп абжьы адура %1%",
  	"music.changeTempo": "иԥсахтәуп атемп %1 ала",
  	"music.setTempo": "иқәыргылатәуп атемп %1",
  	"pen.clear": "ианыхтәуп зегьы",
  	"pen.stamp": "аштамп",
  	"pen.penDown": "акалам лашьҭтәуп",
  	"pen.penUp": "акалам иҩахатәуп",
  	"pen.setColor": "иқәыргылатәуп акалам аԥштәы %1",
  	"pen.changeHue": "иԥсахтәуп акалам аԥштәы %1 ала",
  	"pen.setColorParam": "иқәыргылатәуп акалам %1 %2 аҟны",
  	"pen.changeColorParam": "иԥсахтәуп акалам %1%2 ала",
  	"pen.setHue": "иқәыргылатәуп акалам аԥштәы %1",
  	"pen.changeShade": "иԥсахтәуп акалам агага %1 ала",
  	"pen.setShade": "иқәыргылатәуп акалам агага %1",
  	"pen.changeSize": "иԥсахтәуп акалам ашәагаа %1 ала",
  	"pen.setSize": "иқәыргылатәуп акалам ашәагаа %1",
  	EVENT_WHENFLAGCLICKED: "@greenFlag ҳанақәыӷәӷәалакь",
  	EVENT_WHENKEYPRESSED: "аклавиша %1 ҳанақәыӷәӷәалакь",
  	EVENT_WHENTHISSPRITECLICKED: "анагӡаҩ ҳаниқәыӷәӷәалакь",
  	EVENT_WHENSTAGECLICKED: "асцена ҳанақәыӷәӷәалакь",
  	EVENT_WHENBACKDROPSWITCHESTO: "аҿаԥшыра %1 ала аҽанаԥсахлакь",
  	EVENT_WHENGREATERTHAN: "%1 > %2 анакәу",
  	EVENT_WHENBROADCASTRECEIVED: "%1 аус арура",
  	EVENT_BROADCAST: "идәықәҵатәуп %1",
  	EVENT_BROADCASTANDWAIT: "идәықәҵатәуп %1 нас иԥштәуп",
  	CONTROL_WAIT: "иԥштәуп %1 секундк",
  	CONTROL_REPEAT: "инагӡалатәуп %1 - нтә",
  	CONTROL_FOREVER: "инагӡалатәуп еснагь",
  	CONTROL_IF: "%1 акәзар",
  	CONTROL_WAITUNTIL: "иԥштәуп %1 -нӡа",
  	CONTROL_REPEATUNTIL: "инагӡалатәуп %1 акәымзар",
  	CONTROL_STOP: "иаанкылатәуп %1",
  	CONTROL_STARTASCLONE: "сара аклон ҳасабла саналаго",
  	CONTROL_CREATECLONEOF: "иаԥҵатәуп аклон %1",
  	CONTROL_DELETETHISCLONE: "ианыхтәуп ари аклон",
  	SENSING_ASKANDWAIT: "иазҵаатәуп %1 нас иԥштәуп",
  	"videoSensing.videoToggle": "иаҿактәуп авидео %1",
  	"videoSensing.setVideoTransparency": "иқәыргылатәуп авидео аҵәцара %1",
  	"videoSensing.whenMotionGreaterThan": "авидео аласра > %1 анакәу",
  	SENSING_RESETTIMER: "атаимер рҿыцтәуп",
  	DATA_SETVARIABLETO: "%1 иаҭатәуп %2",
  	DATA_CHANGEVARIABLEBY: "иԥсахтәуп %1 %2 ала",
  	DATA_SHOWVARIABLE: "иаарԥштәуп аҽеиҭак %1",
  	DATA_HIDEVARIABLE: "иҵәахтәуп аҽеиҭак %1",
  	DATA_ADDTOLIST: "иацҵатәуп %1 %2 ахь",
  	DATA_DELETEOFLIST: "ианыхтәуп %1 %2 аҟынтәи",
  	DATA_DELETEALLOFLIST: "ианыхтәуп зегьы %1 аҟынтәи",
  	MOTION_IFONEDGEBOUNCE: "аҵкар иадкьыслозар, иадԥатәуп",
  	DATA_INSERTATLIST: "%3 аҟны ибжьаргылатәуп %1 %2 аҭыԥан",
  	DATA_REPLACEITEMOFLIST: "%2 аҟны иԥсахтәуп аелемент %1 %3 ала",
  	DATA_SHOWLIST: "иаарԥштәуп асиа %1",
  	DATA_HIDELIST: "иҵәахтәуп асиа %1",
  	SENSING_OF_XPOSITION: "x аҭыԥ",
  	SENSING_OF_YPOSITION: "y аҭыԥ",
  	SENSING_OF_DIRECTION: "ахырхарҭа",
  	SENSING_OF_COSTUMENUMBER: "акостиум №",
  	LOOKS_COSTUMENUMBERNAME: "акостиум %1",
  	SENSING_OF_SIZE: "ашәагаа",
  	SENSING_OF_BACKDROPNAME: "аҿаԥшыра ахьӡ",
  	LOOKS_BACKDROPNUMBERNAME: "аҿаԥшыра %1",
  	SENSING_OF_BACKDROPNUMBER: "аҿаԥшыра №",
  	SOUND_VOLUME: "абжьы адура",
  	"music.getTempo": "атемп",
  	SENSING_TOUCHINGOBJECT: "%1 иадкьыслома?",
  	SENSING_TOUCHINGCOLOR: "иадкьыслома аԥштәы %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "аԥштәы %1 иадкьыслома %2?",
  	SENSING_DISTANCETO: "%1 аҟынӡа ибжьоу",
  	SENSING_ANSWER: "аҭак",
  	SENSING_KEYPRESSED: "аклавиша %1  иақәыӷәӷәома?",
  	SENSING_MOUSEDOWN: "аҳәынаԥ иақәыӷәӷәома?",
  	SENSING_MOUSEX: "аҳәынаԥ x ала",
  	SENSING_MOUSEY: "аҳәынаԥ y ала",
  	SENSING_SETDRAGMODE: "иқәыргылатәуп аиагара арежим %1",
  	SENSING_LOUDNESS: "абжьы адура",
  	"videoSensing.videoOn": "авидео %1 %2 аҟны",
  	SENSING_TIMER: "атаимер",
  	SENSING_OF: "%1  %2 аҟынтәи",
  	SENSING_CURRENT: "уажәтәи %1",
  	SENSING_DAYSSINCE2000: "амшқәа 2000 ш. инаркны",
  	SENSING_USERNAME: "ахархәаҩ ихьӡ",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "иарбанзаалакь %1 -и %2 -и рыбжьара",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 - еи  %2 - еи",
  	OPERATORS_OR: "%1 ма %2",
  	OPERATORS_NOT: "%1 акәӡам",
  	OPERATORS_JOIN: "еиԥшьтәуп %1 %2",
  	OPERATORS_LETTEROF: "асимвол %1 %2 аҟны",
  	OPERATORS_LENGTH: "%1 аура",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "ихаргьежьтәуп %1",
  	OPERATORS_MATHOP: "%1 %2",
  	OPERATORS_CONTAINS: "%1 иаҵанакуама %2?",
  	DATA_ITEMOFLIST: "аелемент %1 %2 аҟны",
  	DATA_ITEMNUMOFLIST: "аелемент %1 № %2 аҟны",
  	DATA_LENGTHOFLIST: "асиа %1 аура",
  	DATA_LISTCONTAINSITEM: "%1 иаҵанакуама %2?",
  	CONTROL_ELSE: "акәымзар",
  	SENSING_USERID: "Ахархәаҩ ID",
  	SENSING_LOUD: "абжьы дуума?",
  	"text2speech.speakAndWaitBlock": "иҳәатәуп %1",
  	"text2speech.setVoiceBlock": "иқәыргылатәуп абжьы %1",
  	"text2speech.setLanguageBlock": "иқәыргылатәуп абызшәа %1",
  	"translate.translateBlock": "еиҭагатәуп %1 %2 ахь",
  	"translate.viewerLanguage": "абызшәа",
  	"makeymakey.whenKeyPressed": "аклавиша %1 ианақәыӷәӷәоу",
  	"makeymakey.whenKeysPressedInOrder": "еишьҭаргыланы %1 ақәыӷәӷәараан",
  	"microbit.whenButtonPressed": "акнопка %1 ианақәыӷәӷәоу",
  	"microbit.isButtonPressed": "акнопка %1 иақәыӷәӷәоума?",
  	"microbit.whenGesture": "%1 анакәу",
  	"microbit.displaySymbol": "иаарԥштәуп %1",
  	"microbit.displayText": "иаарԥштәуп атекст %1",
  	"microbit.clearDisplay": "ирыцқьатәуп аекран",
  	"microbit.whenTilted": "%1 анырнаау",
  	"microbit.isTilted": "ирнааума %1?",
  	"microbit.tiltAngle": "арнаара акәакь %1",
  	"microbit.whenPinConnected": "апин %1 анаҿаку",
  	"ev3.motorTurnClockwise": "амотор %1 ыргьежьтәуп арахь %2 сек",
  	"ev3.motorTurnCounterClockwise": "амотор %1 ыргьежьтәуп анахь %2 сек",
  	"ev3.motorSetPower": "амотор %1 иқәыргылатәуп амчра %2 %",
  	"ev3.getMotorPosition": "амотор %1 апозициа",
  	"ev3.whenButtonPressed": "акнопка %1 ианақәыӷәӷәоу",
  	"ev3.whenDistanceLessThan": "ирыбжьоу < %1 анакәу",
  	"ev3.whenBrightnessLessThan": "ажжара < %1 анакәу",
  	"ev3.buttonPressed": "акнопка %1 иақәыӷәӷәоума?",
  	"ev3.getDistance": "ирыбжьоу",
  	"ev3.getBrightness": "ажжара",
  	"ev3.beepNote": "анота %1 ихәмартәуп %2 сек",
  	"wedo2.motorOn": "иаҿактәуп %1",
  	"wedo2.motorOff": "иаҿыхтәуп %1",
  	"wedo2.startMotorPower": "иқәыргылатәуп %1 амчра %2 аҟны",
  	"wedo2.setMotorDirection": "иқәыргылатәуп %1 ахырхарҭа %2 аҟны",
  	"wedo2.whenDistance": "ирыбжьоу %1 %2 анакәу",
  	"wedo2.getDistance": "ирыбжьоу",
  	"wedo2.motorOnFor": "иаҿактәуп  %1 %2 сек",
  	"wedo2.setLightHue": "иқәыргылатәуп  арлашага аԥштәы %1",
  	"wedo2.playNoteFor": "анота %1 ихәмартәуп %2 сек",
  	"wedo2.whenTilted": "%1 анырнаау",
  	"wedo2.isTilted": "ирнааума %1?",
  	"wedo2.getTiltAngle": "арнаара акәакь %1",
  	"gdxfor.whenGesture": "%1 анакәу",
  	"gdxfor.whenForcePushedOrPulled": "амч ҳзырбо асенсор %1 анакәу",
  	"gdxfor.getForce": "амч",
  	"gdxfor.whenTilted": "%1 анырнаау",
  	"gdxfor.isTilted": "ирнааума %1?",
  	"gdxfor.getTilt": "анаара акәакь %1",
  	"gdxfor.isFreeFalling": "икаҳауама?",
  	"gdxfor.getSpin": "аргьежьра аласра %1",
  	"gdxfor.getAcceleration": "аццакра %1",
  	"boost.motorOnFor": "иаҿактәуп амотор %1 %2  секундк",
  	"boost.motorOnForRotation": "иаҿактәуп амотор %1 %2-нтә аргьежьра ала",
  	"boost.motorOn": "амотор %1 аҿактәуп",
  	"boost.motorOff": "амотор %1 аҿыхтәуп",
  	"boost.setMotorPower": "иқәыргылатәуп  %1 аласра %2 % аҟны",
  	"boost.setMotorDirection": "иқәыргылатәуп амотор %1 ахырхарҭа  %2 аҟны",
  	"boost.getMotorPosition": "амотор %1 апозициа",
  	"boost.whenColor": "ақьырмыт %1 анаҳбо",
  	"boost.seeingColor": "иаҳбома ақьырмыт %1?",
  	"boost.whenTilted": "%1 анырнаау",
  	"boost.getTiltAngle": "арнаара акәакь %1",
  	"boost.setLightHue": "иқәыргылатәуп  арлашага аԥштәы %1"
  };
  var dropdowns$1d = {
  };
  var ignorelt$1d = [
  ];
  var soundEffects$1d = [
  	"атемп",
  	"абжьгара армарахь/арӷьарахь"
  ];
  var microbitWhen$1d = [
  	"инаскьагоуп",
  	"идырҵысит",
  	"иԥеит"
  ];
  var osis$1d = [
  	"анагӡаҩ егьырҭ ипрограммақәа"
  ];
  var definePrefix$1d = [
  	"еиҿкаатәуп"
  ];
  var defineSuffix$1d = [
  ];
  var palette$1d = {
  	Motion: "Аиҭаҵра",
  	Looks: "Аԥшра-асахьа",
  	Sound: "Абжьы",
  	Events: "Ахҭысқәа",
  	Control: "Аконтроль",
  	Sensing: "Асенсорқәа",
  	Operators: "Аоператорқәа",
  	Variables: "Аҽеиҭакқәа",
  	"My Blocks": "Сара сблокқәа"
  };
  var math$1d = [
  	"abs",
  	"еиҵоу еибгоу",
  	"еиҳау еибгоу",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$1d = {
  };
  var name$1d = "Аҧсшәа";
  var percentTranslated$1d = 100;
  var ab = {
  	commands: commands$1d,
  	dropdowns: dropdowns$1d,
  	ignorelt: ignorelt$1d,
  	soundEffects: soundEffects$1d,
  	microbitWhen: microbitWhen$1d,
  	osis: osis$1d,
  	definePrefix: definePrefix$1d,
  	defineSuffix: defineSuffix$1d,
  	palette: palette$1d,
  	math: math$1d,
  	aliases: aliases$1d,
  	name: name$1d,
  	percentTranslated: percentTranslated$1d
  };

  var commands$1c = {
  	MOTION_MOVESTEPS: "beweeg %1 tree",
  	MOTION_TURNRIGHT: "draai @turnRight %1 grade",
  	MOTION_TURNLEFT: "draai @turnLeft %1 grade",
  	MOTION_POINTINDIRECTION: "wys na rigting %1",
  	MOTION_POINTTOWARDS: "wys na %1",
  	MOTION_GOTOXY: "gaan na x: %1 y: %2",
  	MOTION_GOTO: "gaan na %1",
  	MOTION_GLIDESECSTOXY: "gly %1 sekondes na x: %2 y: %3",
  	MOTION_GLIDETO: "gly %1 sekondes na %2",
  	MOTION_CHANGEXBY: "verander x met %1",
  	MOTION_SETX: "stel x op %1",
  	MOTION_CHANGEYBY: "verander y met %1",
  	MOTION_SETY: "stel y op %1",
  	MOTION_SETROTATIONSTYLE: "stel rotasiestyl %1",
  	LOOKS_SAYFORSECS: "sê %1 vir %2 sekondes",
  	LOOKS_SAY: "sê %1",
  	LOOKS_THINKFORSECS: "dink %1 vir %2 sekondes",
  	LOOKS_THINK: "dink %1",
  	LOOKS_SHOW: "vertoon",
  	LOOKS_HIDE: "verberg",
  	LOOKS_SWITCHCOSTUMETO: "ruil kostuum na %1",
  	LOOKS_NEXTCOSTUME: "volgende kostuum",
  	LOOKS_NEXTBACKDROP_BLOCK: "volgende agtergrond",
  	LOOKS_SWITCHBACKDROPTO: "ruil agtergrond na %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "ruil agtergrond na %1 en wag",
  	LOOKS_CHANGEEFFECTBY: "verander %1 effek met %2",
  	LOOKS_SETEFFECTTO: "stel %1 effek op %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "verwyder grafiese effekte",
  	LOOKS_CHANGESIZEBY: "verander grootte met %1",
  	LOOKS_SETSIZETO: "stel grootte op %1 %",
  	LOOKS_GOTOFRONTBACK: "gaan na %1 laag",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "gaan %1 %2 lae",
  	SOUND_PLAY: "begin klank %1",
  	SOUND_CHANGEEFFECTBY: "verander %1 effek met %2",
  	SOUND_SETEFFECTO: "stel %1 effek op %2",
  	SOUND_CLEAREFFECTS: "verwyder klank effekte",
  	SOUND_PLAYUNTILDONE: "speel klank %1 tot voltooi",
  	SOUND_STOPALLSOUNDS: "stop alle klanke",
  	"music.playDrumForBeats": "speel drom %1 vir %2 slae",
  	"music.restForBeats": "rus vir %1 slae",
  	"music.playNoteForBeats": "speel noot %1 vir %2 slae",
  	"music.setInstrument": "stel instrument op %1",
  	SOUND_CHANGEVOLUMEBY: "verander volume met %1",
  	SOUND_SETVOLUMETO: "stel volume op %1%",
  	"music.changeTempo": "verander tempo met %1",
  	"music.setTempo": "stel tempo op %1",
  	"pen.clear": "vee alles uit",
  	"pen.stamp": "stempel",
  	"pen.penDown": "sit pen neer",
  	"pen.penUp": "tel pen op",
  	"pen.setColor": "stel pen kleur op %1",
  	"pen.changeHue": "verander pen kleur met %1",
  	"pen.setColorParam": "stel pen %1 op %2",
  	"pen.changeColorParam": "verander pen %1 met %2",
  	"pen.setHue": "stel pen kleur op %1",
  	"pen.changeShade": "Verander pen skakering met %1",
  	"pen.setShade": "stel pen skakering op %1",
  	"pen.changeSize": "verander pen grootte met %1",
  	"pen.setSize": "stel pen grootte op %1",
  	EVENT_WHENFLAGCLICKED: "wanneer @greenFlag gekliek is",
  	EVENT_WHENKEYPRESSED: "wanneer %1 sleutel gedruk is",
  	EVENT_WHENTHISSPRITECLICKED: "wanneer hierdie sprite gekliek is",
  	EVENT_WHENSTAGECLICKED: "wanneer verhoog gekliek is",
  	EVENT_WHENBACKDROPSWITCHESTO: "wanneer agtergrond na %1 verander",
  	EVENT_WHENGREATERTHAN: "wanneer %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "wanneer ek %1 ontvang",
  	EVENT_BROADCAST: "saai %1 uit",
  	EVENT_BROADCASTANDWAIT: "saai %1 uit en wag",
  	CONTROL_WAIT: "wag %1 sekondes",
  	CONTROL_REPEAT: "herhaal %1 keer",
  	CONTROL_FOREVER: "vir ewig",
  	CONTROL_IF: "indien %1 dan",
  	CONTROL_WAITUNTIL: "wag totdat %1",
  	CONTROL_REPEATUNTIL: "herhaal totdat %1",
  	CONTROL_STOP: "stop %1",
  	CONTROL_STARTASCLONE: "wanneer ek as 'n kloon begin",
  	CONTROL_CREATECLONEOF: "skep kloon van %1",
  	CONTROL_DELETETHISCLONE: "skrap hierdie kloon",
  	SENSING_ASKANDWAIT: "vra %1 en wag",
  	"videoSensing.videoToggle": "skakel video %1",
  	"videoSensing.setVideoTransparency": "stel video deursigtigheid op %1",
  	"videoSensing.whenMotionGreaterThan": "wanneer video beweging > %1",
  	SENSING_RESETTIMER: "herstel tydhouer",
  	DATA_SETVARIABLETO: "stel %1 op %2",
  	DATA_CHANGEVARIABLEBY: "verander %1 met %2",
  	DATA_SHOWVARIABLE: "vertoon veranderlike %1",
  	DATA_HIDEVARIABLE: "verberg veranderlike %1",
  	DATA_ADDTOLIST: "voeg %1 by %2",
  	DATA_DELETEOFLIST: "skrap %1 van %2",
  	DATA_DELETEALLOFLIST: "skrap alles van %1",
  	MOTION_IFONEDGEBOUNCE: "as rand bereik is, bons",
  	DATA_INSERTATLIST: "voeg %1 in by %2 van %3",
  	DATA_REPLACEITEMOFLIST: "vervang item %1 van %2 met %3",
  	DATA_SHOWLIST: "vertoon lys %1",
  	DATA_HIDELIST: "verberg lys %1",
  	SENSING_OF_XPOSITION: "x posisie",
  	SENSING_OF_YPOSITION: "y posisie",
  	SENSING_OF_DIRECTION: "rigting",
  	SENSING_OF_COSTUMENUMBER: "kostuum #",
  	LOOKS_COSTUMENUMBERNAME: "kostuum %1",
  	SENSING_OF_SIZE: "grootte",
  	SENSING_OF_BACKDROPNAME: "agtergrondnaam",
  	LOOKS_BACKDROPNUMBERNAME: "agtergrond %1",
  	SENSING_OF_BACKDROPNUMBER: "agtergrond #",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "raak %1",
  	SENSING_TOUCHINGCOLOR: "raak kleur %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "kleur %1 raak aan %2",
  	SENSING_DISTANCETO: "afstand na %1",
  	SENSING_ANSWER: "antwoord",
  	SENSING_KEYPRESSED: "sleutel %1 gedruk?",
  	SENSING_MOUSEDOWN: "muis af?",
  	SENSING_MOUSEX: "muis x",
  	SENSING_MOUSEY: "muis y",
  	SENSING_SETDRAGMODE: "stel sleep modus %1",
  	SENSING_LOUDNESS: "luidheid",
  	"videoSensing.videoOn": "video %1 op %2",
  	SENSING_TIMER: "tydhouer",
  	SENSING_OF: "%1 van %2",
  	SENSING_CURRENT: "huidige %1",
  	SENSING_DAYSSINCE2000: "dae sedert 2000",
  	SENSING_USERNAME: "gebruikersnaam",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "kies ewekansige %1 tot %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 en %2",
  	OPERATORS_OR: "%1 of %2",
  	OPERATORS_NOT: "nie %1",
  	OPERATORS_JOIN: "verbind %1 %2",
  	OPERATORS_LETTEROF: "letter %1 van %2",
  	OPERATORS_LENGTH: "lengte van %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "rond %1 af",
  	OPERATORS_MATHOP: "%1 van %2",
  	OPERATORS_CONTAINS: "%1 bevat %2?",
  	DATA_ITEMOFLIST: "item %1 van %2",
  	DATA_ITEMNUMOFLIST: "item # van %1 in %2",
  	DATA_LENGTHOFLIST: "lengte van %1",
  	DATA_LISTCONTAINSITEM: "%1 bevat %2?",
  	CONTROL_ELSE: "anders",
  	SENSING_USERID: "gebruikers id",
  	SENSING_LOUD: "hard?",
  	"text2speech.speakAndWaitBlock": "praat %1",
  	"text2speech.setVoiceBlock": "stel stem op %1",
  	"text2speech.setLanguageBlock": "stel taal op %1",
  	"translate.translateBlock": "vertaal %1 na %2",
  	"translate.viewerLanguage": "taal",
  	"makeymakey.whenKeyPressed": "wanneer %1 sleutel gedruk word",
  	"makeymakey.whenKeysPressedInOrder": "wanneer %1 in volgorde gedruk word",
  	"microbit.whenButtonPressed": "wanneer %1 knoppie gedruk word",
  	"microbit.isButtonPressed": "%1 knoppie gedruk?",
  	"microbit.whenGesture": "wanneer %1",
  	"microbit.displaySymbol": "vertoon %1",
  	"microbit.displayText": "vertoon teks %1",
  	"microbit.clearDisplay": "verwyder vertooning",
  	"microbit.whenTilted": "wanneer %1 gekantel",
  	"microbit.isTilted": "gekantel %1?",
  	"microbit.tiltAngle": "kantel hoek %1",
  	"microbit.whenPinConnected": "wanneer pin %1 verbind is",
  	"ev3.motorTurnClockwise": "motor %1 draai hierdie kant toe vir %2 sekondes",
  	"ev3.motorTurnCounterClockwise": "motor %1 draai soontoe vir %2 sekondes",
  	"ev3.motorSetPower": "motor %1 stel krag %2 %",
  	"ev3.getMotorPosition": "motor %1 posisie",
  	"ev3.whenButtonPressed": "wanneer knoppie %1 gedruk word",
  	"ev3.whenDistanceLessThan": "wanneer afstand < %1",
  	"ev3.whenBrightnessLessThan": "wanneer helderheid < %1",
  	"ev3.buttonPressed": "knoppie %1 gedruk?",
  	"ev3.getDistance": "afstand",
  	"ev3.getBrightness": "helderheid",
  	"ev3.beepNote": "biep noot %1 vir %2 sekondes",
  	"wedo2.motorOn": "skakel %1 aan",
  	"wedo2.motorOff": "skakel %1 af",
  	"wedo2.startMotorPower": "stel %1 krag op %2",
  	"wedo2.setMotorDirection": "stel %1 rigting op %2",
  	"wedo2.whenDistance": "wanneer afstand %1 %2",
  	"wedo2.getDistance": "afstand",
  	"wedo2.motorOnFor": "skakel %1 aan vir %2 sekondes",
  	"wedo2.setLightHue": "stel ligkleur op %1",
  	"wedo2.playNoteFor": "speel noot %1 vir %2 sekondes",
  	"wedo2.whenTilted": "wanneer gekantel  %1",
  	"wedo2.isTilted": "gekantel %1?",
  	"wedo2.getTiltAngle": "kantel hoek %1",
  	"gdxfor.whenGesture": "wanneer %1",
  	"gdxfor.whenForcePushedOrPulled": "wanneer krag sensor %1",
  	"gdxfor.getForce": "krag",
  	"gdxfor.whenTilted": "wanneer gekantel  %1",
  	"gdxfor.isTilted": "Gekantel %1?",
  	"gdxfor.getTilt": "kantel hoek %1",
  	"gdxfor.isFreeFalling": "Besig om te val?",
  	"gdxfor.getSpin": "draai spoed %1",
  	"gdxfor.getAcceleration": "versnelling %1",
  	"boost.motorOnFor": "skakel motor %1 aan vir %2 sekondes",
  	"boost.motorOnForRotation": "skakel motor %1 aan vir %2 rotasies",
  	"boost.motorOn": "skakel motor %1 aan",
  	"boost.motorOff": "skakel motor  %1 af",
  	"boost.setMotorPower": "stel motor %1 spoed na %2 %",
  	"boost.setMotorDirection": "stel motor %1 rigting %2",
  	"boost.getMotorPosition": "motor %1 posisie",
  	"boost.whenColor": "wanneer %1 baksteen gesien word",
  	"boost.seeingColor": "sien %1 baksteen?",
  	"boost.whenTilted": "wanneer gekantel  %1",
  	"boost.getTiltAngle": "kantel hoek %1",
  	"boost.setLightHue": "stel ligkleur na %1"
  };
  var dropdowns$1c = {
  };
  var ignorelt$1c = [
  ];
  var soundEffects$1c = [
  	"toonhoogte",
  	"swenk links/regs"
  ];
  var microbitWhen$1c = [
  	"geskuif",
  	"geskud",
  	"gespring"
  ];
  var osis$1c = [
  	"ander skripte in sprite"
  ];
  var definePrefix$1c = [
  	"definieer"
  ];
  var defineSuffix$1c = [
  ];
  var palette$1c = {
  	Motion: "Beweging",
  	Looks: "Voorkoms",
  	Sound: "Klank",
  	Events: "Gebeurtenisse",
  	Control: "Beheer",
  	Sensing: "Aanvoeling",
  	Operators: "Operateurs",
  	Variables: "Veranderlikes",
  	"My Blocks": "My Blokke"
  };
  var math$1c = [
  	"abs",
  	"afrond",
  	"oprond",
  	"vierkantswortel",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$1c = {
  };
  var name$1c = "Afrikaans";
  var percentTranslated$1c = 100;
  var af = {
  	commands: commands$1c,
  	dropdowns: dropdowns$1c,
  	ignorelt: ignorelt$1c,
  	soundEffects: soundEffects$1c,
  	microbitWhen: microbitWhen$1c,
  	osis: osis$1c,
  	definePrefix: definePrefix$1c,
  	defineSuffix: defineSuffix$1c,
  	palette: palette$1c,
  	math: math$1c,
  	aliases: aliases$1c,
  	name: name$1c,
  	percentTranslated: percentTranslated$1c
  };

  var commands$1b = {
  	MOTION_MOVESTEPS: "%1 እርምጃዎች ተንቀሳቀስ",
  	MOTION_TURNRIGHT: "ዙር @turnRight %1 ድግሪዎች",
  	MOTION_TURNLEFT: "ዙር @turnLeft %1 ድግሪዎች",
  	MOTION_POINTINDIRECTION: "ወደ %1 አቅጣጫ ደግን",
  	MOTION_POINTTOWARDS: "ወደ %1 ደግን",
  	MOTION_GOTOXY: "ወደ x: %1 y: %2 ሂድ",
  	MOTION_GOTO: "ወደ %1 ሂድ",
  	MOTION_GLIDESECSTOXY: "ተንሸራተት %1 ሰከንድ ወደ x: %2 y: %3",
  	MOTION_GLIDETO: "ተንሸራተት %1 ሰከንድ ወደ %2",
  	MOTION_CHANGEXBY: "xን ቀይር በ%1",
  	MOTION_SETX: "xን ወደ %1 ለውጥ",
  	MOTION_CHANGEYBY: "yን ቀይር በ%1",
  	MOTION_SETY: "yን ወደ %1 ለውጥ",
  	MOTION_SETROTATIONSTYLE: "የዙር ዘዴ ወደ %1 ለውጥ",
  	LOOKS_SAYFORSECS: "%1ን በል ለ%2 ሰከንድ",
  	LOOKS_SAY: "%1ን በል",
  	LOOKS_THINKFORSECS: "%1ን አስብ ለ%2 ሰከንድ",
  	LOOKS_THINK: "%1ን አስብ",
  	LOOKS_SHOW: "አሳይ",
  	LOOKS_HIDE: "ደብቅ",
  	LOOKS_SWITCHCOSTUMETO: "ልብስ ወደ %1 ለውጥ",
  	LOOKS_NEXTCOSTUME: "ቀጣይ አልባስ",
  	LOOKS_NEXTBACKDROP_BLOCK: "ቀጣይ የጀርባ ምስል",
  	LOOKS_SWITCHBACKDROPTO: "የጀርባ ምስል ወደ %1 ለውጥ",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "የጀርባ ምስል ወደ %1 ለውጥና ጠብቅ",
  	LOOKS_CHANGEEFFECTBY: "%1ን ተጽኖ በ%2 ለውጥ",
  	LOOKS_SETEFFECTTO: "%1ን ተጽኖ ወደ %2 ለውጥ",
  	LOOKS_CLEARGRAPHICEFFECTS: "የምስል ማስዋብያዎቹን አጥፋ",
  	LOOKS_CHANGESIZEBY: "ልክን ቀይር በ%1",
  	LOOKS_SETSIZETO: "ልክን ወደ %1 ቀይር",
  	LOOKS_GOTOFRONTBACK: "ወደ %1 ተደራቢ ሂድ",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ወደ %1ና %2 ተደራቢዎች ሂድ",
  	SOUND_PLAY: "%1ን ድምጽ ጀምር",
  	SOUND_CHANGEEFFECTBY: "%1ን ተጽኖ በ%2 ለውጥ",
  	SOUND_SETEFFECTO: "%1ን ተጽኖ ወደ %2 ለውጥ",
  	SOUND_CLEAREFFECTS: "የድምጽ ተጽኖዎች አጽዳ",
  	SOUND_PLAYUNTILDONE: "%1ን ድምጽ ተጫወት እስከሚያልቅ",
  	SOUND_STOPALLSOUNDS: "ሁሉንም ድምጾች አቁም",
  	"music.playDrumForBeats": "%1ን ታምቡር ለ%2 ምት ተጫውት",
  	"music.restForBeats": "እረፍ ለ%1 ምት",
  	"music.playNoteForBeats": "%1ን ኖታ ለ%2 ምት ተጫውት",
  	"music.setInstrument": "መሳሪያ ለውጥ ወደ %1",
  	SOUND_CHANGEVOLUMEBY: "ድምጽ ቀይር በ%1",
  	SOUND_SETVOLUMETO: "ድምጽ ወደ %1% ለውጥ",
  	"music.changeTempo": "ሰልት ቀይር በ%1",
  	"music.setTempo": "ስልት ለውጥ ወደ %1",
  	"pen.clear": "ሁሉንም አስወግድ",
  	"pen.stamp": "ምልክት",
  	"pen.penDown": "ብእር አሳርፍ",
  	"pen.penUp": "ብእር አንሳ",
  	"pen.setColor": "የእስክሪብቶን ቀልም ወደ %1 ለውጥ",
  	"pen.changeHue": "የእስክሪብቶን ቀልም ቀይር በ%1",
  	"pen.setColorParam": "የእስክሪብቶን %1 ወደ %2 ለውጥ",
  	"pen.changeColorParam": "የእስክሪብቶን %1 ቀይር በ%2",
  	"pen.setHue": "የእስክሪብቶን ቀለም ወደ %1 ለውጥ",
  	"pen.changeShade": "የእስክሪብቶን ጥቁረት ቀይር በ%1",
  	"pen.setShade": "የእስክሪብቶን ጥቁረት ወደ %1 ለውጥ",
  	"pen.changeSize": "የእስክሪብቶን ልክ ቀይር በ%1",
  	"pen.setSize": "የእስክሪብቶን ልክ ወደ %1 ለውጥ",
  	EVENT_WHENFLAGCLICKED: "@greenFlag ጠቅ ሲደረግ",
  	EVENT_WHENKEYPRESSED: "%1ን ቁልፍ ጫን ሲደረግ",
  	EVENT_WHENTHISSPRITECLICKED: "ይህ ስፕራይት ሲነካ",
  	EVENT_WHENSTAGECLICKED: "መድረኩ ጠቅ ሲደረግ",
  	EVENT_WHENBACKDROPSWITCHESTO: "የጀርባ ምስል ወደ %1 ሲቀየር",
  	EVENT_WHENGREATERTHAN: "%1 > %2 ሲሆን",
  	EVENT_WHENBROADCASTRECEIVED: "%1ን ስቀበል",
  	EVENT_BROADCAST: "%1ን አሰራጭ",
  	EVENT_BROADCASTANDWAIT: "%1ን አሰራጭና ጠብቅ",
  	CONTROL_WAIT: "ጠብቅ ለ%1 ሰከንድ",
  	CONTROL_REPEAT: "%1ን ድገም",
  	CONTROL_FOREVER: "ለዘላለም",
  	CONTROL_IF: "%1 ከሆነ",
  	CONTROL_WAITUNTIL: "ጠብቅ እስከ %1",
  	CONTROL_REPEATUNTIL: "ድገም እስከ %1",
  	CONTROL_STOP: "አቁም %1",
  	CONTROL_STARTASCLONE: "እንደ አምሳያ ስጀምር",
  	CONTROL_CREATECLONEOF: "የ%1 አምሳያ ፍጠር",
  	CONTROL_DELETETHISCLONE: "ይህንን አምሳያ አጥፋ",
  	SENSING_ASKANDWAIT: "%1 ጠይቅና ጠብቅ",
  	"videoSensing.videoToggle": "ቪድዮ ወደ %1 ቀይር",
  	"videoSensing.setVideoTransparency": "የቪድዮ አሳይነት ወደ %1 ለውጥ",
  	"videoSensing.whenMotionGreaterThan": "የቪድዮ እንቅስቃሴ > %1 ሲሆን",
  	SENSING_RESETTIMER: "ጊዜ ቆጣሪውን ከዜሮ ጀምር",
  	DATA_SETVARIABLETO: "%1 ወደ %2 ለውጥ",
  	DATA_CHANGEVARIABLEBY: "%1 በ%2 ቀይር",
  	DATA_SHOWVARIABLE: "%1ን ተለዋዋጭ አሳይ",
  	DATA_HIDEVARIABLE: "%1ን ተለዋዋጭ ደብቅ",
  	DATA_ADDTOLIST: "%1 ጨምር በ%2",
  	DATA_DELETEOFLIST: "%1 ሰርዝ ከ%2",
  	DATA_DELETEALLOFLIST: "%1 ሁሉ ሰርዝ",
  	MOTION_IFONEDGEBOUNCE: "ጠርዝ ላይ ነጥረህ ተመለስ",
  	DATA_INSERTATLIST: "%1 አስገባ በ%2 ላይ %3 ውስጥ",
  	DATA_REPLACEITEMOFLIST: "%1 ከ%2 ቀይር ወደ %3",
  	DATA_SHOWLIST: "%1ን ዝርዝር አሳይ",
  	DATA_HIDELIST: "%1ን ዝርዝር ደብቅ",
  	SENSING_OF_XPOSITION: "x ቦታ",
  	SENSING_OF_YPOSITION: "y ቦታ",
  	SENSING_OF_DIRECTION: "አቅጣጫ",
  	SENSING_OF_COSTUMENUMBER: "ልብስ ቁጥር",
  	LOOKS_COSTUMENUMBERNAME: "ልብስ %1",
  	SENSING_OF_SIZE: "መጠን",
  	SENSING_OF_BACKDROPNAME: "የጀርባ ምስል ስም",
  	LOOKS_BACKDROPNUMBERNAME: "የጀርባ ምስል %1",
  	SENSING_OF_BACKDROPNUMBER: "የጀርባ ምስል #",
  	SOUND_VOLUME: "የድምጽ መጠን",
  	"music.getTempo": "ምት",
  	SENSING_TOUCHINGOBJECT: "%1ን የነካ ነው?",
  	SENSING_TOUCHINGCOLOR: "%1ን ቀለም የነካ ነው?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 ቀለም %2ን የነካ ነው?",
  	SENSING_DISTANCETO: "ርቀት እስከ %1",
  	SENSING_ANSWER: "መልስ",
  	SENSING_KEYPRESSED: "ቁልፍ %1 ጫን ተብሏል?",
  	SENSING_MOUSEDOWN: "መዳፊት ወደታች?",
  	SENSING_MOUSEX: "መዳፊት x",
  	SENSING_MOUSEY: "መዳፊት y",
  	SENSING_SETDRAGMODE: "የጉትት ሞድ ወደ %1 ለውጥ",
  	SENSING_LOUDNESS: "ጮክታ",
  	"videoSensing.videoOn": "ቪድዮ %1 ስለ %2",
  	SENSING_TIMER: "የጊዜ ቆጣሪ",
  	SENSING_OF: "%1 ከ%2",
  	SENSING_CURRENT: "ያሁኑ %1",
  	SENSING_DAYSSINCE2000: "ከ2000 ጀምሮ ያሉ ቀናት",
  	SENSING_USERNAME: "የተጠቃሚ ስም",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 እስከ %2 በራንደም ምረጥ",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1ና %2",
  	OPERATORS_OR: "%1 ወይስ %2",
  	OPERATORS_NOT: "%1 አይደለም",
  	OPERATORS_JOIN: "%1 %2 አገናኝ",
  	OPERATORS_LETTEROF: "ፊደል %1 ከ%2",
  	OPERATORS_LENGTH: "%1 ርዝመት",
  	OPERATORS_MOD: "%1 ሞዱሎ %2",
  	OPERATORS_ROUND: "%1ን አጠጋጋ",
  	OPERATORS_MATHOP: "%1 ከ%2",
  	OPERATORS_CONTAINS: "%2 %1 አለበት?",
  	DATA_ITEMOFLIST: "%1 ከ%2",
  	DATA_ITEMNUMOFLIST: "item # of %1 in %2",
  	DATA_LENGTHOFLIST: "%1 ርዝመት",
  	DATA_LISTCONTAINSITEM: "%2 %1 አለበት?",
  	CONTROL_ELSE: "ካልሆነ",
  	SENSING_USERID: "የተጠቃሚ መታወቂያ",
  	SENSING_LOUD: "ጮክ ነው?",
  	"text2speech.speakAndWaitBlock": "%1ን ተናገር",
  	"text2speech.setVoiceBlock": "ድምጽ ወደ %1 ለውጥ",
  	"text2speech.setLanguageBlock": "set language to %1",
  	"translate.translateBlock": "%1ን ተርጉም ወደ %2",
  	"translate.viewerLanguage": "ቋንቋ",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "%1ን ቁልፍ ሲጫን",
  	"microbit.isButtonPressed": "%1ን ቁልፍ ተጭኗል?",
  	"microbit.whenGesture": "%1ን ሲሰጥ",
  	"microbit.displaySymbol": "%1ን አሳይ",
  	"microbit.displayText": "display text %1",
  	"microbit.clearDisplay": "ማሳያ አጽዳ",
  	"microbit.whenTilted": "በ%1 አቅጣጫ ሲዘነብል",
  	"microbit.isTilted": "በ%1 አቅጣጫ ተዘነብሏል?",
  	"microbit.tiltAngle": "ማዕዘን በ%1 አቅጣጫ አዘንብል",
  	"microbit.whenPinConnected": "when pin %1 connected",
  	"ev3.motorTurnClockwise": "የ%1 ሞተር በዚህ አቅጣጫ አዙር ለ%2 ሰከንድ",
  	"ev3.motorTurnCounterClockwise": "የ%1 ሞተር በዚያ አቅጣጫ አዙር ለ%2 ሰከንድ",
  	"ev3.motorSetPower": "የ %1ን ሞተር ሃይል ወደ %2% ለውጥ",
  	"ev3.getMotorPosition": "%1ን ሞተር አኳኋን",
  	"ev3.whenButtonPressed": "%1ን ቁልፍ ሲጫን",
  	"ev3.whenDistanceLessThan": "ርቀት < %1 ሲሆን",
  	"ev3.whenBrightnessLessThan": "ብሩህነት < %1 ሲሆን",
  	"ev3.buttonPressed": "%1ን ቁልፍ ተጭኗል?",
  	"ev3.getDistance": "ርቀት",
  	"ev3.getBrightness": "የብርሀን መጠን",
  	"ev3.beepNote": "በ%1 ኖታ ጲጵ በል ለ%2 ሰከንድ",
  	"wedo2.motorOn": "%1ን ሞተር አብራ",
  	"wedo2.motorOff": "%1ን ሞተር አጥፋ",
  	"wedo2.startMotorPower": "የ%1ን ሞተር ኃይል ወደ %2 ለውጥ",
  	"wedo2.setMotorDirection": "የ%1ን ሞተር አቅጣጫ ወደ %2 ለውጥ",
  	"wedo2.whenDistance": "ርቀት %1 %2 ሲሆን",
  	"wedo2.getDistance": "ርቀት",
  	"wedo2.motorOnFor": "%1ን ሞተር አብራ ለ%2 ሰከንድ",
  	"wedo2.setLightHue": "የመብራት ቀለም ወደ %1 ለውጥ",
  	"wedo2.playNoteFor": "%1ን ኖታ ለ%2 ተጫወት",
  	"wedo2.whenTilted": "በ%1 ሲዘነብል",
  	"wedo2.isTilted": "%1ተዘነብሏል?",
  	"wedo2.getTiltAngle": "የዝንባሌ ማዕዘን %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$1b = {
  };
  var ignorelt$1b = [
  ];
  var soundEffects$1b = [
  	"ፒች",
  	"ሸብልል ወደ ግራ/ቀኝ"
  ];
  var microbitWhen$1b = [
  	"ተንቀሳቅሷል",
  	"አራድቷል",
  	"ዘልሏል"
  ];
  var osis$1b = [
  	"ሌሎች በስፕራይት ላይ ያሉ ስክሪፕቶች"
  ];
  var definePrefix$1b = [
  ];
  var defineSuffix$1b = [
  	"ን",
  	"ደንግግ"
  ];
  var palette$1b = {
  	Motion: "እንቅስቃሴ",
  	Looks: "ገጽታ",
  	Sound: "ድምጽ",
  	Events: "ክስተት",
  	Control: "ቁጥጥር",
  	Sensing: "ስሜት",
  	Operators: "ስሌቶች",
  	Variables: "ተለዋዋጮች",
  	"My Blocks": "የኔ ጥምሮች"
  };
  var math$1b = [
  	"abs",
  	"መሬት",
  	"ጣራ",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ውስጥ",
  	"ግባ",
  	"e^",
  	"10 ^"
  ];
  var aliases$1b = {
  };
  var name$1b = "አማርኛ";
  var percentTranslated$1b = 100;
  var am = {
  	commands: commands$1b,
  	dropdowns: dropdowns$1b,
  	ignorelt: ignorelt$1b,
  	soundEffects: soundEffects$1b,
  	microbitWhen: microbitWhen$1b,
  	osis: osis$1b,
  	definePrefix: definePrefix$1b,
  	defineSuffix: defineSuffix$1b,
  	palette: palette$1b,
  	math: math$1b,
  	aliases: aliases$1b,
  	name: name$1b,
  	percentTranslated: percentTranslated$1b
  };

  var commands$1a = {
  	MOTION_MOVESTEPS: "mover %1 pasos",
  	MOTION_TURNRIGHT: "chirar @turnRight %1 graus",
  	MOTION_TURNLEFT: "chirar @turnLeft %1 graus",
  	MOTION_POINTINDIRECTION: "apuntar enta la dirección %1",
  	MOTION_POINTTOWARDS: "apuntar enta %1",
  	MOTION_GOTOXY: "ir ta x: %1 y: %2",
  	MOTION_GOTO: "ir ta %1",
  	MOTION_GLIDESECSTOXY: "eslizar en %1 segs enta x: %2 y: %3",
  	MOTION_GLIDETO: "eslizar en %1 segs enta %2",
  	MOTION_CHANGEXBY: "sumar %1 a x",
  	MOTION_SETX: "dar a x la valor %1",
  	MOTION_CHANGEYBY: "sumar %1 a y",
  	MOTION_SETY: "dar a y la valor %1",
  	MOTION_SETROTATIONSTYLE: "fixar estilo de rotación a %1",
  	LOOKS_SAYFORSECS: "decir %1 per %2 segundos",
  	LOOKS_SAY: "decir %1",
  	LOOKS_THINKFORSECS: "pensar %1 per %2 segundos",
  	LOOKS_THINK: "pensar %1",
  	LOOKS_SHOW: "amostrar",
  	LOOKS_HIDE: "amagar",
  	LOOKS_SWITCHCOSTUMETO: "cambiar vestiu a %1",
  	LOOKS_NEXTCOSTUME: "siguient vestiu",
  	LOOKS_NEXTBACKDROP_BLOCK: "siguient fondo",
  	LOOKS_SWITCHBACKDROPTO: "cambiar fondo a %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "cambiar fondo a %1 y aguardar",
  	LOOKS_CHANGEEFFECTBY: "sumar %2 a l'efecto %1",
  	LOOKS_SETEFFECTTO: "dar a l'efecto %1 la valor %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "borrar los efectos graficos",
  	LOOKS_CHANGESIZEBY: "cambiar grandaria per %1",
  	LOOKS_SETSIZETO: "fixar grandaria a lo %1 %",
  	LOOKS_GOTOFRONTBACK: "ir a capa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ir %2 capas enta %1",
  	SOUND_PLAY: "iniciar son %1",
  	SOUND_CHANGEEFFECTBY: "sumar %2 a l'efecto %1",
  	SOUND_SETEFFECTO: "dar a l'efecto %1 la valor %2",
  	SOUND_CLEAREFFECTS: "sacar efectos de son",
  	SOUND_PLAYUNTILDONE: "tanyer son %1 dica que remate",
  	SOUND_STOPALLSOUNDS: "aturar totz los sons",
  	"music.playDrumForBeats": "tanyer tambor %1 por %2 tiempos",
  	"music.restForBeats": "silencio de %1 tiempos",
  	"music.playNoteForBeats": "tanyer nota %1 por %2 tiempos",
  	"music.setInstrument": "fixar instrumento a %1",
  	SOUND_CHANGEVOLUMEBY: "cambiar volumen per %1",
  	SOUND_SETVOLUMETO: "fixar volumen a %1%",
  	"music.changeTempo": "cambiar tempo por %1",
  	"music.setTempo": "dar a tempo a valor %1",
  	"pen.clear": "borrar tot",
  	"pen.stamp": "sellar",
  	"pen.penDown": "baixar lapicero",
  	"pen.penUp": "puyar lapicero",
  	"pen.setColor": "fixar color de lapicero a %1",
  	"pen.changeHue": "cambiar color de lapicero por %1",
  	"pen.setColorParam": "fixar %1 de lapicero a %2",
  	"pen.changeColorParam": "cambiar %1 de lapicero por %2",
  	"pen.setHue": "fixar color de lapicero a %1",
  	"pen.changeShade": "cambiar uembra de lapicero por %1",
  	"pen.setShade": "fixar uembra de lapicero a %1",
  	"pen.changeSize": "cambiar grandaria de lapicero por %1",
  	"pen.setSize": "fixar grandaria de lapicero a %1",
  	EVENT_WHENFLAGCLICKED: "en fer clic en @greenFlag",
  	EVENT_WHENKEYPRESSED: "en pretar la tecla %1",
  	EVENT_WHENTHISSPRITECLICKED: "en fer clic en este obchecto",
  	EVENT_WHENSTAGECLICKED: "en fer clic en o scenario",
  	EVENT_WHENBACKDROPSWITCHESTO: "quan lo fondo cambie a %1",
  	EVENT_WHENGREATERTHAN: "quan %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "en recibir %1",
  	EVENT_BROADCAST: "ninviar %1",
  	EVENT_BROADCASTANDWAIT: "ninviar %1 y aguardar",
  	CONTROL_WAIT: "aguardar %1 segundos",
  	CONTROL_REPEAT: "repetir %1",
  	CONTROL_FOREVER: "pa cutio",
  	CONTROL_IF: "si %1 allora",
  	CONTROL_WAITUNTIL: "aguardar dica que %1",
  	CONTROL_REPEATUNTIL: "repetir dica que %1",
  	CONTROL_STOP: "aturar %1",
  	CONTROL_STARTASCLONE: "en prencipiar como replica",
  	CONTROL_CREATECLONEOF: "crear replica de %1",
  	CONTROL_DELETETHISCLONE: "eliminar esta replica",
  	SENSING_ASKANDWAIT: "preguntar %1 y aguardar",
  	"videoSensing.videoToggle": "%1 video",
  	"videoSensing.setVideoTransparency": "fixar transparencia de video a %1",
  	"videoSensing.whenMotionGreaterThan": "quan movimiento de video > %1",
  	SENSING_RESETTIMER: "reiniciar cronometro",
  	DATA_SETVARIABLETO: "dar a %1 la valor %2",
  	DATA_CHANGEVARIABLEBY: "sumar %2 a %1",
  	DATA_SHOWVARIABLE: "amostrar variable %1",
  	DATA_HIDEVARIABLE: "amagar variable %1",
  	DATA_ADDTOLIST: "anyadir %1 a %2",
  	DATA_DELETEOFLIST: "eliminar %1 de %2",
  	DATA_DELETEALLOFLIST: "eliminar totz de %1",
  	MOTION_IFONEDGEBOUNCE: "si toca un canto, recutir",
  	DATA_INSERTATLIST: "clavar %1 en a posición %2 de %3",
  	DATA_REPLACEITEMOFLIST: "reemplazar elemento %1 de %2 con %3",
  	DATA_SHOWLIST: "amostrar la lista %1",
  	DATA_HIDELIST: "amagar la lista %1",
  	SENSING_OF_XPOSITION: "posición en x",
  	SENSING_OF_YPOSITION: "posición en y",
  	SENSING_OF_DIRECTION: "dirección",
  	SENSING_OF_COSTUMENUMBER: "# de vestiu",
  	LOOKS_COSTUMENUMBERNAME: "%1 de vestiu",
  	SENSING_OF_SIZE: "grandaria",
  	SENSING_OF_BACKDROPNAME: "nombre de fondo",
  	LOOKS_BACKDROPNUMBERNAME: "%1 de fondo",
  	SENSING_OF_BACKDROPNUMBER: "# de fondo",
  	SOUND_VOLUME: "volumen",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "tocando %1?",
  	SENSING_TOUCHINGCOLOR: "tocando la color %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "color %1 tocando %2?",
  	SENSING_DISTANCETO: "distancia a %1",
  	SENSING_ANSWER: "respuesta",
  	SENSING_KEYPRESSED: "tecla %1 pretada?",
  	SENSING_MOUSEDOWN: "ratet pretau?",
  	SENSING_MOUSEX: "posición x d'o ratet",
  	SENSING_MOUSEY: "posición y d'o ratet",
  	SENSING_SETDRAGMODE: "fixar modo d'arrociegue a %1",
  	SENSING_LOUDNESS: "volumen d'o son",
  	"videoSensing.videoOn": "%1 de video en %2",
  	SENSING_TIMER: "cronometro",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "%1 actual",
  	SENSING_DAYSSINCE2000: "días dende lo 2000",
  	SENSING_USERNAME: "nombre d'usuario",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "numero aleatorio entre %1 y %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 y %2",
  	OPERATORS_OR: "%1 u %2",
  	OPERATORS_NOT: "no %1",
  	OPERATORS_JOIN: "unir %1 %2",
  	OPERATORS_LETTEROF: "letra %1 de %2",
  	OPERATORS_LENGTH: "longaria de %1",
  	OPERATORS_MOD: "%1 modulo %2",
  	OPERATORS_ROUND: "redondiar %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%2 ye en %1?",
  	DATA_ITEMOFLIST: "elemento %1 de %2",
  	DATA_ITEMNUMOFLIST: "# d'elementos de %1 en %2",
  	DATA_LENGTHOFLIST: "longaria de %1",
  	DATA_LISTCONTAINSITEM: "%2 ye en %1?",
  	CONTROL_ELSE: "si no",
  	SENSING_USERID: "identificación d'usuario",
  	SENSING_LOUD: "masiau alto?",
  	"text2speech.speakAndWaitBlock": "decir %1",
  	"text2speech.setVoiceBlock": "fixar voz a %1",
  	"text2speech.setLanguageBlock": "fixar idioma a %1",
  	"translate.translateBlock": "traducir %1 enta lo %2",
  	"translate.viewerLanguage": "idioma",
  	"makeymakey.whenKeyPressed": "en presionar tecla %1",
  	"makeymakey.whenKeysPressedInOrder": "en presionar %1 en orden",
  	"microbit.whenButtonPressed": "en pretar botón %1",
  	"microbit.isButtonPressed": "botón %1 presionau?",
  	"microbit.whenGesture": "quan %1",
  	"microbit.displaySymbol": "amostrar %1",
  	"microbit.displayText": "amostrar texto %1",
  	"microbit.clearDisplay": "limpiar pantalla",
  	"microbit.whenTilted": "en abocar-se enta %1",
  	"microbit.isTilted": "abocau enta %1?",
  	"microbit.tiltAngle": "anglo d'inclinación enta %1",
  	"microbit.whenPinConnected": "en connectar pin %1",
  	"ev3.motorTurnClockwise": "motor %1 chirar ta un costau %2 segundos",
  	"ev3.motorTurnCounterClockwise": "motor %1 chirar a l'atro costau %2 segundos",
  	"ev3.motorSetPower": "motor %1 fixar potencia a %2 %",
  	"ev3.getMotorPosition": "posición d'o motor %1",
  	"ev3.whenButtonPressed": "en pretar botón %1",
  	"ev3.whenDistanceLessThan": "quan distancia < %1",
  	"ev3.whenBrightnessLessThan": "quan brilo < %1",
  	"ev3.buttonPressed": "botón %1 pretau?",
  	"ev3.getDistance": "distancia",
  	"ev3.getBrightness": "brilo",
  	"ev3.beepNote": "tanyer nota %1 %2 segundos",
  	"wedo2.motorOn": "enchegar %1",
  	"wedo2.motorOff": "amortar %1",
  	"wedo2.startMotorPower": "fixar potencia de %1 a %2",
  	"wedo2.setMotorDirection": "fixar dirección de %1 a %2",
  	"wedo2.whenDistance": "quan distancia %1 %2",
  	"wedo2.getDistance": "distancia",
  	"wedo2.motorOnFor": "enchegar %1 por %2 segundos",
  	"wedo2.setLightHue": "fixar color d'a luz a %1",
  	"wedo2.playNoteFor": "tanyer nota %1 por %2 segundos",
  	"wedo2.whenTilted": "en abocar-se enta %1",
  	"wedo2.isTilted": "abocau enta %1?",
  	"wedo2.getTiltAngle": "anglo d'inclinación enta %1",
  	"gdxfor.whenGesture": "quan %1",
  	"gdxfor.whenForcePushedOrPulled": "quan o sensor de fuerza %1",
  	"gdxfor.getForce": "fuerza",
  	"gdxfor.whenTilted": "en abocar-se %1",
  	"gdxfor.isTilted": "abocau %1?",
  	"gdxfor.getTilt": "anglo d'inclinación %1",
  	"gdxfor.isFreeFalling": "cayendo?",
  	"gdxfor.getSpin": "velocidat de chiro %1",
  	"gdxfor.getAcceleration": "acceleración %1",
  	"boost.motorOnFor": "chirar motor %1 %2 segundos",
  	"boost.motorOnForRotation": "chirar motor %1 %2 vueltas",
  	"boost.motorOn": "enchegar motor %1",
  	"boost.motorOff": "amortar motor %1",
  	"boost.setMotorPower": "fixar velocidat d'o motor %1 a o %2 %",
  	"boost.setMotorDirection": "fixar adreza d'o motor %1 %2",
  	"boost.getMotorPosition": "posición d'o motor %1",
  	"boost.whenColor": "en detectar lo bloque %1",
  	"boost.seeingColor": "detecta lo bloque %1?",
  	"boost.whenTilted": "en abocar-se enta %1",
  	"boost.getTiltAngle": "anglo d'inclinación enta %1",
  	"boost.setLightHue": "fixar color d'a luz a %1"
  };
  var dropdowns$1a = {
  };
  var ignorelt$1a = [
  ];
  var soundEffects$1a = [
  	"tono",
  	"balanz zurda/dreita"
  ];
  var microbitWhen$1a = [
  	"moviu",
  	"sobatiu",
  	"blincau"
  ];
  var osis$1a = [
  	"atros programas en l'obchecto"
  ];
  var definePrefix$1a = [
  	"definir"
  ];
  var defineSuffix$1a = [
  ];
  var palette$1a = {
  	Motion: "Movimiento",
  	Looks: "Apariencia",
  	Sound: "Son",
  	Events: "Eventos",
  	Control: "Control",
  	Sensing: "Sensors",
  	Operators: "Operadors",
  	Variables: "Variables",
  	"My Blocks": "Los míos bloques"
  };
  var math$1a = [
  	"valor absoluta",
  	"suelo",
  	"teito",
  	"radiz quadrada",
  	"sen",
  	"cos",
  	"tan",
  	"arcsen",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$1a = {
  };
  var name$1a = "Aragonés";
  var percentTranslated$1a = 100;
  var an = {
  	commands: commands$1a,
  	dropdowns: dropdowns$1a,
  	ignorelt: ignorelt$1a,
  	soundEffects: soundEffects$1a,
  	microbitWhen: microbitWhen$1a,
  	osis: osis$1a,
  	definePrefix: definePrefix$1a,
  	defineSuffix: defineSuffix$1a,
  	palette: palette$1a,
  	math: math$1a,
  	aliases: aliases$1a,
  	name: name$1a,
  	percentTranslated: percentTranslated$1a
  };

  var commands$19 = {
  	MOTION_MOVESTEPS: "تحرك %1 خطوة",
  	MOTION_TURNRIGHT: "استدر @turnRight %1 درجة",
  	MOTION_TURNLEFT: "استدر @turnLeft %1 درجة",
  	MOTION_POINTINDIRECTION: "اتجه نحو الاتجاه %1",
  	MOTION_POINTTOWARDS: "اتجه نحو %1",
  	MOTION_GOTOXY: "اذهب إلى الموضع س: %1 ص: %2",
  	MOTION_GOTO: "اذهب إلى %1",
  	MOTION_GLIDESECSTOXY: "انزلق خلال %1 ثانية إلى الموضع س: %2 ص: %3",
  	MOTION_GLIDETO: "انزلق خلال %1 ثانية إلى %2",
  	MOTION_CHANGEXBY: "غيِّر الموضع س بمقدار %1",
  	MOTION_SETX: "اجعل الموضع س مساويًا %1",
  	MOTION_CHANGEYBY: "غيِّر الموضع ص بمقدار %1",
  	MOTION_SETY: "اجعل الموضع ص مساويًا %1",
  	MOTION_SETROTATIONSTYLE: "اجعل نمط الدوران %1",
  	LOOKS_SAYFORSECS: "قل %1 لمدة %2 ثانية",
  	LOOKS_SAY: "قل %1",
  	LOOKS_THINKFORSECS: "فكِّر %1 لمدة %2 ثانية",
  	LOOKS_THINK: "فكِّر %1",
  	LOOKS_SHOW: "اظهر",
  	LOOKS_HIDE: "اختفِ",
  	LOOKS_SWITCHCOSTUMETO: "غيِّر المظهر إلى %1",
  	LOOKS_NEXTCOSTUME: "المظهر التالي",
  	LOOKS_NEXTBACKDROP_BLOCK: "الخلفية التالية",
  	LOOKS_SWITCHBACKDROPTO: "غيِّر الخلفية إلى %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "غيِّر الخلفية إلى %1 وانتظر",
  	LOOKS_CHANGEEFFECTBY: "غيِّر مؤثر %1 بمقدار %2",
  	LOOKS_SETEFFECTTO: "اجعل مؤثر %1 مساويًا %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "أزل المؤثرات الرسومية",
  	LOOKS_CHANGESIZEBY: "غيِّر الحجم بمقدار %1",
  	LOOKS_SETSIZETO: "اجعل الحجم مساويًا %1 ٪",
  	LOOKS_GOTOFRONTBACK: "انتقل إلى الطبقة %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "انتقل إلى %1 %2 طبقة",
  	SOUND_PLAY: "ابدأ الصوت %1",
  	SOUND_CHANGEEFFECTBY: "غيِّر مؤثر %1 بمقدار %2",
  	SOUND_SETEFFECTO: "اجعل مؤثر %1 مساويًا %2",
  	SOUND_CLEAREFFECTS: "أزل المؤثرات الصوتية",
  	SOUND_PLAYUNTILDONE: "شغِّل الصوت %1 حتى انتهاءه",
  	SOUND_STOPALLSOUNDS: "أوقف كل الأصوات",
  	"music.playDrumForBeats": "اقرع %1 مدة %2 وحدة إيقاع",
  	"music.restForBeats": "استرح مدة %1 وحدة إيقاع",
  	"music.playNoteForBeats": "اعزف النغمة %1 مدة %2 وحدة إيقاع",
  	"music.setInstrument": "اجعل الآلة %1",
  	SOUND_CHANGEVOLUMEBY: "غيِّر شدة الصوت بمقدار %1",
  	SOUND_SETVOLUMETO: "اجعل شدّة الصوت مساويةً %1%",
  	"music.changeTempo": "غيِّر سرعة الأداء بمقدار %1",
  	"music.setTempo": "اجعل سرعة الأداء مساويةً %1 وحدة إيقاع في الدقيقة",
  	"pen.clear": "مسح الكل",
  	"pen.stamp": "اطبع",
  	"pen.penDown": "أنزل القلم",
  	"pen.penUp": "ارفع القلم",
  	"pen.setColor": "اجعل لون القلم مساويًا %1",
  	"pen.changeHue": "غيِّر لون القلم بمقدار %1",
  	"pen.setColorParam": "اجعل %1 القلم مساويًا %2",
  	"pen.changeColorParam": "غيِّر %1 القلم بمقدار %2",
  	"pen.setHue": "اجعل لون القلم مساويًا %1",
  	"pen.changeShade": "غيِّر تظليل القلم بمقدار %1",
  	"pen.setShade": "اجعل تظليل القلم مساويًا %1",
  	"pen.changeSize": "غيِّر حجم القلم بمقدار %1",
  	"pen.setSize": "اجعل حجم القلم مساويًا %1",
  	EVENT_WHENFLAGCLICKED: "عند نقر @greenFlag",
  	EVENT_WHENKEYPRESSED: "عند ضغط مفتاح %1",
  	EVENT_WHENTHISSPRITECLICKED: "عند نقر هذا الكائن",
  	EVENT_WHENSTAGECLICKED: "عند نقر المنصة",
  	EVENT_WHENBACKDROPSWITCHESTO: "عندما تتبدل الخلفية إلى %1",
  	EVENT_WHENGREATERTHAN: "عندما %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "عندما أتلقى %1",
  	EVENT_BROADCAST: "بث %1",
  	EVENT_BROADCASTANDWAIT: "بث %1 وانتظر",
  	CONTROL_WAIT: "انتظر %1 ثانية",
  	CONTROL_REPEAT: "كرِّر %1 مرة",
  	CONTROL_FOREVER: "كرِّر باستمرار",
  	CONTROL_IF: "إذا %1",
  	CONTROL_WAITUNTIL: "انتظر حتى %1",
  	CONTROL_REPEATUNTIL: "كرِّر حتى %1",
  	CONTROL_STOP: "أوقف %1",
  	CONTROL_STARTASCLONE: "عندما تبدأ نسخة مني",
  	CONTROL_CREATECLONEOF: "أنشئ نسخة من %1",
  	CONTROL_DELETETHISCLONE: "احذف هذه النسخة",
  	SENSING_ASKANDWAIT: "اسأل %1 وانتظر",
  	"videoSensing.videoToggle": "اجعل الفيديو %1",
  	"videoSensing.setVideoTransparency": "اجعل شفافية الفيديو مساويةً %1",
  	"videoSensing.whenMotionGreaterThan": "عندما حركة الفيديو > %1",
  	SENSING_RESETTIMER: "صفِّر المؤقت",
  	DATA_SETVARIABLETO: "اجعل %1 مساويًا %2",
  	DATA_CHANGEVARIABLEBY: "غيِّر %1 بمقدار %2",
  	DATA_SHOWVARIABLE: "أظهر المتغير %1",
  	DATA_HIDEVARIABLE: "أخفِ المتغير %1",
  	DATA_ADDTOLIST: "أضف %1 إلى %2",
  	DATA_DELETEOFLIST: "احذف %1 من %2",
  	DATA_DELETEALLOFLIST: "احذف كل العناصر في %1",
  	MOTION_IFONEDGEBOUNCE: "ارتد إذا كنت عند الحافة",
  	DATA_INSERTATLIST: "أدرج %1 في الموقع %2 من %3",
  	DATA_REPLACEITEMOFLIST: "استبدل %3 بالعنصر %1 من %2",
  	DATA_SHOWLIST: "أظهر اللائحة %1",
  	DATA_HIDELIST: "أخفِ اللائحة %1",
  	SENSING_OF_XPOSITION: "الموضع س",
  	SENSING_OF_YPOSITION: "الموضع ص",
  	SENSING_OF_DIRECTION: "الاتجاه",
  	SENSING_OF_COSTUMENUMBER: "رقم المظهر",
  	LOOKS_COSTUMENUMBERNAME: "%1 المظهر",
  	SENSING_OF_SIZE: "الحجم",
  	SENSING_OF_BACKDROPNAME: "اسم الخلفية",
  	LOOKS_BACKDROPNUMBERNAME: "%1 الخلفية",
  	SENSING_OF_BACKDROPNUMBER: "رقم الخلفية",
  	SOUND_VOLUME: "شدة الصوت",
  	"music.getTempo": "سرعة الأداء",
  	SENSING_TOUCHINGOBJECT: "ملامس لـ %1؟",
  	SENSING_TOUCHINGCOLOR: "ملامس للون %1؟",
  	SENSING_COLORISTOUCHINGCOLOR: "اللون %1 ملامس للون %2؟",
  	SENSING_DISTANCETO: "المسافة إلى %1",
  	SENSING_ANSWER: "الإجابة",
  	SENSING_KEYPRESSED: "مفتاح %1 مضغوط؟",
  	SENSING_MOUSEDOWN: "زر الفأرة مضغوط؟",
  	SENSING_MOUSEX: "الموضع س للفأرة",
  	SENSING_MOUSEY: "الموضع ص للفأرة",
  	SENSING_SETDRAGMODE: "اجعل السحب %1",
  	SENSING_LOUDNESS: "الضجيج",
  	"videoSensing.videoOn": "%1 الفيديو على %2",
  	SENSING_TIMER: "المؤقت",
  	SENSING_OF: "%1 الخاص بـ %2",
  	SENSING_CURRENT: "%1 الآن",
  	SENSING_DAYSSINCE2000: "الأيام منذ عام 2000",
  	SENSING_USERNAME: "اسم المستخدم",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 × %2",
  	OPERATORS_DIVIDE: "%1 ÷ %2",
  	OPERATORS_RANDOM: "عدد عشوائي بين %1 و %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 و %2",
  	OPERATORS_OR: "%1 أو %2",
  	OPERATORS_NOT: "ليس %1",
  	OPERATORS_JOIN: "اربط %1 %2",
  	OPERATORS_LETTEROF: "الحرف %1 من %2",
  	OPERATORS_LENGTH: "طول %1",
  	OPERATORS_MOD: "باقي قسمة %1 على %2",
  	OPERATORS_ROUND: "تقريب %1",
  	OPERATORS_MATHOP: "%1 للقيمة %2",
  	OPERATORS_CONTAINS: "%1 تحتوي %2؟",
  	DATA_ITEMOFLIST: "العنصر %1 من %2",
  	DATA_ITEMNUMOFLIST: "رقم العنصر ذي القيمة %1 في %2",
  	DATA_LENGTHOFLIST: "طول %1",
  	DATA_LISTCONTAINSITEM: "%1 تحتوي %2؟",
  	CONTROL_ELSE: "وإلا",
  	SENSING_USERID: "رقم المستخدم",
  	SENSING_LOUD: "الصوت مرتفع؟",
  	"text2speech.speakAndWaitBlock": "تكلم %1",
  	"text2speech.setVoiceBlock": "اجعل الصوت %1",
  	"text2speech.setLanguageBlock": "اجعل اللغة هي %1",
  	"translate.translateBlock": "ترجم %1 إلى %2",
  	"translate.viewerLanguage": "لغتي",
  	"makeymakey.whenKeyPressed": "عند ضغط مفتاح %1",
  	"makeymakey.whenKeysPressedInOrder": "عند ضغط %1 بالترتيب",
  	"microbit.whenButtonPressed": "عند ضغط الزر %1",
  	"microbit.isButtonPressed": "الزر %1 مضغوط؟",
  	"microbit.whenGesture": "عند %1",
  	"microbit.displaySymbol": "اعرض %1",
  	"microbit.displayText": "اعرض النص %1",
  	"microbit.clearDisplay": "امسح الشاشة",
  	"microbit.whenTilted": "عند الميل نحو %1",
  	"microbit.isTilted": "مائل نحو %1؟",
  	"microbit.tiltAngle": "زاوية الميل نحو %1",
  	"microbit.whenPinConnected": "عند توصيل الرجل %1",
  	"ev3.motorTurnClockwise": "شغل المحرك %1 في هذا الاتجاه مدة %2 ثوانٍ",
  	"ev3.motorTurnCounterClockwise": "شغل المحرك %1 في ذاك الاتجاه مدة %2 ثوانٍ",
  	"ev3.motorSetPower": "اجعل طاقة المحرك %1 مساويةً %2 ٪",
  	"ev3.getMotorPosition": "موضع المحرك %1",
  	"ev3.whenButtonPressed": "عند ضغط زر %1",
  	"ev3.whenDistanceLessThan": "عندما المسافة < %1",
  	"ev3.whenBrightnessLessThan": "عندما الإضاءة < %1",
  	"ev3.buttonPressed": "الزر %1 مضغوط؟",
  	"ev3.getDistance": "المسافة",
  	"ev3.getBrightness": "شدة الإضاءة",
  	"ev3.beepNote": "شغل النغمة %1 مدة %2 ثوانٍ",
  	"wedo2.motorOn": "شغِّل %1",
  	"wedo2.motorOff": "أوقف %1",
  	"wedo2.startMotorPower": "اجعل قوة %1  مساويةً %2",
  	"wedo2.setMotorDirection": "اجعل دوران %1 في %2",
  	"wedo2.whenDistance": "عندما المسافة %1 %2",
  	"wedo2.getDistance": "المسافة",
  	"wedo2.motorOnFor": "شغّل %1 مدة %2 ثوانٍ",
  	"wedo2.setLightHue": "اجعل لون المصباح مساويًا %1",
  	"wedo2.playNoteFor": "اعزف النغمة %1 مدة %2 ثوانٍ",
  	"wedo2.whenTilted": "عند الإمالة نحو %1",
  	"wedo2.isTilted": "مائل نحو %1؟",
  	"wedo2.getTiltAngle": "زاوية الميل نحو %1",
  	"gdxfor.whenGesture": "عندما %1",
  	"gdxfor.whenForcePushedOrPulled": "عندما حساس القوة %1",
  	"gdxfor.getForce": "القوة",
  	"gdxfor.whenTilted": "عندما يميل %1",
  	"gdxfor.isTilted": "مائل %1؟",
  	"gdxfor.getTilt": "زاوية الميلان %1",
  	"gdxfor.isFreeFalling": "في حالة سقوط؟",
  	"gdxfor.getSpin": "سرعة الدوران %1",
  	"gdxfor.getAcceleration": "التسارع %1",
  	"boost.motorOnFor": "شغِّل المحرك %1 مدة %2 ثانية",
  	"boost.motorOnForRotation": "شغِّل المحرك %1 لـ%2 دورات",
  	"boost.motorOn": "شغِّل المحرك %1",
  	"boost.motorOff": "أوقف المحرك %1",
  	"boost.setMotorPower": "اجعل سرعة المحرك %1 مساويةً %2 ٪",
  	"boost.setMotorDirection": "اجعل اتجاه المحرك %1 مساويًا %2",
  	"boost.getMotorPosition": "موضع المحرك %1",
  	"boost.whenColor": "عندما ترى اللبنة ذات اللون %1",
  	"boost.seeingColor": "ترى اللبنة ذات اللون %1؟",
  	"boost.whenTilted": "عند الإمالة نحو %1",
  	"boost.getTiltAngle": "زاوية الميلان %1",
  	"boost.setLightHue": "اجعل لون المصباح مساويًا %1"
  };
  var dropdowns$19 = {
  };
  var ignorelt$19 = [
  ];
  var soundEffects$19 = [
  	"طبقة الصوت",
  	"توزيع الصوت يسار/يمين"
  ];
  var microbitWhen$19 = [
  	"الحركة",
  	"الهز",
  	"القفز"
  ];
  var osis$19 = [
  	"المقاطع الأخرى في الكائن"
  ];
  var definePrefix$19 = [
  	"عرِّف"
  ];
  var defineSuffix$19 = [
  ];
  var palette$19 = {
  	Motion: "الحركة",
  	Looks: "الهيئة",
  	Sound: "الصوت",
  	Events: "الأحداث",
  	Control: "التحكم",
  	Sensing: "الاستشعار",
  	Operators: "العمليات",
  	Variables: "المتغيرات",
  	"My Blocks": "لبناتي"
  };
  var math$19 = [
  	"القيمة المطلقة",
  	"الجزء الصحيح",
  	"السقف",
  	"الجذر التربيعي",
  	"الجيب (sin)",
  	"جيب التمام (cos)",
  	"الظل (tan)",
  	"الجيب العكسي (asin)",
  	"جيب التمام العكسي (acos)",
  	"الظل العكسي (atan)",
  	"اللوغارتم الطبيعي",
  	"اللوغارتم العشري",
  	"هـ^",
  	"10^"
  ];
  var aliases$19 = {
  };
  var name$19 = "العربية";
  var percentTranslated$19 = 100;
  var ar = {
  	commands: commands$19,
  	dropdowns: dropdowns$19,
  	ignorelt: ignorelt$19,
  	soundEffects: soundEffects$19,
  	microbitWhen: microbitWhen$19,
  	osis: osis$19,
  	definePrefix: definePrefix$19,
  	defineSuffix: defineSuffix$19,
  	palette: palette$19,
  	math: math$19,
  	aliases: aliases$19,
  	name: name$19,
  	percentTranslated: percentTranslated$19
  };

  var commands$18 = {
  	MOTION_MOVESTEPS: "mover %1 pasos",
  	MOTION_TURNRIGHT: "xirar @turnRight %1 graos",
  	MOTION_TURNLEFT: "xirar @turnLeft %1 graos",
  	MOTION_POINTINDIRECTION: "apuntar en direicion %1",
  	MOTION_POINTTOWARDS: "apuntar a %1",
  	MOTION_GOTOXY: "dir a x: %1 y: %2",
  	MOTION_GOTO: "dir a %1",
  	MOTION_GLIDESECSTOXY: "eslizar %1 seg. a x: %2 y: %3",
  	MOTION_GLIDETO: "eslizar en %1 segundos a %2",
  	MOTION_CHANGEXBY: "cambiar x por %1",
  	MOTION_SETX: "poner x a %1",
  	MOTION_CHANGEYBY: "cambiar y por %1",
  	MOTION_SETY: "poner y a %1",
  	MOTION_SETROTATIONSTYLE: "poner estilu de xiru %1",
  	LOOKS_SAYFORSECS: "dicir %1 durante %2 segundos",
  	LOOKS_SAY: "dicir %1",
  	LOOKS_THINKFORSECS: "pensar %1 durante %2 segundos",
  	LOOKS_THINK: "pensar %1",
  	LOOKS_SHOW: "amosar",
  	LOOKS_HIDE: "anubrir",
  	LOOKS_SWITCHCOSTUMETO: "cambiar disfraz a %1",
  	LOOKS_NEXTCOSTUME: "siguiente disfraz",
  	LOOKS_NEXTBACKDROP_BLOCK: "siguiente fondu",
  	LOOKS_SWITCHBACKDROPTO: "cambiar fondu a %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "cambiar fondu a %1 y esperar",
  	LOOKS_CHANGEEFFECTBY: "cambiar l'efectu %1 por %2",
  	LOOKS_SETEFFECTTO: "poner l'efectu %1 a %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "llimpiar efeutos gráficos",
  	LOOKS_CHANGESIZEBY: "cambiar tamañu por %1",
  	LOOKS_SETSIZETO: "poner tamañu a %1",
  	LOOKS_GOTOFRONTBACK: "dir a la capa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "dir %1 %2 caoes",
  	SOUND_PLAY: "tocar el soníu %1",
  	SOUND_CHANGEEFFECTBY: "cambiar l'efectu %1 por %2",
  	SOUND_SETEFFECTO: "poner l'efectu %1 a %2",
  	SOUND_CLEAREFFECTS: "esborrar efeutos de soníu",
  	SOUND_PLAYUNTILDONE: "tocar el soníu %1 hasta qu'acabe",
  	SOUND_STOPALLSOUNDS: "parar tolos soníos",
  	"music.playDrumForBeats": "tocar el tambor %1 pa %2 pulsos",
  	"music.restForBeats": "silenciu pa %1 pulsos",
  	"music.playNoteForBeats": "tocar una nota %1 pa %2 pulsos",
  	"music.setInstrument": "afitar instrumentu pa %1",
  	SOUND_CHANGEVOLUMEBY: "cambiar volume por %1",
  	SOUND_SETVOLUMETO: "poner volume a %1%",
  	"music.changeTempo": "camudar el tempo por %1",
  	"music.setTempo": "afitar el tempu en %1",
  	"pen.clear": "esborriar too",
  	"pen.stamp": "sellu",
  	"pen.penDown": "baxar llápiz",
  	"pen.penUp": "xubir llápiz",
  	"pen.setColor": "afitar el color del llápiz en %1",
  	"pen.changeHue": "camudar el llápiz por %1",
  	"pen.setColorParam": "afitar el llápiz %1 como %2",
  	"pen.changeColorParam": "camudar el llápiz %1 por %2",
  	"pen.setHue": "afitar el llápiz como %1",
  	"pen.changeShade": "camudar la intensidá del llápiz por %1",
  	"pen.setShade": "afitar el llápiz como %1",
  	"pen.changeSize": "camudar el tamañu del llápiz por %1",
  	"pen.setSize": "apitar el tamañu del llápiz como %1",
  	EVENT_WHENFLAGCLICKED: "cuando se calca en @greenFlag",
  	EVENT_WHENKEYPRESSED: "cuando se calca la tecla %1",
  	EVENT_WHENTHISSPRITECLICKED: "cuando se calque nesti personaxe",
  	EVENT_WHENSTAGECLICKED: "cuando se calque nel escenariu",
  	EVENT_WHENBACKDROPSWITCHESTO: "cuando'l fondu cambie a %1",
  	EVENT_WHENGREATERTHAN: "cuando %1>%2",
  	EVENT_WHENBROADCASTRECEIVED: "cuando reciba %1",
  	EVENT_BROADCAST: "tresmitir %1",
  	EVENT_BROADCASTANDWAIT: "tresmitir %1 y esperar",
  	CONTROL_WAIT: "esperar %1 segundos",
  	CONTROL_REPEAT: "repetir %1",
  	CONTROL_FOREVER: "pa siempres",
  	CONTROL_IF: "si %1 entós",
  	CONTROL_WAITUNTIL: "esperar hasta %1",
  	CONTROL_REPEATUNTIL: "repetir hasta %1",
  	CONTROL_STOP: "parar %1",
  	CONTROL_STARTASCLONE: "cuando principie como clon",
  	CONTROL_CREATECLONEOF: "crear clon de %1",
  	CONTROL_DELETETHISCLONE: "desaniciar esti clon",
  	SENSING_ASKANDWAIT: "Entrugar %1 y esperar",
  	"videoSensing.videoToggle": "videu %1",
  	"videoSensing.setVideoTransparency": "afitar tresparencia del videu como %1",
  	"videoSensing.whenMotionGreaterThan": "cuando'l movimientu del videu > %1",
  	SENSING_RESETTIMER: "reaniciar el cronómetru",
  	DATA_SETVARIABLETO: "poner %1 a %2",
  	DATA_CHANGEVARIABLEBY: "cambiar %1 por %2",
  	DATA_SHOWVARIABLE: "amosar variable %1",
  	DATA_HIDEVARIABLE: "anubrir variable %1",
  	DATA_ADDTOLIST: "amestar %1 a %2",
  	DATA_DELETEOFLIST: "esborrar %1 de %2",
  	DATA_DELETEALLOFLIST: "esborrar too de %1",
  	MOTION_IFONEDGEBOUNCE: "si ta na llende, rebotar",
  	DATA_INSERTATLIST: "inxertar %1 en %2 de %3",
  	DATA_REPLACEITEMOFLIST: "sustituyir item %1 de %2 con %3",
  	DATA_SHOWLIST: "amosar llista %1",
  	DATA_HIDELIST: "anubrir llista %1",
  	SENSING_OF_XPOSITION: "posición x",
  	SENSING_OF_YPOSITION: "posición y",
  	SENSING_OF_DIRECTION: "direición",
  	SENSING_OF_COSTUMENUMBER: "núm. de disfraz",
  	LOOKS_COSTUMENUMBERNAME: "disfraz %1",
  	SENSING_OF_SIZE: "tamañu",
  	SENSING_OF_BACKDROPNAME: "nombre de fondu",
  	LOOKS_BACKDROPNUMBERNAME: "fondu %1",
  	SENSING_OF_BACKDROPNUMBER: "núm. de fondu",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "¿tocando %1?",
  	SENSING_TOUCHINGCOLOR: "¿tocando'l color %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "¿el color %1 ta tocando %2?",
  	SENSING_DISTANCETO: "distancia a %1",
  	SENSING_ANSWER: "respuesta",
  	SENSING_KEYPRESSED: "¿ta calcada la tecla %1?",
  	SENSING_MOUSEDOWN: "¿tá'l mur calcáu?",
  	SENSING_MOUSEX: "x del mur",
  	SENSING_MOUSEY: "y del mur",
  	SENSING_SETDRAGMODE: "poner el mou d'arrastre %1",
  	SENSING_LOUDNESS: "volume del soníu",
  	"videoSensing.videoOn": "videu %1 en %2",
  	SENSING_TIMER: "cronómetru",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "actual %1",
  	SENSING_DAYSSINCE2000: "díes dende 2000",
  	SENSING_USERNAME: "nome d'usuariu",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "al debalu de %1 a %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 y %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "non %1",
  	OPERATORS_JOIN: "xuntar %1 %2",
  	OPERATORS_LETTEROF: "lletra %1 de %2",
  	OPERATORS_LENGTH: "llonxitú de %1",
  	OPERATORS_MOD: "%1 restu %2",
  	OPERATORS_ROUND: "redondiar %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%1 contién %2?",
  	DATA_ITEMOFLIST: "item %1 de %2",
  	DATA_ITEMNUMOFLIST: "item # de %1 en %2",
  	DATA_LENGTHOFLIST: "llonxitú de %1",
  	DATA_LISTCONTAINSITEM: "%1 contién %2?",
  	CONTROL_ELSE: "sinón",
  	SENSING_USERID: "id d'usuariu",
  	SENSING_LOUD: "¿ruidosu?",
  	"text2speech.speakAndWaitBlock": "falar %1",
  	"text2speech.setVoiceBlock": "afitar voz como %1",
  	"text2speech.setLanguageBlock": "afitar llingua como %1",
  	"translate.translateBlock": "traducir %1 al %2",
  	"translate.viewerLanguage": "llingua",
  	"makeymakey.whenKeyPressed": "cuando %1 la tecla tea calcada",
  	"makeymakey.whenKeysPressedInOrder": "cuando %1 tea calcáu n'orde",
  	"microbit.whenButtonPressed": "col %1 botón calcáu",
  	"microbit.isButtonPressed": "¿ %1 botón calcáu",
  	"microbit.whenGesture": "cuando %1",
  	"microbit.displaySymbol": "pantalla %1",
  	"microbit.displayText": "amosar testu %1",
  	"microbit.clearDisplay": "llimpiar pantalla",
  	"microbit.whenTilted": "cuando l'enclín %1",
  	"microbit.isTilted": "¿enclín %1?",
  	"microbit.tiltAngle": "ángulu d'enclín %1",
  	"microbit.whenPinConnected": "col pin %1 conectáu",
  	"ev3.motorTurnClockwise": "motor %1 torcer nesti sentíu pa %2 segundos",
  	"ev3.motorTurnCounterClockwise": "motor %1 torcer nesi sentíu pa %2 segundos",
  	"ev3.motorSetPower": "motor %1 afitar potencia %2 %",
  	"ev3.getMotorPosition": "posición del %1 motor",
  	"ev3.whenButtonPressed": "col botón %1 calcáu",
  	"ev3.whenDistanceLessThan": "cuando la distancia < %1",
  	"ev3.whenBrightnessLessThan": "cuando'l brillu < %1",
  	"ev3.buttonPressed": "¿botón %1 calcáu?",
  	"ev3.getDistance": "distancia",
  	"ev3.getBrightness": "brillu",
  	"ev3.beepNote": "pitíu %1 pa %2 segundos",
  	"wedo2.motorOn": "prender %1",
  	"wedo2.motorOff": "apagar %1",
  	"wedo2.startMotorPower": "afitar %1 potencia como %2",
  	"wedo2.setMotorDirection": "afitar %1 direición como %2",
  	"wedo2.whenDistance": "cuando la distancia %1 %2",
  	"wedo2.getDistance": "distancia",
  	"wedo2.motorOnFor": "prender %1 pa %2 segundos",
  	"wedo2.setLightHue": "afitar color de lluz pa %1",
  	"wedo2.playNoteFor": "tocar una nota %1 por %2 segundos",
  	"wedo2.whenTilted": "cuando l'enclín %1",
  	"wedo2.isTilted": "¿ enclín %1?",
  	"wedo2.getTiltAngle": "ángulu d'enclín %1",
  	"gdxfor.whenGesture": "cuando %1",
  	"gdxfor.whenForcePushedOrPulled": "cuando'l sensor de fuerza %1",
  	"gdxfor.getForce": "fuerza",
  	"gdxfor.whenTilted": "cuando l'enclín %1",
  	"gdxfor.isTilted": "¿enclináu %1?",
  	"gdxfor.getTilt": "ángulu d'enclín %1",
  	"gdxfor.isFreeFalling": "¿cayendo?",
  	"gdxfor.getSpin": "velocidá de xiru %1",
  	"gdxfor.getAcceleration": "aceleración %1",
  	"boost.motorOnFor": "prender motor %1 pa %2 segundos",
  	"boost.motorOnForRotation": "prender motor %1 pa %2 rotaciones",
  	"boost.motorOn": "prender motor %1",
  	"boost.motorOff": "apagar motor %1",
  	"boost.setMotorPower": "afitar velocidá del %1 motor pa %2 %",
  	"boost.setMotorDirection": "afitar direición del %1 motor %2",
  	"boost.getMotorPosition": "posición %1 motor",
  	"boost.whenColor": "cuando %1 lladriyu asemeya",
  	"boost.seeingColor": "¿viendo %1 lladriyu?",
  	"boost.whenTilted": "cuando l'enclín %1",
  	"boost.getTiltAngle": "ángulu d'enclín %1",
  	"boost.setLightHue": "afitar color de lluz pa %1"
  };
  var dropdowns$18 = {
  };
  var ignorelt$18 = [
  ];
  var soundEffects$18 = [
  	"tonu",
  	"panéu izquierda/drecha"
  ];
  var microbitWhen$18 = [
  	"movió",
  	"batulláu",
  	"saltó"
  ];
  var osis$18 = [
  	"otros scripts nel personaxe"
  ];
  var definePrefix$18 = [
  	"definir"
  ];
  var defineSuffix$18 = [
  ];
  var palette$18 = {
  	Motion: "Movimientu",
  	Looks: "Aspeutu",
  	Sound: "Soníu",
  	Events: "Socesos",
  	Control: "Control",
  	Sensing: "Sensores",
  	Operators: "Operadores",
  	Variables: "Variables",
  	"My Blocks": "Los Mios Bloques"
  };
  var math$18 = [
  	"abs",
  	"suelu",
  	"techu",
  	"raíz",
  	"sen",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$18 = {
  };
  var name$18 = "Asturianu";
  var percentTranslated$18 = 100;
  var ast = {
  	commands: commands$18,
  	dropdowns: dropdowns$18,
  	ignorelt: ignorelt$18,
  	soundEffects: soundEffects$18,
  	microbitWhen: microbitWhen$18,
  	osis: osis$18,
  	definePrefix: definePrefix$18,
  	defineSuffix: defineSuffix$18,
  	palette: palette$18,
  	math: math$18,
  	aliases: aliases$18,
  	name: name$18,
  	percentTranslated: percentTranslated$18
  };

  var commands$17 = {
  	MOTION_MOVESTEPS: "%1 addım at",
  	MOTION_TURNRIGHT: "dön @turnRight %1 dərəcə",
  	MOTION_TURNLEFT: "dön @turnLeft %1 dərəcə",
  	MOTION_POINTINDIRECTION: "%1 istiqamətində dön",
  	MOTION_POINTTOWARDS: "%1 tərəfinə dön",
  	MOTION_GOTOXY: "keç: x: %1 y: %2",
  	MOTION_GOTO: "keç: %1",
  	MOTION_GLIDESECSTOXY: "%1 saniyə x: %2 y: %3 nöqtəsinə üz",
  	MOTION_GLIDETO: "%1 saniyə %2 tərəfə üz",
  	MOTION_CHANGEXBY: "x-i %1 qədər dəyiş",
  	MOTION_SETX: "x-i %1 təyin et",
  	MOTION_CHANGEYBY: "y-i %1 qədər dəyiş",
  	MOTION_SETY: "y-i %1 təyin et",
  	MOTION_SETROTATIONSTYLE: "dönmə istiqamətini %1 təyin et",
  	LOOKS_SAYFORSECS: "%1 de %2 saniyə",
  	LOOKS_SAY: "%1 de",
  	LOOKS_THINKFORSECS: "%1 düşün %2 saniyə",
  	LOOKS_THINK: "%1 düşün",
  	LOOKS_SHOW: "görün",
  	LOOKS_HIDE: "gizlən",
  	LOOKS_SWITCHCOSTUMETO: "%1 libasına dəyiş",
  	LOOKS_NEXTCOSTUME: "növbəti libas",
  	LOOKS_NEXTBACKDROP_BLOCK: "növbəti fon",
  	LOOKS_SWITCHBACKDROPTO: "%1 fonuna dəyiş",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "fonu %1 fonuna dəyiş və gözlə",
  	LOOKS_CHANGEEFFECTBY: "%1 effektini %2 qədər dəyiş",
  	LOOKS_SETEFFECTTO: "%1 effektini %2 təyin et",
  	LOOKS_CLEARGRAPHICEFFECTS: "qrafik effektləri sil",
  	LOOKS_CHANGESIZEBY: "ölçünü %1 qədər dəyiş",
  	LOOKS_SETSIZETO: "ölçünü %1 % təyin et",
  	LOOKS_GOTOFRONTBACK: "%1 fonuna keç",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 fonuna keç",
  	SOUND_PLAY: "%1 səsini ifa et",
  	SOUND_CHANGEEFFECTBY: "%1 effektini %2 qədər dəyiş",
  	SOUND_SETEFFECTO: "%1 effektini %2 təyin et",
  	SOUND_CLEAREFFECTS: "səs effektlərini təmizlə",
  	SOUND_PLAYUNTILDONE: "%1 səsini sona qədər ifa et",
  	SOUND_STOPALLSOUNDS: "bütün səsləri dayandır",
  	"music.playDrumForBeats": "%1 barabanını %2 takt çal",
  	"music.restForBeats": "%1 takt çalma",
  	"music.playNoteForBeats": "%1 notunu %2 takt çal",
  	"music.setInstrument": "aləti %1 təyin et",
  	SOUND_CHANGEVOLUMEBY: "səs ucalığını %1 qədər dəyiş",
  	SOUND_SETVOLUMETO: "səs ucalığını %1% təyin et",
  	"music.changeTempo": "tempi %1 qədər dəyiş",
  	"music.setTempo": "tempi %1 təyin et",
  	"pen.clear": "hamısını sil",
  	"pen.stamp": "möhürlə",
  	"pen.penDown": "qələmi endir",
  	"pen.penUp": "qələmi qaldır",
  	"pen.setColor": "qələmin rəngini %1 təyin et",
  	"pen.changeHue": "qələmin rəngini %1 qədər dəyiş",
  	"pen.setColorParam": "qələmin %1 rəngini %2 təyin et",
  	"pen.changeColorParam": "qələmin %1 rəngini %2 qədər dəyiş",
  	"pen.setHue": "qələmin rəngini %1 təyin et",
  	"pen.changeShade": "qələmin çalarını %1 qədər dəyiş",
  	"pen.setShade": "qələmin çalarını %1 təyin et",
  	"pen.changeSize": "qələmin ölçüsünü %1 qədər dəyiş",
  	"pen.setSize": "qələmin ölçüsünü %1 təyin et",
  	EVENT_WHENFLAGCLICKED: "@greenFlag kliklənəndə",
  	EVENT_WHENKEYPRESSED: "%1 düyməsinə basdıqda",
  	EVENT_WHENTHISSPRITECLICKED: "sprayt kliklənəndə",
  	EVENT_WHENSTAGECLICKED: "səhnə kliklənəndə",
  	EVENT_WHENBACKDROPSWITCHESTO: "fon %1 fonuna dəyişdiriləndə",
  	EVENT_WHENGREATERTHAN: "%1 > %2 olduqda",
  	EVENT_WHENBROADCASTRECEIVED: "mən %1 qəbul edəndə",
  	EVENT_BROADCAST: "%1 ötür",
  	EVENT_BROADCASTANDWAIT: "%1 ötür və gözlə",
  	CONTROL_WAIT: "%1 saniyə gözlə",
  	CONTROL_REPEAT: "təkrarla %1 dəfə",
  	CONTROL_FOREVER: "həmişə",
  	CONTROL_IF: "əgər %1, onda",
  	CONTROL_WAITUNTIL: "%1 qədər gözlə",
  	CONTROL_REPEATUNTIL: "təkrarla nə qədər ki, %1 deyil",
  	CONTROL_STOP: "dayandır %1",
  	CONTROL_STARTASCLONE: "mən klon kimi başlayanda",
  	CONTROL_CREATECLONEOF: "%1 klonunu yarat",
  	CONTROL_DELETETHISCLONE: "bu klonu sil",
  	SENSING_ASKANDWAIT: "%1 soruş və gözlə",
  	"videoSensing.videoToggle": "videonu %1 çevir",
  	"videoSensing.setVideoTransparency": "videonun şəffaflığını %1 təyin et",
  	"videoSensing.whenMotionGreaterThan": "videonun hərəkəti > %1  olduqda",
  	SENSING_RESETTIMER: "taymeri yenidən başlat",
  	DATA_SETVARIABLETO: "%1 təyin et: %2",
  	DATA_CHANGEVARIABLEBY: "%1 -i %2 qədər dəyiş",
  	DATA_SHOWVARIABLE: "%1 dəyişənini göstər",
  	DATA_HIDEVARIABLE: "%1 dəyişənini gizlət",
  	DATA_ADDTOLIST: "%1 -i %2 siyahısına əlavə et",
  	DATA_DELETEOFLIST: "%1 elementini %2 siyahısından sil",
  	DATA_DELETEALLOFLIST: "%1 siyahısının bütün elementlərini sil",
  	MOTION_IFONEDGEBOUNCE: "kənara çatdınsa, geri çəkil",
  	DATA_INSERTATLIST: "%1 elementini %2 mövqeyində %3 siyahısına daxil et",
  	DATA_REPLACEITEMOFLIST: "%1 elementini %2 siyahısında %3 ilə əvəz et",
  	DATA_SHOWLIST: "%1 siyahısını göstər",
  	DATA_HIDELIST: "%1 siyahısını gizlət",
  	SENSING_OF_XPOSITION: "x mövqeyi",
  	SENSING_OF_YPOSITION: "y mövqeyi",
  	SENSING_OF_DIRECTION: "istiqamət",
  	SENSING_OF_COSTUMENUMBER: "libas #",
  	LOOKS_COSTUMENUMBERNAME: "%1 libası",
  	SENSING_OF_SIZE: "ölçü",
  	SENSING_OF_BACKDROPNAME: "fonun adı",
  	LOOKS_BACKDROPNUMBERNAME: "%1 fonu",
  	SENSING_OF_BACKDROPNUMBER: "fon #",
  	SOUND_VOLUME: "səsin yüksəkliyi",
  	"music.getTempo": "temp",
  	SENSING_TOUCHINGOBJECT: "%1 toxunur?",
  	SENSING_TOUCHINGCOLOR: "%1 rənginə toxunur?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 rəngi %2 rənginə toxunur?",
  	SENSING_DISTANCETO: "%1 qədər məsafə",
  	SENSING_ANSWER: "cavab",
  	SENSING_KEYPRESSED: "%1 düyməsi basılıb?",
  	SENSING_MOUSEDOWN: "siçanın düyməsi basılıb?",
  	SENSING_MOUSEX: "siçanın göstəricisinin x koordinatı",
  	SENSING_MOUSEY: "siçanın göstəricisinin y koordinatı",
  	SENSING_SETDRAGMODE: "%1 daşıma rejimi təyin et",
  	SENSING_LOUDNESS: "səs ucalığı",
  	"videoSensing.videoOn": "videonun %1 atributları %2 aid",
  	SENSING_TIMER: "taymer",
  	SENSING_OF: "%1 %2-in",
  	SENSING_CURRENT: "cari %1",
  	SENSING_DAYSSINCE2000: "01.01.2000 tarixindən ötən günlərin sayı",
  	SENSING_USERNAME: "istifadəçinin adı",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 və %2 arasında təsadüfi seç",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 və %2",
  	OPERATORS_OR: "%1 və ya %2",
  	OPERATORS_NOT: "%1 deyil",
  	OPERATORS_JOIN: "birləşdir: %1 və %2",
  	OPERATORS_LETTEROF: "hərf %1 %2-də",
  	OPERATORS_LENGTH: "%1 sözünün uzunluğu",
  	OPERATORS_MOD: "%1 ədədinin %2 ədədinə bölünməsindən qalıq",
  	OPERATORS_ROUND: "%1 yuvarlaqlaşdır",
  	OPERATORS_MATHOP: "%1 %2",
  	OPERATORS_CONTAINS: "%1 sözünün tərkibində %2 hərfi var?",
  	DATA_ITEMOFLIST: "%1 elementi %2 siyahısından",
  	DATA_ITEMNUMOFLIST: "item # of %1 in %2",
  	DATA_LENGTHOFLIST: "%1 siyahısının uzunluğu",
  	DATA_LISTCONTAINSITEM: "%1 tərkibində %2 var?",
  	CONTROL_ELSE: "əks halda",
  	SENSING_USERID: "istifadəçi adı",
  	SENSING_LOUD: "ucadır?",
  	"text2speech.speakAndWaitBlock": "speak %1",
  	"text2speech.setVoiceBlock": "set voice to %1",
  	"text2speech.setLanguageBlock": "set language to %1",
  	"translate.translateBlock": "%1 ifadəsini %2 dilinə tərcümə et",
  	"translate.viewerLanguage": "dil",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "when %1 button pressed",
  	"microbit.isButtonPressed": "%1 button pressed?",
  	"microbit.whenGesture": "when %1",
  	"microbit.displaySymbol": "display %1",
  	"microbit.displayText": "display text %1",
  	"microbit.clearDisplay": "clear display",
  	"microbit.whenTilted": "when tilted %1",
  	"microbit.isTilted": "tilted %1?",
  	"microbit.tiltAngle": "tilt angle %1",
  	"microbit.whenPinConnected": "when pin %1 connected",
  	"ev3.motorTurnClockwise": "motor %1 turn this way for %2 seconds",
  	"ev3.motorTurnCounterClockwise": "motor %1 turn that way for %2 seconds",
  	"ev3.motorSetPower": "motor %1 set power %2 %",
  	"ev3.getMotorPosition": "%1 mühərrikinin mövqeyi",
  	"ev3.whenButtonPressed": "when button %1 pressed",
  	"ev3.whenDistanceLessThan": "when distance < %1",
  	"ev3.whenBrightnessLessThan": "when brightness < %1",
  	"ev3.buttonPressed": "%1 düyməsi basılıb?",
  	"ev3.getDistance": "məsafə",
  	"ev3.getBrightness": "parlaqlıq",
  	"ev3.beepNote": "%1 notunu %2 saniyə səsləndir",
  	"wedo2.motorOn": "turn %1 on",
  	"wedo2.motorOff": "turn %1 off",
  	"wedo2.startMotorPower": "set %1 power to %2",
  	"wedo2.setMotorDirection": "set %1 direction to %2",
  	"wedo2.whenDistance": "when distance %1 %2",
  	"wedo2.getDistance": "distance",
  	"wedo2.motorOnFor": "turn %1 on for %2 seconds",
  	"wedo2.setLightHue": "set light color to %1",
  	"wedo2.playNoteFor": "play note %1 for %2 seconds",
  	"wedo2.whenTilted": "when tilted %1",
  	"wedo2.isTilted": "tilted %1?",
  	"wedo2.getTiltAngle": "tilt angle %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$17 = {
  };
  var ignorelt$17 = [
  ];
  var soundEffects$17 = [
  	"kökləmək",
  	"tas sol/sağ"
  ];
  var microbitWhen$17 = [
  	"moved",
  	"shaken",
  	"jumped"
  ];
  var osis$17 = [
  	"spraytın digər skriptləri"
  ];
  var definePrefix$17 = [
  ];
  var defineSuffix$17 = [
  	"təyin",
  	"et"
  ];
  var palette$17 = {
  	Motion: "Hərəkət",
  	Looks: "Görünüş",
  	Sound: "Səs",
  	Events: "Hadisələr",
  	Control: "İdarəetmə",
  	Sensing: "Sensorlar",
  	Operators: "Operatorlar",
  	Variables: "Dəyişənlər",
  	"My Blocks": "Mənim Bloklarım"
  };
  var math$17 = [
  	"modul",
  	"aşağı yuvarlaqlaşdır",
  	"yuxarı yuvarlaqlaşdır",
  	"kvadrat kök",
  	"sin",
  	"cos",
  	"tg",
  	"arcsin",
  	"arccos",
  	"arctg",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$17 = {
  };
  var name$17 = "Azeri";
  var percentTranslated$17 = 100;
  var az = {
  	commands: commands$17,
  	dropdowns: dropdowns$17,
  	ignorelt: ignorelt$17,
  	soundEffects: soundEffects$17,
  	microbitWhen: microbitWhen$17,
  	osis: osis$17,
  	definePrefix: definePrefix$17,
  	defineSuffix: defineSuffix$17,
  	palette: palette$17,
  	math: math$17,
  	aliases: aliases$17,
  	name: name$17,
  	percentTranslated: percentTranslated$17
  };

  var commands$16 = {
  	MOTION_MOVESTEPS: "рухацца %1 крокаў",
  	MOTION_TURNRIGHT: "павярнуць @turnRight %1 градусаў",
  	MOTION_TURNLEFT: "павярнуць @turnLeft %1 градусаў",
  	MOTION_POINTINDIRECTION: "павярнуць у кірунку %1",
  	MOTION_POINTTOWARDS: "павярнуцца да %1",
  	MOTION_GOTOXY: "перайсці ў x: %1 y: %2",
  	MOTION_GOTO: "перайсці ў %1",
  	MOTION_GLIDESECSTOXY: "плысці %1 секунд да x: %2 y: %3",
  	MOTION_GLIDETO: "плысці %1 секунд да %2",
  	MOTION_CHANGEXBY: "змяніць X на %1",
  	MOTION_SETX: "устанавіць X у %1",
  	MOTION_CHANGEYBY: "змяніць Y на %1",
  	MOTION_SETY: "устанавіць Y у %1",
  	MOTION_SETROTATIONSTYLE: "стыль вярчэння %1",
  	LOOKS_SAYFORSECS: "казаць %1 на працягу %2 секунд",
  	LOOKS_SAY: "сказаць %1",
  	LOOKS_THINKFORSECS: "думаць %1 %2 секунд",
  	LOOKS_THINK: "думаць %1",
  	LOOKS_SHOW: "паказацца",
  	LOOKS_HIDE: "схавацца",
  	LOOKS_SWITCHCOSTUMETO: "змяніць касцюм на %1",
  	LOOKS_NEXTCOSTUME: "наступны касцюм",
  	LOOKS_NEXTBACKDROP_BLOCK: "наступны фон",
  	LOOKS_SWITCHBACKDROPTO: "змяніць фон на %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "змяніць фон на %1 і чакаць",
  	LOOKS_CHANGEEFFECTBY: "змяніць %1 эфект на %2",
  	LOOKS_SETEFFECTTO: "устанавіць эфект %1 у значэнне %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "прыбраць графічныя эфекты",
  	LOOKS_CHANGESIZEBY: "змяніць памер на  %1",
  	LOOKS_SETSIZETO: "устанавіць памер %1 %",
  	LOOKS_GOTOFRONTBACK: "перайсці ў %1 слой",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "перайсці %1 на %2 слоя",
  	SOUND_PLAY: "уключыць гук %1",
  	SOUND_CHANGEEFFECTBY: "змяніць %1 эфект на %2",
  	SOUND_SETEFFECTO: "устанавіць эфект %1 у значэнне %2",
  	SOUND_CLEAREFFECTS: "прыбраць гукавыя эфекты",
  	SOUND_PLAYUNTILDONE: "іграць гук %1 да канца",
  	SOUND_STOPALLSOUNDS: "спыніць усе гукі",
  	"music.playDrumForBeats": "барабану %1іграць %2 тактаў",
  	"music.restForBeats": "пачакаць %1 тактаў",
  	"music.playNoteForBeats": "іграць ноту %1 %2 тактаў",
  	"music.setInstrument": "выбраць інструмент %1",
  	SOUND_CHANGEVOLUMEBY: "змяніць гучнасць на %1",
  	SOUND_SETVOLUMETO: "устанавіць гучнасць %1%",
  	"music.changeTempo": "змяніць тэмп на %1",
  	"music.setTempo": "устанавіць тэмп %1",
  	"pen.clear": "сцерці ўсё",
  	"pen.stamp": "штамп",
  	"pen.penDown": "апусціць аловак",
  	"pen.penUp": "падняць аловак",
  	"pen.setColor": "устанавіць колер алоўка %1",
  	"pen.changeHue": "змяніць колер алоўка на %1",
  	"pen.setColorParam": "устанавіць %1 алоўка %2",
  	"pen.changeColorParam": "змяніць %1 алоўка на %2",
  	"pen.setHue": "устанавіць колер алоўка %1",
  	"pen.changeShade": "змяніць цень алоўка на %1",
  	"pen.setShade": "устанавіць цень алоўка %1",
  	"pen.changeSize": "змяніць памер алоўка на %1",
  	"pen.setSize": "устанавіць памер алоўка %1",
  	EVENT_WHENFLAGCLICKED: "калі @greenFlag націснуты",
  	EVENT_WHENKEYPRESSED: "калі клавіша %1 націснутая",
  	EVENT_WHENTHISSPRITECLICKED: "калі спрайт націснуты",
  	EVENT_WHENSTAGECLICKED: "калі клікнуць па сцэне",
  	EVENT_WHENBACKDROPSWITCHESTO: "калі фон змяняецца на %1",
  	EVENT_WHENGREATERTHAN: "калі %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "калі я атрымаю %1",
  	EVENT_BROADCAST: "разаслаць %1",
  	EVENT_BROADCASTANDWAIT: "разаслаць %1 і чакаць",
  	CONTROL_WAIT: "чакаць %1 секунд",
  	CONTROL_REPEAT: "паўтарыць %1",
  	CONTROL_FOREVER: "заўжды",
  	CONTROL_IF: "калі %1 , то",
  	CONTROL_WAITUNTIL: "чакаць да %1",
  	CONTROL_REPEATUNTIL: "паўтараць, пакуль не %1",
  	CONTROL_STOP: "стоп %1",
  	CONTROL_STARTASCLONE: "калі я пачынаю як клон",
  	CONTROL_CREATECLONEOF: "стварыць клона %1",
  	CONTROL_DELETETHISCLONE: "выдаліць гэтага клона",
  	SENSING_ASKANDWAIT: "спытаць %1 і чакаць",
  	"videoSensing.videoToggle": "запіс відэа %1",
  	"videoSensing.setVideoTransparency": "устанавіць празрыстасць відэа %1",
  	"videoSensing.whenMotionGreaterThan": "калі рухаў відэа > %1",
  	SENSING_RESETTIMER: "перазапусціць таймер",
  	DATA_SETVARIABLETO: "устанавіць %1 у %2",
  	DATA_CHANGEVARIABLEBY: "змяніць %1 на %2",
  	DATA_SHOWVARIABLE: "паказаць зменную %1",
  	DATA_HIDEVARIABLE: "схаваць зменную %1",
  	DATA_ADDTOLIST: "дадаць %1 да %2",
  	DATA_DELETEOFLIST: "выдаліць %1 з %2",
  	DATA_DELETEALLOFLIST: "выдаліць усё з %1",
  	MOTION_IFONEDGEBOUNCE: "калі скраю, адштурхнуцца",
  	DATA_INSERTATLIST: "уставіць %1 у %2 з %3",
  	DATA_REPLACEITEMOFLIST: "замяніць элемент %1 у %2 на %3",
  	DATA_SHOWLIST: "паказаць спіс %1",
  	DATA_HIDELIST: "схаваць спіс %1",
  	SENSING_OF_XPOSITION: "пазіцыя X",
  	SENSING_OF_YPOSITION: "пазіцыя Y",
  	SENSING_OF_DIRECTION: "кірунак",
  	SENSING_OF_COSTUMENUMBER: "касцюм #",
  	LOOKS_COSTUMENUMBERNAME: "касцюм %1",
  	SENSING_OF_SIZE: "памер",
  	SENSING_OF_BACKDROPNAME: "імя фону",
  	LOOKS_BACKDROPNUMBERNAME: "фон %1",
  	SENSING_OF_BACKDROPNUMBER: "фон #",
  	SOUND_VOLUME: "гучнасць",
  	"music.getTempo": "тэмп",
  	SENSING_TOUCHINGOBJECT: "кранаецца %1?",
  	SENSING_TOUCHINGCOLOR: "дакранаецца да колеру %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "колер %1 кранаецца %2?",
  	SENSING_DISTANCETO: "адлегласць да %1",
  	SENSING_ANSWER: "адказ",
  	SENSING_KEYPRESSED: "клавіша %1 націснутая?",
  	SENSING_MOUSEDOWN: "мышка націснутая?",
  	SENSING_MOUSEX: "мышка па X",
  	SENSING_MOUSEY: "мышка па Y",
  	SENSING_SETDRAGMODE: "перацягваць %1",
  	SENSING_LOUDNESS: "гучнасць",
  	"videoSensing.videoOn": "відэа %1 на %2",
  	SENSING_TIMER: "таймер",
  	SENSING_OF: "%1 з %2",
  	SENSING_CURRENT: "бягучы %1",
  	SENSING_DAYSSINCE2000: "дзён ад 2000",
  	SENSING_USERNAME: "імя карыстальніка",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "выдаць выпадковы лік ад %1 да %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 і %2",
  	OPERATORS_OR: "%1 ці %2",
  	OPERATORS_NOT: "не %1",
  	OPERATORS_JOIN: "аб'яднаць %1 %2",
  	OPERATORS_LETTEROF: "літара %1 у %2",
  	OPERATORS_LENGTH: "даўжыня %1",
  	OPERATORS_MOD: "астача ад дзялення %1 на %2",
  	OPERATORS_ROUND: "акругліць %1",
  	OPERATORS_MATHOP: "%1 з %2",
  	OPERATORS_CONTAINS: "%1 змяшчае %2?",
  	DATA_ITEMOFLIST: "элемент %1 з %2",
  	DATA_ITEMNUMOFLIST: "элемент # з %1 у %2",
  	DATA_LENGTHOFLIST: "даўжыня %1",
  	DATA_LISTCONTAINSITEM: "%1 змяшчае %2?",
  	CONTROL_ELSE: "інакш",
  	SENSING_USERID: "id ўдзельніка",
  	SENSING_LOUD: "гучна?",
  	"text2speech.speakAndWaitBlock": "сказаць %1",
  	"text2speech.setVoiceBlock": "устанавіць голас %1",
  	"text2speech.setLanguageBlock": "устанавіць мову %1",
  	"translate.translateBlock": "перакласці %1 на %2",
  	"translate.viewerLanguage": "мова",
  	"makeymakey.whenKeyPressed": "калі клавіша %1 націснутая",
  	"makeymakey.whenKeysPressedInOrder": "калі націснутыя %1 па парадку",
  	"microbit.whenButtonPressed": "калі %1 кнопка націснутая",
  	"microbit.isButtonPressed": "%1кнопка націснутая?",
  	"microbit.whenGesture": "калі %1",
  	"microbit.displaySymbol": "паказаць %1",
  	"microbit.displayText": "паказаць тэкст %1",
  	"microbit.clearDisplay": "ачысціць дісплэй",
  	"microbit.whenTilted": "калі нахілены %1",
  	"microbit.isTilted": "нахілены %1?",
  	"microbit.tiltAngle": "вугал нахілу %1",
  	"microbit.whenPinConnected": "калі падлучаны pin %1",
  	"ev3.motorTurnClockwise": "рухавік %1павярнуць па гадзіннікавай стрэлцы на %2 секундаў",
  	"ev3.motorTurnCounterClockwise": "рухавік %1 павярнуць супраць гадзіннікавай стрэлкі на %2 секундаў",
  	"ev3.motorSetPower": "рухавіку %1 устанавіць магутнасць %2 %",
  	"ev3.getMotorPosition": "пазіцыя рухавіка %1",
  	"ev3.whenButtonPressed": "калі кнопка %1 націснутая",
  	"ev3.whenDistanceLessThan": "калі адлегласць < %1",
  	"ev3.whenBrightnessLessThan": "калі яркасць < %1",
  	"ev3.buttonPressed": "кнопка %1 націснутая?",
  	"ev3.getDistance": "адлегласць",
  	"ev3.getBrightness": "яркасць",
  	"ev3.beepNote": "іграць ноту %1на працягу %2 секунд",
  	"wedo2.motorOn": "уключыць %1",
  	"wedo2.motorOff": "выключыць %1",
  	"wedo2.startMotorPower": "устанавіць магутнасць рухавіку %1 як %2",
  	"wedo2.setMotorDirection": "устанавіць напрамак %1 як %2",
  	"wedo2.whenDistance": "калі адлегласць %1 %2",
  	"wedo2.getDistance": "адлегласць",
  	"wedo2.motorOnFor": "уключыць %1 на %2 секунд",
  	"wedo2.setLightHue": "устанавіць колер святла %1",
  	"wedo2.playNoteFor": "іграць ноту %1 на працягу %2 секунд",
  	"wedo2.whenTilted": "калі нахілены %1",
  	"wedo2.isTilted": "нахілены %1?",
  	"wedo2.getTiltAngle": "вугал нахілу %1",
  	"gdxfor.whenGesture": "калі %1",
  	"gdxfor.whenForcePushedOrPulled": "калі сэнсар сілы %1",
  	"gdxfor.getForce": "сіла",
  	"gdxfor.whenTilted": "калі нахілены %1",
  	"gdxfor.isTilted": "нахілены %1?",
  	"gdxfor.getTilt": "вугал нахілу %1",
  	"gdxfor.isFreeFalling": "падае?",
  	"gdxfor.getSpin": "хуткасць кручэння%1",
  	"gdxfor.getAcceleration": "паскарэнне %1",
  	"boost.motorOnFor": "уключыць рухавік %1 на %2 секунд",
  	"boost.motorOnForRotation": "уключыць рухавік %1 на %2 абаротаў",
  	"boost.motorOn": "уключыць рухавік %1",
  	"boost.motorOff": "выключыць рухавік %1",
  	"boost.setMotorPower": "устанавіць рухавіку %1 хуткасць %2 %",
  	"boost.setMotorDirection": "устанавіць напрамак %2 для рухавіка %1",
  	"boost.getMotorPosition": "пазіцыя рухавіка %1",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "калі нахілены %1",
  	"boost.getTiltAngle": "вугал нахілу %1",
  	"boost.setLightHue": "устанавіць колер святла %1"
  };
  var dropdowns$16 = {
  };
  var ignorelt$16 = [
  ];
  var soundEffects$16 = [
  	"вышыня гуку",
  	"рух налева/направа"
  ];
  var microbitWhen$16 = [
  	"зрушыць",
  	"патрэсці",
  	"падкінуць"
  ];
  var osis$16 = [
  	"іншыя скрыпты спрайта"
  ];
  var definePrefix$16 = [
  	"вызначыць"
  ];
  var defineSuffix$16 = [
  ];
  var palette$16 = {
  	Motion: "Рух",
  	Looks: "Выгляд",
  	Sound: "Гук",
  	Events: "Падзеі",
  	Control: "Кіраванне",
  	Sensing: "Сэнсары",
  	Operators: "Аператары",
  	Variables: "Зменныя",
  	"My Blocks": "Уласныя блокі"
  };
  var math$16 = [
  	"модуль",
  	"меншае цэлае",
  	"ліміт",
  	"квадратны корань",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$16 = {
  };
  var name$16 = "Беларуская";
  var percentTranslated$16 = 100;
  var be = {
  	commands: commands$16,
  	dropdowns: dropdowns$16,
  	ignorelt: ignorelt$16,
  	soundEffects: soundEffects$16,
  	microbitWhen: microbitWhen$16,
  	osis: osis$16,
  	definePrefix: definePrefix$16,
  	defineSuffix: defineSuffix$16,
  	palette: palette$16,
  	math: math$16,
  	aliases: aliases$16,
  	name: name$16,
  	percentTranslated: percentTranslated$16
  };

  var commands$15 = {
  	MOTION_MOVESTEPS: "премести се с %1 стъпки",
  	MOTION_TURNRIGHT: "завърти се с @turnRight %1 градуса",
  	MOTION_TURNLEFT: "завърти се с @turnLeft %1 градуса",
  	MOTION_POINTINDIRECTION: "обърни се в посока %1",
  	MOTION_POINTTOWARDS: "обърни се към %1",
  	MOTION_GOTOXY: "отиди до x: %1 y: %2",
  	MOTION_GOTO: "отиди до %1",
  	MOTION_GLIDESECSTOXY: "пропълзи за %1 сек до x: %2 y: %3",
  	MOTION_GLIDETO: "пропълзи за %1 сек до %2",
  	MOTION_CHANGEXBY: "промени х с %1",
  	MOTION_SETX: "направи x равно на %1",
  	MOTION_CHANGEYBY: "промени y с %1",
  	MOTION_SETY: "направи y равно на %1",
  	MOTION_SETROTATIONSTYLE: "избери начин на въртене %1",
  	LOOKS_SAYFORSECS: "кажи %1 за %2 сек",
  	LOOKS_SAY: "кажи %1",
  	LOOKS_THINKFORSECS: "мисли %1 за %2 сек",
  	LOOKS_THINK: "мисли %1",
  	LOOKS_SHOW: "покажи се",
  	LOOKS_HIDE: "скрий се",
  	LOOKS_SWITCHCOSTUMETO: "промени костюм на %1",
  	LOOKS_NEXTCOSTUME: "следващ костюм",
  	LOOKS_NEXTBACKDROP_BLOCK: "следващ декор",
  	LOOKS_SWITCHBACKDROPTO: "смени декора с %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "смени декора с %1 и чакай",
  	LOOKS_CHANGEEFFECTBY: "промени ефект %1  с %2",
  	LOOKS_SETEFFECTTO: "направи %1 ефект на %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "премахни графичните ефекти",
  	LOOKS_CHANGESIZEBY: "промени размера с %1",
  	LOOKS_SETSIZETO: "направи размера %1 %",
  	LOOKS_GOTOFRONTBACK: "отиди до слой %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "премини %1 с %2 слой/я",
  	SOUND_PLAY: "пусни звук %1",
  	SOUND_CHANGEEFFECTBY: "промени ефект %1  с %2",
  	SOUND_SETEFFECTO: "направи %1 ефект на %2",
  	SOUND_CLEAREFFECTS: "премахни звуковите ефекти",
  	SOUND_PLAYUNTILDONE: "пусни звук %1 докато свърши",
  	SOUND_STOPALLSOUNDS: "спри всички звуци",
  	"music.playDrumForBeats": "изсвири барабан %1 за %2 времена",
  	"music.restForBeats": "спри за %1 времена",
  	"music.playNoteForBeats": "изсвири нота %1 за %2 времена",
  	"music.setInstrument": "направи инструмента на %1",
  	SOUND_CHANGEVOLUMEBY: "промени силата на звука с %1",
  	SOUND_SETVOLUMETO: "задай сила на звука %1%",
  	"music.changeTempo": "увеличи темпо с %1",
  	"music.setTempo": "направи темпо на %1",
  	"pen.clear": "изтрий всичко",
  	"pen.stamp": "отпечати",
  	"pen.penDown": "молив долу",
  	"pen.penUp": "молив горе",
  	"pen.setColor": "направи цвета на молива %1",
  	"pen.changeHue": "промени цвета на молива с %1",
  	"pen.setColorParam": "направи %1 на молива на %2",
  	"pen.changeColorParam": "промени %1 на молива с/ъс %2",
  	"pen.setHue": "направи цвета на молива %1",
  	"pen.changeShade": "промени плътността на молива с/ъс %1",
  	"pen.setShade": "направи яркостта на молива %1",
  	"pen.changeSize": "промени pen size by %1",
  	"pen.setSize": "направи дебелината на молива %1",
  	EVENT_WHENFLAGCLICKED: "когато @greenFlag е щракнато",
  	EVENT_WHENKEYPRESSED: "когато е натиснат клавиш %1",
  	EVENT_WHENTHISSPRITECLICKED: "когато този спрайт е щракнат",
  	EVENT_WHENSTAGECLICKED: "когато е щракнато върху сцената",
  	EVENT_WHENBACKDROPSWITCHESTO: "когато декорът се смени на %1",
  	EVENT_WHENGREATERTHAN: "когато %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "когато получа %1",
  	EVENT_BROADCAST: "разпространи %1",
  	EVENT_BROADCASTANDWAIT: "разпространи %1 и чакай",
  	CONTROL_WAIT: "изчакай %1 сек",
  	CONTROL_REPEAT: "повтори %1",
  	CONTROL_FOREVER: "винаги",
  	CONTROL_IF: "ако %1 тогава",
  	CONTROL_WAITUNTIL: "чакай докато %1",
  	CONTROL_REPEATUNTIL: "повтаряй докато %1",
  	CONTROL_STOP: "спри %1",
  	CONTROL_STARTASCLONE: "при старт като клонинг",
  	CONTROL_CREATECLONEOF: "създай клонинг на %1",
  	CONTROL_DELETETHISCLONE: "премахни този клонинг",
  	SENSING_ASKANDWAIT: "питай %1 и чакай",
  	"videoSensing.videoToggle": "%1 видео",
  	"videoSensing.setVideoTransparency": "направи плътност на видеото на %1",
  	"videoSensing.whenMotionGreaterThan": "когато видео движение > %1",
  	SENSING_RESETTIMER: "нулирай таймера",
  	DATA_SETVARIABLETO: "направи %1 на %2",
  	DATA_CHANGEVARIABLEBY: "промени %1 с %2",
  	DATA_SHOWVARIABLE: "покажи променлива %1",
  	DATA_HIDEVARIABLE: "скрий променлива %1",
  	DATA_ADDTOLIST: "добави %1 към %2",
  	DATA_DELETEOFLIST: "изтрий %1 от %2",
  	DATA_DELETEALLOFLIST: "изтрий всичко от %1",
  	MOTION_IFONEDGEBOUNCE: "ако докосваш ръба, отблъсни се",
  	DATA_INSERTATLIST: "вмъкни %1 на %2 като %3",
  	DATA_REPLACEITEMOFLIST: "замени елемент %1 от %2 с %3",
  	DATA_SHOWLIST: "покажи списък %1",
  	DATA_HIDELIST: "скрий списък %1",
  	SENSING_OF_XPOSITION: "x позиция",
  	SENSING_OF_YPOSITION: "y позиция",
  	SENSING_OF_DIRECTION: "посока",
  	SENSING_OF_COSTUMENUMBER: "костюм #",
  	LOOKS_COSTUMENUMBERNAME: "костюм %1",
  	SENSING_OF_SIZE: "размер",
  	SENSING_OF_BACKDROPNAME: "име на декор",
  	LOOKS_BACKDROPNUMBERNAME: "декор %1",
  	SENSING_OF_BACKDROPNUMBER: "декор #",
  	SOUND_VOLUME: "сила на звука",
  	"music.getTempo": "темпо",
  	SENSING_TOUCHINGOBJECT: "допира ли %1?",
  	SENSING_TOUCHINGCOLOR: "допира ли цвят %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "цвят %1 допира ли %2?",
  	SENSING_DISTANCETO: "разстояние до %1",
  	SENSING_ANSWER: "отговор",
  	SENSING_KEYPRESSED: "клавиш %1 натиснат?",
  	SENSING_MOUSEDOWN: "мишка натисната?",
  	SENSING_MOUSEX: "мишка x",
  	SENSING_MOUSEY: "мишка y",
  	SENSING_SETDRAGMODE: "режим на теглене %1",
  	SENSING_LOUDNESS: "сила на звука",
  	"videoSensing.videoOn": "видео %1 на %2",
  	SENSING_TIMER: "таймер",
  	SENSING_OF: "%1 от %2",
  	SENSING_CURRENT: "текущ/а %1",
  	SENSING_DAYSSINCE2000: "дни след 2000 година",
  	SENSING_USERNAME: "потребителско име",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "избери случайно от %1 до %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 и %2",
  	OPERATORS_OR: "%1 или %2",
  	OPERATORS_NOT: "не %1",
  	OPERATORS_JOIN: "съедини %1 %2",
  	OPERATORS_LETTEROF: "буква %1 от %2",
  	OPERATORS_LENGTH: "дължина на %1",
  	OPERATORS_MOD: "остатък от %1 / %2",
  	OPERATORS_ROUND: "закръгли %1",
  	OPERATORS_MATHOP: "%1 от %2",
  	OPERATORS_CONTAINS: "%1 съдържа %2?",
  	DATA_ITEMOFLIST: "елемент %1 от %2",
  	DATA_ITEMNUMOFLIST: "номер на елемента %1 в %2",
  	DATA_LENGTHOFLIST: "големина на %1",
  	DATA_LISTCONTAINSITEM: "%1 съдържа %2?",
  	CONTROL_ELSE: "иначе",
  	SENSING_USERID: "потребителски идентификатор",
  	SENSING_LOUD: "шумно ли е?",
  	"text2speech.speakAndWaitBlock": "кажи %1",
  	"text2speech.setVoiceBlock": "направи звука на %1",
  	"text2speech.setLanguageBlock": "промени езика на %1",
  	"translate.translateBlock": "преведи %1 на %2",
  	"translate.viewerLanguage": "език",
  	"makeymakey.whenKeyPressed": "когато е натиснат клавиш %1",
  	"makeymakey.whenKeysPressedInOrder": "когато %1 е натисната последователно",
  	"microbit.whenButtonPressed": "когато %1 бутон е натиснат",
  	"microbit.isButtonPressed": "%1 бутон натиснат ли е?",
  	"microbit.whenGesture": "когато %1",
  	"microbit.displaySymbol": "покажи %1",
  	"microbit.displayText": "покажи текст %1",
  	"microbit.clearDisplay": "изчисти екрана",
  	"microbit.whenTilted": "при наклон %1",
  	"microbit.isTilted": "наклонен %1?",
  	"microbit.tiltAngle": "наклон на ъгъла %1",
  	"microbit.whenPinConnected": "когато пин %1 е свързан",
  	"ev3.motorTurnClockwise": "моторът %1 се върти по часовника за %2 секунди",
  	"ev3.motorTurnCounterClockwise": "моторът %1 се върти обратно на часовника за %2 секунди",
  	"ev3.motorSetPower": "мотор %1 направи мощност на %2 %",
  	"ev3.getMotorPosition": "позиция на мотор %1",
  	"ev3.whenButtonPressed": "когато бутон %1 е натиснат",
  	"ev3.whenDistanceLessThan": "когато дистанция < %1",
  	"ev3.whenBrightnessLessThan": "когато яркост < %1",
  	"ev3.buttonPressed": "бутон %1 натиснат ли е?",
  	"ev3.getDistance": "разстояние",
  	"ev3.getBrightness": "яркост",
  	"ev3.beepNote": "изсвири тон %1 за %2 секунди",
  	"wedo2.motorOn": "включи %1",
  	"wedo2.motorOff": "изключи %1",
  	"wedo2.startMotorPower": "направи мощност на %1 на %2",
  	"wedo2.setMotorDirection": "задай на %1 посока %2",
  	"wedo2.whenDistance": "когато дистанция %1 %2",
  	"wedo2.getDistance": "разстояние",
  	"wedo2.motorOnFor": "включи %1 за %2 секунди",
  	"wedo2.setLightHue": "задай цвета на светлината на %1",
  	"wedo2.playNoteFor": "изсвири тон %1 за %2 секунди",
  	"wedo2.whenTilted": "при наклон %1",
  	"wedo2.isTilted": "наклонен %1?",
  	"wedo2.getTiltAngle": "наклон на ъгъла %1",
  	"gdxfor.whenGesture": "когато %1",
  	"gdxfor.whenForcePushedOrPulled": "когато сензор за сила %1",
  	"gdxfor.getForce": "сила",
  	"gdxfor.whenTilted": "при наклон %1",
  	"gdxfor.isTilted": "наклон %1?",
  	"gdxfor.getTilt": "наклон на ъгъла %1",
  	"gdxfor.isFreeFalling": "падане?",
  	"gdxfor.getSpin": "скорост на въртене %1",
  	"gdxfor.getAcceleration": "ускорение %1",
  	"boost.motorOnFor": "включи мотор %1 за %2 секунди",
  	"boost.motorOnForRotation": "включи мотор %1 за %2 оборота",
  	"boost.motorOn": "включи мотор %1",
  	"boost.motorOff": "изключи мотор %1",
  	"boost.setMotorPower": "задай скоростта на мотор %1 на %2 %",
  	"boost.setMotorDirection": "задай на мотор %1 посока %2",
  	"boost.getMotorPosition": "мотор %1 на позиция",
  	"boost.whenColor": "когато се вижда тухла с цвят %1",
  	"boost.seeingColor": "виждам %1 тухла?",
  	"boost.whenTilted": "при наклон %1",
  	"boost.getTiltAngle": "наклон на ъгъла %1",
  	"boost.setLightHue": "направи светлината на цвета на %1"
  };
  var dropdowns$15 = {
  };
  var ignorelt$15 = [
  ];
  var soundEffects$15 = [
  	"промяна на тона",
  	"ляво/дясно"
  ];
  var microbitWhen$15 = [
  	"преместен",
  	"разтърсен",
  	"подхвърлен"
  ];
  var osis$15 = [
  	"другите скриптове на спрайта"
  ];
  var definePrefix$15 = [
  	"дефинирай"
  ];
  var defineSuffix$15 = [
  ];
  var palette$15 = {
  	Motion: "Движение",
  	Looks: "Външност",
  	Sound: "Звук",
  	Events: "Събития",
  	Control: "Контрол",
  	Sensing: "Сетива",
  	Operators: "Оператори",
  	Variables: "Променливи",
  	"My Blocks": "Моите Блокове"
  };
  var math$15 = [
  	"абсолютна стойност",
  	"закръглено надолу",
  	"закръглено нагоре",
  	"квадратен корен",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e^",
  	"10 ^"
  ];
  var aliases$15 = {
  };
  var name$15 = "Български";
  var percentTranslated$15 = 100;
  var bg = {
  	commands: commands$15,
  	dropdowns: dropdowns$15,
  	ignorelt: ignorelt$15,
  	soundEffects: soundEffects$15,
  	microbitWhen: microbitWhen$15,
  	osis: osis$15,
  	definePrefix: definePrefix$15,
  	defineSuffix: defineSuffix$15,
  	palette: palette$15,
  	math: math$15,
  	aliases: aliases$15,
  	name: name$15,
  	percentTranslated: percentTranslated$15
  };

  var commands$14 = {
  	MOTION_MOVESTEPS: "%1 ধাপ পরিবর্তন কর",
  	MOTION_TURNRIGHT: "@turnRight %1 ডিগ্রী ঘুর",
  	MOTION_TURNLEFT: "@turnLeft %1 ডিগ্রী ঘুর",
  	MOTION_POINTINDIRECTION: "দিক %1 নির্দেশ কর",
  	MOTION_POINTTOWARDS: "%1 এর দিকে নির্দেশ কর",
  	MOTION_GOTOXY: "x: %1 y: %2 এ যাও",
  	MOTION_GOTO: "%1 যাও",
  	MOTION_GLIDESECSTOXY: "গ্লাইড কর %1 সেকেন্ড x: %2 y: %3 পর্যন্ত",
  	MOTION_GLIDETO: "গ্লাইড কর %1 সেকেন্ড %2 পর্যন্ত",
  	MOTION_CHANGEXBY: "x কে %1 করে পরিবর্তন কর",
  	MOTION_SETX: "x এর মান %1 নির্ধারণ কর",
  	MOTION_CHANGEYBY: "y কে %1 করে পরিবর্তন কর",
  	MOTION_SETY: "y এর মান %1 নির্ধারণ কর",
  	MOTION_SETROTATIONSTYLE: "ঘূর্ণনের ধরন %1",
  	LOOKS_SAYFORSECS: "%2 সেকেন্ডের জন্য %1 বল",
  	LOOKS_SAY: "বল %1",
  	LOOKS_THINKFORSECS: "%2 সেকেন্ডের জন্য %1 চিন্তা কর",
  	LOOKS_THINK: "%1 চিন্তা কর",
  	LOOKS_SHOW: "দেখাও",
  	LOOKS_HIDE: "লুকাও",
  	LOOKS_SWITCHCOSTUMETO: "পোশাক %1 এ পরিবর্তন কর",
  	LOOKS_NEXTCOSTUME: "পরবর্তী পোশাক",
  	LOOKS_NEXTBACKDROP_BLOCK: "পরবর্তী ব্যাকড্রপ",
  	LOOKS_SWITCHBACKDROPTO: "ব্যাকড্রপ %1 এ পরিবর্তন কর",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "ব্যাকড্রপ %1 এ পরিবর্তন করে অপেক্ষা কর",
  	LOOKS_CHANGEEFFECTBY: "%1 এর ইফেক্ট %2 পরিবর্তন কর",
  	LOOKS_SETEFFECTTO: "%1 এর ইফেক্ট %2 নির্ধারণ কর",
  	LOOKS_CLEARGRAPHICEFFECTS: "গ্রাফিক ইফেক্ট মুছে ফেল",
  	LOOKS_CHANGESIZEBY: "%1 করে আকার পরিবর্তন কর",
  	LOOKS_SETSIZETO: "%1 % আকার নির্ধারণ কর",
  	LOOKS_GOTOFRONTBACK: "%1 স্তরে যাও",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 স্তরে যাও",
  	SOUND_PLAY: "শুরু কর %1 শব্দ",
  	SOUND_CHANGEEFFECTBY: "%1 এর ইফেক্ট %2 পরিবর্তন কর",
  	SOUND_SETEFFECTO: "%1 এর ইফেক্ট %2 নির্ধারণ কর",
  	SOUND_CLEAREFFECTS: "শব্দ ইফেক্ট মুছে ফেল",
  	SOUND_PLAYUNTILDONE: "শেষ না হওয়া পর্যন্ত %1 শব্দ বাজাও",
  	SOUND_STOPALLSOUNDS: "সব শব্দ বন্ধ কর",
  	"music.playDrumForBeats": "%2 বিটে %1 ড্রাম বাজাও",
  	"music.restForBeats": "%1 বিটের জন্য অপেক্ষা",
  	"music.playNoteForBeats": "%2 বিটের  জন্য %1 নোট চালু কর",
  	"music.setInstrument": "%1 বাদ্যযন্ত্রটি নির্ধারণ কর",
  	SOUND_CHANGEVOLUMEBY: "শব্দের মাত্রা %1 পরিবর্তন কর",
  	SOUND_SETVOLUMETO: "শব্দের মাত্রা %1% নির্ধারণ কর",
  	"music.changeTempo": "%1 ব্যবহার করে টেম্পো পরিবর্তন কর",
  	"music.setTempo": "টেম্পো %1 নির্ধারণ কর",
  	"pen.clear": "সব মুছে ফেল",
  	"pen.stamp": "স্ট্যাম্প",
  	"pen.penDown": "কলম নিচে নামাও",
  	"pen.penUp": "কলম উপরে উঠাও",
  	"pen.setColor": "কলমের রঙ %1 নির্ধারণ কর",
  	"pen.changeHue": "কলমের রঙ %1 দ্বারা পরিবর্তন",
  	"pen.setColorParam": "কলমের %1 %2 এ নির্ধারণ কর",
  	"pen.changeColorParam": "কলমের %1 %2 দ্বারা পরিবর্তন কর",
  	"pen.setHue": "কলমের রঙ %1 এ নির্ধারণ কর",
  	"pen.changeShade": "কলমের ছায়া %1 দ্বারা পরিবর্তন কর",
  	"pen.setShade": "কলমের ছায়া %1 নির্ধারণ কর",
  	"pen.changeSize": "কলমের আকার %1 তে পরিবর্তন কর",
  	"pen.setSize": "কলমের আকার %1 নির্ধারণ কর",
  	EVENT_WHENFLAGCLICKED: "যখন @greenFlag ক্লিক করা হয়",
  	EVENT_WHENKEYPRESSED: "যখন %1 কী চাপা হয়",
  	EVENT_WHENTHISSPRITECLICKED: "যখন স্প্রাইটে ক্লিক করা হবে",
  	EVENT_WHENSTAGECLICKED: "যখন মঞ্চে ক্লিক করব",
  	EVENT_WHENBACKDROPSWITCHESTO: "যখন ব্যাকড্রপ %1 এ পরিবর্তন হয়",
  	EVENT_WHENGREATERTHAN: "যখন %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "যখন আমি %1 পাই",
  	EVENT_BROADCAST: "সম্প্রচার কর %1",
  	EVENT_BROADCASTANDWAIT: "%1 সম্প্রচার করে অপেক্ষা কর",
  	CONTROL_WAIT: "%1 সেকেন্ড অপেক্ষা কর",
  	CONTROL_REPEAT: "পুনরাবৃত্তি %1 বার",
  	CONTROL_FOREVER: "চিরকালের জন্য",
  	CONTROL_IF: "যদি %1 তাহলে",
  	CONTROL_WAITUNTIL: "%1 পর্যন্ত অপেক্ষা কর",
  	CONTROL_REPEATUNTIL: "%1 পর্যন্ত পুনরাবৃত্তি কর",
  	CONTROL_STOP: "থামাও %1",
  	CONTROL_STARTASCLONE: "যখন আমি একটি ক্লোন হয়ে শুরু করি",
  	CONTROL_CREATECLONEOF: "%1 এর ক্লোন তৈরি কর",
  	CONTROL_DELETETHISCLONE: "ক্লোনটি অপসারণ কর",
  	SENSING_ASKANDWAIT: "প্রশ্ন কর %1 এবং অপেক্ষা কর",
  	"videoSensing.videoToggle": "ভিডিও %1 ঘুরাও",
  	"videoSensing.setVideoTransparency": "ভিডিওর স্বচ্ছতা %1 নির্ধারণ কর",
  	"videoSensing.whenMotionGreaterThan": "যখন ভিডিওর গতি > %1",
  	SENSING_RESETTIMER: "সময় রিসেট কর",
  	DATA_SETVARIABLETO: "%1 %2 নির্ধারণ কর",
  	DATA_CHANGEVARIABLEBY: "%1 %2 করে পরিবর্তন কর",
  	DATA_SHOWVARIABLE: "ভ্যারিয়েবল %1 দেখাও",
  	DATA_HIDEVARIABLE: "ভ্যারিয়েবল %1 লুকাও",
  	DATA_ADDTOLIST: "%2 এর সাথে %1 যোগ কর",
  	DATA_DELETEOFLIST: "%2 এর %1 অপসারণ কর",
  	DATA_DELETEALLOFLIST: "সব %1 অপসারণ কর",
  	MOTION_IFONEDGEBOUNCE: "যদি কিনারে পৌঁছায়, তাহলে লাফাও",
  	DATA_INSERTATLIST: "%3 এর %2 এ %1 ঢুকাও",
  	DATA_REPLACEITEMOFLIST: "%2 এর %1 আইটেমকে %3 দ্বারা প্রতিস্থাপন কর",
  	DATA_SHOWLIST: "%1 তালিকা প্রদর্শন কর",
  	DATA_HIDELIST: "%1 তালিকা লুকাও",
  	SENSING_OF_XPOSITION: "x এর অবস্থান",
  	SENSING_OF_YPOSITION: "y এর অবস্থান",
  	SENSING_OF_DIRECTION: "দিক",
  	SENSING_OF_COSTUMENUMBER: "পোশাক #",
  	LOOKS_COSTUMENUMBERNAME: "পোশাক %1",
  	SENSING_OF_SIZE: "আকার",
  	SENSING_OF_BACKDROPNAME: "ব্যাকড্রপের নাম",
  	LOOKS_BACKDROPNUMBERNAME: "ব্যাকড্রপ %1",
  	SENSING_OF_BACKDROPNUMBER: "ব্যাকড্রপ #",
  	SOUND_VOLUME: "শব্দের মাত্রা",
  	"music.getTempo": "তাল",
  	SENSING_TOUCHINGOBJECT: "%1 স্পর্শ করছে?",
  	SENSING_TOUCHINGCOLOR: "%1 রঙ স্পর্শ করছে?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 রঙ %2 কে স্পর্শ করছে?",
  	SENSING_DISTANCETO: "দূরত্ব %1 পর্যন্ত",
  	SENSING_ANSWER: "উত্তর",
  	SENSING_KEYPRESSED: "%1 কী চাপা হয়েছে?",
  	SENSING_MOUSEDOWN: "mouse down?",
  	SENSING_MOUSEX: "মাউস x",
  	SENSING_MOUSEY: "মাউস y",
  	SENSING_SETDRAGMODE: "ড্র্যাগ মোড %1",
  	SENSING_LOUDNESS: "শব্দের মাত্রা",
  	"videoSensing.videoOn": "%2 এর উপর ভিডিও %1",
  	SENSING_TIMER: "সময়",
  	SENSING_OF: "%2 এর %1",
  	SENSING_CURRENT: "বর্তমান %1",
  	SENSING_DAYSSINCE2000: "2000 সালের পরের দিনগুলো",
  	SENSING_USERNAME: "ইউজারনেম",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 থেকে %2 এর মধ্যে যেকোনটি বাছাই কর",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 এবং %2",
  	OPERATORS_OR: "%1 অথবা %2",
  	OPERATORS_NOT: "%1 না",
  	OPERATORS_JOIN: "%1 এর সাথে %2 যুক্ত কর",
  	OPERATORS_LETTEROF: "%2 এর %1 নম্বর অক্ষর",
  	OPERATORS_LENGTH: "%1 এর দৈর্ঘ্য",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "round %1",
  	OPERATORS_MATHOP: "%2 এর %1",
  	OPERATORS_CONTAINS: "%1 এর মধ্যে কি %2 আছে?",
  	DATA_ITEMOFLIST: "%2 এর মধ্যে %1",
  	DATA_ITEMNUMOFLIST: "%2 এর মধ্যে %1 এর আইটেম #",
  	DATA_LENGTHOFLIST: "%1 শব্দের দৈর্ঘ্য",
  	DATA_LISTCONTAINSITEM: "%1 এর মধ্যে কি %2 আছে?",
  	CONTROL_ELSE: "অন্যথায়",
  	SENSING_USERID: "user id",
  	SENSING_LOUD: "জোরে?",
  	"text2speech.speakAndWaitBlock": "বল %1",
  	"text2speech.setVoiceBlock": "%1 ভয়েস নির্ধারণ কর",
  	"text2speech.setLanguageBlock": "%1 এ ভাষা নির্ধারণ কর",
  	"translate.translateBlock": "%1 %2 ভাষায় অনুবাদ কর",
  	"translate.viewerLanguage": "ভাষা",
  	"makeymakey.whenKeyPressed": "যখন %1 কী চাপা হবে",
  	"makeymakey.whenKeysPressedInOrder": "যখন %1 ক্রমে চাপ দেওয়া হবে",
  	"microbit.whenButtonPressed": "যখন %1 বোতামটি চাপ দেওয়া থাকবে",
  	"microbit.isButtonPressed": "%1 বোতামটি চাপা হয়েছে?",
  	"microbit.whenGesture": "যখন %1",
  	"microbit.displaySymbol": "%1 প্রদর্শন",
  	"microbit.displayText": "%1 টেক্সট প্রদর্শন কর",
  	"microbit.clearDisplay": "পর্দার সব পরিষ্কার কর",
  	"microbit.whenTilted": "when tilted %1",
  	"microbit.isTilted": "tilted %1?",
  	"microbit.tiltAngle": "tilt angle %1",
  	"microbit.whenPinConnected": "যখন %1 পিনটি সংযুক্ত করা হবে",
  	"ev3.motorTurnClockwise": "মোটর %1 %2 সেকেন্ডের জন্য এই পথে ঘুরিয়ে দাও",
  	"ev3.motorTurnCounterClockwise": "মোটর %1 %2 সেকেন্ডের জন্য সে পথে ঘুরিয়ে দাও",
  	"ev3.motorSetPower": "মোটর %1 এ শক্তি নির্ধারণ কর %2 %",
  	"ev3.getMotorPosition": "মোটর %1 এর স্থান",
  	"ev3.whenButtonPressed": "যখন %1 বোতামটি চাপা হবে",
  	"ev3.whenDistanceLessThan": "যখন দূরত্ব < %1",
  	"ev3.whenBrightnessLessThan": "যখন উজ্জ্বলতা < %1",
  	"ev3.buttonPressed": "%1 বোতামটি চাপ দেয়া?",
  	"ev3.getDistance": "দুরত্ব",
  	"ev3.getBrightness": "উজ্জ্বলতা",
  	"ev3.beepNote": "%2 সেকেন্ডের জন্য বীপ নোট %1",
  	"wedo2.motorOn": "%1 চালু কর",
  	"wedo2.motorOff": "%1 বন্ধ কর",
  	"wedo2.startMotorPower": "%1 শক্তি %2 নির্ধারণ কর",
  	"wedo2.setMotorDirection": "%2 এ %1 এর দিক নির্ধারণ কর",
  	"wedo2.whenDistance": "যখন দূরুত্ব %1 %2",
  	"wedo2.getDistance": "দুরত্ব",
  	"wedo2.motorOnFor": "%2 সেকেন্ডের জন্য %1 চালু কর",
  	"wedo2.setLightHue": "লাইটের রঙ %1 নির্ধারণ কর",
  	"wedo2.playNoteFor": "%2 সেকেন্ডের জন্য নোটটি %1 বাজাও",
  	"wedo2.whenTilted": "when tilted %1",
  	"wedo2.isTilted": "tilted %1?",
  	"wedo2.getTiltAngle": "tilt angle %1",
  	"gdxfor.whenGesture": "যখন %1",
  	"gdxfor.whenForcePushedOrPulled": "যখন ফোর্স সেন্সর %1",
  	"gdxfor.getForce": "বল",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "পরে যাচ্ছে?",
  	"gdxfor.getSpin": "ঘুর্নণ গতি %1",
  	"gdxfor.getAcceleration": "%1 গতিবেগ বৃদ্ধি",
  	"boost.motorOnFor": "%1 মটরটি %2 সেকেন্ডের জন্যে ঘোরাও",
  	"boost.motorOnForRotation": "%1 মটরটি %2 বারের জন্যে ঘোরাও",
  	"boost.motorOn": "%1 মোটরটি চালু কর",
  	"boost.motorOff": "%1 মোটরটি বন্ধ কর",
  	"boost.setMotorPower": "মোটর %1 এর গতি %2 % নির্ধারণ কর",
  	"boost.setMotorDirection": "%1 মোটরটি %2 দিকে নির্ধারণ কর",
  	"boost.getMotorPosition": "%1 মোটরের অবস্থান",
  	"boost.whenColor": "%1 ইট দেখা গেলে",
  	"boost.seeingColor": "%1 রঙের ইট দেখা যাচ্ছে?",
  	"boost.whenTilted": "%1 কাত হয়ে গেলে",
  	"boost.getTiltAngle": "টিল্ট কোণ %1",
  	"boost.setLightHue": "লাইটের রঙ %1 কর"
  };
  var dropdowns$14 = {
  };
  var ignorelt$14 = [
  ];
  var soundEffects$14 = [
  	"pitch",
  	"pan left/right"
  ];
  var microbitWhen$14 = [
  	"সরানো হয়েছে",
  	"ঝাঁকাও",
  	"লাফ দিয়েছিল"
  ];
  var osis$14 = [
  	"স্প্রাইটে অন্যান্য স্ক্রিপ্টসমূহ"
  ];
  var definePrefix$14 = [
  	"ডিফাইন"
  ];
  var defineSuffix$14 = [
  ];
  var palette$14 = {
  	Motion: "গতি",
  	Looks: "চেহারা",
  	Sound: "শব্দ",
  	Events: "ঘটনা",
  	Control: "নিয়ন্ত্রণ",
  	Sensing: "অনুভব কর",
  	Operators: "অপারেটর",
  	Variables: "ভ্যারিয়েবল",
  	"My Blocks": "আমার ব্লকগুলো"
  };
  var math$14 = [
  	"abs",
  	"floor",
  	"ceiling",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$14 = {
  };
  var name$14 = "বাংলা";
  var percentTranslated$14 = 100;
  var bn = {
  	commands: commands$14,
  	dropdowns: dropdowns$14,
  	ignorelt: ignorelt$14,
  	soundEffects: soundEffects$14,
  	microbitWhen: microbitWhen$14,
  	osis: osis$14,
  	definePrefix: definePrefix$14,
  	defineSuffix: defineSuffix$14,
  	palette: palette$14,
  	math: math$14,
  	aliases: aliases$14,
  	name: name$14,
  	percentTranslated: percentTranslated$14
  };

  var commands$13 = {
  	MOTION_MOVESTEPS: "mou-te %1 passos",
  	MOTION_TURNRIGHT: "gira @turnRight %1 graus",
  	MOTION_TURNLEFT: "gira @turnLeft %1 graus",
  	MOTION_POINTINDIRECTION: "apunta en direcció %1",
  	MOTION_POINTTOWARDS: "apunta cap a %1",
  	MOTION_GOTOXY: "vés a x: %1 y: %2",
  	MOTION_GOTO: "vés a %1",
  	MOTION_GLIDESECSTOXY: "llisca en %1 segons fins a x: %2 y: %3",
  	MOTION_GLIDETO: "llisca en %1 segons fins a %2",
  	MOTION_CHANGEXBY: "suma %1 a x",
  	MOTION_SETX: "assigna el valor %1 a x",
  	MOTION_CHANGEYBY: "suma %1 a y",
  	MOTION_SETY: "assigna el valor %1 a y",
  	MOTION_SETROTATIONSTYLE: "fixa el tipus de rotació %1",
  	LOOKS_SAYFORSECS: "digues %1 durant %2 segons",
  	LOOKS_SAY: "digues %1",
  	LOOKS_THINKFORSECS: "pensa %1 durant %2 segons",
  	LOOKS_THINK: "pensa %1",
  	LOOKS_SHOW: "mostra't",
  	LOOKS_HIDE: "amaga't",
  	LOOKS_SWITCHCOSTUMETO: "canvia el vestit a %1",
  	LOOKS_NEXTCOSTUME: "següent vestit",
  	LOOKS_NEXTBACKDROP_BLOCK: "següent fons de pantalla",
  	LOOKS_SWITCHBACKDROPTO: "canvia el fons a %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "canvia el fons a %1 i espera",
  	LOOKS_CHANGEEFFECTBY: "augmenta l'efecte %1 en %2",
  	LOOKS_SETEFFECTTO: "fixa l'efecte %1 a %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "treu els efectes gràfics",
  	LOOKS_CHANGESIZEBY: "augmenta %1 la mida",
  	LOOKS_SETSIZETO: "fixa la mida a %1 %",
  	LOOKS_GOTOFRONTBACK: "vés a la capa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "vés %1 %2 capes",
  	SOUND_PLAY: "inicia el so %1",
  	SOUND_CHANGEEFFECTBY: "augmenta l'efecte %1 en %2",
  	SOUND_SETEFFECTO: "fixa l'efecte %1 a %2",
  	SOUND_CLEAREFFECTS: "treu els efectes sonors",
  	SOUND_PLAYUNTILDONE: "toca el so %1 fins que acabi",
  	SOUND_STOPALLSOUNDS: "atura tots els sons",
  	"music.playDrumForBeats": "toca el tambor %1 durant %2 pulsacions",
  	"music.restForBeats": "espera %1 pulsacions",
  	"music.playNoteForBeats": "toca la nota %1 durant %2 pulsacions",
  	"music.setInstrument": "fixa instrument a %1",
  	SOUND_CHANGEVOLUMEBY: "puja %1 el volum",
  	SOUND_SETVOLUMETO: "fixa el volum a %1%",
  	"music.changeTempo": "augmenta %1 el tempo",
  	"music.setTempo": "fixa el tempo a %1",
  	"pen.clear": "esborra-ho tot",
  	"pen.stamp": "estampa",
  	"pen.penDown": "baixa el llapis",
  	"pen.penUp": "puja el llapis",
  	"pen.setColor": "fixa el color del llapis a %1",
  	"pen.changeHue": "augmenta %1 el color del llapis",
  	"pen.setColorParam": "fixa %1 del llapis a %2",
  	"pen.changeColorParam": "augmenta %1 del llapis en %2",
  	"pen.setHue": "fixa el color del llapis a %1",
  	"pen.changeShade": "augmenta %1 la intensitat del llapis",
  	"pen.setShade": "fixa la intensitat del llapis a %1",
  	"pen.changeSize": "augmenta %1 la mida del llapis",
  	"pen.setSize": "fixa la mida del llapis a %1",
  	EVENT_WHENFLAGCLICKED: "quan la @greenFlag es cliqui",
  	EVENT_WHENKEYPRESSED: "quan la tecla %1 es premi",
  	EVENT_WHENTHISSPRITECLICKED: "quan es cliqui aquest personatge",
  	EVENT_WHENSTAGECLICKED: "quan es cliqui l'escenari",
  	EVENT_WHENBACKDROPSWITCHESTO: "quan l'escenari canviï al fons %1",
  	EVENT_WHENGREATERTHAN: "quan %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "quan rebi %1",
  	EVENT_BROADCAST: "envia a tots %1",
  	EVENT_BROADCASTANDWAIT: "envia a tots %1 i espera",
  	CONTROL_WAIT: "espera %1 segons",
  	CONTROL_REPEAT: "repeteix %1",
  	CONTROL_FOREVER: "per sempre",
  	CONTROL_IF: "si %1 llavors",
  	CONTROL_WAITUNTIL: "espera fins %1",
  	CONTROL_REPEATUNTIL: "repeteix fins %1",
  	CONTROL_STOP: "atura %1",
  	CONTROL_STARTASCLONE: "quan una còpia meva comenci",
  	CONTROL_CREATECLONEOF: "crea una còpia de %1",
  	CONTROL_DELETETHISCLONE: "esborra aquesta còpia",
  	SENSING_ASKANDWAIT: "pregunta %1 i espera",
  	"videoSensing.videoToggle": "posa vídeo %1",
  	"videoSensing.setVideoTransparency": "fixa la transparència del vídeo a %1",
  	"videoSensing.whenMotionGreaterThan": "quan el moviment de vídeo > %1",
  	SENSING_RESETTIMER: "reinicia el cronòmetre",
  	DATA_SETVARIABLETO: "assigna a %1 el valor %2",
  	DATA_CHANGEVARIABLEBY: "augmenta %1 en %2",
  	DATA_SHOWVARIABLE: "mostra la variable %1",
  	DATA_HIDEVARIABLE: "amaga la variable %1",
  	DATA_ADDTOLIST: "afegeix %1 a %2",
  	DATA_DELETEOFLIST: "esborra l'element %1 de %2",
  	DATA_DELETEALLOFLIST: "esborra-ho tot de %1",
  	MOTION_IFONEDGEBOUNCE: "rebota en tocar una vora",
  	DATA_INSERTATLIST: "afegeix %1 a la posició %2 de %3",
  	DATA_REPLACEITEMOFLIST: "canvia l'element %1 de %2 per %3",
  	DATA_SHOWLIST: "mostra la llista %1",
  	DATA_HIDELIST: "amaga la llista %1",
  	SENSING_OF_XPOSITION: "posició x",
  	SENSING_OF_YPOSITION: "posició y",
  	SENSING_OF_DIRECTION: "direcció",
  	SENSING_OF_COSTUMENUMBER: "vestit nr",
  	LOOKS_COSTUMENUMBERNAME: "vestit %1",
  	SENSING_OF_SIZE: "mida",
  	SENSING_OF_BACKDROPNAME: "nom del fons",
  	LOOKS_BACKDROPNUMBERNAME: "fons %1",
  	SENSING_OF_BACKDROPNUMBER: "fons nr",
  	SOUND_VOLUME: "volum",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "tocant %1?",
  	SENSING_TOUCHINGCOLOR: "tocant el color %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "color %1 sobre %2?",
  	SENSING_DISTANCETO: "distància a %1",
  	SENSING_ANSWER: "resposta",
  	SENSING_KEYPRESSED: "tecla %1 premuda?",
  	SENSING_MOUSEDOWN: "ratolí clicat?",
  	SENSING_MOUSEX: "ratolí x",
  	SENSING_MOUSEY: "ratolí y",
  	SENSING_SETDRAGMODE: "fixa el mode d'arrossegament %1",
  	SENSING_LOUDNESS: "volum del so",
  	"videoSensing.videoOn": "vídeo %1 a %2",
  	SENSING_TIMER: "cronòmetre",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "actual %1",
  	SENSING_DAYSSINCE2000: "dies des del 2000",
  	SENSING_USERNAME: "nom d'usuari",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "nombre a l'atzar entre %1 i %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 i %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "no %1",
  	OPERATORS_JOIN: "uneix %1 i %2",
  	OPERATORS_LETTEROF: "lletra %1 de %2",
  	OPERATORS_LENGTH: "llargada de %1",
  	OPERATORS_MOD: "residu de dividir %1 entre %2",
  	OPERATORS_ROUND: "arrodoneix %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%1 conté %2?",
  	DATA_ITEMOFLIST: "element %1 de %2",
  	DATA_ITEMNUMOFLIST: "element # de %1 en %2",
  	DATA_LENGTHOFLIST: "llargada de %1",
  	DATA_LISTCONTAINSITEM: "%1 conté %2?",
  	CONTROL_ELSE: "si no",
  	SENSING_USERID: "ID d'usuari",
  	SENSING_LOUD: "so fort?",
  	"text2speech.speakAndWaitBlock": "parla %1",
  	"text2speech.setVoiceBlock": "fixa la veu a %1",
  	"text2speech.setLanguageBlock": "fixa l'idioma a %1",
  	"translate.translateBlock": "tradueix %1 a %2",
  	"translate.viewerLanguage": "idioma",
  	"makeymakey.whenKeyPressed": "quan la tecla %1 es premi",
  	"makeymakey.whenKeysPressedInOrder": "quan %1 es premin en ordre",
  	"microbit.whenButtonPressed": "quan el botó %1 es premi",
  	"microbit.isButtonPressed": "%1 botó premut?",
  	"microbit.whenGesture": "quan %1",
  	"microbit.displaySymbol": "mostra %1",
  	"microbit.displayText": "mostra text %1",
  	"microbit.clearDisplay": "no mostris res",
  	"microbit.whenTilted": "quan s'inclini %1",
  	"microbit.isTilted": "inclinat %1?",
  	"microbit.tiltAngle": "angle d'inclinació %1",
  	"microbit.whenPinConnected": "quan el pin %1 connectat",
  	"ev3.motorTurnClockwise": "motor %1 cap aquí durant %2 segons",
  	"ev3.motorTurnCounterClockwise": "motor %1 cap allà durant %2 segons",
  	"ev3.motorSetPower": "motor %1 potència %2 %",
  	"ev3.getMotorPosition": "posició del motor %1",
  	"ev3.whenButtonPressed": "quan el botó %1 es premi",
  	"ev3.whenDistanceLessThan": "quan la distància < %1",
  	"ev3.whenBrightnessLessThan": "quan la brillantor < %1",
  	"ev3.buttonPressed": "botó %1 premut?",
  	"ev3.getDistance": "distància",
  	"ev3.getBrightness": "brillantor",
  	"ev3.beepNote": "fes sonar la nota %1 durant %2 segons",
  	"wedo2.motorOn": "activa el motor %1",
  	"wedo2.motorOff": "apaga motor %1",
  	"wedo2.startMotorPower": "fixa la potència de %1 a %2",
  	"wedo2.setMotorDirection": "fixa la direcció de %1 a %2",
  	"wedo2.whenDistance": "quan la distància %1 %2",
  	"wedo2.getDistance": "distància",
  	"wedo2.motorOnFor": "activa %1 durant %2 segons",
  	"wedo2.setLightHue": "fixa el color del llum a %1",
  	"wedo2.playNoteFor": "toca la nota %1 durant %2 segons",
  	"wedo2.whenTilted": "quan la inclinació %1",
  	"wedo2.isTilted": "inclinat %1?",
  	"wedo2.getTiltAngle": "angle d'inclinació %1",
  	"gdxfor.whenGesture": "quan %1",
  	"gdxfor.whenForcePushedOrPulled": "quan el sensor de força %1",
  	"gdxfor.getForce": "força",
  	"gdxfor.whenTilted": "quan s'inclini %1",
  	"gdxfor.isTilted": "inclinat %1?",
  	"gdxfor.getTilt": "angle d'inclinació %1",
  	"gdxfor.isFreeFalling": "caient?",
  	"gdxfor.getSpin": "velocitat de gir %1",
  	"gdxfor.getAcceleration": "acceleració %1",
  	"boost.motorOnFor": "activa el motor %1 durant %2 segons",
  	"boost.motorOnForRotation": "activa el motor %1 durant %2 rotacions",
  	"boost.motorOn": "activa el motor %1",
  	"boost.motorOff": "apaga el motor %1",
  	"boost.setMotorPower": "fixa la velocitat del motor %1 a %2 %",
  	"boost.setMotorDirection": "fixa la direcció del motor %1 a %2",
  	"boost.getMotorPosition": "posició del motor %1",
  	"boost.whenColor": "quan detecti el bloc %1",
  	"boost.seeingColor": "detecta el bloc %1?",
  	"boost.whenTilted": "quan la inclinació %1",
  	"boost.getTiltAngle": "angle d'inclinació %1",
  	"boost.setLightHue": "fixa el color del llum a %1"
  };
  var dropdowns$13 = {
  };
  var ignorelt$13 = [
  ];
  var soundEffects$13 = [
  	"pitch",
  	"pan esquerra/dreta"
  ];
  var microbitWhen$13 = [
  	"es mogui",
  	"es sacsegi",
  	"salti"
  ];
  var osis$13 = [
  	"altres programes del personatge"
  ];
  var definePrefix$13 = [
  	"defineix"
  ];
  var defineSuffix$13 = [
  ];
  var palette$13 = {
  	Motion: "Moviment",
  	Looks: "Aspecte",
  	Sound: "So",
  	Events: "Esdeveniments",
  	Control: "Control",
  	Sensing: "Sensors",
  	Operators: "Operadors",
  	Variables: "Variables",
  	"My Blocks": "Els meus blocs"
  };
  var math$13 = [
  	"abs",
  	"part sencera",
  	"sostre",
  	"arrel quadrada",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$13 = {
  	"gira a l'esquerra %1 graus": "MOTION_TURNLEFT",
  	"gira a la dreta %1 graus": "MOTION_TURNRIGHT",
  	"quan la bandera verda es cliqui": "EVENT_WHENFLAGCLICKED",
  	"quan la bandera verda es premi": "EVENT_WHENFLAGCLICKED",
  	fi: "scratchblocks:end"
  };
  var name$13 = "Català";
  var percentTranslated$13 = 100;
  var ca = {
  	commands: commands$13,
  	dropdowns: dropdowns$13,
  	ignorelt: ignorelt$13,
  	soundEffects: soundEffects$13,
  	microbitWhen: microbitWhen$13,
  	osis: osis$13,
  	definePrefix: definePrefix$13,
  	defineSuffix: defineSuffix$13,
  	palette: palette$13,
  	math: math$13,
  	aliases: aliases$13,
  	name: name$13,
  	percentTranslated: percentTranslated$13
  };

  var commands$12 = {
  	MOTION_MOVESTEPS: "جوڵان %1 هەنگاو",
  	MOTION_TURNRIGHT: "بیسوڕێنەوە @turnRight %1 پلە",
  	MOTION_TURNLEFT: "بیسوڕێنەوە @turnLeft %1 پلە",
  	MOTION_POINTINDIRECTION: "خاڵ بە ئاڕاستەی %1",
  	MOTION_POINTTOWARDS: "خاڵ بەرەو %1",
  	MOTION_GOTOXY: "بڕۆ بۆ x: %1   y: %2",
  	MOTION_GOTO: "بڕۆ بۆ %1",
  	MOTION_GLIDESECSTOXY: "خلیسکان %1 چرکە بۆ x %2  y %3",
  	MOTION_GLIDETO: "خلیسکان %1 چرکە بۆ %2",
  	MOTION_CHANGEXBY: "گۆڕینی x بە %1",
  	MOTION_SETX: "دانانی x بە %1",
  	MOTION_CHANGEYBY: "گۆڕینی y بە %1",
  	MOTION_SETY: "دانانی y بە %1",
  	MOTION_SETROTATIONSTYLE: "دانانی شێوازی سوڕانەوە %1",
  	LOOKS_SAYFORSECS: "بڵێ %1 بۆ %2 چرکە",
  	LOOKS_SAY: "بڵێ %1",
  	LOOKS_THINKFORSECS: "بیرکردنەوە %1 بۆ %2 چرکە",
  	LOOKS_THINK: "بیرکردنەوەی %1",
  	LOOKS_SHOW: "پیشاندان",
  	LOOKS_HIDE: "شاردنەوە",
  	LOOKS_SWITCHCOSTUMETO: "گۆڕینی بەرگ بۆ %1",
  	LOOKS_NEXTCOSTUME: "بەرگی دواتر",
  	LOOKS_NEXTBACKDROP_BLOCK: "پاشبنەمای دواتر",
  	LOOKS_SWITCHBACKDROPTO: "گۆڕینی پاشبنەما بۆ %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "گۆڕینی پاشبنەما بۆ %1 و چاوەڕێ بکە",
  	LOOKS_CHANGEEFFECTBY: "گۆڕینی %1 کاریگەری بە %2",
  	LOOKS_SETEFFECTTO: "دانانی %1 کاریگەری بۆ %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "سڕینەوەی کاریگەرییەکانی هێلکاری",
  	LOOKS_CHANGESIZEBY: "گۆڕینی قەبارە بە %1",
  	LOOKS_SETSIZETO: "دانانی قەبارە بە %1 ٪",
  	LOOKS_GOTOFRONTBACK: "بڕۆ بۆ %1 چین",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "بڕۆ بۆ %1 %2 چین",
  	SOUND_PLAY: "دەستپێکردنی دەنگ %1",
  	SOUND_CHANGEEFFECTBY: "گۆڕینی %1 کاریگەری بە %2",
  	SOUND_SETEFFECTO: "دانانی %1 کاریگەری بۆ %2",
  	SOUND_CLEAREFFECTS: "سڕینەوەی کاریگەرییەکانی دەنگ",
  	SOUND_PLAYUNTILDONE: "لێدانی دەنگی %1 تا تەواوبوون",
  	SOUND_STOPALLSOUNDS: "هەموو دەنگەکان ڕاگرە",
  	"music.playDrumForBeats": "لێدانی تەپڵ %1 بۆ %2 لیدان",
  	"music.restForBeats": "پشوو بۆ %1 لێدان",
  	"music.playNoteForBeats": "لێدانی ئاماژەی %1 بۆ %2 لێدان",
  	"music.setInstrument": "دانانی ئامێر بە %1",
  	SOUND_CHANGEVOLUMEBY: "گۆڕینی دەنگ بە %1",
  	SOUND_SETVOLUMETO: "دانانی دانگ بە %1%",
  	"music.changeTempo": "گۆڕینی خێرایی بە %1",
  	"music.setTempo": "دانانی خێرایی بە %1",
  	"pen.clear": "سڕینەوەی هەموو",
  	"pen.stamp": "مۆر",
  	"pen.penDown": "پێنووس داگرتن",
  	"pen.penUp": "پێنووس بەرزکردن",
  	"pen.setColor": "دانانی ڕەنگی پێنووس بە %1",
  	"pen.changeHue": "گۆڕینی ڕەنگی پێنووس بە %1",
  	"pen.setColorParam": "دانانی پێنووس %1 بە %2",
  	"pen.changeColorParam": "گۆڕینی پێنووس %1 بە %2",
  	"pen.setHue": "دانانی ڕەنگی پێنووس بە %1",
  	"pen.changeShade": "گۆڕینی سێبەری پێنووس بە %1",
  	"pen.setShade": "دانانی سێبەری پێنووس بە %1",
  	"pen.changeSize": "گۆڕینی قەبارەی پێنووس بە %1",
  	"pen.setSize": "دانانی قەبارەی پێنووس بە %1",
  	EVENT_WHENFLAGCLICKED: "کاتێک @greenFlag کرتەکرا",
  	EVENT_WHENKEYPRESSED: "کاتێک دوگمەی %1 کرتەکرا",
  	EVENT_WHENTHISSPRITECLICKED: "کاتێک ئەم تەنە کرتەکرا",
  	EVENT_WHENSTAGECLICKED: "کاتێک سەکۆ کرتەکرا",
  	EVENT_WHENBACKDROPSWITCHESTO: "کاتێک پاشبنەما دەگۆڕێت بۆ %1",
  	EVENT_WHENGREATERTHAN: "کاتێک %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "کاتێک بەدەستم گەیشت %1",
  	EVENT_BROADCAST: "پەخشکردن %1",
  	EVENT_BROADCASTANDWAIT: "پەخشکردنی %1 و چاوەڕێکردن",
  	CONTROL_WAIT: "بوەستە %1 چرکە",
  	CONTROL_REPEAT: "دوبارەکردنەوە %1",
  	CONTROL_FOREVER: "بۆهەتایە",
  	CONTROL_IF: "ئەگەر %1 ئینجا",
  	CONTROL_WAITUNTIL: "چاوەڕێ بکە تا %1",
  	CONTROL_REPEATUNTIL: "دوبارەکردنەوە تا %1",
  	CONTROL_STOP: "وەستان %1",
  	CONTROL_STARTASCLONE: "کاتێک دەستپێدەکەم وەک لێکچووێک",
  	CONTROL_CREATECLONEOF: "دروستکردنی لێکچوو لە %1",
  	CONTROL_DELETETHISCLONE: "سڕینەوەی ئەم لێکچووە",
  	SENSING_ASKANDWAIT: "پرسیار بکە %1 و چاوەڕێ بکە",
  	"videoSensing.videoToggle": "ڤیدیۆ بکە بە %1",
  	"videoSensing.setVideoTransparency": "دانانی ڕۆشنایی ڤیدیۆ بە %1",
  	"videoSensing.whenMotionGreaterThan": "کاتێک جوڵەی ڤیدیۆ > %1",
  	SENSING_RESETTIMER: "ڕێکخستنەوەی کاتێنەر",
  	DATA_SETVARIABLETO: "دانانی %1 بۆ %2",
  	DATA_CHANGEVARIABLEBY: "گۆڕین %1 بە %2",
  	DATA_SHOWVARIABLE: "پیشاندانی گۆڕاو %1",
  	DATA_HIDEVARIABLE: "شاردنەوەی گۆڕاوی %1",
  	DATA_ADDTOLIST: "زیادکردنی %1 بۆ %2",
  	DATA_DELETEOFLIST: "سڕینەوە %1 لە %2",
  	DATA_DELETEALLOFLIST: "سڕینەوەی هەموو لە %1",
  	MOTION_IFONEDGEBOUNCE: "ئەگەر لە لێواربوو، بگەڕێوە",
  	DATA_INSERTATLIST: "خستنەناو %1 بۆ %2 لە %3",
  	DATA_REPLACEITEMOFLIST: "گۆڕینەوەی دانە %1 لە %2 لەگەڵ %3",
  	DATA_SHOWLIST: "پیشاندانی لیست %1",
  	DATA_HIDELIST: "شاردنەوەی لیست %1",
  	SENSING_OF_XPOSITION: "شوێنی x",
  	SENSING_OF_YPOSITION: "شوێنی y",
  	SENSING_OF_DIRECTION: "ئاڕاستە",
  	SENSING_OF_COSTUMENUMBER: "بەرگ #",
  	LOOKS_COSTUMENUMBERNAME: "بەرگ %1",
  	SENSING_OF_SIZE: "قەبارە",
  	SENSING_OF_BACKDROPNAME: "ناوی پاشبنەما",
  	LOOKS_BACKDROPNUMBERNAME: "پاشبنه‌ما %1",
  	SENSING_OF_BACKDROPNUMBER: "پاشبنه‌ما #",
  	SOUND_VOLUME: "قەبارە",
  	"music.getTempo": "خێرایی",
  	SENSING_TOUCHINGOBJECT: "بەرکەوتنی %1؟",
  	SENSING_TOUCHINGCOLOR: "بەرکەوتنی ڕەنگ %1؟",
  	SENSING_COLORISTOUCHINGCOLOR: "ڕەنگ %1 بەردەکەوێت %2؟",
  	SENSING_DISTANCETO: "دووری بۆ %1",
  	SENSING_ANSWER: "وەڵام",
  	SENSING_KEYPRESSED: "دوگمەی %1 داگیرا؟",
  	SENSING_MOUSEDOWN: "ماوس بۆ خوارەوە؟",
  	SENSING_MOUSEX: "ماوس x",
  	SENSING_MOUSEY: "ماوس y",
  	SENSING_SETDRAGMODE: "دانانی شێوازی  ڕاکێشان %1",
  	SENSING_LOUDNESS: "دەنگەدەنگ",
  	"videoSensing.videoOn": "ڤیدیۆ %1 لەسەر %2",
  	SENSING_TIMER: "کاتێنەر",
  	SENSING_OF: "%1 لە %2",
  	SENSING_CURRENT: "ئێستا %1",
  	SENSING_DAYSSINCE2000: "ڕۆژ لەوەتەی 2000",
  	SENSING_USERNAME: "ناوی بەکارهێنەر",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "هەڵبژاردنی هەڕەمەکی %1 بۆ %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 and %2",
  	OPERATORS_OR: "%1 or %2",
  	OPERATORS_NOT: "نا %1",
  	OPERATORS_JOIN: "پەیوەندی %1 %2",
  	OPERATORS_LETTEROF: "پیت %1 لە %2",
  	OPERATORS_LENGTH: "درێژی لە %1",
  	OPERATORS_MOD: "%1 ماوە %2",
  	OPERATORS_ROUND: "نزیککردنەوە %1",
  	OPERATORS_MATHOP: "%1 لە %2",
  	OPERATORS_CONTAINS: "%1 تێیدایە %2؟",
  	DATA_ITEMOFLIST: "دانە %1 لە %2",
  	DATA_ITEMNUMOFLIST: "دانەی # %1 لە %2",
  	DATA_LENGTHOFLIST: "درێژی لە %1",
  	DATA_LISTCONTAINSITEM: "%1 تێیدایە %2؟",
  	CONTROL_ELSE: "ئەگەرنا",
  	SENSING_USERID: "ژمارەی بەکارهێنەر",
  	SENSING_LOUD: "بەدەنگی بەرز؟",
  	"text2speech.speakAndWaitBlock": "قسە بکە %1",
  	"text2speech.setVoiceBlock": "دانانی دەنگ بە %1",
  	"text2speech.setLanguageBlock": "دانانی زمان بە %1",
  	"translate.translateBlock": "وەرگێڕانی %1 بۆ %2",
  	"translate.viewerLanguage": "زمان",
  	"makeymakey.whenKeyPressed": "کاتێک دوگمەی %1 کرتەکرا",
  	"makeymakey.whenKeysPressedInOrder": "کاتێک %1 کرتەکرا بە ڕیزبەندی",
  	"microbit.whenButtonPressed": "کاتێک دوگمەی %1 کرتەکرا",
  	"microbit.isButtonPressed": "دوگمەی %1 کرتەکرا؟",
  	"microbit.whenGesture": "کاتێک %1",
  	"microbit.displaySymbol": "پیشاندانی %1",
  	"microbit.displayText": "پیشاندانی دەق %1",
  	"microbit.clearDisplay": "سڕینەوەی شاشە",
  	"microbit.whenTilted": "کاتێک لارکرا %1",
  	"microbit.isTilted": "لارکراو %1؟",
  	"microbit.tiltAngle": "گۆشەی لاری %1",
  	"microbit.whenPinConnected": "کاتێک نێرکی %1 بەسترابوو",
  	"ev3.motorTurnClockwise": "ماتۆڕ %1 ئەم ڕێگایە بگرە بۆ %2 چرکە",
  	"ev3.motorTurnCounterClockwise": "ماتۆڕ %1 ئەو ڕێگایە بگرە بۆ %2 چرکە",
  	"ev3.motorSetPower": "ماتۆڕ %1 دانانی هێز %2 ٪",
  	"ev3.getMotorPosition": "ماتۆڕ %1 شوێن",
  	"ev3.whenButtonPressed": "کاتێک دوگمەی %1 کرتەکرا",
  	"ev3.whenDistanceLessThan": "کاتێک دووری < %1",
  	"ev3.whenBrightnessLessThan": "کاتێک ڕووناکی < %1",
  	"ev3.buttonPressed": "دوگمەی %1 کرتەکرا؟",
  	"ev3.getDistance": "دووری",
  	"ev3.getBrightness": "ڕووناکی",
  	"ev3.beepNote": "ئاماژەی بیپ %1 بۆ %2 چرکە",
  	"wedo2.motorOn": "%1 پێبکە",
  	"wedo2.motorOff": "%1 بکوژێنەوە",
  	"wedo2.startMotorPower": "دانانی هێزی %1 بە %2",
  	"wedo2.setMotorDirection": "دانانی ئاڕاستەی %1 بە %2",
  	"wedo2.whenDistance": "کاتێک دووری %1 %2",
  	"wedo2.getDistance": "دووری",
  	"wedo2.motorOnFor": "%1 پێبکە بۆ %2 چرکە",
  	"wedo2.setLightHue": "دانانی ڕووناکی ڕەنگ بە %1",
  	"wedo2.playNoteFor": "لێدانی ئاماژەی %1 بۆ %2 چرکە",
  	"wedo2.whenTilted": "کاتێک لارکرا %1",
  	"wedo2.isTilted": "لارکراو %1؟",
  	"wedo2.getTiltAngle": "گۆشەی لاری %1",
  	"gdxfor.whenGesture": "کاتێک %1",
  	"gdxfor.whenForcePushedOrPulled": "کاتێک هەستەوەری هێز %1",
  	"gdxfor.getForce": "هێز",
  	"gdxfor.whenTilted": "کاتێک لارکرا %1",
  	"gdxfor.isTilted": "لارکراو %1؟",
  	"gdxfor.getTilt": "گۆشەی لارکردنەوە %1",
  	"gdxfor.isFreeFalling": "دەکەوێت؟",
  	"gdxfor.getSpin": "خێرایی خولانەوە %1",
  	"gdxfor.getAcceleration": "گوڕ %1",
  	"boost.motorOnFor": "ماتۆڕی %1 پێبکە بۆ %2 چرکە",
  	"boost.motorOnForRotation": "ماتۆڕی %1 پێبکە بۆ %2 سوڕان",
  	"boost.motorOn": "ماتۆڕی %1 پێبکە",
  	"boost.motorOff": "ماتۆڕی %1 بکوژێنەوە",
  	"boost.setMotorPower": "دانانی خێرایی ماتۆڕی %1 بە %2 %",
  	"boost.setMotorDirection": "دانانی ئاڕاستەی ماتۆڕی %1 بە %2",
  	"boost.getMotorPosition": "ماتۆڕ %1 شوێن",
  	"boost.whenColor": "کاتێک خشتی %1 بینرا",
  	"boost.seeingColor": "بینینی خشتی %1؟",
  	"boost.whenTilted": "کاتێک لارکرا %1",
  	"boost.getTiltAngle": "گۆشەی لاری %1",
  	"boost.setLightHue": "دانانی ڕووناکی ڕەنگ بە %1"
  };
  var dropdowns$12 = {
  };
  var ignorelt$12 = [
  ];
  var soundEffects$12 = [
  	"بەرزی دەنگ",
  	"سوڕانەوە چەپ/ڕاست"
  ];
  var microbitWhen$12 = [
  	"جوڵاو",
  	"هەژاو",
  	"بازدراو"
  ];
  var osis$12 = [
  	"سکریپتەکانی تر لە تەن"
  ];
  var definePrefix$12 = [
  	"پێناسەی"
  ];
  var defineSuffix$12 = [
  ];
  var palette$12 = {
  	Motion: "جوڵان",
  	Looks: "ڕوانین",
  	Sound: "دەنگ",
  	Events: "چالاکییەکان",
  	Control: "کۆنتڕۆڵ",
  	Sensing: "هەستکردن",
  	Operators: "كرده‌هێماکان",
  	Variables: "گۆڕاوەکان",
  	"My Blocks": "بلۆکەکانم"
  };
  var math$12 = [
  	"ڕەگی دووجا",
  	"زەوی",
  	"بنمیچ",
  	"ڕەگی دووجا",
  	"تەژێ",
  	"تەژێ تەواو",
  	"تانجێنت",
  	"asin",
  	"acos",
  	"atan",
  	"لن",
  	"لۆگاریتم",
  	"e ^",
  	"10 ^"
  ];
  var aliases$12 = {
  };
  var name$12 = "کوردیی ناوەندی";
  var percentTranslated$12 = 100;
  var ckb = {
  	commands: commands$12,
  	dropdowns: dropdowns$12,
  	ignorelt: ignorelt$12,
  	soundEffects: soundEffects$12,
  	microbitWhen: microbitWhen$12,
  	osis: osis$12,
  	definePrefix: definePrefix$12,
  	defineSuffix: defineSuffix$12,
  	palette: palette$12,
  	math: math$12,
  	aliases: aliases$12,
  	name: name$12,
  	percentTranslated: percentTranslated$12
  };

  var commands$11 = {
  	MOTION_MOVESTEPS: "dopředu o %1 kroků",
  	MOTION_TURNRIGHT: "otoč se @turnRight o %1 stupňů",
  	MOTION_TURNLEFT: "otoč se @turnLeft o %1 stupňů",
  	MOTION_POINTINDIRECTION: "nastav směr %1",
  	MOTION_POINTTOWARDS: "nastav směr k %1",
  	MOTION_GOTOXY: "skoč na x: %1 y: %2",
  	MOTION_GOTO: "skoč na %1",
  	MOTION_GLIDESECSTOXY: "klouzej %1 sekund na x: %2 y: %3",
  	MOTION_GLIDETO: "klouzej %1 sekund na %2",
  	MOTION_CHANGEXBY: "změň x o %1",
  	MOTION_SETX: "nastav x na %1",
  	MOTION_CHANGEYBY: "změň y o %1",
  	MOTION_SETY: "nastav y na %1",
  	MOTION_SETROTATIONSTYLE: "nastav otáčení %1",
  	LOOKS_SAYFORSECS: "bublina %1 %2 sekund",
  	LOOKS_SAY: "bublina %1",
  	LOOKS_THINKFORSECS: "myšlenka %1 %2 sekund",
  	LOOKS_THINK: "myšlenka %1",
  	LOOKS_SHOW: "ukaž se",
  	LOOKS_HIDE: "skryj se",
  	LOOKS_SWITCHCOSTUMETO: "změň kostým na %1",
  	LOOKS_NEXTCOSTUME: "další kostým",
  	LOOKS_NEXTBACKDROP_BLOCK: "další pozadí",
  	LOOKS_SWITCHBACKDROPTO: "přepni pozadí na %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "změň pozadí na %1",
  	LOOKS_CHANGEEFFECTBY: "změň efekt %1 o %2",
  	LOOKS_SETEFFECTTO: "nastav efekt %1 na %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "zruš grafické efekty",
  	LOOKS_CHANGESIZEBY: "změň velikost o %1",
  	LOOKS_SETSIZETO: "nastav velikost na %1 %",
  	LOOKS_GOTOFRONTBACK: "přejdi na vrstvu %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "jdi %1 o %2",
  	SOUND_PLAY: "začni hrát zvuk %1",
  	SOUND_CHANGEEFFECTBY: "změň efekt %1 o %2",
  	SOUND_SETEFFECTO: "nastav efekt %1 na %2",
  	SOUND_CLEAREFFECTS: "zruš zvukové efekty",
  	SOUND_PLAYUNTILDONE: "přehraj zvuk %1 až do konce",
  	SOUND_STOPALLSOUNDS: "zastav všechny zvuky",
  	"music.playDrumForBeats": "bubnuj %1 příštích %2 taktů",
  	"music.restForBeats": "pauza %1 taktů",
  	"music.playNoteForBeats": "hraj notu %1 příštích %2 taktů",
  	"music.setInstrument": "nastav nástroj na %1",
  	SOUND_CHANGEVOLUMEBY: "změň hlasitost o %1",
  	SOUND_SETVOLUMETO: "nastav hlasitost na %1%",
  	"music.changeTempo": "změň tempo o %1",
  	"music.setTempo": "nastav tempo na %1",
  	"pen.clear": "smaž",
  	"pen.stamp": "otiskni se",
  	"pen.penDown": "pero zapni",
  	"pen.penUp": "pero vypni",
  	"pen.setColor": "nastav barvu pera na %1",
  	"pen.changeHue": "změň barvu pera o %1",
  	"pen.setColorParam": "nastav %1 pera na %2",
  	"pen.changeColorParam": "změň %1 pera o %2",
  	"pen.setHue": "nastav barvu pera na %1",
  	"pen.changeShade": "změň odstín pera o %1",
  	"pen.setShade": "nastav odstín pera na %1",
  	"pen.changeSize": "změň tloušťku pera o %1",
  	"pen.setSize": "nastav tloušťku pera na %1",
  	EVENT_WHENFLAGCLICKED: "po kliknutí na @greenFlag",
  	EVENT_WHENKEYPRESSED: "po stisku klávesy %1",
  	EVENT_WHENTHISSPRITECLICKED: "po kliknutí na mě",
  	EVENT_WHENSTAGECLICKED: "po kliknutí na scénu",
  	EVENT_WHENBACKDROPSWITCHESTO: "po změně pozadí na %1",
  	EVENT_WHENGREATERTHAN: "když %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "po obdržení zprávy %1",
  	EVENT_BROADCAST: "vyšli zprávu %1",
  	EVENT_BROADCASTANDWAIT: "vyšli zprávu %1 a čekej",
  	CONTROL_WAIT: "čekej %1 sekund",
  	CONTROL_REPEAT: "opakuj %1 krát",
  	CONTROL_FOREVER: "opakuj stále",
  	CONTROL_IF: "když %1 tak",
  	CONTROL_WAITUNTIL: "čekej dokud nenastane %1",
  	CONTROL_REPEATUNTIL: "opakuj dokud nenastane %1",
  	CONTROL_STOP: "zastav %1",
  	CONTROL_STARTASCLONE: "když startuje můj klon",
  	CONTROL_CREATECLONEOF: "klonuj %1",
  	CONTROL_DELETETHISCLONE: "zruš tento klon",
  	SENSING_ASKANDWAIT: "otázka %1",
  	"videoSensing.videoToggle": "%1 video",
  	"videoSensing.setVideoTransparency": "nastav průhlednost videa na %1",
  	"videoSensing.whenMotionGreaterThan": "při pohybu na videu > %1",
  	SENSING_RESETTIMER: "vynuluj stopky",
  	DATA_SETVARIABLETO: "nastav %1 na %2",
  	DATA_CHANGEVARIABLEBY: "změň %1 o %2",
  	DATA_SHOWVARIABLE: "ukaž proměnnou %1",
  	DATA_HIDEVARIABLE: "skryj proměnnou %1",
  	DATA_ADDTOLIST: "přidej %1 k %2",
  	DATA_DELETEOFLIST: "smaž %1 z %2",
  	DATA_DELETEALLOFLIST: "smaž všechno z %1",
  	MOTION_IFONEDGEBOUNCE: "když narazíš na okraj, odraz se",
  	DATA_INSERTATLIST: "vlož %1 na %2 v %3",
  	DATA_REPLACEITEMOFLIST: "nahraď %1 v %2 hodnotou %3",
  	DATA_SHOWLIST: "ukaž seznam %1",
  	DATA_HIDELIST: "skryj seznam %1",
  	SENSING_OF_XPOSITION: "x",
  	SENSING_OF_YPOSITION: "y",
  	SENSING_OF_DIRECTION: "směr",
  	SENSING_OF_COSTUMENUMBER: "číslo kostýmu",
  	LOOKS_COSTUMENUMBERNAME: "kostým %1",
  	SENSING_OF_SIZE: "velikost",
  	SENSING_OF_BACKDROPNAME: "název pozadí",
  	LOOKS_BACKDROPNUMBERNAME: "pozadí %1",
  	SENSING_OF_BACKDROPNUMBER: "číslo pozadí",
  	SOUND_VOLUME: "hlasitost",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "dotýkáš se %1?",
  	SENSING_TOUCHINGCOLOR: "dotýkáš se barvy %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "barvou %1 se dotýkáš %2?",
  	SENSING_DISTANCETO: "vzdálenost k %1",
  	SENSING_ANSWER: "odpověď",
  	SENSING_KEYPRESSED: "klávesa %1 stisknuta?",
  	SENSING_MOUSEDOWN: "myš stisknuta?",
  	SENSING_MOUSEX: "x myši",
  	SENSING_MOUSEY: "y myši",
  	SENSING_SETDRAGMODE: "povoleno přesouvat %1",
  	SENSING_LOUDNESS: "hlasitost",
  	"videoSensing.videoOn": "video %1 na %2",
  	SENSING_TIMER: "stopky",
  	SENSING_OF: "%1 z %2",
  	SENSING_CURRENT: "aktuální %1",
  	SENSING_DAYSSINCE2000: "dnů od r. 2000",
  	SENSING_USERNAME: "jméno uživatele",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "náhodné číslo od %1 do %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 a %2",
  	OPERATORS_OR: "%1 nebo %2",
  	OPERATORS_NOT: "ne %1",
  	OPERATORS_JOIN: "spoj %1 %2",
  	OPERATORS_LETTEROF: "písmeno %1 z %2",
  	OPERATORS_LENGTH: "délka %1",
  	OPERATORS_MOD: "zbytek %1 děleno %2",
  	OPERATORS_ROUND: "zaokrouhli %1",
  	OPERATORS_MATHOP: "%1 %2",
  	OPERATORS_CONTAINS: "%1 obsahuje %2?",
  	DATA_ITEMOFLIST: "prvek %1 z %2",
  	DATA_ITEMNUMOFLIST: "pořadí %1 ve %2",
  	DATA_LENGTHOFLIST: "délka %1",
  	DATA_LISTCONTAINSITEM: "%1 obsahuje %2",
  	CONTROL_ELSE: "jinak",
  	SENSING_USERID: "ID uživatele",
  	SENSING_LOUD: "hlasité?",
  	"text2speech.speakAndWaitBlock": "řekni %1",
  	"text2speech.setVoiceBlock": "nastav hlas na %1",
  	"text2speech.setLanguageBlock": "nastav jazyk na %1",
  	"translate.translateBlock": "přelož %1 do %2",
  	"translate.viewerLanguage": "jazyk",
  	"makeymakey.whenKeyPressed": "když je stisknuta klávesa %1",
  	"makeymakey.whenKeysPressedInOrder": "když %1 stisknuto postupně",
  	"microbit.whenButtonPressed": "po stisku tlačítka %1",
  	"microbit.isButtonPressed": "tlačítko %1 stisknuto?",
  	"microbit.whenGesture": "když %1",
  	"microbit.displaySymbol": "zobraz %1",
  	"microbit.displayText": "displej textu %1",
  	"microbit.clearDisplay": "smaž displej",
  	"microbit.whenTilted": "když nakloněný %1",
  	"microbit.isTilted": "nakloněno %1?",
  	"microbit.tiltAngle": "úhel náklonu %1",
  	"microbit.whenPinConnected": "když je pin %1 propojený",
  	"ev3.motorTurnClockwise": "toč motorem %1 ve směru hodin %2 sekund",
  	"ev3.motorTurnCounterClockwise": "toč motorem %1 proti směru hodin %2 sekund",
  	"ev3.motorSetPower": "nastav motoru %1 rychlost %2 %",
  	"ev3.getMotorPosition": "pozice motoru %1",
  	"ev3.whenButtonPressed": "po stisku tlačítka %1",
  	"ev3.whenDistanceLessThan": "když vzdálenost < %1",
  	"ev3.whenBrightnessLessThan": "když je jas < %1",
  	"ev3.buttonPressed": "je tlačítko %1 stisknuto?",
  	"ev3.getDistance": "vzdálenost",
  	"ev3.getBrightness": "jas",
  	"ev3.beepNote": "hraj notu %1 příštích %2 sekund",
  	"wedo2.motorOn": "zapni %1",
  	"wedo2.motorOff": "vypni %1",
  	"wedo2.startMotorPower": "pro %1 nastav rychlost  %2",
  	"wedo2.setMotorDirection": "nastav %1 směrem %2",
  	"wedo2.whenDistance": "když vzdálenost %1 %2",
  	"wedo2.getDistance": "vzdálenost",
  	"wedo2.motorOnFor": "zapni %1 na %2 sekund",
  	"wedo2.setLightHue": "nastav barvu světla na %1",
  	"wedo2.playNoteFor": "hraj notu %1 příštích %2 sekund",
  	"wedo2.whenTilted": "když nakloněný %1",
  	"wedo2.isTilted": "nakloněno %1?",
  	"wedo2.getTiltAngle": "úhel náklonu %1",
  	"gdxfor.whenGesture": "když %1",
  	"gdxfor.whenForcePushedOrPulled": "když senzor síly %1",
  	"gdxfor.getForce": "síla",
  	"gdxfor.whenTilted": "když nakloněný %1",
  	"gdxfor.isTilted": "nakloněné %1?",
  	"gdxfor.getTilt": "úhel náklonu %1",
  	"gdxfor.isFreeFalling": "padá?",
  	"gdxfor.getSpin": "rychlost otáčení %1",
  	"gdxfor.getAcceleration": "zrychlení %1",
  	"boost.motorOnFor": "zapni motor %1 na %2 sekundy",
  	"boost.motorOnForRotation": "zapni motor %1 na %2 otočky",
  	"boost.motorOn": "zapni motor %1",
  	"boost.motorOff": "vypni motor %1",
  	"boost.setMotorPower": "nastav rychlost motoru %1 na %2 %",
  	"boost.setMotorDirection": "nastav směr motoru %1 na %2",
  	"boost.getMotorPosition": "pozice motoru %1",
  	"boost.whenColor": "když je vidět %1 cihla",
  	"boost.seeingColor": "je vidět %1 cihla?",
  	"boost.whenTilted": "když nakloněný %1",
  	"boost.getTiltAngle": "úhel náklonu %1",
  	"boost.setLightHue": "nastav barvu světla na %1"
  };
  var dropdowns$11 = {
  };
  var ignorelt$11 = [
  ];
  var soundEffects$11 = [
  	"poloha",
  	"stereo vlevo/vpravo"
  ];
  var microbitWhen$11 = [
  	"se pohne",
  	"se zatřese",
  	"poskočí"
  ];
  var osis$11 = [
  	"jiné scénáře postavy"
  ];
  var definePrefix$11 = [
  	"scénář",
  	"pro"
  ];
  var defineSuffix$11 = [
  ];
  var palette$11 = {
  	Motion: "Pohyb",
  	Looks: "Vzhled",
  	Sound: "Zvuk",
  	Events: "Události",
  	Control: "Ovládání",
  	Sensing: "Vnímání",
  	Operators: "Operátory",
  	Variables: "Proměnné",
  	"My Blocks": "Moje bloky"
  };
  var math$11 = [
  	"abs",
  	"zaokr. dolů",
  	"zaokr. nahoru",
  	"odmocnina",
  	"sin",
  	"cos",
  	"tg",
  	"arcsin",
  	"arccos",
  	"arctg",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$11 = {
  	"otoč se o %1 stupňů doleva": "MOTION_TURNLEFT",
  	"otoč se o %1 stupňů doprava": "MOTION_TURNRIGHT",
  	"po kliknutí na zelenou vlajku": "EVENT_WHENFLAGCLICKED",
  	konec: "scratchblocks:end"
  };
  var name$11 = "Česky";
  var percentTranslated$11 = 100;
  var cs = {
  	commands: commands$11,
  	dropdowns: dropdowns$11,
  	ignorelt: ignorelt$11,
  	soundEffects: soundEffects$11,
  	microbitWhen: microbitWhen$11,
  	osis: osis$11,
  	definePrefix: definePrefix$11,
  	defineSuffix: defineSuffix$11,
  	palette: palette$11,
  	math: math$11,
  	aliases: aliases$11,
  	name: name$11,
  	percentTranslated: percentTranslated$11
  };

  var commands$10 = {
  	MOTION_MOVESTEPS: "symud %1 cam",
  	MOTION_TURNRIGHT: "troi @turnRight %1 gradd",
  	MOTION_TURNLEFT: "troi @turnLeft %1 gradd",
  	MOTION_POINTINDIRECTION: "pwyntio i gyfeiriad %1",
  	MOTION_POINTTOWARDS: "pwyntio tuag at %1",
  	MOTION_GOTOXY: "mynd i x:%1 y: %2",
  	MOTION_GOTO: "mynd i %1",
  	MOTION_GLIDESECSTOXY: "llithro %1 eiliad i x: %2 y: %3",
  	MOTION_GLIDETO: "llithro %1 eiliad i %2",
  	MOTION_CHANGEXBY: "newid x gan %1",
  	MOTION_SETX: "gosod x i %1",
  	MOTION_CHANGEYBY: "newid y gan %1",
  	MOTION_SETY: "gosod y i %1",
  	MOTION_SETROTATIONSTYLE: "gosod steil cylchdroi %1",
  	LOOKS_SAYFORSECS: "dweud %1 am %2 eiliad",
  	LOOKS_SAY: "dweud %1",
  	LOOKS_THINKFORSECS: "meddwl %1 am %2 eiliad",
  	LOOKS_THINK: "meddwl %1",
  	LOOKS_SHOW: "dangos",
  	LOOKS_HIDE: "cuddio",
  	LOOKS_SWITCHCOSTUMETO: "newid gwisg i %1",
  	LOOKS_NEXTCOSTUME: "gwisg nesaf",
  	LOOKS_NEXTBACKDROP_BLOCK: "cefnlen nesaf",
  	LOOKS_SWITCHBACKDROPTO: "newid cefndir i %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "newid cefnlen i %1 ac aros",
  	LOOKS_CHANGEEFFECTBY: "newid effaith %1 gan %2",
  	LOOKS_SETEFFECTTO: "gosod effaith %1 effaith i %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "clirio effeithiau graffeg",
  	LOOKS_CHANGESIZEBY: "newid maint gan %1",
  	LOOKS_SETSIZETO: "gosod maint i %1 %",
  	LOOKS_GOTOFRONTBACK: "mynd i haen %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "mynd i haenau %1 %2",
  	SOUND_PLAY: "cychwyn sain %1",
  	SOUND_CHANGEEFFECTBY: "newid effaith %1 gan %2",
  	SOUND_SETEFFECTO: "gosod effaith %1 effaith i %2",
  	SOUND_CLEAREFFECTS: "clirio effeithiau sain",
  	SOUND_PLAYUNTILDONE: "chwarae sain %1 tan y diwedd",
  	SOUND_STOPALLSOUNDS: "atal pob sain",
  	"music.playDrumForBeats": "chwarae drwm %1 am %2 curiad",
  	"music.restForBeats": "oedi am %1curiad",
  	"music.playNoteForBeats": "chwarae nodyn%1am %2curiad",
  	"music.setInstrument": "gosod offeryn i %1",
  	SOUND_CHANGEVOLUMEBY: "newid uchder sain gan %1",
  	SOUND_SETVOLUMETO: "gosod lefel sain i %1%",
  	"music.changeTempo": "Newid tempo gan %1",
  	"music.setTempo": "gosod tempo %1",
  	"pen.clear": "dileu popeth",
  	"pen.stamp": "stampio",
  	"pen.penDown": "pin i lawr",
  	"pen.penUp": "pin i fyny",
  	"pen.setColor": "gosod lliw pin i %1",
  	"pen.changeHue": "newid lliw pin gan %1",
  	"pen.setColorParam": "gosod y pin %1i %2",
  	"pen.changeColorParam": "newid pin %1gan %2",
  	"pen.setHue": "gosod lliw pin i %1",
  	"pen.changeShade": "newid arlliw pin gan %1",
  	"pen.setShade": "gosod arlliw pin i %1",
  	"pen.changeSize": "newid maint pin gan %1",
  	"pen.setSize": "gosod maint pin i %1",
  	EVENT_WHENFLAGCLICKED: "pan fydd @greenFlag wedi ei glicio",
  	EVENT_WHENKEYPRESSED: "pan fo bysell %1 wedi ei wasgu",
  	EVENT_WHENTHISSPRITECLICKED: "pan gaiff y ciplun yma ei glicio",
  	EVENT_WHENSTAGECLICKED: "pan fydd llwyfan wedi ei glicio",
  	EVENT_WHENBACKDROPSWITCHESTO: "pan fydd cefndir yn newid i %1",
  	EVENT_WHENGREATERTHAN: "pan %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "pan rwy'n derbyn %1",
  	EVENT_BROADCAST: "darlledu  %1",
  	EVENT_BROADCASTANDWAIT: "darlledu %1 ac aros",
  	CONTROL_WAIT: "aros %1 eiliad",
  	CONTROL_REPEAT: "ailadrodd %1",
  	CONTROL_FOREVER: "am byth",
  	CONTROL_IF: "os %1 yna",
  	CONTROL_WAITUNTIL: "aros hyd at %1",
  	CONTROL_REPEATUNTIL: "ailadrodd hyd at %1",
  	CONTROL_STOP: "aros %1",
  	CONTROL_STARTASCLONE: "pan rwy'n dechrau fel clôn",
  	CONTROL_CREATECLONEOF: "creu clôn o %1",
  	CONTROL_DELETETHISCLONE: "dileu y clôn hwn",
  	SENSING_ASKANDWAIT: "gofyn %1 ac aros",
  	"videoSensing.videoToggle": "troi fideo %1",
  	"videoSensing.setVideoTransparency": "gosod tryloywder fideo i %1",
  	"videoSensing.whenMotionGreaterThan": "pan mae symud fideo > %1",
  	SENSING_RESETTIMER: "ailosod amserydd",
  	DATA_SETVARIABLETO: "gosod %1 i %2",
  	DATA_CHANGEVARIABLEBY: "newid %1 gan %2",
  	DATA_SHOWVARIABLE: "dangos newidyn %1",
  	DATA_HIDEVARIABLE: "cuddio newidyn %1",
  	DATA_ADDTOLIST: "ychwanegu %1 i %2",
  	DATA_DELETEOFLIST: "dileu %1 o %2",
  	DATA_DELETEALLOFLIST: "Dileu pob un o'r %1",
  	MOTION_IFONEDGEBOUNCE: "os ar ymyl, bowndio",
  	DATA_INSERTATLIST: "mewnosod %1 yn %2 o %3",
  	DATA_REPLACEITEMOFLIST: "amnewid eitem %1 o %2 gyda %3",
  	DATA_SHOWLIST: "dangos rhestr %1",
  	DATA_HIDELIST: "cuddio rhestr %1",
  	SENSING_OF_XPOSITION: "safle x",
  	SENSING_OF_YPOSITION: "safle y",
  	SENSING_OF_DIRECTION: "cyfeiriad",
  	SENSING_OF_COSTUMENUMBER: "gwisg #",
  	LOOKS_COSTUMENUMBERNAME: "gwisg %1",
  	SENSING_OF_SIZE: "maint",
  	SENSING_OF_BACKDROPNAME: "enw cefnlen",
  	LOOKS_BACKDROPNUMBERNAME: "cefnlen %1",
  	SENSING_OF_BACKDROPNUMBER: "cefnlen #",
  	SOUND_VOLUME: "lefel sain",
  	"music.getTempo": "amseriad",
  	SENSING_TOUCHINGOBJECT: "cyffwrdd %1?",
  	SENSING_TOUCHINGCOLOR: "cyffwrdd lliw %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "lliw %1 yn cyffwrdd %2?",
  	SENSING_DISTANCETO: "pellter i %1",
  	SENSING_ANSWER: "ateb",
  	SENSING_KEYPRESSED: "bysell %1 wedi ei phwyso?",
  	SENSING_MOUSEDOWN: "llygoden i lawr?",
  	SENSING_MOUSEX: "llygoden x",
  	SENSING_MOUSEY: "llygoden y",
  	SENSING_SETDRAGMODE: "gosod y modd llusgo %1",
  	SENSING_LOUDNESS: "cryfder sain",
  	"videoSensing.videoOn": "fideo %1 ar %2",
  	SENSING_TIMER: "amserydd",
  	SENSING_OF: "%1 o %2",
  	SENSING_CURRENT: "cyfredol %1",
  	SENSING_DAYSSINCE2000: "dyddiau ers 2000",
  	SENSING_USERNAME: "enw defnyddiwr",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "dewis ar hap %1 i %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 a %2",
  	OPERATORS_OR: "%1 neu %2",
  	OPERATORS_NOT: "nid %1",
  	OPERATORS_JOIN: "uno %1 %2",
  	OPERATORS_LETTEROF: "llythyren %1 o %2",
  	OPERATORS_LENGTH: "hyd %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "talgrynnu %1",
  	OPERATORS_MATHOP: "%1 o %2",
  	OPERATORS_CONTAINS: "%1 yn cynnwys %2?",
  	DATA_ITEMOFLIST: "eitem %1 o %2",
  	DATA_ITEMNUMOFLIST: "eitem # %1 yn %2",
  	DATA_LENGTHOFLIST: "hyd %1",
  	DATA_LISTCONTAINSITEM: "%1 yn cynnwys %2?",
  	CONTROL_ELSE: "fel arall",
  	SENSING_USERID: "id defnyddiwr",
  	SENSING_LOUD: "sain gref?",
  	"text2speech.speakAndWaitBlock": "siarad %1",
  	"text2speech.setVoiceBlock": "gosod llais i %1",
  	"text2speech.setLanguageBlock": "gosod iaith i %1",
  	"translate.translateBlock": "cyfieithu%1 i'r %2",
  	"translate.viewerLanguage": "iaith",
  	"makeymakey.whenKeyPressed": "pan mae %1 allwedd wedi'i phwyso",
  	"makeymakey.whenKeysPressedInOrder": "pan mae %1 wedi'i bwyso mewn trefn",
  	"microbit.whenButtonPressed": "pan mae botwm %1 yn cael ei bwyso",
  	"microbit.isButtonPressed": "botwm %1 wedi ei bwyso?",
  	"microbit.whenGesture": "pan %1",
  	"microbit.displaySymbol": "dangos %1",
  	"microbit.displayText": "dangos testun %1",
  	"microbit.clearDisplay": "clirio'r dangosydd",
  	"microbit.whenTilted": "pan mae wedi gogwyddo i'r %1",
  	"microbit.isTilted": "%1 ar ogwydd?",
  	"microbit.tiltAngle": "ongl gogwydd %1",
  	"microbit.whenPinConnected": "pan mae pin %1 wedi ei gysylltu",
  	"ev3.motorTurnClockwise": "modur %1 yn troi ffordd hyn am %2 eiliad",
  	"ev3.motorTurnCounterClockwise": "modur %1 yn troi ffordd yna am %2 eiliad",
  	"ev3.motorSetPower": "gosod pŵer modur %1 i %2 %",
  	"ev3.getMotorPosition": "safle %1modur",
  	"ev3.whenButtonPressed": "pan mae'r botwm %1yn cael ei bwyso",
  	"ev3.whenDistanceLessThan": "pan mae'r pellter < %1",
  	"ev3.whenBrightnessLessThan": "pan mae'r disgleirdeb < %1",
  	"ev3.buttonPressed": "botwm %1 wedi ei bwyso?",
  	"ev3.getDistance": "pellter",
  	"ev3.getBrightness": "disgleirdeb",
  	"ev3.beepNote": "bipio nodyn %1 am %2eiliad",
  	"wedo2.motorOn": "cychwyn %1",
  	"wedo2.motorOff": "diffodd %1",
  	"wedo2.startMotorPower": "gosod pŵer %1 i %2",
  	"wedo2.setMotorDirection": "gosod cyfeiriad %1 i %2",
  	"wedo2.whenDistance": "pam mae'r pellter %1 %2",
  	"wedo2.getDistance": "pellter",
  	"wedo2.motorOnFor": "cychwyn %1 am %2 eiliad",
  	"wedo2.setLightHue": "gosod lliw'r golau i %1",
  	"wedo2.playNoteFor": "chwarae nodyn %1 am %2 eiliad",
  	"wedo2.whenTilted": "pan mae wedi ei ogwyddo %1",
  	"wedo2.isTilted": "wedi ei ogwyddo %1?",
  	"wedo2.getTiltAngle": "ongl gogwyddo %1",
  	"gdxfor.whenGesture": "pan %1",
  	"gdxfor.whenForcePushedOrPulled": "pan mae synhwyrydd grym %1",
  	"gdxfor.getForce": "grym",
  	"gdxfor.whenTilted": "pan mae wedi gogwyddo %1",
  	"gdxfor.isTilted": "gogwyddo %1?",
  	"gdxfor.getTilt": "ongl gogwyddo %1",
  	"gdxfor.isFreeFalling": "yn syrthio?",
  	"gdxfor.getSpin": "cyflymder troelli %1",
  	"gdxfor.getAcceleration": "cyflymu %1",
  	"boost.motorOnFor": "cychwyn %1 am %2 eiliad",
  	"boost.motorOnForRotation": "cychwyn %1 am %2 troad",
  	"boost.motorOn": "cychwyn %1",
  	"boost.motorOff": "diffodd %1",
  	"boost.setMotorPower": "gosod cyflymder modur %1 i %2",
  	"boost.setMotorDirection": "gosod cyfeiriad modur %1 i %2",
  	"boost.getMotorPosition": "safle %1  modur",
  	"boost.whenColor": "pan welir bric %1",
  	"boost.seeingColor": "gweld bric %1?",
  	"boost.whenTilted": "pan mae wedi ei ogwyddo %1",
  	"boost.getTiltAngle": "ongl gogwyddo %1",
  	"boost.setLightHue": "gosod lliw'r golau i %1"
  };
  var dropdowns$10 = {
  };
  var ignorelt$10 = [
  ];
  var soundEffects$10 = [
  	"traw",
  	"troi chwith/de"
  ];
  var microbitWhen$10 = [
  	"symudodd",
  	"ysgydwyd",
  	"neidiodd"
  ];
  var osis$10 = [
  	"sgriptiau eraill yn y ciplun"
  ];
  var definePrefix$10 = [
  	"diffinio"
  ];
  var defineSuffix$10 = [
  ];
  var palette$10 = {
  	Motion: "Symudiad",
  	Looks: "Edrychiad",
  	Sound: "Sain",
  	Events: "Digwyddiadau",
  	Control: "Rheoli",
  	Sensing: "Synhwyro",
  	Operators: "Gweithredwyr",
  	Variables: "Newidynnau",
  	"My Blocks": "Fy Mlociau"
  };
  var math$10 = [
  	"abs",
  	"llawr",
  	"nenfwd",
  	"ail isradd",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"Yn",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$10 = {
  	"troi %1 gradd i'r chwith": "MOTION_TURNLEFT",
  	"troi %1 gradd i'r dde": "MOTION_TURNRIGHT",
  	"pan fo'r flag werdd yn cael ei glicio": "EVENT_WHENFLAGCLICKED",
  	diwedd: "scratchblocks:end"
  };
  var name$10 = "Cymraeg";
  var percentTranslated$10 = 100;
  var cy = {
  	commands: commands$10,
  	dropdowns: dropdowns$10,
  	ignorelt: ignorelt$10,
  	soundEffects: soundEffects$10,
  	microbitWhen: microbitWhen$10,
  	osis: osis$10,
  	definePrefix: definePrefix$10,
  	defineSuffix: defineSuffix$10,
  	palette: palette$10,
  	math: math$10,
  	aliases: aliases$10,
  	name: name$10,
  	percentTranslated: percentTranslated$10
  };

  var commands$$ = {
  	MOTION_MOVESTEPS: "gå %1 trin",
  	MOTION_TURNRIGHT: "drej @turnRight %1 grader",
  	MOTION_TURNLEFT: "drej @turnLeft %1 grader",
  	MOTION_POINTINDIRECTION: "peg i retning %1",
  	MOTION_POINTTOWARDS: "peg mod %1",
  	MOTION_GOTOXY: "gå til x: %1 y: %2",
  	MOTION_GOTO: "gå til %1",
  	MOTION_GLIDESECSTOXY: "glid %1 sekunder til x: %2 y: %3",
  	MOTION_GLIDETO: "glid %1 sekunder til %2",
  	MOTION_CHANGEXBY: "ændre x med %1",
  	MOTION_SETX: "sæt x til %1",
  	MOTION_CHANGEYBY: "ændre y med %1",
  	MOTION_SETY: "sæt y til %1",
  	MOTION_SETROTATIONSTYLE: "sæt rotationsstil til %1",
  	LOOKS_SAYFORSECS: "sig %1 i %2 sekunder",
  	LOOKS_SAY: "sig %1",
  	LOOKS_THINKFORSECS: "tænk %1 i %2 sekunder",
  	LOOKS_THINK: "tænk %1",
  	LOOKS_SHOW: "vis",
  	LOOKS_HIDE: "skjul",
  	LOOKS_SWITCHCOSTUMETO: "skift kostume til %1",
  	LOOKS_NEXTCOSTUME: "næste kostume",
  	LOOKS_NEXTBACKDROP_BLOCK: "næste baggrund",
  	LOOKS_SWITCHBACKDROPTO: "skift baggrund til %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "skift baggrund til %1 og vent",
  	LOOKS_CHANGEEFFECTBY: "ændre effekt %1 med %2",
  	LOOKS_SETEFFECTTO: "sæt effekt %1 til %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "fjern grafiske effekter",
  	LOOKS_CHANGESIZEBY: "ændre størrelse med %1",
  	LOOKS_SETSIZETO: "sæt størrelse til %1 %",
  	LOOKS_GOTOFRONTBACK: "gå til %1 lag",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "gå %2 lag %1",
  	SOUND_PLAY: "spil lyden %1",
  	SOUND_CHANGEEFFECTBY: "ændre effekt %1 med %2",
  	SOUND_SETEFFECTO: "sæt effekt %1 til %2",
  	SOUND_CLEAREFFECTS: "fjern lydeffekter",
  	SOUND_PLAYUNTILDONE: "spil lyden %1 indtil færdig",
  	SOUND_STOPALLSOUNDS: "stop al lyd",
  	"music.playDrumForBeats": "spil %1 i %2 slag",
  	"music.restForBeats": "pause i %1 slag",
  	"music.playNoteForBeats": "spil node %1 i %2 slag",
  	"music.setInstrument": "skift instrument til %1",
  	SOUND_CHANGEVOLUMEBY: "ændre lydstyrke med %1",
  	SOUND_SETVOLUMETO: "sæt lydstyrke til %1%",
  	"music.changeTempo": "ændre tempo med %1",
  	"music.setTempo": "sæt tempo til %1",
  	"pen.clear": "slet alt",
  	"pen.stamp": "stempel",
  	"pen.penDown": "pen ned",
  	"pen.penUp": "pen op",
  	"pen.setColor": "skift penfarve til %1",
  	"pen.changeHue": "ændre penfarve med %1",
  	"pen.setColorParam": "sæt pen %1 til %2",
  	"pen.changeColorParam": "ændre pen %1 med %2",
  	"pen.setHue": "sæt penfarve til %1",
  	"pen.changeShade": "ændre skyggen på pennen med %1",
  	"pen.setShade": "sæt skyggen på pennen til %1",
  	"pen.changeSize": "ændre pen størrelse med%1",
  	"pen.setSize": "sæt penstørrelse til %1",
  	EVENT_WHENFLAGCLICKED: "når der klikkes på @greenFlag",
  	EVENT_WHENKEYPRESSED: "når du trykker på %1",
  	EVENT_WHENTHISSPRITECLICKED: "når denne sprite klikkes",
  	EVENT_WHENSTAGECLICKED: "når scene er valgt",
  	EVENT_WHENBACKDROPSWITCHESTO: "når baggrund skifter til %1",
  	EVENT_WHENGREATERTHAN: "når %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "når jeg modtager %1",
  	EVENT_BROADCAST: "send %1",
  	EVENT_BROADCASTANDWAIT: "send %1 og vent",
  	CONTROL_WAIT: "vent %1 sekunder",
  	CONTROL_REPEAT: "gentag %1 gange",
  	CONTROL_FOREVER: "for evigt",
  	CONTROL_IF: "hvis %1 så",
  	CONTROL_WAITUNTIL: "vent indtil %1",
  	CONTROL_REPEATUNTIL: "gentag indtil %1",
  	CONTROL_STOP: "stop %1",
  	CONTROL_STARTASCLONE: "når jeg starter som klon",
  	CONTROL_CREATECLONEOF: "opret en klon af %1",
  	CONTROL_DELETETHISCLONE: "slet denne klon",
  	SENSING_ASKANDWAIT: "bed om %1 og vent",
  	"videoSensing.videoToggle": "video %1",
  	"videoSensing.setVideoTransparency": "sæt video gennemsigtighed til %1",
  	"videoSensing.whenMotionGreaterThan": "når video bevægelse > %1",
  	SENSING_RESETTIMER: "nulstil stopur",
  	DATA_SETVARIABLETO: "sæt %1 til %2",
  	DATA_CHANGEVARIABLEBY: "ændre %1 med %2",
  	DATA_SHOWVARIABLE: "vis variabel %1",
  	DATA_HIDEVARIABLE: "skjul variabel %1",
  	DATA_ADDTOLIST: "tilføj %1 til %2",
  	DATA_DELETEOFLIST: "slet %1 af %2",
  	DATA_DELETEALLOFLIST: "slet alle %1",
  	MOTION_IFONEDGEBOUNCE: "hop tilbage ved kanten",
  	DATA_INSERTATLIST: "indsæt %1 ved %2 af %3",
  	DATA_REPLACEITEMOFLIST: "erstat nummer %1 af %2 med %3",
  	DATA_SHOWLIST: "vis liste %1",
  	DATA_HIDELIST: "skjul liste %1",
  	SENSING_OF_XPOSITION: "x position",
  	SENSING_OF_YPOSITION: "y position",
  	SENSING_OF_DIRECTION: "retning",
  	SENSING_OF_COSTUMENUMBER: "kostume #",
  	LOOKS_COSTUMENUMBERNAME: "kostume %1",
  	SENSING_OF_SIZE: "størrelse",
  	SENSING_OF_BACKDROPNAME: "navn på baggrund",
  	LOOKS_BACKDROPNUMBERNAME: "baggrund %1",
  	SENSING_OF_BACKDROPNUMBER: "baggrund #",
  	SOUND_VOLUME: "lydstyrke",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "berører %1?",
  	SENSING_TOUCHINGCOLOR: "berører farven %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "berører %1 farven %2?",
  	SENSING_DISTANCETO: "afstand til %1",
  	SENSING_ANSWER: "svar",
  	SENSING_KEYPRESSED: "trykket på tasten %1?",
  	SENSING_MOUSEDOWN: "trykket på musen?",
  	SENSING_MOUSEX: "musens x-position",
  	SENSING_MOUSEY: "musens y-position",
  	SENSING_SETDRAGMODE: "sæt flytbarhed til %1",
  	SENSING_LOUDNESS: "lydstyrke",
  	"videoSensing.videoOn": "video %1 på %2",
  	SENSING_TIMER: "stopur",
  	SENSING_OF: "%1 af %2",
  	SENSING_CURRENT: "nuværende %1",
  	SENSING_DAYSSINCE2000: "dage siden 2000",
  	SENSING_USERNAME: "brugernavn",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "vælg tilfældigt mellem %1 og %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 og %2",
  	OPERATORS_OR: "%1 eller %2",
  	OPERATORS_NOT: "ikke %1",
  	OPERATORS_JOIN: "%1 tilkobles %2",
  	OPERATORS_LETTEROF: "tegn %1 af %2",
  	OPERATORS_LENGTH: "længden af %1",
  	OPERATORS_MOD: "%1 modulo %2",
  	OPERATORS_ROUND: "afrund %1",
  	OPERATORS_MATHOP: "%1 af %2",
  	OPERATORS_CONTAINS: "%1 indeholder %2?",
  	DATA_ITEMOFLIST: "nummer %1 af %2",
  	DATA_ITEMNUMOFLIST: "nummer # af %1 i %2",
  	DATA_LENGTHOFLIST: "længden af %1",
  	DATA_LISTCONTAINSITEM: "%1 indeholder %2?",
  	CONTROL_ELSE: "ellers",
  	SENSING_USERID: "bruger id",
  	SENSING_LOUD: "højt?",
  	"text2speech.speakAndWaitBlock": "sig %1",
  	"text2speech.setVoiceBlock": "indstil stemme til %1",
  	"text2speech.setLanguageBlock": "sæt sprog til %1",
  	"translate.translateBlock": "oversæt %1 til %2",
  	"translate.viewerLanguage": "sprog",
  	"makeymakey.whenKeyPressed": "når %1 tast er trykket",
  	"makeymakey.whenKeysPressedInOrder": "når %1 er trykket i rækkefølge",
  	"microbit.whenButtonPressed": "tryksensor %1 trykket ind",
  	"microbit.isButtonPressed": "%1 knap trykket?",
  	"microbit.whenGesture": "når %1",
  	"microbit.displaySymbol": "vis %1",
  	"microbit.displayText": "vis tekst %1",
  	"microbit.clearDisplay": "ryd display",
  	"microbit.whenTilted": "er vippet %1",
  	"microbit.isTilted": "vippet %1?",
  	"microbit.tiltAngle": "vippet %1",
  	"microbit.whenPinConnected": "når pin %1 er forbundet",
  	"ev3.motorTurnClockwise": "motor %1 drej en vej i %2 sekunder",
  	"ev3.motorTurnCounterClockwise": "motor %1 drej anden vej i %2 sekunder",
  	"ev3.motorSetPower": "motor %1 indstil styrke  %2 %",
  	"ev3.getMotorPosition": "motor %1 position",
  	"ev3.whenButtonPressed": "tryksensor %1 trykket ind",
  	"ev3.whenDistanceLessThan": "når afstanden  < %1",
  	"ev3.whenBrightnessLessThan": "når lysstyrke < %1",
  	"ev3.buttonPressed": "tryksensor %1 trykket ind?",
  	"ev3.getDistance": "afstand",
  	"ev3.getBrightness": "lysstyrke",
  	"ev3.beepNote": "spil tone %1 i %2 sekunder",
  	"wedo2.motorOn": "tænd %1",
  	"wedo2.motorOff": "sluk %1",
  	"wedo2.startMotorPower": "sæt %1 styrke til %2",
  	"wedo2.setMotorDirection": "sæt %1 retning til %2",
  	"wedo2.whenDistance": "når afstanden %1 %2",
  	"wedo2.getDistance": "afstand",
  	"wedo2.motorOnFor": "tænd %1 i %2 sekunder",
  	"wedo2.setLightHue": "sæt farven på lyset til %1",
  	"wedo2.playNoteFor": "spil node %1 i %2 sekunder",
  	"wedo2.whenTilted": "er vippet %1",
  	"wedo2.isTilted": "vippet %1?",
  	"wedo2.getTiltAngle": "vippet vinkel %1",
  	"gdxfor.whenGesture": "når %1",
  	"gdxfor.whenForcePushedOrPulled": "når kraft sensor %1",
  	"gdxfor.getForce": "kraft",
  	"gdxfor.whenTilted": "når vippet %1",
  	"gdxfor.isTilted": "vippet %1?",
  	"gdxfor.getTilt": "vippet vinkel %1",
  	"gdxfor.isFreeFalling": "falder?",
  	"gdxfor.getSpin": "spin hastighed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "tænd motor %1 i %2 sekunder",
  	"boost.motorOnForRotation": "tænd motor %1 i %2 rotationer",
  	"boost.motorOn": "tænd motor %1",
  	"boost.motorOff": "sluk motor %1",
  	"boost.setMotorPower": "sæt motor %1 hastighed til %2 %",
  	"boost.setMotorDirection": "sæt motor %1 retning til %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "når %1 brikken ses",
  	"boost.seeingColor": "ser %1 brik?",
  	"boost.whenTilted": "er vippet %1",
  	"boost.getTiltAngle": "vippet vinkel %1",
  	"boost.setLightHue": "sæt farven på lyset til %1"
  };
  var dropdowns$$ = {
  };
  var ignorelt$$ = [
  ];
  var soundEffects$$ = [
  	"tonehøjde",
  	"balance venstre/højre"
  ];
  var microbitWhen$$ = [
  	"bevæget",
  	"rystet",
  	"hoppet"
  ];
  var osis$$ = [
  	"andre scripts i sprite"
  ];
  var definePrefix$$ = [
  	"definer"
  ];
  var defineSuffix$$ = [
  ];
  var palette$$ = {
  	Motion: "Bevægelse",
  	Looks: "Udseende",
  	Sound: "Lyd",
  	Events: "Hændelser",
  	Control: "Kontrol",
  	Sensing: "Registrering",
  	Operators: "Operatorer",
  	Variables: "Variabler",
  	"My Blocks": "Mine brikker"
  };
  var math$$ = [
  	"abs",
  	"rund ned",
  	"rund op",
  	"kvrod",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$$ = {
  };
  var name$$ = "Dansk";
  var percentTranslated$$ = 100;
  var da = {
  	commands: commands$$,
  	dropdowns: dropdowns$$,
  	ignorelt: ignorelt$$,
  	soundEffects: soundEffects$$,
  	microbitWhen: microbitWhen$$,
  	osis: osis$$,
  	definePrefix: definePrefix$$,
  	defineSuffix: defineSuffix$$,
  	palette: palette$$,
  	math: math$$,
  	aliases: aliases$$,
  	name: name$$,
  	percentTranslated: percentTranslated$$
  };

  var commands$_ = {
  	MOTION_MOVESTEPS: "gehe %1 er Schritt",
  	MOTION_TURNRIGHT: "drehe dich @turnRight um %1 Grad",
  	MOTION_TURNLEFT: "drehe dich @turnLeft um %1 Grad",
  	MOTION_POINTINDIRECTION: "setze Richtung auf %1 Grad",
  	MOTION_POINTTOWARDS: "drehe dich zu %1",
  	MOTION_GOTOXY: "gehe zu x: %1 y: %2",
  	MOTION_GOTO: "gehe zu %1",
  	MOTION_GLIDESECSTOXY: "gleite in %1 Sek. zu x:%2  y:%3",
  	MOTION_GLIDETO: "gleite in %1 Sek. zu %2",
  	MOTION_CHANGEXBY: "ändere x um %1",
  	MOTION_SETX: "setze x auf %1",
  	MOTION_CHANGEYBY: "ändere y um %1",
  	MOTION_SETY: "setze y auf %1",
  	MOTION_SETROTATIONSTYLE: "setze Drehtyp auf %1",
  	LOOKS_SAYFORSECS: "sage %1 für %2 Sekunden",
  	LOOKS_SAY: "sage %1",
  	LOOKS_THINKFORSECS: "denke %1 für %2 Sekunden",
  	LOOKS_THINK: "denke %1",
  	LOOKS_SHOW: "zeige dich",
  	LOOKS_HIDE: "verstecke dich",
  	LOOKS_SWITCHCOSTUMETO: "wechsle zu Kostüm %1",
  	LOOKS_NEXTCOSTUME: "wechsle zum nächsten Kostüm",
  	LOOKS_NEXTBACKDROP_BLOCK: "wechsle zum nächsten Bühnenbild",
  	LOOKS_SWITCHBACKDROPTO: "wechsle zu Bühnenbild %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "wechsle zu Bühnenbild %1 und warte",
  	LOOKS_CHANGEEFFECTBY: "ändere Effekt %1 um %2",
  	LOOKS_SETEFFECTTO: "setze Effekt %1 auf %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "schalte Grafikeffekte aus",
  	LOOKS_CHANGESIZEBY: "ändere Größe um %1",
  	LOOKS_SETSIZETO: "setze Größe auf %1",
  	LOOKS_GOTOFRONTBACK: "gehe zu %1 Ebene",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "gehe %2 Ebenen %1",
  	SOUND_PLAY: "spiele Klang %1",
  	SOUND_CHANGEEFFECTBY: "ändere Effekt %1 um %2",
  	SOUND_SETEFFECTO: "setze Effekt %1 auf %2",
  	SOUND_CLEAREFFECTS: "schalte Klangeffekte aus",
  	SOUND_PLAYUNTILDONE: "spiele Klang %1 ganz",
  	SOUND_STOPALLSOUNDS: "stoppe alle Klänge",
  	"music.playDrumForBeats": "spiele Schlaginstrument %1 für %2 Schläge",
  	"music.restForBeats": "pausiere %1 Schläge",
  	"music.playNoteForBeats": "spiele Ton %1 für %2 Schläge",
  	"music.setInstrument": "setze Instrument auf %1",
  	SOUND_CHANGEVOLUMEBY: "ändere Lautstärke um %1",
  	SOUND_SETVOLUMETO: "setze Lautstärke auf %1%",
  	"music.changeTempo": "ändere Tempo um %1",
  	"music.setTempo": "setze Tempo auf %1",
  	"pen.clear": "lösche alles",
  	"pen.stamp": "hinterlasse Abdruck",
  	"pen.penDown": "schalte Stift ein",
  	"pen.penUp": "schalte Stift aus",
  	"pen.setColor": "setze Stiftfarbe auf %1",
  	"pen.changeHue": "ändere Stiftfarbe um %1",
  	"pen.setColorParam": "setze Stift %1 auf %2",
  	"pen.changeColorParam": "ändere Stift %1 um %2",
  	"pen.setHue": "setze Stiftfarbe auf %1",
  	"pen.changeShade": "ändere Farbstärke um %1",
  	"pen.setShade": "setze Farbstärke auf %1",
  	"pen.changeSize": "ändere Stiftdicke um %1",
  	"pen.setSize": "setze Stiftdicke auf %1",
  	EVENT_WHENFLAGCLICKED: "Wenn @greenFlag angeklickt wird",
  	EVENT_WHENKEYPRESSED: "Wenn Taste %1 gedrückt wird",
  	EVENT_WHENTHISSPRITECLICKED: "Wenn diese Figur angeklickt wird",
  	EVENT_WHENSTAGECLICKED: "Wenn die Bühne angeklickt wird",
  	EVENT_WHENBACKDROPSWITCHESTO: "Wenn das Bühnenbild zu %1 wechselt",
  	EVENT_WHENGREATERTHAN: "Wenn %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "Wenn ich %1 empfange",
  	EVENT_BROADCAST: "sende %1 an alle",
  	EVENT_BROADCASTANDWAIT: "sende %1 an alle und warte",
  	CONTROL_WAIT: "warte %1 Sekunden",
  	CONTROL_REPEAT: "wiederhole %1 mal",
  	CONTROL_FOREVER: "wiederhole fortlaufend",
  	CONTROL_IF: "falls %1, dann",
  	CONTROL_WAITUNTIL: "warte bis %1",
  	CONTROL_REPEATUNTIL: "wiederhole bis %1",
  	CONTROL_STOP: "stoppe %1",
  	CONTROL_STARTASCLONE: "Wenn ich als Klon entstehe",
  	CONTROL_CREATECLONEOF: "erzeuge Klon von %1",
  	CONTROL_DELETETHISCLONE: "lösche diesen Klon",
  	SENSING_ASKANDWAIT: "frage %1 und warte",
  	"videoSensing.videoToggle": "schalte Video %1",
  	"videoSensing.setVideoTransparency": "setze Video-Transparenz auf %1",
  	"videoSensing.whenMotionGreaterThan": "Wenn Video-Bewegung > %1",
  	SENSING_RESETTIMER: "setze Stoppuhr zurück",
  	DATA_SETVARIABLETO: "setze %1 auf %2",
  	DATA_CHANGEVARIABLEBY: "ändere %1 um %2",
  	DATA_SHOWVARIABLE: "zeige Variable %1",
  	DATA_HIDEVARIABLE: "verstecke Variable %1",
  	DATA_ADDTOLIST: "füge %1 zu %2 hinzu",
  	DATA_DELETEOFLIST: "lösche %1 aus %2",
  	DATA_DELETEALLOFLIST: "lösche alles aus %1",
  	MOTION_IFONEDGEBOUNCE: "pralle vom Rand ab",
  	DATA_INSERTATLIST: "füge %1 bei %2 in %3 ein",
  	DATA_REPLACEITEMOFLIST: "ersetze Element %1 von %2 durch %3",
  	DATA_SHOWLIST: "zeige Liste %1",
  	DATA_HIDELIST: "verstecke Liste %1",
  	SENSING_OF_XPOSITION: "x-Position",
  	SENSING_OF_YPOSITION: "y-Position",
  	SENSING_OF_DIRECTION: "Richtung",
  	SENSING_OF_COSTUMENUMBER: "Kostümnummer",
  	LOOKS_COSTUMENUMBERNAME: "Kostüm %1",
  	SENSING_OF_SIZE: "Größe",
  	SENSING_OF_BACKDROPNAME: "Bühnenbildname",
  	LOOKS_BACKDROPNUMBERNAME: "Bühnenbild %1",
  	SENSING_OF_BACKDROPNUMBER: "Bühnenbildnummer",
  	SOUND_VOLUME: "Lautstärke",
  	"music.getTempo": "Tempo",
  	SENSING_TOUCHINGOBJECT: "wird %1 berührt?",
  	SENSING_TOUCHINGCOLOR: "wird Farbe %1 berührt?",
  	SENSING_COLORISTOUCHINGCOLOR: "Farbe %1 berührt %2?",
  	SENSING_DISTANCETO: "Entfernung von %1",
  	SENSING_ANSWER: "Antwort",
  	SENSING_KEYPRESSED: "Taste %1 gedrückt?",
  	SENSING_MOUSEDOWN: "Maustaste gedrückt?",
  	SENSING_MOUSEX: "Maus x-Position",
  	SENSING_MOUSEY: "Maus y-Position",
  	SENSING_SETDRAGMODE: "setze Ziehbarkeit auf %1",
  	SENSING_LOUDNESS: "Lautstärke",
  	"videoSensing.videoOn": "Video-%1 von %2",
  	SENSING_TIMER: "Stoppuhr",
  	SENSING_OF: "%1 von %2",
  	SENSING_CURRENT: "%1 im Moment",
  	SENSING_DAYSSINCE2000: "Tage seit 2000",
  	SENSING_USERNAME: "Benutzername",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "Zufallszahl von %1 bis %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 und %2",
  	OPERATORS_OR: "%1 oder %2",
  	OPERATORS_NOT: "nicht %1",
  	OPERATORS_JOIN: "verbinde %1 und %2",
  	OPERATORS_LETTEROF: "Zeichen %1 von %2",
  	OPERATORS_LENGTH: "Länge von %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "%1 gerundet",
  	OPERATORS_MATHOP: "%1 von %2",
  	OPERATORS_CONTAINS: "%1 enthält %2?",
  	DATA_ITEMOFLIST: "Element %1 von %2",
  	DATA_ITEMNUMOFLIST: "Nummer von %1 in %2",
  	DATA_LENGTHOFLIST: "Länge von %1",
  	DATA_LISTCONTAINSITEM: "%1 enthält %2?",
  	CONTROL_ELSE: "sonst",
  	SENSING_USERID: "Benutzer-ID",
  	SENSING_LOUD: "laut?",
  	"text2speech.speakAndWaitBlock": "sage %1",
  	"text2speech.setVoiceBlock": "ändere die Stimme zu %1",
  	"text2speech.setLanguageBlock": "setze Sprache auf %1",
  	"translate.translateBlock": "übersetze %1 nach %2",
  	"translate.viewerLanguage": "Sprache",
  	"makeymakey.whenKeyPressed": "Wenn Taste %1 gedrückt",
  	"makeymakey.whenKeysPressedInOrder": "Wenn %1 der Reihe nach gedrückt",
  	"microbit.whenButtonPressed": "Wenn Knopf %1gedrückt wird",
  	"microbit.isButtonPressed": "Knopf %1 gedrückt?",
  	"microbit.whenGesture": "Wenn %1",
  	"microbit.displaySymbol": "zeige %1 an",
  	"microbit.displayText": "zeige Text %1 an",
  	"microbit.clearDisplay": "zeige nichts an",
  	"microbit.whenTilted": "Wenn %1 geneigt",
  	"microbit.isTilted": "%1 geneigt?",
  	"microbit.tiltAngle": "Neigungswinkel %1",
  	"microbit.whenPinConnected": "Wenn Pin %1 angeschlossen ist",
  	"ev3.motorTurnClockwise": "drehe Motor %1 für %2Sekunden rechtsherum",
  	"ev3.motorTurnCounterClockwise": "drehe Motor %1für %2Sekunden linksherum",
  	"ev3.motorSetPower": "setze Leistung von Motor %1 auf %2%",
  	"ev3.getMotorPosition": "Position von Motor %1",
  	"ev3.whenButtonPressed": "Wenn der Knopf %1 gedrückt wird",
  	"ev3.whenDistanceLessThan": "Wenn Abstand < %1",
  	"ev3.whenBrightnessLessThan": "Wenn Helligkeit < %1",
  	"ev3.buttonPressed": "Knopf %1 gedrückt?",
  	"ev3.getDistance": "Abstand",
  	"ev3.getBrightness": "Helligkeit",
  	"ev3.beepNote": "piepse Note %1 für %2 Sek.",
  	"wedo2.motorOn": "schalte %1 an",
  	"wedo2.motorOff": "schalte %1 aus",
  	"wedo2.startMotorPower": "setze Leistung von %1 auf %2",
  	"wedo2.setMotorDirection": "setze Richtung von %1 auf %2",
  	"wedo2.whenDistance": "Wenn Abstand %1 %2",
  	"wedo2.getDistance": "Abstand",
  	"wedo2.motorOnFor": "schalte %1 für %2 Sekunden an",
  	"wedo2.setLightHue": "setze Lichtfarbe auf %1",
  	"wedo2.playNoteFor": "spiele Note %1 für %2 Sekunden",
  	"wedo2.whenTilted": "Wenn %1 geneigt",
  	"wedo2.isTilted": "%1 geneigt?",
  	"wedo2.getTiltAngle": "Neigungswinkel %1",
  	"gdxfor.whenGesture": "Wenn %1",
  	"gdxfor.whenForcePushedOrPulled": "Wenn Kraftsensor %1",
  	"gdxfor.getForce": "Kraft",
  	"gdxfor.whenTilted": "Wenn geneigt %1",
  	"gdxfor.isTilted": "geneigt %1?",
  	"gdxfor.getTilt": "Neigungswinkel %1",
  	"gdxfor.isFreeFalling": "fallend?",
  	"gdxfor.getSpin": "Rotationsgeschwindigkeit %1",
  	"gdxfor.getAcceleration": "Beschleunigung %1",
  	"boost.motorOnFor": "Schalte Motor %1 für %2 Sekunden ein",
  	"boost.motorOnForRotation": "Schalte Motor %1 für %2 Umdrehungen ein",
  	"boost.motorOn": "Schalte Motor %1 ein",
  	"boost.motorOff": "Schalte Motor %1 aus",
  	"boost.setMotorPower": "Setze von Motor %1 die Geschwindigkeit auf %2%",
  	"boost.setMotorDirection": "Setze Richtung von Motor %1 auf %2",
  	"boost.getMotorPosition": "Position des Motors %1",
  	"boost.whenColor": "Wenn %1 gesehen wird",
  	"boost.seeingColor": "Sehe Farbe %1?",
  	"boost.whenTilted": "Wenn %1 geneigt",
  	"boost.getTiltAngle": "Neigungswinkel %1",
  	"boost.setLightHue": "setze Lichtfarbe auf %1"
  };
  var dropdowns$_ = {
  };
  var ignorelt$_ = [
  ];
  var soundEffects$_ = [
  	"Höhe",
  	"Aussteuern links/rechts"
  ];
  var microbitWhen$_ = [
  	"bewegt",
  	"geschüttelt",
  	"hochgehüpft"
  ];
  var osis$_ = [
  	"andere Skripte der Figur"
  ];
  var definePrefix$_ = [
  	"Definiere"
  ];
  var defineSuffix$_ = [
  ];
  var palette$_ = {
  	Motion: "Bewegung",
  	Looks: "Aussehen",
  	Sound: "Klang",
  	Events: "Ereignisse",
  	Control: "Steuerung",
  	Sensing: "Fühlen",
  	Operators: "Operatoren",
  	Variables: "Variablen",
  	"My Blocks": "Meine Blöcke"
  };
  var math$_ = [
  	"Betrag",
  	"abrunden",
  	"aufrunden",
  	"Wurzel",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e^",
  	"10^"
  ];
  var aliases$_ = {
  	"drehe dich nach links um %1 Grad": "MOTION_TURNLEFT",
  	"drehe dich nach rechts um %1 Grad": "MOTION_TURNRIGHT",
  	"Wenn die grüne Flagge angeklickt": "EVENT_WHENFLAGCLICKED",
  	Ende: "scratchblocks:end"
  };
  var name$_ = "Deutsch";
  var percentTranslated$_ = 100;
  var de = {
  	commands: commands$_,
  	dropdowns: dropdowns$_,
  	ignorelt: ignorelt$_,
  	soundEffects: soundEffects$_,
  	microbitWhen: microbitWhen$_,
  	osis: osis$_,
  	definePrefix: definePrefix$_,
  	defineSuffix: defineSuffix$_,
  	palette: palette$_,
  	math: math$_,
  	aliases: aliases$_,
  	name: name$_,
  	percentTranslated: percentTranslated$_
  };

  var commands$Z = {
  	MOTION_MOVESTEPS: "κινήσου %1 βήματα",
  	MOTION_TURNRIGHT: "στρίψε @turnRight %1 μοίρες",
  	MOTION_TURNLEFT: "στρίψε @turnLeft %1 μοίρες",
  	MOTION_POINTINDIRECTION: "δείξε προς κατεύθυνση %1",
  	MOTION_POINTTOWARDS: "δείξε προς %1",
  	MOTION_GOTOXY: "πήγαινε σε θέση x: %1 y: %2",
  	MOTION_GOTO: "πήγαινε σε %1",
  	MOTION_GLIDESECSTOXY: "ολίσθησε για %1 δευτ. στη θέση x: %2 y: %3",
  	MOTION_GLIDETO: "ολίσθησε για %1 δευτ. στη θέση %2",
  	MOTION_CHANGEXBY: "άλλαξε x κατά %1",
  	MOTION_SETX: "όρισε x σε %1",
  	MOTION_CHANGEYBY: "άλλαξε y κατά %1",
  	MOTION_SETY: "όρισε y σε %1",
  	MOTION_SETROTATIONSTYLE: "όρισε τρόπο περιστροφής %1",
  	LOOKS_SAYFORSECS: "πες %1 για %2 δευτερόλεπτα",
  	LOOKS_SAY: "πες %1",
  	LOOKS_THINKFORSECS: "σκέψου %1 για %2 δευτερόλεπτα",
  	LOOKS_THINK: "σκέψου %1",
  	LOOKS_SHOW: "εμφανίσου",
  	LOOKS_HIDE: "εξαφανίσου",
  	LOOKS_SWITCHCOSTUMETO: "άλλαξε ενδυμασία σε %1",
  	LOOKS_NEXTCOSTUME: "επόμενη ενδυμασία",
  	LOOKS_NEXTBACKDROP_BLOCK: "επόμενο υπόβαθρο",
  	LOOKS_SWITCHBACKDROPTO: "άλλαξε υπόβαθρο σε %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "άλλαξε υπόβαθρο σε %1 και περίμενε",
  	LOOKS_CHANGEEFFECTBY: "άλλαξε εφέ %1 κατά %2",
  	LOOKS_SETEFFECTTO: "όρισε εφέ %1 σε %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "επανάφερε εφέ γραφικών",
  	LOOKS_CHANGESIZEBY: "άλλαξε μέγεθος κατά %1",
  	LOOKS_SETSIZETO: "όρισε μέγεθος σε %1 %",
  	LOOKS_GOTOFRONTBACK: "πήγαινε σε επίπεδο %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "πήγαινε %1 %2 επίπεδα",
  	SOUND_PLAY: "παίξε τον ήχο %1",
  	SOUND_CHANGEEFFECTBY: "άλλαξε εφέ %1 κατά %2",
  	SOUND_SETEFFECTO: "όρισε εφέ %1 σε %2",
  	SOUND_CLEAREFFECTS: "καθάρισε ηχητικά εφέ",
  	SOUND_PLAYUNTILDONE: "παίξε ήχο %1 μέχρι τέλους",
  	SOUND_STOPALLSOUNDS: "σταμάτησε όλους τους ήχους",
  	"music.playDrumForBeats": "παίξε τύμπανο %1 για %2 χτύπους",
  	"music.restForBeats": "κάνε παύση για %1 χτύπους",
  	"music.playNoteForBeats": "παίξε νότα %1 για %2 χτύπους",
  	"music.setInstrument": "όρισε όργανο σε %1",
  	SOUND_CHANGEVOLUMEBY: "άλλαξε ένταση κατά %1",
  	SOUND_SETVOLUMETO: "όρισε ένταση σε %1%",
  	"music.changeTempo": "άλλαξε ρυθμό κατά %1",
  	"music.setTempo": "όρισε ρυθμό σε %1",
  	"pen.clear": "καθάρισε όλα",
  	"pen.stamp": "σφραγίδα",
  	"pen.penDown": "κατέβασε πένα",
  	"pen.penUp": "σήκωσε πένα",
  	"pen.setColor": "όρισε χρώμα πένας σε %1",
  	"pen.changeHue": "άλλαξε χρώμα πένας κατά %1",
  	"pen.setColorParam": "όρισε %1 πένας σε %2",
  	"pen.changeColorParam": "άλλαξε %1 πένας κατά %2",
  	"pen.setHue": "όρισε χρώμα πένας σε %1",
  	"pen.changeShade": "άλλαξε σκιά πένας κατά %1",
  	"pen.setShade": "όρισε σκιά πένας σε %1",
  	"pen.changeSize": "άλλαξε μέγεθος πένας κατά %1",
  	"pen.setSize": "όρισε μέγεθος πένας σε %1",
  	EVENT_WHENFLAGCLICKED: "όταν γίνει κλικ σε @greenFlag",
  	EVENT_WHENKEYPRESSED: "όταν πατηθεί πλήκτρο %1",
  	EVENT_WHENTHISSPRITECLICKED: "όταν γίνει κλικ σε αυτό το αντικείμενο",
  	EVENT_WHENSTAGECLICKED: "όταν γίνει κλικ στη σκηνή",
  	EVENT_WHENBACKDROPSWITCHESTO: "όταν το υπόβαθρο αλλάξει σε %1",
  	EVENT_WHENGREATERTHAN: "όταν %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "όταν λάβω %1",
  	EVENT_BROADCAST: "μετάδωσε %1",
  	EVENT_BROADCASTANDWAIT: "μετάδωσε %1 και περίμενε",
  	CONTROL_WAIT: "περίμενε %1 δευτερόλεπτα",
  	CONTROL_REPEAT: "επανάλαβε %1",
  	CONTROL_FOREVER: "για πάντα",
  	CONTROL_IF: "εάν %1 τότε",
  	CONTROL_WAITUNTIL: "περίμενε ώσπου %1",
  	CONTROL_REPEATUNTIL: "επανάλαβε ώσπου %1",
  	CONTROL_STOP: "σταμάτησε %1",
  	CONTROL_STARTASCLONE: "όταν ξεκινήσω ως κλώνος",
  	CONTROL_CREATECLONEOF: "δημιούργησε κλώνο του %1",
  	CONTROL_DELETETHISCLONE: "διάγραψε αυτόν τον κλώνο",
  	SENSING_ASKANDWAIT: "ρώτησε %1 και περίμενε",
  	"videoSensing.videoToggle": "βίντεο %1",
  	"videoSensing.setVideoTransparency": "όρισε διαφάνεια βίντεο σε %1",
  	"videoSensing.whenMotionGreaterThan": "όταν κίνηση βίντεο > %1",
  	SENSING_RESETTIMER: "μηδένισε χρονόμετρο",
  	DATA_SETVARIABLETO: "όρισε %1 σε %2",
  	DATA_CHANGEVARIABLEBY: "άλλαξε %1 κατά %2",
  	DATA_SHOWVARIABLE: "εμφάνισε μεταβλητή %1",
  	DATA_HIDEVARIABLE: "απόκρυψε μεταβλητή %1",
  	DATA_ADDTOLIST: "πρόσθεσε %1 στη λίστα %2",
  	DATA_DELETEOFLIST: "διάγραψε %1 από λίστα %2",
  	DATA_DELETEALLOFLIST: "διαγραφή όλων από λίστα %1",
  	MOTION_IFONEDGEBOUNCE: "εάν σε όριο, αναπήδησε",
  	DATA_INSERTATLIST: "βάλε %1 στη θέση %2 λίστας %3",
  	DATA_REPLACEITEMOFLIST: "αντικατάστησε στοιχείο %1 λίστας %2 με %3",
  	DATA_SHOWLIST: "εμφάνισε λίστα %1",
  	DATA_HIDELIST: "απόκρυψε λίστα %1",
  	SENSING_OF_XPOSITION: "θέση x",
  	SENSING_OF_YPOSITION: "θέση y",
  	SENSING_OF_DIRECTION: "κατεύθυνση",
  	SENSING_OF_COSTUMENUMBER: "# ενδυμασίας",
  	LOOKS_COSTUMENUMBERNAME: "ενδυμασία %1",
  	SENSING_OF_SIZE: "μέγεθος",
  	SENSING_OF_BACKDROPNAME: "όνομα υποβάθρου",
  	LOOKS_BACKDROPNUMBERNAME: "υπόβαθρο %1",
  	SENSING_OF_BACKDROPNUMBER: "# υποβάθρου",
  	SOUND_VOLUME: "ένταση",
  	"music.getTempo": "ρυθμός",
  	SENSING_TOUCHINGOBJECT: "αγγίζει %1;",
  	SENSING_TOUCHINGCOLOR: "αγγίζει χρώμα %1;",
  	SENSING_COLORISTOUCHINGCOLOR: "χρώμα %1 αγγίζει χρώμα %2;",
  	SENSING_DISTANCETO: "απόσταση έως %1",
  	SENSING_ANSWER: "απάντηση",
  	SENSING_KEYPRESSED: "πατήθηκε πλήκτρο %1;",
  	SENSING_MOUSEDOWN: "πατήθηκε πλήκτρο ποντικιού;",
  	SENSING_MOUSEX: "x ποντικιού",
  	SENSING_MOUSEY: "y ποντικιού",
  	SENSING_SETDRAGMODE: "όρισε τρόπο συρσίματος %1",
  	SENSING_LOUDNESS: "ένταση",
  	"videoSensing.videoOn": "βίντεο %1 για %2",
  	SENSING_TIMER: "χρονόμετρο",
  	SENSING_OF: "%1 από %2",
  	SENSING_CURRENT: "τρέχων %1",
  	SENSING_DAYSSINCE2000: "ημέρες από το 2000",
  	SENSING_USERNAME: "όνομα χρήστη",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "επίλεξε τυχαίο %1 εώς %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 και %2",
  	OPERATORS_OR: "%1 ή %2",
  	OPERATORS_NOT: "όχι %1",
  	OPERATORS_JOIN: "ένωσε %1 %2",
  	OPERATORS_LETTEROF: "γράμμα %1 του %2",
  	OPERATORS_LENGTH: "μήκος του %1",
  	OPERATORS_MOD: "ακέρ. υπόλ. %1 δια %2",
  	OPERATORS_ROUND: "στρογγυλ. %1",
  	OPERATORS_MATHOP: "%1 %2",
  	OPERATORS_CONTAINS: "%1 περιλαμβάνει %2;",
  	DATA_ITEMOFLIST: "στοιχείο %1 λίστας %2",
  	DATA_ITEMNUMOFLIST: "# στοιχείου %1 σε %2",
  	DATA_LENGTHOFLIST: "μήκος λίστας %1",
  	DATA_LISTCONTAINSITEM: "%1 περιέχει %2;",
  	CONTROL_ELSE: "αλλιώς",
  	SENSING_USERID: "αναγνωριστικό χρήστη",
  	SENSING_LOUD: "δυνατά;",
  	"text2speech.speakAndWaitBlock": "μίλησε %1",
  	"text2speech.setVoiceBlock": "όρισε φωνή σε %1",
  	"text2speech.setLanguageBlock": "όρισε γλώσσα σε %1",
  	"translate.translateBlock": "μετάφρασε %1 σε %2",
  	"translate.viewerLanguage": "γλώσσα",
  	"makeymakey.whenKeyPressed": "όταν πατηθεί το κουμπί %1",
  	"makeymakey.whenKeysPressedInOrder": "όταν πατηθεί με σειρά %1",
  	"microbit.whenButtonPressed": "όταν πατηθεί το κουμπί %1",
  	"microbit.isButtonPressed": "πατήθηκε το κουμπί %1;",
  	"microbit.whenGesture": "όταν %1",
  	"microbit.displaySymbol": "εμφάνισε %1",
  	"microbit.displayText": "εμφάνισε κείμενο %1",
  	"microbit.clearDisplay": "καθάρισε οθόνη",
  	"microbit.whenTilted": "όταν σε κλίση %1",
  	"microbit.isTilted": "σε κλίση %1;",
  	"microbit.tiltAngle": "γωνία κλίσης %1",
  	"microbit.whenPinConnected": "όταν ακίδσ %1 συνδεθεί",
  	"ev3.motorTurnClockwise": "κινητήρα %1 στρίψε προς αυτήν την κατεύθυνση για %2 δευτ.",
  	"ev3.motorTurnCounterClockwise": "κινητήρα %1 στρίψε προς την άλλη κατεύθυνση για %2 δευτ.",
  	"ev3.motorSetPower": "κινητήρα %1 όρισε ισχύ %2 %",
  	"ev3.getMotorPosition": "θέση κινητήρα %1",
  	"ev3.whenButtonPressed": "όταν πατηθεί το κουμπί %1",
  	"ev3.whenDistanceLessThan": "όταν απόσταση < %1",
  	"ev3.whenBrightnessLessThan": "όταν φωτεινότητα < %1",
  	"ev3.buttonPressed": "πατήθηκε το κουμπί %1;",
  	"ev3.getDistance": "απόσταση",
  	"ev3.getBrightness": "φωτεινότητα",
  	"ev3.beepNote": "παίξε τη νότα %1 για %2 δευτ.",
  	"wedo2.motorOn": "ενεργοποίησε κινητήρα %1",
  	"wedo2.motorOff": "απενεργοποίησε κινητήρα %1",
  	"wedo2.startMotorPower": "όρισε ισχύ του %1 σε %2",
  	"wedo2.setMotorDirection": "όρισε κατεύθυνση %2 στον %1",
  	"wedo2.whenDistance": "όταν απόσταση %1 %2",
  	"wedo2.getDistance": "απόσταση",
  	"wedo2.motorOnFor": "ενεργοποίησε %1 για %2 δευτ.",
  	"wedo2.setLightHue": "όρισε χρώμα φωτός σε %1",
  	"wedo2.playNoteFor": "παίξε νότα %1 για %2 δευτ.",
  	"wedo2.whenTilted": "όταν κλίση %1",
  	"wedo2.isTilted": "έχει κλίση %1;",
  	"wedo2.getTiltAngle": "γωνία κλίσης %1",
  	"gdxfor.whenGesture": "όταν %1",
  	"gdxfor.whenForcePushedOrPulled": "όταν αισθητήρας ισχύος %1",
  	"gdxfor.getForce": "ισχύς",
  	"gdxfor.whenTilted": "όταν σε κλίση%1",
  	"gdxfor.isTilted": "σε κλίση %1;",
  	"gdxfor.getTilt": "γωνία κλίσης %1",
  	"gdxfor.isFreeFalling": "σε πτώση;",
  	"gdxfor.getSpin": "ταχύτητα περιστροφής %1",
  	"gdxfor.getAcceleration": "επιτάχυνση %1",
  	"boost.motorOnFor": "ενεργοποίησε κινητήρα %1 για %2 δευτ.",
  	"boost.motorOnForRotation": "ενεργοποίησε κινητήρα %1 για %2 περιστροφές",
  	"boost.motorOn": "ενεργοποίσε κινητήρα %1",
  	"boost.motorOff": "απενεργοποίησε κινητήρα %1",
  	"boost.setMotorPower": "όρισε ταχύτητα κινητήρα %1 σε %2 %",
  	"boost.setMotorDirection": "όρισε κατεύθυνση %2 κινητήρα %1",
  	"boost.getMotorPosition": "θέση κινητήρα %1",
  	"boost.whenColor": "όταν έχει δει %1 τούβλο",
  	"boost.seeingColor": "βλέπει %1 τούβλο;",
  	"boost.whenTilted": "όταν κλίση %1",
  	"boost.getTiltAngle": "γωνία κλίσης %1",
  	"boost.setLightHue": "όρισε χρώμα φωτός σε %1"
  };
  var dropdowns$Z = {
  };
  var ignorelt$Z = [
  ];
  var soundEffects$Z = [
  	"τόνος",
  	"μετατόπιση αριστερά/δεξιά"
  ];
  var microbitWhen$Z = [
  	"κινηθεί",
  	"τρανταχθεί",
  	"αναπηδήσει"
  ];
  var osis$Z = [
  	"άλλα σενάρια σε αυτό το αντικείμενο"
  ];
  var definePrefix$Z = [
  	"ορισμός"
  ];
  var defineSuffix$Z = [
  ];
  var palette$Z = {
  	Motion: "Κίνηση",
  	Looks: "Όψεις",
  	Sound: "Ήχος",
  	Events: "Συμβάντα",
  	Control: "Έλεγχος",
  	Sensing: "Αισθητήρες",
  	Operators: "Τελεστές",
  	Variables: "Μεταβλητές",
  	"My Blocks": "Οι Εντολές μου"
  };
  var math$Z = [
  	"απόλυτο",
  	"στρογγυλ. κάτω",
  	"στρογγυλ. άνω",
  	"τετρ. ρίζα",
  	"ημ",
  	"συν",
  	"εφ",
  	"τοξημ",
  	"τοξσυν",
  	"τοξεφ",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$Z = {
  	"στρίψε αριστερά %1 μοίρες": "MOTION_TURNLEFT",
  	"στρίψε αριστερόστροφα %1 μοίρες": "MOTION_TURNLEFT",
  	"στρίψε δεξιά %1 μοίρες": "MOTION_TURNRIGHT",
  	"στρίψε δεξιόστροφα %1 μοίρες": "MOTION_TURNRIGHT",
  	"Όταν στην πράσινη σημαία γίνει κλικ": "EVENT_WHENFLAGCLICKED",
  	"τέλος": "scratchblocks:end"
  };
  var name$Z = "Ελληνικά";
  var percentTranslated$Z = 100;
  var el = {
  	commands: commands$Z,
  	dropdowns: dropdowns$Z,
  	ignorelt: ignorelt$Z,
  	soundEffects: soundEffects$Z,
  	microbitWhen: microbitWhen$Z,
  	osis: osis$Z,
  	definePrefix: definePrefix$Z,
  	defineSuffix: defineSuffix$Z,
  	palette: palette$Z,
  	math: math$Z,
  	aliases: aliases$Z,
  	name: name$Z,
  	percentTranslated: percentTranslated$Z
  };

  var commands$Y = {
  	MOTION_MOVESTEPS: "movi %1 paŝojn",
  	MOTION_TURNRIGHT: "turni @turnRight je %1 gradoj",
  	MOTION_TURNLEFT: "turni @turnLeft je %1 gradoj",
  	MOTION_POINTINDIRECTION: "agordi direkton al %1",
  	MOTION_POINTTOWARDS: "direkti al %1",
  	MOTION_GOTOXY: "iri al x: %1 y: %2",
  	MOTION_GOTO: "iri al %1",
  	MOTION_GLIDESECSTOXY: "gliti dum %1 sekundoj al x: %2 y: %3",
  	MOTION_GLIDETO: "gliti dum %1 sekundoj al %2",
  	MOTION_CHANGEXBY: "ŝanĝi x je %1",
  	MOTION_SETX: "agordi x al %1",
  	MOTION_CHANGEYBY: "ŝanĝi y je %1",
  	MOTION_SETY: "agordi y al %1",
  	MOTION_SETROTATIONSTYLE: "turniĝi tiel: %1",
  	LOOKS_SAYFORSECS: "diri %1 dum %2 sekundoj",
  	LOOKS_SAY: "diri %1",
  	LOOKS_THINKFORSECS: "pensi %1 dum %2 sekundoj",
  	LOOKS_THINK: "pensi %1",
  	LOOKS_SHOW: "montri",
  	LOOKS_HIDE: "kaŝi",
  	LOOKS_SWITCHCOSTUMETO: "ŝanĝi al la kostumo %1",
  	LOOKS_NEXTCOSTUME: "sekva kostumo",
  	LOOKS_NEXTBACKDROP_BLOCK: "sekva fono",
  	LOOKS_SWITCHBACKDROPTO: "ŝanĝi fonon al %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "ŝanĝi fonon al %1 kaj atendi",
  	LOOKS_CHANGEEFFECTBY: "ŝanĝi efikon %1 je %2",
  	LOOKS_SETEFFECTTO: "agordi efikon %1 al %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "forigi grafikajn efikojn",
  	LOOKS_CHANGESIZEBY: "ŝanĝi grandon je %1",
  	LOOKS_SETSIZETO: "agordi grandon al %1 %",
  	LOOKS_GOTOFRONTBACK: "iri al %1 tavolo",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "iri %1 je %2 tavoloj",
  	SOUND_PLAY: "komenci sonon %1",
  	SOUND_CHANGEEFFECTBY: "ŝanĝi efikon %1 je %2",
  	SOUND_SETEFFECTO: "agordi efikon %1 al %2",
  	SOUND_CLEAREFFECTS: "forigi sonojn",
  	SOUND_PLAYUNTILDONE: "aŭdigi sonon %1 ĝis la fino",
  	SOUND_STOPALLSOUNDS: "ĉesigi ĉiujn sonojn",
  	"music.playDrumForBeats": "ludi tamburon %1 dum %2 taktoj",
  	"music.restForBeats": "silenti dum %1 taktoj",
  	"music.playNoteForBeats": "ludi noton %1 dum %2 taktoj",
  	"music.setInstrument": "elekti instrumenton %1",
  	SOUND_CHANGEVOLUMEBY: "ŝanĝi laŭtecon je %1",
  	SOUND_SETVOLUMETO: "agordi laŭtecon al %1%",
  	"music.changeTempo": "ŝanĝi muziktempon je %1",
  	"music.setTempo": "agordi muziktempon al %1",
  	"pen.clear": "forigi ĉion",
  	"pen.stamp": "stampi",
  	"pen.penDown": "ekskribi",
  	"pen.penUp": "ĉesi skribi",
  	"pen.setColor": "kolorigi skribilon al %1",
  	"pen.changeHue": "ŝanĝi koloron de skribilo de %1",
  	"pen.setColorParam": "agordi %1 de skribilo al %2",
  	"pen.changeColorParam": "ŝanĝi skribilon %1 je %2",
  	"pen.setHue": "kolorigi skribilon al %1",
  	"pen.changeShade": "ŝanĝi kolornuancon de skribilo de %1",
  	"pen.setShade": "agordi kolornuancon de skribilo al %1",
  	"pen.changeSize": "ŝanĝi grandon de skribilo de %1",
  	"pen.setSize": "agordi grandon de skribilo al %1",
  	EVENT_WHENFLAGCLICKED: "kiam @greenFlag estas alklakita",
  	EVENT_WHENKEYPRESSED: "kiam klavo %1 estas tuŝita",
  	EVENT_WHENTHISSPRITECLICKED: "kiam tiu ĉi rolulo estas alklakita",
  	EVENT_WHENSTAGECLICKED: "kiam la scenejo estas alklakita",
  	EVENT_WHENBACKDROPSWITCHESTO: "kiam fono ŝanĝiĝas al %1",
  	EVENT_WHENGREATERTHAN: "kiam %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kiam mi ricevas %1",
  	EVENT_BROADCAST: "elsendi %1",
  	EVENT_BROADCASTANDWAIT: "elsendi %1 kaj atendi",
  	CONTROL_WAIT: "atendi %1 sekundojn",
  	CONTROL_REPEAT: "ripeti %1-foje",
  	CONTROL_FOREVER: "ripeti senfine",
  	CONTROL_IF: "se %1 do",
  	CONTROL_WAITUNTIL: "atendi ĝis %1",
  	CONTROL_REPEATUNTIL: "ripeti ĝis %1",
  	CONTROL_STOP: "haltigi %1",
  	CONTROL_STARTASCLONE: "kiam mi kreiĝas kiel klono",
  	CONTROL_CREATECLONEOF: "krei klonon de %1",
  	CONTROL_DELETETHISCLONE: "forigi tiun ĉi klonon",
  	SENSING_ASKANDWAIT: "demandi %1 kaj atendi",
  	"videoSensing.videoToggle": "agordi videon %1",
  	"videoSensing.setVideoTransparency": "agordi travideblecon de video al %1",
  	"videoSensing.whenMotionGreaterThan": "kiam movo en video > %1",
  	SENSING_RESETTIMER: "restartigi klikhorloĝon",
  	DATA_SETVARIABLETO: "agordi %1 al %2",
  	DATA_CHANGEVARIABLEBY: "ŝanĝi %1 je %2",
  	DATA_SHOWVARIABLE: "montri variablon %1",
  	DATA_HIDEVARIABLE: "kaŝi variablon %1",
  	DATA_ADDTOLIST: "aldoni %1 al %2",
  	DATA_DELETEOFLIST: "forigi %1 de el %2",
  	DATA_DELETEALLOFLIST: "forigi ĉion el %1",
  	MOTION_IFONEDGEBOUNCE: "se mi tuŝas randon, resalti",
  	DATA_INSERTATLIST: "enmeti %1 ĉe %2 de %3",
  	DATA_REPLACEITEMOFLIST: "anstataŭigi %1-an eron de %2 per %3",
  	DATA_SHOWLIST: "montri liston %1",
  	DATA_HIDELIST: "kaŝi liston %1",
  	SENSING_OF_XPOSITION: "x-pozicio",
  	SENSING_OF_YPOSITION: "y-pozicio",
  	SENSING_OF_DIRECTION: "direkto",
  	SENSING_OF_COSTUMENUMBER: "numero de kostumo",
  	LOOKS_COSTUMENUMBERNAME: "%1 de kostumo",
  	SENSING_OF_SIZE: "grando",
  	SENSING_OF_BACKDROPNAME: "nomo de fono",
  	LOOKS_BACKDROPNUMBERNAME: "%1 de fono",
  	SENSING_OF_BACKDROPNUMBER: "numero de la fono",
  	SOUND_VOLUME: "laŭteco",
  	"music.getTempo": "rapido",
  	SENSING_TOUCHINGOBJECT: "ĉu tuŝas %1?",
  	SENSING_TOUCHINGCOLOR: "ĉu tuŝas koloron %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "ĉu koloro %1 tuŝas koloron %2?",
  	SENSING_DISTANCETO: "distanco al %1",
  	SENSING_ANSWER: "respondo",
  	SENSING_KEYPRESSED: "ĉu klavo %1 estas tuŝita?",
  	SENSING_MOUSEDOWN: "ĉu musbutono estas premita?",
  	SENSING_MOUSEX: "musa x-pozicio",
  	SENSING_MOUSEY: "musa y-pozicio",
  	SENSING_SETDRAGMODE: "ĉu eblu treni rolulojn? %1",
  	SENSING_LOUDNESS: "laŭto",
  	"videoSensing.videoOn": "%1 de video sur %2",
  	SENSING_TIMER: "horloĝo",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "aktuala %1",
  	SENSING_DAYSSINCE2000: "tagoj post 2000",
  	SENSING_USERNAME: "salutnomo",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "hazarda numero inter %1 kaj %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 kaj %2",
  	OPERATORS_OR: "%1 aŭ %2",
  	OPERATORS_NOT: "ne %1",
  	OPERATORS_JOIN: "kunigi %1 %2",
  	OPERATORS_LETTEROF: "%1 -a litero de %2",
  	OPERATORS_LENGTH: "longo de %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "rondigi %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "ĉu %1 enhavas %2?",
  	DATA_ITEMOFLIST: "%1-a ero de %2",
  	DATA_ITEMNUMOFLIST: "vica numero de %1 en %2",
  	DATA_LENGTHOFLIST: "longo de %1",
  	DATA_LISTCONTAINSITEM: "ĉu %1 enhavas %2?",
  	CONTROL_ELSE: "alikaze",
  	SENSING_USERID: "ID de uzanto",
  	SENSING_LOUD: "ĉu laŭta?",
  	"text2speech.speakAndWaitBlock": "diri %1",
  	"text2speech.setVoiceBlock": "agordi voĉon al %1",
  	"text2speech.setLanguageBlock": "agordi lingvon al %1",
  	"translate.translateBlock": "traduki %1 al %2",
  	"translate.viewerLanguage": "lingvo",
  	"makeymakey.whenKeyPressed": "kiam klavo %1 premita",
  	"makeymakey.whenKeysPressedInOrder": "kiam sinsekvo %1 tajpita",
  	"microbit.whenButtonPressed": "kiam butono %1 premita",
  	"microbit.isButtonPressed": "ĉu butono %1 premita?",
  	"microbit.whenGesture": "kiam %1",
  	"microbit.displaySymbol": "afiŝi %1",
  	"microbit.displayText": "afiŝi tekston %1",
  	"microbit.clearDisplay": "viŝi matricon",
  	"microbit.whenTilted": "kiam klinita %1",
  	"microbit.isTilted": "ĉu klinita %1?",
  	"microbit.tiltAngle": "angulo de kliniĝo %1",
  	"microbit.whenPinConnected": "kiam stifto %1 konektita",
  	"ev3.motorTurnClockwise": "motoro ĉe pordo %1 turniĝu dekstrume dum %2 sekundoj",
  	"ev3.motorTurnCounterClockwise": "motoro ĉe pordo %1 turniĝu maldekstrume dum %2 sekundoj",
  	"ev3.motorSetPower": "motoro ĉe pordo %1 turniĝu kun rapideco %2 %",
  	"ev3.getMotorPosition": "pozicio de motoro ĉe pordo %1",
  	"ev3.whenButtonPressed": "kiam butono ĉe pordo %1 estas premita",
  	"ev3.whenDistanceLessThan": "kiam distanco < %1",
  	"ev3.whenBrightnessLessThan": "kiam brileco < %1",
  	"ev3.buttonPressed": "ĉu butono %1 estas premita?",
  	"ev3.getDistance": "distanco",
  	"ev3.getBrightness": "heleco",
  	"ev3.beepNote": "sonorigi noton %1 dum %2 sekundoj",
  	"wedo2.motorOn": "ŝalti %1",
  	"wedo2.motorOff": "malŝalti %1",
  	"wedo2.startMotorPower": "agordi rapidecon de %1 al %2",
  	"wedo2.setMotorDirection": "agordi direkton de %1 al %2",
  	"wedo2.whenDistance": "kiam distanco %1 %2",
  	"wedo2.getDistance": "distanco",
  	"wedo2.motorOnFor": "ŝalti %1 dum %2 sekundoj",
  	"wedo2.setLightHue": "kolorigi LED al %1",
  	"wedo2.playNoteFor": "ludi noton %1 dum %2 sekundoj",
  	"wedo2.whenTilted": "kiam klinita %1",
  	"wedo2.isTilted": "ĉu inklinita %1?",
  	"wedo2.getTiltAngle": "angulo de klino %1",
  	"gdxfor.whenGesture": "kiam %1",
  	"gdxfor.whenForcePushedOrPulled": "kiam fortodetektilo %1",
  	"gdxfor.getForce": "forto",
  	"gdxfor.whenTilted": "kiam klinita %1",
  	"gdxfor.isTilted": "ĉu klinita %1?",
  	"gdxfor.getTilt": "angulo de klino %1",
  	"gdxfor.isFreeFalling": "ĉu falanta?",
  	"gdxfor.getSpin": "rapideco de turnado %1",
  	"gdxfor.getAcceleration": "akcelo %1",
  	"boost.motorOnFor": "ŝalti motoron %1 dum %2 sekundoj",
  	"boost.motorOnForRotation": "ŝalti motoron %1 dum %2 turnoj",
  	"boost.motorOn": "ŝalti motoron %1",
  	"boost.motorOff": "malŝalti motoron %1",
  	"boost.setMotorPower": "motoro %1 turniĝu kun rapideco %2 %",
  	"boost.setMotorDirection": "motoro %1 turniĝu %2",
  	"boost.getMotorPosition": "pozicio de motoro %1",
  	"boost.whenColor": "kiam %1 briko videblas",
  	"boost.seeingColor": "ĉu %1 briko videblas?",
  	"boost.whenTilted": "kiam klinita %1",
  	"boost.getTiltAngle": "angulo de klino %1",
  	"boost.setLightHue": "kolorigi LED al %1"
  };
  var dropdowns$Y = {
  };
  var ignorelt$Y = [
  ];
  var soundEffects$Y = [
  	"tonalto",
  	"aŭdigi maldekstre/dekstre"
  ];
  var microbitWhen$Y = [
  	"movita",
  	"ŝancelita",
  	"saltigita"
  ];
  var osis$Y = [
  	"aliajn skriptojn en la rolulo"
  ];
  var definePrefix$Y = [
  	"difini"
  ];
  var defineSuffix$Y = [
  ];
  var palette$Y = {
  	Motion: "Movado",
  	Looks: "Aspekto",
  	Sound: "Sono",
  	Events: "Eventoj",
  	Control: "Stirado",
  	Sensing: "Sentiloj",
  	Operators: "Operatoroj",
  	Variables: "Variabloj",
  	"My Blocks": "Miaj Blokoj"
  };
  var math$Y = [
  	"abs",
  	"planko",
  	"plafono",
  	"radiko",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$Y = {
  };
  var name$Y = "Esperanto";
  var percentTranslated$Y = 100;
  var eo = {
  	commands: commands$Y,
  	dropdowns: dropdowns$Y,
  	ignorelt: ignorelt$Y,
  	soundEffects: soundEffects$Y,
  	microbitWhen: microbitWhen$Y,
  	osis: osis$Y,
  	definePrefix: definePrefix$Y,
  	defineSuffix: defineSuffix$Y,
  	palette: palette$Y,
  	math: math$Y,
  	aliases: aliases$Y,
  	name: name$Y,
  	percentTranslated: percentTranslated$Y
  };

  var commands$X = {
  	MOTION_MOVESTEPS: "mover %1 pasos",
  	MOTION_TURNRIGHT: "girar @turnRight %1 grados",
  	MOTION_TURNLEFT: "girar @turnLeft %1 grados",
  	MOTION_POINTINDIRECTION: "apuntar en dirección %1",
  	MOTION_POINTTOWARDS: "apuntar hacia %1",
  	MOTION_GOTOXY: "ir a x: %1 y: %2",
  	MOTION_GOTO: "ir a %1",
  	MOTION_GLIDESECSTOXY: "deslizar en %1 segs a x: %2 y: %3",
  	MOTION_GLIDETO: "deslizar en %1 segs a %2",
  	MOTION_CHANGEXBY: "sumar a x %1",
  	MOTION_SETX: "dar a x el valor %1",
  	MOTION_CHANGEYBY: "sumar a y %1",
  	MOTION_SETY: "dar a y el valor %1",
  	MOTION_SETROTATIONSTYLE: "fijar estilo de rotación a %1",
  	LOOKS_SAYFORSECS: "decir %1 durante %2 segundos",
  	LOOKS_SAY: "decir %1",
  	LOOKS_THINKFORSECS: "pensar %1 durante %2 segundos",
  	LOOKS_THINK: "pensar %1",
  	LOOKS_SHOW: "mostrar",
  	LOOKS_HIDE: "esconder",
  	LOOKS_SWITCHCOSTUMETO: "cambiar disfraz a %1",
  	LOOKS_NEXTCOSTUME: "siguiente disfraz",
  	LOOKS_NEXTBACKDROP_BLOCK: "siguiente fondo",
  	LOOKS_SWITCHBACKDROPTO: "cambiar fondo a %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "cambiar fondo a %1 y esperar",
  	LOOKS_CHANGEEFFECTBY: "sumar al efecto %1 %2",
  	LOOKS_SETEFFECTTO: "dar al efecto %1 el valor %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "quitar efectos gráficos",
  	LOOKS_CHANGESIZEBY: "cambiar tamaño por %1",
  	LOOKS_SETSIZETO: "fijar tamaño al %1 %",
  	LOOKS_GOTOFRONTBACK: "ir a capa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ir %2 capas hacia %1",
  	SOUND_PLAY: "iniciar sonido %1",
  	SOUND_CHANGEEFFECTBY: "sumar al efecto %1 %2",
  	SOUND_SETEFFECTO: "dar al efecto %1 el valor %2",
  	SOUND_CLEAREFFECTS: "quitar efectos de sonido",
  	SOUND_PLAYUNTILDONE: "tocar sonido %1 hasta que termine",
  	SOUND_STOPALLSOUNDS: "detener todos los sonidos",
  	"music.playDrumForBeats": "tocar tambor %1 durante %2 tiempos",
  	"music.restForBeats": "silencio de %1 tiempos",
  	"music.playNoteForBeats": "tocar nota %1 durante %2 tiempos",
  	"music.setInstrument": "fijar instrumento a %1",
  	SOUND_CHANGEVOLUMEBY: "cambiar volumen por %1",
  	SOUND_SETVOLUMETO: "fijar volumen al %1%",
  	"music.changeTempo": "cambiar tempo por %1",
  	"music.setTempo": "dar al tempo el valor %1",
  	"pen.clear": "borrar todo",
  	"pen.stamp": "sellar",
  	"pen.penDown": "bajar lápiz",
  	"pen.penUp": "subir lápiz",
  	"pen.setColor": "fijar color de lápiz a %1",
  	"pen.changeHue": "cambiar color de lápiz por %1",
  	"pen.setColorParam": "fijar %1 de lápiz a %2",
  	"pen.changeColorParam": "cambiar %1 de lápiz por %2",
  	"pen.setHue": "fijar color de lápiz a %1",
  	"pen.changeShade": "cambiar sombra de lápiz por %1",
  	"pen.setShade": "fijar sombra de lápiz a %1",
  	"pen.changeSize": "cambiar tamaño de lápiz por %1",
  	"pen.setSize": "fijar tamaño de lápiz a %1",
  	EVENT_WHENFLAGCLICKED: "al hacer clic en @greenFlag",
  	EVENT_WHENKEYPRESSED: "al presionar tecla %1",
  	EVENT_WHENTHISSPRITECLICKED: "al hacer clic en este objeto",
  	EVENT_WHENSTAGECLICKED: "al hacer clic en el escenario",
  	EVENT_WHENBACKDROPSWITCHESTO: "cuando el fondo cambie a %1",
  	EVENT_WHENGREATERTHAN: "cuando %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "al recibir %1",
  	EVENT_BROADCAST: "enviar %1",
  	EVENT_BROADCASTANDWAIT: "enviar %1 y esperar",
  	CONTROL_WAIT: "esperar %1 segundos",
  	CONTROL_REPEAT: "repetir %1",
  	CONTROL_FOREVER: "por siempre",
  	CONTROL_IF: "si %1 entonces",
  	CONTROL_WAITUNTIL: "esperar hasta que %1",
  	CONTROL_REPEATUNTIL: "repetir hasta que %1",
  	CONTROL_STOP: "detener %1",
  	CONTROL_STARTASCLONE: "al comenzar como clon",
  	CONTROL_CREATECLONEOF: "crear clon de %1",
  	CONTROL_DELETETHISCLONE: "eliminar este clon",
  	SENSING_ASKANDWAIT: "preguntar %1 y esperar",
  	"videoSensing.videoToggle": "%1 vídeo",
  	"videoSensing.setVideoTransparency": "fijar transparencia de vídeo a %1",
  	"videoSensing.whenMotionGreaterThan": "cuando movimiento de vídeo > %1",
  	SENSING_RESETTIMER: "reiniciar cronómetro",
  	DATA_SETVARIABLETO: "dar a %1 el valor %2",
  	DATA_CHANGEVARIABLEBY: "sumar a %1 %2",
  	DATA_SHOWVARIABLE: "mostrar variable %1",
  	DATA_HIDEVARIABLE: "esconder variable %1",
  	DATA_ADDTOLIST: "añadir %1 a %2",
  	DATA_DELETEOFLIST: "eliminar %1 de %2",
  	DATA_DELETEALLOFLIST: "eliminar todos de %1",
  	MOTION_IFONEDGEBOUNCE: "si toca un borde, rebotar",
  	DATA_INSERTATLIST: "insertar %1 en %2 de %3",
  	DATA_REPLACEITEMOFLIST: "reemplazar elemento %1 de %2 con %3",
  	DATA_SHOWLIST: "mostrar lista %1",
  	DATA_HIDELIST: "esconder lista %1",
  	SENSING_OF_XPOSITION: "posición en x",
  	SENSING_OF_YPOSITION: "posición en y",
  	SENSING_OF_DIRECTION: "dirección",
  	SENSING_OF_COSTUMENUMBER: "# de disfraz",
  	LOOKS_COSTUMENUMBERNAME: "%1 de disfraz",
  	SENSING_OF_SIZE: "tamaño",
  	SENSING_OF_BACKDROPNAME: "nombre de fondo",
  	LOOKS_BACKDROPNUMBERNAME: "%1 de fondo",
  	SENSING_OF_BACKDROPNUMBER: "# de fondo",
  	SOUND_VOLUME: "volumen",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "¿tocando %1?",
  	SENSING_TOUCHINGCOLOR: "¿tocando el color %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "¿color %1 tocando %2?",
  	SENSING_DISTANCETO: "distancia a %1",
  	SENSING_ANSWER: "respuesta",
  	SENSING_KEYPRESSED: "¿tecla %1 presionada?",
  	SENSING_MOUSEDOWN: "¿ratón presionado?",
  	SENSING_MOUSEX: "posición x del ratón",
  	SENSING_MOUSEY: "posición y del ratón",
  	SENSING_SETDRAGMODE: "fijar modo de arrastre a %1",
  	SENSING_LOUDNESS: "volumen del sonido",
  	"videoSensing.videoOn": "%1 de vídeo en %2",
  	SENSING_TIMER: "cronómetro",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "%1 actual",
  	SENSING_DAYSSINCE2000: "días desde el 2000",
  	SENSING_USERNAME: "nombre de usuario",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "número aleatorio entre %1 y %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 y %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "no %1",
  	OPERATORS_JOIN: "unir %1 %2",
  	OPERATORS_LETTEROF: "letra %1 de %2",
  	OPERATORS_LENGTH: "longitud de %1",
  	OPERATORS_MOD: "%1 módulo %2",
  	OPERATORS_ROUND: "redondear %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "¿%2 está en %1?",
  	DATA_ITEMOFLIST: "elemento %1 de %2",
  	DATA_ITEMNUMOFLIST: "# de elemento de %1 en %2",
  	DATA_LENGTHOFLIST: "longitud de %1",
  	DATA_LISTCONTAINSITEM: "¿%2 está en %1?",
  	CONTROL_ELSE: "si no",
  	SENSING_USERID: "id de usuario",
  	SENSING_LOUD: "¿ruidoso?",
  	"text2speech.speakAndWaitBlock": "decir %1",
  	"text2speech.setVoiceBlock": "asignar voz a %1",
  	"text2speech.setLanguageBlock": "fijar idioma a %1",
  	"translate.translateBlock": "traducir %1 al %2",
  	"translate.viewerLanguage": "idioma",
  	"makeymakey.whenKeyPressed": "al presionar tecla %1",
  	"makeymakey.whenKeysPressedInOrder": "al presionar %1 en orden",
  	"microbit.whenButtonPressed": "al presionar botón %1",
  	"microbit.isButtonPressed": "¿botón %1 presionado?",
  	"microbit.whenGesture": "al %1",
  	"microbit.displaySymbol": "mostrar %1",
  	"microbit.displayText": "mostrar texto %1",
  	"microbit.clearDisplay": "limpiar pantalla",
  	"microbit.whenTilted": "al inclinar hacia %1",
  	"microbit.isTilted": "¿inclinado hacia %1?",
  	"microbit.tiltAngle": "ángulo de inclinación hacia %1",
  	"microbit.whenPinConnected": "al conectar pin %1",
  	"ev3.motorTurnClockwise": "motor %1 girar a un lado %2 segundos",
  	"ev3.motorTurnCounterClockwise": "motor %1 girar al otro lado %2 segundos",
  	"ev3.motorSetPower": "motor %1 fijar potencia a %2 %",
  	"ev3.getMotorPosition": "posición del motor %1",
  	"ev3.whenButtonPressed": "al presionar botón %1",
  	"ev3.whenDistanceLessThan": "cuando distancia < %1",
  	"ev3.whenBrightnessLessThan": "cuando brillo < %1",
  	"ev3.buttonPressed": "¿botón %1 presionado?",
  	"ev3.getDistance": "distancia",
  	"ev3.getBrightness": "brillo",
  	"ev3.beepNote": "tocar nota %1 durante %2 segundos",
  	"wedo2.motorOn": "encender %1",
  	"wedo2.motorOff": "apagar %1",
  	"wedo2.startMotorPower": "fijar potencia de %1 a %2",
  	"wedo2.setMotorDirection": "fijar dirección de %1 a %2",
  	"wedo2.whenDistance": "cuando distancia %1 %2",
  	"wedo2.getDistance": "distancia",
  	"wedo2.motorOnFor": "encender %1 durante %2 segundos",
  	"wedo2.setLightHue": "fijar color de la luz a %1",
  	"wedo2.playNoteFor": "tocar nota %1 durante %2 segundos",
  	"wedo2.whenTilted": "al inclinar hacia %1",
  	"wedo2.isTilted": "¿inclinado hacia %1?",
  	"wedo2.getTiltAngle": "ángulo de inclinación hacia %1",
  	"gdxfor.whenGesture": "al %1",
  	"gdxfor.whenForcePushedOrPulled": "cuando el sensor de fuerza %1",
  	"gdxfor.getForce": "fuerza",
  	"gdxfor.whenTilted": "al inclinar %1",
  	"gdxfor.isTilted": "¿inclinado %1?",
  	"gdxfor.getTilt": "ángulo de inclinación %1",
  	"gdxfor.isFreeFalling": "¿cayendo?",
  	"gdxfor.getSpin": "velocidad de giro %1",
  	"gdxfor.getAcceleration": "aceleración %1",
  	"boost.motorOnFor": "girar motor %1 %2 segundos",
  	"boost.motorOnForRotation": "girar motor %1 %2 vueltas",
  	"boost.motorOn": "encender motor %1",
  	"boost.motorOff": "apagar motor %1",
  	"boost.setMotorPower": "fijar velocidad del motor %1 al %2 %",
  	"boost.setMotorDirection": "fijar dirección del motor %1 %2",
  	"boost.getMotorPosition": "posición del motor %1",
  	"boost.whenColor": "cuando vea pieza %1",
  	"boost.seeingColor": "¿ve pieza %1?",
  	"boost.whenTilted": "al inclinar hacia %1",
  	"boost.getTiltAngle": "ángulo de inclinación hacia %1",
  	"boost.setLightHue": "fijar color de la luz a %1"
  };
  var dropdowns$X = {
  };
  var ignorelt$X = [
  ];
  var soundEffects$X = [
  	"altura",
  	"balance izquierda/derecha"
  ];
  var microbitWhen$X = [
  	"mover",
  	"agitar",
  	"saltar"
  ];
  var osis$X = [
  	"otros programas en el objeto"
  ];
  var definePrefix$X = [
  	"definir"
  ];
  var defineSuffix$X = [
  ];
  var palette$X = {
  	Motion: "Movimiento",
  	Looks: "Apariencia",
  	Sound: "Sonido",
  	Events: "Eventos",
  	Control: "Control",
  	Sensing: "Sensores",
  	Operators: "Operadores",
  	Variables: "Variables",
  	"My Blocks": "Mis bloques"
  };
  var math$X = [
  	"valor absoluto",
  	"suelo",
  	"techo",
  	"raíz cuadrada",
  	"sen",
  	"cos",
  	"tan",
  	"arcsen",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$X = {
  	"girar a la izquierda %1 grados": "MOTION_TURNLEFT",
  	"girar a la derecha %1 grados": "MOTION_TURNRIGHT",
  	"al presionar bandera verde": "EVENT_WHENFLAGCLICKED",
  	fin: "scratchblocks:end"
  };
  var name$X = "Español (España)";
  var percentTranslated$X = 100;
  var es = {
  	commands: commands$X,
  	dropdowns: dropdowns$X,
  	ignorelt: ignorelt$X,
  	soundEffects: soundEffects$X,
  	microbitWhen: microbitWhen$X,
  	osis: osis$X,
  	definePrefix: definePrefix$X,
  	defineSuffix: defineSuffix$X,
  	palette: palette$X,
  	math: math$X,
  	aliases: aliases$X,
  	name: name$X,
  	percentTranslated: percentTranslated$X
  };

  var commands$W = {
  	MOTION_MOVESTEPS: "mover %1 pasos",
  	MOTION_TURNRIGHT: "girar @turnRight %1 grados",
  	MOTION_TURNLEFT: "girar @turnLeft %1 grados",
  	MOTION_POINTINDIRECTION: "apuntar en dirección %1",
  	MOTION_POINTTOWARDS: "apuntar hacia %1",
  	MOTION_GOTOXY: "ir a x: %1 y: %2",
  	MOTION_GOTO: "ir a %1",
  	MOTION_GLIDESECSTOXY: "desplazar en %1 segs a x: %2 y: %3",
  	MOTION_GLIDETO: "desplazar en %1 segs a %2",
  	MOTION_CHANGEXBY: "cambiar x en %1",
  	MOTION_SETX: "fijar x a %1",
  	MOTION_CHANGEYBY: "cambiar y en %1",
  	MOTION_SETY: "fijar y a %1",
  	MOTION_SETROTATIONSTYLE: "fijar estilo de rotación a %1",
  	LOOKS_SAYFORSECS: "decir %1 durante %2 segundos",
  	LOOKS_SAY: "decir %1",
  	LOOKS_THINKFORSECS: "pensar %1 durante %2 segundos",
  	LOOKS_THINK: "pensar %1",
  	LOOKS_SHOW: "mostrar",
  	LOOKS_HIDE: "esconder",
  	LOOKS_SWITCHCOSTUMETO: "cambiar disfraz a %1",
  	LOOKS_NEXTCOSTUME: "siguiente disfraz",
  	LOOKS_NEXTBACKDROP_BLOCK: "siguiente fondo",
  	LOOKS_SWITCHBACKDROPTO: "cambiar fondo a %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "cambiar fondo a %1 y esperar",
  	LOOKS_CHANGEEFFECTBY: "cambiar el efecto %1 en %2",
  	LOOKS_SETEFFECTTO: "fijar efecto %1 a %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "quitar efectos gráficos",
  	LOOKS_CHANGESIZEBY: "cambiar tamaño en %1",
  	LOOKS_SETSIZETO: "fijar tamaño a %1 %",
  	LOOKS_GOTOFRONTBACK: "ir a la capa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ir %2 capas hacia %1",
  	SOUND_PLAY: "iniciar sonido %1",
  	SOUND_CHANGEEFFECTBY: "cambiar efecto %1 en %2",
  	SOUND_SETEFFECTO: "fijar efecto %1 a %2",
  	SOUND_CLEAREFFECTS: "quitar efectos de sonido",
  	SOUND_PLAYUNTILDONE: "tocar sonido %1 hasta que termine",
  	SOUND_STOPALLSOUNDS: "detener todos los sonidos",
  	"music.playDrumForBeats": "tocar tambor %1 durante %2 tiempos",
  	"music.restForBeats": "silenciar durante %1 tiempos",
  	"music.playNoteForBeats": "tocar nota %1 durante %2 tiempos",
  	"music.setInstrument": "fijar instrumento a %1",
  	SOUND_CHANGEVOLUMEBY: "cambiar volumen en %1",
  	SOUND_SETVOLUMETO: "fijar volumen a %1%",
  	"music.changeTempo": "cambiar el tempo en %1",
  	"music.setTempo": "fijar tempo a %1",
  	"pen.clear": "borrar todo",
  	"pen.stamp": "sellar",
  	"pen.penDown": "bajar lápiz",
  	"pen.penUp": "subir lápiz",
  	"pen.setColor": "fijar color de lápiz a %1",
  	"pen.changeHue": "cambiar color de lápiz en %1",
  	"pen.setColorParam": "fijar %1 de lápiz a %2",
  	"pen.changeColorParam": "cambiar %1 de lápiz en %2",
  	"pen.setHue": "fijar color de lápiz a %1",
  	"pen.changeShade": "cambiar sombra de lápiz en %1",
  	"pen.setShade": "fijar sombra de lápiz a %1",
  	"pen.changeSize": "cambiar tamaño de lápiz en %1",
  	"pen.setSize": "fijar tamaño de lápiz a %1",
  	EVENT_WHENFLAGCLICKED: "al presionar @greenFlag",
  	EVENT_WHENKEYPRESSED: "al presionar tecla %1",
  	EVENT_WHENTHISSPRITECLICKED: "al hacer clic en este objeto",
  	EVENT_WHENSTAGECLICKED: "al hacer clic en el escenario",
  	EVENT_WHENBACKDROPSWITCHESTO: "cuando el fondo cambie a %1",
  	EVENT_WHENGREATERTHAN: "cuando %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "al recibir %1",
  	EVENT_BROADCAST: "enviar %1",
  	EVENT_BROADCASTANDWAIT: "enviar %1 y esperar",
  	CONTROL_WAIT: "esperar %1 segundos",
  	CONTROL_REPEAT: "repetir %1",
  	CONTROL_FOREVER: "por siempre",
  	CONTROL_IF: "si %1 entonces",
  	CONTROL_WAITUNTIL: "esperar hasta que %1",
  	CONTROL_REPEATUNTIL: "repetir hasta que %1",
  	CONTROL_STOP: "detener %1",
  	CONTROL_STARTASCLONE: "al comenzar como clon",
  	CONTROL_CREATECLONEOF: "crear clon de %1",
  	CONTROL_DELETETHISCLONE: "eliminar este clon",
  	SENSING_ASKANDWAIT: "preguntar %1 y esperar",
  	"videoSensing.videoToggle": "%1 video",
  	"videoSensing.setVideoTransparency": "fijar transparencia de video a %1",
  	"videoSensing.whenMotionGreaterThan": "cuando el movimiento del video > %1",
  	SENSING_RESETTIMER: "reiniciar cronómetro",
  	DATA_SETVARIABLETO: "fijar %1 a %2",
  	DATA_CHANGEVARIABLEBY: "cambiar %1 en %2",
  	DATA_SHOWVARIABLE: "mostrar variable %1",
  	DATA_HIDEVARIABLE: "esconder variable %1",
  	DATA_ADDTOLIST: "añadir %1 a %2",
  	DATA_DELETEOFLIST: "eliminar %1 de %2",
  	DATA_DELETEALLOFLIST: "Eliminar todos de %1",
  	MOTION_IFONEDGEBOUNCE: "si toca un borde, rebotar",
  	DATA_INSERTATLIST: "insertar %1 en %2 de %3",
  	DATA_REPLACEITEMOFLIST: "reemplazar elemento %1 de %2 con %3",
  	DATA_SHOWLIST: "mostrar lista %1",
  	DATA_HIDELIST: "esconder lista %1",
  	SENSING_OF_XPOSITION: "posición en x",
  	SENSING_OF_YPOSITION: "posición en y",
  	SENSING_OF_DIRECTION: "dirección",
  	SENSING_OF_COSTUMENUMBER: "# de disfraz",
  	LOOKS_COSTUMENUMBERNAME: "disfraz %1",
  	SENSING_OF_SIZE: "tamaño",
  	SENSING_OF_BACKDROPNAME: "nombre de fondo",
  	LOOKS_BACKDROPNUMBERNAME: "fondo %1",
  	SENSING_OF_BACKDROPNUMBER: "# de fondo",
  	SOUND_VOLUME: "volumen",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "¿tocando %1?",
  	SENSING_TOUCHINGCOLOR: "¿tocando el color %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "¿color %1 está tocando %2?",
  	SENSING_DISTANCETO: "distancia a %1",
  	SENSING_ANSWER: "respuesta",
  	SENSING_KEYPRESSED: "¿tecla %1 presionada?",
  	SENSING_MOUSEDOWN: "¿ratón presionado?",
  	SENSING_MOUSEX: "posición x del ratón",
  	SENSING_MOUSEY: "posición y del ratón",
  	SENSING_SETDRAGMODE: "fijar modo de arrastre a %1",
  	SENSING_LOUDNESS: "volumen del sonido",
  	"videoSensing.videoOn": "%1 del video en %2",
  	SENSING_TIMER: "cronómetro",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "%1 actual",
  	SENSING_DAYSSINCE2000: "días desde el 2000",
  	SENSING_USERNAME: "nombre de usuario",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "elegir número al azar entre %1 y %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 y %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "no %1",
  	OPERATORS_JOIN: "unir %1 %2",
  	OPERATORS_LETTEROF: "letra %1 de %2",
  	OPERATORS_LENGTH: "longitud de %1",
  	OPERATORS_MOD: "%1 módulo %2",
  	OPERATORS_ROUND: "redondear %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "¿%1 contiene %2?",
  	DATA_ITEMOFLIST: "elemento %1 de %2",
  	DATA_ITEMNUMOFLIST: "# de elemento de %1 en %2",
  	DATA_LENGTHOFLIST: "longitud de %1",
  	DATA_LISTCONTAINSITEM: "¿%2 está en %1?",
  	CONTROL_ELSE: "si no",
  	SENSING_USERID: "nombre de usuario",
  	SENSING_LOUD: "¿fuerte?",
  	"text2speech.speakAndWaitBlock": "decir %1",
  	"text2speech.setVoiceBlock": "fijar voz a %1",
  	"text2speech.setLanguageBlock": "fijar idioma a %1",
  	"translate.translateBlock": "traducir %1 al %2",
  	"translate.viewerLanguage": "idioma",
  	"makeymakey.whenKeyPressed": "al presionar la tecla %1",
  	"makeymakey.whenKeysPressedInOrder": "al presionar en orden %1",
  	"microbit.whenButtonPressed": "al presionar botón %1",
  	"microbit.isButtonPressed": "¿botón %1 presionado?",
  	"microbit.whenGesture": "al %1",
  	"microbit.displaySymbol": "mostrar %1",
  	"microbit.displayText": "mostrar texto %1",
  	"microbit.clearDisplay": "limpiar pantalla",
  	"microbit.whenTilted": "al inclinar %1",
  	"microbit.isTilted": "¿inclinado hacia %1?",
  	"microbit.tiltAngle": "ángulo de inclinación hacia %1",
  	"microbit.whenPinConnected": "al conectar pin %1",
  	"ev3.motorTurnClockwise": "girar motor %1 hacia acá durante %2 segundos",
  	"ev3.motorTurnCounterClockwise": "girar motor %1 hacia allá durante %2 segundos",
  	"ev3.motorSetPower": "fijar potencia de motor %1 a %2%",
  	"ev3.getMotorPosition": "posición del motor %1",
  	"ev3.whenButtonPressed": "al presionar botón %1",
  	"ev3.whenDistanceLessThan": "cuando distancia < %1",
  	"ev3.whenBrightnessLessThan": "cuando brillo < %1",
  	"ev3.buttonPressed": "¿botón %1 presionado?",
  	"ev3.getDistance": "distancia",
  	"ev3.getBrightness": "brillo",
  	"ev3.beepNote": "tocar nota %1 durante %2 segundos",
  	"wedo2.motorOn": "encender %1",
  	"wedo2.motorOff": "apagar %1",
  	"wedo2.startMotorPower": "fijar potencia de %1 a %2",
  	"wedo2.setMotorDirection": "fijar dirección de %1 hacia %2",
  	"wedo2.whenDistance": "cuando distancia %1 %2",
  	"wedo2.getDistance": "distancia",
  	"wedo2.motorOnFor": "encender %1 durante %2 segundos",
  	"wedo2.setLightHue": "fijar color de la luz a %1",
  	"wedo2.playNoteFor": "tocar nota %1 durante %2 segundos",
  	"wedo2.whenTilted": "al inclinar hacia %1",
  	"wedo2.isTilted": "¿inclinado hacia %1?",
  	"wedo2.getTiltAngle": "ángulo de inclinación hacia %1",
  	"gdxfor.whenGesture": "al %1",
  	"gdxfor.whenForcePushedOrPulled": "cuando el sensor de fuerza es %1",
  	"gdxfor.getForce": "fuerza",
  	"gdxfor.whenTilted": "al inclinarse hacia %1",
  	"gdxfor.isTilted": "¿inclinado hacia %1?",
  	"gdxfor.getTilt": "ángulo de inclinación hacia %1",
  	"gdxfor.isFreeFalling": "¿cayendo?",
  	"gdxfor.getSpin": "velocidad de giro %1",
  	"gdxfor.getAcceleration": "aceleración %1",
  	"boost.motorOnFor": "girar motor %1 durante %2 segundos",
  	"boost.motorOnForRotation": "girar motor %1 por %2 vueltas",
  	"boost.motorOn": "encender motor %1",
  	"boost.motorOff": "apagar motor %1",
  	"boost.setMotorPower": "fijar velocidad del motor %1 a %2 %",
  	"boost.setMotorDirection": "fijar dirección de motor %1 hacia %2",
  	"boost.getMotorPosition": "posición de motor %1",
  	"boost.whenColor": "cuando vea pieza %1",
  	"boost.seeingColor": "¿viendo pieza %1?",
  	"boost.whenTilted": "al inclinar hacia %1",
  	"boost.getTiltAngle": "ángulo de inclinación hacia %1",
  	"boost.setLightHue": "fijar color de luz a %1"
  };
  var dropdowns$W = {
  };
  var ignorelt$W = [
  ];
  var soundEffects$W = [
  	"tono",
  	"paneo izquierda/derecha"
  ];
  var microbitWhen$W = [
  	"mover",
  	"agitar",
  	"saltar"
  ];
  var osis$W = [
  	"otros programas en el objeto"
  ];
  var definePrefix$W = [
  	"definir"
  ];
  var defineSuffix$W = [
  ];
  var palette$W = {
  	Motion: "Movimiento",
  	Looks: "Apariencia",
  	Sound: "Sonido",
  	Events: "Eventos",
  	Control: "Control",
  	Sensing: "Sensores",
  	Operators: "Operadores",
  	Variables: "Variables",
  	"My Blocks": "Mis Bloques"
  };
  var math$W = [
  	"valor absoluto",
  	"piso",
  	"techo",
  	"raíz cuadrada",
  	"sen",
  	"cos",
  	"tan",
  	"arcsen",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$W = {
  };
  var name$W = "Español Latinoamericano";
  var percentTranslated$W = 100;
  var es_419 = {
  	commands: commands$W,
  	dropdowns: dropdowns$W,
  	ignorelt: ignorelt$W,
  	soundEffects: soundEffects$W,
  	microbitWhen: microbitWhen$W,
  	osis: osis$W,
  	definePrefix: definePrefix$W,
  	defineSuffix: defineSuffix$W,
  	palette: palette$W,
  	math: math$W,
  	aliases: aliases$W,
  	name: name$W,
  	percentTranslated: percentTranslated$W
  };

  var commands$V = {
  	MOTION_MOVESTEPS: "liigu %1 punkti",
  	MOTION_TURNRIGHT: "pööra @turnRight %1 kraadi",
  	MOTION_TURNLEFT: "pööra @turnLeft %1 kraadi",
  	MOTION_POINTINDIRECTION: "osuta suunas %1",
  	MOTION_POINTTOWARDS: "osuta %1-le",
  	MOTION_GOTOXY: "mine x: %1 y: %2",
  	MOTION_GOTO: "mine %1",
  	MOTION_GLIDESECSTOXY: "liugle %1 sekundiga x: %2 y: %3",
  	MOTION_GLIDETO: "liugle %1 sekundiga %2",
  	MOTION_CHANGEXBY: "muuda x %1 võrra",
  	MOTION_SETX: "võta x %1",
  	MOTION_CHANGEYBY: "muuda y %1 võrra",
  	MOTION_SETY: "võta y %1",
  	MOTION_SETROTATIONSTYLE: "määra pööramisstiil %1",
  	LOOKS_SAYFORSECS: "ütle %1 %2 sek",
  	LOOKS_SAY: "ütle %1",
  	LOOKS_THINKFORSECS: "mõtle %1 %2 sek",
  	LOOKS_THINK: "mõtle %1",
  	LOOKS_SHOW: "näita",
  	LOOKS_HIDE: "peida",
  	LOOKS_SWITCHCOSTUMETO: "võta kostüüm %1",
  	LOOKS_NEXTCOSTUME: "järgmine kostüüm",
  	LOOKS_NEXTBACKDROP_BLOCK: "järgmine taust",
  	LOOKS_SWITCHBACKDROPTO: "võta taust %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "võta taust %1 ja oota",
  	LOOKS_CHANGEEFFECTBY: "muuda efekti %1 %2 võrra",
  	LOOKS_SETEFFECTTO: "pane %1 efekt %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "tühista graafikaefektid",
  	LOOKS_CHANGESIZEBY: "muuda suurust %1 võrra",
  	LOOKS_SETSIZETO: "võta suuruseks %1 %",
  	LOOKS_GOTOFRONTBACK: "mine kihile %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "mine %1 %2 kihti",
  	SOUND_PLAY: "alusta heli %1",
  	SOUND_CHANGEEFFECTBY: "muuda efekti %1 %2 võrra",
  	SOUND_SETEFFECTO: "pane %1 efekt %2",
  	SOUND_CLEAREFFECTS: "vaigista heliefektid",
  	SOUND_PLAYUNTILDONE: "mängi heli %1 kuni lõpuni",
  	SOUND_STOPALLSOUNDS: "peata kõik helid",
  	"music.playDrumForBeats": "mängi trummi %1 kestusega %2",
  	"music.restForBeats": "paus %1 lööki",
  	"music.playNoteForBeats": "mängi nooti %1 %2 lööki",
  	"music.setInstrument": "võta instrumendiks %1",
  	SOUND_CHANGEVOLUMEBY: "muuda helitugevust %1 võrra",
  	SOUND_SETVOLUMETO: "võta helitugevuseks %1%",
  	"music.changeTempo": "muuda tempot %1 võrra",
  	"music.setTempo": "võta tempoks %1",
  	"pen.clear": "kustuta kõik",
  	"pen.stamp": "jäljend",
  	"pen.penDown": "pliiats alla",
  	"pen.penUp": "pliiats üles",
  	"pen.setColor": "võta pliiatsi värviks %1",
  	"pen.changeHue": "muuda pliiatsi värvi %1 võrra",
  	"pen.setColorParam": "võta pliiatsi %1 %2",
  	"pen.changeColorParam": "muuda pliiatsi %1 %2 võrra",
  	"pen.setHue": "võta pliiatsi värviks %1",
  	"pen.changeShade": "muuda pliiatsi varjundit %1 võrra",
  	"pen.setShade": "võta pliiatsi varjundiks %1",
  	"pen.changeSize": "muuda pliiatsi suurust %1 võrra",
  	"pen.setSize": "võta pliiatsi suuruseks %1",
  	EVENT_WHENFLAGCLICKED: "kui klõpsata @greenFlag",
  	EVENT_WHENKEYPRESSED: "kui klõpsata klahvi %1",
  	EVENT_WHENTHISSPRITECLICKED: "kui spraiti klõpsata",
  	EVENT_WHENSTAGECLICKED: "kui lava klõpsata",
  	EVENT_WHENBACKDROPSWITCHESTO: "kui taustaks saab %1",
  	EVENT_WHENGREATERTHAN: "kui %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kui saan teate %1",
  	EVENT_BROADCAST: "teata %1",
  	EVENT_BROADCASTANDWAIT: "teata %1 ja oota",
  	CONTROL_WAIT: "oota %1 sek",
  	CONTROL_REPEAT: "korda %1 korda",
  	CONTROL_FOREVER: "korda lõputult",
  	CONTROL_IF: "kui %1 siis",
  	CONTROL_WAITUNTIL: "oota kuni %1",
  	CONTROL_REPEATUNTIL: "korda kuni %1",
  	CONTROL_STOP: "stopp %1",
  	CONTROL_STARTASCLONE: "kui alustan kloonina",
  	CONTROL_CREATECLONEOF: "klooni %1",
  	CONTROL_DELETETHISCLONE: "eemalda see kloon",
  	SENSING_ASKANDWAIT: "küsi %1 ja oota",
  	"videoSensing.videoToggle": "lülita video %1",
  	"videoSensing.setVideoTransparency": "võta video läbipaistvus %1",
  	"videoSensing.whenMotionGreaterThan": "kui video liikumine > %1",
  	SENSING_RESETTIMER: "nulli taimer",
  	DATA_SETVARIABLETO: "võta %1 = %2",
  	DATA_CHANGEVARIABLEBY: "muuda %1 %2 võrra",
  	DATA_SHOWVARIABLE: "näita muutujat %1",
  	DATA_HIDEVARIABLE: "peida muutuja %1",
  	DATA_ADDTOLIST: "lisa %1 loendisse %2",
  	DATA_DELETEOFLIST: "eemalda %1 loendist %2",
  	DATA_DELETEALLOFLIST: "eemalda kõik loendist %1",
  	MOTION_IFONEDGEBOUNCE: "kui äärel, põrka",
  	DATA_INSERTATLIST: "sisesta %1 kohale %2 loendis %3",
  	DATA_REPLACEITEMOFLIST: "asenda väärtus %1 loendis %2 %3 -ga",
  	DATA_SHOWLIST: "näita loendit %1",
  	DATA_HIDELIST: "peida loend %1",
  	SENSING_OF_XPOSITION: "x",
  	SENSING_OF_YPOSITION: "y",
  	SENSING_OF_DIRECTION: "suund",
  	SENSING_OF_COSTUMENUMBER: "kostüümi nr",
  	LOOKS_COSTUMENUMBERNAME: "kostüümi %1",
  	SENSING_OF_SIZE: "suurus",
  	SENSING_OF_BACKDROPNAME: "tausta nimi",
  	LOOKS_BACKDROPNUMBERNAME: "tausta %1",
  	SENSING_OF_BACKDROPNUMBER: "tausta nr",
  	SOUND_VOLUME: "helitugevus",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "puudutab %1?",
  	SENSING_TOUCHINGCOLOR: "puudutab värvi %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "värv %1 puudutab värvi %2?",
  	SENSING_DISTANCETO: "kaugus %1-st",
  	SENSING_ANSWER: "vastus",
  	SENSING_KEYPRESSED: "klahv %1 all?",
  	SENSING_MOUSEDOWN: "hiir all?",
  	SENSING_MOUSEX: "hiire x",
  	SENSING_MOUSEY: "hiire y",
  	SENSING_SETDRAGMODE: "võta lohistatavus = %1",
  	SENSING_LOUDNESS: "valjus",
  	"videoSensing.videoOn": "%2 video %1",
  	SENSING_TIMER: "taimer",
  	SENSING_OF: "%2 %1",
  	SENSING_CURRENT: "hetke %1",
  	SENSING_DAYSSINCE2000: "päevi alates 2000",
  	SENSING_USERNAME: "kasutajanimi",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "juhuarv %1 kuni %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 ja %2",
  	OPERATORS_OR: "%1 või %2",
  	OPERATORS_NOT: "mitte %1",
  	OPERATORS_JOIN: "%1 & %2",
  	OPERATORS_LETTEROF: "märk %1 sõnas %2",
  	OPERATORS_LENGTH: "%1 pikkus",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "ümarda %1",
  	OPERATORS_MATHOP: "%2 %1",
  	OPERATORS_CONTAINS: "%1 sisaldab %2?",
  	DATA_ITEMOFLIST: "%1 loendis %2",
  	DATA_ITEMNUMOFLIST: "%1 jrk nr loendis %2",
  	DATA_LENGTHOFLIST: "%1 pikkus",
  	DATA_LISTCONTAINSITEM: "%1 sisaldab %2?",
  	CONTROL_ELSE: "muidu",
  	SENSING_USERID: "kasutaja ID",
  	SENSING_LOUD: "väga vali?",
  	"text2speech.speakAndWaitBlock": "ütle %1",
  	"text2speech.setVoiceBlock": "võta hääleks %1",
  	"text2speech.setLanguageBlock": "võta keeleks %1",
  	"translate.translateBlock": "tõlgi %1 %2 keelde",
  	"translate.viewerLanguage": "keel",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "kui %1 nupp all",
  	"microbit.isButtonPressed": "%1 nupp all?",
  	"microbit.whenGesture": "kui %1",
  	"microbit.displaySymbol": "kuva %1",
  	"microbit.displayText": "kuva tekst %1",
  	"microbit.clearDisplay": "tühjenda kuva",
  	"microbit.whenTilted": "kui kallutatud %1",
  	"microbit.isTilted": "kallutatud %1?",
  	"microbit.tiltAngle": "kaldenurk %1",
  	"microbit.whenPinConnected": "Kui %1 ühendas",
  	"ev3.motorTurnClockwise": "pööra mootor %1 päripäeva %2 sek",
  	"ev3.motorTurnCounterClockwise": "pööra mootor %1 vastupäeva %2 sek",
  	"ev3.motorSetPower": "võta mootori %1 võimsus %2 %",
  	"ev3.getMotorPosition": "mootori %1 positsioon",
  	"ev3.whenButtonPressed": "kui nupp %1 all",
  	"ev3.whenDistanceLessThan": "kui kaugus < %1",
  	"ev3.whenBrightnessLessThan": "kui heledus < %1",
  	"ev3.buttonPressed": "nupp %1 all?",
  	"ev3.getDistance": "kaugus",
  	"ev3.getBrightness": "heledus",
  	"ev3.beepNote": "mängi nooti %1 %2 sek",
  	"wedo2.motorOn": "lülita %1 sisse",
  	"wedo2.motorOff": "lülita %1 välja",
  	"wedo2.startMotorPower": "võta %1 võimsuseks %2",
  	"wedo2.setMotorDirection": "võta %1 suunaks %2",
  	"wedo2.whenDistance": "kui kaugus %1 %2",
  	"wedo2.getDistance": "kaugus",
  	"wedo2.motorOnFor": "lülita %1 sisse %2 sek",
  	"wedo2.setLightHue": "võta LED värviks %1",
  	"wedo2.playNoteFor": "mängi nooti %1 %2 sek",
  	"wedo2.whenTilted": "kui kallutatud %1",
  	"wedo2.isTilted": "kallutatud %1?",
  	"wedo2.getTiltAngle": "kaldenurk %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$V = {
  };
  var ignorelt$V = [
  ];
  var soundEffects$V = [
  	"helikõrgus",
  	"heli vasakul/paremal"
  ];
  var microbitWhen$V = [
  	"liikus",
  	"rappus",
  	"hüppas"
  ];
  var osis$V = [
  	"teised spraidi skriptid"
  ];
  var definePrefix$V = [
  	"defineeri"
  ];
  var defineSuffix$V = [
  ];
  var palette$V = {
  	Motion: "Liikumine",
  	Looks: "Välimus",
  	Sound: "Helid",
  	Events: "Sündmused",
  	Control: "Juhtimine",
  	Sensing: "Andurid",
  	Operators: "Tehted",
  	Variables: "Muutujad",
  	"My Blocks": "Minu Plokid"
  };
  var math$V = [
  	"abs",
  	"floor",
  	"ceiling",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$V = {
  };
  var name$V = "Eesti";
  var percentTranslated$V = 100;
  var et = {
  	commands: commands$V,
  	dropdowns: dropdowns$V,
  	ignorelt: ignorelt$V,
  	soundEffects: soundEffects$V,
  	microbitWhen: microbitWhen$V,
  	osis: osis$V,
  	definePrefix: definePrefix$V,
  	defineSuffix: defineSuffix$V,
  	palette: palette$V,
  	math: math$V,
  	aliases: aliases$V,
  	name: name$V,
  	percentTranslated: percentTranslated$V
  };

  var commands$U = {
  	MOTION_MOVESTEPS: "mugitu %1 pausu",
  	MOTION_TURNRIGHT: "biratu @turnRight %1 gradu",
  	MOTION_TURNLEFT: "biratu @turnLeft %1 gradu",
  	MOTION_POINTINDIRECTION: "apuntatu norabidea: %1",
  	MOTION_POINTTOWARDS: "jarri hona begira: %1",
  	MOTION_GOTOXY: "joan x: %1 y: %2 kokapenera",
  	MOTION_GOTO: "joan hona %1",
  	MOTION_GLIDESECSTOXY: "Irristatu %1 segundotan hona x: %2 y: %3",
  	MOTION_GLIDETO: "Irristatu %1 segundotan hona: %2",
  	MOTION_CHANGEXBY: "aldatu x %1 unitate",
  	MOTION_SETX: "ezarri x: %1",
  	MOTION_CHANGEYBY: "aldatu y %1 unitate",
  	MOTION_SETY: "ezarri y: %1",
  	MOTION_SETROTATIONSTYLE: "ezarri biraketa modua: %1",
  	LOOKS_SAYFORSECS: "esan %1 %2 segundoz",
  	LOOKS_SAY: "esan %1",
  	LOOKS_THINKFORSECS: "pentsatu %1  %2 segundoz",
  	LOOKS_THINK: "pentsatu %1",
  	LOOKS_SHOW: "erakutsi",
  	LOOKS_HIDE: "ezkutatu",
  	LOOKS_SWITCHCOSTUMETO: "aldatu tankera %1 ra",
  	LOOKS_NEXTCOSTUME: "hurrengo tankera",
  	LOOKS_NEXTBACKDROP_BLOCK: "hurrengo atzeko oihala",
  	LOOKS_SWITCHBACKDROPTO: "aldatu atzeko oihala %1 ra",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "aldatu atzeko oihala %1 ra eta itxaron",
  	LOOKS_CHANGEEFFECTBY: "aldatu %1 efektua %2 unitate",
  	LOOKS_SETEFFECTTO: "ezarri %1 efektua %2 ri",
  	LOOKS_CLEARGRAPHICEFFECTS: "kendu efektu grafikoak",
  	LOOKS_CHANGESIZEBY: "aldatu tamaina %1 unitate",
  	LOOKS_SETSIZETO: "ezarri tamaina: % %1",
  	LOOKS_GOTOFRONTBACK: "joan %1 geruzara",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "joan %1 geruza %2",
  	SOUND_PLAY: "hasi %1 soinua",
  	SOUND_CHANGEEFFECTBY: "aldatu %1 efektua %2 unitate",
  	SOUND_SETEFFECTO: "ezarri %1 efektua: %2",
  	SOUND_CLEAREFFECTS: "kendu soinu-efektuak",
  	SOUND_PLAYUNTILDONE: "jo %1 soinua amaitu arte",
  	SOUND_STOPALLSOUNDS: "gelditu soinu guztiak",
  	"music.playDrumForBeats": "jo  %1danborrean %2 pultsuz",
  	"music.restForBeats": "isilunea %1 pultsuz",
  	"music.playNoteForBeats": "jo %1 nota %2 pultsuz",
  	"music.setInstrument": "ezarri %1 tresna",
  	SOUND_CHANGEVOLUMEBY: "aldatu bolumena %1 unitate",
  	SOUND_SETVOLUMETO: "ezarri bolumena: %1%",
  	"music.changeTempo": "aldatu tempoa %1 unitate",
  	"music.setTempo": "ezarri %1 tempoa",
  	"pen.clear": "ezabatu guztia",
  	"pen.stamp": "zigilatu",
  	"pen.penDown": "jaitsi arkatza",
  	"pen.penUp": "igo arkatza",
  	"pen.setColor": "ezarri arkatzaren kolorea: %1",
  	"pen.changeHue": "aldatu arkatzaren kolorea %1 tonu",
  	"pen.setColorParam": "ezarri arkatzaren %1: %2",
  	"pen.changeColorParam": "aldatu arkatzaren %1%2 unitate",
  	"pen.setHue": "ezarri arkatzaren kolorea: %1",
  	"pen.changeShade": "aldatu arkatzaren itzala %1 unitate",
  	"pen.setShade": "ezarri arkatzaren itzala: %1",
  	"pen.changeSize": "aldatu arkatzaren tamaina %1 unitate",
  	"pen.setSize": "ezarri arkatzaren tamaina: %1",
  	EVENT_WHENFLAGCLICKED: "@greenFlag klik egitean",
  	EVENT_WHENKEYPRESSED: "%1 tekla sakatzean",
  	EVENT_WHENTHISSPRITECLICKED: "pertsonai honetan klik egitean",
  	EVENT_WHENSTAGECLICKED: "Eszenan klik egitean",
  	EVENT_WHENBACKDROPSWITCHESTO: "atzeko oihala %1 ra aldatzen denean",
  	EVENT_WHENGREATERTHAN: "%1  > %2 bada",
  	EVENT_WHENBROADCASTRECEIVED: "%1 jasotzean",
  	EVENT_BROADCAST: "bidali %1 guztiei",
  	EVENT_BROADCASTANDWAIT: "bidali %1 guztiei eta itxaron",
  	CONTROL_WAIT: "itxaron %1 segundo",
  	CONTROL_REPEAT: "errepikatu %1 aldiz",
  	CONTROL_FOREVER: "etengabe",
  	CONTROL_IF: "baldin %1 orduan",
  	CONTROL_WAITUNTIL: "itxaron %1 arte",
  	CONTROL_REPEATUNTIL: "errepikatu %1 arte",
  	CONTROL_STOP: "gelditu %1",
  	CONTROL_STARTASCLONE: "klon moduan hasten naizenean",
  	CONTROL_CREATECLONEOF: "sortu %1 ren klona",
  	CONTROL_DELETETHISCLONE: "ezabatu klon hau",
  	SENSING_ASKANDWAIT: "galdetu %1 eta itxaron",
  	"videoSensing.videoToggle": "%1 bideoa",
  	"videoSensing.setVideoTransparency": "ezarri bideo gardentasuna: %1",
  	"videoSensing.whenMotionGreaterThan": "bideo-mugimendua > %1 denean",
  	SENSING_RESETTIMER: "berrabiarazi kronometroa",
  	DATA_SETVARIABLETO: "ezarri %1: %2",
  	DATA_CHANGEVARIABLEBY: "aldatu %1 %2 unitate",
  	DATA_SHOWVARIABLE: "erakutsi %1 aldagaia",
  	DATA_HIDEVARIABLE: "ezkutatu %1 aldagaia",
  	DATA_ADDTOLIST: "batu %1 %2 ri",
  	DATA_DELETEOFLIST: "ezabatu %1 %2 tik",
  	DATA_DELETEALLOFLIST: "ezabatu %1-ko guztia",
  	MOTION_IFONEDGEBOUNCE: "errebotatu ertza ukitzean",
  	DATA_INSERTATLIST: "txertatu %1  %3 -ren %2 -an",
  	DATA_REPLACEITEMOFLIST: "aldatu %2 -ko %1 elementua %3 -rekin",
  	DATA_SHOWLIST: "erakutsi %1 zerrenda",
  	DATA_HIDELIST: "ezkutatu %1 zerrenda",
  	SENSING_OF_XPOSITION: "x kokapena",
  	SENSING_OF_YPOSITION: "y kokapena",
  	SENSING_OF_DIRECTION: "norabidea",
  	SENSING_OF_COSTUMENUMBER: "# tankera",
  	LOOKS_COSTUMENUMBERNAME: "%1 tankera",
  	SENSING_OF_SIZE: "tamaina",
  	SENSING_OF_BACKDROPNAME: "atzeko oihalaren izena",
  	LOOKS_BACKDROPNUMBERNAME: "%1 atzeko oihala",
  	SENSING_OF_BACKDROPNUMBER: "# atzeko oihala",
  	SOUND_VOLUME: "bolumena",
  	"music.getTempo": "tempoa",
  	SENSING_TOUCHINGOBJECT: "%1 ukitzen?",
  	SENSING_TOUCHINGCOLOR: "%1 kolorea ukitzen?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 koloreak %2 ukitzen du?",
  	SENSING_DISTANCETO: "%1 rako distantzia",
  	SENSING_ANSWER: "erantzuna",
  	SENSING_KEYPRESSED: "%1 tekla sakatuta?",
  	SENSING_MOUSEDOWN: "sagua sakatuta?",
  	SENSING_MOUSEX: "saguaren x",
  	SENSING_MOUSEY: "saguaren y",
  	SENSING_SETDRAGMODE: "ezarri arrastea %1 moduan",
  	SENSING_LOUDNESS: "ozentasuna",
  	"videoSensing.videoOn": "bideo- %1 hemen: %2",
  	SENSING_TIMER: "kronometroa",
  	SENSING_OF: "%2 tik %1",
  	SENSING_CURRENT: "oraingo %1",
  	SENSING_DAYSSINCE2000: "2000tik geroztiko egunak",
  	SENSING_USERNAME: "erabiltzaile-izena",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 eta %2 arteko ausazko balioa",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 eta %2",
  	OPERATORS_OR: "%1 edo %2",
  	OPERATORS_NOT: "%1 ez",
  	OPERATORS_JOIN: "elkartu %1 %2 rekin",
  	OPERATORS_LETTEROF: "%1. letra %2 tik",
  	OPERATORS_LENGTH: "%1 ren luzera",
  	OPERATORS_MOD: "%1 modulu %2",
  	OPERATORS_ROUND: "biribildu %1",
  	OPERATORS_MATHOP: "%2 tik %1",
  	OPERATORS_CONTAINS: "%1(e)k bere baitan al du %2?",
  	DATA_ITEMOFLIST: "%2 tik %1. elementua",
  	DATA_ITEMNUMOFLIST: "%1 tik #. elementua %2 n",
  	DATA_LENGTHOFLIST: "%1 ren luzera",
  	DATA_LISTCONTAINSITEM: "%1 k bere baitan al du %2?",
  	CONTROL_ELSE: "bestela",
  	SENSING_USERID: "erabiltzaile-id",
  	SENSING_LOUD: "ozen?",
  	"text2speech.speakAndWaitBlock": "esan %1",
  	"text2speech.setVoiceBlock": "ezarri ahotsa: %1",
  	"text2speech.setLanguageBlock": "ezarri hizkuntza: %1",
  	"translate.translateBlock": "itzuli %1  %2-ra",
  	"translate.viewerLanguage": "hizkuntza",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "%1 botoia sakatzean",
  	"microbit.isButtonPressed": "%1 botoia sakatuta dago?",
  	"microbit.whenGesture": "%1 antzematean",
  	"microbit.displaySymbol": "bistaratu %1",
  	"microbit.displayText": "bistaratu %1 testua",
  	"microbit.clearDisplay": "garbitu pantaila",
  	"microbit.whenTilted": "%1-ra okertuta dagoenean",
  	"microbit.isTilted": "%1-ra okertuta dago?",
  	"microbit.tiltAngle": "okertu angelua %1",
  	"microbit.whenPinConnected": "%1 pina konektatuta dagoenean",
  	"ev3.motorTurnClockwise": "biratu %1 motorra norabide honetan %2 segundoz",
  	"ev3.motorTurnCounterClockwise": "biratu  %1 motorra norabide horretan %2 segundoz",
  	"ev3.motorSetPower": "ezarri %1 motorra % %2 potentzian",
  	"ev3.getMotorPosition": "%1 motorraren kokapena",
  	"ev3.whenButtonPressed": "%1 botoia sakatzean",
  	"ev3.whenDistanceLessThan": "distantzia < %1 denean",
  	"ev3.whenBrightnessLessThan": "distira < %1 denean",
  	"ev3.buttonPressed": "%1 botoia sakatuta dago?",
  	"ev3.getDistance": "distantzia",
  	"ev3.getBrightness": "distira",
  	"ev3.beepNote": "jo %1 nota %2 segundoz",
  	"wedo2.motorOn": "piztu %1",
  	"wedo2.motorOff": "itzali %1",
  	"wedo2.startMotorPower": "ezarri %1 potentzia: %2",
  	"wedo2.setMotorDirection": "ezarri %1 norabidea: %2",
  	"wedo2.whenDistance": "distantzia %1 %2 denean",
  	"wedo2.getDistance": "distantzia",
  	"wedo2.motorOnFor": "piztu %1  %2 segundoz",
  	"wedo2.setLightHue": "ezarri argiaren kolorea: %1",
  	"wedo2.playNoteFor": "jo %1 nota %2 segundoz",
  	"wedo2.whenTilted": "okertasuna %1 denean",
  	"wedo2.isTilted": "%1 okertuta?",
  	"wedo2.getTiltAngle": "inklinazio angelua %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$U = {
  };
  var ignorelt$U = [
  ];
  var soundEffects$U = [
  	"tonua",
  	"ezker/eskuin balantzea"
  ];
  var microbitWhen$U = [
  	"mugitua",
  	"astindua",
  	"salto egina"
  ];
  var osis$U = [
  	"pertsonaiaren beste script batzuk"
  ];
  var definePrefix$U = [
  	"definitu"
  ];
  var defineSuffix$U = [
  ];
  var palette$U = {
  	Motion: "Mugimendua",
  	Looks: "Itxura",
  	Sound: "Soinua",
  	Events: "Gertaerak",
  	Control: "Kontrola",
  	Sensing: "Sentsoreak",
  	Operators: "Eragileak",
  	Variables: "Aldagaiak",
  	"My Blocks": "Nire blokeak"
  };
  var math$U = [
  	"balio absolutu",
  	"zoru-funtzioa",
  	"sabai-funtzioa",
  	"erro karratua",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$U = {
  };
  var name$U = "Euskara";
  var percentTranslated$U = 100;
  var eu = {
  	commands: commands$U,
  	dropdowns: dropdowns$U,
  	ignorelt: ignorelt$U,
  	soundEffects: soundEffects$U,
  	microbitWhen: microbitWhen$U,
  	osis: osis$U,
  	definePrefix: definePrefix$U,
  	defineSuffix: defineSuffix$U,
  	palette: palette$U,
  	math: math$U,
  	aliases: aliases$U,
  	name: name$U,
  	percentTranslated: percentTranslated$U
  };

  var commands$T = {
  	MOTION_MOVESTEPS: "حرکت کن  %1 گام",
  	MOTION_TURNRIGHT: "بچرخ @turnRight %1 درجه",
  	MOTION_TURNLEFT: "بچرخ @turnLeft %1 درجه",
  	MOTION_POINTINDIRECTION: "در جهت %1 قرار بگیر",
  	MOTION_POINTTOWARDS: "به سمت %1 قرار بگیر",
  	MOTION_GOTOXY: "برو به x: %1 و y: %2",
  	MOTION_GOTO: "برو به %1",
  	MOTION_GLIDESECSTOXY: "سر بخور در %1 ثانیه به x: %2 و y: %3",
  	MOTION_GLIDETO: "سر بخور در %1 ثانیه به %2",
  	MOTION_CHANGEXBY: "تغییر x به اندازه %1 تا",
  	MOTION_SETX: "x برابر %1 شود",
  	MOTION_CHANGEYBY: "تغییر y به اندازه %1 تا",
  	MOTION_SETY: "y برابر %1 شود",
  	MOTION_SETROTATIONSTYLE: "حالت گردش %1 شود",
  	LOOKS_SAYFORSECS: "بگو %1 به مدت %2 ثانیه",
  	LOOKS_SAY: "بگو %1",
  	LOOKS_THINKFORSECS: "فکر کن به %1 به مدت %2 ثانیه",
  	LOOKS_THINK: "فکر کن به %1",
  	LOOKS_SHOW: "ظاهر شو",
  	LOOKS_HIDE: "پنهان شو",
  	LOOKS_SWITCHCOSTUMETO: "تغییر حالت به %1",
  	LOOKS_NEXTCOSTUME: "حالت بعدی",
  	LOOKS_NEXTBACKDROP_BLOCK: "پس‌زمینه‌ی بعدی",
  	LOOKS_SWITCHBACKDROPTO: "تغییر پس‌زمینه به %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "تغییر پس‌زمینه به %1 و منتظر بمان",
  	LOOKS_CHANGEEFFECTBY: "تغییر جلوه‌ی %1 به اندازه %2 تا",
  	LOOKS_SETEFFECTTO: "جلوه‌ی %1 %2 شود",
  	LOOKS_CLEARGRAPHICEFFECTS: "جلوه‌های گرافیکی را پاک کن",
  	LOOKS_CHANGESIZEBY: "تغییر اندازه به مقدار %1 تا",
  	LOOKS_SETSIZETO: "اندازه  %  %1 شود",
  	LOOKS_GOTOFRONTBACK: "برو به %1 لایه",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "برو %2 لایه %1",
  	SOUND_PLAY: "شروع صدای %1",
  	SOUND_CHANGEEFFECTBY: "تغییر افکت %1 به اندازه %2 تا",
  	SOUND_SETEFFECTO: "افکت %1 %2 شود",
  	SOUND_CLEAREFFECTS: "افکت‌های صدا را پاک کن",
  	SOUND_PLAYUNTILDONE: "پخش صدای %1 تا انتها",
  	SOUND_STOPALLSOUNDS: "همه‌ی صدا‌ها را متوقف کن",
  	"music.playDrumForBeats": "نواختن درامز %1 در مدت %2 ضرب",
  	"music.restForBeats": "%1 ضرب سکوت کن",
  	"music.playNoteForBeats": "نواختن نت %1 در مدت  %2 ضرب",
  	"music.setInstrument": "ساز  %1 شود",
  	SOUND_CHANGEVOLUMEBY: "تغییر بلندی صدا به اندازه %1 تا",
  	SOUND_SETVOLUMETO: "بلندی صدا % %1 شود",
  	"music.changeTempo": "تغییر سرعت نواختن به اندازه %1 تا",
  	"music.setTempo": "سرعت نواختن %1 شود",
  	"pen.clear": "همه را پاک کن",
  	"pen.stamp": "مُـهـر بزن",
  	"pen.penDown": "قلم پایین بیاید",
  	"pen.penUp": "قلم بالا برود",
  	"pen.setColor": "رنگ قلم %1 شود",
  	"pen.changeHue": "تغییر رنگ قلم به اندازه %1 تا",
  	"pen.setColorParam": "%1 %2 شود",
  	"pen.changeColorParam": "تغییر %1 قلم به اندازه %2 تا",
  	"pen.setHue": "رنگ قلم %1 شود",
  	"pen.changeShade": "تغییر سایه قلم به اندازه %1 تا",
  	"pen.setShade": "سایه‌ی قلم %1 شود",
  	"pen.changeSize": "تغییر ضخامت قلم به اندازه %1 تا",
  	"pen.setSize": "ضخامت قلم %1 شود",
  	EVENT_WHENFLAGCLICKED: "وقتی‌ @greenFlag کلیک شد",
  	EVENT_WHENKEYPRESSED: "وقتی‌ کلید %1 فشرده شد",
  	EVENT_WHENTHISSPRITECLICKED: "وقتی‌ این شکلک کلیک شد",
  	EVENT_WHENSTAGECLICKED: "وقتی‌ صحنه کلیک شد",
  	EVENT_WHENBACKDROPSWITCHESTO: "وقتی‌ پس‌زمینه به %1 تغییر کرد",
  	EVENT_WHENGREATERTHAN: "وقتی‌ %2 < %1 شد",
  	EVENT_WHENBROADCASTRECEIVED: "وقتی‌ %1 را دریافت کردم",
  	EVENT_BROADCAST: "پخش سراسری %1",
  	EVENT_BROADCASTANDWAIT: "پخش سراسری %1 و منتظر بمان",
  	CONTROL_WAIT: "منتظر بمان %1 ثانیه",
  	CONTROL_REPEAT: "تکرار کن %1",
  	CONTROL_FOREVER: "برای همیشه",
  	CONTROL_IF: "اگر %1 آنگاه",
  	CONTROL_WAITUNTIL: "منتظر بمان تا اینکه %1",
  	CONTROL_REPEATUNTIL: "تکرار کن تا اینکه %1",
  	CONTROL_STOP: "توقف %1",
  	CONTROL_STARTASCLONE: "وقتی‌ به‌عنوان یک مشابه شروع کردم",
  	CONTROL_CREATECLONEOF: "مشابه %1 را بساز",
  	CONTROL_DELETETHISCLONE: "این مشابه را حذف کن",
  	SENSING_ASKANDWAIT: "بپرس %1 و منتظر بمان",
  	"videoSensing.videoToggle": "تشخیص ویدئویی %1 شود",
  	"videoSensing.setVideoTransparency": "شفافیت ویدئو %1 شود",
  	"videoSensing.whenMotionGreaterThan": "وقتی  %1 < حرکت ویدئو",
  	SENSING_RESETTIMER: "بازنشانی زمان سنج",
  	DATA_SETVARIABLETO: "%1 برابر %2 شود",
  	DATA_CHANGEVARIABLEBY: "تغییر %1 به اندازه %2 تا",
  	DATA_SHOWVARIABLE: "متغیر %1 را نمایش بده",
  	DATA_HIDEVARIABLE: "متغیر %1 را پنهان کن",
  	DATA_ADDTOLIST: "افزودن  %1 به %2",
  	DATA_DELETEOFLIST: "حذف %1 از %2",
  	DATA_DELETEALLOFLIST: "حذف همه‌ از %1",
  	MOTION_IFONEDGEBOUNCE: "اگر به لبه رسیدی، برگرد",
  	DATA_INSERTATLIST: "درج %1 در %2 %3",
  	DATA_REPLACEITEMOFLIST: "جایگزینی ردیف %1 %2 با %3",
  	DATA_SHOWLIST: "لیست %1 را نمایش بده",
  	DATA_HIDELIST: "لیست %1 را پنهان کن",
  	SENSING_OF_XPOSITION: "مکان x",
  	SENSING_OF_YPOSITION: "مکان y",
  	SENSING_OF_DIRECTION: "جهت",
  	SENSING_OF_COSTUMENUMBER: "# حالت",
  	LOOKS_COSTUMENUMBERNAME: "%1 حالت",
  	SENSING_OF_SIZE: "اندازه‌ی",
  	SENSING_OF_BACKDROPNAME: "نام پس‌زمینه‌ی",
  	LOOKS_BACKDROPNUMBERNAME: "%1 پس‌زمینه‌",
  	SENSING_OF_BACKDROPNUMBER: "# پس‌زمینه‌ی",
  	SOUND_VOLUME: "بلندی صدا",
  	"music.getTempo": "سرعت نواختن",
  	SENSING_TOUCHINGOBJECT: "خوردی به %1 ؟",
  	SENSING_TOUCHINGCOLOR: "خوردی به رنگ %1 ؟",
  	SENSING_COLORISTOUCHINGCOLOR: "رنگ %1 به %2 خورد؟",
  	SENSING_DISTANCETO: "فاصله تا %1",
  	SENSING_ANSWER: "پاسخ",
  	SENSING_KEYPRESSED: "کلید %1 فشرده شده؟",
  	SENSING_MOUSEDOWN: "دکمه‌ی ماوس پایین نگه داشته شده؟",
  	SENSING_MOUSEX: "مکان x ماوس",
  	SENSING_MOUSEY: "مکان y ماوس",
  	SENSING_SETDRAGMODE: "قابل جابه‌جا کردن با ماوس  %1",
  	SENSING_LOUDNESS: "بلندی صدا",
  	"videoSensing.videoOn": "%1  ویدئو بر روی %2",
  	SENSING_TIMER: "زمان سنج",
  	SENSING_OF: "%1 %2",
  	SENSING_CURRENT: "همین %1",
  	SENSING_DAYSSINCE2000: "تعداد روز‌ها از سال ۲۰۰۰ میلادی تا کنون",
  	SENSING_USERNAME: "نام کاربری",
  	OPERATORS_ADD: "%2 + %1",
  	OPERATORS_SUBTRACT: "%2 - %1",
  	OPERATORS_MULTIPLY: "%2 * %1",
  	OPERATORS_DIVIDE: "%2 / %1",
  	OPERATORS_RANDOM: "انتخاب تصادفی بین %1 تا %2",
  	OPERATORS_LT: "%2 > %1",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%2 < %1",
  	OPERATORS_AND: "%1 و %2",
  	OPERATORS_OR: "%1 یا %2",
  	OPERATORS_NOT: "چنین نیست که %1",
  	OPERATORS_JOIN: "چسباندن %1 به %2",
  	OPERATORS_LETTEROF: "حرف %1 %2",
  	OPERATORS_LENGTH: "طول %1",
  	OPERATORS_MOD: "باقیمانده‌ی تقسیم %1 بر %2",
  	OPERATORS_ROUND: "گرد شده‌ی %1",
  	OPERATORS_MATHOP: "%1 عدد %2",
  	OPERATORS_CONTAINS: "در %1 %2 هست؟",
  	DATA_ITEMOFLIST: "ردیف %1 در %2",
  	DATA_ITEMNUMOFLIST: "# ردیف %1 در %2",
  	DATA_LENGTHOFLIST: "طول %1",
  	DATA_LISTCONTAINSITEM: "در %1 %2 هست؟",
  	CONTROL_ELSE: "وگرنه",
  	SENSING_USERID: "شناسه‌ی کاربر",
  	SENSING_LOUD: "صدا بلند است؟",
  	"text2speech.speakAndWaitBlock": "بگو %1",
  	"text2speech.setVoiceBlock": "صدا %1 شود",
  	"text2speech.setLanguageBlock": "زبان %1 شود",
  	"translate.translateBlock": "ترجمه کن %1 را به %2",
  	"translate.viewerLanguage": "زبان",
  	"makeymakey.whenKeyPressed": "وقتی کلید %1 فشرده شد",
  	"makeymakey.whenKeysPressedInOrder": "وقتی %1 به ترتیب فشرده شدند",
  	"microbit.whenButtonPressed": "وقتی دکمه %1 فشار داده شد",
  	"microbit.isButtonPressed": "دکمه‌ی %1 فشار داده شد؟",
  	"microbit.whenGesture": "وقتی %1",
  	"microbit.displaySymbol": "نمایش %1",
  	"microbit.displayText": "نمایش متن %1",
  	"microbit.clearDisplay": "پاک کردن صفحه‌ی نمایش",
  	"microbit.whenTilted": "وقتی %1 کج شد",
  	"microbit.isTilted": "%1 کج شد؟",
  	"microbit.tiltAngle": "زاویه‌ی شیب %1",
  	"microbit.whenPinConnected": "وقتی پین %1 وصل شد",
  	"ev3.motorTurnClockwise": "موتور %1 به مدت %2 ثانیه ساعتگرد بچرخد",
  	"ev3.motorTurnCounterClockwise": "موتور %1 به مدت %2 ثانیه پادساعتگرد بچرخد",
  	"ev3.motorSetPower": "قدرت موتور %1 % %2 شود",
  	"ev3.getMotorPosition": "موقعیت موتور %1",
  	"ev3.whenButtonPressed": "وقتی دکمه‌ی %1 فشار داده شد",
  	"ev3.whenDistanceLessThan": "وقتی  %1 > فاصله",
  	"ev3.whenBrightnessLessThan": "وقتی  %1 > روشنایی",
  	"ev3.buttonPressed": "دکمه‌ی %1 فشرده شده؟",
  	"ev3.getDistance": "فاصله",
  	"ev3.getBrightness": "روشنایی",
  	"ev3.beepNote": "نت %1 را به مدت %2 ثانیه بزن",
  	"wedo2.motorOn": "%1 روشن شود",
  	"wedo2.motorOff": "%1 خاموش شود",
  	"wedo2.startMotorPower": "قدرت %1 %2 شود",
  	"wedo2.setMotorDirection": "جهت %1 %2 شود",
  	"wedo2.whenDistance": "وقتی %2 %1 فاصله‌",
  	"wedo2.getDistance": "فاصله",
  	"wedo2.motorOnFor": "روشن کردن %1 به مدت %2 ثانیه",
  	"wedo2.setLightHue": "رنگ نور %1 شود",
  	"wedo2.playNoteFor": "نواختن نت %1 در مدت %2 ثانیه",
  	"wedo2.whenTilted": "وقتی به %1 کج شد",
  	"wedo2.isTilted": "%1 کج شده؟",
  	"wedo2.getTiltAngle": "زاویه‌ ی کج شدن %1",
  	"gdxfor.whenGesture": "وقتی %1",
  	"gdxfor.whenForcePushedOrPulled": "وقتی حسگر نیرو %1",
  	"gdxfor.getForce": "نیرو",
  	"gdxfor.whenTilted": "وقتی  %1 کج شد",
  	"gdxfor.isTilted": "%1 کج شده؟",
  	"gdxfor.getTilt": "زاویه‌ی شیب %1",
  	"gdxfor.isFreeFalling": "در حال سقوطه؟",
  	"gdxfor.getSpin": "سرعت چرخش %1",
  	"gdxfor.getAcceleration": "شتاب %1",
  	"boost.motorOnFor": "موتور  %1 به‌ مدت %2 ثانیه بچرخد",
  	"boost.motorOnForRotation": "موتور %1 %2 دور بچرخد",
  	"boost.motorOn": "موتور  %1 روشن شود",
  	"boost.motorOff": "موتور  %1 خاموش شود",
  	"boost.setMotorPower": "سرعت موتور  %1 % %2 شود",
  	"boost.setMotorDirection": "جهت موتور %1 %2 شود",
  	"boost.getMotorPosition": "موقعیت %1  موتور",
  	"boost.whenColor": "وقتی قطعه‌ی %1 را دید",
  	"boost.seeingColor": "قطعه %1 را دید؟",
  	"boost.whenTilted": "وقتی %1 کج شد",
  	"boost.getTiltAngle": "زاویه‌ی کج شدن %1",
  	"boost.setLightHue": "رنگ %1 شود"
  };
  var dropdowns$T = {
  };
  var ignorelt$T = [
  ];
  var soundEffects$T = [
  	"زیری یا بمی",
  	"پخش صدا از چپ/راست"
  ];
  var microbitWhen$T = [
  	"حرکت کرد",
  	"تکان داده شد",
  	"پرید"
  ];
  var osis$T = [
  	"سایر برنامه‌های این شکلک"
  ];
  var definePrefix$T = [
  	"تعریف"
  ];
  var defineSuffix$T = [
  ];
  var palette$T = {
  	Motion: "حرکت",
  	Looks: "ظاهر‌",
  	Sound: "صدا",
  	Events: "رویدادها",
  	Control: "کنترل",
  	Sensing: "تشخیص",
  	Operators: "عملگرها",
  	Variables: "متغیرها",
  	"My Blocks": "قطعه‌های من"
  };
  var math$T = [
  	"قدر مطلق",
  	"جزء صحیح",
  	"سقف",
  	"جذر",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e به توان",
  	"۱۰ به توان"
  ];
  var aliases$T = {
  	"به اندازه %1 درجه به چپ بچرخ": "MOTION_TURNLEFT",
  	"به اندازه %1 درجه به راست بچرخ": "MOTION_TURNRIGHT",
  	"وقتی که پرچم کلیک شد": "EVENT_WHENFLAGCLICKED",
  	"آخر": "scratchblocks:end"
  };
  var name$T = "فارسی";
  var percentTranslated$T = 100;
  var fa = {
  	commands: commands$T,
  	dropdowns: dropdowns$T,
  	ignorelt: ignorelt$T,
  	soundEffects: soundEffects$T,
  	microbitWhen: microbitWhen$T,
  	osis: osis$T,
  	definePrefix: definePrefix$T,
  	defineSuffix: defineSuffix$T,
  	palette: palette$T,
  	math: math$T,
  	aliases: aliases$T,
  	name: name$T,
  	percentTranslated: percentTranslated$T
  };

  var commands$S = {
  	MOTION_MOVESTEPS: "liiku %1 askelta",
  	MOTION_TURNRIGHT: "käänny @turnRight %1 astetta",
  	MOTION_TURNLEFT: "käänny @turnLeft %1 astetta",
  	MOTION_POINTINDIRECTION: "osoita suuntaan %1",
  	MOTION_POINTTOWARDS: "osoita kohti %1",
  	MOTION_GOTOXY: "mene sijaintiin x: %1 y: %2",
  	MOTION_GOTO: "mene sijaintiin %1",
  	MOTION_GLIDESECSTOXY: "liu'u %1 sekuntia sijaintiin x: %2 y: %3",
  	MOTION_GLIDETO: "liu'u %1 sekuntia sijaintiin %2",
  	MOTION_CHANGEXBY: "lisää x:n arvoon %1",
  	MOTION_SETX: "aseta x:n arvoksi %1",
  	MOTION_CHANGEYBY: "lisää y:n arvoon %1",
  	MOTION_SETY: "aseta y:n arvoksi %1",
  	MOTION_SETROTATIONSTYLE: "aseta kiertotyyliksi %1",
  	LOOKS_SAYFORSECS: "sano %1 %2 sekunnin ajan",
  	LOOKS_SAY: "sano %1",
  	LOOKS_THINKFORSECS: "ajattele %1 %2 sekunnin ajan",
  	LOOKS_THINK: "ajattele %1",
  	LOOKS_SHOW: "näytä",
  	LOOKS_HIDE: "piilota",
  	LOOKS_SWITCHCOSTUMETO: "vaihda asusteeksi %1",
  	LOOKS_NEXTCOSTUME: "seuraava asuste",
  	LOOKS_NEXTBACKDROP_BLOCK: "seuraava tausta",
  	LOOKS_SWITCHBACKDROPTO: "vaihda taustaksi %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "vaihda taustaksi %1 ja odota",
  	LOOKS_CHANGEEFFECTBY: "lisää %1 tehostetta arvolla %2",
  	LOOKS_SETEFFECTTO: "aseta tehoste %1 arvoon %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "poista graafiset tehosteet",
  	LOOKS_CHANGESIZEBY: "kasvata kokoa arvolla %1",
  	LOOKS_SETSIZETO: "aseta koko arvoon %1 %",
  	LOOKS_GOTOFRONTBACK: "mene %1 alalle",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "mene %2 tasoa %1",
  	SOUND_PLAY: "soita ääni %1",
  	SOUND_CHANGEEFFECTBY: "lisää tehosteeseen %1 arvo %2",
  	SOUND_SETEFFECTO: "aseta tehoste %1 arvoon %2",
  	SOUND_CLEAREFFECTS: "poista ääniefektit",
  	SOUND_PLAYUNTILDONE: "soita ääni %1 loppuun",
  	SOUND_STOPALLSOUNDS: "pysäytä kaikki äänet",
  	"music.playDrumForBeats": "soita rumpua %1 %2 iskun ajan",
  	"music.restForBeats": "tauko %1 iskun ajan",
  	"music.playNoteForBeats": "soita nuottia %1 %2 iskun ajan",
  	"music.setInstrument": "aseta soittimeksi %1",
  	SOUND_CHANGEVOLUMEBY: "lisää äänenvoimakkuutta arvolla %1",
  	SOUND_SETVOLUMETO: "aseta äänenvoimakkuudeksi %1%",
  	"music.changeTempo": "lisää tempoa arvolla %1",
  	"music.setTempo": "aseta tempoksi %1",
  	"pen.clear": "pyyhi kaikki",
  	"pen.stamp": "leimaa",
  	"pen.penDown": "kynä alas",
  	"pen.penUp": "kynä ylös",
  	"pen.setColor": "aseta kynän väriksi %1",
  	"pen.changeHue": "lisää kynän väriä arvolla %1",
  	"pen.setColorParam": "aseta kynän värin %1 arvoksi %2",
  	"pen.changeColorParam": "lisää kynän väriä %1 arvolla %2",
  	"pen.setHue": "aseta kynän väriksi %1",
  	"pen.changeShade": "lisää kynän tummuutta arvolla %1",
  	"pen.setShade": "aseta kynän tummuudeksi %1",
  	"pen.changeSize": "lisää kynän kokoa arvolla %1",
  	"pen.setSize": "aseta kynän kooksi %1",
  	EVENT_WHENFLAGCLICKED: "kun klikataan @greenFlag",
  	EVENT_WHENKEYPRESSED: "kun painetaan %1",
  	EVENT_WHENTHISSPRITECLICKED: "kun tätä hahmoa klikataan",
  	EVENT_WHENSTAGECLICKED: "kun esiintymislavaa klikataan",
  	EVENT_WHENBACKDROPSWITCHESTO: "kun taustaksi vaihtuu %1",
  	EVENT_WHENGREATERTHAN: "kun %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kun vastaanotan %1",
  	EVENT_BROADCAST: "lähetä %1",
  	EVENT_BROADCASTANDWAIT: "lähetä %1 ja odota",
  	CONTROL_WAIT: "odota %1 sekuntia",
  	CONTROL_REPEAT: "toista %1 kertaa",
  	CONTROL_FOREVER: "ikuisesti",
  	CONTROL_IF: "jos %1, niin",
  	CONTROL_WAITUNTIL: "odota kunnes %1",
  	CONTROL_REPEATUNTIL: "toista kunnes %1",
  	CONTROL_STOP: "pysäytä %1",
  	CONTROL_STARTASCLONE: "kun aloitan kloonina",
  	CONTROL_CREATECLONEOF: "luo klooni hahmosta %1",
  	CONTROL_DELETETHISCLONE: "poista tämä klooni",
  	SENSING_ASKANDWAIT: "kysy %1 ja odota",
  	"videoSensing.videoToggle": "kytke video %1",
  	"videoSensing.setVideoTransparency": "aseta videon läpinäkyvyys arvoon %1",
  	"videoSensing.whenMotionGreaterThan": "kun videon liike > %1",
  	SENSING_RESETTIMER: "nollaa ajastin",
  	DATA_SETVARIABLETO: "aseta %1 arvoon %2",
  	DATA_CHANGEVARIABLEBY: "lisää muuttujaan %1 arvo %2",
  	DATA_SHOWVARIABLE: "näytä muuttuja %1",
  	DATA_HIDEVARIABLE: "piilota muuttuja %1",
  	DATA_ADDTOLIST: "lisää %1 listaan %2",
  	DATA_DELETEOFLIST: "poista %1 listasta %2",
  	DATA_DELETEALLOFLIST: "poista kaikki listasta %1",
  	MOTION_IFONEDGEBOUNCE: "kimpoa reunasta",
  	DATA_INSERTATLIST: "lisää %1 kohtaan %2 listassa %3",
  	DATA_REPLACEITEMOFLIST: "korvaa listan %2 kohdan %1 arvo arvolla %3",
  	DATA_SHOWLIST: "näytä lista %1",
  	DATA_HIDELIST: "piilota lista %1",
  	SENSING_OF_XPOSITION: "x-sijainti",
  	SENSING_OF_YPOSITION: "y-sijainti",
  	SENSING_OF_DIRECTION: "suunta",
  	SENSING_OF_COSTUMENUMBER: "asusteen numero",
  	LOOKS_COSTUMENUMBERNAME: "asuste %1",
  	SENSING_OF_SIZE: "koko",
  	SENSING_OF_BACKDROPNAME: "taustan nimi",
  	LOOKS_BACKDROPNUMBERNAME: "tausta %1",
  	SENSING_OF_BACKDROPNUMBER: "taustan numero",
  	SOUND_VOLUME: "äänenvoimakkuus",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "koskettaako %1?",
  	SENSING_TOUCHINGCOLOR: "koskettaako väriä %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "koskeeko väri %1 väriä %2?",
  	SENSING_DISTANCETO: "etäisyys kohteeseen %1",
  	SENSING_ANSWER: "vastaus",
  	SENSING_KEYPRESSED: "onko näppäin %1 painettu?",
  	SENSING_MOUSEDOWN: "onko hiiren nappi painettu?",
  	SENSING_MOUSEX: "hiiren x-sijainti",
  	SENSING_MOUSEY: "hiiren y-sijainti",
  	SENSING_SETDRAGMODE: "aseta raahaustilaksi %1",
  	SENSING_LOUDNESS: "äänentaso",
  	"videoSensing.videoOn": "%2n %1 videolla",
  	SENSING_TIMER: "ajastin",
  	SENSING_OF: "kohteen %2 %1",
  	SENSING_CURRENT: "nykyinen %1",
  	SENSING_DAYSSINCE2000: "päiviä vuoden 2000 jälkeen",
  	SENSING_USERNAME: "käyttäjänimi",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "valitse satunnaisluku väliltä %1 – %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 ja %2",
  	OPERATORS_OR: "%1 tai %2",
  	OPERATORS_NOT: "ei %1",
  	OPERATORS_JOIN: "yhdistä %1 ja %2",
  	OPERATORS_LETTEROF: "%1. kirjain sanasta %2",
  	OPERATORS_LENGTH: "sanan %1 pituus",
  	OPERATORS_MOD: "lukujen %1 ja %2 jakojäännös",
  	OPERATORS_ROUND: "pyöristä %1",
  	OPERATORS_MATHOP: "%1 luvusta %2",
  	OPERATORS_CONTAINS: "%1 sisältää %2?",
  	DATA_ITEMOFLIST: "listan %2 %1. kohde",
  	DATA_ITEMNUMOFLIST: "kohteen %1 numero listassa %2",
  	DATA_LENGTHOFLIST: "listan %1 pituus",
  	DATA_LISTCONTAINSITEM: "%1 sisältää %2?",
  	CONTROL_ELSE: "tai muuten",
  	SENSING_USERID: "käyttäjä-id",
  	SENSING_LOUD: "kova äänentaso?",
  	"text2speech.speakAndWaitBlock": "puhu %1",
  	"text2speech.setVoiceBlock": "aseta ääneksi %1",
  	"text2speech.setLanguageBlock": "aseta kieleksi %1",
  	"translate.translateBlock": "käännä %1 kielelle %2",
  	"translate.viewerLanguage": "kieli",
  	"makeymakey.whenKeyPressed": "kun %1-näppäintä painetaan",
  	"makeymakey.whenKeysPressedInOrder": "kun %1 painetaan järjestyksessä",
  	"microbit.whenButtonPressed": "kun nappia %1 painetaan",
  	"microbit.isButtonPressed": "onko nappia %1 painettu?",
  	"microbit.whenGesture": "kun on %1",
  	"microbit.displaySymbol": "näytä %1",
  	"microbit.displayText": "näytä teksti %1",
  	"microbit.clearDisplay": "tyhjennä näyttö",
  	"microbit.whenTilted": "kun kallistettu suuntaan %1",
  	"microbit.isTilted": "onko kallistus suuntaan %1?",
  	"microbit.tiltAngle": "kallista suuntaan %1",
  	"microbit.whenPinConnected": "kun nasta %1 yhdistetty",
  	"ev3.motorTurnClockwise": "käännä moottoria %1 myötäpäivään %2 sekuntia",
  	"ev3.motorTurnCounterClockwise": "käännä moottoria %1 vastapäivään %2 sekuntia",
  	"ev3.motorSetPower": "aseta moottorin %1 tehoksi %2 %",
  	"ev3.getMotorPosition": "moottorin %1 asento",
  	"ev3.whenButtonPressed": "kun nappia painetaan portissa %1",
  	"ev3.whenDistanceLessThan": "kun etäisyys < %1",
  	"ev3.whenBrightnessLessThan": "kun kirkkaus < %1",
  	"ev3.buttonPressed": "onko nappia painettu portissa %1?",
  	"ev3.getDistance": "etäisyys",
  	"ev3.getBrightness": "kirkkaus",
  	"ev3.beepNote": "soita nuottia %1 %2 sekuntia",
  	"wedo2.motorOn": "laita %1 päälle",
  	"wedo2.motorOff": "laita %1 pois päältä",
  	"wedo2.startMotorPower": "aseta moottorin %1 teho arvoon %2",
  	"wedo2.setMotorDirection": "aseta moottorin %1 suunnaksi %2",
  	"wedo2.whenDistance": "kun etäisyys %1 %2",
  	"wedo2.getDistance": "etäisyys",
  	"wedo2.motorOnFor": "laita %1 päälle %2 sekunniksi",
  	"wedo2.setLightHue": "aseta valon väriksi %1",
  	"wedo2.playNoteFor": "soita nuottia %1 %2 sekuntia",
  	"wedo2.whenTilted": "kun kallistettu suuntaan %1",
  	"wedo2.isTilted": "onko kallistettu suuntaan %1?",
  	"wedo2.getTiltAngle": "kallista suuntaan %1",
  	"gdxfor.whenGesture": "kun on %1",
  	"gdxfor.whenForcePushedOrPulled": "kun voima-anturia %1",
  	"gdxfor.getForce": "voima",
  	"gdxfor.whenTilted": "kun kallistus %1",
  	"gdxfor.isTilted": "onko kallistus %1?",
  	"gdxfor.getTilt": "kallistuskulma %1",
  	"gdxfor.isFreeFalling": "putoaako?",
  	"gdxfor.getSpin": "pyörimisnopeus %1",
  	"gdxfor.getAcceleration": "kiihtyvyys %1",
  	"boost.motorOnFor": "käynnistä moottori %1 %2 sekunniksi",
  	"boost.motorOnForRotation": "käynnistä moottori %1 %2 kierroksen ajan",
  	"boost.motorOn": "laita moottori %1 päälle",
  	"boost.motorOff": "laita moottori %1 pois päältä",
  	"boost.setMotorPower": "aseta moottorin %1 nopeudeksi %2 %",
  	"boost.setMotorDirection": "aseta moottorin %1 suunnaksi %2",
  	"boost.getMotorPosition": "moottorin %1 asento",
  	"boost.whenColor": "kun %1 nähty",
  	"boost.seeingColor": "näkeekö värin %1?",
  	"boost.whenTilted": "kun kallistettu suuntaan %1",
  	"boost.getTiltAngle": "kallista suuntaan %1",
  	"boost.setLightHue": "aseta valon väriksi %1"
  };
  var dropdowns$S = {
  };
  var ignorelt$S = [
  ];
  var soundEffects$S = [
  	"sävelkorkeus",
  	"panoroi vasen/oikea"
  ];
  var microbitWhen$S = [
  	"siirretty",
  	"ravistettu",
  	"hypätty"
  ];
  var osis$S = [
  	"hahmon muut koodit"
  ];
  var definePrefix$S = [
  	"määrittele"
  ];
  var defineSuffix$S = [
  ];
  var palette$S = {
  	Motion: "Liike",
  	Looks: "Ulkonäkö",
  	Sound: "Ääni",
  	Events: "Tapahtumat",
  	Control: "Ohjaus",
  	Sensing: "Tuntoaisti",
  	Operators: "Toiminnot",
  	Variables: "Muuttujat",
  	"My Blocks": "Lohkoni"
  };
  var math$S = [
  	"itseisarvo",
  	"pyöristä alaspäin",
  	"pyöristä ylöspäin",
  	"neliöjuuri",
  	"sini",
  	"kosini",
  	"tangentti",
  	"asin",
  	"acos",
  	"atan",
  	"luonnollinen logaritmi",
  	"10-kantainen logaritmi",
  	"e ^",
  	"10 ^"
  ];
  var aliases$S = {
  };
  var name$S = "Suomi";
  var percentTranslated$S = 100;
  var fi = {
  	commands: commands$S,
  	dropdowns: dropdowns$S,
  	ignorelt: ignorelt$S,
  	soundEffects: soundEffects$S,
  	microbitWhen: microbitWhen$S,
  	osis: osis$S,
  	definePrefix: definePrefix$S,
  	defineSuffix: defineSuffix$S,
  	palette: palette$S,
  	math: math$S,
  	aliases: aliases$S,
  	name: name$S,
  	percentTranslated: percentTranslated$S
  };

  var commands$R = {
  	MOTION_MOVESTEPS: "gumalaw nang %1 (na) hakbang",
  	MOTION_TURNRIGHT: "umikot @turnRight nang %1 (na) digri",
  	MOTION_TURNLEFT: "umikot @turnLeft nang %1 (na) digri",
  	MOTION_POINTINDIRECTION: "humarap sa direksyong %1",
  	MOTION_POINTTOWARDS: "humarap patungong %1",
  	MOTION_GOTOXY: "pumunta sa x: %1 y: %2",
  	MOTION_GOTO: "pumunta sa %1",
  	MOTION_GLIDESECSTOXY: "dumulas nang %1 (na) seg. papuntang x: %2 y: %3",
  	MOTION_GLIDETO: "dumulas nang %1 (na) seg. papuntang %2",
  	MOTION_CHANGEXBY: "palitan ang x ng %1",
  	MOTION_SETX: "itakda ang x bilang %1",
  	MOTION_CHANGEYBY: "palitan ang y ng %1",
  	MOTION_SETY: "itakda ang y bilang %1",
  	MOTION_SETROTATIONSTYLE: "itakda ang estilo ng pag-ikot %1",
  	LOOKS_SAYFORSECS: "sabihin ang %1 nang %2 (na) segundo",
  	LOOKS_SAY: "sabihin ang %1",
  	LOOKS_THINKFORSECS: "isipin ang %1 nang %2 (na) segundo",
  	LOOKS_THINK: "isipin ang %1",
  	LOOKS_SHOW: "ipakita",
  	LOOKS_HIDE: "itago",
  	LOOKS_SWITCHCOSTUMETO: "palitan ang costume ng %1",
  	LOOKS_NEXTCOSTUME: "susunod na costume",
  	LOOKS_NEXTBACKDROP_BLOCK: "susunod na likod",
  	LOOKS_SWITCHBACKDROPTO: "palitan ang likod ng %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "palitan ang likod ng %1 at maghintay",
  	LOOKS_CHANGEEFFECTBY: "baguhin ang epektong %1 nang %2",
  	LOOKS_SETEFFECTTO: "itakda ang epektong %1 bilang %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "tanggalin lahat ng graphic effects",
  	LOOKS_CHANGESIZEBY: "palitan ang laki nang %1",
  	LOOKS_SETSIZETO: "itakda ang laki nang %1",
  	LOOKS_GOTOFRONTBACK: "pumunta sa layer na %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "pumunta %1 nang %2 na layer",
  	SOUND_PLAY: "simulan ang tunog na %1",
  	SOUND_CHANGEEFFECTBY: "baguhin ang epektong %1 nang %2",
  	SOUND_SETEFFECTO: "itakda ang epektong %1 bilang %2",
  	SOUND_CLEAREFFECTS: "tanggalin lahat ng sound effects",
  	SOUND_PLAYUNTILDONE: "i-play ang tunog na %1 hanggang matapos",
  	SOUND_STOPALLSOUNDS: "itigil ang lahat ng tunog",
  	"music.playDrumForBeats": "i-play ang tambol na %1 nang %2 (na) beat",
  	"music.restForBeats": "magpahinga nang %1 (na) beat",
  	"music.playNoteForBeats": "i-play ang notang %1 nang %2 (na) beat",
  	"music.setInstrument": "itakda ang instrumento bilang %1",
  	SOUND_CHANGEVOLUMEBY: "palitan ang volume nang %1",
  	SOUND_SETVOLUMETO: "itakda ang volume bilang %1%",
  	"music.changeTempo": "baguhin ang bilis nang %1",
  	"music.setTempo": "itakda ang bilis bilang %1",
  	"pen.clear": "burahin lahat",
  	"pen.stamp": "i-stamp",
  	"pen.penDown": "ibaba ang panulat",
  	"pen.penUp": "itaas ang panulat",
  	"pen.setColor": "itakda ang kulay ng panulat sa %1",
  	"pen.changeHue": "baguhin ang kulay ng panulat sa %1",
  	"pen.setColorParam": "itakda ang panulat %1 sa %2",
  	"pen.changeColorParam": "baguhin ang panulat %1 ng %2",
  	"pen.setHue": "itakda ang kulay ng panulat sa %1",
  	"pen.changeShade": "baguhin ang shade ng panulat sa %1",
  	"pen.setShade": "itakda ang shade ng panulat sa %1",
  	"pen.changeSize": "baguhin ang laki ng panulat nang %1",
  	"pen.setSize": "itakda ang laki ng panulat sa %1",
  	EVENT_WHENFLAGCLICKED: "kapag pinindot ang @greenFlag",
  	EVENT_WHENKEYPRESSED: "kapag pinindot ang key na %1",
  	EVENT_WHENTHISSPRITECLICKED: "kapag pinindot ang sprite na ito",
  	EVENT_WHENSTAGECLICKED: "kapag pinindot ang stage",
  	EVENT_WHENBACKDROPSWITCHESTO: "kapag lumipat ang likod sa %1",
  	EVENT_WHENGREATERTHAN: "kapag %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kapag natanggap ko ang %1",
  	EVENT_BROADCAST: "iulat ang %1",
  	EVENT_BROADCASTANDWAIT: "iulat ang %1 at maghintay",
  	CONTROL_WAIT: "maghintay nang %1 (na) segundo",
  	CONTROL_REPEAT: "ulitin nang %1",
  	CONTROL_FOREVER: "kailanman",
  	CONTROL_IF: "kung %1 edi",
  	CONTROL_WAITUNTIL: "maghintay hanggang %1",
  	CONTROL_REPEATUNTIL: "ulitin hanggang %1",
  	CONTROL_STOP: "itigil %1",
  	CONTROL_STARTASCLONE: "kapag clone ako nagsimula",
  	CONTROL_CREATECLONEOF: "gumawa ng clone ng %1",
  	CONTROL_DELETETHISCLONE: "tanggalin ang clone na ito",
  	SENSING_ASKANDWAIT: "magtanong ng %1 at maghintay",
  	"videoSensing.videoToggle": "itakda ang video sa %1",
  	"videoSensing.setVideoTransparency": "itakda ang labo ng video sa %1",
  	"videoSensing.whenMotionGreaterThan": "kapag ang paggalaw sa video > %1",
  	SENSING_RESETTIMER: "i-reset ang timer",
  	DATA_SETVARIABLETO: "itakda ang %1 bilang %2",
  	DATA_CHANGEVARIABLEBY: "palitan ang %1 ng %2",
  	DATA_SHOWVARIABLE: "ipakita ang variable na %1",
  	DATA_HIDEVARIABLE: "itago ang variable na %1",
  	DATA_ADDTOLIST: "idagdag ang %1 sa %2",
  	DATA_DELETEOFLIST: "burahin ang %1 ng %2",
  	DATA_DELETEALLOFLIST: "burahin lahat ng %1",
  	MOTION_IFONEDGEBOUNCE: "kung nasa gilid, tumalbog",
  	DATA_INSERTATLIST: "isingit ang %1 sa %2 ng %3",
  	DATA_REPLACEITEMOFLIST: "palitan ang item na %1 ng %2 ng %3",
  	DATA_SHOWLIST: "ipakita ang listahan na %1",
  	DATA_HIDELIST: "itago ang listahan na %1",
  	SENSING_OF_XPOSITION: "posisyong x",
  	SENSING_OF_YPOSITION: "posisyong y",
  	SENSING_OF_DIRECTION: "direksyon",
  	SENSING_OF_COSTUMENUMBER: "costume #",
  	LOOKS_COSTUMENUMBERNAME: "costume na %1",
  	SENSING_OF_SIZE: "laki",
  	SENSING_OF_BACKDROPNAME: "pangalan ng likod",
  	LOOKS_BACKDROPNUMBERNAME: "likod na %1",
  	SENSING_OF_BACKDROPNUMBER: "likod #",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "bilis",
  	SENSING_TOUCHINGOBJECT: "tinatamaan ang %1?",
  	SENSING_TOUCHINGCOLOR: "tinatamaan ang kulay %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "tinatamaan ang %2 ng kulay na %1?",
  	SENSING_DISTANCETO: "layo sa %1",
  	SENSING_ANSWER: "sagot",
  	SENSING_KEYPRESSED: "napindot ang key na %1?",
  	SENSING_MOUSEDOWN: "nakapindot?",
  	SENSING_MOUSEX: "mouse x",
  	SENSING_MOUSEY: "mouse y",
  	SENSING_SETDRAGMODE: "itakda ang drag mode bilang %1",
  	SENSING_LOUDNESS: "lakas",
  	"videoSensing.videoOn": "%1 ng video sa %2",
  	SENSING_TIMER: "timer",
  	SENSING_OF: "%1 ng %2",
  	SENSING_CURRENT: "kasalukuyang %1",
  	SENSING_DAYSSINCE2000: "araw simula noong 2000",
  	SENSING_USERNAME: "username",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "pumili ng kahit ano mula %1 hanggang %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 at %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "hindi %1",
  	OPERATORS_JOIN: "ipagsama ang %1 %2",
  	OPERATORS_LETTEROF: "titik %1 ng %2",
  	OPERATORS_LENGTH: "haba ng %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "i-round ang %1",
  	OPERATORS_MATHOP: "%1 ng %2",
  	OPERATORS_CONTAINS: "may %2 ang %1?",
  	DATA_ITEMOFLIST: "item na %1 ng %2",
  	DATA_ITEMNUMOFLIST: "# ng item na %1 sa %2",
  	DATA_LENGTHOFLIST: "haba ng %1",
  	DATA_LISTCONTAINSITEM: "may %2 ang %1?",
  	CONTROL_ELSE: "kundi",
  	SENSING_USERID: "user id",
  	SENSING_LOUD: "malakas?",
  	"text2speech.speakAndWaitBlock": "sabihin ang %1",
  	"text2speech.setVoiceBlock": "itakda ang boses sa %1",
  	"text2speech.setLanguageBlock": "itakda ang wika sa %1",
  	"translate.translateBlock": "isalin ang %1 sa %2",
  	"translate.viewerLanguage": "wika",
  	"makeymakey.whenKeyPressed": "kapag pinindot ang key na %1",
  	"makeymakey.whenKeysPressedInOrder": "kapag diretsong pinindot ang %1",
  	"microbit.whenButtonPressed": "kapag pinindot ang button na %1",
  	"microbit.isButtonPressed": "pinindot ang button na %1?",
  	"microbit.whenGesture": "kapag %1",
  	"microbit.displaySymbol": "i-display ang %1",
  	"microbit.displayText": "i-display ang teksto na %1",
  	"microbit.clearDisplay": "linisin ang display",
  	"microbit.whenTilted": "kapag nakatagilid %1",
  	"microbit.isTilted": "nakatagilid %1?",
  	"microbit.tiltAngle": "anggulo ng pagtagilid %1",
  	"microbit.whenPinConnected": "kapag konektado ang pin na %1",
  	"ev3.motorTurnClockwise": "paikutin dito nang %2 (na) seguno ang motor na %1",
  	"ev3.motorTurnCounterClockwise": "paikutin doon nang %2 (na) segundo ang motor na %1",
  	"ev3.motorSetPower": "itakda ang lakas na %2 % sa motor na %1",
  	"ev3.getMotorPosition": "posisyon ng motor na %1",
  	"ev3.whenButtonPressed": "kapag pinindot ang button na %1",
  	"ev3.whenDistanceLessThan": "kapag ang layo < %1",
  	"ev3.whenBrightnessLessThan": "kapag ang liwanag < %1",
  	"ev3.buttonPressed": "pinindot ang button na %1?",
  	"ev3.getDistance": "layo",
  	"ev3.getBrightness": "liwanag",
  	"ev3.beepNote": "i-beep ang notang %1 nang %2 (na) segundo",
  	"wedo2.motorOn": "buksan ang %1",
  	"wedo2.motorOff": "patayin ang %1",
  	"wedo2.startMotorPower": "itakda ang lakas ng %1 sa %2",
  	"wedo2.setMotorDirection": "itakda ang direksyon ng %1 sa %2",
  	"wedo2.whenDistance": "kapag ang layo %1 %2",
  	"wedo2.getDistance": "layo",
  	"wedo2.motorOnFor": "buksan ang %1 nang %2 (na) segundo",
  	"wedo2.setLightHue": "itakda ang kulay ng ilaw bilang %1",
  	"wedo2.playNoteFor": "i-play ang notang %1 nang %2 (na) segundo",
  	"wedo2.whenTilted": "kapag nakatagilid %1",
  	"wedo2.isTilted": "nakatagilid %1?",
  	"wedo2.getTiltAngle": "anggulo ng pagtagilid %1",
  	"gdxfor.whenGesture": "kapag %1",
  	"gdxfor.whenForcePushedOrPulled": "kapag ang sensor ng pwersa ay %1",
  	"gdxfor.getForce": "pwersa",
  	"gdxfor.whenTilted": "kapag nakatagilid %1",
  	"gdxfor.isTilted": "nakatagilid %1?",
  	"gdxfor.getTilt": "anggulo ng pagtagilid %1",
  	"gdxfor.isFreeFalling": "nahuhulog?",
  	"gdxfor.getSpin": "bilis ng pag-ikot %1",
  	"gdxfor.getAcceleration": "pagbilis %1",
  	"boost.motorOnFor": "buksan ang motor na %1 nang %2 (na) segundo",
  	"boost.motorOnForRotation": "buksan ang motor na %1 nang %2 (na) ikot",
  	"boost.motorOn": "buksan ang motor na %1",
  	"boost.motorOff": "isara ang motor na %1",
  	"boost.setMotorPower": "itakda sa bilis na %2 % ang motor na %1",
  	"boost.setMotorDirection": "itakda sa direksyong %2 ang motor na %1",
  	"boost.getMotorPosition": "posisyon ng motor na %1",
  	"boost.whenColor": "kapag nakita ang brick na %1",
  	"boost.seeingColor": "nakikita ang brick na %1?",
  	"boost.whenTilted": "kapag nakatagilid %1",
  	"boost.getTiltAngle": "anggulo ng pagtagilid %1",
  	"boost.setLightHue": "itakda ang kulay ng ilaw bilang %1"
  };
  var dropdowns$R = {
  };
  var ignorelt$R = [
  ];
  var soundEffects$R = [
  	"tinis",
  	"i-pan kaliwa/kanan"
  ];
  var microbitWhen$R = [
  	"gumalaw",
  	"niyugyog",
  	"tumalon"
  ];
  var osis$R = [
  	"ibang script sa sprite"
  ];
  var definePrefix$R = [
  	"i-define",
  	"ang"
  ];
  var defineSuffix$R = [
  ];
  var palette$R = {
  	Motion: "Galaw",
  	Looks: "Hitsura",
  	Sound: "Tunog",
  	Events: "Pangyayari",
  	Control: "Kontrol",
  	Sensing: "Pakiramdam",
  	Operators: "Mga Operator",
  	Variables: "Mga Variable",
  	"My Blocks": "Mga Block Ko"
  };
  var math$R = [
  	"abs",
  	"floor",
  	"ceiling",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$R = {
  };
  var name$R = "Filipino";
  var percentTranslated$R = 100;
  var fil = {
  	commands: commands$R,
  	dropdowns: dropdowns$R,
  	ignorelt: ignorelt$R,
  	soundEffects: soundEffects$R,
  	microbitWhen: microbitWhen$R,
  	osis: osis$R,
  	definePrefix: definePrefix$R,
  	defineSuffix: defineSuffix$R,
  	palette: palette$R,
  	math: math$R,
  	aliases: aliases$R,
  	name: name$R,
  	percentTranslated: percentTranslated$R
  };

  var commands$Q = {
  	MOTION_MOVESTEPS: "avancer de %1 pas",
  	MOTION_TURNRIGHT: "tourner @turnRight de %1 degrés",
  	MOTION_TURNLEFT: "tourner @turnLeft de %1 degrés",
  	MOTION_POINTINDIRECTION: "s'orienter à %1",
  	MOTION_POINTTOWARDS: "s'orienter vers %1",
  	MOTION_GOTOXY: "aller à x: %1 y: %2",
  	MOTION_GOTO: "aller à %1",
  	MOTION_GLIDESECSTOXY: "glisser en %1 secondes à x: %2 y: %3",
  	MOTION_GLIDETO: "glisser en %1 secondes à %2",
  	MOTION_CHANGEXBY: "ajouter %1 à x",
  	MOTION_SETX: "mettre x à %1",
  	MOTION_CHANGEYBY: "ajouter %1 à y",
  	MOTION_SETY: "mettre y à %1",
  	MOTION_SETROTATIONSTYLE: "fixer le sens de rotation %1",
  	LOOKS_SAYFORSECS: "dire %1 pendant %2 secondes",
  	LOOKS_SAY: "dire %1",
  	LOOKS_THINKFORSECS: "penser à %1 pendant %2 secondes",
  	LOOKS_THINK: "penser à %1",
  	LOOKS_SHOW: "montrer",
  	LOOKS_HIDE: "cacher",
  	LOOKS_SWITCHCOSTUMETO: "basculer sur le costume %1",
  	LOOKS_NEXTCOSTUME: "costume suivant",
  	LOOKS_NEXTBACKDROP_BLOCK: "arrière-plan suivant",
  	LOOKS_SWITCHBACKDROPTO: "basculer sur l'arrière-plan %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "basculer sur l'arrière-plan %1 et attendre",
  	LOOKS_CHANGEEFFECTBY: "ajouter %2 à l'effet %1",
  	LOOKS_SETEFFECTTO: "mettre l'effet %1 à %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "annuler les effets graphiques",
  	LOOKS_CHANGESIZEBY: "ajouter %1 à la taille",
  	LOOKS_SETSIZETO: "mettre la taille à %1 % de la taille initiale",
  	LOOKS_GOTOFRONTBACK: "aller à l'%1 plan",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "déplacer de %2 plans vers l'%1",
  	SOUND_PLAY: "jouer le son %1",
  	SOUND_CHANGEEFFECTBY: "ajouter %2 à l'effet %1",
  	SOUND_SETEFFECTO: "mettre l'effet %1 à %2",
  	SOUND_CLEAREFFECTS: "annuler tous les effets sonores",
  	SOUND_PLAYUNTILDONE: "jouer le son %1 jusqu'au bout",
  	SOUND_STOPALLSOUNDS: "arrêter tous les sons",
  	"music.playDrumForBeats": "jouer du tambour %1 pendant %2 temps",
  	"music.restForBeats": "faire une pause pendant %1 temps",
  	"music.playNoteForBeats": "jouer la note %1 pendant %2 temps",
  	"music.setInstrument": "choisir l'instrument n° %1",
  	SOUND_CHANGEVOLUMEBY: "ajouter %1 au volume",
  	SOUND_SETVOLUMETO: "mettre le volume à %1%",
  	"music.changeTempo": "ajouter %1 au tempo",
  	"music.setTempo": "mettre le tempo à %1",
  	"pen.clear": "effacer tout",
  	"pen.stamp": "estampiller",
  	"pen.penDown": "stylo en position d'écriture",
  	"pen.penUp": "relever le stylo",
  	"pen.setColor": "mettre la couleur du stylo à %1",
  	"pen.changeHue": "ajouter %1 à la couleur du stylo",
  	"pen.setColorParam": "mettre la %1 du stylo à %2",
  	"pen.changeColorParam": "ajouter %2 à la %1 du stylo",
  	"pen.setHue": "mettre la couleur du stylo à %1",
  	"pen.changeShade": "ajouter %1 à l'intensité du stylo",
  	"pen.setShade": "mettre l'intensité du stylo à %1",
  	"pen.changeSize": "ajouter %1 à la taille du stylo",
  	"pen.setSize": "mettre la taille du stylo à %1",
  	EVENT_WHENFLAGCLICKED: "quand @greenFlag est cliqué",
  	EVENT_WHENKEYPRESSED: "quand la touche %1 est pressée",
  	EVENT_WHENTHISSPRITECLICKED: "quand ce sprite est cliqué",
  	EVENT_WHENSTAGECLICKED: "quand la scène est cliquée",
  	EVENT_WHENBACKDROPSWITCHESTO: "quand l'arrière-plan bascule sur %1",
  	EVENT_WHENGREATERTHAN: "quand le %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "quand je reçois %1",
  	EVENT_BROADCAST: "envoyer à tous %1",
  	EVENT_BROADCASTANDWAIT: "envoyer à tous %1 et attendre",
  	CONTROL_WAIT: "attendre %1 secondes",
  	CONTROL_REPEAT: "répéter %1 fois",
  	CONTROL_FOREVER: "répéter indéfiniment",
  	CONTROL_IF: "si %1 alors",
  	CONTROL_WAITUNTIL: "attendre jusqu'à ce que %1",
  	CONTROL_REPEATUNTIL: "répéter jusqu'à ce que %1",
  	CONTROL_STOP: "stop %1",
  	CONTROL_STARTASCLONE: "quand je commence comme un clone",
  	CONTROL_CREATECLONEOF: "créer un clone de %1",
  	CONTROL_DELETETHISCLONE: "supprimer ce clone",
  	SENSING_ASKANDWAIT: "demander %1 et attendre",
  	"videoSensing.videoToggle": "%1 la vidéo",
  	"videoSensing.setVideoTransparency": "mettre la transparence de la vidéo à %1",
  	"videoSensing.whenMotionGreaterThan": "quand le mouvement de la vidéo > %1",
  	SENSING_RESETTIMER: "réinitialiser le chronomètre",
  	DATA_SETVARIABLETO: "mettre %1 à %2",
  	DATA_CHANGEVARIABLEBY: "ajouter %2 à %1",
  	DATA_SHOWVARIABLE: "montrer la variable %1",
  	DATA_HIDEVARIABLE: "cacher la variable %1",
  	DATA_ADDTOLIST: "ajouter %1 à %2",
  	DATA_DELETEOFLIST: "supprimer l'élément %1 de %2",
  	DATA_DELETEALLOFLIST: "supprimer tous les éléments de la liste %1",
  	MOTION_IFONEDGEBOUNCE: "rebondir si le bord est atteint",
  	DATA_INSERTATLIST: "insérer %1 en position %2 de %3",
  	DATA_REPLACEITEMOFLIST: "remplacer l'élément %1 de la liste %2 par %3",
  	DATA_SHOWLIST: "montrer la liste %1",
  	DATA_HIDELIST: "cacher la liste %1",
  	SENSING_OF_XPOSITION: "abscisse x",
  	SENSING_OF_YPOSITION: "ordonnée y",
  	SENSING_OF_DIRECTION: "direction",
  	SENSING_OF_COSTUMENUMBER: "numéro de costume",
  	LOOKS_COSTUMENUMBERNAME: "%1 du costume",
  	SENSING_OF_SIZE: "taille",
  	SENSING_OF_BACKDROPNAME: "nom de l'arrière-plan",
  	LOOKS_BACKDROPNUMBERNAME: "%1 de l'arrière-plan",
  	SENSING_OF_BACKDROPNUMBER: "numéro de l'arrière-plan",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "touche le %1 ?",
  	SENSING_TOUCHINGCOLOR: "couleur %1 touchée ?",
  	SENSING_COLORISTOUCHINGCOLOR: "couleur %1 touche %2 ?",
  	SENSING_DISTANCETO: "distance de %1",
  	SENSING_ANSWER: "réponse",
  	SENSING_KEYPRESSED: "touche %1 pressée ?",
  	SENSING_MOUSEDOWN: "souris pressée ?",
  	SENSING_MOUSEX: "souris x",
  	SENSING_MOUSEY: "souris y",
  	SENSING_SETDRAGMODE: "mettre mode de glissement à %1",
  	SENSING_LOUDNESS: "volume sonore",
  	"videoSensing.videoOn": "%1 de la vidéo de %2",
  	SENSING_TIMER: "chronomètre",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "%1 actuelle",
  	SENSING_DAYSSINCE2000: "jours depuis 2000",
  	SENSING_USERNAME: "nom d'utilisateur",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "nombre aléatoire entre %1 et %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 et %2",
  	OPERATORS_OR: "%1 ou %2",
  	OPERATORS_NOT: "non %1",
  	OPERATORS_JOIN: "regrouper %1 et %2",
  	OPERATORS_LETTEROF: "lettre %1 de %2",
  	OPERATORS_LENGTH: "longueur de %1",
  	OPERATORS_MOD: "%1 modulo %2",
  	OPERATORS_ROUND: "arrondi de %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%1 contient %2 ?",
  	DATA_ITEMOFLIST: "élément %1 de %2",
  	DATA_ITEMNUMOFLIST: "position de %1 dans %2",
  	DATA_LENGTHOFLIST: "longueur de %1",
  	DATA_LISTCONTAINSITEM: "%1 contient %2 ?",
  	CONTROL_ELSE: "sinon",
  	SENSING_USERID: "id de l'utilisateur",
  	SENSING_LOUD: "fort ?",
  	"text2speech.speakAndWaitBlock": "prononcer %1",
  	"text2speech.setVoiceBlock": "choisir la voix du %1",
  	"text2speech.setLanguageBlock": "mettre la langue à %1",
  	"translate.translateBlock": "traduire %1 en %2",
  	"translate.viewerLanguage": "langue",
  	"makeymakey.whenKeyPressed": "quand la touche %1 pressée",
  	"makeymakey.whenKeysPressedInOrder": "quand %1 sont pressés dans l'ordre",
  	"microbit.whenButtonPressed": "quand le bouton %1 est appuyé",
  	"microbit.isButtonPressed": "bouton %1 appuyé ?",
  	"microbit.whenGesture": "quand %1",
  	"microbit.displaySymbol": "afficher %1",
  	"microbit.displayText": "afficher le texte %1",
  	"microbit.clearDisplay": "effacer l'écran",
  	"microbit.whenTilted": "quand incliné %1",
  	"microbit.isTilted": "incliné %1 ?",
  	"microbit.tiltAngle": "angle d'inclinaison %1",
  	"microbit.whenPinConnected": "quand la broche %1 est connectée",
  	"ev3.motorTurnClockwise": "faire tourner le moteur %1 dans ce sens-ci pendant %2 secondes",
  	"ev3.motorTurnCounterClockwise": "faire tourner le moteur %1 dans ce sens-là pendant %2 secondes",
  	"ev3.motorSetPower": "mettre la puissance du moteur %1 à %2 %",
  	"ev3.getMotorPosition": "position du moteur %1",
  	"ev3.whenButtonPressed": "quand le bouton %1 est appuyé",
  	"ev3.whenDistanceLessThan": "quand la distance < %1",
  	"ev3.whenBrightnessLessThan": "quand la luminosité < %1",
  	"ev3.buttonPressed": "bouton %1 appuyé ?",
  	"ev3.getDistance": "distance",
  	"ev3.getBrightness": "luminosité",
  	"ev3.beepNote": "jouer la note %1 pendant %2 secondes",
  	"wedo2.motorOn": "allumer %1",
  	"wedo2.motorOff": "éteindre %1",
  	"wedo2.startMotorPower": "set %1 power to %2",
  	"wedo2.setMotorDirection": "mettre la direction de %1 à %2",
  	"wedo2.whenDistance": "quand la distance %1 %2",
  	"wedo2.getDistance": "distance",
  	"wedo2.motorOnFor": "allumer %1 pendant %2 secondes",
  	"wedo2.setLightHue": "mettre la couleur de la lampe à %1",
  	"wedo2.playNoteFor": "jouer la note %1 pendant %2 secondes",
  	"wedo2.whenTilted": "quand incliné %1",
  	"wedo2.isTilted": "incliné %1 ?",
  	"wedo2.getTiltAngle": "angle d'inclinaison %1",
  	"gdxfor.whenGesture": "quand %1",
  	"gdxfor.whenForcePushedOrPulled": "quand le capteur de force est %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "quand incliné %1",
  	"gdxfor.isTilted": "incliné %1 ?",
  	"gdxfor.getTilt": "angle d'inclinaison %1",
  	"gdxfor.isFreeFalling": "tombe ?",
  	"gdxfor.getSpin": "vitesse de rotation %1",
  	"gdxfor.getAcceleration": "accélération %1",
  	"boost.motorOnFor": "faire tourner le moteur %1 pendant %2 secondes",
  	"boost.motorOnForRotation": "faire tourner le moteur %1 de %2 rotations",
  	"boost.motorOn": "allumer le moteur %1",
  	"boost.motorOff": "éteindre le moteur %1",
  	"boost.setMotorPower": "mettre la vitesse du moteur %1 à %2 %",
  	"boost.setMotorDirection": "mettre la direction du moteur %1 à %2",
  	"boost.getMotorPosition": "position du moteur %1",
  	"boost.whenColor": "quand une brique %1 est vue",
  	"boost.seeingColor": "brique %1 vue ?",
  	"boost.whenTilted": "quand incliné %1",
  	"boost.getTiltAngle": "angle d'inclinaison %1",
  	"boost.setLightHue": "mettre la couleur de la lampe à %1"
  };
  var dropdowns$Q = {
  };
  var ignorelt$Q = [
  ];
  var soundEffects$Q = [
  	"hauteur",
  	"stéréo gauche/droite"
  ];
  var microbitWhen$Q = [
  	"bougé",
  	"secoué",
  	"sauté"
  ];
  var osis$Q = [
  	"autres scripts dans sprite"
  ];
  var definePrefix$Q = [
  	"définir"
  ];
  var defineSuffix$Q = [
  ];
  var palette$Q = {
  	Motion: "Mouvement",
  	Looks: "Apparence",
  	Sound: "Son",
  	Events: "Événements",
  	Control: "Contrôle",
  	Sensing: "Capteurs",
  	Operators: "Opérateurs",
  	Variables: "Variables",
  	"My Blocks": "Mes Blocs"
  };
  var math$Q = [
  	"abs",
  	"plancher",
  	"plafond",
  	"racine",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e^",
  	"10^"
  ];
  var aliases$Q = {
  	"tourner gauche de %1 degrés": "MOTION_TURNLEFT",
  	"tourner droite de %1 degrés": "MOTION_TURNRIGHT",
  	"quand le drapeau vert pressé": "EVENT_WHENFLAGCLICKED",
  	fin: "scratchblocks:end"
  };
  var name$Q = "Français";
  var percentTranslated$Q = 100;
  var fr = {
  	commands: commands$Q,
  	dropdowns: dropdowns$Q,
  	ignorelt: ignorelt$Q,
  	soundEffects: soundEffects$Q,
  	microbitWhen: microbitWhen$Q,
  	osis: osis$Q,
  	definePrefix: definePrefix$Q,
  	defineSuffix: defineSuffix$Q,
  	palette: palette$Q,
  	math: math$Q,
  	aliases: aliases$Q,
  	name: name$Q,
  	percentTranslated: percentTranslated$Q
  };

  var commands$P = {
  	MOTION_MOVESTEPS: "ferpleats %1 stappen",
  	MOTION_TURNRIGHT: "draaie @turnRight %1 graden",
  	MOTION_TURNLEFT: "draai @turnLeft %1 graden",
  	MOTION_POINTINDIRECTION: "wiis yn rjochting %1",
  	MOTION_POINTTOWARDS: "wiis nei %1",
  	MOTION_GOTOXY: "gean nei x: %1 y: %2",
  	MOTION_GOTO: "gean nei %1",
  	MOTION_GLIDESECSTOXY: "glydzje %1 sekonden nei x: %2 y: %3",
  	MOTION_GLIDETO: "glydzje %1 sekonden nei %2",
  	MOTION_CHANGEXBY: "feroarje x mei %1",
  	MOTION_SETX: "stel x yn op %1",
  	MOTION_CHANGEYBY: "feroarje y mei %1",
  	MOTION_SETY: "stel y yn op %1",
  	MOTION_SETROTATIONSTYLE: "stel rotaasjestyl %1 yn",
  	LOOKS_SAYFORSECS: "sis %1 foar %2 sekonden",
  	LOOKS_SAY: "sis %1",
  	LOOKS_THINKFORSECS: "tink %1 foar %2 sekonden",
  	LOOKS_THINK: "tink %1",
  	LOOKS_SHOW: "sjen litte",
  	LOOKS_HIDE: "ferstopje",
  	LOOKS_SWITCHCOSTUMETO: "wikselje kostúm nei %1",
  	LOOKS_NEXTCOSTUME: "folgjende kostúm",
  	LOOKS_NEXTBACKDROP_BLOCK: "folgjende dekôr",
  	LOOKS_SWITCHBACKDROPTO: "wikselje eftergrûn nei %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "wikselje dekôr nei %1 en wachtsje",
  	LOOKS_CHANGEEFFECTBY: "feroarje %1 effekt mei %2",
  	LOOKS_SETEFFECTTO: "stel %1 effekt yn op %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "grafyske effekten weromsette",
  	LOOKS_CHANGESIZEBY: "feroarje grutte mei %1",
  	LOOKS_SETSIZETO: "stel grutte yn op %1 %",
  	LOOKS_GOTOFRONTBACK: "gean nei %1 laach",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "gean %1 %2 lagen",
  	SOUND_PLAY: "start lûd %1",
  	SOUND_CHANGEEFFECTBY: "feroarje %1 effekt mei %2",
  	SOUND_SETEFFECTO: "stel %1 effekt yn op %2",
  	SOUND_CLEAREFFECTS: "opskjinje lûdseffekten",
  	SOUND_PLAYUNTILDONE: "spylje lûd %1 oant ein",
  	SOUND_STOPALLSOUNDS: "stopje alle lûden",
  	"music.playDrumForBeats": "spylje trommel %1 foar %2 beats",
  	"music.restForBeats": "rêst foar %1 beats",
  	"music.playNoteForBeats": "play noat %1 foar %2 beats",
  	"music.setInstrument": "ynstrumint ynstelle op %1",
  	SOUND_CHANGEVOLUMEBY: "feroarje folume mei %1",
  	SOUND_SETVOLUMETO: "stel folume yn op %1%",
  	"music.changeTempo": "tempo feroarje mei %1",
  	"music.setTempo": "set tempo yn op %1",
  	"pen.clear": "wiskje alles",
  	"pen.stamp": "stimpel",
  	"pen.penDown": "pen omleech",
  	"pen.penUp": "pen omheech",
  	"pen.setColor": "set pennekleur yn op %1",
  	"pen.changeHue": "feroarje pennekleur troch %1",
  	"pen.setColorParam": "set pinne %1 yn op %2",
  	"pen.changeColorParam": "feroarje pinne %1 troch %2",
  	"pen.setHue": "set pennekleur yn op %1",
  	"pen.changeShade": "feroarje penskerm troch %1",
  	"pen.setShade": "set penskerm op %1",
  	"pen.changeSize": "pennegrutte feroarje mei %1",
  	"pen.setSize": "set pennegrutte yn op %1",
  	EVENT_WHENFLAGCLICKED: "as @greenFlag klikt",
  	EVENT_WHENKEYPRESSED: "as %1 toets yndrukt wurdt",
  	EVENT_WHENTHISSPRITECLICKED: "as dizze sprite klikt",
  	EVENT_WHENSTAGECLICKED: "as faze klikt",
  	EVENT_WHENBACKDROPSWITCHESTO: "as eftergrûn feroaret nei %1",
  	EVENT_WHENGREATERTHAN: "as %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "as ik %1 ûntfang",
  	EVENT_BROADCAST: "stjoer %1 út",
  	EVENT_BROADCASTANDWAIT: "stjoer %1 út en wachtsje",
  	CONTROL_WAIT: "wachtsje %1 sekonden",
  	CONTROL_REPEAT: "werhelje %1",
  	CONTROL_FOREVER: "foar altyd",
  	CONTROL_IF: "as %1 dan",
  	CONTROL_WAITUNTIL: "wachtsje oant %1",
  	CONTROL_REPEATUNTIL: "werhelje oant %1",
  	CONTROL_STOP: "stop %1",
  	CONTROL_STARTASCLONE: "as ik begjin as in kloan",
  	CONTROL_CREATECLONEOF: "meitsje kloan fan %1",
  	CONTROL_DELETETHISCLONE: "dizze kloan fuortsmite",
  	SENSING_ASKANDWAIT: "freegje %1 en wachtsje",
  	"videoSensing.videoToggle": "keare fideo %1",
  	"videoSensing.setVideoTransparency": "set fideotransparânsje yn op %1",
  	"videoSensing.whenMotionGreaterThan": "wannear fideobeweging> %1",
  	SENSING_RESETTIMER: "weromsette timer",
  	DATA_SETVARIABLETO: "set %1 op %2",
  	DATA_CHANGEVARIABLEBY: "feroarje %1 mei %2",
  	DATA_SHOWVARIABLE: "toan fariabele %1",
  	DATA_HIDEVARIABLE: "ferstopje fariabele %1",
  	DATA_ADDTOLIST: "fergrutsje %1 nei %2",
  	DATA_DELETEOFLIST: "wiskje %1 fan %2",
  	DATA_DELETEALLOFLIST: "wiskje alles fan %1",
  	MOTION_IFONEDGEBOUNCE: "as op 'e râne, stuiterje",
  	DATA_INSERTATLIST: "foegje %1 yn op %2 fan %3",
  	DATA_REPLACEITEMOFLIST: "ferfang ûnderdiel %1 fan %2 troch %3",
  	DATA_SHOWLIST: "list %1 sjen litte",
  	DATA_HIDELIST: "list %1 ferbergje",
  	SENSING_OF_XPOSITION: "posysje fan x",
  	SENSING_OF_YPOSITION: "posysje fan y",
  	SENSING_OF_DIRECTION: "rjochting",
  	SENSING_OF_COSTUMENUMBER: "kostúm #",
  	LOOKS_COSTUMENUMBERNAME: "kostúm %1",
  	SENSING_OF_SIZE: "grutte",
  	SENSING_OF_BACKDROPNAME: "eftergrûn namme",
  	LOOKS_BACKDROPNUMBERNAME: "eftergrûn %1",
  	SENSING_OF_BACKDROPNUMBER: "eftergrûn #",
  	SOUND_VOLUME: "folume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "rekket %1 oan?",
  	SENSING_TOUCHINGCOLOR: "rekket kleur %1 oan?",
  	SENSING_COLORISTOUCHINGCOLOR: "kleur %1 rekket %2 oan?",
  	SENSING_DISTANCETO: "ôfstân nei %1",
  	SENSING_ANSWER: "antwurd",
  	SENSING_KEYPRESSED: "toets %1 yndrukt?",
  	SENSING_MOUSEDOWN: "mûs omleech?",
  	SENSING_MOUSEX: "mûs x",
  	SENSING_MOUSEY: "mûs y",
  	SENSING_SETDRAGMODE: "sleepmodus %1 ynstelle",
  	SENSING_LOUDNESS: "lûdens",
  	"videoSensing.videoOn": "fideo %1 op %2",
  	SENSING_TIMER: "timer",
  	SENSING_OF: "%1 fan %2",
  	SENSING_CURRENT: "aktueel %1",
  	SENSING_DAYSSINCE2000: "dagen sûnt 2000",
  	SENSING_USERNAME: "brûkersnamme",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "kies willekeurich %1 oant %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 en %2",
  	OPERATORS_OR: "%1 of %2",
  	OPERATORS_NOT: "net %1",
  	OPERATORS_JOIN: "gearkomme mei %1 %2",
  	OPERATORS_LETTEROF: "letter %1 fan %2",
  	OPERATORS_LENGTH: "lingte fan %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "likernôch %1",
  	OPERATORS_MATHOP: "%1 fan %2",
  	OPERATORS_CONTAINS: "%1 befettet %2?",
  	DATA_ITEMOFLIST: "ûnderdiel  %1 fan %2",
  	DATA_ITEMNUMOFLIST: "ûnderdiel # fan %1 yn %2",
  	DATA_LENGTHOFLIST: "lingte fan %1",
  	DATA_LISTCONTAINSITEM: "%1 befettet %2?",
  	CONTROL_ELSE: "oars",
  	SENSING_USERID: "brûkers-id",
  	SENSING_LOUD: "lûd?",
  	"text2speech.speakAndWaitBlock": "sprekke %1",
  	"text2speech.setVoiceBlock": "set stim op %1",
  	"text2speech.setLanguageBlock": "set taal yn op %1",
  	"translate.translateBlock": "oersette %1 nei %2",
  	"translate.viewerLanguage": "taal",
  	"makeymakey.whenKeyPressed": "as %1 toets yndrukt wurdt",
  	"makeymakey.whenKeysPressedInOrder": "as %1 yn folchoarder yndrukt wurdt",
  	"microbit.whenButtonPressed": "as %1 knop yndrukt wurdt",
  	"microbit.isButtonPressed": "%1 knop yndrukt?",
  	"microbit.whenGesture": "as %1",
  	"microbit.displaySymbol": "skerm %1",
  	"microbit.displayText": "skerm tekst %1",
  	"microbit.clearDisplay": "Skerm skjinmeitsje",
  	"microbit.whenTilted": "as kantele nei %1",
  	"microbit.isTilted": "kantele %1?",
  	"microbit.tiltAngle": "kantelhoek %1",
  	"microbit.whenPinConnected": "as pin %1 ferbûn is",
  	"ev3.motorTurnClockwise": "draai motor %1 dizze kant út foar %2 sekonden",
  	"ev3.motorTurnCounterClockwise": "draai motor %1 dy kant út foar %2 sekonden",
  	"ev3.motorSetPower": "stel motor %1 yn op %2% krêft",
  	"ev3.getMotorPosition": "motor %1 posysje",
  	"ev3.whenButtonPressed": "as knop %1 yndrukt wurdt",
  	"ev3.whenDistanceLessThan": "wannear't ôfstân <%1",
  	"ev3.whenBrightnessLessThan": "as helderheid <%1",
  	"ev3.buttonPressed": "knop %1 yndrukt?",
  	"ev3.getDistance": "ôfstân",
  	"ev3.getBrightness": "helderheid",
  	"ev3.beepNote": "lit %1 %2 sekonden hearre",
  	"wedo2.motorOn": "skeakelje %1 yn",
  	"wedo2.motorOff": "set %1 út",
  	"wedo2.startMotorPower": "set %1 macht yn op %2",
  	"wedo2.setMotorDirection": "set %1 rjochting yn op %2",
  	"wedo2.whenDistance": "wannear ôfstân %1 %2",
  	"wedo2.getDistance": "ôfstân",
  	"wedo2.motorOnFor": "skeakelje %1 %2 sekonden yn",
  	"wedo2.setLightHue": "set ljochtkleur yn op %1",
  	"wedo2.playNoteFor": "spylje noat %1 foar %2 sekonden",
  	"wedo2.whenTilted": "as kantele %1",
  	"wedo2.isTilted": "kantele %1?",
  	"wedo2.getTiltAngle": "kantelhoek %1",
  	"gdxfor.whenGesture": "as %1",
  	"gdxfor.whenForcePushedOrPulled": "as krêftsensor %1",
  	"gdxfor.getForce": "krêft",
  	"gdxfor.whenTilted": "as kantele %1",
  	"gdxfor.isTilted": "kantele %1?",
  	"gdxfor.getTilt": "kantelhoeke %1",
  	"gdxfor.isFreeFalling": "falt?",
  	"gdxfor.getSpin": "draaisnelheid %1",
  	"gdxfor.getAcceleration": "fersnelling %1",
  	"boost.motorOnFor": "lit motor %1 %2 sekonden draaie",
  	"boost.motorOnForRotation": "lit motor %1 %2 rûntsjes draaie",
  	"boost.motorOn": "set motor %1 oan",
  	"boost.motorOff": "set motor %1 út",
  	"boost.setMotorPower": "set motor %1 op %2% snelheid",
  	"boost.setMotorDirection": "set motor %1 yn de rjochting %2",
  	"boost.getMotorPosition": "motor %1 posysje",
  	"boost.whenColor": "as it %1 stientsje te sjen is",
  	"boost.seeingColor": "is it %1 stientsje te sjen?",
  	"boost.whenTilted": "as kantele %1",
  	"boost.getTiltAngle": "kantelhoek %1",
  	"boost.setLightHue": "stel de kleur fan it ljocht yn op %1"
  };
  var dropdowns$P = {
  };
  var ignorelt$P = [
  ];
  var soundEffects$P = [
  	"toanhichte",
  	"ferskowe links/rjochts"
  ];
  var microbitWhen$P = [
  	"bewege",
  	"skodde",
  	"sprong"
  ];
  var osis$P = [
  	"oare skripts yn sprite"
  ];
  var definePrefix$P = [
  	"definiearje"
  ];
  var defineSuffix$P = [
  ];
  var palette$P = {
  	Motion: "Beweging",
  	Looks: "Ferskining",
  	Sound: "Lûd",
  	Events: "Eveneminten",
  	Control: "Kontrôle",
  	Sensing: "Gefoel",
  	Operators: "Bestjoerders",
  	Variables: "Fariabelen",
  	"My Blocks": "Myn Blokken"
  };
  var math$P = [
  	"abs",
  	"flier",
  	"plafond",
  	"woartel",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$P = {
  };
  var name$P = "Frysk";
  var percentTranslated$P = 100;
  var fy = {
  	commands: commands$P,
  	dropdowns: dropdowns$P,
  	ignorelt: ignorelt$P,
  	soundEffects: soundEffects$P,
  	microbitWhen: microbitWhen$P,
  	osis: osis$P,
  	definePrefix: definePrefix$P,
  	defineSuffix: defineSuffix$P,
  	palette: palette$P,
  	math: math$P,
  	aliases: aliases$P,
  	name: name$P,
  	percentTranslated: percentTranslated$P
  };

  var commands$O = {
  	MOTION_MOVESTEPS: "bog %1 coiscéim",
  	MOTION_TURNRIGHT: "rothlaigh @turnRight %1 céim",
  	MOTION_TURNLEFT: "rothlaigh @turnLeft %1 céim",
  	MOTION_POINTINDIRECTION: "tabhair aghaidh ar %1",
  	MOTION_POINTTOWARDS: "tabhair aghaidh i dtreo %1",
  	MOTION_GOTOXY: "téigh go x: %1 y: %2",
  	MOTION_GOTO: "téigh go %1",
  	MOTION_GLIDESECSTOXY: "sleamhnaigh %1 soicind go x: %2 y: %3",
  	MOTION_GLIDETO: "sleamhnaigh %1 soicind go %2",
  	MOTION_CHANGEXBY: "athraigh x de %1",
  	MOTION_SETX: "socraigh x: %1",
  	MOTION_CHANGEYBY: "athraigh y de %1",
  	MOTION_SETY: "socraigh y: %1",
  	MOTION_SETROTATIONSTYLE: "socraigh an stíl rothlaithe: %1",
  	LOOKS_SAYFORSECS: "abair %1 ar feadh %2 soicind",
  	LOOKS_SAY: "abair %1",
  	LOOKS_THINKFORSECS: "smaoinigh %1 ar feadh %2 soicind",
  	LOOKS_THINK: "smaoinigh %1",
  	LOOKS_SHOW: "taispeáin",
  	LOOKS_HIDE: "folaigh",
  	LOOKS_SWITCHCOSTUMETO: "athraigh an chulaith go %1",
  	LOOKS_NEXTCOSTUME: "an chéad chulaith eile",
  	LOOKS_NEXTBACKDROP_BLOCK: "an chéad chúlra eile",
  	LOOKS_SWITCHBACKDROPTO: "athraigh an cúlra go %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "athraigh an cúlra go %1 agus fan",
  	LOOKS_CHANGEEFFECTBY: "athraigh maisíocht %1 de %2",
  	LOOKS_SETEFFECTTO: "socraigh maisíocht %1: %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "glan na maisíochtaí grafaice",
  	LOOKS_CHANGESIZEBY: "athraigh an mhéid de %1",
  	LOOKS_SETSIZETO: "socraigh an mhéid: %1 %",
  	LOOKS_GOTOFRONTBACK: "téigh go dtí an tsraith %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "téigh %1 %2 sraith",
  	SOUND_PLAY: "seinn fuaim %1",
  	SOUND_CHANGEEFFECTBY: "athraigh maisíocht %1 de %2",
  	SOUND_SETEFFECTO: "socraigh maisíocht %1: %2",
  	SOUND_CLEAREFFECTS: "glan na maisíochtaí fuaime",
  	SOUND_PLAYUNTILDONE: "seinn fuaim %1 go dtí a deireadh",
  	SOUND_STOPALLSOUNDS: "stop gach fuaim",
  	"music.playDrumForBeats": "seinn druma %1 ar feadh %2 buille",
  	"music.restForBeats": "stad ar feadh %1 buille",
  	"music.playNoteForBeats": "seinn nóta %1 ar feadh %2 buille",
  	"music.setInstrument": "socraigh an ionstraim: %1",
  	SOUND_CHANGEVOLUMEBY: "athraigh airde na fuaime de %1",
  	SOUND_SETVOLUMETO: "socraigh airde na fuaime: %1%",
  	"music.changeTempo": "athraigh an luas de %1",
  	"music.setTempo": "socraigh an luas: %1",
  	"pen.clear": "scrios uile",
  	"pen.stamp": "stampa",
  	"pen.penDown": "peann síos",
  	"pen.penUp": "peann suas",
  	"pen.setColor": "socraigh dath an phinn: %1",
  	"pen.changeHue": "athraigh dath an phinn de %1",
  	"pen.setColorParam": "socraigh %1 an phinn: %2",
  	"pen.changeColorParam": "athraigh %1 an phinn de %2",
  	"pen.setHue": "socraigh dath an phinn: %1",
  	"pen.changeShade": "athraigh dorchadas an phinn de %1",
  	"pen.setShade": "socraigh dorchadas an phinn: %1",
  	"pen.changeSize": "athraigh méid an phinn de %1",
  	"pen.setSize": "socraigh méid an phinn: %1",
  	EVENT_WHENFLAGCLICKED: "nuair a chliceáiltear @greenFlag",
  	EVENT_WHENKEYPRESSED: "nuair a bhrúitear eochair %1",
  	EVENT_WHENTHISSPRITECLICKED: "nuair a chliceáiltear an sprid seo",
  	EVENT_WHENSTAGECLICKED: "nuair a chliceáiltear an stáitse",
  	EVENT_WHENBACKDROPSWITCHESTO: "nuair a chuirtear %1 suas",
  	EVENT_WHENGREATERTHAN: "nuair atá %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "nuair a fhaighim %1",
  	EVENT_BROADCAST: "craol %1",
  	EVENT_BROADCASTANDWAIT: "craol %1 agus fan",
  	CONTROL_WAIT: "fan %1 soicind",
  	CONTROL_REPEAT: "déan %1 uair",
  	CONTROL_FOREVER: "go deo",
  	CONTROL_IF: "más %1 ansin",
  	CONTROL_WAITUNTIL: "fan go %1",
  	CONTROL_REPEATUNTIL: "athdhéan go %1",
  	CONTROL_STOP: "stop %1",
  	CONTROL_STARTASCLONE: "nuair a thosaím mar chóip",
  	CONTROL_CREATECLONEOF: "cruthaigh cóip de %1",
  	CONTROL_DELETETHISCLONE: "scrios an chóip seo",
  	SENSING_ASKANDWAIT: "fiafraigh %1 agus fan",
  	"videoSensing.videoToggle": "cas an físeán %1",
  	"videoSensing.setVideoTransparency": "socraigh an trédhearcacht físe: %1",
  	"videoSensing.whenMotionGreaterThan": "Nuair atá físghluaiseacht > %1",
  	SENSING_RESETTIMER: "athshocraigh an t-amadóir",
  	DATA_SETVARIABLETO: "socraigh %1: %2",
  	DATA_CHANGEVARIABLEBY: "athraigh %1 de %2",
  	DATA_SHOWVARIABLE: "taispeáin athróg %1",
  	DATA_HIDEVARIABLE: "folaigh athróg %1",
  	DATA_ADDTOLIST: "cuir %1 le %2",
  	DATA_DELETEOFLIST: "scrios %1 as %2",
  	DATA_DELETEALLOFLIST: "scrios na %1 rud go léir",
  	MOTION_IFONEDGEBOUNCE: "más ar an imeall, preab",
  	DATA_INSERTATLIST: "ionsáigh %1 ag %2 i %3",
  	DATA_REPLACEITEMOFLIST: "cuir %3 in áit mír %1 i %2",
  	DATA_SHOWLIST: "taispeáin liosta %1",
  	DATA_HIDELIST: "folaigh liosta %1",
  	SENSING_OF_XPOSITION: "ionad x",
  	SENSING_OF_YPOSITION: "ionad y",
  	SENSING_OF_DIRECTION: "treo",
  	SENSING_OF_COSTUMENUMBER: "culaith #",
  	LOOKS_COSTUMENUMBERNAME: "culaith %1",
  	SENSING_OF_SIZE: "méid",
  	SENSING_OF_BACKDROPNAME: "ainm an chúlra",
  	LOOKS_BACKDROPNUMBERNAME: "cúlra %1",
  	SENSING_OF_BACKDROPNUMBER: "cúlra #",
  	SOUND_VOLUME: "airde",
  	"music.getTempo": "luas",
  	SENSING_TOUCHINGOBJECT: "i dteagmháil le %1?",
  	SENSING_TOUCHINGCOLOR: "i dteagmháil le dath %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "dath %1 i dteagmháil le %2?",
  	SENSING_DISTANCETO: "fad go dtí %1",
  	SENSING_ANSWER: "freagra",
  	SENSING_KEYPRESSED: "eochair %1 brúite?",
  	SENSING_MOUSEDOWN: "luchóg síos?",
  	SENSING_MOUSEX: "luchóg x",
  	SENSING_MOUSEY: "luchóg y",
  	SENSING_SETDRAGMODE: "socraigh mód tarraingthe: %1",
  	SENSING_LOUDNESS: "treise",
  	"videoSensing.videoOn": "%1 físe ar %2",
  	SENSING_TIMER: "amadóir",
  	SENSING_OF: "%1 as %2",
  	SENSING_CURRENT: "%1 reatha",
  	SENSING_DAYSSINCE2000: "laethanta ó 2000",
  	SENSING_USERNAME: "ainm úsáideora",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "uimhir randamach idir %1 agus %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 agus %2",
  	OPERATORS_OR: "%1 nó %2",
  	OPERATORS_NOT: "séanadh %1",
  	OPERATORS_JOIN: "ceangail %1 %2",
  	OPERATORS_LETTEROF: "litir %1 de %2",
  	OPERATORS_LENGTH: "fad %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "slánaigh %1",
  	OPERATORS_MATHOP: "%1 as %2",
  	OPERATORS_CONTAINS: "%1 agus %2 ann?",
  	DATA_ITEMOFLIST: "mír %1 as %2",
  	DATA_ITEMNUMOFLIST: "mír # as %1 in %2",
  	DATA_LENGTHOFLIST: "fad %1",
  	DATA_LISTCONTAINSITEM: "%1 agus %2 ann?",
  	CONTROL_ELSE: "seachas sin",
  	SENSING_USERID: "aitheantas úsáideora",
  	SENSING_LOUD: "os ard?",
  	"text2speech.speakAndWaitBlock": "abair %1",
  	"text2speech.setVoiceBlock": "socraigh an guth: %1",
  	"text2speech.setLanguageBlock": "socraigh an teanga: %1",
  	"translate.translateBlock": "aistrigh %1 go %2",
  	"translate.viewerLanguage": "teanga",
  	"makeymakey.whenKeyPressed": "nuair a bhrúitear eochair %1",
  	"makeymakey.whenKeysPressedInOrder": "nuair a bhrúitear %1 in ord",
  	"microbit.whenButtonPressed": "agus cnaipe %1 brúite",
  	"microbit.isButtonPressed": "cnaipe %1 brúite?",
  	"microbit.whenGesture": "nuair a bhraitear %1",
  	"microbit.displaySymbol": "taispeáin %1",
  	"microbit.displayText": "taispeáin téacs %1",
  	"microbit.clearDisplay": "glan an scáileán",
  	"microbit.whenTilted": "agus claonta i dtreo %1",
  	"microbit.isTilted": "claonta %1?",
  	"microbit.tiltAngle": "uillinn %1",
  	"microbit.whenPinConnected": "nuair atá pionna %1 ceangailte",
  	"ev3.motorTurnClockwise": "cas mótar %1 sa treo seo ar feadh %2 soicind",
  	"ev3.motorTurnCounterClockwise": "cas mótar %1 sa treo sin ar feadh %2 soicind",
  	"ev3.motorSetPower": "socraigh cumhacht mhótar %1: %2%",
  	"ev3.getMotorPosition": "treoshuíomh mótair %1",
  	"ev3.whenButtonPressed": "agus cnaipe %1 brúite",
  	"ev3.whenDistanceLessThan": "agus fad < %1",
  	"ev3.whenBrightnessLessThan": "agus gile < %1",
  	"ev3.buttonPressed": "cnaipe %1 brúite?",
  	"ev3.getDistance": "fad slí",
  	"ev3.getBrightness": "gile",
  	"ev3.beepNote": "seinn nóta %1 mar bhíp ar feadh %2 soicind",
  	"wedo2.motorOn": "cuir %1 ar siúl",
  	"wedo2.motorOff": "múch %1",
  	"wedo2.startMotorPower": "socraigh cumhacht %1: %2",
  	"wedo2.setMotorDirection": "socraigh treo %1: %2",
  	"wedo2.whenDistance": "agus fad %1 %2",
  	"wedo2.getDistance": "fad slí",
  	"wedo2.motorOnFor": "cuir %1 ar siúl ar feadh %2 soicind",
  	"wedo2.setLightHue": "socraigh dath an tsolais: %1",
  	"wedo2.playNoteFor": "seinn nóta %1 ar feadh %2 soicind",
  	"wedo2.whenTilted": "agus claonta %1",
  	"wedo2.isTilted": "claonta %1?",
  	"wedo2.getTiltAngle": "uillinn chlaonta %1",
  	"gdxfor.whenGesture": "nuair a bhraitear %1",
  	"gdxfor.whenForcePushedOrPulled": "nuair atá an braiteoir fórsa %1",
  	"gdxfor.getForce": "fórsa",
  	"gdxfor.whenTilted": "agus claonta %1",
  	"gdxfor.isTilted": "claonta %1?",
  	"gdxfor.getTilt": "uillinn chlaonta %1",
  	"gdxfor.isFreeFalling": "ag titim?",
  	"gdxfor.getSpin": "luas casta %1",
  	"gdxfor.getAcceleration": "luasghéarú %1",
  	"boost.motorOnFor": "cas mótar %1 ar feadh %2 soicind",
  	"boost.motorOnForRotation": "cas mótar %1 ar feadh %2 rothlú",
  	"boost.motorOn": "cuir mótar %1 ar siúl",
  	"boost.motorOff": "múch mótar %1",
  	"boost.setMotorPower": "socraigh luas mótair %1: %2 %",
  	"boost.setMotorDirection": "socraigh treo mótair %1: %2",
  	"boost.getMotorPosition": "ionad mótair %1",
  	"boost.whenColor": "nuair a fheictear bríce %1",
  	"boost.seeingColor": "an bhfeictear bríce %1?",
  	"boost.whenTilted": "agus claonta %1",
  	"boost.getTiltAngle": "uillinn chlaonta %1",
  	"boost.setLightHue": "socraigh dath an tsolais: %1"
  };
  var dropdowns$O = {
  };
  var ignorelt$O = [
  ];
  var soundEffects$O = [
  	"tuinairde",
  	"peanáil ar chlé/ar dheis"
  ];
  var microbitWhen$O = [
  	"bogtha",
  	"croite",
  	"léimthe"
  ];
  var osis$O = [
  	"scripteanna eile sa sprid"
  ];
  var definePrefix$O = [
  	"sainmhínigh"
  ];
  var defineSuffix$O = [
  ];
  var palette$O = {
  	Motion: "Gluaiseacht",
  	Looks: "Cuma",
  	Sound: "Fuaim",
  	Events: "Teagmhais",
  	Control: "Rialú",
  	Sensing: "Brath",
  	Operators: "Oibreoirí",
  	Variables: "Athróga",
  	"My Blocks": "Mo Chuid Blocanna"
  };
  var math$O = [
  	"abs",
  	"urlár",
  	"síleáil",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$O = {
  };
  var name$O = "Gaeilge";
  var percentTranslated$O = 100;
  var ga = {
  	commands: commands$O,
  	dropdowns: dropdowns$O,
  	ignorelt: ignorelt$O,
  	soundEffects: soundEffects$O,
  	microbitWhen: microbitWhen$O,
  	osis: osis$O,
  	definePrefix: definePrefix$O,
  	defineSuffix: defineSuffix$O,
  	palette: palette$O,
  	math: math$O,
  	aliases: aliases$O,
  	name: name$O,
  	percentTranslated: percentTranslated$O
  };

  var commands$N = {
  	MOTION_MOVESTEPS: "gluais le %1 ceum",
  	MOTION_TURNRIGHT: "cuairtich @turnRight le %1 puing",
  	MOTION_TURNLEFT: "cuairtich @turnLeft le %1 puing",
  	MOTION_POINTINDIRECTION: "cuir d’ aghaidh ri %1",
  	MOTION_POINTTOWARDS: "cuir d’ aghaidh an comhair %1",
  	MOTION_GOTOXY: "rach gu x: %1 y: %2",
  	MOTION_GOTO: "rach gu %1",
  	MOTION_GLIDESECSTOXY: "gluais fad %1 diog gu x: %2 y: %3",
  	MOTION_GLIDETO: "gluais fad %1 diog gu %2",
  	MOTION_CHANGEXBY: "atharraich x le %1",
  	MOTION_SETX: "suidhich x air %1",
  	MOTION_CHANGEYBY: "atharraich y le %1",
  	MOTION_SETY: "suidhich y air %1",
  	MOTION_SETROTATIONSTYLE: "suidhich stoidhle na cuairte air %1",
  	LOOKS_SAYFORSECS: "can %1 fad %2 diog",
  	LOOKS_SAY: "can %1",
  	LOOKS_THINKFORSECS: "smaoinich %1 fad %2 diog",
  	LOOKS_THINK: "smaoinich %1",
  	LOOKS_SHOW: "seall",
  	LOOKS_HIDE: "falaich",
  	LOOKS_SWITCHCOSTUMETO: "cuir dreach %1 ort",
  	LOOKS_NEXTCOSTUME: "an t-ath-dhreach",
  	LOOKS_NEXTBACKDROP_BLOCK: "an t-ath-chùlaibh",
  	LOOKS_SWITCHBACKDROPTO: "cuir %1 air a’ chùlaibh",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "cuir %1 air a’ chùlaibh is fan ri càch",
  	LOOKS_CHANGEEFFECTBY: "atharraich èifeachd %1 le %2",
  	LOOKS_SETEFFECTTO: "cuir èifeachd %1 de %2 ort",
  	LOOKS_CLEARGRAPHICEFFECTS: "falamhaich na h-èifeachdan",
  	LOOKS_CHANGESIZEBY: "atharraich do mheud le %1",
  	LOOKS_SETSIZETO: "suidhich do mheud air %1 %",
  	LOOKS_GOTOFRONTBACK: "rach gu breath %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "rach %2 breath %1",
  	SOUND_PLAY: "tòisich air fuaim %1 a chluich",
  	SOUND_CHANGEEFFECTBY: "atharraich èifeachd %1 le %2",
  	SOUND_SETEFFECTO: "cuir èifeachd %1 de %2 ort",
  	SOUND_CLEAREFFECTS: "falamhaich èifeachdan na fuaime",
  	SOUND_PLAYUNTILDONE: "cluich fuaim %1 gu lèir",
  	SOUND_STOPALLSOUNDS: "cuir stad air a h-uile fuaim",
  	"music.playDrumForBeats": "cluich druma %1 fad %2 buille",
  	"music.restForBeats": "tost fad %1 buille",
  	"music.playNoteForBeats": "cluich pong %1 fad %2 buille",
  	"music.setInstrument": "suidhich an t‑inneal-ciùil air %1",
  	SOUND_CHANGEVOLUMEBY: "atharraich àirde na fuaime le %1",
  	SOUND_SETVOLUMETO: "suidhich àirde na fuaime air %1%",
  	"music.changeTempo": "atharraich an luaths le %1",
  	"music.setTempo": "suidhich an luaths air %1",
  	"pen.clear": "suath às na h‑uile",
  	"pen.stamp": "stampa",
  	"pen.penDown": "peann sìos",
  	"pen.penUp": "peann suas",
  	"pen.setColor": "suidhich dath a’ phinn air %1",
  	"pen.changeHue": "atharraich dath a’ phinn le %1",
  	"pen.setColorParam": "suidhich %1 a’ phinn air %2",
  	"pen.changeColorParam": "atharraich %1 a’ phinn le %2",
  	"pen.setHue": "suidhich dath a’ phinn air %1",
  	"pen.changeShade": "atharraich tuar a’ phinn le %1",
  	"pen.setShade": "suidhich tuar a’ phinn air %1",
  	"pen.changeSize": "atharraich meud a’ phinn le %1",
  	"pen.setSize": "suidhich meud a’ phinn air %1",
  	EVENT_WHENFLAGCLICKED: "le briogadh air @greenFlag",
  	EVENT_WHENKEYPRESSED: "le brùthadh air iuchair %1",
  	EVENT_WHENTHISSPRITECLICKED: "le briogadh air an sprìd seo",
  	EVENT_WHENSTAGECLICKED: "le briogadh air an àrd-ùrlar",
  	EVENT_WHENBACKDROPSWITCHESTO: "nuair a thèid an cùlaibh na %1",
  	EVENT_WHENGREATERTHAN: "nuair a thèid %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "nuair a gheibh thu %1",
  	EVENT_BROADCAST: "craol %1",
  	EVENT_BROADCASTANDWAIT: "craol %1 is fan ri càch",
  	CONTROL_WAIT: "fan fad %1 diog",
  	CONTROL_REPEAT: "dèan seo %1 turas",
  	CONTROL_FOREVER: "gu buan",
  	CONTROL_IF: "ma tha %1 a-rèiste",
  	CONTROL_WAITUNTIL: "fan gus am bi %1",
  	CONTROL_REPEATUNTIL: "dèan a-rithist e gus am bi %1",
  	CONTROL_STOP: "cuir stad air %1",
  	CONTROL_STARTASCLONE: "nuair a thèid thu nad chlòn",
  	CONTROL_CREATECLONEOF: "cruthaich clòn %1",
  	CONTROL_DELETETHISCLONE: "sguab às an clòn seo",
  	SENSING_ASKANDWAIT: "faighnich %1 is fan ris",
  	"videoSensing.videoToggle": "cuir a’ video %1",
  	"videoSensing.setVideoTransparency": "suidhich trìd-shoillse a’ video air %1",
  	"videoSensing.whenMotionGreaterThan": "nuair a thèid gluasad a’ video > %1",
  	SENSING_RESETTIMER: "ath-shuidhich an tìmear",
  	DATA_SETVARIABLETO: "suidhich %1 air %2",
  	DATA_CHANGEVARIABLEBY: "atharraich %1 le %2",
  	DATA_SHOWVARIABLE: "seall an caochladair %1",
  	DATA_HIDEVARIABLE: "falaich an caochladair %1",
  	DATA_ADDTOLIST: "cuir %1 ri %2",
  	DATA_DELETEOFLIST: "sguab às %1 de %2",
  	DATA_DELETEALLOFLIST: "sguab às na h-uile gin de %1",
  	MOTION_IFONEDGEBOUNCE: "ma tha thu ris an oir, boc",
  	DATA_INSERTATLIST: "cuir %1 ris aig %2 de %3",
  	DATA_REPLACEITEMOFLIST: "cuir %3 an àite nì %1 de %2",
  	DATA_SHOWLIST: "seall an liosta %1",
  	DATA_HIDELIST: "falaich an liosta %1",
  	SENSING_OF_XPOSITION: "ionad x",
  	SENSING_OF_YPOSITION: "ionad y",
  	SENSING_OF_DIRECTION: "comhair",
  	SENSING_OF_COSTUMENUMBER: "àireamh an dreacha",
  	LOOKS_COSTUMENUMBERNAME: "%1 an dreacha",
  	SENSING_OF_SIZE: "meud",
  	SENSING_OF_BACKDROPNAME: "ainm a’ chùlaibh",
  	LOOKS_BACKDROPNUMBERNAME: "%1 a’ chùlaibh",
  	SENSING_OF_BACKDROPNUMBER: "àireamh a’ chùlaibh",
  	SOUND_VOLUME: "àirde na fuaime",
  	"music.getTempo": "luaths",
  	SENSING_TOUCHINGOBJECT: "%1 a’ beantainn riut",
  	SENSING_TOUCHINGCOLOR: "an dath %1 a’ beantainn riut",
  	SENSING_COLORISTOUCHINGCOLOR: "an dath %1 a’ beantainn ri %2",
  	SENSING_DISTANCETO: "an t-astar gu %1",
  	SENSING_ANSWER: "freagairt",
  	SENSING_KEYPRESSED: "iuchair %1 ga brùthadh",
  	SENSING_MOUSEDOWN: "an luchag ga briogadh",
  	SENSING_MOUSEX: "x na luchaige",
  	SENSING_MOUSEY: "y na luchaige",
  	SENSING_SETDRAGMODE: "suidhich %1 a shlaodadh",
  	SENSING_LOUDNESS: "àirde na fuaime",
  	"videoSensing.videoOn": "%1 a’ video air %2",
  	SENSING_TIMER: "an tìmear",
  	SENSING_OF: "%1 aig %2",
  	SENSING_CURRENT: "%1 làithreach",
  	SENSING_DAYSSINCE2000: "làithean o 2000 a-mach",
  	SENSING_USERNAME: "ainm-cleachdaiche",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 × %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "luach tuaireamach eadar %1 is %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 agus %2",
  	OPERATORS_OR: "%1 no %2",
  	OPERATORS_NOT: "e fallsa gu bheil %1",
  	OPERATORS_JOIN: "ceangail %1 ri %2",
  	OPERATORS_LETTEROF: "litir %1 de %2",
  	OPERATORS_LENGTH: "an fhaide aig %1",
  	OPERATORS_MOD: "%1 mòidealas %2",
  	OPERATORS_ROUND: "cuairtich %1",
  	OPERATORS_MATHOP: "%1 aig %2",
  	OPERATORS_CONTAINS: "%2 am broinn %1",
  	DATA_ITEMOFLIST: "nì %1 de %2",
  	DATA_ITEMNUMOFLIST: "àireamh an nì %1 air %2",
  	DATA_LENGTHOFLIST: "an fhaide aig %1",
  	DATA_LISTCONTAINSITEM: "%2 am broinn %1",
  	CONTROL_ELSE: "air neo",
  	SENSING_USERID: "ID a’ chleachdaiche",
  	SENSING_LOUD: "an fhuaim air",
  	"text2speech.speakAndWaitBlock": "can %1 gu h-àrd",
  	"text2speech.setVoiceBlock": "suidhich a’ ghuth air %1",
  	"text2speech.setLanguageBlock": "suidhich an cànan air %1",
  	"translate.translateBlock": "eadar-theangaich %1 gu %2",
  	"translate.viewerLanguage": "cànan",
  	"makeymakey.whenKeyPressed": "le brùthadh iuchrach %1",
  	"makeymakey.whenKeysPressedInOrder": "nuair a bhrùthar air %1 às dèidh a chèile",
  	"microbit.whenButtonPressed": "le brùthadh air putan %1",
  	"microbit.isButtonPressed": "putan %1 ga bhrùthadh",
  	"microbit.whenGesture": "le mothachadh air %1",
  	"microbit.displaySymbol": "seall %1",
  	"microbit.displayText": "seall an teacsa %1",
  	"microbit.clearDisplay": "falamhaich an sgrìn",
  	"microbit.whenTilted": "le claonadh %1",
  	"microbit.isTilted": "claonadh %1 air",
  	"microbit.tiltAngle": "ceàrn claonaidh %1",
  	"microbit.whenPinConnected": "nuair a thèid prìne %1 a cheangal",
  	"ev3.motorTurnClockwise": "gluais motar %1 dhan dàrna taobh fad %2 diog",
  	"ev3.motorTurnCounterClockwise": "gluais motar %1 dhan taobh eile fad %2 diog",
  	"ev3.motorSetPower": "suidhich cumhachd motar %1 air %2 %",
  	"ev3.getMotorPosition": "ionad a’ mhotair %1",
  	"ev3.whenButtonPressed": "le brùthadh air putan %1",
  	"ev3.whenDistanceLessThan": "nuair a thèid an t-astar < %1",
  	"ev3.whenBrightnessLessThan": "nuair a thèid an t-soilleireachd < %1",
  	"ev3.buttonPressed": "putan %1 ga bhrùthadh",
  	"ev3.getDistance": "astar",
  	"ev3.getBrightness": "soilleireachd",
  	"ev3.beepNote": "bìd pong %1 fad %2 diog",
  	"wedo2.motorOn": "cuir %1 air",
  	"wedo2.motorOff": "cuir %1 dheth",
  	"wedo2.startMotorPower": "suidhich cumhachd %1 air %2",
  	"wedo2.setMotorDirection": "suidhich comhair %1 air %2",
  	"wedo2.whenDistance": "nuair a thèid an t-astar %1 %2",
  	"wedo2.getDistance": "astar",
  	"wedo2.motorOnFor": "cuir %1 air fad %2 diog",
  	"wedo2.setLightHue": "suidhich dath an t-solais air %1",
  	"wedo2.playNoteFor": "cluich pong %1 fad %2 diog",
  	"wedo2.whenTilted": "le claonadh %1",
  	"wedo2.isTilted": "claonadh %1 air",
  	"wedo2.getTiltAngle": "ceàrn claonaidh %1",
  	"gdxfor.whenGesture": "le mothachadh air %1",
  	"gdxfor.whenForcePushedOrPulled": "le %1 air mothaichear an fhorsa",
  	"gdxfor.getForce": "forsa",
  	"gdxfor.whenTilted": "le claonadh %1",
  	"gdxfor.isTilted": "claonadh %1 air",
  	"gdxfor.getTilt": "ceàrn claonaidh %1",
  	"gdxfor.isFreeFalling": "a’ tuiteam",
  	"gdxfor.getSpin": "luaths a’ chuir %1",
  	"gdxfor.getAcceleration": "luathachadh %1",
  	"boost.motorOnFor": "cuairtich motar %1 fad %2 diog",
  	"boost.motorOnForRotation": "cuir %2 car air motar %1",
  	"boost.motorOn": "cuir motar %1 air",
  	"boost.motorOff": "cuir motar %1 dheth",
  	"boost.setMotorPower": "suidhich luaths a’ mhotair %1 air %2 %",
  	"boost.setMotorDirection": "cuir motar %1 an comhair %2",
  	"boost.getMotorPosition": "ionad a’ mhotair %1",
  	"boost.whenColor": "nuair a chì thu breige %1",
  	"boost.seeingColor": "thu a’ faicinn breige %1",
  	"boost.whenTilted": "le claonadh %1",
  	"boost.getTiltAngle": "ceàrn claonaidh %1",
  	"boost.setLightHue": "suidhich dath an t-solais air %1"
  };
  var dropdowns$N = {
  };
  var ignorelt$N = [
  ];
  var soundEffects$N = [
  	"gleusa",
  	"panachaidh gu clì/deas"
  ];
  var microbitWhen$N = [
  	"gluasad",
  	"crith",
  	"leum"
  ];
  var osis$N = [
  	"sgriobtaichean eile na sprìde"
  ];
  var definePrefix$N = [
  	"mìnich"
  ];
  var defineSuffix$N = [
  ];
  var palette$N = {
  	Motion: "Gluasad",
  	Looks: "Coltas",
  	Sound: "Fuaim",
  	Events: "Tachartas",
  	Control: "Smachd",
  	Sensing: "Mothachadh",
  	Operators: "Gnìomharaiche",
  	Variables: "Caochladairean",
  	"My Blocks": "Bloca agamsa"
  };
  var math$N = [
  	"an luach absaloideach",
  	"an cuairteachadh sìos",
  	"an cuairteachadh suas",
  	"am freumh ceàrnagach",
  	"an sìneas",
  	"an co-shìneas",
  	"am beantan",
  	"an t-àrc-shìneas",
  	"an t-àrc-cho-shìneas",
  	"an t-àrc-bheantan",
  	"an log-àireamh nàdarra",
  	"an log-àireamh",
  	"e ^",
  	"10 ^"
  ];
  var aliases$N = {
  	"cuairtich @turnLeft le %1 ceum": "MOTION_TURNLEFT",
  	"cuairtich @turnRight le %1 ceum": "MOTION_TURNRIGHT",
  	"le briogadh air @greenFlag": "EVENT_WHENFLAGCLICKED",
  	deireadh: "scratchblocks:end"
  };
  var name$N = "Gàidhlig";
  var percentTranslated$N = 100;
  var gd = {
  	commands: commands$N,
  	dropdowns: dropdowns$N,
  	ignorelt: ignorelt$N,
  	soundEffects: soundEffects$N,
  	microbitWhen: microbitWhen$N,
  	osis: osis$N,
  	definePrefix: definePrefix$N,
  	defineSuffix: defineSuffix$N,
  	palette: palette$N,
  	math: math$N,
  	aliases: aliases$N,
  	name: name$N,
  	percentTranslated: percentTranslated$N
  };

  var commands$M = {
  	MOTION_MOVESTEPS: "mover %1 pasos",
  	MOTION_TURNRIGHT: "xirar @turnRight %1 graos",
  	MOTION_TURNLEFT: "xirar @turnLeft %1 graos",
  	MOTION_POINTINDIRECTION: "apuntar na dirección %1",
  	MOTION_POINTTOWARDS: "apuntar cara a %1",
  	MOTION_GOTOXY: "ir para X: %1 Y: %2",
  	MOTION_GOTO: "ir para %1",
  	MOTION_GLIDESECSTOXY: "esvarar durante %1 seg a X: %2 Y: %3",
  	MOTION_GLIDETO: "esvarar durante %1 seg a %2",
  	MOTION_CHANGEXBY: "sumar %1 a X",
  	MOTION_SETX: "asignar a X o valor %1",
  	MOTION_CHANGEYBY: "sumar %1 a Y",
  	MOTION_SETY: "asignar a Y o valor %1",
  	MOTION_SETROTATIONSTYLE: "usar o estilo de rotación %1",
  	LOOKS_SAYFORSECS: "dicir %1 durante %2 segundos",
  	LOOKS_SAY: "dicir %1",
  	LOOKS_THINKFORSECS: "pensar %1 durante %2 segundos",
  	LOOKS_THINK: "pensar %1",
  	LOOKS_SHOW: "amosarse",
  	LOOKS_HIDE: "agocharse",
  	LOOKS_SWITCHCOSTUMETO: "mudar traxe a %1",
  	LOOKS_NEXTCOSTUME: "traxe seguinte",
  	LOOKS_NEXTBACKDROP_BLOCK: "fondo seguinte",
  	LOOKS_SWITCHBACKDROPTO: "mudar fondo a %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "mudar fondo a %1 e agardar",
  	LOOKS_CHANGEEFFECTBY: "sumar %2 ao efecto %1",
  	LOOKS_SETEFFECTTO: "aplicar o efecto %1 co valor %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "limpar os efectos gráficos",
  	LOOKS_CHANGESIZEBY: "sumar %1 ao tamaño",
  	LOOKS_SETSIZETO: "pór o tamaño ao %1 %",
  	LOOKS_GOTOFRONTBACK: "ir para a capa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ir %1 %2 capas",
  	SOUND_PLAY: "iniciar son %1",
  	SOUND_CHANGEEFFECTBY: "sumar ao efecto %1 o valor %2",
  	SOUND_SETEFFECTO: "aplicar o efecto %1 co valor %2",
  	SOUND_CLEAREFFECTS: "limpar os efectos de son",
  	SOUND_PLAYUNTILDONE: "reproducir %1 até rematar",
  	SOUND_STOPALLSOUNDS: "deter todos os sons",
  	"music.playDrumForBeats": "tocar o tambor %1 durante %2 pulsos",
  	"music.restForBeats": "descanso de %1 pulsos",
  	"music.playNoteForBeats": "tocar a nota %1 durante %2 pulsos",
  	"music.setInstrument": "usar o instrumento %1",
  	SOUND_CHANGEVOLUMEBY: "subir o volume en %1",
  	SOUND_SETVOLUMETO: "pór o volume no %1%",
  	"music.changeTempo": "aumentar o tempo en %1",
  	"music.setTempo": "aplicar un tempo de %1",
  	"pen.clear": "borrar todo",
  	"pen.stamp": "selar",
  	"pen.penDown": "baixar o lapis",
  	"pen.penUp": "subir o lapis",
  	"pen.setColor": "usar un lapis de cor %1",
  	"pen.changeHue": "sumar %1 á cor do lapis",
  	"pen.setColorParam": "pór a %1 do lapis en %2",
  	"pen.changeColorParam": "sumar %2 á %1 do lapis",
  	"pen.setHue": "usar un lapis de cor %1",
  	"pen.changeShade": "sumar %1 a intensidade do lapis",
  	"pen.setShade": "pór a intensidade do lapis a %1",
  	"pen.changeSize": "aumentar o tamaño do lapis en %1",
  	"pen.setSize": "usar un lapis de tamaño %1",
  	EVENT_WHENFLAGCLICKED: "Ao premer en @greenFlag",
  	EVENT_WHENKEYPRESSED: "Ao premer na tecla %1",
  	EVENT_WHENTHISSPRITECLICKED: "Ao premer nesta figura",
  	EVENT_WHENSTAGECLICKED: "Ao premer no escenario",
  	EVENT_WHENBACKDROPSWITCHESTO: "Ao mudar o fondo a %1",
  	EVENT_WHENGREATERTHAN: "Cando %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "Ao recibir %1",
  	EVENT_BROADCAST: "emitir %1",
  	EVENT_BROADCASTANDWAIT: "emitir %1 e agardar",
  	CONTROL_WAIT: "agardar %1 segundos",
  	CONTROL_REPEAT: "repetir %1",
  	CONTROL_FOREVER: "para sempre",
  	CONTROL_IF: "se %1 entón",
  	CONTROL_WAITUNTIL: "agardar até %1",
  	CONTROL_REPEATUNTIL: "repetir até %1",
  	CONTROL_STOP: "parar. %1",
  	CONTROL_STARTASCLONE: "Ao comezar como clon",
  	CONTROL_CREATECLONEOF: "crear un clon de %1",
  	CONTROL_DELETETHISCLONE: "eliminar este clon.",
  	SENSING_ASKANDWAIT: "preguntar %1 e agardar",
  	"videoSensing.videoToggle": "vídeo %1",
  	"videoSensing.setVideoTransparency": "pór a transparencia de vídeo en %1",
  	"videoSensing.whenMotionGreaterThan": "Cando o movemento de vídeo > %1",
  	SENSING_RESETTIMER: "reiniciar o cronómetro",
  	DATA_SETVARIABLETO: "asignar %2 a %1",
  	DATA_CHANGEVARIABLEBY: "sumarlle %2 a %1",
  	DATA_SHOWVARIABLE: "amosar a variábel %1",
  	DATA_HIDEVARIABLE: "agochar a variábel %1",
  	DATA_ADDTOLIST: "engadir %1 a %2",
  	DATA_DELETEOFLIST: "eliminar %1 de %2",
  	DATA_DELETEALLOFLIST: "eliminar todo o contido de %1",
  	MOTION_IFONEDGEBOUNCE: "se toca un bordo, rebotar",
  	DATA_INSERTATLIST: "inserir %1 na posición %2 de %3",
  	DATA_REPLACEITEMOFLIST: "substituír o elemento %1 de %2 por %3",
  	DATA_SHOWLIST: "amosar a lista %1",
  	DATA_HIDELIST: "agochar a lista %1",
  	SENSING_OF_XPOSITION: "posición en X",
  	SENSING_OF_YPOSITION: "posición en Y",
  	SENSING_OF_DIRECTION: "dirección",
  	SENSING_OF_COSTUMENUMBER: "traxe n.º",
  	LOOKS_COSTUMENUMBERNAME: "traxe %1",
  	SENSING_OF_SIZE: "tamaño",
  	SENSING_OF_BACKDROPNAME: "nome do fondo",
  	LOOKS_BACKDROPNUMBERNAME: "fondo %1",
  	SENSING_OF_BACKDROPNUMBER: "fondo n.º",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "toca %1",
  	SENSING_TOUCHINGCOLOR: "toca na cor %1",
  	SENSING_COLORISTOUCHINGCOLOR: "a cor %1 toca %2",
  	SENSING_DISTANCETO: "distancia a %1",
  	SENSING_ANSWER: "resposta",
  	SENSING_KEYPRESSED: "a tecla %1 está premida",
  	SENSING_MOUSEDOWN: "o rato está premido",
  	SENSING_MOUSEX: "posición en X do rato",
  	SENSING_MOUSEY: "posición en Y do rato",
  	SENSING_SETDRAGMODE: "usar o modo de arrastre %1",
  	SENSING_LOUDNESS: "volume no micrófono",
  	"videoSensing.videoOn": "%1 de vídeo a %2",
  	SENSING_TIMER: "cronómetro",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "%1 actual",
  	SENSING_DAYSSINCE2000: "días desde o 2000",
  	SENSING_USERNAME: "nome de usuario",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 – %2",
  	OPERATORS_MULTIPLY: "%1 × %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "número ao chou entre %1 e %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 e %2",
  	OPERATORS_OR: "%1 ou %2",
  	OPERATORS_NOT: "non %1",
  	OPERATORS_JOIN: "concatenar %1 %2",
  	OPERATORS_LETTEROF: "letra %1 de %2",
  	OPERATORS_LENGTH: "lonxitude de %1",
  	OPERATORS_MOD: "%1 módulo %2",
  	OPERATORS_ROUND: "arredondar %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%1 contén %2",
  	DATA_ITEMOFLIST: "elemento %1 de %2",
  	DATA_ITEMNUMOFLIST: "posición de %2 que contén %1",
  	DATA_LENGTHOFLIST: "lonxitude de %1",
  	DATA_LISTCONTAINSITEM: "%1 contén %2",
  	CONTROL_ELSE: "se non",
  	SENSING_USERID: "identificador de usuario",
  	SENSING_LOUD: "forte?",
  	"text2speech.speakAndWaitBlock": "falar %1",
  	"text2speech.setVoiceBlock": "darlle a voz de %1",
  	"text2speech.setLanguageBlock": "usar o idioma %1",
  	"translate.translateBlock": "traducir %1 a %2",
  	"translate.viewerLanguage": "idioma",
  	"makeymakey.whenKeyPressed": "Ao premer a tecla %1",
  	"makeymakey.whenKeysPressedInOrder": "Ao premer en orde %1",
  	"microbit.whenButtonPressed": "Ao premer o botón %1",
  	"microbit.isButtonPressed": "está premido o botón %1",
  	"microbit.whenGesture": "Cando é %1",
  	"microbit.displaySymbol": "mostrar %1",
  	"microbit.displayText": "mostrar o texto %1",
  	"microbit.clearDisplay": "limpar a pantalla",
  	"microbit.whenTilted": "Ao estar inclinado cara %1",
  	"microbit.isTilted": "inclinado cara %1",
  	"microbit.tiltAngle": "ángulo de inclinación cara %1",
  	"microbit.whenPinConnected": "Cando o pin %1 estea conectado",
  	"ev3.motorTurnClockwise": "virar o motor %1 para aquí durante %2 segundos",
  	"ev3.motorTurnCounterClockwise": "virar o motor %1 para alá durante %2 segundos",
  	"ev3.motorSetPower": "pór o motor %1 ao %2% de potencia",
  	"ev3.getMotorPosition": "posición do motor %1",
  	"ev3.whenButtonPressed": "Ao premer o botón %1",
  	"ev3.whenDistanceLessThan": "Cando a distancia < %1",
  	"ev3.whenBrightnessLessThan": "Cando o brillo < %1",
  	"ev3.buttonPressed": "está premido o botón %1",
  	"ev3.getDistance": "distancia",
  	"ev3.getBrightness": "luminosidade",
  	"ev3.beepNote": "tocar a nota %1 durante %2 segundos",
  	"wedo2.motorOn": "acender %1",
  	"wedo2.motorOff": "apagar %1",
  	"wedo2.startMotorPower": "pór a potencia de %1 a %2",
  	"wedo2.setMotorDirection": "trocar a dirección de %1 por %2",
  	"wedo2.whenDistance": "Cando a distancia %1 %2",
  	"wedo2.getDistance": "distancia",
  	"wedo2.motorOnFor": "acender %1 durante %2 segundos",
  	"wedo2.setLightHue": "pór a cor da luz a %1",
  	"wedo2.playNoteFor": "tocar a nota %1 durante %2 segundos",
  	"wedo2.whenTilted": "Cando estea inclinado cara %1",
  	"wedo2.isTilted": "inclinado á %1",
  	"wedo2.getTiltAngle": "ángulo de inclinación %1",
  	"gdxfor.whenGesture": "Cando é %1",
  	"gdxfor.whenForcePushedOrPulled": "Cando o sensor de forza %1",
  	"gdxfor.getForce": "a forza",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "está a caer?",
  	"gdxfor.getSpin": "a velocidade angular %1",
  	"gdxfor.getAcceleration": "a aceleración %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "Ao ver un bloque %1",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "Cando estea inclinado cara %1",
  	"boost.getTiltAngle": "ángulo de inclinación %1",
  	"boost.setLightHue": "pór a cor da luz a %1"
  };
  var dropdowns$M = {
  };
  var ignorelt$M = [
  ];
  var soundEffects$M = [
  	"ton",
  	"canle esquerda/dereita"
  ];
  var microbitWhen$M = [
  	"movido",
  	"abalado",
  	"saltado"
  ];
  var osis$M = [
  	"outros programas na figura"
  ];
  var definePrefix$M = [
  	"definir"
  ];
  var defineSuffix$M = [
  ];
  var palette$M = {
  	Motion: "Movemento",
  	Looks: "Aparencia",
  	Sound: "Son",
  	Events: "Eventos",
  	Control: "Control",
  	Sensing: "Sensores",
  	Operators: "Operadores",
  	Variables: "Variábeis",
  	"My Blocks": "Os meus bloques"
  };
  var math$M = [
  	"valor absoluto",
  	"chan",
  	"teito",
  	"raíz cadrada",
  	"seno",
  	"coseno",
  	"tanxente",
  	"arco seno",
  	"arco coseno",
  	"arco tanxente",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$M = {
  };
  var name$M = "Galego";
  var percentTranslated$M = 100;
  var gl = {
  	commands: commands$M,
  	dropdowns: dropdowns$M,
  	ignorelt: ignorelt$M,
  	soundEffects: soundEffects$M,
  	microbitWhen: microbitWhen$M,
  	osis: osis$M,
  	definePrefix: definePrefix$M,
  	defineSuffix: defineSuffix$M,
  	palette: palette$M,
  	math: math$M,
  	aliases: aliases$M,
  	name: name$M,
  	percentTranslated: percentTranslated$M
  };

  var commands$L = {
  	MOTION_MOVESTEPS: "matsa matakai %1",
  	MOTION_TURNRIGHT: "juya digiri @turnRight %1",
  	MOTION_TURNLEFT: "juya digiri @turnLeft %1",
  	MOTION_POINTINDIRECTION: "nuna mafuskantar %1",
  	MOTION_POINTTOWARDS: "yi nuni zuwa %1",
  	MOTION_GOTOXY: "je zuwa x:%1 y:%2",
  	MOTION_GOTO: "je zuwa %1",
  	MOTION_GLIDESECSTOXY: "matsa daƙiƙai %1 zuwa x: %2 y: %3",
  	MOTION_GLIDETO: "matsa daƙiƙai %1 zuwa %2",
  	MOTION_CHANGEXBY: "canza x da %1",
  	MOTION_SETX: "saita x zuwa %1",
  	MOTION_CHANGEYBY: "canza y da %1",
  	MOTION_SETY: "saita y zuwa %1",
  	MOTION_SETROTATIONSTYLE: "saita salon juyawa %1",
  	LOOKS_SAYFORSECS: "ce %1 sau daƙiƙai %2",
  	LOOKS_SAY: "ce %1",
  	LOOKS_THINKFORSECS: "yi tunanin %1 sau daƙiƙai %2",
  	LOOKS_THINK: "yi tunanin %1",
  	LOOKS_SHOW: "nuna",
  	LOOKS_HIDE: "ɓoye",
  	LOOKS_SWITCHCOSTUMETO: "sauya fasalin zuwa %1",
  	LOOKS_NEXTCOSTUME: "fasali na gaba",
  	LOOKS_NEXTBACKDROP_BLOCK: "hoton fage na gaba",
  	LOOKS_SWITCHBACKDROPTO: "sauya hoton fage zuwa %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "sauya hoton fage zuwa %1 kuma a jira",
  	LOOKS_CHANGEEFFECTBY: "canza tsarin %1 zuwa %2",
  	LOOKS_SETEFFECTTO: "saita tsarin %1 zuwa %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "share tsarin zanen",
  	LOOKS_CHANGESIZEBY: "canza girman da %1",
  	LOOKS_SETSIZETO: "saita girman zuwa %1 %",
  	LOOKS_GOTOFRONTBACK: "je zuwa shimfiɗar %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "je zuwa shimfiɗun %1 %2",
  	SOUND_PLAY: "kunna sautin %1",
  	SOUND_CHANGEEFFECTBY: "canza tsarin %1 da %2",
  	SOUND_SETEFFECTO: "saita tsarin %1 zuwa %2",
  	SOUND_CLEAREFFECTS: "share tsarin sauti",
  	SOUND_PLAYUNTILDONE: "kunna sautin %1 har sai angama",
  	SOUND_STOPALLSOUNDS: "dakatar da duka sauti",
  	"music.playDrumForBeats": "buga gangar %1 na bugun %2",
  	"music.restForBeats": "huta na bugun %1",
  	"music.playNoteForBeats": "buga rubutun %1 na bugun %2",
  	"music.setInstrument": "saita kayan aikin zuwa %1",
  	SOUND_CHANGEVOLUMEBY: "canza ƙarfin sauti da %1",
  	SOUND_SETVOLUMETO: "saita ƙarfin sauti zuwa %1%",
  	"music.changeTempo": "canza saurin da %1",
  	"music.setTempo": "saita saurin zuwa %1",
  	"pen.clear": "share duka",
  	"pen.stamp": "tambari",
  	"pen.penDown": "alkalamin kasa",
  	"pen.penUp": "alkalamin sama",
  	"pen.setColor": "saita launin alƙalamin zuwa %1",
  	"pen.changeHue": "canja launin alkalami da %1",
  	"pen.setColorParam": "saita alkalamin %1 zuwa %2",
  	"pen.changeColorParam": "canja alƙalami %1 da %2",
  	"pen.setHue": "saita launin alkalami zuwa %1",
  	"pen.changeShade": "canja launin zanen alkalami da %1",
  	"pen.setShade": "saita yanayin launin alkalami zuwa %1",
  	"pen.changeSize": "canja girman alkalamin da %1",
  	"pen.setSize": "saita girman alkalami zuwa %1",
  	EVENT_WHENFLAGCLICKED: "lokacin da aka danna @greenFlag",
  	EVENT_WHENKEYPRESSED: "lokacin da aka danna madannin %1",
  	EVENT_WHENTHISSPRITECLICKED: "lokacin da aka danna wannan sprite ɗin",
  	EVENT_WHENSTAGECLICKED: "lokacin da aka danna mataki",
  	EVENT_WHENBACKDROPSWITCHESTO: "lokacin da hoton fage ya koma zuwa %1",
  	EVENT_WHENGREATERTHAN: "lokacin da %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "lokacin da na karɓi %1",
  	EVENT_BROADCAST: "yaɗa %1",
  	EVENT_BROADCASTANDWAIT: "yaɗa %1 kuma a jira",
  	CONTROL_WAIT: "jira daƙiƙai %1",
  	CONTROL_REPEAT: "maimaita %1",
  	CONTROL_FOREVER: "har abada",
  	CONTROL_IF: "idan %1 sai",
  	CONTROL_WAITUNTIL: "jira har %1",
  	CONTROL_REPEATUNTIL: "maimaita har zuwa %1",
  	CONTROL_STOP: "tsaya %1",
  	CONTROL_STARTASCLONE: "lokacin da na fara a matsayin kwaikwayo",
  	CONTROL_CREATECLONEOF: "ƙirƙiri kwaikwayon %1",
  	CONTROL_DELETETHISCLONE: "goge wannan kwaikwayon",
  	SENSING_ASKANDWAIT: "tambayi %1 kuma a jira",
  	"videoSensing.videoToggle": "juya bidiyon %1",
  	"videoSensing.setVideoTransparency": "Saita ganin bayyanar bidiyon zuwa %1",
  	"videoSensing.whenMotionGreaterThan": "a lokacin da motsin bidiyon > %1",
  	SENSING_RESETTIMER: "sake saita mai ƙidayar lokaci",
  	DATA_SETVARIABLETO: "saita %1 zuwa %2",
  	DATA_CHANGEVARIABLEBY: "canza %1 a madadin %2",
  	DATA_SHOWVARIABLE: "nuna abu mai canzawa na %1",
  	DATA_HIDEVARIABLE: "ɓoye abu mai canzawa na %1",
  	DATA_ADDTOLIST: "ƙara %1 zuwa %2",
  	DATA_DELETEOFLIST: "goge %1 na %2",
  	DATA_DELETEALLOFLIST: "cire dukkan %1",
  	MOTION_IFONEDGEBOUNCE: "idan a baki, yi tsalle mai maimaituwa",
  	DATA_INSERTATLIST: "saka %1 a cikin %2 na %3",
  	DATA_REPLACEITEMOFLIST: "mayar da abun %1 na %2 da %3",
  	DATA_SHOWLIST: "nuna jerin %1",
  	DATA_HIDELIST: "ɓoye jerin %1",
  	SENSING_OF_XPOSITION: "matsayin x",
  	SENSING_OF_YPOSITION: "matsayin y",
  	SENSING_OF_DIRECTION: "mafuskanta",
  	SENSING_OF_COSTUMENUMBER: "fasali #",
  	LOOKS_COSTUMENUMBERNAME: "fasalin %1",
  	SENSING_OF_SIZE: "girma",
  	SENSING_OF_BACKDROPNAME: "sunan hoton fage",
  	LOOKS_BACKDROPNUMBERNAME: "hoton fagen %1",
  	SENSING_OF_BACKDROPNUMBER: "hoton fage",
  	SOUND_VOLUME: "ƙarfin sauti",
  	"music.getTempo": "sauri",
  	SENSING_TOUCHINGOBJECT: "taɓawar %1?",
  	SENSING_TOUCHINGCOLOR: "taɓawar launin %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "launin %1 yana taɓa %2?",
  	SENSING_DISTANCETO: "nisa zuwa %1",
  	SENSING_ANSWER: "amsa",
  	SENSING_KEYPRESSED: "madannin %1 a danne?",
  	SENSING_MOUSEDOWN: "linzamin kwamfuta ya yi ƙasa?",
  	SENSING_MOUSEX: "linzamin kwamfuta x",
  	SENSING_MOUSEY: "linzamin kwamfuta y",
  	SENSING_SETDRAGMODE: "saita yanayin ja %1",
  	SENSING_LOUDNESS: "ƙara",
  	"videoSensing.videoOn": "bidiyon %1 akan %2",
  	SENSING_TIMER: "mai ƙidayar lokaci",
  	SENSING_OF: "%1 cikin %2",
  	SENSING_CURRENT: "yanzu %1",
  	SENSING_DAYSSINCE2000: "kwanaki tun 2000",
  	SENSING_USERNAME: "sunnan mai amfani",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "zaɓa a hargitse %1 zuwa %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 da %2",
  	OPERATORS_OR: "%1 ko %2",
  	OPERATORS_NOT: "ba %1 ba",
  	OPERATORS_JOIN: "haɗa %1 %2",
  	OPERATORS_LETTEROF: "harafin %1 na %2",
  	OPERATORS_LENGTH: "tsayin %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "zagaye %1",
  	OPERATORS_MATHOP: "%1 na %2",
  	OPERATORS_CONTAINS: "%1 ya ƙunshi %2?",
  	DATA_ITEMOFLIST: "abun %1 na %2",
  	DATA_ITEMNUMOFLIST: "abun # na %1 cikin %2",
  	DATA_LENGTHOFLIST: "tsawon %1",
  	DATA_LISTCONTAINSITEM: "%1 ya ƙunshi %2?",
  	CONTROL_ELSE: "ko kuma",
  	SENSING_USERID: "shaidar mai amfani",
  	SENSING_LOUD: "da ƙara?",
  	"text2speech.speakAndWaitBlock": "yi magana%1",
  	"text2speech.setVoiceBlock": "saita murya zuwa %1",
  	"text2speech.setLanguageBlock": "saita yare zuwa %1",
  	"translate.translateBlock": "fassara %1 zuwa %2",
  	"translate.viewerLanguage": "yare",
  	"makeymakey.whenKeyPressed": "a lokacin da aka danna madannin %1",
  	"makeymakey.whenKeysPressedInOrder": "a lokacin da aka danna %1 a tsari",
  	"microbit.whenButtonPressed": "a lokacin da aka danna madannin %1",
  	"microbit.isButtonPressed": "an danna madannin %1 ?",
  	"microbit.whenGesture": "a lokacin da %1",
  	"microbit.displaySymbol": "nuna %1",
  	"microbit.displayText": "nuna rubutun %1",
  	"microbit.clearDisplay": "share nunawa",
  	"microbit.whenTilted": "a lokacin da aka karkata %1",
  	"microbit.isTilted": "an karkata %1?",
  	"microbit.tiltAngle": "karkata kwanar %1",
  	"microbit.whenPinConnected": "a lokacin da mabudin sirri %1 ya sadu",
  	"ev3.motorTurnClockwise": "motar %1 juya wannan hanyar na daƙiƙoƙi %2",
  	"ev3.motorTurnCounterClockwise": "motar %1 juya waccan hanyar na daƙiƙoƙi %2",
  	"ev3.motorSetPower": "motar %1 saita ƙarfi %2 %",
  	"ev3.getMotorPosition": "matsayin motar %1",
  	"ev3.whenButtonPressed": "a lokacin da aka danna madannin %1",
  	"ev3.whenDistanceLessThan": "a lokacin da nisa < %1",
  	"ev3.whenBrightnessLessThan": "a lokacin da haske < %1",
  	"ev3.buttonPressed": "an danna madannin %1 ?",
  	"ev3.getDistance": "nisa",
  	"ev3.getBrightness": "haske",
  	"ev3.beepNote": "yi ƙaran bif ɗin  %1 na daƙiƙa %2",
  	"wedo2.motorOn": "kunna %1",
  	"wedo2.motorOff": "kashe %1",
  	"wedo2.startMotorPower": "saita ƙarfin %1 zuwa %2",
  	"wedo2.setMotorDirection": "saita mafuskantar %1 zuwa %2",
  	"wedo2.whenDistance": "a lokacin nisan %1 %2",
  	"wedo2.getDistance": "nisa",
  	"wedo2.motorOnFor": "kunna %1 na daƙiƙoƙi %2",
  	"wedo2.setLightHue": "saita launin haske zuwa %1",
  	"wedo2.playNoteFor": "kunna sautin %1 na daƙiƙoƙi %2",
  	"wedo2.whenTilted": "a lokacin da aka karkata %1",
  	"wedo2.isTilted": "an karkata %1?",
  	"wedo2.getTiltAngle": "karkata kwanan %1",
  	"gdxfor.whenGesture": "a lokacin da %1",
  	"gdxfor.whenForcePushedOrPulled": "a lokacin da na'urar gano ƙarfi a %1",
  	"gdxfor.getForce": "ƙarfi",
  	"gdxfor.whenTilted": "a lokacin da aka karkata %1",
  	"gdxfor.isTilted": "an karkata %1",
  	"gdxfor.getTilt": "karkata kwanar %1",
  	"gdxfor.isFreeFalling": "faɗuwa?",
  	"gdxfor.getSpin": "gudun juyawa %1",
  	"gdxfor.getAcceleration": "sauri %1",
  	"boost.motorOnFor": "juya motar %1 na daƙiƙoƙi %2",
  	"boost.motorOnForRotation": "juya motar %1 na juyawa %2",
  	"boost.motorOn": "kunna motar %1",
  	"boost.motorOff": "kashe motar %1",
  	"boost.setMotorPower": "saita gudun motar %1 zuwa %2 %",
  	"boost.setMotorDirection": "saita motar %1 mafuskantar %2",
  	"boost.getMotorPosition": "matsayin moto %1",
  	"boost.whenColor": "a lokacin da aka ga tubalin %1",
  	"boost.seeingColor": "ganin tubalin %1 ?",
  	"boost.whenTilted": "a lokacin da aka karkata %1",
  	"boost.getTiltAngle": "karkata kwanar %1",
  	"boost.setLightHue": "saita launin haske zuwa %1"
  };
  var dropdowns$L = {
  };
  var ignorelt$L = [
  ];
  var soundEffects$L = [
  	"tsarin sauti",
  	"fitar da sauti a hagu/dama"
  ];
  var microbitWhen$L = [
  	"an motsa",
  	"an girgiza",
  	"anyi tsalle"
  ];
  var osis$L = [
  	"sauran rubutun cikin sprite"
  ];
  var definePrefix$L = [
  	"ayyana"
  ];
  var defineSuffix$L = [
  ];
  var palette$L = {
  	Motion: "motsi",
  	Looks: "yanayin bayyana",
  	Sound: "sauti",
  	Events: "yanayin faruwar abubuwa",
  	Control: "sarrafawa",
  	Sensing: "ganowa",
  	Operators: "ma'alaƙanta",
  	Variables: "abubuwa masu canzawa",
  	"My Blocks": "tubalai na"
  };
  var math$L = [
  	"abs",
  	"ƙasa",
  	"rufi",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"In",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$L = {
  };
  var name$L = "Hausa";
  var percentTranslated$L = 100;
  var ha = {
  	commands: commands$L,
  	dropdowns: dropdowns$L,
  	ignorelt: ignorelt$L,
  	soundEffects: soundEffects$L,
  	microbitWhen: microbitWhen$L,
  	osis: osis$L,
  	definePrefix: definePrefix$L,
  	defineSuffix: defineSuffix$L,
  	palette: palette$L,
  	math: math$L,
  	aliases: aliases$L,
  	name: name$L,
  	percentTranslated: percentTranslated$L
  };

  var commands$K = {
  	MOTION_MOVESTEPS: "זוז %1 צעדים",
  	MOTION_TURNRIGHT: "הסתובב @turnRight %1 מעלות",
  	MOTION_TURNLEFT: "הסתובב @turnLeft %1 מעלות",
  	MOTION_POINTINDIRECTION: "פנה לכיוון %1",
  	MOTION_POINTTOWARDS: "פנה לכיוון של %1",
  	MOTION_GOTOXY: "קפוץ אל x: %1 y: %2",
  	MOTION_GOTO: "קפוץ אל %1",
  	MOTION_GLIDESECSTOXY: "גלוש %1 שניות אל x: %2 y: %3",
  	MOTION_GLIDETO: "גלוש %1 שניות אל %2",
  	MOTION_CHANGEXBY: "שנה את ערך x ב %1",
  	MOTION_SETX: "קבע את ערך x ל %1",
  	MOTION_CHANGEYBY: "שנה את ערך y ב %1",
  	MOTION_SETY: "קבע את ערך y ל %1",
  	MOTION_SETROTATIONSTYLE: "קבע אופן סיבוב %1",
  	LOOKS_SAYFORSECS: "אמור %1 למשך %2 שניות",
  	LOOKS_SAY: "אמור %1",
  	LOOKS_THINKFORSECS: "חשוב %1 למשך %2 שניות",
  	LOOKS_THINK: "חשוב %1",
  	LOOKS_SHOW: "הצג",
  	LOOKS_HIDE: "הסתר",
  	LOOKS_SWITCHCOSTUMETO: "קבע תלבושת ל %1",
  	LOOKS_NEXTCOSTUME: "התלבושת הבאה",
  	LOOKS_NEXTBACKDROP_BLOCK: "הרקע הבא",
  	LOOKS_SWITCHBACKDROPTO: "קבע רקע ל %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "החלף רקע ל %1 וחכה",
  	LOOKS_CHANGEEFFECTBY: "שנה אפקט %1 ב %2",
  	LOOKS_SETEFFECTTO: "קבע אפקט %1 ל %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "נקה אפקטים",
  	LOOKS_CHANGESIZEBY: "שנה גודל ב %1",
  	LOOKS_SETSIZETO: "קבע גודל ל %1 %",
  	LOOKS_GOTOFRONTBACK: "העבר לשכבה ה %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "העבר %2 שכבות %1",
  	SOUND_PLAY: "נגן צליל %1",
  	SOUND_CHANGEEFFECTBY: "שנה אפקט %1 ב %2",
  	SOUND_SETEFFECTO: "קבע אפקט %1 ל %2",
  	SOUND_CLEAREFFECTS: "נקה אפקטים קוליים",
  	SOUND_PLAYUNTILDONE: "נגן צליל %1 עד לסיום",
  	SOUND_STOPALLSOUNDS: "הפסק את כל הצלילים",
  	"music.playDrumForBeats": "נגן בתוף %1 למשך %2 פעימות",
  	"music.restForBeats": "נוח למשך %1 פעימות",
  	"music.playNoteForBeats": "נגן תו %1 במשך %2 פעימות",
  	"music.setInstrument": "קבע כלי נגינה ל %1",
  	SOUND_CHANGEVOLUMEBY: "שנה עוצמת קול ב %1",
  	SOUND_SETVOLUMETO: "קבע עוצמת קול ל %1%",
  	"music.changeTempo": "שנה קצב ב %1",
  	"music.setTempo": "קבע קצב ל %1",
  	"pen.clear": "מחק הכול",
  	"pen.stamp": "חתום",
  	"pen.penDown": "עט מטה",
  	"pen.penUp": "עט מעלה",
  	"pen.setColor": "קבע צבע עט ל%1",
  	"pen.changeHue": "שנה צבע עט ב%1",
  	"pen.setColorParam": "קבע %1 עט ל%2",
  	"pen.changeColorParam": "שנה %1 עט ב%2",
  	"pen.setHue": "קבע צבע עט ל%1",
  	"pen.changeShade": "שנה הצללת עט ב%1",
  	"pen.setShade": "קבע הצללת עט ל%1",
  	"pen.changeSize": "שנה גודל עט ב%1",
  	"pen.setSize": "קבע גודל עט ל%1",
  	EVENT_WHENFLAGCLICKED: "כאשר לוחצים על @greenFlag",
  	EVENT_WHENKEYPRESSED: "כאשר נלחץ מקש %1",
  	EVENT_WHENTHISSPRITECLICKED: "כאשר לוחצים על דמות זו",
  	EVENT_WHENSTAGECLICKED: "כאשר לוחצים על הבמה",
  	EVENT_WHENBACKDROPSWITCHESTO: "כאשר הרקע משתנה ל %1",
  	EVENT_WHENGREATERTHAN: "כאשר %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "כאשר מתקבל מסר %1",
  	EVENT_BROADCAST: "שדר מסר %1",
  	EVENT_BROADCASTANDWAIT: "שדר מסר %1 וחכה",
  	CONTROL_WAIT: "חכה %1 שניות",
  	CONTROL_REPEAT: "חזור  %1 פעמים",
  	CONTROL_FOREVER: "לעולמים",
  	CONTROL_IF: "אם %1 אז",
  	CONTROL_WAITUNTIL: "חכה עד ש %1",
  	CONTROL_REPEATUNTIL: "חזור עד ש %1",
  	CONTROL_STOP: "עצור %1",
  	CONTROL_STARTASCLONE: "כאשר מופעל ככפיל",
  	CONTROL_CREATECLONEOF: "יצירת כפיל של %1",
  	CONTROL_DELETETHISCLONE: "מחק כפיל זה",
  	SENSING_ASKANDWAIT: "שאל %1 והמתן",
  	"videoSensing.videoToggle": "%1 את המצלמה",
  	"videoSensing.setVideoTransparency": "קבע שקיפות מצלמה ל %1",
  	"videoSensing.whenMotionGreaterThan": "כאשר התנועה במצלמה > %1",
  	SENSING_RESETTIMER: "אפס מונה",
  	DATA_SETVARIABLETO: "קבע %1 ל %2",
  	DATA_CHANGEVARIABLEBY: "שנה %1 ב %2",
  	DATA_SHOWVARIABLE: "הצג משתנה %1",
  	DATA_HIDEVARIABLE: "הסתר משתנה %1",
  	DATA_ADDTOLIST: "הוסף %1 ל %2",
  	DATA_DELETEOFLIST: "מחק פריט %1 מתוך %2",
  	DATA_DELETEALLOFLIST: "מחק הכול מ%1",
  	MOTION_IFONEDGEBOUNCE: "בנגיעה במסגרת שנה כיוון",
  	DATA_INSERTATLIST: "הכנס %1 במקום %2 של %3",
  	DATA_REPLACEITEMOFLIST: "קבע פריט %1 של %2 ל %3",
  	DATA_SHOWLIST: "הצג רשימה %1",
  	DATA_HIDELIST: "הסתר רשימה %1",
  	SENSING_OF_XPOSITION: "מיקום על ציר x",
  	SENSING_OF_YPOSITION: "מיקום על ציר y",
  	SENSING_OF_DIRECTION: "כיוון",
  	SENSING_OF_COSTUMENUMBER: "מספר תלבושת",
  	LOOKS_COSTUMENUMBERNAME: "%1 תלבושת",
  	SENSING_OF_SIZE: "גודל",
  	SENSING_OF_BACKDROPNAME: "שם רקע",
  	LOOKS_BACKDROPNUMBERNAME: "%1 רקע",
  	SENSING_OF_BACKDROPNUMBER: "מספר רקע",
  	SOUND_VOLUME: "עוצמת קול",
  	"music.getTempo": "קצב",
  	SENSING_TOUCHINGOBJECT: "נוגע ב %1?",
  	SENSING_TOUCHINGCOLOR: "נוגע בצבע  %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "צבע %1 נוגע בצבע %2?",
  	SENSING_DISTANCETO: "מרחק אל %1",
  	SENSING_ANSWER: "תשובה",
  	SENSING_KEYPRESSED: "מקש %1 נלחץ?",
  	SENSING_MOUSEDOWN: "עכבר נלחץ?",
  	SENSING_MOUSEX: "מיקום עכבר בציר x",
  	SENSING_MOUSEY: "מיקום עכבר בציר y",
  	SENSING_SETDRAGMODE: "קבע מצב גרירה ל %1",
  	SENSING_LOUDNESS: "עוצמת קול",
  	"videoSensing.videoOn": "%1 של המצלמה על %2",
  	SENSING_TIMER: "שעון עצר",
  	SENSING_OF: "%1 של %2",
  	SENSING_CURRENT: "%1 נוכחית",
  	SENSING_DAYSSINCE2000: "ימים מאז 2000",
  	SENSING_USERNAME: "שם משתמש",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%2 - %1",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%2 / %1",
  	OPERATORS_RANDOM: "בחר מספר אקראי בין %1 ל %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 וגם %2",
  	OPERATORS_OR: "%1 או %2",
  	OPERATORS_NOT: "לא %1",
  	OPERATORS_JOIN: "חבר %1 %2",
  	OPERATORS_LETTEROF: "אות %1 של %2",
  	OPERATORS_LENGTH: "האורך של %1",
  	OPERATORS_MOD: "%1 מודולו %2",
  	OPERATORS_ROUND: "עגל %1",
  	OPERATORS_MATHOP: "%1 של %2",
  	OPERATORS_CONTAINS: "%1 מכיל %2?",
  	DATA_ITEMOFLIST: "פריט %1 של %2",
  	DATA_ITEMNUMOFLIST: "מספר פריט של %1 ב- %2",
  	DATA_LENGTHOFLIST: "האורך של %1",
  	DATA_LISTCONTAINSITEM: "%1 מכיל %2?",
  	CONTROL_ELSE: "אחרת",
  	SENSING_USERID: "זהות המשתמש",
  	SENSING_LOUD: "עוצמת קול?",
  	"text2speech.speakAndWaitBlock": "הקרא %1",
  	"text2speech.setVoiceBlock": "קבע קול ל %1",
  	"text2speech.setLanguageBlock": "קבע שפה ל%1",
  	"translate.translateBlock": "תרגם%1 ל%2",
  	"translate.viewerLanguage": "שפה",
  	"makeymakey.whenKeyPressed": "כאשר לוחצים על מקש %1",
  	"makeymakey.whenKeysPressedInOrder": "כאשר מקישים את הרצף %1",
  	"microbit.whenButtonPressed": "כאשר לוחצים על כפתור %1",
  	"microbit.isButtonPressed": "לחצו על כפתור %1‏ ?",
  	"microbit.whenGesture": "כאשר %1",
  	"microbit.displaySymbol": "הצג %1",
  	"microbit.displayText": "הצגת טקסט %1",
  	"microbit.clearDisplay": "נקה תצוגה",
  	"microbit.whenTilted": "כאשר מוטה %1",
  	"microbit.isTilted": "נוטה%1?",
  	"microbit.tiltAngle": "זווית הטיה %1",
  	"microbit.whenPinConnected": "כאשר פין %1 מחובר",
  	"ev3.motorTurnClockwise": "סובב את מנוע%1 בכיוון זה במשך %2 שניות",
  	"ev3.motorTurnCounterClockwise": "סובב את מנוע %1 בכיוון ההוא במשך %2 שניות",
  	"ev3.motorSetPower": "קבע מנוע%1 להספק של %2 %",
  	"ev3.getMotorPosition": "מצב מנוע ב%1",
  	"ev3.whenButtonPressed": "כאשר לוחצים על כפתור %1",
  	"ev3.whenDistanceLessThan": "כאשר מרחק < %1",
  	"ev3.whenBrightnessLessThan": "כאשר בהירות <%1",
  	"ev3.buttonPressed": "כפתור %1 נלחץ?",
  	"ev3.getDistance": "מרחק",
  	"ev3.getBrightness": "בהירות",
  	"ev3.beepNote": "צפצף תו %1ל%2שניות",
  	"wedo2.motorOn": "הדלקת %1",
  	"wedo2.motorOff": "כיבוי %1",
  	"wedo2.startMotorPower": "קבע הספק של%1 ל %2",
  	"wedo2.setMotorDirection": "קבע כיוון%1 ל %2",
  	"wedo2.whenDistance": "כאשר מרחק %1 %2",
  	"wedo2.getDistance": "מרחק",
  	"wedo2.motorOnFor": "הדלקת%1 למשך %2 שניות",
  	"wedo2.setLightHue": "קבע צבע אור ל %1",
  	"wedo2.playNoteFor": "ניגון תו %1 למשך %2 שניות",
  	"wedo2.whenTilted": "כאשר מוטה %1",
  	"wedo2.isTilted": "מוטה%1?",
  	"wedo2.getTiltAngle": "זווית הטיה %1",
  	"gdxfor.whenGesture": "כאשר %1",
  	"gdxfor.whenForcePushedOrPulled": "כאשר חיישן הכוח %1",
  	"gdxfor.getForce": "כוח",
  	"gdxfor.whenTilted": "כאשר מוטה %1",
  	"gdxfor.isTilted": "מוטה %1",
  	"gdxfor.getTilt": "זווית הטיה %1",
  	"gdxfor.isFreeFalling": "נופל?",
  	"gdxfor.getSpin": "מהירות סיבוב %1",
  	"gdxfor.getAcceleration": "תאוצה %1",
  	"boost.motorOnFor": "הדלקת %1 למשך %2 שניות",
  	"boost.motorOnForRotation": "הדלק מנוע %1 למשך %2 סיבובים",
  	"boost.motorOn": "הדלק את מנוע %1",
  	"boost.motorOff": "כבה את מנוע %1",
  	"boost.setMotorPower": "קבע מהירות של %1 ל%2 %",
  	"boost.setMotorDirection": "קבע כיוון %1 ל%2",
  	"boost.getMotorPosition": "מיקום מנוע %1",
  	"boost.whenColor": "כאשר רואים לבנה בצבע %1",
  	"boost.seeingColor": "רואים לבנה בצבע %1?",
  	"boost.whenTilted": "כאשר מוטה %1",
  	"boost.getTiltAngle": "זווית הטיה %1",
  	"boost.setLightHue": "קבע צבע אור ל %1"
  };
  var dropdowns$K = {
  };
  var ignorelt$K = [
  ];
  var soundEffects$K = [
  	"גובה צליל",
  	"ערוץ שמע שמאלי/ימני"
  ];
  var microbitWhen$K = [
  	"זז",
  	"רעד",
  	"קפץ"
  ];
  var osis$K = [
  	"תסריטים אחרים בדמות"
  ];
  var definePrefix$K = [
  	"הגדר"
  ];
  var defineSuffix$K = [
  ];
  var palette$K = {
  	Motion: "תנועה",
  	Looks: "מראה",
  	Sound: "צלילים",
  	Events: "אירועים",
  	Control: "בקרה",
  	Sensing: "חיישנים",
  	Operators: "מפעילים",
  	Variables: "משתנים",
  	"My Blocks": "הלבנים שלי"
  };
  var math$K = [
  	"ערך מוחלט",
  	"עיגול למטה",
  	"עיגול למעלה",
  	"שורש ריבועי",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"‏e בחזקה",
  	"‏10 בחזקה"
  ];
  var aliases$K = {
  	"הסתובב שמאל %1 מעלות": "MOTION_TURNLEFT",
  	"הסתובב ימינה %1 מעלות": "MOTION_TURNRIGHT",
  	"כאשר לוחצים על דגל ירוק": "EVENT_WHENFLAGCLICKED",
  	"סוף": "scratchblocks:end"
  };
  var name$K = "עִבְרִית";
  var percentTranslated$K = 100;
  var he = {
  	commands: commands$K,
  	dropdowns: dropdowns$K,
  	ignorelt: ignorelt$K,
  	soundEffects: soundEffects$K,
  	microbitWhen: microbitWhen$K,
  	osis: osis$K,
  	definePrefix: definePrefix$K,
  	defineSuffix: defineSuffix$K,
  	palette: palette$K,
  	math: math$K,
  	aliases: aliases$K,
  	name: name$K,
  	percentTranslated: percentTranslated$K
  };

  var commands$J = {
  	MOTION_MOVESTEPS: "idi %1 koraka",
  	MOTION_TURNRIGHT: "skreni @turnRight %1 stupnjeva",
  	MOTION_TURNLEFT: "skreni @turnLeft %1 stupnjeva",
  	MOTION_POINTINDIRECTION: "okreni se u smjeru %1",
  	MOTION_POINTTOWARDS: "okreni se prema %1",
  	MOTION_GOTOXY: "idi na x: %1 y: %2",
  	MOTION_GOTO: "idi do %1",
  	MOTION_GLIDESECSTOXY: "klizi %1 sekundi do x: %2 y: %3",
  	MOTION_GLIDETO: "klizi %1 sekundi do %2",
  	MOTION_CHANGEXBY: "promijeni x za %1",
  	MOTION_SETX: "postavi x na %1",
  	MOTION_CHANGEYBY: "promijeni y za %1",
  	MOTION_SETY: "postavi y na %1",
  	MOTION_SETROTATIONSTYLE: "postavi stil rotacije %1",
  	LOOKS_SAYFORSECS: "govori %1 %2 sekundi",
  	LOOKS_SAY: "reci %1",
  	LOOKS_THINKFORSECS: "razmišljaj %1 %2 sekundi",
  	LOOKS_THINK: "misli %1",
  	LOOKS_SHOW: "prikaži",
  	LOOKS_HIDE: "sakrij",
  	LOOKS_SWITCHCOSTUMETO: "promijeni kostim u %1",
  	LOOKS_NEXTCOSTUME: "sljedeći kostim",
  	LOOKS_NEXTBACKDROP_BLOCK: "sljedeća pozadina",
  	LOOKS_SWITCHBACKDROPTO: "promijeni pozadinu na %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "promijeni pozadinu u %1 i čekaj",
  	LOOKS_CHANGEEFFECTBY: "promijeni efekt %1 za %2",
  	LOOKS_SETEFFECTTO: "promijeni efekt %1 na %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "ukloni grafičke efekte",
  	LOOKS_CHANGESIZEBY: "promijeni veličinu za %1",
  	LOOKS_SETSIZETO: "postavi veličinu na %1 %",
  	LOOKS_GOTOFRONTBACK: "idi na sloj %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "idi %1 %2 sloja",
  	SOUND_PLAY: "sviraj zvuk %1",
  	SOUND_CHANGEEFFECTBY: "promijeni efekt %1 za %2",
  	SOUND_SETEFFECTO: "promijeni efekt %1 na %2",
  	SOUND_CLEAREFFECTS: "očisti sve efekte zvuka",
  	SOUND_PLAYUNTILDONE: "sviraj zvuk %1 do kraja",
  	SOUND_STOPALLSOUNDS: "zaustavi sve zvukove",
  	"music.playDrumForBeats": "bubnjaj %1 %2 puta",
  	"music.restForBeats": "preskoči %1 puta",
  	"music.playNoteForBeats": "sviraj ton %1 %2 puta",
  	"music.setInstrument": "postavi instrument na %1",
  	SOUND_CHANGEVOLUMEBY: "promijeni glasnoću za %1",
  	SOUND_SETVOLUMETO: "postavi glasnoću na %1%",
  	"music.changeTempo": "promijeni tempo za %1",
  	"music.setTempo": "postavi tempo na %1",
  	"pen.clear": "izbriši sve",
  	"pen.stamp": "žig",
  	"pen.penDown": "spusti olovku",
  	"pen.penUp": "podigni olovku",
  	"pen.setColor": "postavi boju olovke na %1",
  	"pen.changeHue": "promijeni boju olovke za %1",
  	"pen.setColorParam": "postavi %1 olovke na %2",
  	"pen.changeColorParam": "promijeni %1 olovke za %2",
  	"pen.setHue": "postavi boju olovke na %1",
  	"pen.changeShade": "promjeni sjenu olovke za %1",
  	"pen.setShade": "postavi sjenu olovke na %1",
  	"pen.changeSize": "promijeni debljinu olovke za %1",
  	"pen.setSize": "postavi debljinu olovke na %1",
  	EVENT_WHENFLAGCLICKED: "Kada je kliknuta @greenFlag",
  	EVENT_WHENKEYPRESSED: "kada je tipka %1 pritisnuta",
  	EVENT_WHENTHISSPRITECLICKED: "Kada je lik kliknut",
  	EVENT_WHENSTAGECLICKED: "kada je kliknuto na pozadinu",
  	EVENT_WHENBACKDROPSWITCHESTO: "kada se pozadina promijeni u %1",
  	EVENT_WHENGREATERTHAN: "kada je %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kada primim %1",
  	EVENT_BROADCAST: "pošalji %1",
  	EVENT_BROADCASTANDWAIT: "pošalji %1 i čekaj",
  	CONTROL_WAIT: "čekaj %1 sekundi",
  	CONTROL_REPEAT: "ponovi %1",
  	CONTROL_FOREVER: "ponavljaj",
  	CONTROL_IF: "ako %1 onda",
  	CONTROL_WAITUNTIL: "čekaj do %1",
  	CONTROL_REPEATUNTIL: "ponavljaj dok nije %1",
  	CONTROL_STOP: "zaustavi %1",
  	CONTROL_STARTASCLONE: "kada krećem kao klon",
  	CONTROL_CREATECLONEOF: "kloniraj %1",
  	CONTROL_DELETETHISCLONE: "izbriši klona",
  	SENSING_ASKANDWAIT: "pitaj %1 i čekaj",
  	"videoSensing.videoToggle": "postavi video %1",
  	"videoSensing.setVideoTransparency": "postavi providnost videa na %1",
  	"videoSensing.whenMotionGreaterThan": "kada je gibanje videa > %1",
  	SENSING_RESETTIMER: "poništi štopericu",
  	DATA_SETVARIABLETO: "postavi %1 na %2",
  	DATA_CHANGEVARIABLEBY: "promijeni %1 za %2",
  	DATA_SHOWVARIABLE: "prikaži varijablu %1",
  	DATA_HIDEVARIABLE: "sakrij varijablu %1",
  	DATA_ADDTOLIST: "dodaj %1 u %2",
  	DATA_DELETEOFLIST: "izbriši %1 iz %2",
  	DATA_DELETEALLOFLIST: "izbriši sve %1",
  	MOTION_IFONEDGEBOUNCE: "ako si na rubu, okreni se",
  	DATA_INSERTATLIST: "umetni %1 na %2 u %3",
  	DATA_REPLACEITEMOFLIST: "zamijeni %1 na %2 s %3",
  	DATA_SHOWLIST: "prikaži listu %1",
  	DATA_HIDELIST: "sakrij listu %1",
  	SENSING_OF_XPOSITION: "x položaj",
  	SENSING_OF_YPOSITION: "y položaj",
  	SENSING_OF_DIRECTION: "smjer",
  	SENSING_OF_COSTUMENUMBER: "kostim #",
  	LOOKS_COSTUMENUMBERNAME: "kostim %1",
  	SENSING_OF_SIZE: "veličina",
  	SENSING_OF_BACKDROPNAME: "naziv pozadine",
  	LOOKS_BACKDROPNUMBERNAME: "pozadina %1",
  	SENSING_OF_BACKDROPNUMBER: "pozadina #",
  	SOUND_VOLUME: "glasnoća",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "dodiruje %1?",
  	SENSING_TOUCHINGCOLOR: "dodiruje boju %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "boja %1 dodiruje %2?",
  	SENSING_DISTANCETO: "udaljenost do %1",
  	SENSING_ANSWER: "odgovor",
  	SENSING_KEYPRESSED: "tipka %1 pritisnuta?",
  	SENSING_MOUSEDOWN: "miš pritisnut?",
  	SENSING_MOUSEX: "miš x",
  	SENSING_MOUSEY: "miš y",
  	SENSING_SETDRAGMODE: "postavi način povlačenja na %1",
  	SENSING_LOUDNESS: "glasnoća",
  	"videoSensing.videoOn": "video %1 na %2",
  	SENSING_TIMER: "štoperica",
  	SENSING_OF: "%1 od %2",
  	SENSING_CURRENT: "trenutna %1",
  	SENSING_DAYSSINCE2000: "dana od 2000",
  	SENSING_USERNAME: "nadimak",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "slučajan broj od %1 do %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 i %2",
  	OPERATORS_OR: "%1 ili %2",
  	OPERATORS_NOT: "nije %1",
  	OPERATORS_JOIN: "spoji %1 %2",
  	OPERATORS_LETTEROF: "slovo %1 od %2",
  	OPERATORS_LENGTH: "dužina %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "zaokruži %1",
  	OPERATORS_MATHOP: "%1 od %2",
  	OPERATORS_CONTAINS: "%1 sadrži %2",
  	DATA_ITEMOFLIST: "element %1 od %2",
  	DATA_ITEMNUMOFLIST: "element # od %1 u %2",
  	DATA_LENGTHOFLIST: "dužina %1",
  	DATA_LISTCONTAINSITEM: "Sadrži li %1 %2?",
  	CONTROL_ELSE: "inače",
  	SENSING_USERID: "korisnički id",
  	SENSING_LOUD: "glasno?",
  	"text2speech.speakAndWaitBlock": "govori %1",
  	"text2speech.setVoiceBlock": "postavi glas na %1",
  	"text2speech.setLanguageBlock": "postavi jezik na %1",
  	"translate.translateBlock": "prevedi %1 na %2",
  	"translate.viewerLanguage": "jezik",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "kada je gumb %1 pritisnut",
  	"microbit.isButtonPressed": "gumb %1 pritisnut?",
  	"microbit.whenGesture": "kada je %1",
  	"microbit.displaySymbol": "prikaži %1",
  	"microbit.displayText": "prikaži tekst %1",
  	"microbit.clearDisplay": "očisti ekran",
  	"microbit.whenTilted": "kada je nagnuto %1",
  	"microbit.isTilted": "nagnuto %1?",
  	"microbit.tiltAngle": "kut nagiba %1",
  	"microbit.whenPinConnected": "kada je pin %1 spojen",
  	"ev3.motorTurnClockwise": "motor %1 okreni ovako na %2 sekundi",
  	"ev3.motorTurnCounterClockwise": "motor %1 okreni suprotno od kazaljke na satu na %2 sekunde",
  	"ev3.motorSetPower": "motor %1 postavi snagu na %2 %",
  	"ev3.getMotorPosition": "motor %1 pozicija",
  	"ev3.whenButtonPressed": "kada je tipka %1 pritisnuta",
  	"ev3.whenDistanceLessThan": "kada je udaljenost < %1",
  	"ev3.whenBrightnessLessThan": "kada je osvjeteljnje < %1",
  	"ev3.buttonPressed": "gumb %1 pritisnut?",
  	"ev3.getDistance": "udaljenost",
  	"ev3.getBrightness": "osvjetljenje",
  	"ev3.beepNote": "sviraj ton %1  %2 sekundi",
  	"wedo2.motorOn": "uključi %1",
  	"wedo2.motorOff": "isključi %1",
  	"wedo2.startMotorPower": "postavi snagu %1 na %2",
  	"wedo2.setMotorDirection": "postavi smjer %1 na %2",
  	"wedo2.whenDistance": "kada je udaljenost %1 %2",
  	"wedo2.getDistance": "udaljenost",
  	"wedo2.motorOnFor": "uključi %1 na %2 sekundi",
  	"wedo2.setLightHue": "postavi  boju svjetla na %1",
  	"wedo2.playNoteFor": "sviraj ton %1 %2 sekundi",
  	"wedo2.whenTilted": "kada je nagnuto %1",
  	"wedo2.isTilted": "nagnuto %1?",
  	"wedo2.getTiltAngle": "kut nagiba %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "ubrzanje %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "kada je nagnuto %1",
  	"boost.getTiltAngle": "kut nagiba %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$J = {
  };
  var ignorelt$J = [
  ];
  var soundEffects$J = [
  	"visina tona",
  	"kretanje lijevo/desno"
  ];
  var microbitWhen$J = [
  	"pomaknuto",
  	"protresen",
  	"skok"
  ];
  var osis$J = [
  	"druge programe lika"
  ];
  var definePrefix$J = [
  	"definiraj"
  ];
  var defineSuffix$J = [
  ];
  var palette$J = {
  	Motion: "Kretanje",
  	Looks: "Izgled",
  	Sound: "Zvuk",
  	Events: "Događaji",
  	Control: "Upravljanje",
  	Sensing: "Očitanja",
  	Operators: "Operacije",
  	Variables: "Varijable",
  	"My Blocks": "Moji Blokovi"
  };
  var math$J = [
  	"apsolutno",
  	"donja vrijednost",
  	"gornja vrijednost",
  	"korijen",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$J = {
  	"skreni lijevo %1 stupnjeva": "MOTION_TURNLEFT",
  	"skreni desno %1 stupnjeva": "MOTION_TURNRIGHT",
  	"kada je zelena zastava kliknut": "EVENT_WHENFLAGCLICKED",
  	kraj: "scratchblocks:end"
  };
  var name$J = "Hrvatski";
  var percentTranslated$J = 100;
  var hr = {
  	commands: commands$J,
  	dropdowns: dropdowns$J,
  	ignorelt: ignorelt$J,
  	soundEffects: soundEffects$J,
  	microbitWhen: microbitWhen$J,
  	osis: osis$J,
  	definePrefix: definePrefix$J,
  	defineSuffix: defineSuffix$J,
  	palette: palette$J,
  	math: math$J,
  	aliases: aliases$J,
  	name: name$J,
  	percentTranslated: percentTranslated$J
  };

  var commands$I = {
  	MOTION_MOVESTEPS: "fè %1 pa",
  	MOTION_TURNRIGHT: "vire @turnRight %1 grad",
  	MOTION_TURNLEFT: "vire @turnLeft %1 grad",
  	MOTION_POINTINDIRECTION: "bay tèt li sou direksyon %1",
  	MOTION_POINTTOWARDS: "bay tèt li sou %1",
  	MOTION_GOTOXY: "ale nan x : %1 y : %2",
  	MOTION_GOTO: "ale nan %1",
  	MOTION_GLIDESECSTOXY: "glise pou %1 segond vè x : %2 y : %3",
  	MOTION_GLIDETO: "glise pou %1 segond vè %2",
  	MOTION_CHANGEXBY: "chanje x pa %1",
  	MOTION_SETX: "fikse x a %1",
  	MOTION_CHANGEYBY: "chanje y pa %1",
  	MOTION_SETY: "fikse y a %1",
  	MOTION_SETROTATIONSTYLE: "fikse stil vire a %1",
  	LOOKS_SAYFORSECS: "di %1 pandan %2 segond",
  	LOOKS_SAY: "di %1",
  	LOOKS_THINKFORSECS: "panse %1 pou %2 segond",
  	LOOKS_THINK: "panse %1",
  	LOOKS_SHOW: "montre",
  	LOOKS_HIDE: "kache",
  	LOOKS_SWITCHCOSTUMETO: "chanje a kostim %1",
  	LOOKS_NEXTCOSTUME: "pwochenn kostim",
  	LOOKS_NEXTBACKDROP_BLOCK: "pwochenn fon",
  	LOOKS_SWITCHBACKDROPTO: "chanje fon an a %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "chanje fon a %1 epi tann",
  	LOOKS_CHANGEEFFECTBY: "chanje efè %1 pa %2",
  	LOOKS_SETEFFECTTO: "fikse efè %1 a %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "efase efè grafik yo",
  	LOOKS_CHANGESIZEBY: "chanje gwosè a pa %1",
  	LOOKS_SETSIZETO: "mete gwosè a %1 %",
  	LOOKS_GOTOFRONTBACK: "ale nan kouch %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ale nan kouch %1 %2",
  	SOUND_PLAY: "kòmanse jwe son %1",
  	SOUND_CHANGEEFFECTBY: "chanje efè %1 pa %2",
  	SOUND_SETEFFECTO: "fikse efè %1 a %2",
  	SOUND_CLEAREFFECTS: "efase tout efè son yo",
  	SOUND_PLAYUNTILDONE: "jwe son %1 jiskaske l fini",
  	SOUND_STOPALLSOUNDS: "koupe tout son",
  	"music.playDrumForBeats": "jwe tanbou %1 pandan %2 batman",
  	"music.restForBeats": "repoze pandan %1 batman",
  	"music.playNoteForBeats": "jwe ton %1 pandan %2 batman",
  	"music.setInstrument": "chwazi enstriman %1",
  	SOUND_CHANGEVOLUMEBY: "chanje volim lan pa %1",
  	SOUND_SETVOLUMETO: "fikse volim lan a %1%",
  	"music.changeTempo": "chanje tenmpo pa %1",
  	"music.setTempo": "fikse tenmpo a %1",
  	"pen.clear": "efase tout",
  	"pen.stamp": "mete so",
  	"pen.penDown": "bese plim la",
  	"pen.penUp": "leve plim la",
  	"pen.setColor": "fikse koulè plim nan %1",
  	"pen.changeHue": "chanje koulè plim pa %1",
  	"pen.setColorParam": "fikse plim %1 sou %2",
  	"pen.changeColorParam": "chanje plim %1 pa %2",
  	"pen.setHue": "fikse koulè plim sou %1",
  	"pen.changeShade": "chanje lonbraj plim pa %1",
  	"pen.setShade": "fikse lonbraj plim a %1",
  	"pen.changeSize": "chanje tay plim pa %1",
  	"pen.setSize": "fikse tay plim sou %1",
  	EVENT_WHENFLAGCLICKED: "lè n klike @greenFlag",
  	EVENT_WHENKEYPRESSED: "depi bouton %1 peze",
  	EVENT_WHENTHISSPRITECLICKED: "lè aktè la klike",
  	EVENT_WHENSTAGECLICKED: "lè sèn an klike",
  	EVENT_WHENBACKDROPSWITCHESTO: "lè fon an chanje a %1",
  	EVENT_WHENGREATERTHAN: "lè %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "lè m resevwa %1",
  	EVENT_BROADCAST: "kònen %1",
  	EVENT_BROADCASTANDWAIT: "kònen %1 epi tann",
  	CONTROL_WAIT: "rete tann %1 segond",
  	CONTROL_REPEAT: "repete %1",
  	CONTROL_FOREVER: "pou toujou",
  	CONTROL_IF: "si %1 ebyen",
  	CONTROL_WAITUNTIL: "tann jiska %1",
  	CONTROL_REPEATUNTIL: "repete jiska %1",
  	CONTROL_STOP: "kanpe %1",
  	CONTROL_STARTASCLONE: "lè m parèt kòm marasa",
  	CONTROL_CREATECLONEOF: "kreye marasa pou  %1 sa a",
  	CONTROL_DELETETHISCLONE: "efase marasa sa a",
  	SENSING_ASKANDWAIT: "mande %1 epi tann",
  	"videoSensing.videoToggle": "fè videyo %1",
  	"videoSensing.setVideoTransparency": "fikse transparans videyo a %1",
  	"videoSensing.whenMotionGreaterThan": "lè mouvman videyo > %1",
  	SENSING_RESETTIMER: "rekòmanse kwonomèt la",
  	DATA_SETVARIABLETO: "fikse %2 a %1",
  	DATA_CHANGEVARIABLEBY: "chanje %1 pa %2",
  	DATA_SHOWVARIABLE: "montre varyab %1",
  	DATA_HIDEVARIABLE: "kache varyab %1",
  	DATA_ADDTOLIST: "ajoute %1 sou %2",
  	DATA_DELETEOFLIST: "efase %1 nan %2",
  	DATA_DELETEALLOFLIST: "efase tout %1",
  	MOTION_IFONEDGEBOUNCE: "si li nan bout la, rebondi li",
  	DATA_INSERTATLIST: "antre %1 nan %2 de %3",
  	DATA_REPLACEITEMOFLIST: "ranplase %1 nan %2 avèk %3",
  	DATA_SHOWLIST: "montre lis %1",
  	DATA_HIDELIST: "kache lis %1",
  	SENSING_OF_XPOSITION: "pozisyon x",
  	SENSING_OF_YPOSITION: "pozisyon y",
  	SENSING_OF_DIRECTION: "direksyon",
  	SENSING_OF_COSTUMENUMBER: "kostim #",
  	LOOKS_COSTUMENUMBERNAME: "kostim %1",
  	SENSING_OF_SIZE: "gwosè",
  	SENSING_OF_BACKDROPNAME: "non fon an",
  	LOOKS_BACKDROPNUMBERNAME: "fon %1",
  	SENSING_OF_BACKDROPNUMBER: "# fon",
  	SOUND_VOLUME: "volim",
  	"music.getTempo": "tenmpo",
  	SENSING_TOUCHINGOBJECT: "èske l ap touche %1 ?",
  	SENSING_TOUCHINGCOLOR: "èske l ap touche koulè %1 ?",
  	SENSING_COLORISTOUCHINGCOLOR: "èske koulè %1 ap touche %2 ?",
  	SENSING_DISTANCETO: "distans a %1",
  	SENSING_ANSWER: "repons",
  	SENSING_KEYPRESSED: "èske bouton %1 peze ?",
  	SENSING_MOUSEDOWN: "sourit peze ?",
  	SENSING_MOUSEX: "sourit x",
  	SENSING_MOUSEY: "sourit y",
  	SENSING_SETDRAGMODE: "fikse mòd glise a %1",
  	SENSING_LOUDNESS: "volim",
  	"videoSensing.videoOn": "videyo %1 sou %2",
  	SENSING_TIMER: "kwonomèt",
  	SENSING_OF: "%1 nan %2",
  	SENSING_CURRENT: "%1 aktyèl",
  	SENSING_DAYSSINCE2000: "jou depi 2000",
  	SENSING_USERNAME: "non itilizatè",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "chwazi pa aza soti %1 rive %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 ak %2",
  	OPERATORS_OR: "%1 oubyen %2",
  	OPERATORS_NOT: "pa %1",
  	OPERATORS_JOIN: "kole %1 ak %2",
  	OPERATORS_LETTEROF: "lèt %1 nan %2",
  	OPERATORS_LENGTH: "longè %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "awondi %1",
  	OPERATORS_MATHOP: "%1 nan %2",
  	OPERATORS_CONTAINS: "èske %1 gen %2 ladan l ?",
  	DATA_ITEMOFLIST: "bagay %1 nan %2",
  	DATA_ITEMNUMOFLIST: "bagay # de %1 nan %2",
  	DATA_LENGTHOFLIST: "longè %1 a",
  	DATA_LISTCONTAINSITEM: "èske %1 genyen %2 ladan l ?",
  	CONTROL_ELSE: "si non",
  	SENSING_USERID: "idantite itilizatè",
  	SENSING_LOUD: "fò ?",
  	"text2speech.speakAndWaitBlock": "pale %1",
  	"text2speech.setVoiceBlock": "fikse vwa a %1",
  	"text2speech.setLanguageBlock": "chwazi lang %1",
  	"translate.translateBlock": "tradwi %1 an %2",
  	"translate.viewerLanguage": "lang",
  	"makeymakey.whenKeyPressed": "lè %1 touch peze",
  	"makeymakey.whenKeysPressedInOrder": "lè %1 peze nan lòd",
  	"microbit.whenButtonPressed": "lè bouton %1  peze",
  	"microbit.isButtonPressed": "èske bouton %1 peze ?",
  	"microbit.whenGesture": "lè %1",
  	"microbit.displaySymbol": "afiche %1",
  	"microbit.displayText": "afiche tèks %1",
  	"microbit.clearDisplay": "netwaye ekran",
  	"microbit.whenTilted": "lè l panche an %1",
  	"microbit.isTilted": "èske l panche a %1 ?",
  	"microbit.tiltAngle": "ang li panche an %1",
  	"microbit.whenPinConnected": "lè zepeng %1 konekte",
  	"ev3.motorTurnClockwise": "motè %1 pran direksyon sa a pandan %2 segond",
  	"ev3.motorTurnCounterClockwise": "motè %1 pran lòt direksyon an pandan %2 segond",
  	"ev3.motorSetPower": "fikse fòs motè %1 a %2 %",
  	"ev3.getMotorPosition": "Pozisyon motè %1",
  	"ev3.whenButtonPressed": "lè bouton %1 peze",
  	"ev3.whenDistanceLessThan": "lè distans < %1",
  	"ev3.whenBrightnessLessThan": "lè ekleraj < %1",
  	"ev3.buttonPressed": "èske bouton %1 an peze ?",
  	"ev3.getDistance": "distans",
  	"ev3.getBrightness": "ekleraj",
  	"ev3.beepNote": "bipe ton %1 pandan %2 segond",
  	"wedo2.motorOn": "mete %1 an mach",
  	"wedo2.motorOff": "rete %1",
  	"wedo2.startMotorPower": "fikse fòs %1 a %2",
  	"wedo2.setMotorDirection": "mete %1 sou direksyon %2",
  	"wedo2.whenDistance": "lè distans %1 %2",
  	"wedo2.getDistance": "distans",
  	"wedo2.motorOnFor": "fè %1 woule pandan %2 segond",
  	"wedo2.setLightHue": "mete koulè limyè sou %1",
  	"wedo2.playNoteFor": "jwe ton %1 pandan %2 segond",
  	"wedo2.whenTilted": "lè l panche %1",
  	"wedo2.isTilted": "èske li panche %1 ?",
  	"wedo2.getTiltAngle": "ang li panche %1",
  	"gdxfor.whenGesture": "lè %1",
  	"gdxfor.whenForcePushedOrPulled": "lè kaptè fòs %1",
  	"gdxfor.getForce": "fòs",
  	"gdxfor.whenTilted": "lè l panche %1",
  	"gdxfor.isTilted": "èske l ap panche %1 ?",
  	"gdxfor.getTilt": "ang l ap panche %1",
  	"gdxfor.isFreeFalling": "èske l ap tonbe ?",
  	"gdxfor.getSpin": "vitès rotasyon %1",
  	"gdxfor.getAcceleration": "akselere an %1",
  	"boost.motorOnFor": "fè motè a woule %1 pandan %2 segond",
  	"boost.motorOnForRotation": "fè motè woule %1 pandan %2 rotasyon",
  	"boost.motorOn": "mete motè %1 an mach",
  	"boost.motorOff": "rete motè %1",
  	"boost.setMotorPower": "fikse vitès motè %1 a %2 %",
  	"boost.setMotorDirection": "fikse direksyon motè %1 a %2",
  	"boost.getMotorPosition": "pozisyon motè %1",
  	"boost.whenColor": "lè l wè brik %1",
  	"boost.seeingColor": "èske l wè brik %1 ?",
  	"boost.whenTilted": "lè l panche %1",
  	"boost.getTiltAngle": "ang li panche %1",
  	"boost.setLightHue": "mete koulè limyè sou %1"
  };
  var dropdowns$I = {
  };
  var ignorelt$I = [
  ];
  var soundEffects$I = [
  	"ton",
  	"voye sou bò goch/dwat"
  ];
  var microbitWhen$I = [
  	"deplase",
  	"te souke",
  	"sote"
  ];
  var osis$I = [
  	"lòt eskrip nan aktè la"
  ];
  var definePrefix$I = [
  	"defini"
  ];
  var defineSuffix$I = [
  ];
  var palette$I = {
  	Motion: "Mouvman",
  	Looks: "Aparans",
  	Sound: "Son",
  	Events: "Evènman",
  	Control: "Kontwòl",
  	Sensing: "Deteksyon",
  	Operators: "Operatè",
  	Variables: "Varyab",
  	"My Blocks": "Blòk mwen yo"
  };
  var math$I = [
  	"abs",
  	"desann pou awondi chif la",
  	"monte pou awondi chif la",
  	"rasin kare",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$I = {
  };
  var name$I = "Kreyòl ayisyen";
  var percentTranslated$I = 100;
  var ht = {
  	commands: commands$I,
  	dropdowns: dropdowns$I,
  	ignorelt: ignorelt$I,
  	soundEffects: soundEffects$I,
  	microbitWhen: microbitWhen$I,
  	osis: osis$I,
  	definePrefix: definePrefix$I,
  	defineSuffix: defineSuffix$I,
  	palette: palette$I,
  	math: math$I,
  	aliases: aliases$I,
  	name: name$I,
  	percentTranslated: percentTranslated$I
  };

  var commands$H = {
  	MOTION_MOVESTEPS: "menj %1 lépést",
  	MOTION_TURNRIGHT: "fordulj @turnRight %1 fokot",
  	MOTION_TURNLEFT: "fordulj @turnLeft %1 fokot",
  	MOTION_POINTINDIRECTION: "nézz %1 fokos irányba",
  	MOTION_POINTTOWARDS: "nézz %1 felé",
  	MOTION_GOTOXY: "ugorj ide: x: %1 y: %2",
  	MOTION_GOTO: "ugorj %1 helyére",
  	MOTION_GLIDESECSTOXY: "csússz %1 mp-ig ide: x: %2 y: %3",
  	MOTION_GLIDETO: "csússz %1 mp-ig ide: %2",
  	MOTION_CHANGEXBY: "x változzon %1",
  	MOTION_SETX: "x legyen %1",
  	MOTION_CHANGEYBY: "y változzon %1",
  	MOTION_SETY: "y legyen %1",
  	MOTION_SETROTATIONSTYLE: "jelmez %1",
  	LOOKS_SAYFORSECS: "mondd: %1 %2 másodpercig",
  	LOOKS_SAY: "mondd: %1",
  	LOOKS_THINKFORSECS: "gondold: %1 %2 másodpercig",
  	LOOKS_THINK: "gondold: %1",
  	LOOKS_SHOW: "jelenj meg",
  	LOOKS_HIDE: "tűnj el",
  	LOOKS_SWITCHCOSTUMETO: "jelmez legyen %1",
  	LOOKS_NEXTCOSTUME: "következő jelmez",
  	LOOKS_NEXTBACKDROP_BLOCK: "következő háttér",
  	LOOKS_SWITCHBACKDROPTO: "háttér legyen %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "háttér legyen %1 és várj",
  	LOOKS_CHANGEEFFECTBY: "%1 hatás változzon %2",
  	LOOKS_SETEFFECTTO: "%1 hatás legyen %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "töröld a grafikus hatásokat",
  	LOOKS_CHANGESIZEBY: "méret változzon %1",
  	LOOKS_SETSIZETO: "méret legyen %1 %",
  	LOOKS_GOTOFRONTBACK: "kerülj %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "kerülj %1 %2 szintet",
  	SOUND_PLAY: "indítsd el %1 hangot",
  	SOUND_CHANGEEFFECTBY: "%1 hatás változzon %2",
  	SOUND_SETEFFECTO: "%1 hatás legyen %2",
  	SOUND_CLEAREFFECTS: "hanghatások törlése",
  	SOUND_PLAYUNTILDONE: "játszd végig %1 hangot",
  	SOUND_STOPALLSOUNDS: "minden hang álljon le",
  	"music.playDrumForBeats": "játssz %1 dobon %2 ütemig",
  	"music.restForBeats": "szünetelj %1 ütemig",
  	"music.playNoteForBeats": "játszd le %1 hangjegyet %2 ütemig",
  	"music.setInstrument": "hangszer legyen %1",
  	SOUND_CHANGEVOLUMEBY: "hangerő változzon %1",
  	SOUND_SETVOLUMETO: "hangerő legyen %1%",
  	"music.changeTempo": "tempó változzon %1",
  	"music.setTempo": "tempó legyen %1",
  	"pen.clear": "töröld a rajzokat",
  	"pen.stamp": "készíts lenyomatot",
  	"pen.penDown": "tollat tedd le",
  	"pen.penUp": "tollat emeld fel",
  	"pen.setColor": "toll színe legyen %1",
  	"pen.changeHue": "toll színe változzon %1",
  	"pen.setColorParam": "toll %1 legyen %2",
  	"pen.changeColorParam": "toll %1 változzon %2",
  	"pen.setHue": "toll színe legyen %1",
  	"pen.changeShade": "toll árnyalata változzon %1",
  	"pen.setShade": "toll árnyalata legyen %1",
  	"pen.changeSize": "toll mérete változzon %1",
  	"pen.setSize": "toll mérete legyen %1",
  	EVENT_WHENFLAGCLICKED: "@greenFlag -ra kattintáskor",
  	EVENT_WHENKEYPRESSED: "%1 gomb lenyomásakor",
  	EVENT_WHENTHISSPRITECLICKED: "ezen szereplőre kattintáskor",
  	EVENT_WHENSTAGECLICKED: "színpadra kattintáskor",
  	EVENT_WHENBACKDROPSWITCHESTO: "%1 háttér beállításakor",
  	EVENT_WHENGREATERTHAN: "amikor %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "%1 üzenet érkezésekor",
  	EVENT_BROADCAST: "küldj üzenetet: %1",
  	EVENT_BROADCASTANDWAIT: "küldj üzenetet: %1 és várj",
  	CONTROL_WAIT: "várj %1 mp-et",
  	CONTROL_REPEAT: "ismételd %1",
  	CONTROL_FOREVER: "mindig",
  	CONTROL_IF: "ha %1 akkor",
  	CONTROL_WAITUNTIL: "várj eddig: %1",
  	CONTROL_REPEATUNTIL: "ismételd eddig: %1",
  	CONTROL_STOP: "álljon le %1",
  	CONTROL_STARTASCLONE: "másolatként kezdéskor",
  	CONTROL_CREATECLONEOF: "készíts másolatot: %1",
  	CONTROL_DELETETHISCLONE: "töröld ezt a másolatot",
  	SENSING_ASKANDWAIT: "kérdezd meg: %1 és várj",
  	"videoSensing.videoToggle": "videó kapcsolása %1",
  	"videoSensing.setVideoTransparency": "videó átlátszósága legyen %1",
  	"videoSensing.whenMotionGreaterThan": "amikor a videó mozgása > %1",
  	SENSING_RESETTIMER: "időmérő visszaállítása",
  	DATA_SETVARIABLETO: "%1 legyen %2",
  	DATA_CHANGEVARIABLEBY: "%1 változzon %2",
  	DATA_SHOWVARIABLE: "%1 változó jelenjen meg",
  	DATA_HIDEVARIABLE: "%1 változó tűnjön el",
  	DATA_ADDTOLIST: "add %1 elemet %2 listához",
  	DATA_DELETEOFLIST: "töröld %1 elemet %2 listából",
  	DATA_DELETEALLOFLIST: "töröld %1 lista minden elemét",
  	MOTION_IFONEDGEBOUNCE: "ha szélen vagy, pattanj vissza",
  	DATA_INSERTATLIST: "szúrd be %1 elemet %2 helyre %3 listában",
  	DATA_REPLACEITEMOFLIST: "cseréld le %1 elemet %2 listában %3 elemre",
  	DATA_SHOWLIST: "%1 lista jelenjen meg",
  	DATA_HIDELIST: "%1 lista tűnjön el",
  	SENSING_OF_XPOSITION: "x hely",
  	SENSING_OF_YPOSITION: "y hely",
  	SENSING_OF_DIRECTION: "irány",
  	SENSING_OF_COSTUMENUMBER: "jelmez sorszáma",
  	LOOKS_COSTUMENUMBERNAME: "jelmez %1",
  	SENSING_OF_SIZE: "mérete",
  	SENSING_OF_BACKDROPNAME: "háttér neve",
  	LOOKS_BACKDROPNUMBERNAME: "háttér %1",
  	SENSING_OF_BACKDROPNUMBER: "háttér sorszáma",
  	SOUND_VOLUME: "hangerő",
  	"music.getTempo": "tempó",
  	SENSING_TOUCHINGOBJECT: "érinted: %1?",
  	SENSING_TOUCHINGCOLOR: "érintesz %1 színt?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 érint %2 színt?",
  	SENSING_DISTANCETO: "%1 távolsága",
  	SENSING_ANSWER: "válasz",
  	SENSING_KEYPRESSED: "%1 lenyomva?",
  	SENSING_MOUSEDOWN: "egér lenyomva?",
  	SENSING_MOUSEX: "egér x",
  	SENSING_MOUSEY: "egér y",
  	SENSING_SETDRAGMODE: "húzás módja legyen %1",
  	SENSING_LOUDNESS: "hangerő",
  	"videoSensing.videoOn": "video attribútum %1 %2 tárgyban",
  	SENSING_TIMER: "időmérő",
  	SENSING_OF: "%2 %1",
  	SENSING_CURRENT: "jelenlegi %1",
  	SENSING_DAYSSINCE2000: "napok 2000 óta",
  	SENSING_USERNAME: "felhasználó",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "véletlen %1 és %2 között",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 és %2",
  	OPERATORS_OR: "%1 vagy %2",
  	OPERATORS_NOT: "nem %1",
  	OPERATORS_JOIN: "%1 %2 együtt",
  	OPERATORS_LETTEROF: "%2 %1 betűje",
  	OPERATORS_LENGTH: "%1 hossza",
  	OPERATORS_MOD: "%1 / %2 maradéka",
  	OPERATORS_ROUND: "%1 kerekítve",
  	OPERATORS_MATHOP: "%1 %2",
  	OPERATORS_CONTAINS: "%1 tartalmazza %2?",
  	DATA_ITEMOFLIST: "%2 %1 eleme",
  	DATA_ITEMNUMOFLIST: "%1 sorszáma %2 listában",
  	DATA_LENGTHOFLIST: "%1 hossza",
  	DATA_LISTCONTAINSITEM: "%1 tartalmazza %2?",
  	CONTROL_ELSE: "különben",
  	SENSING_USERID: "felhasználóazonosító",
  	SENSING_LOUD: "hangos?",
  	"text2speech.speakAndWaitBlock": "mondd %1",
  	"text2speech.setVoiceBlock": "hang legyen %1",
  	"text2speech.setLanguageBlock": "nyelv legyen %1",
  	"translate.translateBlock": "fordítsd le azt, hogy %1 erre a nyelvre:%2",
  	"translate.viewerLanguage": "nyelv",
  	"makeymakey.whenKeyPressed": "amikor %1 gomb lenyomva",
  	"makeymakey.whenKeysPressedInOrder": "amikor %1 sorban lenyomva",
  	"microbit.whenButtonPressed": "amikor %1 gomb megnyomva",
  	"microbit.isButtonPressed": "%1 gomb megnyomva?",
  	"microbit.whenGesture": "amikor %1",
  	"microbit.displaySymbol": "%1 megjelenítése",
  	"microbit.displayText": "%1 szöveg megjelenítése",
  	"microbit.clearDisplay": "kijelző törlése",
  	"microbit.whenTilted": "amikor %1 irányba billentve",
  	"microbit.isTilted": "%1 irányba billentve ?",
  	"microbit.tiltAngle": "%1 billenési szög",
  	"microbit.whenPinConnected": "amikor pin %1 csatlakoztatva",
  	"ev3.motorTurnClockwise": "%1 motor forduljon erre %2 másodpercig",
  	"ev3.motorTurnCounterClockwise": "%1 motor forduljon arra %2 másodpercig",
  	"ev3.motorSetPower": "%1 motor teljesítménye legyen %2 %",
  	"ev3.getMotorPosition": "%1 motor pozíciója",
  	"ev3.whenButtonPressed": "amikor %1 gomb lenyomva",
  	"ev3.whenDistanceLessThan": "amikor a távolság < %1",
  	"ev3.whenBrightnessLessThan": "amikor a fényerő < %1",
  	"ev3.buttonPressed": "%1 gomb lenyomva?",
  	"ev3.getDistance": "távolság",
  	"ev3.getBrightness": "fényerő",
  	"ev3.beepNote": "%1 hangjelzés lejátszása %2 másodpercig",
  	"wedo2.motorOn": "%1 bekapcsolása",
  	"wedo2.motorOff": "%1 kikapcsolása",
  	"wedo2.startMotorPower": "%1 teljesítménye legyen %2",
  	"wedo2.setMotorDirection": "%1 beállítása %2 irányba",
  	"wedo2.whenDistance": "amikor %1 távolság %2",
  	"wedo2.getDistance": "távolság",
  	"wedo2.motorOnFor": "%1 bekapcsolása %2 másodpercig",
  	"wedo2.setLightHue": "lámpa színének beállítása erre: %1",
  	"wedo2.playNoteFor": "%1 hang lejátszása %2 másodpercig",
  	"wedo2.whenTilted": "amikor %1 irányba billentve",
  	"wedo2.isTilted": "%1 irányba billenve?",
  	"wedo2.getTiltAngle": "%1 billenési szög",
  	"gdxfor.whenGesture": "amikor %1",
  	"gdxfor.whenForcePushedOrPulled": "amikor az erő-szenzor %1",
  	"gdxfor.getForce": "erő",
  	"gdxfor.whenTilted": "amikor billen %1",
  	"gdxfor.isTilted": "billen %1?",
  	"gdxfor.getTilt": "billenés szög %1",
  	"gdxfor.isFreeFalling": "zuhan?",
  	"gdxfor.getSpin": "forgási sebesség %1 irányban",
  	"gdxfor.getAcceleration": "gyorsulás %1 irányban",
  	"boost.motorOnFor": "%1 motor bekapcsolása %2 másodpercig",
  	"boost.motorOnForRotation": "%1 motor bekapcsolása %2 fordulatra",
  	"boost.motorOn": "%1 motor bekapcsolása",
  	"boost.motorOff": "%1 motor kikapcsolása",
  	"boost.setMotorPower": "%1 motor sebessége legyen %2%",
  	"boost.setMotorDirection": "%1 motor beállítása %2 irányba",
  	"boost.getMotorPosition": "%1 motor pozíciója",
  	"boost.whenColor": "ha %1 téglát látsz",
  	"boost.seeingColor": "látsz %1 téglát?",
  	"boost.whenTilted": "amikor %1 irányba billentve",
  	"boost.getTiltAngle": "%1 billenési szög",
  	"boost.setLightHue": "lámpa színe legyen %1"
  };
  var dropdowns$H = {
  };
  var ignorelt$H = [
  ];
  var soundEffects$H = [
  	"hangmagasság",
  	"pásztázás balra/jobbra"
  ];
  var microbitWhen$H = [
  	"elmozdult",
  	"megrázva",
  	"átugrott"
  ];
  var osis$H = [
  	"szereplő többi eljárása"
  ];
  var definePrefix$H = [
  ];
  var defineSuffix$H = [
  	"meghatározása"
  ];
  var palette$H = {
  	Motion: "Mozgás",
  	Looks: "Kinézet",
  	Sound: "Hang",
  	Events: "Események",
  	Control: "Vezérlés",
  	Sensing: "Érzékelés",
  	Operators: "Műveletek",
  	Variables: "Változók",
  	"My Blocks": "Blokkjaim"
  };
  var math$H = [
  	"abszolut érték",
  	"lefelé kerekítve",
  	"felfelé kerekítve",
  	"gyök",
  	"sin",
  	"cos",
  	"tg",
  	"arcsin",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e^",
  	"10^"
  ];
  var aliases$H = {
  	"fordulj balra %1 fokot": "MOTION_TURNLEFT",
  	"fordulj jobbra %1 fokot": "MOTION_TURNRIGHT",
  	"zászlóra kattintáskor": "EVENT_WHENFLAGCLICKED",
  	"a zászlóra kattintáskor": "EVENT_WHENFLAGCLICKED",
  	"vége": "scratchblocks:end"
  };
  var name$H = "Magyar";
  var percentTranslated$H = 100;
  var hu = {
  	commands: commands$H,
  	dropdowns: dropdowns$H,
  	ignorelt: ignorelt$H,
  	soundEffects: soundEffects$H,
  	microbitWhen: microbitWhen$H,
  	osis: osis$H,
  	definePrefix: definePrefix$H,
  	defineSuffix: defineSuffix$H,
  	palette: palette$H,
  	math: math$H,
  	aliases: aliases$H,
  	name: name$H,
  	percentTranslated: percentTranslated$H
  };

  var commands$G = {
  	MOTION_MOVESTEPS: "տեղափոխվել %1 քայլ",
  	MOTION_TURNRIGHT: "շրջվել @turnRight %1 աստիճան",
  	MOTION_TURNLEFT: "շրջվել @turnLeft %1 աստիճան",
  	MOTION_POINTINDIRECTION: "ուղղությունը %1",
  	MOTION_POINTTOWARDS: "ուղղվել դեպի %1",
  	MOTION_GOTOXY: "գնալ դեպի x. %1 y. %2",
  	MOTION_GOTO: "գնալ դեպի %1",
  	MOTION_GLIDESECSTOXY: "սահել %1 վայրկյան դեպի x. %2 y. %3",
  	MOTION_GLIDETO: "սահել %1 վայրկյան դեպի %2",
  	MOTION_CHANGEXBY: "փոխել x -ը %1 -ով",
  	MOTION_SETX: "x -ը՝ %1",
  	MOTION_CHANGEYBY: "փոխել y -ը %1 -ով",
  	MOTION_SETY: "y -ը՝ %1",
  	MOTION_SETROTATIONSTYLE: "պտույտի ձևը՝ %1",
  	LOOKS_SAYFORSECS: "ասել %1  %2 վայրկյան",
  	LOOKS_SAY: "ասել %1",
  	LOOKS_THINKFORSECS: "մտածել %1 %2 վայրկյան",
  	LOOKS_THINK: "մտածել %1",
  	LOOKS_SHOW: "ցույց տալ",
  	LOOKS_HIDE: "թաքցնել",
  	LOOKS_SWITCHCOSTUMETO: "զգեստը՝ %1",
  	LOOKS_NEXTCOSTUME: "հաջորդ զգեստը",
  	LOOKS_NEXTBACKDROP_BLOCK: "հաջորդ ետնապատկերը",
  	LOOKS_SWITCHBACKDROPTO: "ետնապատկերը՝ %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "Ետնապատկերը փոխարինել %1 -ով և սպասել",
  	LOOKS_CHANGEEFFECTBY: "փոխել %1 էֆՖեկտը %2 -ով",
  	LOOKS_SETEFFECTTO: "կիրառել %1 էֆֆեկտը  %2 արժեքով",
  	LOOKS_CLEARGRAPHICEFFECTS: "մաքրել գրաֆիկական էֆեկտները",
  	LOOKS_CHANGESIZEBY: "փոխել չափսը %1 -ով",
  	LOOKS_SETSIZETO: "չափսը՝ %1  %",
  	LOOKS_GOTOFRONTBACK: "գնալ դեպի %1 շերտ",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "գնալ %1 %2 շերտ",
  	SOUND_PLAY: "սկսել ձայն %1 -ը",
  	SOUND_CHANGEEFFECTBY: "փոխել %1 էֆեկտը %2 -ով",
  	SOUND_SETEFFECTO: "կիրառել %1 էֆեկտը %2 արժեքով",
  	SOUND_CLEAREFFECTS: "մաքրել ձայնային էֆեկտները",
  	SOUND_PLAYUNTILDONE: "արտաբերել %1 ձայնը մինչև ավարտը",
  	SOUND_STOPALLSOUNDS: "դադարեցնել բոլոր ձայները",
  	"music.playDrumForBeats": "նվագել թմբուկով %1  %2 տակտով",
  	"music.restForBeats": "դադարեցնել %1 տակտով",
  	"music.playNoteForBeats": "միացնել %1 %2 տակտերով",
  	"music.setInstrument": "սահմանել երաժշտական գործիքը %1",
  	SOUND_CHANGEVOLUMEBY: "փոխել ձայնի բարձրությունը %1 -ով",
  	SOUND_SETVOLUMETO: "ձայնը բարձրությունը՝ %1%",
  	"music.changeTempo": "փոխել տեմպը %1-ով",
  	"music.setTempo": "սահմանել տեմպը %1",
  	"pen.clear": "ջնջել բոլորը",
  	"pen.stamp": "կնիք",
  	"pen.penDown": "գրիչն իջեցնել",
  	"pen.penUp": "գրիչը բարձրացնել",
  	"pen.setColor": "սահմանել գրիչի գույնը %1",
  	"pen.changeHue": "փոխել գրիչի գույնը %1-ով",
  	"pen.setColorParam": "սահմենլ գրիչի %1 %2-ի",
  	"pen.changeColorParam": "փոխել գրիչի գույնը %1  %2-ով",
  	"pen.setHue": "սահմանել գրիչի գույնը %1",
  	"pen.changeShade": "փոխել գրիչի ստվերը %1-ով",
  	"pen.setShade": "սահմանել գրիչի ստվերը %1",
  	"pen.changeSize": "փոխել գրիչի չափը %1-ով",
  	"pen.setSize": "սահմանել գրիչի չափսը %1",
  	EVENT_WHENFLAGCLICKED: "երբ @greenFlag -ը սեղմված է",
  	EVENT_WHENKEYPRESSED: "երբ %1 ստեղնը սեղմված է",
  	EVENT_WHENTHISSPRITECLICKED: "երբ այս կերպարը սեղմված է",
  	EVENT_WHENSTAGECLICKED: "երբ բեմը սեղմված է",
  	EVENT_WHENBACKDROPSWITCHESTO: "երբ ետնապատկերը փոխարինվում է %1 -ով",
  	EVENT_WHENGREATERTHAN: "երբ %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "երբ ստանում եմ %1",
  	EVENT_BROADCAST: "հաղորդել %1",
  	EVENT_BROADCASTANDWAIT: "հաղորդել %1 և սպասել",
  	CONTROL_WAIT: "սպասել %1 վայրկյան",
  	CONTROL_REPEAT: "կրկնել %1",
  	CONTROL_FOREVER: "անվերջ",
  	CONTROL_IF: "եթե %1 ապա",
  	CONTROL_WAITUNTIL: "սպասել մինչև %1",
  	CONTROL_REPEATUNTIL: "կրկնել մինչև %1",
  	CONTROL_STOP: "դադարեցնել %1",
  	CONTROL_STARTASCLONE: "Երբ սկսում եմ որպես կրկնօրինակ",
  	CONTROL_CREATECLONEOF: "ստեղծել  %1-ի կրկնօրինակը",
  	CONTROL_DELETETHISCLONE: "ջնջել այս կրկնօրինակը",
  	SENSING_ASKANDWAIT: "հարցնել %1 և սպասել",
  	"videoSensing.videoToggle": "միացնել տեսանյութը %1",
  	"videoSensing.setVideoTransparency": "սահմանել տեսանյութի թափանցիկությունը %1",
  	"videoSensing.whenMotionGreaterThan": "երբ տեսանյութի շարժը > %1",
  	SENSING_RESETTIMER: "զրոյացնել վայրկյանաչափը",
  	DATA_SETVARIABLETO: "%1 -ը՝ %2",
  	DATA_CHANGEVARIABLEBY: "փոխել %1 -ը  %2 -ով",
  	DATA_SHOWVARIABLE: "ցույց տալ %1 փոփոխականը",
  	DATA_HIDEVARIABLE: "թաքցնել  %1 փոփոխականը",
  	DATA_ADDTOLIST: "ավելացնել %1 -ը %2 -ին",
  	DATA_DELETEOFLIST: "ջնջել %1 -ը %2 -ից",
  	DATA_DELETEALLOFLIST: "ջնջել %1 -ի ամենը",
  	MOTION_IFONEDGEBOUNCE: "եթե եզրին է, հրվել",
  	DATA_INSERTATLIST: "%3 -ի %2 -ում զետեղել %1 -ը",
  	DATA_REPLACEITEMOFLIST: "փոխարինել %1 տարրը %2-ից  %3-ով",
  	DATA_SHOWLIST: "ցույց տալ %1 ցուցակը",
  	DATA_HIDELIST: "թաքցնել %1 ցուցակը",
  	SENSING_OF_XPOSITION: "x -ը",
  	SENSING_OF_YPOSITION: "y -ը",
  	SENSING_OF_DIRECTION: "ուղղություն",
  	SENSING_OF_COSTUMENUMBER: "զգեստ #",
  	LOOKS_COSTUMENUMBERNAME: "զգեստ %1",
  	SENSING_OF_SIZE: "չափս",
  	SENSING_OF_BACKDROPNAME: "ետնապատկերի անունը",
  	LOOKS_BACKDROPNUMBERNAME: "ետնապատկեր %1",
  	SENSING_OF_BACKDROPNUMBER: "ետնապատկեր #",
  	SOUND_VOLUME: "ձայնը",
  	"music.getTempo": "տեմպ",
  	SENSING_TOUCHINGOBJECT: "հպվու՞մ է %1",
  	SENSING_TOUCHINGCOLOR: "հպվու՞մ է %1 գույնին",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 գույնը հպվու՞մ է %2",
  	SENSING_DISTANCETO: "հեռավորությունը մինչև %1",
  	SENSING_ANSWER: "պատասխան",
  	SENSING_KEYPRESSED: "%1 ստեղնը սեղմվա՞ծ է",
  	SENSING_MOUSEDOWN: "մկնիկն սեղմվա՞ծ է",
  	SENSING_MOUSEX: "մկնիկի x -ը",
  	SENSING_MOUSEY: "մկնիկի y -ը",
  	SENSING_SETDRAGMODE: "տեղափոխման ռեժիմը՝  %1",
  	SENSING_LOUDNESS: "ձայնի բարձրությունը",
  	"videoSensing.videoOn": "Տեսանյութի %1֊ը %2֊ում",
  	SENSING_TIMER: "վայրկյանաչափ",
  	SENSING_OF: "%2 -ի %1 -ը",
  	SENSING_CURRENT: "ընթացիկ %1",
  	SENSING_DAYSSINCE2000: "օրերը՝ սկսած 2000-ից",
  	SENSING_USERNAME: "մուտքանուն",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "պատահական թիվ՝ %1 -ից %2 -ը",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 և %2",
  	OPERATORS_OR: "%1 կամ %2",
  	OPERATORS_NOT: "ոչ %1",
  	OPERATORS_JOIN: "%1 -ին միավորել  %2",
  	OPERATORS_LETTEROF: "%2-ի թիվ %1 տառը",
  	OPERATORS_LENGTH: "%1 տողի երկարությունը",
  	OPERATORS_MOD: "%1 մնացորդ %2",
  	OPERATORS_ROUND: "կլորացնել %1 -ը",
  	OPERATORS_MATHOP: "%2 -ից %1",
  	OPERATORS_CONTAINS: "%1 -ը պարունակու՞մ է %2",
  	DATA_ITEMOFLIST: "%2 -ի %1 տարրը",
  	DATA_ITEMNUMOFLIST: "%1 տարրի համարը %2 -ում",
  	DATA_LENGTHOFLIST: "%1 -ի երկարությունը",
  	DATA_LISTCONTAINSITEM: "%1-ը պարունակու՞մ է %2",
  	CONTROL_ELSE: "այլապես",
  	SENSING_USERID: "օգտատիրոջ id",
  	SENSING_LOUD: "ձայնը բա՞րձր է",
  	"text2speech.speakAndWaitBlock": "ասել %1",
  	"text2speech.setVoiceBlock": "սահմանել ձայնը %1",
  	"text2speech.setLanguageBlock": "սահմանել լեզուն %1",
  	"translate.translateBlock": "թարգմանել %1֊ը %2",
  	"translate.viewerLanguage": "լեզու",
  	"makeymakey.whenKeyPressed": "երբ %1 ստեղնը սեղմված է",
  	"makeymakey.whenKeysPressedInOrder": "երբ %1 սեղմված է ըստ հաջորդականության",
  	"microbit.whenButtonPressed": "երբ %1 կոճակը սեղմված է",
  	"microbit.isButtonPressed": "%1 կոճակը սեղմվա՞ծ է",
  	"microbit.whenGesture": "երբ %1",
  	"microbit.displaySymbol": "ցույց տալ %1",
  	"microbit.displayText": "ցույց տալ տեքստ %1",
  	"microbit.clearDisplay": "մաքրել էկրանը",
  	"microbit.whenTilted": "երբ թեքված է %1",
  	"microbit.isTilted": "թեքվա՞ծ է %1",
  	"microbit.tiltAngle": "թեքել անկյունը %1",
  	"microbit.whenPinConnected": "երբ  %1 փինը միացված է",
  	"ev3.motorTurnClockwise": "շարժիչ  %1 պտտել այս կողմ %2 վայրկյանով",
  	"ev3.motorTurnCounterClockwise": "շարժիչ  %1 պտտել այդ կողմ  %2 վայրկյանով",
  	"ev3.motorSetPower": "շարժիչ  %1 հզորությունը  %2 %",
  	"ev3.getMotorPosition": "շարժիչի  %1 դիրքը",
  	"ev3.whenButtonPressed": "երբ %1 կոճակը սեղմված է",
  	"ev3.whenDistanceLessThan": "երբ հեռավորությունը < %1",
  	"ev3.whenBrightnessLessThan": "երբ պայծառությունը < %1",
  	"ev3.buttonPressed": "կոճակ %1  սեղմվա՞ծ է",
  	"ev3.getDistance": "հեռավորություն",
  	"ev3.getBrightness": "պայծառություն",
  	"ev3.beepNote": "միացնել %1 ազդանշանաը %2 վայրկյան",
  	"wedo2.motorOn": "միացնել %1",
  	"wedo2.motorOff": "անջատել %1",
  	"wedo2.startMotorPower": "սահմանել %1  արագությունը մինչև %2",
  	"wedo2.setMotorDirection": "սահմանել %1 ուղղությունը դեպի %2",
  	"wedo2.whenDistance": "երբ հեռավորություն %1 %2",
  	"wedo2.getDistance": "հեռավորություն",
  	"wedo2.motorOnFor": "միացնել %1 շարժիչը %2 վայրկյանով",
  	"wedo2.setLightHue": "սահմանել լույսի գույնը %1",
  	"wedo2.playNoteFor": "միացնել %1 %2 վայրկյանով",
  	"wedo2.whenTilted": "երբ թեքված է %1",
  	"wedo2.isTilted": "թեքվա՞ծ է որևէ ուղղությամբ %1",
  	"wedo2.getTiltAngle": "թեքել անկյունը %1",
  	"gdxfor.whenGesture": "երբ %1",
  	"gdxfor.whenForcePushedOrPulled": "երբ ուժի տվիչը %1",
  	"gdxfor.getForce": "ուժ",
  	"gdxfor.whenTilted": "երբ թեքություն կա %1",
  	"gdxfor.isTilted": "թեքվա՞ծ %1",
  	"gdxfor.getTilt": "անկյան թեքվածություն %1",
  	"gdxfor.isFreeFalling": "ընկնում",
  	"gdxfor.getSpin": "պտտման արագություն %1",
  	"gdxfor.getAcceleration": "արագացում  %1",
  	"boost.motorOnFor": "միացնել %1 շարժիչը %2 վայրկյանով",
  	"boost.motorOnForRotation": "պտտել %1 շարժիչը %2 աստիճանով",
  	"boost.motorOn": "միացնել %1",
  	"boost.motorOff": "անջատել %1",
  	"boost.setMotorPower": "սահմանել  %1-ի  արագությունը մինչև %2 %",
  	"boost.setMotorDirection": "սահմանել %1-ի ուղղությունը %2",
  	"boost.getMotorPosition": "տեղաշարժել %1",
  	"boost.whenColor": "երբ երևում է %1 աղյուսը",
  	"boost.seeingColor": "երևո՞ւմ է %1 աղյուսը",
  	"boost.whenTilted": "երբ թեքված է %1",
  	"boost.getTiltAngle": "թեքել անկյունը %1",
  	"boost.setLightHue": "սահմանել լույսի գույնը %1"
  };
  var dropdowns$G = {
  };
  var ignorelt$G = [
  ];
  var soundEffects$G = [
  	"խոսք",
  	"տարածում ձախ/աջ"
  ];
  var microbitWhen$G = [
  	"շարժված",
  	"թափահարած",
  	"ցատկած"
  ];
  var osis$G = [
  	"կերպարի այլ սցենարները"
  ];
  var definePrefix$G = [
  	"սահմանել"
  ];
  var defineSuffix$G = [
  ];
  var palette$G = {
  	Motion: "Շարժ",
  	Looks: "Տեսք",
  	Sound: "Ձայն",
  	Events: "Իրադար­­ձություն",
  	Control: "Կառավա­­րում",
  	Sensing: "Ընկալում",
  	Operators: "Հաշվարկ",
  	Variables: "Փոփոխա­­կան",
  	"My Blocks": "Մասնիկ"
  };
  var math$G = [
  	"մոդուլ",
  	"ամբողջ թիվ՝ վար",
  	"ամբողջ թիվ՝ վեր",
  	"արմատ",
  	"sin",
  	"cos",
  	"tan",
  	"arcsin",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$G = {
  };
  var name$G = "Հայերեն";
  var percentTranslated$G = 100;
  var hy = {
  	commands: commands$G,
  	dropdowns: dropdowns$G,
  	ignorelt: ignorelt$G,
  	soundEffects: soundEffects$G,
  	microbitWhen: microbitWhen$G,
  	osis: osis$G,
  	definePrefix: definePrefix$G,
  	defineSuffix: defineSuffix$G,
  	palette: palette$G,
  	math: math$G,
  	aliases: aliases$G,
  	name: name$G,
  	percentTranslated: percentTranslated$G
  };

  var commands$F = {
  	MOTION_MOVESTEPS: "gerak %1 langkah",
  	MOTION_TURNRIGHT: "putar @turnRight %1 derajat",
  	MOTION_TURNLEFT: "putar @turnLeft %1 derajat",
  	MOTION_POINTINDIRECTION: "mengarah ke arah %1",
  	MOTION_POINTTOWARDS: "mengarah ke %1",
  	MOTION_GOTOXY: "pergi ke x: %1 y: %2",
  	MOTION_GOTO: "pergi ke %1",
  	MOTION_GLIDESECSTOXY: "meluncur %1 detik ke x: %2 y: %3",
  	MOTION_GLIDETO: "meluncur %1 detik ke %2",
  	MOTION_CHANGEXBY: "ubah x sebesar %1",
  	MOTION_SETX: "atur x ke %1",
  	MOTION_CHANGEYBY: "ubah y sebesar %1",
  	MOTION_SETY: "atur y ke %1",
  	MOTION_SETROTATIONSTYLE: "atur gaya rotasi %1",
  	LOOKS_SAYFORSECS: "katakan %1 selama %2 detik",
  	LOOKS_SAY: "katakan %1",
  	LOOKS_THINKFORSECS: "pikirkan %1 selama %2 detik",
  	LOOKS_THINK: "pikirkan %1",
  	LOOKS_SHOW: "tampilkan",
  	LOOKS_HIDE: "sembunyikan",
  	LOOKS_SWITCHCOSTUMETO: "ganti kostum ke %1",
  	LOOKS_NEXTCOSTUME: "kostum berikutnya",
  	LOOKS_NEXTBACKDROP_BLOCK: "latar berikutnya",
  	LOOKS_SWITCHBACKDROPTO: "ganti latar ke %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "ganti latar ke %1 dan tunggu",
  	LOOKS_CHANGEEFFECTBY: "ubah efek %1 sebesar %2",
  	LOOKS_SETEFFECTTO: "atur efek %1 ke %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "hapus semua efek grafis",
  	LOOKS_CHANGESIZEBY: "ubah ukuran sebesar %1",
  	LOOKS_SETSIZETO: "atur ukuran ke %1 %",
  	LOOKS_GOTOFRONTBACK: "pergi ke lapisan %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "pergi %1 %2 lapisan",
  	SOUND_PLAY: "mulai suara %1",
  	SOUND_CHANGEEFFECTBY: "ubah efek %1 sebesar %2",
  	SOUND_SETEFFECTO: "atur efek %1 ke %2",
  	SOUND_CLEAREFFECTS: "hapus semua efek suara",
  	SOUND_PLAYUNTILDONE: "mainkan suara %1 sampai selesai",
  	SOUND_STOPALLSOUNDS: "hentikan semua suara",
  	"music.playDrumForBeats": "mainkan drum %1 selama %2 ketukan",
  	"music.restForBeats": "diam selama %1 ketukan",
  	"music.playNoteForBeats": "mainkan nada %1 selama %2 ketukan",
  	"music.setInstrument": "atur instrumen ke %1",
  	SOUND_CHANGEVOLUMEBY: "ubah volume sebesar %1",
  	SOUND_SETVOLUMETO: "atur volume ke %1%",
  	"music.changeTempo": "ubah tempo sebesar %1",
  	"music.setTempo": "atur tempo ke %1",
  	"pen.clear": "hapus semua",
  	"pen.stamp": "cap",
  	"pen.penDown": "tekan pena",
  	"pen.penUp": "angkat pena",
  	"pen.setColor": "atur warna pena ke %1",
  	"pen.changeHue": "ubah warna pena sebesar %1",
  	"pen.setColorParam": "atur %1 pena ke %2",
  	"pen.changeColorParam": "ubah %1 pena sebesar %2",
  	"pen.setHue": "atur warna pena ke %1",
  	"pen.changeShade": "ubah kegelapan pena sebesar %1",
  	"pen.setShade": "atur kegelapan pena sebesar %1",
  	"pen.changeSize": "ubah ukuran pena sebesar %1",
  	"pen.setSize": "atur ukuran pena ke %1",
  	EVENT_WHENFLAGCLICKED: "ketika @greenFlag diklik",
  	EVENT_WHENKEYPRESSED: "ketika tombol %1 ditekan",
  	EVENT_WHENTHISSPRITECLICKED: "ketika sprite ini diklik",
  	EVENT_WHENSTAGECLICKED: "ketika panggung diklik",
  	EVENT_WHENBACKDROPSWITCHESTO: "ketika latar menjadi %1",
  	EVENT_WHENGREATERTHAN: "ketika %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ketika aku menerima %1",
  	EVENT_BROADCAST: "siarkan %1",
  	EVENT_BROADCASTANDWAIT: "siarkan %1 dan tunggu",
  	CONTROL_WAIT: "tunggu %1 detik",
  	CONTROL_REPEAT: "ulangi %1 kali",
  	CONTROL_FOREVER: "selamanya",
  	CONTROL_IF: "jika %1",
  	CONTROL_WAITUNTIL: "tunggu sampai %1",
  	CONTROL_REPEATUNTIL: "ulangi sampai %1",
  	CONTROL_STOP: "berhenti %1",
  	CONTROL_STARTASCLONE: "ketika aku mulai sebagai clone",
  	CONTROL_CREATECLONEOF: "buat clone dari %1",
  	CONTROL_DELETETHISCLONE: "hapus clone ini",
  	SENSING_ASKANDWAIT: "tanya %1 dan tunggu",
  	"videoSensing.videoToggle": "nyalakan video %1",
  	"videoSensing.setVideoTransparency": "atur transparansi video ke %1",
  	"videoSensing.whenMotionGreaterThan": "ketika gerakan video > %1",
  	SENSING_RESETTIMER: "atur ulang pengatur waktu",
  	DATA_SETVARIABLETO: "atur %1 ke %2",
  	DATA_CHANGEVARIABLEBY: "ubah %1 sebesar %2",
  	DATA_SHOWVARIABLE: "tampilkan variabel %1",
  	DATA_HIDEVARIABLE: "sembunyikan variabel %1",
  	DATA_ADDTOLIST: "tambahkan %1 ke %2",
  	DATA_DELETEOFLIST: "hapus %1 dari %2",
  	DATA_DELETEALLOFLIST: "hapus semua dari %1",
  	MOTION_IFONEDGEBOUNCE: "jika di pinggir, pantulkan",
  	DATA_INSERTATLIST: "sisipkan %1 pada %2 dari %3",
  	DATA_REPLACEITEMOFLIST: "ganti benda %1 dari %2 dengan %3",
  	DATA_SHOWLIST: "tampilkan daftar %1",
  	DATA_HIDELIST: "sembunyikan daftar %1",
  	SENSING_OF_XPOSITION: "posisi x",
  	SENSING_OF_YPOSITION: "posisi y",
  	SENSING_OF_DIRECTION: "arah",
  	SENSING_OF_COSTUMENUMBER: "# kostum",
  	LOOKS_COSTUMENUMBERNAME: "%1 kostum",
  	SENSING_OF_SIZE: "ukuran",
  	SENSING_OF_BACKDROPNAME: "nama latar",
  	LOOKS_BACKDROPNUMBERNAME: "latar %1",
  	SENSING_OF_BACKDROPNUMBER: "latar #",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "menyentuh %1?",
  	SENSING_TOUCHINGCOLOR: "menyentuh warna %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "warna %1 menyentuh %2?",
  	SENSING_DISTANCETO: "jarak dari %1",
  	SENSING_ANSWER: "jawaban",
  	SENSING_KEYPRESSED: "tombol %1 ditekan?",
  	SENSING_MOUSEDOWN: "mouse ditekan?",
  	SENSING_MOUSEX: "x mouse",
  	SENSING_MOUSEY: "y mouse",
  	SENSING_SETDRAGMODE: "atur mode seret %1",
  	SENSING_LOUDNESS: "kenyaringan",
  	"videoSensing.videoOn": "video %1 di %2",
  	SENSING_TIMER: "pengatur waktu",
  	SENSING_OF: "%1 dari %2",
  	SENSING_CURRENT: "%1 saat ini",
  	SENSING_DAYSSINCE2000: "hari-hari sejak 2000",
  	SENSING_USERNAME: "nama pengguna",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "pilih acak dari %1 hingga %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 dan %2",
  	OPERATORS_OR: "%1 atau %2",
  	OPERATORS_NOT: "tidak %1",
  	OPERATORS_JOIN: "gabungkan %1 %2",
  	OPERATORS_LETTEROF: "huruf %1 dari %2",
  	OPERATORS_LENGTH: "panjang dari %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "bulatkan %1",
  	OPERATORS_MATHOP: "%1 dari %2",
  	OPERATORS_CONTAINS: "%1 berisi %2?",
  	DATA_ITEMOFLIST: "benda %1 dari %2",
  	DATA_ITEMNUMOFLIST: "benda # dari %1 di %2",
  	DATA_LENGTHOFLIST: "panjang dari %1",
  	DATA_LISTCONTAINSITEM: "%1 berisi %2?",
  	CONTROL_ELSE: "jika tidak",
  	SENSING_USERID: "id pengguna",
  	SENSING_LOUD: "nyaring?",
  	"text2speech.speakAndWaitBlock": "ujarkan %1",
  	"text2speech.setVoiceBlock": "atur suara ke %1",
  	"text2speech.setLanguageBlock": "atur bahasa ke %1",
  	"translate.translateBlock": "terjemahkan %1 ke %2",
  	"translate.viewerLanguage": "bahasa",
  	"makeymakey.whenKeyPressed": "ketika tombol %1 ditekan",
  	"makeymakey.whenKeysPressedInOrder": "ketika %1 ditekan dalam urutan tersebut",
  	"microbit.whenButtonPressed": "ketika tombol %1 ditekan",
  	"microbit.isButtonPressed": "tombol %1 ditekan?",
  	"microbit.whenGesture": "ketika %1",
  	"microbit.displaySymbol": "tampilkan %1",
  	"microbit.displayText": "tampilkan teks %1",
  	"microbit.clearDisplay": "bersihkan tampilan",
  	"microbit.whenTilted": "ketika dimiringkan %1",
  	"microbit.isTilted": "miring %1?",
  	"microbit.tiltAngle": "sudut miring %1",
  	"microbit.whenPinConnected": "ketika pin %1 disambung",
  	"ev3.motorTurnClockwise": "motor %1 belok ke arah ini selama %2 detik",
  	"ev3.motorTurnCounterClockwise": "motor %1 belok ke arah itu selama %2 detik",
  	"ev3.motorSetPower": "motor %1 atur kekuatan %2 %",
  	"ev3.getMotorPosition": "posisi motor %1",
  	"ev3.whenButtonPressed": "ketika tombol %1 ditekan",
  	"ev3.whenDistanceLessThan": "ketika jarak < %1",
  	"ev3.whenBrightnessLessThan": "ketika kecerahan < %1",
  	"ev3.buttonPressed": "tombol %1 ditekan?",
  	"ev3.getDistance": "jarak",
  	"ev3.getBrightness": "kecerahan",
  	"ev3.beepNote": "bunyikan nada %1 selama %2 detik",
  	"wedo2.motorOn": "nyalakan %1",
  	"wedo2.motorOff": "matikan %1",
  	"wedo2.startMotorPower": "atur kekuatan %1 ke %2",
  	"wedo2.setMotorDirection": "atur arah %1 ke %2",
  	"wedo2.whenDistance": "ketika jarak %1 %2",
  	"wedo2.getDistance": "jarak",
  	"wedo2.motorOnFor": "nyalakan %1 selama %2 detik",
  	"wedo2.setLightHue": "atur warna lampu ke %1",
  	"wedo2.playNoteFor": "mainkan nada %1 selama %2 detik",
  	"wedo2.whenTilted": "ketika dimiringkan %1",
  	"wedo2.isTilted": "dimiringkan %1?",
  	"wedo2.getTiltAngle": "sudut kemiringan %1",
  	"gdxfor.whenGesture": "ketika %1",
  	"gdxfor.whenForcePushedOrPulled": "ketika sensor gaya %1",
  	"gdxfor.getForce": "gaya",
  	"gdxfor.whenTilted": "ketika dimiringkan %1",
  	"gdxfor.isTilted": "dimiringkan %1?",
  	"gdxfor.getTilt": "sudut kemiringan %1",
  	"gdxfor.isFreeFalling": "sedang jatuh bebas?",
  	"gdxfor.getSpin": "kecepatan berputar %1",
  	"gdxfor.getAcceleration": "akselerasi %1",
  	"boost.motorOnFor": "nyalakan motor %1 selama %2 detik",
  	"boost.motorOnForRotation": "nyalakan motor %1 selama %2 rotasi",
  	"boost.motorOn": "nyalakan motor %1",
  	"boost.motorOff": "matikan motor %1",
  	"boost.setMotorPower": "atur kecepatan motor %1 ke %2 %",
  	"boost.setMotorDirection": "atur arah motor %1 %2",
  	"boost.getMotorPosition": "posisi motor %1",
  	"boost.whenColor": "ketika bata %1 dilihat",
  	"boost.seeingColor": "melihat bata %1?",
  	"boost.whenTilted": "ketika dimiringkan %1",
  	"boost.getTiltAngle": "sudut kemiringan %1",
  	"boost.setLightHue": "atur warna lampu ke %1"
  };
  var dropdowns$F = {
  };
  var ignorelt$F = [
  ];
  var soundEffects$F = [
  	"nada",
  	"pan kiri/kanan"
  ];
  var microbitWhen$F = [
  	"bergerak",
  	"tergoyang",
  	"melompat"
  ];
  var osis$F = [
  	"skrip lain di sprite ini"
  ];
  var definePrefix$F = [
  	"artikan"
  ];
  var defineSuffix$F = [
  ];
  var palette$F = {
  	Motion: "Gerakan",
  	Looks: "Tampilan",
  	Sound: "Suara",
  	Events: "Kejadian",
  	Control: "Kontrol",
  	Sensing: "Sensor",
  	Operators: "Operator",
  	Variables: "Variabel",
  	"My Blocks": "Balok Saya"
  };
  var math$F = [
  	"abs",
  	"floor",
  	"ceil",
  	"akar kuadrat",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$F = {
  	"putar ke kiri %1 derajat": "MOTION_TURNLEFT",
  	"putar ke kanan %1 derajat": "MOTION_TURNRIGHT",
  	"ketika bendera hijau diklik": "EVENT_WHENFLAGCLICKED",
  	selesai: "scratchblocks:end"
  };
  var name$F = "Bahasa Indonesia";
  var percentTranslated$F = 100;
  var id = {
  	commands: commands$F,
  	dropdowns: dropdowns$F,
  	ignorelt: ignorelt$F,
  	soundEffects: soundEffects$F,
  	microbitWhen: microbitWhen$F,
  	osis: osis$F,
  	definePrefix: definePrefix$F,
  	defineSuffix: defineSuffix$F,
  	palette: palette$F,
  	math: math$F,
  	aliases: aliases$F,
  	name: name$F,
  	percentTranslated: percentTranslated$F
  };

  var commands$E = {
  	MOTION_MOVESTEPS: "fara %1 skref",
  	MOTION_TURNRIGHT: "snúa til @turnRight um %1 gráður",
  	MOTION_TURNLEFT: "snúa til @turnLeft um %1 gráður",
  	MOTION_POINTINDIRECTION: "stefna í %1 gráður",
  	MOTION_POINTTOWARDS: "stefna í átt að %1",
  	MOTION_GOTOXY: "fara til x: %1 og y: %2",
  	MOTION_GOTO: "fara til %1",
  	MOTION_GLIDESECSTOXY: "svífa í %1 sekúndur til x: %2 og y: %3",
  	MOTION_GLIDETO: "svífa í %1 sekúndur til %2",
  	MOTION_CHANGEXBY: "breyta x um %1",
  	MOTION_SETX: "láttu x verða %1",
  	MOTION_CHANGEYBY: "breyttu y um %1",
  	MOTION_SETY: "láttu y verða %1",
  	MOTION_SETROTATIONSTYLE: "snúningsgerð verður %1",
  	LOOKS_SAYFORSECS: "segðu %1 í %2 sekúndur",
  	LOOKS_SAY: "segðu %1",
  	LOOKS_THINKFORSECS: "hugsaðu %1 í %2 sekúndur",
  	LOOKS_THINK: "hugsaðu %1",
  	LOOKS_SHOW: "birta",
  	LOOKS_HIDE: "fela",
  	LOOKS_SWITCHCOSTUMETO: "breyttu í búning %1",
  	LOOKS_NEXTCOSTUME: "næsti búningur",
  	LOOKS_NEXTBACKDROP_BLOCK: "næsti bakgrunnur",
  	LOOKS_SWITCHBACKDROPTO: "bakgrunnur verður %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "nota bakgrunn %1 og bíða",
  	LOOKS_CHANGEEFFECTBY: "breyta %1 áhrifunum um %2",
  	LOOKS_SETEFFECTTO: "settu %1 áhrifin á %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "hreinsa myndbrellur",
  	LOOKS_CHANGESIZEBY: "breyta stærð um %1",
  	LOOKS_SETSIZETO: "stærð verður %1 %",
  	LOOKS_GOTOFRONTBACK: "farðu á lag %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "farðu %1 %2 lög",
  	SOUND_PLAY: "spila hljóð %1",
  	SOUND_CHANGEEFFECTBY: "breyta %1 áhrifunum um %2",
  	SOUND_SETEFFECTO: "settu %1 áhrifin á %2",
  	SOUND_CLEAREFFECTS: "fjarlægja hljóðbreytingar",
  	SOUND_PLAYUNTILDONE: "spila hljóð %1 þar til það klárast",
  	SOUND_STOPALLSOUNDS: "stöðva öll hljóð",
  	"music.playDrumForBeats": "spila trommu %1 í %2 slög",
  	"music.restForBeats": "bíða í %1 slög",
  	"music.playNoteForBeats": "spila nótu %1 í %2 slög",
  	"music.setInstrument": "setja hljóðfæri sem %1",
  	SOUND_CHANGEVOLUMEBY: "breyta hljóðstyrk um %1",
  	SOUND_SETVOLUMETO: "setja hljóðstyrk í  %1%",
  	"music.changeTempo": "breyta hraða um  %1",
  	"music.setTempo": "setja hraða sem %1",
  	"pen.clear": "hreinsa allt",
  	"pen.stamp": "stimpla",
  	"pen.penDown": "penni niður",
  	"pen.penUp": "penni upp",
  	"pen.setColor": "setja lit penna sem %1",
  	"pen.changeHue": "breyta lit penna um %1",
  	"pen.setColorParam": "setja lit penna %1í %2",
  	"pen.changeColorParam": "breyta lit penna %1 í %2",
  	"pen.setHue": "setja lit penna sem %1",
  	"pen.changeShade": "breyta litbrigði penna um %1",
  	"pen.setShade": "setja skugga penna í %1",
  	"pen.changeSize": "breyta stærð penna um %1",
  	"pen.setSize": "setja stærð penna í %1",
  	EVENT_WHENFLAGCLICKED: "þegar smellt er á @greenFlag",
  	EVENT_WHENKEYPRESSED: "þegar ýtt er á %1",
  	EVENT_WHENTHISSPRITECLICKED: "þegar smellt er á þennan karakter",
  	EVENT_WHENSTAGECLICKED: "þegar smellt er a sviðið",
  	EVENT_WHENBACKDROPSWITCHESTO: "þegar bakgrunnurinn verður %1",
  	EVENT_WHENGREATERTHAN: "þegar %1 er meira en %2",
  	EVENT_WHENBROADCASTRECEIVED: "þegar ég fæ sent %1",
  	EVENT_BROADCAST: "senda %1",
  	EVENT_BROADCASTANDWAIT: "senda %1 og bíða",
  	CONTROL_WAIT: "bíða í %1 sekúndur",
  	CONTROL_REPEAT: "endurtaka %1 sinnum",
  	CONTROL_FOREVER: "endalaust",
  	CONTROL_IF: "ef %1 þá",
  	CONTROL_WAITUNTIL: "bíða þangað til %1",
  	CONTROL_REPEATUNTIL: "endurtaka þar til %1",
  	CONTROL_STOP: "stöðva %1",
  	CONTROL_STARTASCLONE: "þegar ég byrja sem klónn",
  	CONTROL_CREATECLONEOF: "búa til klón af %1",
  	CONTROL_DELETETHISCLONE: "eyða þessum klón",
  	SENSING_ASKANDWAIT: "spurðu %1 og bíddu",
  	"videoSensing.videoToggle": "breyta vídeó %1",
  	"videoSensing.setVideoTransparency": "setja gegnsæi hreyfimyndar í %1",
  	"videoSensing.whenMotionGreaterThan": "þegar hreyfing í vídeó > %1",
  	SENSING_RESETTIMER: "endurstilla skeiðklukku",
  	DATA_SETVARIABLETO: "láttu %1 verða %2",
  	DATA_CHANGEVARIABLEBY: "breyttu %1 um %2",
  	DATA_SHOWVARIABLE: "sýndu mér breytu %1",
  	DATA_HIDEVARIABLE: "feldu breytu %1",
  	DATA_ADDTOLIST: "bættu %1 við %2",
  	DATA_DELETEOFLIST: "fjarlægðu %1 af %2",
  	DATA_DELETEALLOFLIST: "eyddu öllu af %1",
  	MOTION_IFONEDGEBOUNCE: "ef á kanti, snúðu við",
  	DATA_INSERTATLIST: "settu %1 við %2 af %3",
  	DATA_REPLACEITEMOFLIST: "skiptu út hlut %1 af %2 fyrir %3",
  	DATA_SHOWLIST: "sýndu lista %1",
  	DATA_HIDELIST: "feldu lista %1",
  	SENSING_OF_XPOSITION: "x hnit",
  	SENSING_OF_YPOSITION: "y hnit",
  	SENSING_OF_DIRECTION: "stefna",
  	SENSING_OF_COSTUMENUMBER: "búnungur númer",
  	LOOKS_COSTUMENUMBERNAME: "búningur %1",
  	SENSING_OF_SIZE: "stærð",
  	SENSING_OF_BACKDROPNAME: "nafn bakgrunns",
  	LOOKS_BACKDROPNUMBERNAME: "bakgrunnur %1",
  	SENSING_OF_BACKDROPNUMBER: "bakgrunnur númer",
  	SOUND_VOLUME: "hljóðstyrkur",
  	"music.getTempo": "taktur",
  	SENSING_TOUCHINGOBJECT: "snertir %1",
  	SENSING_TOUCHINGCOLOR: "snertir litinn %1",
  	SENSING_COLORISTOUCHINGCOLOR: "liturinn %1 snertir litinn %2",
  	SENSING_DISTANCETO: "fjarlægð til %1",
  	SENSING_ANSWER: "svar",
  	SENSING_KEYPRESSED: "hnappur %1 sleginn",
  	SENSING_MOUSEDOWN: "músarhnappur niðri?",
  	SENSING_MOUSEX: "x hnit músar",
  	SENSING_MOUSEY: "y hnit músar",
  	SENSING_SETDRAGMODE: "breyttu dragstillingu %1",
  	SENSING_LOUDNESS: "hljóðstyrkur",
  	"videoSensing.videoOn": "vídeó %1 á %2",
  	SENSING_TIMER: "skeiðklukka",
  	SENSING_OF: "%1 af %2",
  	SENSING_CURRENT: "núverandi %1",
  	SENSING_DAYSSINCE2000: "dagar síðan árið 2000",
  	SENSING_USERNAME: "notendanafn",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "velja tölu á milli %1 og %2 af handahófi",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 og %2",
  	OPERATORS_OR: "%1 eða %2",
  	OPERATORS_NOT: "ekki %1",
  	OPERATORS_JOIN: "sameina %1 og %2",
  	OPERATORS_LETTEROF: "stafur númer %1 úr %2",
  	OPERATORS_LENGTH: "lengd %1",
  	OPERATORS_MOD: "%1 modulus %2",
  	OPERATORS_ROUND: "rúna %1",
  	OPERATORS_MATHOP: "%1 af %2",
  	OPERATORS_CONTAINS: "inniheldur %1 %2?",
  	DATA_ITEMOFLIST: "hlutur %1 af %2",
  	DATA_ITEMNUMOFLIST: "item # of %1 in %2",
  	DATA_LENGTHOFLIST: "lengd %1",
  	DATA_LISTCONTAINSITEM: "inniheldur %1, %2?",
  	CONTROL_ELSE: "annars",
  	SENSING_USERID: "einkenni notenda",
  	SENSING_LOUD: "hávær?",
  	"text2speech.speakAndWaitBlock": "tala %1",
  	"text2speech.setVoiceBlock": "setja rödd sem %1",
  	"text2speech.setLanguageBlock": "set language to %1",
  	"translate.translateBlock": "þýða %1 á %2",
  	"translate.viewerLanguage": "tungumál",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "when %1 button pressed",
  	"microbit.isButtonPressed": "%1 button pressed?",
  	"microbit.whenGesture": "when %1",
  	"microbit.displaySymbol": "display %1",
  	"microbit.displayText": "display text %1",
  	"microbit.clearDisplay": "clear display",
  	"microbit.whenTilted": "when tilted %1",
  	"microbit.isTilted": "tilted %1?",
  	"microbit.tiltAngle": "tilt angle %1",
  	"microbit.whenPinConnected": "when pin %1 connected",
  	"ev3.motorTurnClockwise": "motor %1 turn this way for %2 seconds",
  	"ev3.motorTurnCounterClockwise": "motor %1 turn that way for %2 seconds",
  	"ev3.motorSetPower": "motor %1 set power %2 %",
  	"ev3.getMotorPosition": "motor %1 position",
  	"ev3.whenButtonPressed": "when button %1 pressed",
  	"ev3.whenDistanceLessThan": "when distance < %1",
  	"ev3.whenBrightnessLessThan": "when brightness < %1",
  	"ev3.buttonPressed": "button %1 pressed?",
  	"ev3.getDistance": "distance",
  	"ev3.getBrightness": "brightness",
  	"ev3.beepNote": "beep note %1 for %2 secs",
  	"wedo2.motorOn": "turn %1 on",
  	"wedo2.motorOff": "turn %1 off",
  	"wedo2.startMotorPower": "set %1 power to %2",
  	"wedo2.setMotorDirection": "set %1 direction to %2",
  	"wedo2.whenDistance": "when distance %1 %2",
  	"wedo2.getDistance": "distance",
  	"wedo2.motorOnFor": "turn %1 on for %2 seconds",
  	"wedo2.setLightHue": "set light color to %1",
  	"wedo2.playNoteFor": "play note %1 for %2 seconds",
  	"wedo2.whenTilted": "when tilted %1",
  	"wedo2.isTilted": "tilted %1?",
  	"wedo2.getTiltAngle": "tilt angle %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$E = {
  };
  var ignorelt$E = [
  ];
  var soundEffects$E = [
  	"tónhæð",
  	"skima til vinstri/hægri"
  ];
  var microbitWhen$E = [
  	"moved",
  	"shaken",
  	"jumped"
  ];
  var osis$E = [
  	"önnur forrit á karakter"
  ];
  var definePrefix$E = [
  	"skilgreina"
  ];
  var defineSuffix$E = [
  ];
  var palette$E = {
  	Motion: "Hreyfing",
  	Looks: "Útlit",
  	Sound: "Hljóð",
  	Events: "Atburðir",
  	Control: "Stjórn",
  	Sensing: "Mæling",
  	Operators: "Virkjar",
  	Variables: "Breytur",
  	"My Blocks": "Mínir kubbar"
  };
  var math$E = [
  	"abs",
  	"rúna niður",
  	"rúna upp",
  	"kvaðratrót",
  	"sínus",
  	"kósínus",
  	"tangens",
  	"arksínus",
  	"arkcósínus",
  	"arktangens",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$E = {
  };
  var name$E = "Íslenska";
  var percentTranslated$E = 100;
  var is = {
  	commands: commands$E,
  	dropdowns: dropdowns$E,
  	ignorelt: ignorelt$E,
  	soundEffects: soundEffects$E,
  	microbitWhen: microbitWhen$E,
  	osis: osis$E,
  	definePrefix: definePrefix$E,
  	defineSuffix: defineSuffix$E,
  	palette: palette$E,
  	math: math$E,
  	aliases: aliases$E,
  	name: name$E,
  	percentTranslated: percentTranslated$E
  };

  var commands$D = {
  	MOTION_MOVESTEPS: "fai %1 passi",
  	MOTION_TURNRIGHT: "ruota @turnRight di %1 gradi",
  	MOTION_TURNLEFT: "ruota @turnLeft di %1 gradi",
  	MOTION_POINTINDIRECTION: "punta in direzione %1",
  	MOTION_POINTTOWARDS: "punta verso %1",
  	MOTION_GOTOXY: "vai a x: %1 y: %2",
  	MOTION_GOTO: "raggiungi %1",
  	MOTION_GLIDESECSTOXY: "scivola in %1 secondi a x: %2 y: %3",
  	MOTION_GLIDETO: "scivola in %1 secondi a %2",
  	MOTION_CHANGEXBY: "cambia x di %1",
  	MOTION_SETX: "vai dove x è %1",
  	MOTION_CHANGEYBY: "cambia y di %1",
  	MOTION_SETY: "vai dove y è %1",
  	MOTION_SETROTATIONSTYLE: "usa stile rotazione %1",
  	LOOKS_SAYFORSECS: "dire %1 per %2 secondi",
  	LOOKS_SAY: "dire %1",
  	LOOKS_THINKFORSECS: "pensa %1 per %2 secondi",
  	LOOKS_THINK: "pensa %1",
  	LOOKS_SHOW: "mostra",
  	LOOKS_HIDE: "nascondi",
  	LOOKS_SWITCHCOSTUMETO: "passa al costume %1",
  	LOOKS_NEXTCOSTUME: "passa al costume seguente",
  	LOOKS_NEXTBACKDROP_BLOCK: "passa allo sfondo seguente",
  	LOOKS_SWITCHBACKDROPTO: "passa allo sfondo %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "passa allo sfondo %1 e attendi",
  	LOOKS_CHANGEEFFECTBY: "cambia effetto %1 di %2",
  	LOOKS_SETEFFECTTO: "porta effetto %1 a %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "rimuovi effetti grafici",
  	LOOKS_CHANGESIZEBY: "cambia dimensione di %1",
  	LOOKS_SETSIZETO: "porta dimensione a %1 %",
  	LOOKS_GOTOFRONTBACK: "vai in %1 piano",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "vai %1 di %2 livelli",
  	SOUND_PLAY: "avvia riproduzione suono %1",
  	SOUND_CHANGEEFFECTBY: "cambia effetto %1 di %2",
  	SOUND_SETEFFECTO: "porta effetto %1 a %2",
  	SOUND_CLEAREFFECTS: "rimuovi effetti audio",
  	SOUND_PLAYUNTILDONE: "riproduci suono %1 e attendi la fine",
  	SOUND_STOPALLSOUNDS: "ferma tutti i suoni",
  	"music.playDrumForBeats": "suona il tamburo %1 per %2 battute",
  	"music.restForBeats": "pausa di %1 battute",
  	"music.playNoteForBeats": "suona la nota %1 per %2 battute",
  	"music.setInstrument": "passa a strumento %1",
  	SOUND_CHANGEVOLUMEBY: "cambia volume di %1",
  	SOUND_SETVOLUMETO: "porta volume a %1%",
  	"music.changeTempo": "cambia tempo di %1",
  	"music.setTempo": "imposta tempo a %1 bpm",
  	"pen.clear": "pulisci",
  	"pen.stamp": "timbra",
  	"pen.penDown": "penna giù",
  	"pen.penUp": "penna su",
  	"pen.setColor": "usa penna di colore %1",
  	"pen.changeHue": "cambia colore penna di %1",
  	"pen.setColorParam": "porta %1 penna a %2",
  	"pen.changeColorParam": "cambia %1 penna di %2",
  	"pen.setHue": "usa penna di colore %1",
  	"pen.changeShade": "cambia luminosità penna di %1",
  	"pen.setShade": "porta luminosità penna a %1",
  	"pen.changeSize": "cambia spessore penna di %1",
  	"pen.setSize": "usa penna di spessore %1",
  	EVENT_WHENFLAGCLICKED: "quando si clicca su @greenFlag",
  	EVENT_WHENKEYPRESSED: "quando si preme il tasto %1",
  	EVENT_WHENTHISSPRITECLICKED: "quando si clicca questo sprite",
  	EVENT_WHENSTAGECLICKED: "quando si clicca sullo Stage",
  	EVENT_WHENBACKDROPSWITCHESTO: "quando lo sfondo passa a %1",
  	EVENT_WHENGREATERTHAN: "quando %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "quando ricevo %1",
  	EVENT_BROADCAST: "invia a tutti %1",
  	EVENT_BROADCASTANDWAIT: "invia a tutti %1 e attendi",
  	CONTROL_WAIT: "attendi %1 secondi",
  	CONTROL_REPEAT: "ripeti %1  volte",
  	CONTROL_FOREVER: "per sempre",
  	CONTROL_IF: "se %1 allora",
  	CONTROL_WAITUNTIL: "attendi fino a quando %1",
  	CONTROL_REPEATUNTIL: "ripeti fino a quando %1",
  	CONTROL_STOP: "ferma %1",
  	CONTROL_STARTASCLONE: "quando vengo clonato",
  	CONTROL_CREATECLONEOF: "crea clone di %1",
  	CONTROL_DELETETHISCLONE: "elimina questo clone",
  	SENSING_ASKANDWAIT: "chiedi %1 e attendi",
  	"videoSensing.videoToggle": "%1 il video della webcam",
  	"videoSensing.setVideoTransparency": "porta trasparenza webcam a %1",
  	"videoSensing.whenMotionGreaterThan": "quando movimento video è > %1",
  	SENSING_RESETTIMER: "azzera cronometro",
  	DATA_SETVARIABLETO: "porta %1 a %2",
  	DATA_CHANGEVARIABLEBY: "cambia %1 di %2",
  	DATA_SHOWVARIABLE: "mostra la variabile %1",
  	DATA_HIDEVARIABLE: "nascondi la variabile %1",
  	DATA_ADDTOLIST: "aggiungi %1 a %2",
  	DATA_DELETEOFLIST: "cancella %1 da %2",
  	DATA_DELETEALLOFLIST: "cancella tutto da %1",
  	MOTION_IFONEDGEBOUNCE: "rimbalza quando tocchi il bordo",
  	DATA_INSERTATLIST: "inserisci %1 alla posizione %2 di %3",
  	DATA_REPLACEITEMOFLIST: "sostituisci elemento %1 di %2 con %3",
  	DATA_SHOWLIST: "mostra la lista %1",
  	DATA_HIDELIST: "nascondi la lista %1",
  	SENSING_OF_XPOSITION: "posizione x",
  	SENSING_OF_YPOSITION: "posizione y",
  	SENSING_OF_DIRECTION: "direzione",
  	SENSING_OF_COSTUMENUMBER: "numero del costume",
  	LOOKS_COSTUMENUMBERNAME: "%1 costume",
  	SENSING_OF_SIZE: "dimensione",
  	SENSING_OF_BACKDROPNAME: "nome dello sfondo",
  	LOOKS_BACKDROPNUMBERNAME: "%1 sfondo",
  	SENSING_OF_BACKDROPNUMBER: "numero dello sfondo",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "sta toccando %1",
  	SENSING_TOUCHINGCOLOR: "sta toccando il colore %1",
  	SENSING_COLORISTOUCHINGCOLOR: "il colore %1 sta toccando il colore %2",
  	SENSING_DISTANCETO: "distanza da %1",
  	SENSING_ANSWER: "risposta",
  	SENSING_KEYPRESSED: "tasto %1 premuto",
  	SENSING_MOUSEDOWN: "pulsante del mouse premuto",
  	SENSING_MOUSEX: "x del mouse",
  	SENSING_MOUSEY: "y del mouse",
  	SENSING_SETDRAGMODE: "rendi lo sprite %1",
  	SENSING_LOUDNESS: "volume microfono",
  	"videoSensing.videoOn": "%1 del video su %2",
  	SENSING_TIMER: "cronometro",
  	SENSING_OF: "%1 di %2",
  	SENSING_CURRENT: "%1 attuale",
  	SENSING_DAYSSINCE2000: "giorni trascorsi dal 2000",
  	SENSING_USERNAME: "username",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "numero a caso tra %1 e %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 e %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "non %1",
  	OPERATORS_JOIN: "unione di %1 e %2",
  	OPERATORS_LETTEROF: "lettera %1 di %2",
  	OPERATORS_LENGTH: "lunghezza di %1",
  	OPERATORS_MOD: "resto della divisione di %1 diviso %2",
  	OPERATORS_ROUND: "arrotonda %1",
  	OPERATORS_MATHOP: "%1 di %2",
  	OPERATORS_CONTAINS: "%1 contiene %2",
  	DATA_ITEMOFLIST: "elemento %1 di %2",
  	DATA_ITEMNUMOFLIST: "posizione di %1 in %2",
  	DATA_LENGTHOFLIST: "lunghezza di %1",
  	DATA_LISTCONTAINSITEM: "%1 contiene %2",
  	CONTROL_ELSE: "altrimenti",
  	SENSING_USERID: "user id",
  	SENSING_LOUD: "volume alto?",
  	"text2speech.speakAndWaitBlock": "pronuncia %1",
  	"text2speech.setVoiceBlock": "usa voce %1",
  	"text2speech.setLanguageBlock": "usa lingua %1",
  	"translate.translateBlock": "traduci %1 in %2",
  	"translate.viewerLanguage": "lingua",
  	"makeymakey.whenKeyPressed": "quando si preme il tasto %1",
  	"makeymakey.whenKeysPressedInOrder": "quando si preme la sequenza di tasti %1",
  	"microbit.whenButtonPressed": "quando pulsante %1 premuto",
  	"microbit.isButtonPressed": "pulsante %1 premuto",
  	"microbit.whenGesture": "quando %1",
  	"microbit.displaySymbol": "mostra %1 su display",
  	"microbit.displayText": "mostra testo %1",
  	"microbit.clearDisplay": "cancella display",
  	"microbit.whenTilted": "quando inclinato %1",
  	"microbit.isTilted": "inclinato %1",
  	"microbit.tiltAngle": "angolo inclinazione %1",
  	"microbit.whenPinConnected": "quando il pin %1 è collegato",
  	"ev3.motorTurnClockwise": "aziona il motore %1 in questa direzione per %2 secondi",
  	"ev3.motorTurnCounterClockwise": "azione il motore %1 nell'altra direzione per %2 secondi",
  	"ev3.motorSetPower": "porta potenza motore %1 a %2 %",
  	"ev3.getMotorPosition": "posizione motore %1",
  	"ev3.whenButtonPressed": "quando pulsante %1 premuto",
  	"ev3.whenDistanceLessThan": "quando distanza < %1",
  	"ev3.whenBrightnessLessThan": "quando luminosità < %1",
  	"ev3.buttonPressed": "pulsante %1 premuto",
  	"ev3.getDistance": "distanza",
  	"ev3.getBrightness": "luminosità",
  	"ev3.beepNote": "emetti nota %1 per %2 secondi",
  	"wedo2.motorOn": "accendi %1",
  	"wedo2.motorOff": "spegni %1",
  	"wedo2.startMotorPower": "porta potenza %1 a %2",
  	"wedo2.setMotorDirection": "porta direzione %1 a %2",
  	"wedo2.whenDistance": "quando distanza %1 %2",
  	"wedo2.getDistance": "distanza",
  	"wedo2.motorOnFor": "accendi %1 per %2 secondi",
  	"wedo2.setLightHue": "porta colore luci a %1",
  	"wedo2.playNoteFor": "suona nota %1 per %2 secondi",
  	"wedo2.whenTilted": "quando inclinato %1",
  	"wedo2.isTilted": "inclinato %1",
  	"wedo2.getTiltAngle": "angolo inclinazione %1",
  	"gdxfor.whenGesture": "quando %1",
  	"gdxfor.whenForcePushedOrPulled": "quando il sensore di forza rileva che %1",
  	"gdxfor.getForce": "forza",
  	"gdxfor.whenTilted": "quando inclinato %1",
  	"gdxfor.isTilted": "inclinato %1",
  	"gdxfor.getTilt": "angolo inclinazione %1",
  	"gdxfor.isFreeFalling": "sto cadendo",
  	"gdxfor.getSpin": "velocità di rotazione %1",
  	"gdxfor.getAcceleration": "accelerazione %1",
  	"boost.motorOnFor": "accendi motore %1 per %2 secondi",
  	"boost.motorOnForRotation": "accendi motore %1 per %2 rotazioni",
  	"boost.motorOn": "accendi motore %1",
  	"boost.motorOff": "spegni motore %1",
  	"boost.setMotorPower": "porta potenza %1 a %2",
  	"boost.setMotorDirection": "porta direzione motore %1 a %2",
  	"boost.getMotorPosition": "posizione motore %1",
  	"boost.whenColor": "quando vedo mattoncino %1",
  	"boost.seeingColor": "vedo mattoncino %1",
  	"boost.whenTilted": "quando inclinato %1",
  	"boost.getTiltAngle": "angolo inclinazione %1",
  	"boost.setLightHue": "porta colore luci a %1"
  };
  var dropdowns$D = {
  };
  var ignorelt$D = [
  ];
  var soundEffects$D = [
  	"frequenza",
  	"panning sinistra/destra"
  ];
  var microbitWhen$D = [
  	"si muove",
  	"si scuote",
  	"salta"
  ];
  var osis$D = [
  	"tutti gli altri script dello sprite"
  ];
  var definePrefix$D = [
  	"definisci"
  ];
  var defineSuffix$D = [
  ];
  var palette$D = {
  	Motion: "Movimento",
  	Looks: "Aspetto",
  	Sound: "Suono",
  	Events: "Situazioni",
  	Control: "Controllo",
  	Sensing: "Sensori",
  	Operators: "Operatori",
  	Variables: "Variabili",
  	"My Blocks": "I Miei Blocchi"
  };
  var math$D = [
  	"valore assoluto",
  	"intero inferiore",
  	"intero superiore",
  	"radice quadrata",
  	"sen",
  	"cos",
  	"tan",
  	"arcsen",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$D = {
  	"ruota in senso antiorario di %1 gradi": "MOTION_TURNLEFT",
  	"ruota in senso orario di %1 gradi": "MOTION_TURNRIGHT",
  	"quando si clicca sulla bandiera verde": "EVENT_WHENFLAGCLICKED",
  	fine: "scratchblocks:end"
  };
  var name$D = "Italiano";
  var percentTranslated$D = 100;
  var it = {
  	commands: commands$D,
  	dropdowns: dropdowns$D,
  	ignorelt: ignorelt$D,
  	soundEffects: soundEffects$D,
  	microbitWhen: microbitWhen$D,
  	osis: osis$D,
  	definePrefix: definePrefix$D,
  	defineSuffix: defineSuffix$D,
  	palette: palette$D,
  	math: math$D,
  	aliases: aliases$D,
  	name: name$D,
  	percentTranslated: percentTranslated$D
  };

  var commands$C = {
  	MOTION_MOVESTEPS: "%1 歩動かす",
  	MOTION_TURNRIGHT: "@turnRight %1 度回す",
  	MOTION_TURNLEFT: "@turnLeft %1 度回す",
  	MOTION_POINTINDIRECTION: "%1 度に向ける",
  	MOTION_POINTTOWARDS: "%1 へ向ける",
  	MOTION_GOTOXY: "x座標を %1 、y座標を %2 にする",
  	MOTION_GOTO: "%1 へ行く",
  	MOTION_GLIDESECSTOXY: "%1 秒でx座標を %2 に、y座標を %3 に変える",
  	MOTION_GLIDETO: "%1 秒で %2 へ行く",
  	MOTION_CHANGEXBY: "x座標を %1 ずつ変える",
  	MOTION_SETX: "x座標を %1 にする",
  	MOTION_CHANGEYBY: "y座標を %1 ずつ変える",
  	MOTION_SETY: "y座標を %1 にする",
  	MOTION_SETROTATIONSTYLE: "回転方法を %1 にする",
  	LOOKS_SAYFORSECS: "%1 と %2 秒言う",
  	LOOKS_SAY: "%1 と言う",
  	LOOKS_THINKFORSECS: "%1 と %2 秒考える",
  	LOOKS_THINK: "%1 と考える",
  	LOOKS_SHOW: "表示する",
  	LOOKS_HIDE: "隠す",
  	LOOKS_SWITCHCOSTUMETO: "コスチュームを %1 にする",
  	LOOKS_NEXTCOSTUME: "次のコスチュームにする",
  	LOOKS_NEXTBACKDROP_BLOCK: "次の背景にする",
  	LOOKS_SWITCHBACKDROPTO: "背景を %1 にする",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "背景を %1 にして待つ",
  	LOOKS_CHANGEEFFECTBY: "%1 の効果を %2 ずつ変える",
  	LOOKS_SETEFFECTTO: "%1 の効果を %2 にする",
  	LOOKS_CLEARGRAPHICEFFECTS: "画像効果をなくす",
  	LOOKS_CHANGESIZEBY: "大きさを %1 ずつ変える",
  	LOOKS_SETSIZETO: "大きさを %1 %にする",
  	LOOKS_GOTOFRONTBACK: "%1 へ移動する",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%2 層 %1",
  	SOUND_PLAY: "%1 の音を鳴らす",
  	SOUND_CHANGEEFFECTBY: "%1 の効果を %2 ずつ変える",
  	SOUND_SETEFFECTO: "%1 の効果を %2 にする",
  	SOUND_CLEAREFFECTS: "音の効果をなくす",
  	SOUND_PLAYUNTILDONE: "終わるまで %1 の音を鳴らす",
  	SOUND_STOPALLSOUNDS: "すべての音を止める",
  	"music.playDrumForBeats": "%1のドラムを%2拍鳴らす",
  	"music.restForBeats": "%1拍休む",
  	"music.playNoteForBeats": "%1の音符を%2拍鳴らす",
  	"music.setInstrument": "楽器を%1にする",
  	SOUND_CHANGEVOLUMEBY: "音量を %1 ずつ変える",
  	SOUND_SETVOLUMETO: "音量を %1 %にする",
  	"music.changeTempo": "テンポを%1ずつ変える",
  	"music.setTempo": "テンポを%1にする",
  	"pen.clear": "全部消す",
  	"pen.stamp": "スタンプ",
  	"pen.penDown": "ペンを下ろす",
  	"pen.penUp": "ペンを上げる",
  	"pen.setColor": "ペンの色を%1にする",
  	"pen.changeHue": "ペンの色を%1ずつ変える",
  	"pen.setColorParam": "ペンの%1を%2にする",
  	"pen.changeColorParam": "ペンの%1を%2ずつ変える",
  	"pen.setHue": "ペンの色を%1にする",
  	"pen.changeShade": "ペンの濃さを%1ずつ変える",
  	"pen.setShade": "ペンの濃さを%1にする",
  	"pen.changeSize": "ペンの太さを%1ずつ変える",
  	"pen.setSize": "ペンの太さを%1にする",
  	EVENT_WHENFLAGCLICKED: "@greenFlag が押されたとき",
  	EVENT_WHENKEYPRESSED: "%1 キーが押されたとき",
  	EVENT_WHENTHISSPRITECLICKED: "このスプライトが押されたとき",
  	EVENT_WHENSTAGECLICKED: "ステージが押されたとき",
  	EVENT_WHENBACKDROPSWITCHESTO: "背景が %1 になったとき",
  	EVENT_WHENGREATERTHAN: "%1 > %2 のとき",
  	EVENT_WHENBROADCASTRECEIVED: "%1 を受け取ったとき",
  	EVENT_BROADCAST: "%1 を送る",
  	EVENT_BROADCASTANDWAIT: "%1 を送って待つ",
  	CONTROL_WAIT: "%1 秒待つ",
  	CONTROL_REPEAT: "%1 回繰り返す",
  	CONTROL_FOREVER: "ずっと",
  	CONTROL_IF: "もし %1 なら",
  	CONTROL_WAITUNTIL: "%1 まで待つ",
  	CONTROL_REPEATUNTIL: "%1 まで繰り返す",
  	CONTROL_STOP: " %1",
  	CONTROL_STARTASCLONE: "クローンされたとき",
  	CONTROL_CREATECLONEOF: "%1 のクローンを作る",
  	CONTROL_DELETETHISCLONE: "このクローンを削除する",
  	SENSING_ASKANDWAIT: "%1 と聞いて待つ",
  	"videoSensing.videoToggle": "ビデオを%1にする",
  	"videoSensing.setVideoTransparency": "ビデオの透明度を%1にする",
  	"videoSensing.whenMotionGreaterThan": "ビデオモーション > %1のとき",
  	SENSING_RESETTIMER: "タイマーをリセット",
  	DATA_SETVARIABLETO: "%1 を %2 にする",
  	DATA_CHANGEVARIABLEBY: "%1 を %2 ずつ変える",
  	DATA_SHOWVARIABLE: "変数 %1 を表示する",
  	DATA_HIDEVARIABLE: "変数 %1 を隠す",
  	DATA_ADDTOLIST: "%1 を %2 に追加する",
  	DATA_DELETEOFLIST: "%2 の %1 番目を削除する",
  	DATA_DELETEALLOFLIST: "%1のすべてを削除する",
  	MOTION_IFONEDGEBOUNCE: "もし端に着いたら、跳ね返る",
  	DATA_INSERTATLIST: "%3 の %2 番目に %1 を挿入する",
  	DATA_REPLACEITEMOFLIST: "%2 の %1 番目を %3 で置き換える",
  	DATA_SHOWLIST: "リスト %1 を表示する",
  	DATA_HIDELIST: "リスト %1 を隠す",
  	SENSING_OF_XPOSITION: "x座標",
  	SENSING_OF_YPOSITION: "y座標",
  	SENSING_OF_DIRECTION: "向き",
  	SENSING_OF_COSTUMENUMBER: "コスチューム #",
  	LOOKS_COSTUMENUMBERNAME: "コスチュームの %1",
  	SENSING_OF_SIZE: "大きさ",
  	SENSING_OF_BACKDROPNAME: "背景の名前",
  	LOOKS_BACKDROPNUMBERNAME: "背景の %1",
  	SENSING_OF_BACKDROPNUMBER: "背景 #",
  	SOUND_VOLUME: "音量",
  	"music.getTempo": "テンポ",
  	SENSING_TOUCHINGOBJECT: "%1 に触れた",
  	SENSING_TOUCHINGCOLOR: "%1 色に触れた",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 色が %2 色に触れた",
  	SENSING_DISTANCETO: "%1 までの距離",
  	SENSING_ANSWER: "答え",
  	SENSING_KEYPRESSED: "%1 キーが押された",
  	SENSING_MOUSEDOWN: "マウスが押された",
  	SENSING_MOUSEX: "マウスのx座標",
  	SENSING_MOUSEY: "マウスのy座標",
  	SENSING_SETDRAGMODE: "ドラッグ %1 ようにする",
  	SENSING_LOUDNESS: "音量",
  	"videoSensing.videoOn": "%2のビデオの%1",
  	SENSING_TIMER: "タイマー",
  	SENSING_OF: "%2 の %1",
  	SENSING_CURRENT: "現在の %1",
  	SENSING_DAYSSINCE2000: "2000年からの日数",
  	SENSING_USERNAME: "ユーザー名",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 から %2 までの乱数",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 かつ %2",
  	OPERATORS_OR: "%1 または %2",
  	OPERATORS_NOT: "%1 ではない",
  	OPERATORS_JOIN: "%1 と %2",
  	OPERATORS_LETTEROF: "%2 の %1 番目の文字",
  	OPERATORS_LENGTH: "%1 の長さ",
  	OPERATORS_MOD: "%1 を %2 で割った余り",
  	OPERATORS_ROUND: "%1 を四捨五入",
  	OPERATORS_MATHOP: "%2 の %1",
  	OPERATORS_CONTAINS: "%1 に %2 が含まれる",
  	DATA_ITEMOFLIST: "%2 の %1 番目",
  	DATA_ITEMNUMOFLIST: "%2中の%1の場所",
  	DATA_LENGTHOFLIST: "%1 の長さ",
  	DATA_LISTCONTAINSITEM: "%1 に %2 が含まれる",
  	CONTROL_ELSE: "でなければ",
  	SENSING_USERID: "ユーザーID",
  	SENSING_LOUD: "うるさい",
  	"text2speech.speakAndWaitBlock": "%1としゃべる",
  	"text2speech.setVoiceBlock": "声を%1にする",
  	"text2speech.setLanguageBlock": "言語を%1にする",
  	"translate.translateBlock": "%1を%2に翻訳する",
  	"translate.viewerLanguage": "言語",
  	"makeymakey.whenKeyPressed": "%1キーが押されたとき",
  	"makeymakey.whenKeysPressedInOrder": "%1が順番に押されたとき",
  	"microbit.whenButtonPressed": "ボタン%1が押されたとき",
  	"microbit.isButtonPressed": "ボタン%1が押された",
  	"microbit.whenGesture": "%1とき",
  	"microbit.displaySymbol": "%1を表示する",
  	"microbit.displayText": "%1を表示する",
  	"microbit.clearDisplay": "画面を消す",
  	"microbit.whenTilted": "%1に傾いたとき",
  	"microbit.isTilted": "%1に傾いた",
  	"microbit.tiltAngle": "%1方向の傾き",
  	"microbit.whenPinConnected": "ピン%1がつながったとき",
  	"ev3.motorTurnClockwise": "モーター%1をこちら向きに%2秒間回す",
  	"ev3.motorTurnCounterClockwise": "モーター%1をあちら向きに%2秒間回す",
  	"ev3.motorSetPower": "モーター%1のパワーを%2%にする",
  	"ev3.getMotorPosition": "モーター%1の位置",
  	"ev3.whenButtonPressed": "ボタン%1が押されたとき",
  	"ev3.whenDistanceLessThan": "距離 < %1のとき",
  	"ev3.whenBrightnessLessThan": "明るさ < %1のとき",
  	"ev3.buttonPressed": "ボタン%1が押された",
  	"ev3.getDistance": "距離",
  	"ev3.getBrightness": "明るさ",
  	"ev3.beepNote": "%1の音符を%2秒鳴らす",
  	"wedo2.motorOn": "%1をオンにする",
  	"wedo2.motorOff": "%1をオフにする",
  	"wedo2.startMotorPower": "%1のパワーを%2にする",
  	"wedo2.setMotorDirection": "%1の方向を%2にする",
  	"wedo2.whenDistance": "距離%1%2のとき",
  	"wedo2.getDistance": "距離",
  	"wedo2.motorOnFor": "%1を%2秒間オンにする",
  	"wedo2.setLightHue": "ライトの色を%1にする",
  	"wedo2.playNoteFor": "%1の音符を%2秒間鳴らす",
  	"wedo2.whenTilted": "%1に傾いたとき",
  	"wedo2.isTilted": "%1に傾いた",
  	"wedo2.getTiltAngle": "%1方向の傾き",
  	"gdxfor.whenGesture": "%1とき",
  	"gdxfor.whenForcePushedOrPulled": "force sensorが%1とき",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "%1に傾いたとき",
  	"gdxfor.isTilted": "%1に傾いた",
  	"gdxfor.getTilt": "%1方向の傾き",
  	"gdxfor.isFreeFalling": "落下中",
  	"gdxfor.getSpin": "%1回転のはやさ",
  	"gdxfor.getAcceleration": "%1方向への加速度",
  	"boost.motorOnFor": "モーター%1を%2秒間オンにする",
  	"boost.motorOnForRotation": "モーター%1を%2回転させる",
  	"boost.motorOn": "モーター%1をオンにする",
  	"boost.motorOff": "モーター%1をオフにする",
  	"boost.setMotorPower": "モーター%1の速さを%2%にする",
  	"boost.setMotorDirection": "モーター%1の向きを%2にする",
  	"boost.getMotorPosition": "モーター%1の位置",
  	"boost.whenColor": "%1 を見たとき",
  	"boost.seeingColor": "%1 を見ている？",
  	"boost.whenTilted": "%1に傾いたとき",
  	"boost.getTiltAngle": "%1方向の傾き",
  	"boost.setLightHue": "ライトの色を%1にする"
  };
  var dropdowns$C = {
  };
  var ignorelt$C = [
  ];
  var soundEffects$C = [
  	"ピッチ",
  	"左右にパン"
  ];
  var microbitWhen$C = [
  	"動いた",
  	"振られた",
  	"ジャンプした"
  ];
  var osis$C = [
  	"スプライトの他のスクリプトを止める"
  ];
  var definePrefix$C = [
  	"定義"
  ];
  var defineSuffix$C = [
  ];
  var palette$C = {
  	Motion: "動き",
  	Looks: "見た目",
  	Sound: "音",
  	Events: "イベント",
  	Control: "制御",
  	Sensing: "調べる",
  	Operators: "演算",
  	Variables: "変数",
  	"My Blocks": "ブロック定義"
  };
  var math$C = [
  	"絶対値",
  	"切り下げ",
  	"切り上げ",
  	"平方根",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$C = {
  	"左に %1 度回す": "MOTION_TURNLEFT",
  	"反時計回りに %1 度回す": "MOTION_TURNLEFT",
  	"右に %1 度回す": "MOTION_TURNRIGHT",
  	"時計回りに %1 度回す": "MOTION_TURNRIGHT",
  	"緑の旗が押されたとき": "EVENT_WHENFLAGCLICKED",
  	"緑の旗がクリックされたとき": "EVENT_WHENFLAGCLICKED"
  };
  var name$C = "日本語";
  var percentTranslated$C = 100;
  var ja = {
  	commands: commands$C,
  	dropdowns: dropdowns$C,
  	ignorelt: ignorelt$C,
  	soundEffects: soundEffects$C,
  	microbitWhen: microbitWhen$C,
  	osis: osis$C,
  	definePrefix: definePrefix$C,
  	defineSuffix: defineSuffix$C,
  	palette: palette$C,
  	math: math$C,
  	aliases: aliases$C,
  	name: name$C,
  	percentTranslated: percentTranslated$C
  };

  var commands$B = {
  	MOTION_MOVESTEPS: "%1 ほうごかす",
  	MOTION_TURNRIGHT: "@turnRight %1 どまわす",
  	MOTION_TURNLEFT: "@turnLeft %1 どまわす",
  	MOTION_POINTINDIRECTION: "%1 どにむける",
  	MOTION_POINTTOWARDS: "%1 へむける",
  	MOTION_GOTOXY: "xざひょうを %1 、yざひょうを %2 にする",
  	MOTION_GOTO: "%1 へいく",
  	MOTION_GLIDESECSTOXY: "%1 びょうでxざひょうを %2 に、yざひょうを %3 にかえる",
  	MOTION_GLIDETO: "%1 びょうで %2 へいく",
  	MOTION_CHANGEXBY: "xざひょうを %1 ずつかえる",
  	MOTION_SETX: "xざひょうを %1 にする",
  	MOTION_CHANGEYBY: "yざひょうを %1 ずつかえる",
  	MOTION_SETY: "yざひょうを %1 にする",
  	MOTION_SETROTATIONSTYLE: "かいてんほうほうを %1 にする",
  	LOOKS_SAYFORSECS: "%1 と %2 びょういう",
  	LOOKS_SAY: "%1 という",
  	LOOKS_THINKFORSECS: "%1 と %2 びょうかんがえる",
  	LOOKS_THINK: "%1 とかんがえる",
  	LOOKS_SHOW: "ひょうじする",
  	LOOKS_HIDE: "かくす",
  	LOOKS_SWITCHCOSTUMETO: "コスチュームを %1 にする",
  	LOOKS_NEXTCOSTUME: "つぎのコスチュームにする",
  	LOOKS_NEXTBACKDROP_BLOCK: "つぎのはいけいにする",
  	LOOKS_SWITCHBACKDROPTO: "はいけいを %1 にする",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "はいけいを %1 にしてまつ",
  	LOOKS_CHANGEEFFECTBY: "%1 のこうかを %2 ずつかえる",
  	LOOKS_SETEFFECTTO: "%1 のこうかを %2 にする",
  	LOOKS_CLEARGRAPHICEFFECTS: "がぞうこうかをなくす",
  	LOOKS_CHANGESIZEBY: "おおきさを %1 ずつかえる",
  	LOOKS_SETSIZETO: "おおきさを %1 %にする",
  	LOOKS_GOTOFRONTBACK: "%1 へいどうする",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%2 そう %1",
  	SOUND_PLAY: "%1 のおとをならす",
  	SOUND_CHANGEEFFECTBY: "%1 のこうかを %2 ずつかえる",
  	SOUND_SETEFFECTO: "%1 のこうかを %2 にする",
  	SOUND_CLEAREFFECTS: "おとのこうかをなくす",
  	SOUND_PLAYUNTILDONE: "おわるまで %1 のおとをならす",
  	SOUND_STOPALLSOUNDS: "すべてのおとをとめる",
  	"music.playDrumForBeats": "%1のドラムを%2はくならす",
  	"music.restForBeats": "%1はくやすむ",
  	"music.playNoteForBeats": "%1のおんぷを%2はくならす",
  	"music.setInstrument": "がっきを%1にする",
  	SOUND_CHANGEVOLUMEBY: "おんりょうを %1 ずつかえる",
  	SOUND_SETVOLUMETO: "おんりょうを %1 %にする",
  	"music.changeTempo": "テンポを%1ずつかえる",
  	"music.setTempo": "テンポを%1にする",
  	"pen.clear": "ぜんぶけす",
  	"pen.stamp": "スタンプ",
  	"pen.penDown": "ペンをおろす",
  	"pen.penUp": "ペンをあげる",
  	"pen.setColor": "ペンのいろを%1にする",
  	"pen.changeHue": "ペンのいろを%1ずつかえる",
  	"pen.setColorParam": "ペンの%1を%2にする",
  	"pen.changeColorParam": "ペンの%1を%2ずつかえる",
  	"pen.setHue": "ペンのいろを%1にする",
  	"pen.changeShade": "ペンのこさを%1ずつかえる",
  	"pen.setShade": "ペンのこさを%1にする",
  	"pen.changeSize": "ペンのふとさを%1ずつかえる",
  	"pen.setSize": "ペンのふとさを%1にする",
  	EVENT_WHENFLAGCLICKED: "@greenFlag がおされたとき",
  	EVENT_WHENKEYPRESSED: "%1 キーがおされたとき",
  	EVENT_WHENTHISSPRITECLICKED: "このスプライトがおされたとき",
  	EVENT_WHENSTAGECLICKED: "ステージがおされたとき",
  	EVENT_WHENBACKDROPSWITCHESTO: "はいけいが %1 になったとき",
  	EVENT_WHENGREATERTHAN: "%1 > %2 のとき",
  	EVENT_WHENBROADCASTRECEIVED: "%1 をうけとったとき",
  	EVENT_BROADCAST: "%1 をおくる",
  	EVENT_BROADCASTANDWAIT: "%1 をおくってまつ",
  	CONTROL_WAIT: "%1 びょうまつ",
  	CONTROL_REPEAT: "%1 かいくりかえす",
  	CONTROL_FOREVER: "ずっと",
  	CONTROL_IF: "もし %1 なら",
  	CONTROL_WAITUNTIL: "%1 までまつ",
  	CONTROL_REPEATUNTIL: "%1 までくりかえす",
  	CONTROL_STOP: " %1",
  	CONTROL_STARTASCLONE: "クローンされたとき",
  	CONTROL_CREATECLONEOF: "%1 のクローンをつくる",
  	CONTROL_DELETETHISCLONE: "このクローンをさくじょする",
  	SENSING_ASKANDWAIT: "%1 ときいてまつ",
  	"videoSensing.videoToggle": "ビデオを%1にする",
  	"videoSensing.setVideoTransparency": "ビデオのとうめいどを%1にする",
  	"videoSensing.whenMotionGreaterThan": "ビデオモーション > %1のとき",
  	SENSING_RESETTIMER: "タイマーをリセット",
  	DATA_SETVARIABLETO: "%1 を %2 にする",
  	DATA_CHANGEVARIABLEBY: "%1 を %2 ずつかえる",
  	DATA_SHOWVARIABLE: "へんすう %1 をひょうじする",
  	DATA_HIDEVARIABLE: "へんすう %1 をかくす",
  	DATA_ADDTOLIST: "%1 を %2 についかする",
  	DATA_DELETEOFLIST: "%2 の %1 ばんめをさくじょする",
  	DATA_DELETEALLOFLIST: "%1のすべてをさくじょする",
  	MOTION_IFONEDGEBOUNCE: "もしはしについたら、はねかえる",
  	DATA_INSERTATLIST: "%3 の %2 ばんめに %1 をそうにゅうする",
  	DATA_REPLACEITEMOFLIST: "%2 の %1 ばんめを %3 でおきかえる",
  	DATA_SHOWLIST: "リスト %1 をひょうじする",
  	DATA_HIDELIST: "リスト %1 をかくす",
  	SENSING_OF_XPOSITION: "xざひょう",
  	SENSING_OF_YPOSITION: "yざひょう",
  	SENSING_OF_DIRECTION: "むき",
  	SENSING_OF_COSTUMENUMBER: "コスチューム #",
  	LOOKS_COSTUMENUMBERNAME: "コスチュームの %1",
  	SENSING_OF_SIZE: "おおきさ",
  	SENSING_OF_BACKDROPNAME: "はいけいのなまえ",
  	LOOKS_BACKDROPNUMBERNAME: "はいけいの %1",
  	SENSING_OF_BACKDROPNUMBER: "はいけい #",
  	SOUND_VOLUME: "おんりょう",
  	"music.getTempo": "テンポ",
  	SENSING_TOUCHINGOBJECT: "%1 にふれた",
  	SENSING_TOUCHINGCOLOR: "%1 いろにふれた",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 いろが %2 いろにふれた",
  	SENSING_DISTANCETO: "%1 までのきょり",
  	SENSING_ANSWER: "こたえ",
  	SENSING_KEYPRESSED: "%1 キーがおされた",
  	SENSING_MOUSEDOWN: "マウスがおされた",
  	SENSING_MOUSEX: "マウスのxざひょう",
  	SENSING_MOUSEY: "マウスのyざひょう",
  	SENSING_SETDRAGMODE: "ドラッグ %1 ようにする",
  	SENSING_LOUDNESS: "おんりょう",
  	"videoSensing.videoOn": "%2のビデオの%1",
  	SENSING_TIMER: "タイマー",
  	SENSING_OF: "%2 の %1",
  	SENSING_CURRENT: "げんざいの %1",
  	SENSING_DAYSSINCE2000: "2000ねんからのにっすう",
  	SENSING_USERNAME: "ユーザーめい",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 から %2 までのらんすう",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 かつ %2",
  	OPERATORS_OR: "%1 または %2",
  	OPERATORS_NOT: "%1 ではない",
  	OPERATORS_JOIN: "%1 と %2",
  	OPERATORS_LETTEROF: "%2 の %1 ばんめのもじ",
  	OPERATORS_LENGTH: "%1 のながさ",
  	OPERATORS_MOD: "%1 を %2 でわったあまり",
  	OPERATORS_ROUND: "%1 をししゃごにゅう",
  	OPERATORS_MATHOP: "%2 の %1",
  	OPERATORS_CONTAINS: "%1 に %2 がふくまれる",
  	DATA_ITEMOFLIST: "%2 の %1 ばんめ",
  	DATA_ITEMNUMOFLIST: "%2なかの%1のばしょ",
  	DATA_LENGTHOFLIST: "%1 のながさ",
  	DATA_LISTCONTAINSITEM: "%1 に %2 がふくまれる",
  	CONTROL_ELSE: "でなければ",
  	SENSING_USERID: "ユーザーID",
  	SENSING_LOUD: "うるさい",
  	"text2speech.speakAndWaitBlock": "%1としゃべる",
  	"text2speech.setVoiceBlock": "こえを%1にする",
  	"text2speech.setLanguageBlock": "げんごを%1にする",
  	"translate.translateBlock": "%1を%2にほんやくする",
  	"translate.viewerLanguage": "げんご",
  	"makeymakey.whenKeyPressed": "%1キーがおされたとき",
  	"makeymakey.whenKeysPressedInOrder": "%1 がじゅんばんにおされたとき",
  	"microbit.whenButtonPressed": "ボタン%1がおされたとき",
  	"microbit.isButtonPressed": "ボタン%1がおされた",
  	"microbit.whenGesture": "%1とき",
  	"microbit.displaySymbol": "%1をひょうじする",
  	"microbit.displayText": "%1をひょうじする",
  	"microbit.clearDisplay": "がめんをけす",
  	"microbit.whenTilted": "%1にかたむいたとき",
  	"microbit.isTilted": "%1にかたむいた",
  	"microbit.tiltAngle": "%1ほうこうのかたむき",
  	"microbit.whenPinConnected": "ピン%1がつながったとき",
  	"ev3.motorTurnClockwise": "モーター%1をこちらむきに%2びょうかんまわす",
  	"ev3.motorTurnCounterClockwise": "モーター%1をあちらむきに%2びょうかんまわす",
  	"ev3.motorSetPower": "モーター%1のパワーを%2%にする",
  	"ev3.getMotorPosition": "モーター%1のいち",
  	"ev3.whenButtonPressed": "ボタン%1がおされたとき",
  	"ev3.whenDistanceLessThan": "きょり < %1のとき",
  	"ev3.whenBrightnessLessThan": "あかるさ < %1のとき",
  	"ev3.buttonPressed": "ボタン%1がおされた",
  	"ev3.getDistance": "きょり",
  	"ev3.getBrightness": "あかるさ",
  	"ev3.beepNote": "%1のおんぷを%2びょうならす",
  	"wedo2.motorOn": "%1をオンにする",
  	"wedo2.motorOff": "%1をオフにする",
  	"wedo2.startMotorPower": "%1のパワーを%2にする",
  	"wedo2.setMotorDirection": "%1のほうこうを%2にする",
  	"wedo2.whenDistance": "きょり%1%2のとき",
  	"wedo2.getDistance": "きょり",
  	"wedo2.motorOnFor": "%1を%2びょうかんオンにする",
  	"wedo2.setLightHue": "ライトのいろを%1にする",
  	"wedo2.playNoteFor": "%1のおんぷを%2びょうかんならす",
  	"wedo2.whenTilted": "%1にかたむいたとき",
  	"wedo2.isTilted": "%1にかたむいた",
  	"wedo2.getTiltAngle": "%1ほうこうのかたむき",
  	"gdxfor.whenGesture": "%1とき",
  	"gdxfor.whenForcePushedOrPulled": "ちからのセンサーが%1とき",
  	"gdxfor.getForce": "ちから",
  	"gdxfor.whenTilted": "%1にかたむいたとき",
  	"gdxfor.isTilted": "%1にかたむいた",
  	"gdxfor.getTilt": "%1ほうこうのかたむき",
  	"gdxfor.isFreeFalling": "らっかちゅう",
  	"gdxfor.getSpin": "%1かいてんのはやさ",
  	"gdxfor.getAcceleration": "%1のかそく",
  	"boost.motorOnFor": "モーター%1を%2びょうかんオンにする",
  	"boost.motorOnForRotation": "モーター%1を%2かいてんさせる",
  	"boost.motorOn": "モーター%1をオンにする",
  	"boost.motorOff": "モーター%1をオフにする",
  	"boost.setMotorPower": "モーター%1のはやさを%2%にする",
  	"boost.setMotorDirection": "モーター%1のむきを%2にする",
  	"boost.getMotorPosition": "モーター%1のいち",
  	"boost.whenColor": "%1 をみたとき",
  	"boost.seeingColor": "%1 をみている？",
  	"boost.whenTilted": "%1にかたむいたとき",
  	"boost.getTiltAngle": "%1ほうこうのかたむき",
  	"boost.setLightHue": "ライトのいろを%1にする"
  };
  var dropdowns$B = {
  };
  var ignorelt$B = [
  ];
  var soundEffects$B = [
  	"ピッチ",
  	"さゆうにパン"
  ];
  var microbitWhen$B = [
  	"うごいた",
  	"ふられた",
  	"ジャンプした"
  ];
  var osis$B = [
  	"スプライトのほかのスクリプトをとめる"
  ];
  var definePrefix$B = [
  	"ていぎ"
  ];
  var defineSuffix$B = [
  ];
  var palette$B = {
  	Motion: "うごき",
  	Looks: "みため",
  	Sound: "おと",
  	Events: "イベント",
  	Control: "せいぎょ",
  	Sensing: "しらべる",
  	Operators: "えんざん",
  	Variables: "へんすう",
  	"My Blocks": "ブロックていぎ"
  };
  var math$B = [
  	"ぜったいち",
  	"きりさげ",
  	"きりあげ",
  	"へいほうこん",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$B = {
  	"ひだりに %1 どまわす": "MOTION_TURNLEFT",
  	"はんとけいまわりに %1 どまわす": "MOTION_TURNLEFT",
  	"みぎに %1 どまわす": "MOTION_TURNRIGHT",
  	"とけいまわりに %1 どまわす": "MOTION_TURNRIGHT",
  	"みどりのはたがおされたとき": "EVENT_WHENFLAGCLICKED",
  	"みどりのはたがクリックされたとき": "EVENT_WHENFLAGCLICKED"
  };
  var name$B = "にほんご";
  var percentTranslated$B = 100;
  var ja_Hira = {
  	commands: commands$B,
  	dropdowns: dropdowns$B,
  	ignorelt: ignorelt$B,
  	soundEffects: soundEffects$B,
  	microbitWhen: microbitWhen$B,
  	osis: osis$B,
  	definePrefix: definePrefix$B,
  	defineSuffix: defineSuffix$B,
  	palette: palette$B,
  	math: math$B,
  	aliases: aliases$B,
  	name: name$B,
  	percentTranslated: percentTranslated$B
  };

  var commands$A = {
  	MOTION_MOVESTEPS: "გადადგი %1 ნაბიჯი",
  	MOTION_TURNRIGHT: "მობრუნდი @turnRight %1 გრადუსით",
  	MOTION_TURNLEFT: "მობრუნდი @turnLeft %1 გრადუსით",
  	MOTION_POINTINDIRECTION: "მიუთითე %1 მიმართულებით",
  	MOTION_POINTTOWARDS: "მიუთითე %1",
  	MOTION_GOTOXY: "გადადი x: %1 y:%2",
  	MOTION_GOTO: "გადადი %1",
  	MOTION_GLIDESECSTOXY: "ისრიალე %1 წმ x:%2 y:%3კენ",
  	MOTION_GLIDETO: "ისრიალე %1 წმ %2",
  	MOTION_CHANGEXBY: "შეცვალე x %1ით",
  	MOTION_SETX: "მიანიჭე x-ს %1",
  	MOTION_CHANGEYBY: "შეცვალე y %1ით",
  	MOTION_SETY: "მიანიჭე y-ს %1",
  	MOTION_SETROTATIONSTYLE: "ბრუნვის წესი %1",
  	LOOKS_SAYFORSECS: "თქვი %1 %2 წამით",
  	LOOKS_SAY: "თქვი %1",
  	LOOKS_THINKFORSECS: "იფიქრე %1 %2 წამით",
  	LOOKS_THINK: "იფიქრე %1",
  	LOOKS_SHOW: "გამოჩნდი",
  	LOOKS_HIDE: "დაიმალე",
  	LOOKS_SWITCHCOSTUMETO: "გადაერთე კოსტიუმზე %1",
  	LOOKS_NEXTCOSTUME: "მომდევნო კოსტიუმი",
  	LOOKS_NEXTBACKDROP_BLOCK: "მომდევნო ფონი",
  	LOOKS_SWITCHBACKDROPTO: "გადაერთე ფონზე %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "გადაერთე ფონზე %1 და იცადე",
  	LOOKS_CHANGEEFFECTBY: "შეცვალე%1ეფექტი%2ით",
  	LOOKS_SETEFFECTTO: "დააყენე %1 ეფექტი %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "გრაფიკული ეფექტების მოხსნა",
  	LOOKS_CHANGESIZEBY: "შეცვალე ზომა %1ით",
  	LOOKS_SETSIZETO: "დააყენე ზომა %1 %",
  	LOOKS_GOTOFRONTBACK: "გადადი %1 შრეზე",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "გადადი %1 %2 შრით",
  	SOUND_PLAY: "ჩართე ხმა %1",
  	SOUND_CHANGEEFFECTBY: "შეცვალე%1ეფექტი%2ით",
  	SOUND_SETEFFECTO: "დააყენე%1ეფექტი%2",
  	SOUND_CLEAREFFECTS: "ხმის ეფექტების მოხსნა",
  	SOUND_PLAYUNTILDONE: "დაუკარი ხმა %1 დასრულებამდე",
  	SOUND_STOPALLSOUNDS: "გამორთე ყველა ხმა",
  	"music.playDrumForBeats": "დაუკარი დოლი %1  %2 ბიტით",
  	"music.restForBeats": "პაუზა %1 ბიტით",
  	"music.playNoteForBeats": "დაუკარი ნოტა %1  %2 ბიტით",
  	"music.setInstrument": "აირჩიე ინსტრუმენტი %1",
  	SOUND_CHANGEVOLUMEBY: "შეცვლე ხმის სიმაღლე %1ით",
  	SOUND_SETVOLUMETO: "ხმის სიმაღლე %1%",
  	"music.changeTempo": "შეცვალე ტემპი %1-ით",
  	"music.setTempo": "დააყენე ტემპი %1",
  	"pen.clear": "წაშალე ყველაფერი",
  	"pen.stamp": "ბეჭდვა",
  	"pen.penDown": "კალამი ქვევით",
  	"pen.penUp": "კალამი ზევით",
  	"pen.setColor": "დააყენე კალმის ფერი %1",
  	"pen.changeHue": "შეცვალე კალმის ფერი %1-თი",
  	"pen.setColorParam": "დააყენე კალმის %1  %2",
  	"pen.changeColorParam": "შეცვალე კალმის %1  %2-ით",
  	"pen.setHue": "დააყენე კალმის ფერი %1",
  	"pen.changeShade": "შეცვალე კალმის ელფერი %1-ით",
  	"pen.setShade": "დააყენე კალმის ელფერი %1",
  	"pen.changeSize": "შეცვალე კალმის ზომა %1-ით",
  	"pen.setSize": "დააყენე კალმის ზომა %1",
  	EVENT_WHENFLAGCLICKED: "როდესაც აჭერ @greenFlag",
  	EVENT_WHENKEYPRESSED: "როდესაც აჭერ ღილაკს %1",
  	EVENT_WHENTHISSPRITECLICKED: "როდესაც აჭერ ამ სპრაიტს",
  	EVENT_WHENSTAGECLICKED: "როდესაც აჭერ სცენას",
  	EVENT_WHENBACKDROPSWITCHESTO: "როდესაც ფონი ხდება %1",
  	EVENT_WHENGREATERTHAN: "როდესაც %1 >%2",
  	EVENT_WHENBROADCASTRECEIVED: "როდესაც ვიღებ %1ს",
  	EVENT_BROADCAST: "გადაეცი %1",
  	EVENT_BROADCASTANDWAIT: "გადაეცი %1 და იცადე",
  	CONTROL_WAIT: "იცადე %1 წამი",
  	CONTROL_REPEAT: "გაიმეორე %1ჯერ",
  	CONTROL_FOREVER: "მუდმივად",
  	CONTROL_IF: "თუ %1 მაშინ",
  	CONTROL_WAITUNTIL: "იცადე მანამ %1",
  	CONTROL_REPEATUNTIL: "გაიმეორე მანამ %1",
  	CONTROL_STOP: "გააჩერე %1",
  	CONTROL_STARTASCLONE: "როდესაც მე ვიწყებ როგორც კლონი",
  	CONTROL_CREATECLONEOF: "შექმენი  %1ს კლონი",
  	CONTROL_DELETETHISCLONE: "წაშალე ეს კლონი",
  	SENSING_ASKANDWAIT: "იკითხე %1 და იცადე",
  	"videoSensing.videoToggle": "ჩართე ვიდეო %1",
  	"videoSensing.setVideoTransparency": "დააყენე ვიდეოს გამჭვირვალობა %1",
  	"videoSensing.whenMotionGreaterThan": "როდესაც ვიდეო მოძრაობა > %1",
  	SENSING_RESETTIMER: "წამზომის განულება",
  	DATA_SETVARIABLETO: "მიანიჭე %1ს %2",
  	DATA_CHANGEVARIABLEBY: "შეცვალე %1 %2ით",
  	DATA_SHOWVARIABLE: "გამოაჩინე ცვლადი %1",
  	DATA_HIDEVARIABLE: "დამალე ცვლადი %1",
  	DATA_ADDTOLIST: "დაუმატე %1 %2ს",
  	DATA_DELETEOFLIST: "წაშალე %1 %2დან",
  	DATA_DELETEALLOFLIST: "წაშალე ყველაფერი %1დან",
  	MOTION_IFONEDGEBOUNCE: "ზღვარზე უკანდახევა",
  	DATA_INSERTATLIST: "ჩასვი %1 %2მდე %3ში",
  	DATA_REPLACEITEMOFLIST: "შეცვალე %1 %2დან %3ით",
  	DATA_SHOWLIST: "გამოაჩინე სია %1",
  	DATA_HIDELIST: "დამალე სია %1",
  	SENSING_OF_XPOSITION: "x მდებარეობა",
  	SENSING_OF_YPOSITION: "y მდებარეობა",
  	SENSING_OF_DIRECTION: "მიმართულება",
  	SENSING_OF_COSTUMENUMBER: "კოსტიუმის ნომერი",
  	LOOKS_COSTUMENUMBERNAME: "კოსტიუმი %1",
  	SENSING_OF_SIZE: "ზომა",
  	SENSING_OF_BACKDROPNAME: "ფონის სახელი",
  	LOOKS_BACKDROPNUMBERNAME: "ფონი %1",
  	SENSING_OF_BACKDROPNUMBER: "ფონის ნომერი",
  	SOUND_VOLUME: "ხმის სიმაღლე",
  	"music.getTempo": "ტემპი",
  	SENSING_TOUCHINGOBJECT: "ეხება %1?",
  	SENSING_TOUCHINGCOLOR: "ეხება ფერს %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "ფერი %1 ეხება %2ს?",
  	SENSING_DISTANCETO: "მანძილი %1",
  	SENSING_ANSWER: "პასუხი",
  	SENSING_KEYPRESSED: "ღილაკი %1 დაჭერილია?",
  	SENSING_MOUSEDOWN: "თაგვი დაჭერილია?",
  	SENSING_MOUSEX: "თაგვი x",
  	SENSING_MOUSEY: "თაგვი y",
  	SENSING_SETDRAGMODE: "გადატანის წესი %1",
  	SENSING_LOUDNESS: "ხმის სიმაღლე",
  	"videoSensing.videoOn": "ვიდეო %1 %2",
  	SENSING_TIMER: "წამზომი",
  	SENSING_OF: "%2ს %1",
  	SENSING_CURRENT: "მიმდინარე %1",
  	SENSING_DAYSSINCE2000: "2000-ის შემდგომი დღეები",
  	SENSING_USERNAME: "მომხმარებელი",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1-%2",
  	OPERATORS_MULTIPLY: "%1*%2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "შემთხვევითი %1დან %2მდე",
  	OPERATORS_LT: "%1<%2",
  	OPERATORS_EQUALS: "%1=%2",
  	OPERATORS_GT: "%1>%2",
  	OPERATORS_AND: "%1 და %2",
  	OPERATORS_OR: "%1 ან %2",
  	OPERATORS_NOT: "არა %1",
  	OPERATORS_JOIN: "შეაერთე %1 %2",
  	OPERATORS_LETTEROF: "ასო %1 %2დან",
  	OPERATORS_LENGTH: "%1ს სიგრძე",
  	OPERATORS_MOD: "%1 მოდული %2",
  	OPERATORS_ROUND: "დაამრგვალე %1",
  	OPERATORS_MATHOP: "%2ს %1",
  	OPERATORS_CONTAINS: "%1 შეიცავს %2ს?",
  	DATA_ITEMOFLIST: "ელემენტი %1 %2დან",
  	DATA_ITEMNUMOFLIST: "%1 ელემენტის № %2ში",
  	DATA_LENGTHOFLIST: "%1ს სიგრძე",
  	DATA_LISTCONTAINSITEM: "%1 შეიცავს %2ს?",
  	CONTROL_ELSE: "სხვა შემთხვევაში",
  	SENSING_USERID: "მომხმარებლის id",
  	SENSING_LOUD: "ხმა მაღალია?",
  	"text2speech.speakAndWaitBlock": "თქვი %1",
  	"text2speech.setVoiceBlock": "აირჩიე ხმა %1",
  	"text2speech.setLanguageBlock": "აირჩიე ენა %1",
  	"translate.translateBlock": "თარგმნე %1 %2-ად",
  	"translate.viewerLanguage": "ენა",
  	"makeymakey.whenKeyPressed": "როდესაც %1 ღილაკი დაჭერილია",
  	"makeymakey.whenKeysPressedInOrder": "როდესაც %1 რიგითაა დაჭერილი",
  	"microbit.whenButtonPressed": "როდესაც %1 ღილაკი დაჭერილია",
  	"microbit.isButtonPressed": "%1 ღილაკი დაჭერილია?",
  	"microbit.whenGesture": "როდესაც %1",
  	"microbit.displaySymbol": "ეკრანი %1",
  	"microbit.displayText": "აჩვენე ტექსტი %1",
  	"microbit.clearDisplay": "გაწმინდე ეკრანი",
  	"microbit.whenTilted": "როდესაც დახრილია %1",
  	"microbit.isTilted": "გადაიხარა %1?",
  	"microbit.tiltAngle": "დახრის კუთხე %1",
  	"microbit.whenPinConnected": "როდესაც კონტაქტი %1 ჩართულია",
  	"ev3.motorTurnClockwise": "ძრავა %1 აბრუნე აქეთ %2 წამი",
  	"ev3.motorTurnCounterClockwise": "ძრავა %1 აბრუნე იქით %2 წამი",
  	"ev3.motorSetPower": "ძრავას %1 დაუყენე სიმძლავრე %2 %",
  	"ev3.getMotorPosition": "ძრავის მდგომარეობა %1",
  	"ev3.whenButtonPressed": "როდესაც ღილაკი %1 დაჭერილია",
  	"ev3.whenDistanceLessThan": "როდესაც მანძილი < %1",
  	"ev3.whenBrightnessLessThan": "როდესაც სიკაშკაშე < %1",
  	"ev3.buttonPressed": "ღილაკი %1 დაჭერილია?",
  	"ev3.getDistance": "მანძილი",
  	"ev3.getBrightness": "სიკაშკაშე",
  	"ev3.beepNote": "დაუკარი ნოტა %1 %2 წამი",
  	"wedo2.motorOn": "ჩართე %1",
  	"wedo2.motorOff": "გამორთე %1",
  	"wedo2.startMotorPower": "დააყენე %1-ის ძალა %2",
  	"wedo2.setMotorDirection": "დააყენე %1-ის მიმართულება %2",
  	"wedo2.whenDistance": "როდესაც მანძილი %1 %2",
  	"wedo2.getDistance": "მანძილი",
  	"wedo2.motorOnFor": "ჩართე ძრავა %1 %2 წამით",
  	"wedo2.setLightHue": "დააყენე ნათურის ფერი %1",
  	"wedo2.playNoteFor": "დაუკარი ნოტა %1 %2 წამი",
  	"wedo2.whenTilted": "როდესაც დახრილია %1",
  	"wedo2.isTilted": "დახრილია %1?",
  	"wedo2.getTiltAngle": "დახრის კუთხე %1",
  	"gdxfor.whenGesture": "როდესაც %1",
  	"gdxfor.whenForcePushedOrPulled": "როდესაც ძალის სენსორი %1",
  	"gdxfor.getForce": "ძალა",
  	"gdxfor.whenTilted": "როდესაც დახრილია %1",
  	"gdxfor.isTilted": "დახრილია %1?",
  	"gdxfor.getTilt": "დახრის კუთხე %1",
  	"gdxfor.isFreeFalling": "ვარდება?",
  	"gdxfor.getSpin": "ბრუნვის სიჩქარე %1",
  	"gdxfor.getAcceleration": "აჩქარება %1",
  	"boost.motorOnFor": "ჩართე ძრავა %1 %2 წამით",
  	"boost.motorOnForRotation": "ჩართე ძრავა %1 %2 ბრუნით",
  	"boost.motorOn": "ჩართე ძრავა %1",
  	"boost.motorOff": "გამორთე ძრავა %1",
  	"boost.setMotorPower": "დააყენე ძრავის %1 სიჩქარე %2 %",
  	"boost.setMotorDirection": "დააყენე ძრავის %1 მიმართულება %2",
  	"boost.getMotorPosition": "ძრავის %1 მდგომარეობა",
  	"boost.whenColor": "როდესაც ხედავ %1 აგურს",
  	"boost.seeingColor": "ხედავ %1 აგურს?",
  	"boost.whenTilted": "როდესაც დახრილია %1",
  	"boost.getTiltAngle": "დახრის კუთხე %1",
  	"boost.setLightHue": "დააყენე ნათურის ფერი %1"
  };
  var dropdowns$A = {
  };
  var ignorelt$A = [
  ];
  var soundEffects$A = [
  	"ბგერის სიმაღლე",
  	"ხმა მარცხნიდან/მარჯვნიდან"
  ];
  var microbitWhen$A = [
  	"გადაადგილდა",
  	"შეირხა",
  	"გადახტა"
  ];
  var osis$A = [
  	"სპრაიტის სხვა სკრიპტები"
  ];
  var definePrefix$A = [
  	"განსაზღვრე"
  ];
  var defineSuffix$A = [
  ];
  var palette$A = {
  	Motion: "მოძრაობა",
  	Looks: "გარეგნობა",
  	Sound: "ხმა",
  	Events: "მოვლენები",
  	Control: "მართვა",
  	Sensing: "სენსორები",
  	Operators: "ოპერატორები",
  	Variables: "ცვლადები",
  	"My Blocks": "ჩემი ბლოკები"
  };
  var math$A = [
  	"abs",
  	"უმცირესი მთელი",
  	"უდიდესი მთელი",
  	"კვადრატული ფესვი",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10^"
  ];
  var aliases$A = {
  };
  var name$A = "ქართული ენა";
  var percentTranslated$A = 100;
  var ka = {
  	commands: commands$A,
  	dropdowns: dropdowns$A,
  	ignorelt: ignorelt$A,
  	soundEffects: soundEffects$A,
  	microbitWhen: microbitWhen$A,
  	osis: osis$A,
  	definePrefix: definePrefix$A,
  	defineSuffix: defineSuffix$A,
  	palette: palette$A,
  	math: math$A,
  	aliases: aliases$A,
  	name: name$A,
  	percentTranslated: percentTranslated$A
  };

  var commands$z = {
  	MOTION_MOVESTEPS: "%1 қадамға жылжу",
  	MOTION_TURNRIGHT: "@turnRightді %1ге градусқа бұру",
  	MOTION_TURNLEFT: "@turnLeftді %1ге градусқа бұру",
  	MOTION_POINTINDIRECTION: "%1 бағытына бұру",
  	MOTION_POINTTOWARDS: "%1 бағытында",
  	MOTION_GOTOXY: "x: %1 y:%2 бару",
  	MOTION_GOTO: "%1ге бару",
  	MOTION_GLIDESECSTOXY: "%1 секунд бойы x: %2 y: %3ке сырғу",
  	MOTION_GLIDETO: "%2ге %1 секунд бойы сырғу",
  	MOTION_CHANGEXBY: "x мәнін %1ге өзгерту",
  	MOTION_SETX: "x-қа %1 мәнін беру",
  	MOTION_CHANGEYBY: "y-ті %1ге өзгерту",
  	MOTION_SETY: "y-ке %1 мәнін беру",
  	MOTION_SETROTATIONSTYLE: "бұрылу стиліне %1 мәнін беру",
  	LOOKS_SAYFORSECS: "%2 секунд бойы %1 айту",
  	LOOKS_SAY: "%1 де",
  	LOOKS_THINKFORSECS: "%2 секунд бойы %1 ойла",
  	LOOKS_THINK: "%1 ойла",
  	LOOKS_SHOW: "көрсету",
  	LOOKS_HIDE: "жасыру",
  	LOOKS_SWITCHCOSTUMETO: "киімін %1ге ауыстыру",
  	LOOKS_NEXTCOSTUME: "келесі костюм",
  	LOOKS_NEXTBACKDROP_BLOCK: "келесі фон",
  	LOOKS_SWITCHBACKDROPTO: "аясын %1ге ауыстыру",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "аясын %1ге ауыстырып күту",
  	LOOKS_CHANGEEFFECTBY: "%1 әсерін %2ге өзерту",
  	LOOKS_SETEFFECTTO: "%2ге %1 әсерін беру",
  	LOOKS_CLEARGRAPHICEFFECTS: "сызбалық әсерлерді тазалау",
  	LOOKS_CHANGESIZEBY: "өлшемді %1ге өзгерту",
  	LOOKS_SETSIZETO: "өлшем мәніне %1 беру",
  	LOOKS_GOTOFRONTBACK: "%1 қабатына бару",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 қабаттарына бару",
  	SOUND_PLAY: "%1 дыбысын баста",
  	SOUND_CHANGEEFFECTBY: "%1 әсерін %2ге өзерту",
  	SOUND_SETEFFECTO: "%2ге %1 әсерін беру",
  	SOUND_CLEAREFFECTS: "дыбыс эффектерін жою",
  	SOUND_PLAYUNTILDONE: "%1 дыбысын ақталғанша ойна",
  	SOUND_STOPALLSOUNDS: "Дыбыстардың барлығын тоқтатыңыз",
  	"music.playDrumForBeats": "%1  дабылында %2  такт ойнау",
  	"music.restForBeats": "%1  такт күту",
  	"music.playNoteForBeats": "%1  нотасында %2  такт ойнау",
  	"music.setInstrument": "%1 аспабын орнату",
  	SOUND_CHANGEVOLUMEBY: "мәнін %1-ге өзгерту",
  	SOUND_SETVOLUMETO: "дыбыс күштілігін %1% орнату",
  	"music.changeTempo": "темпті %1 өзгерткенде",
  	"music.setTempo": "Ырғақты %1 орнатыңыз",
  	"pen.clear": "Бәрін өшіру",
  	"pen.stamp": "марка",
  	"pen.penDown": "қауырсынды түсіру",
  	"pen.penUp": "қауырсынды көтеру",
  	"pen.setColor": "қаламның түсін %1 орнату",
  	"pen.changeHue": "қаламның түсін %1  өзгерту",
  	"pen.setColorParam": "%1 қаламның түсін  %2 бойынша орнату",
  	"pen.changeColorParam": "%1  қаламның түсін  %2 бойынша өзгерту",
  	"pen.setHue": "қаламның түсін  %1 орнату",
  	"pen.changeShade": "қалам реңін %1 өзгерту",
  	"pen.setShade": "қалам реңін %1 өзгерту",
  	"pen.changeSize": "қаламның өлшемін %1 өзгерту",
  	"pen.setSize": "қаламның өлшемін %1 орнату",
  	EVENT_WHENFLAGCLICKED: "@greenFlag басылғанда",
  	EVENT_WHENKEYPRESSED: "%1 пернесі басылғанда",
  	EVENT_WHENTHISSPRITECLICKED: "спрайт басылған кезде",
  	EVENT_WHENSTAGECLICKED: "сахна басылғанда",
  	EVENT_WHENBACKDROPSWITCHESTO: "аясы %1ге ауысқанда",
  	EVENT_WHENGREATERTHAN: "%1>%2 болғанда",
  	EVENT_WHENBROADCASTRECEIVED: "маған %1 келгенде",
  	EVENT_BROADCAST: "%1ді тарату",
  	EVENT_BROADCASTANDWAIT: "%1ді таратып күту",
  	CONTROL_WAIT: "%1 секунд күту",
  	CONTROL_REPEAT: "%1 рет қайталау",
  	CONTROL_FOREVER: "әрқашан",
  	CONTROL_IF: "егер %1, онда",
  	CONTROL_WAITUNTIL: "%1 секундка дейін күту",
  	CONTROL_REPEATUNTIL: "%1 болғанға дейін қайталау",
  	CONTROL_STOP: "тоқтату %1",
  	CONTROL_STARTASCLONE: "мен клон ретінде бастағанда",
  	CONTROL_CREATECLONEOF: "%1 клонын жасау",
  	CONTROL_DELETETHISCLONE: "бұл клонды жою",
  	SENSING_ASKANDWAIT: "%1ден сұра да күт",
  	"videoSensing.videoToggle": "%1 видеоны іске қосу",
  	"videoSensing.setVideoTransparency": "бейне ашықтығын %1  орнату",
  	"videoSensing.whenMotionGreaterThan": "видео қозғалысы > %1",
  	SENSING_RESETTIMER: "таймерді қайта іске қосу",
  	DATA_SETVARIABLETO: "%2ге %1ді орнату",
  	DATA_CHANGEVARIABLEBY: "%1ді %2ге өзгерту",
  	DATA_SHOWVARIABLE: "%1 айнымалысын көрсету",
  	DATA_HIDEVARIABLE: "%1 айнымалысын жасыру",
  	DATA_ADDTOLIST: "%1ге %2ні қосу",
  	DATA_DELETEOFLIST: "%2ден %1ді алу",
  	DATA_DELETEALLOFLIST: "%1 түгел жою",
  	MOTION_IFONEDGEBOUNCE: "шетте болса, әрі итерілу",
  	DATA_INSERTATLIST: "%3тің %2сіне %1ді салу",
  	DATA_REPLACEITEMOFLIST: "%2нің %1ін %3пен алмастыру",
  	DATA_SHOWLIST: "%1 тізімін көрсет",
  	DATA_HIDELIST: "%1 тізімін жасыр",
  	SENSING_OF_XPOSITION: "x орны",
  	SENSING_OF_YPOSITION: "y орны",
  	SENSING_OF_DIRECTION: "бағыт",
  	SENSING_OF_COSTUMENUMBER: "костюм #",
  	LOOKS_COSTUMENUMBERNAME: "%1 киімі",
  	SENSING_OF_SIZE: "өлшем",
  	SENSING_OF_BACKDROPNAME: "фонның аты",
  	LOOKS_BACKDROPNUMBERNAME: "%1 аясы",
  	SENSING_OF_BACKDROPNUMBER: "фон #",
  	SOUND_VOLUME: "Дыбыс",
  	"music.getTempo": "Дыбыс ырғағы",
  	SENSING_TOUCHINGOBJECT: "%1ге тиді ме?",
  	SENSING_TOUCHINGCOLOR: "%1 түсіне тиді ме?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 түсі %2ге тиді ме?",
  	SENSING_DISTANCETO: "%1 дейінгі қашықтық",
  	SENSING_ANSWER: "жауап",
  	SENSING_KEYPRESSED: "%1 пернесі басылды ма?",
  	SENSING_MOUSEDOWN: "тінтуір басылған ба?",
  	SENSING_MOUSEX: "тінтуір x бойынша",
  	SENSING_MOUSEY: "тінтуір y бойынша",
  	SENSING_SETDRAGMODE: "%1 тарту күйін орнату",
  	SENSING_LOUDNESS: "дыбыс қаттылығы",
  	"videoSensing.videoOn": "%2-тегі видео %1",
  	SENSING_TIMER: "таймер",
  	SENSING_OF: "%2нің %1і",
  	SENSING_CURRENT: "ағымдағы %1",
  	SENSING_DAYSSINCE2000: "2000-шы жылдан бастап күндер",
  	SENSING_USERNAME: "пайдаланушының аты",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 мен %2 аралығындағы кездейсоқ санды таңда",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 and %2",
  	OPERATORS_OR: "%1 немесе %2",
  	OPERATORS_NOT: "%1 емес",
  	OPERATORS_JOIN: "%1 %2 біріктіру",
  	OPERATORS_LETTEROF: "%2нің %1 әрібі",
  	OPERATORS_LENGTH: "%1дің ұзындығы",
  	OPERATORS_MOD: "%1 қб %2",
  	OPERATORS_ROUND: "%1ді дөңгелекте",
  	OPERATORS_MATHOP: "%2нің %1і",
  	OPERATORS_CONTAINS: "%1де %2 бар ма?",
  	DATA_ITEMOFLIST: "%2нің %1і",
  	DATA_ITEMNUMOFLIST: "%2дегі %1 мүшесінің #",
  	DATA_LENGTHOFLIST: "%1дің ұзындығы",
  	DATA_LISTCONTAINSITEM: "%1де %2 бар ма?",
  	CONTROL_ELSE: "әйтпесе",
  	SENSING_USERID: "қолданушы id",
  	SENSING_LOUD: "дауысу тым жоғары ма?",
  	"text2speech.speakAndWaitBlock": "%1 айту",
  	"text2speech.setVoiceBlock": "дауысты  %1 орнату",
  	"text2speech.setLanguageBlock": "тілді %1 орнату",
  	"translate.translateBlock": "%1 %2 тіліне аудару",
  	"translate.viewerLanguage": "тіл",
  	"makeymakey.whenKeyPressed": "%1 пернесі басылғанда",
  	"makeymakey.whenKeysPressedInOrder": "%1 ретпен басылғанда",
  	"microbit.whenButtonPressed": "%1 пернесі басылғанда",
  	"microbit.isButtonPressed": "%1 пернесі басылды ма?",
  	"microbit.whenGesture": "%1 болғанда",
  	"microbit.displaySymbol": "%1 көрсету",
  	"microbit.displayText": "%1 мәтінін көрсету",
  	"microbit.clearDisplay": "дисплейді тазалау",
  	"microbit.whenTilted": "%1 бағытында еңкейгенде",
  	"microbit.isTilted": "%1 еңкейді ме?",
  	"microbit.tiltAngle": "еңкею бұрышы %1",
  	"microbit.whenPinConnected": "%1 істігі қосылғанда",
  	"ev3.motorTurnClockwise": "%1 моторын осы бағытта %2 секунд бойы бұру",
  	"ev3.motorTurnCounterClockwise": "%1 моторын осы бағытта %2 секунд бойы бұр",
  	"ev3.motorSetPower": "%1 моторына %2 % қуатын орнату",
  	"ev3.getMotorPosition": "%1 моторының орны",
  	"ev3.whenButtonPressed": "%1 пернесі басылғанда",
  	"ev3.whenDistanceLessThan": "қашықтыңы < %1 болғанда",
  	"ev3.whenBrightnessLessThan": "жарықтығы < %1 болғанда",
  	"ev3.buttonPressed": "%1 пернесі басылды ма?",
  	"ev3.getDistance": "арақашықтық",
  	"ev3.getBrightness": "жарықтық",
  	"ev3.beepNote": "%1 жазбасының %2 секундқа дыбысын қос",
  	"wedo2.motorOn": "%1 моторын іске қос",
  	"wedo2.motorOff": "%1 моторын өшір",
  	"wedo2.startMotorPower": "%1 қуатын %2 орнату",
  	"wedo2.setMotorDirection": "%1  моторын %2 бағытында орнат",
  	"wedo2.whenDistance": "арақашықтық %1 %2 болған кезде",
  	"wedo2.getDistance": "арақашықтық",
  	"wedo2.motorOnFor": "%1 моторын %2 секундқа қос",
  	"wedo2.setLightHue": "жарық түсін %1 орнат",
  	"wedo2.playNoteFor": "%1  нотасын %2 секунд ойнату",
  	"wedo2.whenTilted": "%1 еңкейгенде",
  	"wedo2.isTilted": "%1 еңкейген бе?",
  	"wedo2.getTiltAngle": "%1 еңкею бұрышы",
  	"gdxfor.whenGesture": "%1 болғанда",
  	"gdxfor.whenForcePushedOrPulled": "сенсорда %1 әрекеті болғанда",
  	"gdxfor.getForce": "күш",
  	"gdxfor.whenTilted": "%1 еңкейгенде",
  	"gdxfor.isTilted": "%1 еңкейді ме?",
  	"gdxfor.getTilt": "еңкею бұрышы %1",
  	"gdxfor.isFreeFalling": "құлап бара жатыр ма?",
  	"gdxfor.getSpin": "айналу жылдамдығы %1",
  	"gdxfor.getAcceleration": "%1 үдеу",
  	"boost.motorOnFor": "%1 моторын %2 секундқа қос",
  	"boost.motorOnForRotation": "%1 моторын %2 рет айналуға қос",
  	"boost.motorOn": "%1 моторын іске қос",
  	"boost.motorOff": "%1 моторын өшір",
  	"boost.setMotorPower": "%1 моторының жылдамдығын  %2 % орнат",
  	"boost.setMotorDirection": "%1  моторын %2 бағытында орнат",
  	"boost.getMotorPosition": "%1 моторының орны",
  	"boost.whenColor": "%1  кірпіші көрінгенде",
  	"boost.seeingColor": "%1 кірпіші көрініп тұр ма?",
  	"boost.whenTilted": "%1 еңкейгенде",
  	"boost.getTiltAngle": "%1 еңкею бұрышы",
  	"boost.setLightHue": "жарық түсін %1 орнат"
  };
  var dropdowns$z = {
  };
  var ignorelt$z = [
  ];
  var soundEffects$z = [
  	"лақтыру",
  	"оң/сол қыздыру"
  ];
  var microbitWhen$z = [
  	"қозғалды",
  	"шайқалды",
  	"секірді"
  ];
  var osis$z = [
  	"спрайттағы басқа скрипттер"
  ];
  var definePrefix$z = [
  ];
  var defineSuffix$z = [
  	"ге",
  	"мән",
  	"бер"
  ];
  var palette$z = {
  	Motion: "Қозғалыс",
  	Looks: "Келбет",
  	Sound: "Дыбыс",
  	Events: "Оқиғалар",
  	Control: "Басқару",
  	Sensing: "Сенсорлер",
  	Operators: "Операторлар",
  	Variables: "айнымалылар",
  	"My Blocks": "Менің блоктарым"
  };
  var math$z = [
  	"модуль",
  	"еден",
  	"шектеу",
  	"квадрат түбір",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$z = {
  };
  var name$z = "қазақша";
  var percentTranslated$z = 100;
  var kk = {
  	commands: commands$z,
  	dropdowns: dropdowns$z,
  	ignorelt: ignorelt$z,
  	soundEffects: soundEffects$z,
  	microbitWhen: microbitWhen$z,
  	osis: osis$z,
  	definePrefix: definePrefix$z,
  	defineSuffix: defineSuffix$z,
  	palette: palette$z,
  	math: math$z,
  	aliases: aliases$z,
  	name: name$z,
  	percentTranslated: percentTranslated$z
  };

  var commands$y = {
  	MOTION_MOVESTEPS: "ផ្លាស់ទី %1 ជំហាន",
  	MOTION_TURNRIGHT: "បង្វិល @turnRight %1 ដឺក្រេ",
  	MOTION_TURNLEFT: "បង្វិល @turnLeft %1 ដឺក្រេ",
  	MOTION_POINTINDIRECTION: "ចង្អុលទៅទិសដៅ %1",
  	MOTION_POINTTOWARDS: "ចង្អុលទៅ %1",
  	MOTION_GOTOXY: "ទៅកាន់ x: %1 y: %2",
  	MOTION_GOTO: "ទៅកាន់ %1",
  	MOTION_GLIDESECSTOXY: "រំកិល %1 វិនាទី ទៅ x: %2 y: %3",
  	MOTION_GLIDETO: "រំកិល %1 វិនាទី ទៅ %2",
  	MOTION_CHANGEXBY: "ប្តូរ x ចំនួន %1",
  	MOTION_SETX: "ដាក់ x ត្រឹម %1",
  	MOTION_CHANGEYBY: "ប្តូរ y ចំនួន %1",
  	MOTION_SETY: "ដាក់ y ត្រឹម %1",
  	MOTION_SETROTATIONSTYLE: "ដាក់ស្តាយបង្វិល %1",
  	LOOKS_SAYFORSECS: "និយាយ %1 រយៈពេល %2 វិនាទី",
  	LOOKS_SAY: "និយាយ %1",
  	LOOKS_THINKFORSECS: "គិត %1 រយៈពេល %2 វិនាទី",
  	LOOKS_THINK: "គិត %1",
  	LOOKS_SHOW: "បង្ហាញ",
  	LOOKS_HIDE: "លាក់",
  	LOOKS_SWITCHCOSTUMETO: "ប្តូររូបរាងទៅជា %1",
  	LOOKS_NEXTCOSTUME: "រូបរាងបន្ទាប់",
  	LOOKS_NEXTBACKDROP_BLOCK: "ផ្ទាំងខាងក្រោយបន្ទាប់",
  	LOOKS_SWITCHBACKDROPTO: "ប្ដូរផ្ទាំង​ខាងក្រោយ​ទៅជា %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "ប្ដូរផ្ទាំងខាង​ក្រោយ​ទៅជា %1 ហើយ​រងចាំ",
  	LOOKS_CHANGEEFFECTBY: "ប្តូរបែបផែន %1 ចំនួន %2",
  	LOOKS_SETEFFECTTO: "ដាក់បែបផែន %1 ត្រឹម %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "លុបបែបផែនក្រាហ្វិក",
  	LOOKS_CHANGESIZEBY: "ប្តូរទំហំចំនួន %1",
  	LOOKS_SETSIZETO: "ដាក់ទំហំត្រឹម %1 %",
  	LOOKS_GOTOFRONTBACK: "ទៅស្រទាប់ %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 ស្រទាប់",
  	SOUND_PLAY: "ផ្តើមសម្លេង %1",
  	SOUND_CHANGEEFFECTBY: "ប្តូរបែបផែន %1 ចំនួន %2",
  	SOUND_SETEFFECTO: "ដាក់បែបផែន %1 ត្រឹម %2",
  	SOUND_CLEAREFFECTS: "លុបបែបផែនសម្លេង",
  	SOUND_PLAYUNTILDONE: "លេងសម្លេង %1 រហូតដល់ចប់",
  	SOUND_STOPALLSOUNDS: "បញ្ឈប់សម្លេងទាំងអស់",
  	"music.playDrumForBeats": "លេងសូរ %1 ចំនួន %2 ប៊ីត",
  	"music.restForBeats": "ផ្អាកចំនួន %1 ប៊ីត",
  	"music.playNoteForBeats": "លេងណូត %1 ចំនួន %2 ប៊ីត",
  	"music.setInstrument": "ដាក់ឧបករណ៍ទៅជា %1",
  	SOUND_CHANGEVOLUMEBY: "ប្តូរកម្រិតសម្លេងចំនួន %1",
  	SOUND_SETVOLUMETO: "ដាក់កម្រិតសម្លេងត្រឹម %1%",
  	"music.changeTempo": "ប្តូរចង្វាក់ចំនួន %1",
  	"music.setTempo": "ដាក់ចង្វាក់ត្រឹម %1",
  	"pen.clear": "លុបទាំងអស់",
  	"pen.stamp": "ដាក់ផ្តិតរូប",
  	"pen.penDown": "ចាប់គូស",
  	"pen.penUp": "ឈប់គូស",
  	"pen.setColor": "ដាក់ពណ៌ប៊ិចទៅជា %1",
  	"pen.changeHue": "ប្ដូរពណ៌ប៊ិចចំនួន %1",
  	"pen.setColorParam": "ដាក់ %1 របស់ប៊ិចត្រឹម %2",
  	"pen.changeColorParam": "ប្តូរ %1 របស់ប៊ិចចំនួន %2",
  	"pen.setHue": "ដាក់ពណ៌ប៊ិចទៅជា %1",
  	"pen.changeShade": "ប្តូរកម្រិតដិតរបស់ប៊ិចចំនួន %1",
  	"pen.setShade": "ដាក់កម្រិតដឹតរបស់ប៊ិចត្រឹម %1",
  	"pen.changeSize": "ប្តូរទំហំប៊ិចចំនួន %1",
  	"pen.setSize": "ដាក់ទំហំប៊ិចត្រឹម %1",
  	EVENT_WHENFLAGCLICKED: "ពេលចុច @greenFlag",
  	EVENT_WHENKEYPRESSED: "ពេលចុច %1",
  	EVENT_WHENTHISSPRITECLICKED: "ពេលចុចតួអង្គ",
  	EVENT_WHENSTAGECLICKED: "ពេលចុចឆាក",
  	EVENT_WHENBACKDROPSWITCHESTO: "ពេលផ្ទាំងខាងក្រោយប្តូរទៅជា %1",
  	EVENT_WHENGREATERTHAN: "ពេល %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ពេលខ្ញុំទទួលបាន %1",
  	EVENT_BROADCAST: "បញ្ជូនសារ %1",
  	EVENT_BROADCASTANDWAIT: "បញ្ជូនសារ %1 ហើយចាំ",
  	CONTROL_WAIT: "ចាំ %1 វិនាទី",
  	CONTROL_REPEAT: "ធ្វើដដែលៗ %1 ដង",
  	CONTROL_FOREVER: "រហូត",
  	CONTROL_IF: "ប្រសិន %1 នោះ",
  	CONTROL_WAITUNTIL: "ចាំរហូតដល់ %1",
  	CONTROL_REPEATUNTIL: "ធ្វើដដែលៗរហូតដល់ %1",
  	CONTROL_STOP: "ឈប់ %1",
  	CONTROL_STARTASCLONE: "ពេលខ្ញុំចាប់ផ្តើមជារូបចម្លង",
  	CONTROL_CREATECLONEOF: "ចម្លងរូបរាងនៃ %1",
  	CONTROL_DELETETHISCLONE: "លុបរូបចម្លងនេះ",
  	SENSING_ASKANDWAIT: "សួរ %1 ហើយចាំ",
  	"videoSensing.videoToggle": "%1 វីដេអូ",
  	"videoSensing.setVideoTransparency": "ដាក់កម្រិតឆ្លុះរបស់វីដេអូត្រឹម %1",
  	"videoSensing.whenMotionGreaterThan": "ពេលកម្រិតចលនាក្នុងវីដេអូ > %1",
  	SENSING_RESETTIMER: "កំណត់ម៉ោងរាប់ថយក្រោយឡើងវិញ",
  	DATA_SETVARIABLETO: "ដាក់ %1 ទៅជា %2",
  	DATA_CHANGEVARIABLEBY: "ប្តូរ %1 ចំនួន %2",
  	DATA_SHOWVARIABLE: "បង្ហាញអថេរ %1",
  	DATA_HIDEVARIABLE: "លាក់អថេរ %1",
  	DATA_ADDTOLIST: "បន្ថែម %1 ទៅលើ %2",
  	DATA_DELETEOFLIST: "លុបធាតុទី %1 ចេញពី %2",
  	DATA_DELETEALLOFLIST: "លុបធាតុទាំងអស់ក្នុង %1",
  	MOTION_IFONEDGEBOUNCE: "បើនៅគែមឆាក, អោយខ្ទាតចេញ",
  	DATA_INSERTATLIST: "បញ្ចូល %1 នៅទីតាំង %2 ក្នុង %3",
  	DATA_REPLACEITEMOFLIST: "ជំនួសធាតុ %1 នៃ %2 ដោយ %3",
  	DATA_SHOWLIST: "បង្ហាញបញ្ជី %1",
  	DATA_HIDELIST: "លាក់បញ្ជី %1",
  	SENSING_OF_XPOSITION: "ទីតាំង x",
  	SENSING_OF_YPOSITION: "ទីតាំង y",
  	SENSING_OF_DIRECTION: "ទិសដៅ",
  	SENSING_OF_COSTUMENUMBER: "រូបរាង #",
  	LOOKS_COSTUMENUMBERNAME: "រូបរាង %1",
  	SENSING_OF_SIZE: "ទំហំ",
  	SENSING_OF_BACKDROPNAME: "ឈ្មោះផ្ទាំងខាងក្រោយ",
  	LOOKS_BACKDROPNUMBERNAME: "ផ្ទាំងខាងក្រោយ %1",
  	SENSING_OF_BACKDROPNUMBER: "ផ្ទាំងខាងក្រោយ #",
  	SOUND_VOLUME: "កម្រិតសម្លេង",
  	"music.getTempo": "ចង្វាក់",
  	SENSING_TOUCHINGOBJECT: "ប៉ះ %1?",
  	SENSING_TOUCHINGCOLOR: "ប៉ះពណ៌ %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "ពណ៌ %1 ប៉ះ %2?",
  	SENSING_DISTANCETO: "ចម្ងាយពី %1",
  	SENSING_ANSWER: "ចម្លើយ",
  	SENSING_KEYPRESSED: "ច្នុច %1 ត្រូវបានចុច?",
  	SENSING_MOUSEDOWN: "ចុចម៉ៅស៍?",
  	SENSING_MOUSEX: "ទីតាំងព្រួញម៉ៅស៍ x",
  	SENSING_MOUSEY: "ទីតាំងព្រួញម៉ៅស៍ y",
  	SENSING_SETDRAGMODE: "ដាក់ម៉ូតអូស %1",
  	SENSING_LOUDNESS: "កម្រិតឮ",
  	"videoSensing.videoOn": "%1 របស់វីដេអូទៅលើ %2",
  	SENSING_TIMER: "ម៉ោងរាប់ថយក្រោយ",
  	SENSING_OF: "%1 នៃ %2",
  	SENSING_CURRENT: "%1 បច្ចុប្បន្ន",
  	SENSING_DAYSSINCE2000: "ចំនួនថ្ងៃចាប់ពីឆ្នាំ 2000",
  	SENSING_USERNAME: "ឈ្មោះគណនី",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "យកតម្លៃចៃដន្យពី %1 ទៅ %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 និង %2",
  	OPERATORS_OR: "%1 ឬ %2",
  	OPERATORS_NOT: "មិនមែន %1",
  	OPERATORS_JOIN: "ភ្ជាប់ %1 %2",
  	OPERATORS_LETTEROF: "តួអក្សរទី %1 នៃ %2",
  	OPERATORS_LENGTH: "ប្រវែងនៃ %1",
  	OPERATORS_MOD: "សំណល់នៃ %1 ចែកនឹង %2",
  	OPERATORS_ROUND: "បង្គត់ %1",
  	OPERATORS_MATHOP: "%1 នៃ %2",
  	OPERATORS_CONTAINS: "%1 មាន %2?",
  	DATA_ITEMOFLIST: "ធាតុ %1 នៃ %2",
  	DATA_ITEMNUMOFLIST: "លេខទីតាំងនៃធាតុ %1 ក្នុង %2",
  	DATA_LENGTHOFLIST: "ប្រវែងនៃ %1",
  	DATA_LISTCONTAINSITEM: "%1 មាន %2?",
  	CONTROL_ELSE: "បើមិនដូច្នោះទេ",
  	SENSING_USERID: "លេខសម្គាល់អ្នកប្រើ",
  	SENSING_LOUD: "លឺ?",
  	"text2speech.speakAndWaitBlock": "និយាយ %1",
  	"text2speech.setVoiceBlock": "ដាក់សម្លេងទៅជា %1",
  	"text2speech.setLanguageBlock": "ដាក់ភាសាទៅជា %1",
  	"translate.translateBlock": "បកប្រែ %1 ទៅជាភាសា %2",
  	"translate.viewerLanguage": "ភាសា",
  	"makeymakey.whenKeyPressed": "ពេលចុច %1",
  	"makeymakey.whenKeysPressedInOrder": "ពេលចុច %1 តាមលំដាប់",
  	"microbit.whenButtonPressed": "ពេលប៊ូតុង %1 ​ត្រូវ​បាន​ចុច",
  	"microbit.isButtonPressed": "ប៊ូតុង %1 ​ត្រូវ​បាន​ចុច?",
  	"microbit.whenGesture": "ពេល %1",
  	"microbit.displaySymbol": "បង្ហាញ %1",
  	"microbit.displayText": "បង្ហាញអត្ថបទ %1",
  	"microbit.clearDisplay": "សម្អាតអេក្រង់",
  	"microbit.whenTilted": "ពេលលំអៀង %1",
  	"microbit.isTilted": "លំអៀង %1?",
  	"microbit.tiltAngle": "លម្អៀងមុំ %1",
  	"microbit.whenPinConnected": "ពេលម្ជុលតំណរ %1 ត្រូវបានភ្ជាប់",
  	"ev3.motorTurnClockwise": "ម៉ូទ័រ %1 បែរតាមទ្រនិចនាឡិការយៈពេល %2 វិនាទី",
  	"ev3.motorTurnCounterClockwise": "ម៉ូទ័រ %1 បែរបញ្ច្រាសទ្រនិចនាឡិការយៈពេល %2 វិនាទី",
  	"ev3.motorSetPower": "ដាក់ថាមពលម៉ូទ័រ %1 ត្រឹម %2 %",
  	"ev3.getMotorPosition": "ទីតាំងម៉ូទ័រ %1",
  	"ev3.whenButtonPressed": "ពេលប៊ូតុង %1 បានចុច",
  	"ev3.whenDistanceLessThan": "ពេលចម្ងាយ < %1",
  	"ev3.whenBrightnessLessThan": "ពេលកម្រិតពន្លឺ < %1",
  	"ev3.buttonPressed": "ប៊ូតុងលើ %1 ត្រូវបានចុច?",
  	"ev3.getDistance": "កម្រិតចម្ងាយ",
  	"ev3.getBrightness": "កម្រិតពន្លឺ",
  	"ev3.beepNote": "លេងណូត %1 រយៈពេល​ %2 វិនាទី",
  	"wedo2.motorOn": "បើកម៉ូទ័រ %1",
  	"wedo2.motorOff": "បិទម៉ូទ័រ %1",
  	"wedo2.startMotorPower": "ដាក់ថាមពលម៉ូទ័រ %1 ត្រឹម %2 %",
  	"wedo2.setMotorDirection": "ដាក់ទិសដៅរបស់ %1 ទៅជា %2",
  	"wedo2.whenDistance": "ពេលចម្ងាយ %1 %2",
  	"wedo2.getDistance": "ចម្ងាយ",
  	"wedo2.motorOnFor": "បើកម៉ូទ័រ %1 រយៈពេល %2 វិនាទី",
  	"wedo2.setLightHue": "ដាក់ពណ៌ភ្លើងទៅជា %1",
  	"wedo2.playNoteFor": "លេងណូត %1 រយៈពេល​ %2 វិនាទី",
  	"wedo2.whenTilted": "ពេលលំអៀង %1",
  	"wedo2.isTilted": "លំអៀង %1?",
  	"wedo2.getTiltAngle": "លម្អៀងមុំ %1",
  	"gdxfor.whenGesture": "ពេល %1",
  	"gdxfor.whenForcePushedOrPulled": "ពេលសិនស័រកម្លាំង %1",
  	"gdxfor.getForce": "កម្លាំង",
  	"gdxfor.whenTilted": "ពេលលំអៀង %1",
  	"gdxfor.isTilted": "លំអៀង %1?",
  	"gdxfor.getTilt": "លម្អៀងមុំ %1",
  	"gdxfor.isFreeFalling": "ធ្លាក់សេរី?",
  	"gdxfor.getSpin": "ល្បឿនបង្វិល %1",
  	"gdxfor.getAcceleration": "សំទុះ %1",
  	"boost.motorOnFor": "បង្វិលម៉ូទ័រ %1 រយៈពេល %2 វិនាទី",
  	"boost.motorOnForRotation": "បង្វិលម៉ូទ័រ %1 ចំនួន %2 ជុំ",
  	"boost.motorOn": "បើកម៉ូទ័រ %1",
  	"boost.motorOff": "បិទម៉ូទ័រ %1",
  	"boost.setMotorPower": "ដាក់ល្បឿនម៉ូទ័រ %1 ត្រឹម %2 %",
  	"boost.setMotorDirection": "ដាក់ទិសដៅរបស់ %1 ទៅជា %2",
  	"boost.getMotorPosition": "ទីតាំងម៉ូទ័រ %1",
  	"boost.whenColor": "ពេលឃើញពណ៌ %1",
  	"boost.seeingColor": "ឃើញដុំពណ៌ %1?",
  	"boost.whenTilted": "ពេលលំអៀង %1",
  	"boost.getTiltAngle": "លម្អៀងមុំ %1",
  	"boost.setLightHue": "ដាក់ពណ៌របស់ភ្លើងទៅជា %1"
  };
  var dropdowns$y = {
  };
  var ignorelt$y = [
  ];
  var soundEffects$y = [
  	"កម្រិតខ្ពស់ទាប",
  	"កម្រិតឆ្វេងស្តាំ"
  ];
  var microbitWhen$y = [
  	"បានផ្លាស់ទី",
  	"ញាក់",
  	"បានលោត"
  ];
  var osis$y = [
  	"ស្រ្គីបផ្សេងទៀតក្នុងតួអង្គ"
  ];
  var definePrefix$y = [
  	"កំណត់ន័យ"
  ];
  var defineSuffix$y = [
  ];
  var palette$y = {
  	Motion: "ចលនា",
  	Looks: "រូបរាង",
  	Sound: "សម្លេង",
  	Events: "ព្រឹត្តិការណ៍",
  	Control: "គ្រប់គ្រង",
  	Sensing: "ញ្ញាណ",
  	Operators: "ប្រមាណវិធី",
  	Variables: "អថេរ",
  	"My Blocks": "ប្លុកខ្ញុំ"
  };
  var math$y = [
  	"តម្លៃដាច់ខាត",
  	"បង្គត់ចុះ",
  	"បង្គត់ឡើង",
  	"ឫស​ការ៉េ",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$y = {
  };
  var name$y = "ភាសាខ្មែរ";
  var percentTranslated$y = 100;
  var km = {
  	commands: commands$y,
  	dropdowns: dropdowns$y,
  	ignorelt: ignorelt$y,
  	soundEffects: soundEffects$y,
  	microbitWhen: microbitWhen$y,
  	osis: osis$y,
  	definePrefix: definePrefix$y,
  	defineSuffix: defineSuffix$y,
  	palette: palette$y,
  	math: math$y,
  	aliases: aliases$y,
  	name: name$y,
  	percentTranslated: percentTranslated$y
  };

  var commands$x = {
  	MOTION_MOVESTEPS: "%1 만큼 움직이기",
  	MOTION_TURNRIGHT: "@turnRight 방향으로 %1 도 돌기",
  	MOTION_TURNLEFT: "@turnLeft 방향으로 %1 도 회전하기",
  	MOTION_POINTINDIRECTION: "%1 도 방향 보기",
  	MOTION_POINTTOWARDS: "%1 쪽 보기",
  	MOTION_GOTOXY: "x: %1 y: %2 (으)로 이동하기",
  	MOTION_GOTO: "%1 (으)로 이동하기",
  	MOTION_GLIDESECSTOXY: "%1 초 동안 x: %2 y: %3 (으)로 이동하기",
  	MOTION_GLIDETO: "%1 초 동안 %2 (으)로 이동하기",
  	MOTION_CHANGEXBY: "x좌표를 %1 만큼 바꾸기",
  	MOTION_SETX: "x좌표를 %1 (으)로 정하기",
  	MOTION_CHANGEYBY: "y좌표를 %1 만큼 바꾸기",
  	MOTION_SETY: "y좌표를 %1 (으)로 정하기",
  	MOTION_SETROTATIONSTYLE: "회전 방식을 %1 (으)로 정하기",
  	LOOKS_SAYFORSECS: "%1 을(를) %2 초 동안 말하기",
  	LOOKS_SAY: "%1 말하기",
  	LOOKS_THINKFORSECS: "%1 을(를) %2 초 동안 생각하기",
  	LOOKS_THINK: "%1 생각하기",
  	LOOKS_SHOW: "보이기",
  	LOOKS_HIDE: "숨기기",
  	LOOKS_SWITCHCOSTUMETO: "모양을 %1 (으)로 바꾸기",
  	LOOKS_NEXTCOSTUME: "다음 모양으로 바꾸기",
  	LOOKS_NEXTBACKDROP_BLOCK: "다음 배경으로 바꾸기",
  	LOOKS_SWITCHBACKDROPTO: "배경을 %1 (으)로 바꾸기",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "배경을 %1 (으)로 바꾸고 기다리기",
  	LOOKS_CHANGEEFFECTBY: "%1 효과를 %2 만큼 바꾸기",
  	LOOKS_SETEFFECTTO: "%1 효과를 %2 (으)로 정하기",
  	LOOKS_CLEARGRAPHICEFFECTS: "그래픽 효과 지우기",
  	LOOKS_CHANGESIZEBY: "크기를 %1 만큼 바꾸기",
  	LOOKS_SETSIZETO: "크기를 %1 %로 정하기",
  	LOOKS_GOTOFRONTBACK: "%1 으로 순서 바꾸기",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 단계 보내기",
  	SOUND_PLAY: "%1 재생하기",
  	SOUND_CHANGEEFFECTBY: "%1 효과를 %2 만큼 바꾸기",
  	SOUND_SETEFFECTO: "%1 효과를 %2 로 정하기",
  	SOUND_CLEAREFFECTS: "소리 효과 지우기",
  	SOUND_PLAYUNTILDONE: "%1 끝까지 재생하기",
  	SOUND_STOPALLSOUNDS: "모든 소리 끄기",
  	"music.playDrumForBeats": "%1번 타악기를 %2 박자로 연주하기",
  	"music.restForBeats": "%1 박자 쉬기",
  	"music.playNoteForBeats": "%1번 음을 %2 박자로 연주하기",
  	"music.setInstrument": "악기를 %1(으)로 정하기",
  	SOUND_CHANGEVOLUMEBY: "음량을 %1 만큼 바꾸기",
  	SOUND_SETVOLUMETO: "음량을 %1%로 정하기",
  	"music.changeTempo": "빠르기를 %1 만큼 바꾸기",
  	"music.setTempo": "빠르기를 %1(으)로 정하기",
  	"pen.clear": "모두 지우기",
  	"pen.stamp": "도장찍기",
  	"pen.penDown": "펜 내리기",
  	"pen.penUp": "펜 올리기",
  	"pen.setColor": "펜 색깔을 %1(으)로 정하기",
  	"pen.changeHue": "펜 색깔을 %1만큼 바꾸기",
  	"pen.setColorParam": "펜 %1을(를) %2(으)로 정하기",
  	"pen.changeColorParam": "펜 %1을(를) %2만큼 바꾸기",
  	"pen.setHue": "펜 색깔을 %1(으)로 정하기",
  	"pen.changeShade": "펜 명암을 %1 만큼 바꾸기",
  	"pen.setShade": "펜 명암을 %1(으)로 정하기",
  	"pen.changeSize": "펜 굵기를 %1 만큼 바꾸기",
  	"pen.setSize": "펜 굵기를 %1(으)로 정하기",
  	EVENT_WHENFLAGCLICKED: "@greenFlag 클릭했을 때",
  	EVENT_WHENKEYPRESSED: "%1 키를 눌렀을 때",
  	EVENT_WHENTHISSPRITECLICKED: "이 스프라이트를 클릭했을 때",
  	EVENT_WHENSTAGECLICKED: "무대를 클릭했을 때",
  	EVENT_WHENBACKDROPSWITCHESTO: "배경이 %1 (으)로 바뀌었을 때",
  	EVENT_WHENGREATERTHAN: "%1 > %2 일 때",
  	EVENT_WHENBROADCASTRECEIVED: "%1 신호를 받았을 때",
  	EVENT_BROADCAST: "%1 신호 보내기",
  	EVENT_BROADCASTANDWAIT: "%1 신호 보내고 기다리기",
  	CONTROL_WAIT: "%1 초 기다리기",
  	CONTROL_REPEAT: "%1 번 반복하기",
  	CONTROL_FOREVER: "무한 반복하기",
  	CONTROL_IF: "만약 %1 (이)라면",
  	CONTROL_WAITUNTIL: "%1 까지 기다리기",
  	CONTROL_REPEATUNTIL: "%1 까지 반복하기",
  	CONTROL_STOP: "멈추기 %1",
  	CONTROL_STARTASCLONE: "복제되었을 때",
  	CONTROL_CREATECLONEOF: "%1 복제하기",
  	CONTROL_DELETETHISCLONE: "이 복제본 삭제하기",
  	SENSING_ASKANDWAIT: "%1 라고 묻고 기다리기",
  	"videoSensing.videoToggle": "비디오 %1",
  	"videoSensing.setVideoTransparency": "비디오 투명도를 %1 (으)로 정하기",
  	"videoSensing.whenMotionGreaterThan": "비디오 동작 > %1일 때",
  	SENSING_RESETTIMER: "타이머 초기화",
  	DATA_SETVARIABLETO: "%1 을(를) %2 로 정하기",
  	DATA_CHANGEVARIABLEBY: "%1 을(를) %2 만큼 바꾸기",
  	DATA_SHOWVARIABLE: "%1 변수 보이기",
  	DATA_HIDEVARIABLE: "%1 변수 숨기기",
  	DATA_ADDTOLIST: "%1 을(를) %2 에 추가하기",
  	DATA_DELETEOFLIST: "%1 번째 항목을 %2 에서 삭제하기",
  	DATA_DELETEALLOFLIST: "%1 의 항목을 모두 삭제하기",
  	MOTION_IFONEDGEBOUNCE: "벽에 닿으면 튕기기",
  	DATA_INSERTATLIST: "%1 을(를) %3 리스트의 %2 번째에 넣기",
  	DATA_REPLACEITEMOFLIST: "%2 리스트의 %1 번째 항목을 %3 으로 바꾸기",
  	DATA_SHOWLIST: "%1 리스트 보이기",
  	DATA_HIDELIST: "%1 리스트 숨기기",
  	SENSING_OF_XPOSITION: "x좌표",
  	SENSING_OF_YPOSITION: "y좌표",
  	SENSING_OF_DIRECTION: "방향",
  	SENSING_OF_COSTUMENUMBER: "모양 번호",
  	LOOKS_COSTUMENUMBERNAME: "모양 %1",
  	SENSING_OF_SIZE: "크기",
  	SENSING_OF_BACKDROPNAME: "배경 이름",
  	LOOKS_BACKDROPNUMBERNAME: "배경 %1",
  	SENSING_OF_BACKDROPNUMBER: "배경 번호",
  	SOUND_VOLUME: "음량",
  	"music.getTempo": "빠르기",
  	SENSING_TOUCHINGOBJECT: "%1 에 닿았는가?",
  	SENSING_TOUCHINGCOLOR: "%1 색에 닿았는가?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 색이 %2 색에 닿았는가?",
  	SENSING_DISTANCETO: "%1 까지의 거리",
  	SENSING_ANSWER: "대답",
  	SENSING_KEYPRESSED: "%1 키를 눌렸는가?",
  	SENSING_MOUSEDOWN: "마우스를 클릭했는가?",
  	SENSING_MOUSEX: "마우스의 x좌표",
  	SENSING_MOUSEY: "마우스의 y좌표",
  	SENSING_SETDRAGMODE: "드래그 모드를 %1 상태로 정하기",
  	SENSING_LOUDNESS: "음량",
  	"videoSensing.videoOn": "비디오 %1에 대한 %2에서의 관찰값",
  	SENSING_TIMER: "타이머",
  	SENSING_OF: "%2 의 %1",
  	SENSING_CURRENT: "현재 %1",
  	SENSING_DAYSSINCE2000: "2000년 이후 현재까지 날짜 수",
  	SENSING_USERNAME: "사용자 이름",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 부터 %2 사이의 난수",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 그리고 %2",
  	OPERATORS_OR: "%1 또는 %2",
  	OPERATORS_NOT: "%1 이(가) 아니다",
  	OPERATORS_JOIN: "%1 와(과) %2 결합하기",
  	OPERATORS_LETTEROF: "%2 의 %1 번째 글자",
  	OPERATORS_LENGTH: "%1 의 길이",
  	OPERATORS_MOD: "%1 나누기 %2 의 나머지",
  	OPERATORS_ROUND: "%1 의 반올림",
  	OPERATORS_MATHOP: "%1 ( %2 )",
  	OPERATORS_CONTAINS: "%1 이(가) %2 을(를) 포함하는가?",
  	DATA_ITEMOFLIST: "%2 리스트의 %1 번째 항목",
  	DATA_ITEMNUMOFLIST: "%2 리스트에서 %1 항목의 위치",
  	DATA_LENGTHOFLIST: "%1 의 길이",
  	DATA_LISTCONTAINSITEM: "%1 이(가) %2 을(를) 포함하는가?",
  	CONTROL_ELSE: "아니면",
  	SENSING_USERID: "사용자 번호",
  	SENSING_LOUD: "소리가 큰가?",
  	"text2speech.speakAndWaitBlock": "%1 말하기",
  	"text2speech.setVoiceBlock": "음성을 %1로 정하기",
  	"text2speech.setLanguageBlock": "언어를 %1로 정하기",
  	"translate.translateBlock": "%1을(를) %2로 번역하기",
  	"translate.viewerLanguage": "언어",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "%1 버튼이 눌러졌을 때",
  	"microbit.isButtonPressed": "%1 버튼이 눌려졌는가?",
  	"microbit.whenGesture": "%1 때",
  	"microbit.displaySymbol": "%1 보여주기",
  	"microbit.displayText": "글자 %1 보여주기",
  	"microbit.clearDisplay": "화면 지우기",
  	"microbit.whenTilted": "%1 방향으로 기울어졌을 때",
  	"microbit.isTilted": "%1 방향으로 기울어졌는가?",
  	"microbit.tiltAngle": "%1 방향으로 기울어진 각도",
  	"microbit.whenPinConnected": "%1번 핀이 연결되었을 때",
  	"ev3.motorTurnClockwise": "%1 모터를 %2 초 동안 이쪽으로 돌리기",
  	"ev3.motorTurnCounterClockwise": "%1 모터를 %2 초 동안 저쪽으로 돌리기",
  	"ev3.motorSetPower": "%1 모터 강도를 %2 %로 정하기",
  	"ev3.getMotorPosition": "모터 %1 위치",
  	"ev3.whenButtonPressed": "%1 번 버튼이 눌러졌을 때",
  	"ev3.whenDistanceLessThan": "거리 < %1일 때",
  	"ev3.whenBrightnessLessThan": "밝기 <  %1일 때",
  	"ev3.buttonPressed": "%1 번 버튼이 눌러졌는가?",
  	"ev3.getDistance": "거리",
  	"ev3.getBrightness": "밝기",
  	"ev3.beepNote": "%2 초 동안 %1 번 음 울리기",
  	"wedo2.motorOn": "%1 켜기",
  	"wedo2.motorOff": "%1 끄기",
  	"wedo2.startMotorPower": "%1 모터 강도를 %2로 정하기",
  	"wedo2.setMotorDirection": "%1의 방향을 %2으로 정하기",
  	"wedo2.whenDistance": "거리 %1 %2 일 때",
  	"wedo2.getDistance": "거리",
  	"wedo2.motorOnFor": "%2 초 동안 %1 켜기",
  	"wedo2.setLightHue": "빛의 색을  %1로 정하기",
  	"wedo2.playNoteFor": "%1 번 음을 %2초 간 연주하기",
  	"wedo2.whenTilted": "%1 방향으로 기울일 때",
  	"wedo2.isTilted": "%1 방향으로 기울어졌는가?",
  	"wedo2.getTiltAngle": "%1 방향으로 기울어진 각도",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$x = {
  };
  var ignorelt$x = [
  ];
  var soundEffects$x = [
  	"음 높이",
  	"음향 위치 왼쪽/오른쪽"
  ];
  var microbitWhen$x = [
  	"움직일",
  	"흔들어졌을",
  	"점프하였을"
  ];
  var osis$x = [
  	"이 스프라이트에 있는 다른 스크립트"
  ];
  var definePrefix$x = [
  ];
  var defineSuffix$x = [
  	"정의하기"
  ];
  var palette$x = {
  	Motion: "동작",
  	Looks: "형태",
  	Sound: "소리",
  	Events: "이벤트",
  	Control: "제어",
  	Sensing: "감지",
  	Operators: "연산",
  	Variables: "변수",
  	"My Blocks": "내 블록"
  };
  var math$x = [
  	"절댓값",
  	"버림",
  	"올림",
  	"제곱근",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$x = {
  };
  var name$x = "한국어";
  var percentTranslated$x = 100;
  var ko = {
  	commands: commands$x,
  	dropdowns: dropdowns$x,
  	ignorelt: ignorelt$x,
  	soundEffects: soundEffects$x,
  	microbitWhen: microbitWhen$x,
  	osis: osis$x,
  	definePrefix: definePrefix$x,
  	defineSuffix: defineSuffix$x,
  	palette: palette$x,
  	math: math$x,
  	aliases: aliases$x,
  	name: name$x,
  	percentTranslated: percentTranslated$x
  };

  var commands$w = {
  	MOTION_MOVESTEPS: "%1 gavan biavêje",
  	MOTION_TURNRIGHT: "@turnRight %1 dereceyan bizîvirîne",
  	MOTION_TURNLEFT: "@turnLeft %1 dereceyan bizîvirîne",
  	MOTION_POINTINDIRECTION: "berê wê %1 dereceyan bizîvirîne",
  	MOTION_POINTTOWARDS: "berê wê bide %1",
  	MOTION_GOTOXY: "biçe x: %1 y: %2ê",
  	MOTION_GOTO: "here %1",
  	MOTION_GLIDESECSTOXY: "di %1 çirkeyan de biçe x: %2 y: %3ê",
  	MOTION_GLIDETO: "di %1 çirkeyan de biçe %2ê",
  	MOTION_CHANGEXBY: "cîgeha x'ê bi %1an biguherîne",
  	MOTION_SETX: "cîgeha x'ê bike %1",
  	MOTION_CHANGEYBY: "cîgeha y'yê bi %1an biguherîne",
  	MOTION_SETY: "cîgeha y'yê bike %1",
  	MOTION_SETROTATIONSTYLE: "şêweya zîvirê bike %1",
  	LOOKS_SAYFORSECS: "bi qasî %2 çirkeyan bibêje %1",
  	LOOKS_SAY: "bibêje %1",
  	LOOKS_THINKFORSECS: "bi qasî %2 çirkeyan wekî %1 bifikire",
  	LOOKS_THINK: "wekî %1 bifikire",
  	LOOKS_SHOW: "nîşan bide",
  	LOOKS_HIDE: "veşêre",
  	LOOKS_SWITCHCOSTUMETO: "kostumê %1ê li xwe bike",
  	LOOKS_NEXTCOSTUME: "kostumê pêş",
  	LOOKS_NEXTBACKDROP_BLOCK: "dekora piştre",
  	LOOKS_SWITCHBACKDROPTO: "derbasî dekora %1ê bibe",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "derbasî dekora %1 bibe û bisekine",
  	LOOKS_CHANGEEFFECTBY: "efekta %1 bi qasî %2 biguherîne",
  	LOOKS_SETEFFECTTO: "efekta %1 bike %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "efektên grafikê paqij bike",
  	LOOKS_CHANGESIZEBY: "mezinbûnê bi qasî %1 biguherîne",
  	LOOKS_SETSIZETO: "mezinbûnê bike %1 %",
  	LOOKS_GOTOFRONTBACK: "here tebeqeya %1yê",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 tebeqeyan here",
  	SOUND_PLAY: "denge %1ê bide destpêkirin",
  	SOUND_CHANGEEFFECTBY: "efekta %1ê bi qasî %2 biguherîne",
  	SOUND_SETEFFECTO: "efekta %1ê bike %2",
  	SOUND_CLEAREFFECTS: "efektên deng paqij bike",
  	SOUND_PLAYUNTILDONE: "heta denge %1ê biqede, lêxe",
  	SOUND_STOPALLSOUNDS: "hemû dengan rawestîne",
  	"music.playDrumForBeats": "dahola %1ê %2 lêdana lêxe",
  	"music.restForBeats": "%1 lêdana bisekine",
  	"music.playNoteForBeats": "notaya %1ê %2 lêdana lêxe",
  	"music.setInstrument": "amûrê bike %1",
  	SOUND_CHANGEVOLUMEBY: "rêjeya deng bike %1",
  	SOUND_SETVOLUMETO: "rêjeya deng bike %1%",
  	"music.changeTempo": "tempoyê bike %1",
  	"music.setTempo": "tempoyê bike %1",
  	"pen.clear": "hemûyan jê bibe",
  	"pen.stamp": "mohr bike",
  	"pen.penDown": "pênûsê pêxîne",
  	"pen.penUp": "pênûsê bilind bike",
  	"pen.setColor": "rengê pênûsê bike %1",
  	"pen.changeHue": "rengê pênûsê bi qasî %1 zêde bike",
  	"pen.setColorParam": "pênûsa %1ê bike %2",
  	"pen.changeColorParam": "pênûsa %1ê bi %2 re biguherîne",
  	"pen.setHue": "rengê pênûsê bike %1",
  	"pen.changeShade": "sîbera pênûsê bi qasî %1 zêde bike",
  	"pen.setShade": "sîbera pênûsê bike %1",
  	"pen.changeSize": "mezinahiya pênûsê bi qasî %1 zêde bike",
  	"pen.setSize": "mezinahiya pênûsê bike %1",
  	EVENT_WHENFLAGCLICKED: "dema ku @greenFlag hat tikandin",
  	EVENT_WHENKEYPRESSED: "dema ku pêlî bişkoka %1ê hate kirin",
  	EVENT_WHENTHISSPRITECLICKED: "dema ku ev pêlîstik hate tikandin",
  	EVENT_WHENSTAGECLICKED: "dema ku dik hate tikandin",
  	EVENT_WHENBACKDROPSWITCHESTO: "dema ku dekor wekî %1ê hate guhertin",
  	EVENT_WHENGREATERTHAN: "dema ku bû wekî %1 > %2 yê",
  	EVENT_WHENBROADCASTRECEIVED: "dema ku min %1ê wergirt",
  	EVENT_BROADCAST: "%1ê biweşîne",
  	EVENT_BROADCASTANDWAIT: "%1ê biweşîne û bisekine",
  	CONTROL_WAIT: "%1 çirkeyan bisekine",
  	CONTROL_REPEAT: "%1 caran dubare bike",
  	CONTROL_FOREVER: "berdewamî",
  	CONTROL_IF: "heke %1 be",
  	CONTROL_WAITUNTIL: "heta ku bibe %1 bisekine",
  	CONTROL_REPEATUNTIL: "heta ku bibe %1 dubare bike",
  	CONTROL_STOP: "rawestîne %1",
  	CONTROL_STARTASCLONE: "dema ku min wekî cotikan dest pê kir",
  	CONTROL_CREATECLONEOF: "cotika %1yê biafirîne",
  	CONTROL_DELETETHISCLONE: "vê cotikê jê bibe",
  	SENSING_ASKANDWAIT: "%1ê bipirse û bisekine",
  	"videoSensing.videoToggle": "vîdyoyê %1",
  	"videoSensing.setVideoTransparency": "zelalbûna vîdyoyê bike %1",
  	"videoSensing.whenMotionGreaterThan": "dema ku tevgera vîdyoyê bû > %1",
  	SENSING_RESETTIMER: "demsazkerê nûsaz bike",
  	DATA_SETVARIABLETO: "%1ê bike %2",
  	DATA_CHANGEVARIABLEBY: "%1ê biguherîne %2ê",
  	DATA_SHOWVARIABLE: "guheroka %1ê nîşan bide",
  	DATA_HIDEVARIABLE: "guheroka %1ê veşêre",
  	DATA_ADDTOLIST: "%1ê tevlî %2ê bike",
  	DATA_DELETEOFLIST: "%1ê ji %2ê bibe",
  	DATA_DELETEALLOFLIST: "hemû tiştên %1ê jê bibe",
  	MOTION_IFONEDGEBOUNCE: "heke li kêlekê be, hilpekîne",
  	DATA_INSERTATLIST: "%1ê tevlî pozisyona %3 ya %2ê bike",
  	DATA_REPLACEITEMOFLIST: "hêmana %2 ya %1ê bi %3ê re pev biguherîne",
  	DATA_SHOWLIST: "lîsteya %1ê nîşan bide",
  	DATA_HIDELIST: "lîsteya %1ê veşêre",
  	SENSING_OF_XPOSITION: "cîgeha x'ê",
  	SENSING_OF_YPOSITION: "cîgeha y'yê",
  	SENSING_OF_DIRECTION: "hêl",
  	SENSING_OF_COSTUMENUMBER: "kostum #",
  	LOOKS_COSTUMENUMBERNAME: "kostumê %1",
  	SENSING_OF_SIZE: "mezinahî",
  	SENSING_OF_BACKDROPNAME: "navê dekorê",
  	LOOKS_BACKDROPNUMBERNAME: "dekora %1",
  	SENSING_OF_BACKDROPNUMBER: "dekor #",
  	SOUND_VOLUME: "rêjeya deng",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "%1 tê tepandin?",
  	SENSING_TOUCHINGCOLOR: "te pêlî rengê %1 kir?",
  	SENSING_COLORISTOUCHINGCOLOR: "rengê %2 dikeve nav yê %1?",
  	SENSING_DISTANCETO: "mesafeya bi %1 re",
  	SENSING_ANSWER: "bersiv",
  	SENSING_KEYPRESSED: "pêlî bişkoka %1ê hate kirin?",
  	SENSING_MOUSEDOWN: "mişk pêlêkirî ye?",
  	SENSING_MOUSEX: "x'a mişkê",
  	SENSING_MOUSEY: "y'ya mişkê",
  	SENSING_SETDRAGMODE: "moda kişkişandinê wekî %1ê saz bike",
  	SENSING_LOUDNESS: "bilindbûna deng",
  	"videoSensing.videoOn": "vîdyoya %1ê ya li ser %2ê",
  	SENSING_TIMER: "demsazker",
  	SENSING_OF: "%1 ya %2ê",
  	SENSING_CURRENT: "aniha %1",
  	SENSING_DAYSSINCE2000: "rojên ji salên 2000an vir de",
  	SENSING_USERNAME: "navê bikarhêner",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "hejmareke ketoberî di navbera %1 - %2an de hilbijêre",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 û %2",
  	OPERATORS_OR: "%1 an jî %2",
  	OPERATORS_NOT: "ne %1 e",
  	OPERATORS_JOIN: "%1 û %2ê tevlî hev bike",
  	OPERATORS_LETTEROF: "tîpa %1. ya '%2ê",
  	OPERATORS_LENGTH: "dirêjiya %1ê",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "bi qasî %1 bizîvirîne",
  	OPERATORS_MATHOP: "%1-a %2ê",
  	OPERATORS_CONTAINS: "di nav %2ê de %1 heye?",
  	DATA_ITEMOFLIST: "hêmana %1 ya %2ê",
  	DATA_ITEMNUMOFLIST: "hêmana %1 ya %2ê",
  	DATA_LENGTHOFLIST: "dirêjiya %1ê",
  	DATA_LISTCONTAINSITEM: "%1 di nav %2ê de heye?",
  	CONTROL_ELSE: "ne ew be",
  	SENSING_USERID: "nasnameya bikarhêner",
  	SENSING_LOUD: "denge bilind?",
  	"text2speech.speakAndWaitBlock": "bipeyive %1",
  	"text2speech.setVoiceBlock": "deng bike %1",
  	"text2speech.setLanguageBlock": "ziman bike %1",
  	"translate.translateBlock": "nivîsa %1ê wergerîne zimanê %2",
  	"translate.viewerLanguage": "ziman",
  	"makeymakey.whenKeyPressed": "dema ku pêlî bişkoka %1ê hate kirin",
  	"makeymakey.whenKeysPressedInOrder": "dema ku bi rêzê pêlî %1ê hate kirin",
  	"microbit.whenButtonPressed": "dema ku pêlî bişkoka %1ê hate kirin",
  	"microbit.isButtonPressed": "pêlî bişkoka %1ê hatiye kirin?",
  	"microbit.whenGesture": "dema ku bû %1",
  	"microbit.displaySymbol": "%1ê nîşan bide",
  	"microbit.displayText": "nivîsa %1ê nîşan bide",
  	"microbit.clearDisplay": "ekranê paqij bike",
  	"microbit.whenTilted": "dema ku %1 hate xwarkirin",
  	"microbit.isTilted": "%1 hatiye xwarkirin?",
  	"microbit.tiltAngle": "pîvana xwarbûnê %1",
  	"microbit.whenPinConnected": "dema ku pîn %1ê hate girêdan",
  	"ev3.motorTurnClockwise": "motora %1ê bi vê hêlê ( > ) ve %2 çirkeyan bizîvirîne",
  	"ev3.motorTurnCounterClockwise": "motora %1ê bi vê hêla ( < ) %2 çirkeyan bizîvirîne",
  	"ev3.motorSetPower": "hêza motora %1ê wekî % %2 saz bike",
  	"ev3.getMotorPosition": "cîgeha motora %1ê",
  	"ev3.whenButtonPressed": "dema ku pêlî bişkoka %1ê hate kirin",
  	"ev3.whenDistanceLessThan": "dema ku mesafe bû < %1",
  	"ev3.whenBrightnessLessThan": "dema ku ronahî bû < %1",
  	"ev3.buttonPressed": "pêlî bişkoka %1ê hate kirin?",
  	"ev3.getDistance": "mesafe",
  	"ev3.getBrightness": "ronahî",
  	"ev3.beepNote": "notaya %1ê %2 çirkeyan lêxe",
  	"wedo2.motorOn": "%1ê veke",
  	"wedo2.motorOff": "%1ê bigire",
  	"wedo2.startMotorPower": "hêza motora %1ê bike % %2",
  	"wedo2.setMotorDirection": "berê motora %1ê bide %2ê",
  	"wedo2.whenDistance": "dema ku mesafe bû %1 %2",
  	"wedo2.getDistance": "mesafe",
  	"wedo2.motorOnFor": "%1ê %2 çirkeyan bixebitîne",
  	"wedo2.setLightHue": "rengê ronahiyê wekî %1 saz bike",
  	"wedo2.playNoteFor": "notaya %1ê %2 çirkeyan lêxe",
  	"wedo2.whenTilted": "dema ku %1 xwar bû",
  	"wedo2.isTilted": "%1 xwar bûye?",
  	"wedo2.getTiltAngle": "pîvana xwarbûnê %1",
  	"gdxfor.whenGesture": "dema ku bû %1",
  	"gdxfor.whenForcePushedOrPulled": "dema ku hêza sensorê bû %1",
  	"gdxfor.getForce": "hêz",
  	"gdxfor.whenTilted": "dema ku xwarbûn bibe %1",
  	"gdxfor.isTilted": "ma %1 xwar e?",
  	"gdxfor.getTilt": "pîvana xwarbûnê %1",
  	"gdxfor.isFreeFalling": "dikeve?",
  	"gdxfor.getSpin": "leza zîvirînê %1",
  	"gdxfor.getAcceleration": "lezîn %1",
  	"boost.motorOnFor": "motora %1ê %2 çirkeyan bixebitîne",
  	"boost.motorOnForRotation": "motora %1ê %2 cara bizîvirîne",
  	"boost.motorOn": "motora %1ê veke",
  	"boost.motorOff": "motora %1ê bigire",
  	"boost.setMotorPower": "hêza motora %1ê wekî % %2 saz bike",
  	"boost.setMotorDirection": "berê motora %1ê wekî %2 saz bike",
  	"boost.getMotorPosition": "cîgeha motora %1ê",
  	"boost.whenColor": "dema ku parçeyê bi rengê %1 hat dîtin",
  	"boost.seeingColor": "parçeyê %1 dibînî?",
  	"boost.whenTilted": "dema ku %1 xwar bû",
  	"boost.getTiltAngle": "pîvana xwarbûnê %1",
  	"boost.setLightHue": "rengê ronahiyê bike %1"
  };
  var dropdowns$w = {
  };
  var ignorelt$w = [
  ];
  var soundEffects$w = [
  	"perdeya deng",
  	"bikişîne rastê-çepê"
  ];
  var microbitWhen$w = [
  	"veguheztî",
  	"hejandî",
  	"gavkirî"
  ];
  var osis$w = [
  	"di pêlîstikê de rêzikên din"
  ];
  var definePrefix$w = [
  ];
  var defineSuffix$w = [
  	"ê",
  	"pênase",
  	"bike"
  ];
  var palette$w = {
  	Motion: "Tevger",
  	Looks: "Xuyang",
  	Sound: "Deng",
  	Events: "Çalakî",
  	Control: "Kontrol",
  	Sensing: "Pêhisîn",
  	Operators: "Operator",
  	Variables: "Guherok",
  	"My Blocks": "Blokên Min"
  };
  var math$w = [
  	"nirxê mutlaq",
  	"bigindirîne erdê",
  	"bigindirîne jorê",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"In",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$w = {
  };
  var name$w = "Kurdî";
  var percentTranslated$w = 100;
  var ku = {
  	commands: commands$w,
  	dropdowns: dropdowns$w,
  	ignorelt: ignorelt$w,
  	soundEffects: soundEffects$w,
  	microbitWhen: microbitWhen$w,
  	osis: osis$w,
  	definePrefix: definePrefix$w,
  	defineSuffix: defineSuffix$w,
  	palette: palette$w,
  	math: math$w,
  	aliases: aliases$w,
  	name: name$w,
  	percentTranslated: percentTranslated$w
  };

  var commands$v = {
  	MOTION_MOVESTEPS: "eik %1",
  	MOTION_TURNRIGHT: "pasisuk @turnRight %1 laipsnių",
  	MOTION_TURNLEFT: "pasisuk @turnLeft %1 laipsnių",
  	MOTION_POINTINDIRECTION: "žiūrėk %1 laipsnių kryptimi",
  	MOTION_POINTTOWARDS: "žiūrėk į %1",
  	MOTION_GOTOXY: "eik į x: %1 y: %2",
  	MOTION_GOTO: "eik ten, kur %1",
  	MOTION_GLIDESECSTOXY: "slink į x: %2 y: %3 per %1 s.",
  	MOTION_GLIDETO: "slink ten, kur %2 per %1 s.",
  	MOTION_CHANGEXBY: "x padidink %1",
  	MOTION_SETX: "x = %1",
  	MOTION_CHANGEYBY: "y padidink %1",
  	MOTION_SETY: "y = %1",
  	MOTION_SETROTATIONSTYLE: "sukimosi būdas = %1",
  	LOOKS_SAYFORSECS: "sakyk %1 %2 s.",
  	LOOKS_SAY: "sakyk %1",
  	LOOKS_THINKFORSECS: "galvok %1 %2 s.",
  	LOOKS_THINK: "galvok %1",
  	LOOKS_SHOW: "rodyk",
  	LOOKS_HIDE: "slėpk",
  	LOOKS_SWITCHCOSTUMETO: "kaukė = %1",
  	LOOKS_NEXTCOSTUME: "kita kaukė",
  	LOOKS_NEXTBACKDROP_BLOCK: "kitas  fonas",
  	LOOKS_SWITCHBACKDROPTO: "fonas = %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "fonas = %1 (palauk, kol pasikeis)",
  	LOOKS_CHANGEEFFECTBY: "efektą %1 padidink %2",
  	LOOKS_SETEFFECTTO: "efektas %1 = %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "panaikink išvaizdos efektus",
  	LOOKS_CHANGESIZEBY: "dydį padidink %1",
  	LOOKS_SETSIZETO: "dydis = %1 %",
  	LOOKS_GOTOFRONTBACK: "perkelk į %1 sluoksnį",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "perkelti per %2 sluoksnius %1",
  	SOUND_PLAY: "grok %1",
  	SOUND_CHANGEEFFECTBY: "efektą %1 padidink %2",
  	SOUND_SETEFFECTO: "efektas %1 = %2",
  	SOUND_CLEAREFFECTS: "pašalink garso efektus",
  	SOUND_PLAYUNTILDONE: "grok %1 kol pasibaigs",
  	SOUND_STOPALLSOUNDS: "išjunk garsus",
  	"music.playDrumForBeats": "groti būgnu %1 tiek taktų: %2",
  	"music.restForBeats": "pauzė tiek taktų: %1",
  	"music.playNoteForBeats": "groti natą %1 tiek taktų: %2",
  	"music.setInstrument": "instrumentą nustatyti į %1",
  	SOUND_CHANGEVOLUMEBY: "garsą padidink %1",
  	SOUND_SETVOLUMETO: "garsumas = %1%",
  	"music.changeTempo": "tempą padidink %1",
  	"music.setTempo": "keisti tempą į %1",
  	"pen.clear": "ištrinti viską",
  	"pen.stamp": "antspaudas",
  	"pen.penDown": "pieštukas pieš",
  	"pen.penUp": "pieštukas nebepieš",
  	"pen.setColor": "keisti pieštuko spalvą į %1",
  	"pen.changeHue": "keisk pieštuko spalvą per %1",
  	"pen.setColorParam": "piešimo %1 = %2",
  	"pen.changeColorParam": "keisk pieštuko %1per%2",
  	"pen.setHue": "piešimo atspalvis = %1",
  	"pen.changeShade": "keisk pieštuko atspalvį per %1",
  	"pen.setShade": "keisti pieštuko atspalvį į %1",
  	"pen.changeSize": "keisk pieštuko dydį per %1",
  	"pen.setSize": "keisti pieštuko dydį į %1",
  	EVENT_WHENFLAGCLICKED: "kai spusteli @greenFlag",
  	EVENT_WHENKEYPRESSED: "kai paspaudi %1",
  	EVENT_WHENTHISSPRITECLICKED: "kai spusteli ant šio veikėjo",
  	EVENT_WHENSTAGECLICKED: "kai paspaudi scenoje",
  	EVENT_WHENBACKDROPSWITCHESTO: "kai fonas perjungiamas į %1",
  	EVENT_WHENGREATERTHAN: "kai %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kai gausi žinutę %1",
  	EVENT_BROADCAST: "skelbti %1",
  	EVENT_BROADCASTANDWAIT: "skelbti %1 ir palaukti",
  	CONTROL_WAIT: "palauk %1 sek.",
  	CONTROL_REPEAT: "kartok %1",
  	CONTROL_FOREVER: "kartok be galo",
  	CONTROL_IF: "jeigu %1",
  	CONTROL_WAITUNTIL: "palauk, kol pasidarys %1",
  	CONTROL_REPEATUNTIL: "kartok, kol pasidarys %1",
  	CONTROL_STOP: "sustok %1",
  	CONTROL_STARTASCLONE: "kai pradės veikti klonas",
  	CONTROL_CREATECLONEOF: "sukurk %1 kloną",
  	CONTROL_DELETETHISCLONE: "ištrink šį kloną",
  	SENSING_ASKANDWAIT: "paklausk %1 ir lauk",
  	"videoSensing.videoToggle": "perjungti video į %1",
  	"videoSensing.setVideoTransparency": "nustatyk video permatomumą į%1",
  	"videoSensing.whenMotionGreaterThan": "kai judesio vaizde > %1",
  	SENSING_RESETTIMER: "laikmatis = 0",
  	DATA_SETVARIABLETO: "%1 = %2",
  	DATA_CHANGEVARIABLEBY: "%1 padidink %2",
  	DATA_SHOWVARIABLE: "rodyk %1",
  	DATA_HIDEVARIABLE: "slėpk %1",
  	DATA_ADDTOLIST: "pridėk %1 į %2",
  	DATA_DELETEOFLIST: "ištrinti %1 iš %2",
  	DATA_DELETEALLOFLIST: "ištrinti visus iš %1",
  	MOTION_IFONEDGEBOUNCE: "jei prie krašto, atšok",
  	DATA_INSERTATLIST: "į sąrašo %3 %2 vietą įterpti %1",
  	DATA_REPLACEITEMOFLIST: "sąrašo %2  %1 vietai priskirti %3",
  	DATA_SHOWLIST: "rodyti sąrašą %1",
  	DATA_HIDELIST: "slėpti sąrašą %1",
  	SENSING_OF_XPOSITION: "x koordinatė",
  	SENSING_OF_YPOSITION: "y koordinatė",
  	SENSING_OF_DIRECTION: "kryptis",
  	SENSING_OF_COSTUMENUMBER: "kaukės nr.",
  	LOOKS_COSTUMENUMBERNAME: "kaukė %1",
  	SENSING_OF_SIZE: "dydis",
  	SENSING_OF_BACKDROPNAME: "fono pavadinimas",
  	LOOKS_BACKDROPNUMBERNAME: "fonas %1",
  	SENSING_OF_BACKDROPNUMBER: "fono nr.",
  	SOUND_VOLUME: "garsumas",
  	"music.getTempo": "tempas",
  	SENSING_TOUCHINGOBJECT: "lieti %1?",
  	SENSING_TOUCHINGCOLOR: "lieti spalvą %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "spalva %1 liečia %2?",
  	SENSING_DISTANCETO: "atstumas iki %1",
  	SENSING_ANSWER: "atsakas",
  	SENSING_KEYPRESSED: "%1 paspausta?",
  	SENSING_MOUSEDOWN: "pelė paspausta?",
  	SENSING_MOUSEX: "pelės x",
  	SENSING_MOUSEY: "pelės y",
  	SENSING_SETDRAGMODE: "vilkimas pele = %1",
  	SENSING_LOUDNESS: "garsumas",
  	"videoSensing.videoOn": "video %1iš%2",
  	SENSING_TIMER: "laikmatis",
  	SENSING_OF: "%2 : %1",
  	SENSING_CURRENT: "šio momento %1",
  	SENSING_DAYSSINCE2000: "dienų skaičius nuo 2000-ųjų",
  	SENSING_USERNAME: "vartotojo vardas",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "atsitiktinis sk. tarp %1 ir %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 ir %2",
  	OPERATORS_OR: "%1 arba %2",
  	OPERATORS_NOT: "ne %1",
  	OPERATORS_JOIN: "sujunk %1 ir %2",
  	OPERATORS_LETTEROF: "%2 raidė nr. %1",
  	OPERATORS_LENGTH: "%1 ilgis",
  	OPERATORS_MOD: "%1 / %2 liekana",
  	OPERATORS_ROUND: "suapvalinta %1",
  	OPERATORS_MATHOP: "%1 ( %2 )",
  	OPERATORS_CONTAINS: "ar %1 turi %2?",
  	DATA_ITEMOFLIST: "%2 nr. %1",
  	DATA_ITEMNUMOFLIST: "%1 vieta sąraše %2",
  	DATA_LENGTHOFLIST: "%1 ilgis",
  	DATA_LISTCONTAINSITEM: "%1 turi %2?",
  	CONTROL_ELSE: "kitais atvejais",
  	SENSING_USERID: "vartotojo ID",
  	SENSING_LOUD: "garsiai?",
  	"text2speech.speakAndWaitBlock": "sakyti %1",
  	"text2speech.setVoiceBlock": "keisti balsą į %1",
  	"text2speech.setLanguageBlock": "keisti kalbą į %1",
  	"translate.translateBlock": "išversti %1 į %2",
  	"translate.viewerLanguage": "kalba",
  	"makeymakey.whenKeyPressed": "Kai %1 paspaustas",
  	"makeymakey.whenKeysPressedInOrder": "Kai seka %1 suvesta",
  	"microbit.whenButtonPressed": "kai paspaudi mygtuką %1",
  	"microbit.isButtonPressed": "ar nuspaustas mygtukas %1?",
  	"microbit.whenGesture": "kai %1",
  	"microbit.displaySymbol": "rodyti %1",
  	"microbit.displayText": "rodyti tekstą %1",
  	"microbit.clearDisplay": "išvalyti ekraną",
  	"microbit.whenTilted": "kai paversta %1",
  	"microbit.isTilted": "ar paversta %1?",
  	"microbit.tiltAngle": "paversta kampu %1",
  	"microbit.whenPinConnected": "kai prijungtas kištukas %1",
  	"ev3.motorTurnClockwise": "%1 variklį sukti šia kryptimi tiek sekundžių: %2",
  	"ev3.motorTurnCounterClockwise": "%1 variklį sukti šia kryptimi tiek sekundžių: %2",
  	"ev3.motorSetPower": "%1 varikliui nustatyti jėgą %2 %",
  	"ev3.getMotorPosition": "%1 variklio pozicija",
  	"ev3.whenButtonPressed": "kai nuspaudžiamas mygtukas %1",
  	"ev3.whenDistanceLessThan": "kai atstumas < %1",
  	"ev3.whenBrightnessLessThan": "kai šviesumas < %1",
  	"ev3.buttonPressed": "ar mygtukas %1 nuspaustas?",
  	"ev3.getDistance": "atstumas",
  	"ev3.getBrightness": "šviesumas",
  	"ev3.beepNote": "groti natą %1tiek sekundžių: %2",
  	"wedo2.motorOn": "įjungti %1",
  	"wedo2.motorOff": "išjungti %1",
  	"wedo2.startMotorPower": "%1 galia = %2",
  	"wedo2.setMotorDirection": "%1 kryptis = %2",
  	"wedo2.whenDistance": "kai atstumas %1 %2",
  	"wedo2.getDistance": "atstumas",
  	"wedo2.motorOnFor": "įjungti %1  %2 sekundžių",
  	"wedo2.setLightHue": "spalvos tonas = %1",
  	"wedo2.playNoteFor": "groti natą %1  %2 s.",
  	"wedo2.whenTilted": "kai paversta %1",
  	"wedo2.isTilted": "ar paversta %1?",
  	"wedo2.getTiltAngle": "paversta kryptimi %1",
  	"gdxfor.whenGesture": "kai %1",
  	"gdxfor.whenForcePushedOrPulled": "kai jėgos jutiklis %1",
  	"gdxfor.getForce": "jėga",
  	"gdxfor.whenTilted": "pakreipus %1",
  	"gdxfor.isTilted": "Pasukta %1?",
  	"gdxfor.getTilt": "pasvirk kampu %1",
  	"gdxfor.isFreeFalling": "krenta?",
  	"gdxfor.getSpin": "sukimosi greitis %1]",
  	"gdxfor.getAcceleration": "pagreitis %1",
  	"boost.motorOnFor": "suk variklį %1  %2 sekundes",
  	"boost.motorOnForRotation": "suk variklį %1  %2 apsukas",
  	"boost.motorOn": "įjunk variklį %1",
  	"boost.motorOff": "išjunk variklį %1",
  	"boost.setMotorPower": "nustatyti variklio %1 greitį į %2 %",
  	"boost.setMotorDirection": "nustatyti variklio %1 kryptį %2",
  	"boost.getMotorPosition": "variklio %1 pozicija",
  	"boost.whenColor": "kai %1 bloko matoma",
  	"boost.seeingColor": "matoma %1 blokų?",
  	"boost.whenTilted": "kai paversta %1",
  	"boost.getTiltAngle": "paversk kryptimi %1",
  	"boost.setLightHue": "keisti šviesos spalvą į %1"
  };
  var dropdowns$v = {
  };
  var ignorelt$v = [
  ];
  var soundEffects$v = [
  	"garso aukštis",
  	"kairiau/dešiniau"
  ];
  var microbitWhen$v = [
  	"pajudinta",
  	"papurtyta",
  	"šuolis"
  ];
  var osis$v = [
  	"kitus veikėjo scenarijus"
  ];
  var definePrefix$v = [
  	"komanda"
  ];
  var defineSuffix$v = [
  ];
  var palette$v = {
  	Motion: "Judėjimas",
  	Looks: "Išvaizda",
  	Sound: "Garsas",
  	Events: "Įvykiai",
  	Control: "Valdymas",
  	Sensing: "Jutimas",
  	Operators: "Matematika",
  	Variables: "Kintamieji",
  	"My Blocks": "Mano Komandos"
  };
  var math$v = [
  	"teigiama reikšmė",
  	"apvalinimas žemyn",
  	"apvalinimas aukštyn",
  	"kvadratinė šaknis",
  	"sin",
  	"cos",
  	"tg",
  	"arcsin",
  	"arccos",
  	"arctg",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$v = {
  };
  var name$v = "Lietuvių";
  var percentTranslated$v = 100;
  var lt = {
  	commands: commands$v,
  	dropdowns: dropdowns$v,
  	ignorelt: ignorelt$v,
  	soundEffects: soundEffects$v,
  	microbitWhen: microbitWhen$v,
  	osis: osis$v,
  	definePrefix: definePrefix$v,
  	defineSuffix: defineSuffix$v,
  	palette: palette$v,
  	math: math$v,
  	aliases: aliases$v,
  	name: name$v,
  	percentTranslated: percentTranslated$v
  };

  var commands$u = {
  	MOTION_MOVESTEPS: "pārvietoties %1 soļus",
  	MOTION_TURNRIGHT: "pagriezties @turnRight par %1 grādiem",
  	MOTION_TURNLEFT: "pagriezties @turnLeft par %1 grādiem",
  	MOTION_POINTINDIRECTION: "pagriezt virzienā %1",
  	MOTION_POINTTOWARDS: "pagriezt uz %1",
  	MOTION_GOTOXY: "iet uz x: %1 y: %2",
  	MOTION_GOTO: "iet uz %1",
  	MOTION_GLIDESECSTOXY: "slīdēt %1 sekundes uz x: %2 y: %3",
  	MOTION_GLIDETO: "slīdēt %1 sekundes uz %2",
  	MOTION_CHANGEXBY: "mainīt x par %1",
  	MOTION_SETX: "iestatīt x uz %1",
  	MOTION_CHANGEYBY: "mainīt y par %1",
  	MOTION_SETY: "iestatīt y uz %1",
  	MOTION_SETROTATIONSTYLE: "iestatīt griešanās stilu uz %1",
  	LOOKS_SAYFORSECS: "teikt %1 %2 sekundes",
  	LOOKS_SAY: "teikt %1",
  	LOOKS_THINKFORSECS: "domāt %1 %2 sekundes",
  	LOOKS_THINK: "domāt %1",
  	LOOKS_SHOW: "rādīt",
  	LOOKS_HIDE: "slēpt",
  	LOOKS_SWITCHCOSTUMETO: "mainīt tērpu uz %1",
  	LOOKS_NEXTCOSTUME: "nākamais tērps",
  	LOOKS_NEXTBACKDROP_BLOCK: "nākamais fons",
  	LOOKS_SWITCHBACKDROPTO: "mainīt fonu uz %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "mainīt fonu uz %1 un gaidīt",
  	LOOKS_CHANGEEFFECTBY: "mainīt efektu %1 par %2",
  	LOOKS_SETEFFECTTO: "iestatīt efektu %1 par %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "notīrīt grafiskos efektus",
  	LOOKS_CHANGESIZEBY: "mainīt izmēru par %1",
  	LOOKS_SETSIZETO: "iestatīt izmēru uz %1 %",
  	LOOKS_GOTOFRONTBACK: "iet uz %1 slāni",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "iet %1 %2 slāņus",
  	SOUND_PLAY: "atskaņot skaņu %1",
  	SOUND_CHANGEEFFECTBY: "mainīt efektu %1 par %2",
  	SOUND_SETEFFECTO: "iestatīt efektu %1 uz %2",
  	SOUND_CLEAREFFECTS: "notīrīt skaņas efektus",
  	SOUND_PLAYUNTILDONE: "atskaņot skaņu %1 līdz galam",
  	SOUND_STOPALLSOUNDS: "apturēt visas skaņas",
  	"music.playDrumForBeats": "spēlēt bungas %1 %2 sitienus",
  	"music.restForBeats": "pauze %1 sitienus",
  	"music.playNoteForBeats": "spēlēt noti %1 %2 sitienus",
  	"music.setInstrument": "iestatīt instrumentu uz %1",
  	SOUND_CHANGEVOLUMEBY: "mainīt skaļumu par %1",
  	SOUND_SETVOLUMETO: "iestatīt skaļumu uz %1%",
  	"music.changeTempo": "mainīt tempu par %1",
  	"music.setTempo": "iestatīt tempu uz %1",
  	"pen.clear": "notīrīt visu",
  	"pen.stamp": "zīmogs",
  	"pen.penDown": "zīmulis piespiests",
  	"pen.penUp": "zīmulis pacelts",
  	"pen.setColor": "iestatīt zīmuļa krāsu uz %1",
  	"pen.changeHue": "mainīt zīmuļa krāsu par %1",
  	"pen.setColorParam": "iestatīt zīmuļa %1 uz %2",
  	"pen.changeColorParam": "mainīt zīmuļa %1 par %2",
  	"pen.setHue": "iestatīt zīmuļa krāsu uz %1",
  	"pen.changeShade": "mainīt zīmuļa tumšumu par %1",
  	"pen.setShade": "iestatīt zīmuļa tumšumu uz %1",
  	"pen.changeSize": "mainīt zīmuļa izmēru par %1",
  	"pen.setSize": "iestatīt zīmuļa izmēru uz %1",
  	EVENT_WHENFLAGCLICKED: "kad @greenFlag nospiests",
  	EVENT_WHENKEYPRESSED: "kad nospiests taustiņš %1",
  	EVENT_WHENTHISSPRITECLICKED: "kad noklikšķināts šis gariņš",
  	EVENT_WHENSTAGECLICKED: "kad noklikšķināta skatuve",
  	EVENT_WHENBACKDROPSWITCHESTO: "kad fons nomainās uz %1",
  	EVENT_WHENGREATERTHAN: "kad %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kad es saņemu %1",
  	EVENT_BROADCAST: "pārraidīt %1",
  	EVENT_BROADCASTANDWAIT: "pārraidīt %1 un gaidīt",
  	CONTROL_WAIT: "gaidīt %1 sekundes",
  	CONTROL_REPEAT: "atkārtot %1",
  	CONTROL_FOREVER: "nepārtraukti",
  	CONTROL_IF: "ja %1 tad",
  	CONTROL_WAITUNTIL: "gaidīt līdz %1",
  	CONTROL_REPEATUNTIL: "atkārtot līdz %1",
  	CONTROL_STOP: "apturēt %1",
  	CONTROL_STARTASCLONE: "kad es parādos kā dublikāts",
  	CONTROL_CREATECLONEOF: "izveidot %1 dublikātu",
  	CONTROL_DELETETHISCLONE: "dzēst šo dublikātu",
  	SENSING_ASKANDWAIT: "jautāt %1 un gaidīt",
  	"videoSensing.videoToggle": "%1video",
  	"videoSensing.setVideoTransparency": "iestatīt video caurspīdīgumu uz %1",
  	"videoSensing.whenMotionGreaterThan": "kad video kustība > %1",
  	SENSING_RESETTIMER: "atiestatīt taimeri",
  	DATA_SETVARIABLETO: "iestatīt %1 uz %2",
  	DATA_CHANGEVARIABLEBY: "mainīt %1 par %2",
  	DATA_SHOWVARIABLE: "rādīt mainīgo %1",
  	DATA_HIDEVARIABLE: "slēpt mainīgo %1",
  	DATA_ADDTOLIST: "pievienot %1 pie %2",
  	DATA_DELETEOFLIST: "dzēst %1 no %2",
  	DATA_DELETEALLOFLIST: "dzēst visu no %1",
  	MOTION_IFONEDGEBOUNCE: "ja uz malas, atlēkt",
  	DATA_INSERTATLIST: "ievietot %1 kā %2 sarakstā %3",
  	DATA_REPLACEITEMOFLIST: "aizvietot %1 vienumu sarakstā %2 ar %3",
  	DATA_SHOWLIST: "rādīt sarakstu %1",
  	DATA_HIDELIST: "slēpt sarakstu %1",
  	SENSING_OF_XPOSITION: "x pozīcija",
  	SENSING_OF_YPOSITION: "y pozīcija",
  	SENSING_OF_DIRECTION: "virziens",
  	SENSING_OF_COSTUMENUMBER: "tērpa #",
  	LOOKS_COSTUMENUMBERNAME: "tērpa %1",
  	SENSING_OF_SIZE: "izmērs",
  	SENSING_OF_BACKDROPNAME: "fona nosaukums",
  	LOOKS_BACKDROPNUMBERNAME: "fona %1",
  	SENSING_OF_BACKDROPNUMBER: "fona #",
  	SOUND_VOLUME: "skaļums",
  	"music.getTempo": "temps",
  	SENSING_TOUCHINGOBJECT: "pieskaras %1?",
  	SENSING_TOUCHINGCOLOR: "pieskaras krāsai %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "krāsa %1 pieskaras %2?",
  	SENSING_DISTANCETO: "attālums līdz %1",
  	SENSING_ANSWER: "atbilde",
  	SENSING_KEYPRESSED: "nospiests taustiņš %1?",
  	SENSING_MOUSEDOWN: "peles taustiņš nospiests?",
  	SENSING_MOUSEX: "peles x",
  	SENSING_MOUSEY: "peles y",
  	SENSING_SETDRAGMODE: "iestatīt vilkšanas režīmu uz %1",
  	SENSING_LOUDNESS: "skaļums",
  	"videoSensing.videoOn": "video %1 uz %2",
  	SENSING_TIMER: "taimeris",
  	SENSING_OF: "%1 no %2",
  	SENSING_CURRENT: "pašreizējais %1",
  	SENSING_DAYSSINCE2000: "dienas kopš 2000",
  	SENSING_USERNAME: "lietotājvārds",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "izvēlēties nejauši no %1 līdz %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 un %2",
  	OPERATORS_OR: "%1 vai %2",
  	OPERATORS_NOT: "nav  %1",
  	OPERATORS_JOIN: "apvienot %1 %2",
  	OPERATORS_LETTEROF: "burts %1 no %2",
  	OPERATORS_LENGTH: "%1 garums",
  	OPERATORS_MOD: "%1 atlikums dalot ar %2",
  	OPERATORS_ROUND: "noapaļot %1",
  	OPERATORS_MATHOP: "%1 no %2",
  	OPERATORS_CONTAINS: "%1 satur %2?",
  	DATA_ITEMOFLIST: "vienums %1 sarakstā %2",
  	DATA_ITEMNUMOFLIST: "vienuma %1 # sarakstā %2",
  	DATA_LENGTHOFLIST: "%1 garums",
  	DATA_LISTCONTAINSITEM: "%1 satur %2?",
  	CONTROL_ELSE: "citādi",
  	SENSING_USERID: "lietotāja id",
  	SENSING_LOUD: "skaļš?",
  	"text2speech.speakAndWaitBlock": "teikt %1",
  	"text2speech.setVoiceBlock": "iestatīt balsi uz %1",
  	"text2speech.setLanguageBlock": "iestatīt valodu uz %1",
  	"translate.translateBlock": "tulkot %1 uz %2",
  	"translate.viewerLanguage": "valoda",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "kad poga %1 piespiesta",
  	"microbit.isButtonPressed": "%1 poga piespiesta?",
  	"microbit.whenGesture": "kad %1",
  	"microbit.displaySymbol": "rādīt %1",
  	"microbit.displayText": "rādīt tekstu %1",
  	"microbit.clearDisplay": "notīrīt ekrānu",
  	"microbit.whenTilted": "kad noliekts %1",
  	"microbit.isTilted": "noliekts %1?",
  	"microbit.tiltAngle": "noliekt leņķī %1",
  	"microbit.whenPinConnected": "kad spraudnis %1 savienots",
  	"ev3.motorTurnClockwise": "motoru %1 pagriezt šajā virzienā %2 sekundes",
  	"ev3.motorTurnCounterClockwise": "motoru %1 pagriezt tajā virzienā %2 sekundes",
  	"ev3.motorSetPower": "motoram %1 iestatīt enerģiju uz %2 %",
  	"ev3.getMotorPosition": "motora %1 pozīcija",
  	"ev3.whenButtonPressed": "kad poga %1 piespiesta",
  	"ev3.whenDistanceLessThan": "kad attālums < %1",
  	"ev3.whenBrightnessLessThan": "kad gaišums < %1",
  	"ev3.buttonPressed": "poga %1 piespiesta?",
  	"ev3.getDistance": "attālums",
  	"ev3.getBrightness": "gaišums",
  	"ev3.beepNote": "pīkstināt noti %1 %2 sekundes",
  	"wedo2.motorOn": "ieslēgt %1",
  	"wedo2.motorOff": "izslēgt %1",
  	"wedo2.startMotorPower": "iestatīt %1 enerģiju uz %2",
  	"wedo2.setMotorDirection": "iestatīt %1 virzienu uz %2",
  	"wedo2.whenDistance": "kad attālums %1%2",
  	"wedo2.getDistance": "attālums",
  	"wedo2.motorOnFor": "ieslēgt %1 %2 sekundes",
  	"wedo2.setLightHue": "iestatīt gaismas krāsu uz %1",
  	"wedo2.playNoteFor": "spēlēt noti %1 %2 sekundes",
  	"wedo2.whenTilted": "kad noliekts %1",
  	"wedo2.isTilted": "noliekts %1?",
  	"wedo2.getTiltAngle": "noliekt leņķī %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "spēks",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "paātrinājums %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$u = {
  };
  var ignorelt$u = [
  ];
  var soundEffects$u = [
  	"augstums",
  	"bīdīt pa labi/pa kreisi"
  ];
  var microbitWhen$u = [
  	"pārvietojās",
  	"pakratījās",
  	"palēcās"
  ];
  var osis$u = [
  	"citi skripti gariņā"
  ];
  var definePrefix$u = [
  	"definēt"
  ];
  var defineSuffix$u = [
  ];
  var palette$u = {
  	Motion: "Kustība",
  	Looks: "Izskats",
  	Sound: "Skaņa",
  	Events: "Notikumi",
  	Control: "Vadība",
  	Sensing: "Uztveršana",
  	Operators: "Operatori",
  	Variables: "Mainīgie",
  	"My Blocks": "Mani bloki"
  };
  var math$u = [
  	"modulis (absolūtā vērtība)",
  	"apaļot uz leju",
  	"apaļot uz augšu",
  	"kvadrātsakne",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"In",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$u = {
  };
  var name$u = "Latviešu";
  var percentTranslated$u = 100;
  var lv = {
  	commands: commands$u,
  	dropdowns: dropdowns$u,
  	ignorelt: ignorelt$u,
  	soundEffects: soundEffects$u,
  	microbitWhen: microbitWhen$u,
  	osis: osis$u,
  	definePrefix: definePrefix$u,
  	defineSuffix: defineSuffix$u,
  	palette: palette$u,
  	math: math$u,
  	aliases: aliases$u,
  	name: name$u,
  	percentTranslated: percentTranslated$u
  };

  var commands$t = {
  	MOTION_MOVESTEPS: "nekehia kia %1 ngā takahanga",
  	MOTION_TURNRIGHT: "hurihia @turnRight, kia %1 putu",
  	MOTION_TURNLEFT: "hurihia @turnLeft, kia %1 putu",
  	MOTION_POINTINDIRECTION: "atatohua ki %1",
  	MOTION_POINTTOWARDS: "atatohua ki %1",
  	MOTION_GOTOXY: "neke ki x: %1 y: %2",
  	MOTION_GOTO: "neke ki %1",
  	MOTION_GLIDESECSTOXY: "wania kia %1 hēkona ki x: %2 y: %3",
  	MOTION_GLIDETO: "wania kia %1 hēkona ki %2",
  	MOTION_CHANGEXBY: "panonitia x mā te %1",
  	MOTION_SETX: "tautuhia te x kia %1",
  	MOTION_CHANGEYBY: "panonitia y mā te %1",
  	MOTION_SETY: "tautuhia te y kia %1",
  	MOTION_SETROTATIONSTYLE: "tautuhia te momo huringa kia %1",
  	LOOKS_SAYFORSECS: "kīia %1 mō ngā hēkona %2",
  	LOOKS_SAY: "kīia %1",
  	LOOKS_THINKFORSECS: "whakaarohia te %1 mō ngā hēkona %2",
  	LOOKS_THINK: "whakaarohia te %1",
  	LOOKS_SHOW: "whakaatu",
  	LOOKS_HIDE: "huna",
  	LOOKS_SWITCHCOSTUMETO: "panonitia te kākahu kia %1",
  	LOOKS_NEXTCOSTUME: "kākahu panuku",
  	LOOKS_NEXTBACKDROP_BLOCK: "ārai tuarongo panuku",
  	LOOKS_SWITCHBACKDROPTO: "panonitia te ārai tuarongo kia %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "panonitia te ārai tuarongo kia %1, kātahi, tatari",
  	LOOKS_CHANGEEFFECTBY: "panonitia te rākeitanga %1 mā te %2",
  	LOOKS_SETEFFECTTO: "panonitia te rākeitanga %1 ki te %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "ūkui rākeitanga whakairoiro",
  	LOOKS_CHANGESIZEBY: "panonitia te rahi mā te %1",
  	LOOKS_SETSIZETO: "tautuhia te rahi kia %1 %",
  	LOOKS_GOTOFRONTBACK: "haere ki te apa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "nekehia %1, kia %2 ngā apaapa",
  	SOUND_PLAY: "tīmatahia te whakatangi i te oro %1",
  	SOUND_CHANGEEFFECTBY: "panonitia te rākeitanga %1 mā te %2",
  	SOUND_SETEFFECTO: "tautuhia te rākeitanga %1 kia %2",
  	SOUND_CLEAREFFECTS: "ūkui rākeitanga orotaunaki",
  	SOUND_PLAYUNTILDONE: "whakatangihia te oro %1 kia mutu rawa",
  	SOUND_STOPALLSOUNDS: "katia ngā oro katoa",
  	"music.playDrumForBeats": "whakatangihia te pahū %1 mō ngā taki %2",
  	"music.restForBeats": "tatari mō ngā taki %1",
  	"music.playNoteForBeats": "whakatangihia te oro %1 mō ngā taki %2",
  	"music.setInstrument": "tautuhia te taonga puoro ki te %1",
  	SOUND_CHANGEVOLUMEBY: "panonitia te kahaoro mā te %1",
  	SOUND_SETVOLUMETO: "tautuhia te kahaoro kia %1%",
  	"music.changeTempo": "panonitia te tere mā te %1",
  	"music.setTempo": "tautuhia te tere kia %1",
  	"pen.clear": "Kōmurutia te katoa",
  	"pen.stamp": "waitohu",
  	"pen.penDown": "pene ki raro",
  	"pen.penUp": "pene ki runga",
  	"pen.setColor": "tautuhia te tae o te pene kia %1",
  	"pen.changeHue": "panonitia te tae o te pene mā te %1",
  	"pen.setColorParam": "tautuhia te %1 o te pene kia %2",
  	"pen.changeColorParam": "panonitia te %1 o te pene mā te %2",
  	"pen.setHue": "tautuhia te tae o te pene kia %1",
  	"pen.changeShade": "panonitia te kauruku o te pene mā te %1",
  	"pen.setShade": "tautuhia te kauruku o te pene kia %1",
  	"pen.changeSize": "panonitia te nui o te pene mā te %1",
  	"pen.setSize": "tautuhia te nui o te pene kia %1",
  	EVENT_WHENFLAGCLICKED: "ina pāwhiria te @greenFlag",
  	EVENT_WHENKEYPRESSED: "ina pēhia te pātuhi %1",
  	EVENT_WHENTHISSPRITECLICKED: "ina pāwhiria tēnei parehe",
  	EVENT_WHENSTAGECLICKED: "ina pāwhiria te Atamira",
  	EVENT_WHENBACKDROPSWITCHESTO: "ina hurihia te ārai tuarongo kia %1",
  	EVENT_WHENGREATERTHAN: "mēnā %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ina ka riro mai te %1",
  	EVENT_BROADCAST: "whakapaoho %1",
  	EVENT_BROADCASTANDWAIT: "whakapaoho %1, kātahi tatari",
  	CONTROL_WAIT: "tatari kia %1 hēkona",
  	CONTROL_REPEAT: "tōaitia %1",
  	CONTROL_FOREVER: "mō ake, ake mahia",
  	CONTROL_IF: "mēnā %1 mahia",
  	CONTROL_WAITUNTIL: "tatari kia %1",
  	CONTROL_REPEATUNTIL: "tōaitia tonutia kia %1",
  	CONTROL_STOP: "katia %1",
  	CONTROL_STARTASCLONE: "ina ka tīmata mai ahau hei tārua",
  	CONTROL_CREATECLONEOF: "whakapūruatia %1",
  	CONTROL_DELETETHISCLONE: "mukua tēnei tāruarua",
  	SENSING_ASKANDWAIT: "pātai %1, kātahi, tatari",
  	"videoSensing.videoToggle": "hurihia te ataata kia %1",
  	"videoSensing.setVideoTransparency": "tautuhia te pūatatata o te ataata kia %1",
  	"videoSensing.whenMotionGreaterThan": "ina te nekenekehanga o te ataata > %1",
  	SENSING_RESETTIMER: "tautuhia anōtia te taima",
  	DATA_SETVARIABLETO: "tautuhia %1 ki te %2",
  	DATA_CHANGEVARIABLEBY: "panonitia %1 mā te %2",
  	DATA_SHOWVARIABLE: "whakaaturia te taurangi %1",
  	DATA_HIDEVARIABLE: "hunaia te taurangi %1",
  	DATA_ADDTOLIST: "tāpiritia te %1 ki te %2",
  	DATA_DELETEOFLIST: "mukua %1 i a %2",
  	DATA_DELETEALLOFLIST: "mukua te katoa o %1",
  	MOTION_IFONEDGEBOUNCE: "mēnā kei te taitapa, tupanatia",
  	DATA_INSERTATLIST: "whakaurua te %1 hei %2 o %3",
  	DATA_REPLACEITEMOFLIST: "whakakapia te tūemi %1 o %2, ki %3",
  	DATA_SHOWLIST: "whakaaturia te rārangi %1",
  	DATA_HIDELIST: "hunāia te rārangi %1",
  	SENSING_OF_XPOSITION: "tūnga x",
  	SENSING_OF_YPOSITION: "tūnga y",
  	SENSING_OF_DIRECTION: "ahunga",
  	SENSING_OF_COSTUMENUMBER: "kākahu #",
  	LOOKS_COSTUMENUMBERNAME: "kākahu %1",
  	SENSING_OF_SIZE: "rahi",
  	SENSING_OF_BACKDROPNAME: "ingoa ārai tuarongo",
  	LOOKS_BACKDROPNUMBERNAME: "ārai tuarongo %1",
  	SENSING_OF_BACKDROPNUMBER: "ārai tuarongo #",
  	SOUND_VOLUME: "kahaoro",
  	"music.getTempo": "tere",
  	SENSING_TOUCHINGOBJECT: "kei te pā ki te %1?",
  	SENSING_TOUCHINGCOLOR: "kei te pā ki te tae %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "ka pā te tae %1 i te %2?",
  	SENSING_DISTANCETO: "tawhiti ki %1",
  	SENSING_ANSWER: "whakautu",
  	SENSING_KEYPRESSED: "kua pēhia te pātuhi %1?",
  	SENSING_MOUSEDOWN: "pāwhiri kiore?",
  	SENSING_MOUSEX: "x kiore",
  	SENSING_MOUSEY: "y kiore",
  	SENSING_SETDRAGMODE: "tautuhia te aratau tō kia %1",
  	SENSING_LOUDNESS: "hoihoi",
  	"videoSensing.videoOn": "ataata %1 kei %2",
  	SENSING_TIMER: "taima",
  	SENSING_OF: "%1 o %2",
  	SENSING_CURRENT: "%1 o nāianei",
  	SENSING_DAYSSINCE2000: "ngā rā mai i 2000",
  	SENSING_USERNAME: "ingoa kaiwhakamahi",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "kōwhiria matapōkere %1 ki te %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 me %2",
  	OPERATORS_OR: "%1, %2 rānei",
  	OPERATORS_NOT: "ehara ko te %1",
  	OPERATORS_JOIN: "tāpiritia te %1, %2",
  	OPERATORS_LETTEROF: "te pū %1 o te %2",
  	OPERATORS_LENGTH: "te roanga o te %1",
  	OPERATORS_MOD: "%1 % %2",
  	OPERATORS_ROUND: "whakaawhiwhi %1",
  	OPERATORS_MATHOP: "%1 o te %2",
  	OPERATORS_CONTAINS: "kei roto i a %1 : %2?",
  	DATA_ITEMOFLIST: "te tūemi %1 o %2",
  	DATA_ITEMNUMOFLIST: "te tūemi # %1 o %2",
  	DATA_LENGTHOFLIST: "te roanga o te %1",
  	DATA_LISTCONTAINSITEM: "kei roto i %1 te %2?",
  	CONTROL_ELSE: "kē atu",
  	SENSING_USERID: "tohu tuakiri",
  	SENSING_LOUD: "hoihoi?",
  	"text2speech.speakAndWaitBlock": "kīia %1",
  	"text2speech.setVoiceBlock": "tautuhia te reo ki %1",
  	"text2speech.setLanguageBlock": "tautuhia te reo kia%1",
  	"translate.translateBlock": "whakawhitiwhitia %1 ki te reo %2",
  	"translate.viewerLanguage": "reo",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "ina pēhia pātene %1",
  	"microbit.isButtonPressed": "%1 pātene i pēhia?",
  	"microbit.whenGesture": "ina %1",
  	"microbit.displaySymbol": "whakaaturia %1",
  	"microbit.displayText": "whakaaturia %1",
  	"microbit.clearDisplay": "ūkuia te mata",
  	"microbit.whenTilted": "ina tītaha ki %1",
  	"microbit.isTilted": "kua tītaha ki%1?",
  	"microbit.tiltAngle": "koki tītaha %1",
  	"microbit.whenPinConnected": "whakamātautau, ina honoa ki te pine %1",
  	"ev3.motorTurnClockwise": "pūkaha %1 huri pēnei mō ngā hēkona %2",
  	"ev3.motorTurnCounterClockwise": "pūkaha %1huri pērā mō ngā hēkona %2",
  	"ev3.motorSetPower": "pūkaha%1 tautuhia te kaha ki%2 %",
  	"ev3.getMotorPosition": "ahunga pūkaha%1",
  	"ev3.whenButtonPressed": "inā pāwhiria te pātene %1",
  	"ev3.whenDistanceLessThan": "ina tawhiti < %1",
  	"ev3.whenBrightnessLessThan": "ina pīataata < %1",
  	"ev3.buttonPressed": "kua pēhia te pātuhi %1?",
  	"ev3.getDistance": "tawhiti",
  	"ev3.getBrightness": "pīataata",
  	"ev3.beepNote": "whakatangihia te oro %1 mō ngā hēkona %2",
  	"wedo2.motorOn": "whakakā %1",
  	"wedo2.motorOff": "whakaweto %1",
  	"wedo2.startMotorPower": "tautuhia te pūkaha %1 kia %2 te kaha",
  	"wedo2.setMotorDirection": "tautuhia te pūkaha %1 kia huri %2",
  	"wedo2.whenDistance": "ina tawhiti %1 %2",
  	"wedo2.getDistance": "tawhiti",
  	"wedo2.motorOnFor": "whakakā%1 mō ngā hēkona %2",
  	"wedo2.setLightHue": "tautuhia te tae māmā ki te %1",
  	"wedo2.playNoteFor": "whakatangihia te oro %1 mō ngā hēkona%2",
  	"wedo2.whenTilted": "ina tītaha %1",
  	"wedo2.isTilted": "kua tītaha ki %1?",
  	"wedo2.getTiltAngle": "koki tītaha %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$t = {
  };
  var ignorelt$t = [
  ];
  var soundEffects$t = [
  	"hauoro",
  	"huri whakatemauī/whakatekatau"
  ];
  var microbitWhen$t = [
  	"i neke",
  	"i rūrū",
  	"i peke"
  ];
  var osis$t = [
  	"hōtuhi kē i roto i te parehe"
  ];
  var definePrefix$t = [
  	"tautuhia"
  ];
  var defineSuffix$t = [
  ];
  var palette$t = {
  	Motion: "Nekehanga",
  	Looks: "Āhua",
  	Sound: "Oro",
  	Events: "Takahanga",
  	Control: "Whakatina",
  	Sensing: "Paerongo",
  	Operators: "Tohutūmahi",
  	Variables: "Ngā Taurangi",
  	"My Blocks": "Aku Paraka"
  };
  var math$t = [
  	"abs",
  	"papa",
  	"tuanui",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$t = {
  };
  var name$t = "Māori";
  var percentTranslated$t = 100;
  var mi = {
  	commands: commands$t,
  	dropdowns: dropdowns$t,
  	ignorelt: ignorelt$t,
  	soundEffects: soundEffects$t,
  	microbitWhen: microbitWhen$t,
  	osis: osis$t,
  	definePrefix: definePrefix$t,
  	defineSuffix: defineSuffix$t,
  	palette: palette$t,
  	math: math$t,
  	aliases: aliases$t,
  	name: name$t,
  	percentTranslated: percentTranslated$t
  };

  var commands$s = {
  	MOTION_MOVESTEPS: "%1 алхам яв",
  	MOTION_TURNRIGHT: "@turnRight тийш %1 хэм эргэ",
  	MOTION_TURNLEFT: "@turnLeft тийш %1 хэм эргэ",
  	MOTION_POINTINDIRECTION: "чиглэлийг %1 хэм болго",
  	MOTION_POINTTOWARDS: "чигийг %1 рүү чиглүүл",
  	MOTION_GOTOXY: "x: %1 y:%2 цэгт оч",
  	MOTION_GOTO: "%1-рүү оч",
  	MOTION_GLIDESECSTOXY: "%1 секундэд x: %2 y: %3 цэг рүү гулс",
  	MOTION_GLIDETO: "%1 секундэд %2-руу гулс",
  	MOTION_CHANGEXBY: "x-г %1 нэгжээр өөрчил",
  	MOTION_SETX: "x-н утгыг %1 болго",
  	MOTION_CHANGEYBY: "y-г %1 нэгжээр өөрчил",
  	MOTION_SETY: "y-н утгыг %1 болго",
  	MOTION_SETROTATIONSTYLE: "эргэх хэлбэрийг %1 болго",
  	LOOKS_SAYFORSECS: "%2 секундийн турш %1-г хэл",
  	LOOKS_SAY: "%1-г хэл",
  	LOOKS_THINKFORSECS: "%2 секундийн турш %1-г бод",
  	LOOKS_THINK: "%1-г бод",
  	LOOKS_SHOW: "харагд",
  	LOOKS_HIDE: "нуугд",
  	LOOKS_SWITCHCOSTUMETO: "өмсгөлийг %1 болгож соль",
  	LOOKS_NEXTCOSTUME: "дараах өмсгөл",
  	LOOKS_NEXTBACKDROP_BLOCK: "дараах дэвсгэр",
  	LOOKS_SWITCHBACKDROPTO: "Дэвсгэрийг %1 болгож өөрчил",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "Дэвсгэр %1 -рүү шилжээд хүлээ",
  	LOOKS_CHANGEEFFECTBY: "%1 нөлөөг %2 нэгжээр өөрчил",
  	LOOKS_SETEFFECTTO: "%1 нөлөөг %2 болго",
  	LOOKS_CLEARGRAPHICEFFECTS: "дүрсэнд оруулсан нөлөөг арилга",
  	LOOKS_CHANGESIZEBY: "хэмжээг %1 нэгжээр өөрчил",
  	LOOKS_SETSIZETO: "хэмжээг %1 болго",
  	LOOKS_GOTOFRONTBACK: "Давхрага %1-рүү оч",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 давхрага руу оч",
  	SOUND_PLAY: "дуу %1-ийг эхлүүл",
  	SOUND_CHANGEEFFECTBY: "%1 эффектийг %2 нэгжээр өөрчил",
  	SOUND_SETEFFECTO: "%1 эффектийг %2 болго",
  	SOUND_CLEAREFFECTS: "дууны нөлөөг арилга",
  	SOUND_PLAYUNTILDONE: "дуу %1-г дуусах хүртэл нь тоглуул",
  	SOUND_STOPALLSOUNDS: "бүх дууг зогсоо",
  	"music.playDrumForBeats": "%1 бөмбөрийг %2 хэмнэл тогло",
  	"music.restForBeats": "%1 хэмнэл завсарла",
  	"music.playNoteForBeats": "%1 нотыг %2 хэмнэл тогло",
  	"music.setInstrument": "хөгжмийн зэмсгийг %1 болго",
  	SOUND_CHANGEVOLUMEBY: "дууны эрчийг %1 нэгжээр өөрчил",
  	SOUND_SETVOLUMETO: "дууны эрчийг %1% болго",
  	"music.changeTempo": "эрчмийг %1-р соль",
  	"music.setTempo": "темпийг %1 болго",
  	"pen.clear": "бүгдийг арилга",
  	"pen.stamp": "дардас",
  	"pen.penDown": "зур",
  	"pen.penUp": "зурахаа боль",
  	"pen.setColor": "%1 өнгийн үзэг",
  	"pen.changeHue": "үзэгний өнгийг %1 болго",
  	"pen.setColorParam": "үзэгний %1 -г %2 болго",
  	"pen.changeColorParam": "үзгийн %1 -г %2 -р соль",
  	"pen.setHue": "үзэгний өнгийг %1 болго",
  	"pen.changeShade": "үзэгний сүүдрийг %1 болго",
  	"pen.setShade": "үзэгний сүүдрийг %1 болго",
  	"pen.changeSize": "үзэгний хэмжээг %1-р өөрчил",
  	"pen.setSize": "үзэгний хэмжээг %1 болго",
  	EVENT_WHENFLAGCLICKED: "@greenFlag дарагдсан үед",
  	EVENT_WHENKEYPRESSED: "товчлуур %1 дарагдах үед",
  	EVENT_WHENTHISSPRITECLICKED: "Дүрс дээр дарах үед",
  	EVENT_WHENSTAGECLICKED: "тайз дээр дарах үед",
  	EVENT_WHENBACKDROPSWITCHESTO: "дэвсгэр %1 болж өөрчлөгдөх үед",
  	EVENT_WHENGREATERTHAN: "%1 > %2 үед",
  	EVENT_WHENBROADCASTRECEIVED: "би %1-г хүлээж авах үед",
  	EVENT_BROADCAST: "%1-г дамжуулах",
  	EVENT_BROADCASTANDWAIT: "%1-г дамжуулаад хүлээ",
  	CONTROL_WAIT: "%1 секунд хүлээх",
  	CONTROL_REPEAT: "%1 удаа давтах",
  	CONTROL_FOREVER: "Үргэлж",
  	CONTROL_IF: "хэрэв %1 бол",
  	CONTROL_WAITUNTIL: "%1 болтол хүлээх",
  	CONTROL_REPEATUNTIL: "%1 болтол давт",
  	CONTROL_STOP: "зогсоо %1",
  	CONTROL_STARTASCLONE: "Миний хуулбар үүсэх үед",
  	CONTROL_CREATECLONEOF: "%1-н хуулбарыг үүсгэ",
  	CONTROL_DELETETHISCLONE: "Энэ хуулбарыг устга",
  	SENSING_ASKANDWAIT: "%1-ийг асуугаад хүлээ",
  	"videoSensing.videoToggle": "бичлэгийг %1 болго",
  	"videoSensing.setVideoTransparency": "бичлэгийн тунгалагжилтыг %1 болго",
  	"videoSensing.whenMotionGreaterThan": "бичлэгийн хөдөлгөөн > %1 үед",
  	SENSING_RESETTIMER: "тоолуурыг тэглэ",
  	DATA_SETVARIABLETO: "%1 хувьсагчийг %2 болго",
  	DATA_CHANGEVARIABLEBY: "%1 хувьсагчийг %2 нэгжээр өөрчил",
  	DATA_SHOWVARIABLE: "%1 хувьсагчийг харуул",
  	DATA_HIDEVARIABLE: "%1 хувьсагчийг нуу",
  	DATA_ADDTOLIST: "%1-г %2 дээр нэм",
  	DATA_DELETEOFLIST: "%2-н %1-г устга",
  	DATA_DELETEALLOFLIST: "%1 жагсаалтын бүгдийг устга",
  	MOTION_IFONEDGEBOUNCE: "Ирмэгт хүрсэн бол ой",
  	DATA_INSERTATLIST: "%3-н %2-р байранд %1-г оруул",
  	DATA_REPLACEITEMOFLIST: "%2-н %1-г %3 болгож өөрчил",
  	DATA_SHOWLIST: "%1 жагсаалтыг харуул",
  	DATA_HIDELIST: "%1 жагсаалтыг нуу",
  	SENSING_OF_XPOSITION: "x - н утга",
  	SENSING_OF_YPOSITION: "y - н утга",
  	SENSING_OF_DIRECTION: "чиглэл",
  	SENSING_OF_COSTUMENUMBER: "өмсгөл #",
  	LOOKS_COSTUMENUMBERNAME: "Өмсгөл %1",
  	SENSING_OF_SIZE: "хэмжээ",
  	SENSING_OF_BACKDROPNAME: "дэвсгэрийн нэр",
  	LOOKS_BACKDROPNUMBERNAME: "Дэвсгэр %1",
  	SENSING_OF_BACKDROPNUMBER: "# дэвсгэр",
  	SOUND_VOLUME: "дууны эрч",
  	"music.getTempo": "хэм",
  	SENSING_TOUCHINGOBJECT: "%1-д хүрсэн үү?",
  	SENSING_TOUCHINGCOLOR: "%1 өнгөнд хүрсэн үү?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 өнгө %2-т хүрсэн үү?",
  	SENSING_DISTANCETO: "%1 хүртэлх зай",
  	SENSING_ANSWER: "хариулт",
  	SENSING_KEYPRESSED: "товчлуур %1 дарагдсан",
  	SENSING_MOUSEDOWN: "хулгана дарагдсан",
  	SENSING_MOUSEX: "x-н утга",
  	SENSING_MOUSEY: "y-н утга",
  	SENSING_SETDRAGMODE: "чирэх горимыг %1 болго",
  	SENSING_LOUDNESS: "дууны чанга",
  	"videoSensing.videoOn": "%2 -д оногдох нийт %1 -н тоо",
  	SENSING_TIMER: "тоолуур",
  	SENSING_OF: "%2-н %1",
  	SENSING_CURRENT: "одоогийн %1",
  	SENSING_DAYSSINCE2000: "2000 оноос хойших өдрийн тоо",
  	SENSING_USERNAME: "хэрэглэгчийн нэр",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1-ээс %2 хооронд санамсаргүй сонго",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1  = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 ба %2",
  	OPERATORS_OR: "%1 эсвэл %2",
  	OPERATORS_NOT: "%1 биш",
  	OPERATORS_JOIN: "%1-г %2-т залга",
  	OPERATORS_LETTEROF: "%2-ийн %1-р үсэг",
  	OPERATORS_LENGTH: "%1-н урт",
  	OPERATORS_MOD: "%1-г %2-р хуваасны үлдэгдэл",
  	OPERATORS_ROUND: "%1-г тоймло",
  	OPERATORS_MATHOP: "%2-н %1",
  	OPERATORS_CONTAINS: "%1 нь %2-г агуулж байна уу?",
  	DATA_ITEMOFLIST: "%2 жагсаалтын %1",
  	DATA_ITEMNUMOFLIST: "%2 доторх %1-н # хэсэг",
  	DATA_LENGTHOFLIST: "%1 жагсаалтын урт",
  	DATA_LISTCONTAINSITEM: "%1 жагсаалт %2-г агуулж байвал",
  	CONTROL_ELSE: "эсвэл",
  	SENSING_USERID: "хэрэглэгчийн ID",
  	SENSING_LOUD: "чанга уу?",
  	"text2speech.speakAndWaitBlock": "%1 үгийг хэл",
  	"text2speech.setVoiceBlock": "авиаг %1 болго",
  	"text2speech.setLanguageBlock": "хэлийг %1 хэл болго",
  	"translate.translateBlock": "%1 -г %2 хэл лүү орчуул",
  	"translate.viewerLanguage": "хэл",
  	"makeymakey.whenKeyPressed": "товчлуур %1 дарагдах үед",
  	"makeymakey.whenKeysPressedInOrder": "%1 дарааллыг дарах үед",
  	"microbit.whenButtonPressed": "%1 товчлуурыг дарсан үед",
  	"microbit.isButtonPressed": "%1 товчлуур дарагдсан уу?",
  	"microbit.whenGesture": "%1 мэдрэгдэх үед",
  	"microbit.displaySymbol": "%1 -г дэлгэцээр гарга",
  	"microbit.displayText": "%1 -г дэлгэцээр гарга",
  	"microbit.clearDisplay": "дэлгэцийг цэвэрлэ",
  	"microbit.whenTilted": "%1 чигт хазайсан бол",
  	"microbit.isTilted": "%1 зүг рүү хазайсан байна уу?",
  	"microbit.tiltAngle": "өнцгийг %1 -р хазайлга",
  	"microbit.whenPinConnected": "%1 хөл холбогдсон үед",
  	"ev3.motorTurnClockwise": "моторын %1 -г цагийн зүүний дагуу %2 секунд хөдөлгө",
  	"ev3.motorTurnCounterClockwise": "моторын %1 -г цагийн зүүний эсрэг тийш %2 секунд хөдөлгө",
  	"ev3.motorSetPower": "моторын %1 -ын хүчийг %2 болго",
  	"ev3.getMotorPosition": "моторын %1 -ын байрлал",
  	"ev3.whenButtonPressed": "%1 товчлуурыг дарсан үед",
  	"ev3.whenDistanceLessThan": "зай < %1 үед",
  	"ev3.whenBrightnessLessThan": "цайруулалт < %1 үед",
  	"ev3.buttonPressed": "%1 товчлуурыг дарсан уу?",
  	"ev3.getDistance": "зай",
  	"ev3.getBrightness": "цайруулалт",
  	"ev3.beepNote": "%1 нот-г %2 секундын турш дуугарга",
  	"wedo2.motorOn": "мотор %1 -г асаа",
  	"wedo2.motorOff": "мотор %1 -г унтраа",
  	"wedo2.startMotorPower": "моторын %1 -ын хүчийг %2 болго",
  	"wedo2.setMotorDirection": "мотор %1 -н чиглэлийг %2 болго",
  	"wedo2.whenDistance": "зай %1%2 үед",
  	"wedo2.getDistance": "зай",
  	"wedo2.motorOnFor": "мотор %1 -г %2 секунд асаа",
  	"wedo2.setLightHue": "гэрлийн өнгийг %1 болго",
  	"wedo2.playNoteFor": "%1 нотыг %2 секунд тогло",
  	"wedo2.whenTilted": "%1 чигт хазайсан бол",
  	"wedo2.isTilted": "%1 чигт хазайсан байна уу?",
  	"wedo2.getTiltAngle": "өнцгийг %1 -р хазайлга",
  	"gdxfor.whenGesture": "%1 мэдрэгдэх үед",
  	"gdxfor.whenForcePushedOrPulled": "хүч мэдрэгч %1 мэдрэх үед",
  	"gdxfor.getForce": "хүч",
  	"gdxfor.whenTilted": "%1 өнцгөөр хазайсан байхад",
  	"gdxfor.isTilted": "%1 өнцгөөр хазайсан байна уу?",
  	"gdxfor.getTilt": "өнцгийг %1 -р хазайлга",
  	"gdxfor.isFreeFalling": "унаж байна уу?",
  	"gdxfor.getSpin": "%1 хурдаар эргэлд",
  	"gdxfor.getAcceleration": "%1 зүгт хурдал",
  	"boost.motorOnFor": "%1 моторыг %2 секунд асаа",
  	"boost.motorOnForRotation": "мотор %1-г %2 эргүүлэхээр асаа",
  	"boost.motorOn": "%1 моторыг асаа",
  	"boost.motorOff": "%1 мотор-г унтраа",
  	"boost.setMotorPower": "%1 моторын хурдыг %2 % болго",
  	"boost.setMotorDirection": "%1 моторын чиглэлийг %2 болго",
  	"boost.getMotorPosition": "%1 моторын байршил",
  	"boost.whenColor": "%1 тоосгыг харсан бол",
  	"boost.seeingColor": "%1 тоосгыг харж байна уу?",
  	"boost.whenTilted": "%1 чигт хазайсан бол",
  	"boost.getTiltAngle": "%1 өнцгөөр хазайлга",
  	"boost.setLightHue": "гэрлийн өнгийг %1 болго"
  };
  var dropdowns$s = {
  };
  var ignorelt$s = [
  ];
  var soundEffects$s = [
  	"авиа",
  	"pan зүүн/баруун"
  ];
  var microbitWhen$s = [
  	"хөдөлсөн",
  	"сэгсрэгдсэн",
  	"үсэрсэн"
  ];
  var osis$s = [
  	"дүрсний бусад кодууд"
  ];
  var definePrefix$s = [
  ];
  var defineSuffix$s = [
  	"-г",
  	"зохио"
  ];
  var palette$s = {
  	Motion: "Хөдлөхүй",
  	Looks: "Харагдахуй",
  	Sound: "Сонсогдохуй",
  	Events: "Хэзээ",
  	Control: "Хянахуй",
  	Sensing: "Мэдрэхүй",
  	Operators: "Тоолохуй",
  	Variables: "Хувьсагч",
  	"My Blocks": "Миний блокууд"
  };
  var math$s = [
  	"модуль",
  	"доош бүхэлд тоймлох",
  	"дээш бүхэлд тоймлох",
  	"квадрат язгуур",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$s = {
  };
  var name$s = "Монгол хэл";
  var percentTranslated$s = 100;
  var mn = {
  	commands: commands$s,
  	dropdowns: dropdowns$s,
  	ignorelt: ignorelt$s,
  	soundEffects: soundEffects$s,
  	microbitWhen: microbitWhen$s,
  	osis: osis$s,
  	definePrefix: definePrefix$s,
  	defineSuffix: defineSuffix$s,
  	palette: palette$s,
  	math: math$s,
  	aliases: aliases$s,
  	name: name$s,
  	percentTranslated: percentTranslated$s
  };

  var commands$r = {
  	MOTION_MOVESTEPS: "gå %1 steg",
  	MOTION_TURNRIGHT: "snu @turnRight %1 grader",
  	MOTION_TURNLEFT: "snu @turnLeft %1 grader",
  	MOTION_POINTINDIRECTION: "pek i retning %1",
  	MOTION_POINTTOWARDS: "pek mot %1",
  	MOTION_GOTOXY: "gå til x: %1 y: %2",
  	MOTION_GOTO: "gå til %1",
  	MOTION_GLIDESECSTOXY: "gli %1 sekunder til x: %2 y: %3",
  	MOTION_GLIDETO: "gli %1 sekunder til %2",
  	MOTION_CHANGEXBY: "endre x med %1",
  	MOTION_SETX: "sett x til %1",
  	MOTION_CHANGEYBY: "endre y med %1",
  	MOTION_SETY: "sett y til %1",
  	MOTION_SETROTATIONSTYLE: "begrens rotasjon %1",
  	LOOKS_SAYFORSECS: "si %1 i %2 sekunder",
  	LOOKS_SAY: "si %1",
  	LOOKS_THINKFORSECS: "tenk %1 i %2 sekunder",
  	LOOKS_THINK: "tenk %1",
  	LOOKS_SHOW: "vis",
  	LOOKS_HIDE: "skjul",
  	LOOKS_SWITCHCOSTUMETO: "bytt drakt til %1",
  	LOOKS_NEXTCOSTUME: "neste drakt",
  	LOOKS_NEXTBACKDROP_BLOCK: "neste bakgrunn",
  	LOOKS_SWITCHBACKDROPTO: "bytt bakgrunn til %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "bytt bakgrunn til %1 og vent",
  	LOOKS_CHANGEEFFECTBY: "endre %1 effekt med %2",
  	LOOKS_SETEFFECTTO: "sett %1 effekt til %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "fjern grafiske effekter",
  	LOOKS_CHANGESIZEBY: "endre størrelse med %1",
  	LOOKS_SETSIZETO: "sett størrelse til %1 %",
  	LOOKS_GOTOFRONTBACK: "legg %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "gå %1 %2 lag",
  	SOUND_PLAY: "start lyden %1",
  	SOUND_CHANGEEFFECTBY: "endre %1 effekt med %2",
  	SOUND_SETEFFECTO: "sett %1 effekt til %2",
  	SOUND_CLEAREFFECTS: "fjern lydeffekter",
  	SOUND_PLAYUNTILDONE: "spill lyden %1 til den er ferdig",
  	SOUND_STOPALLSOUNDS: "stopp alle lyder",
  	"music.playDrumForBeats": "trommeslag %1 som varer %2 taktslag",
  	"music.restForBeats": "pause i %1 taktslag",
  	"music.playNoteForBeats": "spill tone %1 som varer %2 taktslag",
  	"music.setInstrument": "velg instrument %1",
  	SOUND_CHANGEVOLUMEBY: "endre volum med %1",
  	SOUND_SETVOLUMETO: "sett volum %1%",
  	"music.changeTempo": "endre tempo med %1",
  	"music.setTempo": "sett tempo til %1",
  	"pen.clear": "slett alt",
  	"pen.stamp": "stemple avtrykk",
  	"pen.penDown": "penn på",
  	"pen.penUp": "penn av",
  	"pen.setColor": "sett pennfarge til %1",
  	"pen.changeHue": "endre pennfarge med %1",
  	"pen.setColorParam": "sett pennens %1 til %2",
  	"pen.changeColorParam": "endre pennens %1 med %2",
  	"pen.setHue": "sett pennens farge til %1",
  	"pen.changeShade": "endre pennens lysstyrke med %1",
  	"pen.setShade": "sett pennens lysstyrke til %1",
  	"pen.changeSize": "endre pennens bredde med %1",
  	"pen.setSize": "sett pennbredde til %1",
  	EVENT_WHENFLAGCLICKED: "når @greenFlag klikkes",
  	EVENT_WHENKEYPRESSED: "når %1 trykkes",
  	EVENT_WHENTHISSPRITECLICKED: "når denne figuren klikkes",
  	EVENT_WHENSTAGECLICKED: "når scenen klikkes",
  	EVENT_WHENBACKDROPSWITCHESTO: "når bakgrunn bytter til %1",
  	EVENT_WHENGREATERTHAN: "når %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "når jeg mottar %1",
  	EVENT_BROADCAST: "send melding %1",
  	EVENT_BROADCASTANDWAIT: "send melding %1 og vent",
  	CONTROL_WAIT: "vent %1 sekunder",
  	CONTROL_REPEAT: "gjenta %1 ganger",
  	CONTROL_FOREVER: "gjenta for alltid",
  	CONTROL_IF: "hvis %1",
  	CONTROL_WAITUNTIL: "vent til %1",
  	CONTROL_REPEATUNTIL: "gjenta til %1",
  	CONTROL_STOP: "stopp %1",
  	CONTROL_STARTASCLONE: "når jeg starter som klon",
  	CONTROL_CREATECLONEOF: "lag klon av %1",
  	CONTROL_DELETETHISCLONE: "slett denne klonen",
  	SENSING_ASKANDWAIT: "spør %1 og vent",
  	"videoSensing.videoToggle": "sett video %1",
  	"videoSensing.setVideoTransparency": "sett %1 gjennomsiktighet av video",
  	"videoSensing.whenMotionGreaterThan": "når videobevegelse > %1",
  	SENSING_RESETTIMER: "nullstill klokken",
  	DATA_SETVARIABLETO: "sett %1 til %2",
  	DATA_CHANGEVARIABLEBY: "endre %1 med %2",
  	DATA_SHOWVARIABLE: "vis variabel %1",
  	DATA_HIDEVARIABLE: "skjul variabel %1",
  	DATA_ADDTOLIST: "legg til %1 i %2",
  	DATA_DELETEOFLIST: "slett element %1 i %2",
  	DATA_DELETEALLOFLIST: "slett alt i %1",
  	MOTION_IFONEDGEBOUNCE: "sprett tilbake ved kanten",
  	DATA_INSERTATLIST: "sett inn %1 på plass %2 i %3",
  	DATA_REPLACEITEMOFLIST: "erstatt element %1 i %2 med %3",
  	DATA_SHOWLIST: "vis liste %1",
  	DATA_HIDELIST: "skjul liste %1",
  	SENSING_OF_XPOSITION: "x-posisjon",
  	SENSING_OF_YPOSITION: "y-posisjon",
  	SENSING_OF_DIRECTION: "retning",
  	SENSING_OF_COSTUMENUMBER: "drakt nr.",
  	LOOKS_COSTUMENUMBERNAME: "drakt %1",
  	SENSING_OF_SIZE: "størrelse",
  	SENSING_OF_BACKDROPNAME: "navn på bakgrunn",
  	LOOKS_BACKDROPNUMBERNAME: "bakgrunn %1",
  	SENSING_OF_BACKDROPNUMBER: "bakgrunn nr.",
  	SOUND_VOLUME: "volum",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "berører %1?",
  	SENSING_TOUCHINGCOLOR: "berører fargen %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "farge %1 berører %2?",
  	SENSING_DISTANCETO: "avstand til %1",
  	SENSING_ANSWER: "svar",
  	SENSING_KEYPRESSED: "tast %1 trykket?",
  	SENSING_MOUSEDOWN: "museknappen er trykket?",
  	SENSING_MOUSEX: "mus x",
  	SENSING_MOUSEY: "mus y",
  	SENSING_SETDRAGMODE: "%1 å dra med musen",
  	SENSING_LOUDNESS: "lydnivå",
  	"videoSensing.videoOn": "video %1 på %2",
  	SENSING_TIMER: "sekundklokke",
  	SENSING_OF: "%1 av %2",
  	SENSING_CURRENT: "%1 nå",
  	SENSING_DAYSSINCE2000: "dager siden 2000",
  	SENSING_USERNAME: "brukernavn",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "tilfeldig tall fra %1 til %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 og %2",
  	OPERATORS_OR: "%1 eller %2",
  	OPERATORS_NOT: "ikke %1",
  	OPERATORS_JOIN: "sett sammen %1 %2",
  	OPERATORS_LETTEROF: "bokstav %1 i %2",
  	OPERATORS_LENGTH: "lengden av %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "avrund %1",
  	OPERATORS_MATHOP: "%1 av %2",
  	OPERATORS_CONTAINS: "%1 inneholder %2?",
  	DATA_ITEMOFLIST: "element %1 i %2",
  	DATA_ITEMNUMOFLIST: "posisjon av %1 i %2",
  	DATA_LENGTHOFLIST: "lengden av %1",
  	DATA_LISTCONTAINSITEM: "%1 inneholder %2?",
  	CONTROL_ELSE: "ellers",
  	SENSING_USERID: "brukernavn",
  	SENSING_LOUD: "høy lyd?",
  	"text2speech.speakAndWaitBlock": "si %1",
  	"text2speech.setVoiceBlock": "velg stemme %1",
  	"text2speech.setLanguageBlock": "velg språk %1",
  	"translate.translateBlock": "oversett %1 til %2",
  	"translate.viewerLanguage": "språk",
  	"makeymakey.whenKeyPressed": "når %1 trykkes",
  	"makeymakey.whenKeysPressedInOrder": "når %1 trykkes i rekkefølge",
  	"microbit.whenButtonPressed": "når %1 knapp trykkes",
  	"microbit.isButtonPressed": "%1 knapp trykket?",
  	"microbit.whenGesture": "når %1",
  	"microbit.displaySymbol": "vis bilde %1",
  	"microbit.displayText": "vis tekst %1",
  	"microbit.clearDisplay": "tøm skjermen",
  	"microbit.whenTilted": "når helning %1",
  	"microbit.isTilted": "helning %1?",
  	"microbit.tiltAngle": "helningsvinkel %1",
  	"microbit.whenPinConnected": "når kontakt %1 trykkes",
  	"ev3.motorTurnClockwise": "motor %1 kjør den ene veien i %2 sekunder",
  	"ev3.motorTurnCounterClockwise": "motor %1 kjør den andre veien i %2 sekunder",
  	"ev3.motorSetPower": "motor %1 sett fart %2 %",
  	"ev3.getMotorPosition": "motor %1 vinkel",
  	"ev3.whenButtonPressed": "når knapp %1 trykkes",
  	"ev3.whenDistanceLessThan": "når avstand < %1",
  	"ev3.whenBrightnessLessThan": "når lysnivå < %1",
  	"ev3.buttonPressed": "knapp %1 trykket?",
  	"ev3.getDistance": "avstand",
  	"ev3.getBrightness": "lysstyrke",
  	"ev3.beepNote": "tone %1 i %2 sekunder",
  	"wedo2.motorOn": "skru på %1",
  	"wedo2.motorOff": "skru av %1",
  	"wedo2.startMotorPower": "sett %1 fart %2",
  	"wedo2.setMotorDirection": "velg %1 retning %2",
  	"wedo2.whenDistance": "når avstand %1 %2",
  	"wedo2.getDistance": "avstand",
  	"wedo2.motorOnFor": "skru på %1 i %2 sekunder",
  	"wedo2.setLightHue": "sett lysfarge %1",
  	"wedo2.playNoteFor": "spill tone %1 i %2 sekunder",
  	"wedo2.whenTilted": "når helning %1",
  	"wedo2.isTilted": "helning %1?",
  	"wedo2.getTiltAngle": "helningsvinkel %1",
  	"gdxfor.whenGesture": "når %1",
  	"gdxfor.whenForcePushedOrPulled": "når kraftsensoren %1",
  	"gdxfor.getForce": "kraft",
  	"gdxfor.whenTilted": "ved helning %1",
  	"gdxfor.isTilted": "heller %1?",
  	"gdxfor.getTilt": "helningsvinkel %1",
  	"gdxfor.isFreeFalling": "fritt fall",
  	"gdxfor.getSpin": "rotasjonsfart %1",
  	"gdxfor.getAcceleration": "akselerasjon %1",
  	"boost.motorOnFor": "kjør motor %1 i %2 sekunder",
  	"boost.motorOnForRotation": "kjør motor %1 rundt %2 rotasjoner",
  	"boost.motorOn": "skru på motor %1",
  	"boost.motorOff": "skru av motor %1",
  	"boost.setMotorPower": "sett motor %1 fart til %2 %",
  	"boost.setMotorDirection": "velg motor %1 retning %2",
  	"boost.getMotorPosition": "motor %1 posisjon",
  	"boost.whenColor": "når %1 kloss sett",
  	"boost.seeingColor": "ser %1 kloss?",
  	"boost.whenTilted": "når helning %1",
  	"boost.getTiltAngle": "helningsvinkel %1",
  	"boost.setLightHue": "sett lysfarge %1"
  };
  var dropdowns$r = {
  };
  var ignorelt$r = [
  ];
  var soundEffects$r = [
  	"tonehøyde",
  	"retning"
  ];
  var microbitWhen$r = [
  	"flyttet",
  	"ristet",
  	"hoppet"
  ];
  var osis$r = [
  	"andre skript i figuren"
  ];
  var definePrefix$r = [
  	"definer"
  ];
  var defineSuffix$r = [
  ];
  var palette$r = {
  	Motion: "Bevegelse",
  	Looks: "Utseende",
  	Sound: "Lyd",
  	Events: "Hendelser",
  	Control: "Styring",
  	Sensing: "Sansing",
  	Operators: "Operatorer",
  	Variables: "Variabler",
  	"My Blocks": "Mine klosser"
  };
  var math$r = [
  	"absoluttverdi",
  	"avrund ned",
  	"avrund opp",
  	"kvadratrot",
  	"sin",
  	"cos",
  	"tan",
  	"arcsin",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$r = {
  	"vend venstre %1 grader": "MOTION_TURNLEFT",
  	"vend høyre %1 grader": "MOTION_TURNRIGHT",
  	"når grønt flagg klikkes": "EVENT_WHENFLAGCLICKED",
  	slutt: "scratchblocks:end"
  };
  var name$r = "Norsk Bokmål";
  var percentTranslated$r = 100;
  var nb = {
  	commands: commands$r,
  	dropdowns: dropdowns$r,
  	ignorelt: ignorelt$r,
  	soundEffects: soundEffects$r,
  	microbitWhen: microbitWhen$r,
  	osis: osis$r,
  	definePrefix: definePrefix$r,
  	defineSuffix: defineSuffix$r,
  	palette: palette$r,
  	math: math$r,
  	aliases: aliases$r,
  	name: name$r,
  	percentTranslated: percentTranslated$r
  };

  var commands$q = {
  	MOTION_MOVESTEPS: "neem %1 stappen",
  	MOTION_TURNRIGHT: "draai @turnRight %1 graden",
  	MOTION_TURNLEFT: "draai @turnLeft %1 graden",
  	MOTION_POINTINDIRECTION: "richt naar %1 graden",
  	MOTION_POINTTOWARDS: "richt naar %1",
  	MOTION_GOTOXY: "ga naar x: %1 y: %2",
  	MOTION_GOTO: "ga naar %1",
  	MOTION_GLIDESECSTOXY: "schuif in %1 sec. naar x: %2 y: %3",
  	MOTION_GLIDETO: "schuif in %1 sec. naar %2",
  	MOTION_CHANGEXBY: "verander x met %1",
  	MOTION_SETX: "maak x %1",
  	MOTION_CHANGEYBY: "verander y met %1",
  	MOTION_SETY: "maak y %1",
  	MOTION_SETROTATIONSTYLE: "maak draaistijl %1",
  	LOOKS_SAYFORSECS: "zeg %1 %2 sec.",
  	LOOKS_SAY: "zeg %1",
  	LOOKS_THINKFORSECS: "denk %1 %2 sec.",
  	LOOKS_THINK: "denk %1",
  	LOOKS_SHOW: "verschijn",
  	LOOKS_HIDE: "verdwijn",
  	LOOKS_SWITCHCOSTUMETO: "verander uiterlijk naar %1",
  	LOOKS_NEXTCOSTUME: "volgend uiterlijk",
  	LOOKS_NEXTBACKDROP_BLOCK: "volgende achtergrond",
  	LOOKS_SWITCHBACKDROPTO: "verander achtergrond naar %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "verander achtergrond naar %1 en wacht",
  	LOOKS_CHANGEEFFECTBY: "verander %1 effect met %2",
  	LOOKS_SETEFFECTTO: "zet %1 effect op %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "zet alle effecten uit",
  	LOOKS_CHANGESIZEBY: "verander grootte met %1",
  	LOOKS_SETSIZETO: "maak grootte %1 %",
  	LOOKS_GOTOFRONTBACK: "ga naar laag %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ga %1 %2 lagen",
  	SOUND_PLAY: "start geluid %1",
  	SOUND_CHANGEEFFECTBY: "verander %1-effect met %2",
  	SOUND_SETEFFECTO: "zet effect %1 op %2",
  	SOUND_CLEAREFFECTS: "zet alle effecten uit",
  	SOUND_PLAYUNTILDONE: "start geluid %1 en wacht",
  	SOUND_STOPALLSOUNDS: "stop alle geluiden",
  	"music.playDrumForBeats": "speel drum %1gedurende%2 maten",
  	"music.restForBeats": "%1maten rust",
  	"music.playNoteForBeats": "speel noot %1 gedurende %2maten",
  	"music.setInstrument": "maak instrument %1",
  	SOUND_CHANGEVOLUMEBY: "verander volume met %1",
  	SOUND_SETVOLUMETO: "zet volume op %1%",
  	"music.changeTempo": "verander tempo met %1",
  	"music.setTempo": "maak tempo %1",
  	"pen.clear": "wis alles",
  	"pen.stamp": "stempel",
  	"pen.penDown": "pen neer",
  	"pen.penUp": "pen op",
  	"pen.setColor": "maak penkleur %1",
  	"pen.changeHue": "verander penkleur met %1",
  	"pen.setColorParam": "maak pen %1 %2",
  	"pen.changeColorParam": "verander pen %1met %2",
  	"pen.setHue": "maak penkleur %1",
  	"pen.changeShade": "verander penhelderheid met %1",
  	"pen.setShade": "maak penhelderheid %1",
  	"pen.changeSize": "verander pendikte met %1",
  	"pen.setSize": "maak pendikte %1",
  	EVENT_WHENFLAGCLICKED: "wanneer op @greenFlag wordt geklikt",
  	EVENT_WHENKEYPRESSED: "wanneer %1 is ingedrukt",
  	EVENT_WHENTHISSPRITECLICKED: "wanneer op deze sprite wordt geklikt",
  	EVENT_WHENSTAGECLICKED: "wanneer op het speelveld wordt geklikt",
  	EVENT_WHENBACKDROPSWITCHESTO: "wanneer achtergrond verandert naar %1",
  	EVENT_WHENGREATERTHAN: "wanneer %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "wanneer ik signaal %1 ontvang",
  	EVENT_BROADCAST: "zend signaal %1",
  	EVENT_BROADCASTANDWAIT: "zend signaal %1 en wacht",
  	CONTROL_WAIT: "wacht %1 sec.",
  	CONTROL_REPEAT: "herhaal %1",
  	CONTROL_FOREVER: "herhaal",
  	CONTROL_IF: "als %1 dan",
  	CONTROL_WAITUNTIL: "wacht tot %1",
  	CONTROL_REPEATUNTIL: "herhaal tot %1",
  	CONTROL_STOP: "stop %1",
  	CONTROL_STARTASCLONE: "wanneer ik als kloon start",
  	CONTROL_CREATECLONEOF: "maak een kloon van %1",
  	CONTROL_DELETETHISCLONE: "verwijder deze kloon",
  	SENSING_ASKANDWAIT: "vraag %1 en wacht",
  	"videoSensing.videoToggle": "zet video %1",
  	"videoSensing.setVideoTransparency": "zet video transparantie op %1",
  	"videoSensing.whenMotionGreaterThan": "wanneer video beweging > %1",
  	SENSING_RESETTIMER: "zet klok op 0",
  	DATA_SETVARIABLETO: "maak %1 %2",
  	DATA_CHANGEVARIABLEBY: "verander %1 met %2",
  	DATA_SHOWVARIABLE: "toon variabele %1",
  	DATA_HIDEVARIABLE: "verberg variabele %1",
  	DATA_ADDTOLIST: "voeg %1 toe aan %2",
  	DATA_DELETEOFLIST: "verwijder %1 van %2",
  	DATA_DELETEALLOFLIST: "verwijder alle van %1",
  	MOTION_IFONEDGEBOUNCE: "keer om aan de rand",
  	DATA_INSERTATLIST: "voeg %1 toe op %2 van %3",
  	DATA_REPLACEITEMOFLIST: "vervang item %1 van %2 door %3",
  	DATA_SHOWLIST: "toon lijst %1",
  	DATA_HIDELIST: "verberg lijst %1",
  	SENSING_OF_XPOSITION: "x-positie",
  	SENSING_OF_YPOSITION: "y-positie",
  	SENSING_OF_DIRECTION: "richting",
  	SENSING_OF_COSTUMENUMBER: "uiterlijk #",
  	LOOKS_COSTUMENUMBERNAME: "uiterlijk %1",
  	SENSING_OF_SIZE: "grootte",
  	SENSING_OF_BACKDROPNAME: "achtergrond naam",
  	LOOKS_BACKDROPNUMBERNAME: "achtergrond %1",
  	SENSING_OF_BACKDROPNUMBER: "achtergrond #",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "raak ik %1?",
  	SENSING_TOUCHINGCOLOR: "raak ik kleur %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "raakt kleur %1 kleur %2?",
  	SENSING_DISTANCETO: "afstand tot %1",
  	SENSING_ANSWER: "antwoord",
  	SENSING_KEYPRESSED: "toets %1 ingedrukt?",
  	SENSING_MOUSEDOWN: "muis ingedrukt?",
  	SENSING_MOUSEX: "muis x",
  	SENSING_MOUSEY: "muis y",
  	SENSING_SETDRAGMODE: "zet sleepbaar op %1",
  	SENSING_LOUDNESS: "volume",
  	"videoSensing.videoOn": "video %1van%2",
  	SENSING_TIMER: "klok",
  	SENSING_OF: "%1 van %2",
  	SENSING_CURRENT: "huidige %1",
  	SENSING_DAYSSINCE2000: "dagen sinds 2000",
  	SENSING_USERNAME: "gebruikersnaam",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "willekeurig getal tussen %1 en %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 en %2",
  	OPERATORS_OR: "%1 of %2",
  	OPERATORS_NOT: "niet %1",
  	OPERATORS_JOIN: "voeg %1 en %2 samen",
  	OPERATORS_LETTEROF: "letter %1 van %2",
  	OPERATORS_LENGTH: "lengte van %1",
  	OPERATORS_MOD: "%1 modulo %2",
  	OPERATORS_ROUND: "afgerond %1",
  	OPERATORS_MATHOP: "%1 van %2",
  	OPERATORS_CONTAINS: "%1 bevat %2?",
  	DATA_ITEMOFLIST: "item %1 van %2",
  	DATA_ITEMNUMOFLIST: "item # van %1 in %2",
  	DATA_LENGTHOFLIST: "lengte van %1",
  	DATA_LISTCONTAINSITEM: "%1 bevat %2?",
  	CONTROL_ELSE: "anders",
  	SENSING_USERID: "gebruiker id",
  	SENSING_LOUD: "luid?",
  	"text2speech.speakAndWaitBlock": "zeg %1",
  	"text2speech.setVoiceBlock": "zet stem op %1",
  	"text2speech.setLanguageBlock": "stel de taal in op %1",
  	"translate.translateBlock": "vertaal %1 naar %2",
  	"translate.viewerLanguage": "taal",
  	"makeymakey.whenKeyPressed": "wanneer %1toets ingedrukt wordt",
  	"makeymakey.whenKeysPressedInOrder": "wanneer %1in deze volgorde wordt ingedrukt",
  	"microbit.whenButtonPressed": "als knop %1ingedrukt is",
  	"microbit.isButtonPressed": "knop %1ingedrukt?",
  	"microbit.whenGesture": "als %1",
  	"microbit.displaySymbol": "display %1",
  	"microbit.displayText": "toon tekst %1",
  	"microbit.clearDisplay": "wis het display",
  	"microbit.whenTilted": "als gekanteld naar %1",
  	"microbit.isTilted": "gekanteld naar%1?",
  	"microbit.tiltAngle": "kantelhoek %1",
  	"microbit.whenPinConnected": "wanneer pin %1 is verbonden",
  	"ev3.motorTurnClockwise": "draai motor %1%2 seconde hierheen",
  	"ev3.motorTurnCounterClockwise": "draai motor %1%2seconde daarheen",
  	"ev3.motorSetPower": "zet motor %1op %2%",
  	"ev3.getMotorPosition": "motor %1positie",
  	"ev3.whenButtonPressed": "als knop %1ingedrukt is",
  	"ev3.whenDistanceLessThan": "als afstand < %1",
  	"ev3.whenBrightnessLessThan": "als helderheid < %1",
  	"ev3.buttonPressed": "knop %1ingedrukt?",
  	"ev3.getDistance": "afstand",
  	"ev3.getBrightness": "helderheid",
  	"ev3.beepNote": "speel noot %1%2seconde",
  	"wedo2.motorOn": "zet %1aan",
  	"wedo2.motorOff": "zet %1uit",
  	"wedo2.startMotorPower": "zet %1kracht op %2",
  	"wedo2.setMotorDirection": "zet %1richting op %2",
  	"wedo2.whenDistance": "als afstand %1%2",
  	"wedo2.getDistance": "afstand",
  	"wedo2.motorOnFor": "zet %1%2seconde aan",
  	"wedo2.setLightHue": "zet lichtkleur op %1",
  	"wedo2.playNoteFor": "speel noot %1%2seconde",
  	"wedo2.whenTilted": "als gekanteld naar %1",
  	"wedo2.isTilted": "gekanteld %1?",
  	"wedo2.getTiltAngle": "kantelhoek %1",
  	"gdxfor.whenGesture": "wanneer %1",
  	"gdxfor.whenForcePushedOrPulled": "wanneer krachtsensor %1",
  	"gdxfor.getForce": "kracht",
  	"gdxfor.whenTilted": "als %1gekanteld",
  	"gdxfor.isTilted": "gekanteld %1",
  	"gdxfor.getTilt": "kantelhoek %1",
  	"gdxfor.isFreeFalling": "vallend?",
  	"gdxfor.getSpin": "draaisnelheid %1",
  	"gdxfor.getAcceleration": "versnelling %1",
  	"boost.motorOnFor": "zet motor %1%2 seconde aan",
  	"boost.motorOnForRotation": "zet motor %1 aan voor %2 omwentelingen",
  	"boost.motorOn": "zet motor %1 aan",
  	"boost.motorOff": "zet motor %1 uit",
  	"boost.setMotorPower": "zet motor %1 snelheid op %2%",
  	"boost.setMotorDirection": "zet motor %1 richting op %2",
  	"boost.getMotorPosition": "motor %1 positie",
  	"boost.whenColor": "als %1 steen gezien",
  	"boost.seeingColor": "is steen %1?",
  	"boost.whenTilted": "als gekanteld naar %1",
  	"boost.getTiltAngle": "kantelhoek %1",
  	"boost.setLightHue": "zet lichtkleur op %1"
  };
  var dropdowns$q = {
  };
  var ignorelt$q = [
  ];
  var soundEffects$q = [
  	"toonhoogte",
  	"kanaal links/rechts"
  ];
  var microbitWhen$q = [
  	"bewogen",
  	"geschud",
  	"gesprongen"
  ];
  var osis$q = [
  	"andere scripts in sprite"
  ];
  var definePrefix$q = [
  	"definieer"
  ];
  var defineSuffix$q = [
  ];
  var palette$q = {
  	Motion: "Beweging",
  	Looks: "Uiterlijken",
  	Sound: "Geluid",
  	Events: "Gebeurtenissen",
  	Control: "Besturen",
  	Sensing: "Waarnemen",
  	Operators: "Functies",
  	Variables: "Variabelen",
  	"My Blocks": "Mijn blokken"
  };
  var math$q = [
  	"absoluut",
  	"beneden",
  	"boven",
  	"wortel",
  	"sin",
  	"cos",
  	"tan",
  	"arcsin",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$q = {
  	"draai %1 graden naar links": "MOTION_TURNLEFT",
  	"draai %1 graden naar rechts": "MOTION_TURNRIGHT",
  	"wanneer groene vlag wordt aangeklikt": "EVENT_WHENFLAGCLICKED",
  	einde: "scratchblocks:end"
  };
  var name$q = "Nederlands";
  var percentTranslated$q = 100;
  var nl = {
  	commands: commands$q,
  	dropdowns: dropdowns$q,
  	ignorelt: ignorelt$q,
  	soundEffects: soundEffects$q,
  	microbitWhen: microbitWhen$q,
  	osis: osis$q,
  	definePrefix: definePrefix$q,
  	defineSuffix: defineSuffix$q,
  	palette: palette$q,
  	math: math$q,
  	aliases: aliases$q,
  	name: name$q,
  	percentTranslated: percentTranslated$q
  };

  var commands$p = {
  	MOTION_MOVESTEPS: "gå %1 steg",
  	MOTION_TURNRIGHT: "snu @turnRight %1 gradar",
  	MOTION_TURNLEFT: "snu @turnLeft %1 gradar",
  	MOTION_POINTINDIRECTION: "peik i retning %1",
  	MOTION_POINTTOWARDS: "peik mot %1",
  	MOTION_GOTOXY: "gå til x: %1 y: %2",
  	MOTION_GOTO: "gå til %1",
  	MOTION_GLIDESECSTOXY: "gli %1 sekund til x: %2 y: %3",
  	MOTION_GLIDETO: "gli %1 sekund til %2",
  	MOTION_CHANGEXBY: "endra x med %1",
  	MOTION_SETX: "set x til %1",
  	MOTION_CHANGEYBY: "endra y med %1",
  	MOTION_SETY: "set y til %1",
  	MOTION_SETROTATIONSTYLE: "avgrens rotering til %1",
  	LOOKS_SAYFORSECS: "sei %1 i %2 sekund",
  	LOOKS_SAY: "sei %1",
  	LOOKS_THINKFORSECS: "tenk %1 i %2 sekund",
  	LOOKS_THINK: "tenk %1",
  	LOOKS_SHOW: "vis",
  	LOOKS_HIDE: "gøym",
  	LOOKS_SWITCHCOSTUMETO: "byt drakt til %1",
  	LOOKS_NEXTCOSTUME: "neste drakt",
  	LOOKS_NEXTBACKDROP_BLOCK: "neste bakgrunn",
  	LOOKS_SWITCHBACKDROPTO: "byt bakgrunn til %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "byt bakgrunn til %1 og vent",
  	LOOKS_CHANGEEFFECTBY: "endra %1-effekten med %2",
  	LOOKS_SETEFFECTTO: "set %1-effekten til %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "ta vekk grafiske effektar",
  	LOOKS_CHANGESIZEBY: "endra storleik med %1",
  	LOOKS_SETSIZETO: "set storleik til %1 %",
  	LOOKS_GOTOFRONTBACK: "legg %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "gå %1 %2 lag",
  	SOUND_PLAY: "start lyden %1",
  	SOUND_CHANGEEFFECTBY: "endra %1-effekt med %2",
  	SOUND_SETEFFECTO: "set %1-effekt til %2",
  	SOUND_CLEAREFFECTS: "fjern lydeffektar",
  	SOUND_PLAYUNTILDONE: "spel lyden %1 til han er ferdig",
  	SOUND_STOPALLSOUNDS: "stopp alle lydar",
  	"music.playDrumForBeats": "trommeslag %1 som varer i %2 taktslag",
  	"music.restForBeats": "pause i %1 taktslag",
  	"music.playNoteForBeats": "spel tonen %1 i %2 taktslag",
  	"music.setInstrument": "bruk instrumentet %1",
  	SOUND_CHANGEVOLUMEBY: "endra lydstyrken med %1",
  	SOUND_SETVOLUMETO: "set lydstyrken til %1 %",
  	"music.changeTempo": "endra tempo med %1",
  	"music.setTempo": "set tempo til %1",
  	"pen.clear": "visk vekk alt",
  	"pen.stamp": "lag avtrykk",
  	"pen.penDown": "penn ned",
  	"pen.penUp": "penn opp",
  	"pen.setColor": "bruk pennefargen %1",
  	"pen.changeHue": "endra pennefarge med %1",
  	"pen.setColorParam": "set %1 til %2",
  	"pen.changeColorParam": "endra pennens %1 med %2",
  	"pen.setHue": "bruk pennefargen %1",
  	"pen.changeShade": "endra penneskugge med %1",
  	"pen.setShade": "set penneskugge til %1",
  	"pen.changeSize": "endra pennebreidd med %1",
  	"pen.setSize": "set pennebreidd til %1",
  	EVENT_WHENFLAGCLICKED: "når @greenFlag vert trykt på",
  	EVENT_WHENKEYPRESSED: "når %1 vert trykt",
  	EVENT_WHENTHISSPRITECLICKED: "når denne figuren vert trykt på",
  	EVENT_WHENSTAGECLICKED: "når scena vert trykt på",
  	EVENT_WHENBACKDROPSWITCHESTO: "når bakgrunnen byter til %1",
  	EVENT_WHENGREATERTHAN: "når %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "når eg får meldinga %1",
  	EVENT_BROADCAST: "send meldinga %1",
  	EVENT_BROADCASTANDWAIT: "send meldinga %1 og vent",
  	CONTROL_WAIT: "vent %1 sekund",
  	CONTROL_REPEAT: "gjenta %1 gongar",
  	CONTROL_FOREVER: "for alltid",
  	CONTROL_IF: "viss %1",
  	CONTROL_WAITUNTIL: "vent til %1",
  	CONTROL_REPEATUNTIL: "gjenta til %1",
  	CONTROL_STOP: "stopp %1",
  	CONTROL_STARTASCLONE: "når eg startar som klon",
  	CONTROL_CREATECLONEOF: "lag klon av %1",
  	CONTROL_DELETETHISCLONE: "slett denne klonen",
  	SENSING_ASKANDWAIT: "spør %1 og vent",
  	"videoSensing.videoToggle": "set video %1",
  	"videoSensing.setVideoTransparency": "set gjennomsikt av video til %1",
  	"videoSensing.whenMotionGreaterThan": "når videorørsle > %1",
  	SENSING_RESETTIMER: "nullstill klokka",
  	DATA_SETVARIABLETO: "set %1 til %2",
  	DATA_CHANGEVARIABLEBY: "endra %1 med %2",
  	DATA_SHOWVARIABLE: "vis variabelen %1",
  	DATA_HIDEVARIABLE: "gøym variabelen %1",
  	DATA_ADDTOLIST: "legg %1 til %2",
  	DATA_DELETEOFLIST: "slett element %1 i %2",
  	DATA_DELETEALLOFLIST: "slett alt i %1",
  	MOTION_IFONEDGEBOUNCE: "viss ved kant, sprett",
  	DATA_INSERTATLIST: "set inn %1 på plass %2 i %3",
  	DATA_REPLACEITEMOFLIST: "byt ut element %1 i %2 med %3",
  	DATA_SHOWLIST: "vis lista %1",
  	DATA_HIDELIST: "gøym lista %1",
  	SENSING_OF_XPOSITION: "x-posisjon",
  	SENSING_OF_YPOSITION: "y-posisjon",
  	SENSING_OF_DIRECTION: "retning",
  	SENSING_OF_COSTUMENUMBER: "drakt nr.",
  	LOOKS_COSTUMENUMBERNAME: "drakt %1",
  	SENSING_OF_SIZE: "storleik",
  	SENSING_OF_BACKDROPNAME: "bakgrunnsnamn",
  	LOOKS_BACKDROPNUMBERNAME: "bakgrunn %1",
  	SENSING_OF_BACKDROPNUMBER: "bakgrunn nr.",
  	SOUND_VOLUME: "lydstyrke",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "rører %1",
  	SENSING_TOUCHINGCOLOR: "rører fargen %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "fargen %1 rører %2?",
  	SENSING_DISTANCETO: "avstand til %1",
  	SENSING_ANSWER: "svar",
  	SENSING_KEYPRESSED: "tasten %1 er trykt?",
  	SENSING_MOUSEDOWN: "museknappen er trykt?",
  	SENSING_MOUSEX: "mus x",
  	SENSING_MOUSEY: "mus y",
  	SENSING_SETDRAGMODE: "%1 å dra med musa",
  	SENSING_LOUDNESS: "lydstyrke",
  	"videoSensing.videoOn": "video-%1 på %2",
  	SENSING_TIMER: "sekundklokke",
  	SENSING_OF: "%1 av %2",
  	SENSING_CURRENT: "%1 nett no",
  	SENSING_DAYSSINCE2000: "dagar sidan år 2000",
  	SENSING_USERNAME: "brukarnamn",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 − %2",
  	OPERATORS_MULTIPLY: "%1 × %2",
  	OPERATORS_DIVIDE: "%1 : %2",
  	OPERATORS_RANDOM: "tilfeldig tal frå %1 til %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 og %2",
  	OPERATORS_OR: "%1 eller %2",
  	OPERATORS_NOT: "ikkje %1",
  	OPERATORS_JOIN: "set saman %1 %2",
  	OPERATORS_LETTEROF: "bokstav %1 i %2",
  	OPERATORS_LENGTH: "lengda til %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "rund av %1",
  	OPERATORS_MATHOP: "%1 av %2",
  	OPERATORS_CONTAINS: "%1 inneheld %2?",
  	DATA_ITEMOFLIST: "element %1 i %2",
  	DATA_ITEMNUMOFLIST: "posisjon til %1 i %2",
  	DATA_LENGTHOFLIST: "lengda til %1",
  	DATA_LISTCONTAINSITEM: "%1 inneheld %2?",
  	CONTROL_ELSE: "elles",
  	SENSING_USERID: "brukar-id",
  	SENSING_LOUD: "høg lyd?",
  	"text2speech.speakAndWaitBlock": "les opp %1",
  	"text2speech.setVoiceBlock": "bruk stemmen %1",
  	"text2speech.setLanguageBlock": "set språket til %1",
  	"translate.translateBlock": "set om %1 til %2",
  	"translate.viewerLanguage": "språk",
  	"makeymakey.whenKeyPressed": "når %1 vert trykt",
  	"makeymakey.whenKeysPressedInOrder": "når %1 vert trykt i rekkjefølgje",
  	"microbit.whenButtonPressed": "når %1-knappen er trykt",
  	"microbit.isButtonPressed": "%1-knapp trykt?",
  	"microbit.whenGesture": "når %1",
  	"microbit.displaySymbol": "vis bilete %1",
  	"microbit.displayText": "vis tekst %1",
  	"microbit.clearDisplay": "tøm skjermen",
  	"microbit.whenTilted": "ved helling %1",
  	"microbit.isTilted": "helling %1?",
  	"microbit.tiltAngle": "hellingsvinkel %1",
  	"microbit.whenPinConnected": "når kontakten %1 får signal",
  	"ev3.motorTurnClockwise": "snu motor %1 med klokka i %2 sekund",
  	"ev3.motorTurnCounterClockwise": "snu motor %1 mot klokka i %2 sekund",
  	"ev3.motorSetPower": "set styrken til motor %1 til %2 %",
  	"ev3.getMotorPosition": "posisjon til motor %1",
  	"ev3.whenButtonPressed": "når knappen %1 er trykt",
  	"ev3.whenDistanceLessThan": "når avstanden < %1",
  	"ev3.whenBrightnessLessThan": "når lysstyrken < %1",
  	"ev3.buttonPressed": "knapp %1 trykt?",
  	"ev3.getDistance": "avstand",
  	"ev3.getBrightness": "lysstyrke",
  	"ev3.beepNote": "tonen %1 i %2 sekund",
  	"wedo2.motorOn": "slå på %1",
  	"wedo2.motorOff": "slå av %1",
  	"wedo2.startMotorPower": "set %1-styrken til %2",
  	"wedo2.setMotorDirection": "set %1-retninga til %2",
  	"wedo2.whenDistance": "når avstanden %1 %2",
  	"wedo2.getDistance": "avstand",
  	"wedo2.motorOnFor": "slå på %1 i %2 sekund",
  	"wedo2.setLightHue": "set lysfargen til %1",
  	"wedo2.playNoteFor": "spel tonen %1 i %2 sekund",
  	"wedo2.whenTilted": "ved helling %1",
  	"wedo2.isTilted": "helling %1?",
  	"wedo2.getTiltAngle": "hellingsvinkel %1",
  	"gdxfor.whenGesture": "når %1",
  	"gdxfor.whenForcePushedOrPulled": "når kraftsensoren vert %1",
  	"gdxfor.getForce": "kraft",
  	"gdxfor.whenTilted": "ved helling %1",
  	"gdxfor.isTilted": "heller %1?",
  	"gdxfor.getTilt": "hellingsvinkel %1",
  	"gdxfor.isFreeFalling": "i fritt fall?",
  	"gdxfor.getSpin": "rotasjonsfart %1",
  	"gdxfor.getAcceleration": "akselerasjon %1",
  	"boost.motorOnFor": "slå på %1 i %2 sekund",
  	"boost.motorOnForRotation": "roter %1 %2 omdreiingar",
  	"boost.motorOn": "slå på %1",
  	"boost.motorOff": "slå av %1",
  	"boost.setMotorPower": "set motor %1-fart til %2 %",
  	"boost.setMotorDirection": "set motor %1-retning til %2",
  	"boost.getMotorPosition": "posisjon til motor %1",
  	"boost.whenColor": "når %1 kloss vert sett",
  	"boost.seeingColor": "ser %1 kloss?",
  	"boost.whenTilted": "ved helling %1",
  	"boost.getTiltAngle": "hellingsvinkel %1",
  	"boost.setLightHue": "set lysfargen til %1"
  };
  var dropdowns$p = {
  };
  var ignorelt$p = [
  ];
  var soundEffects$p = [
  	"tonehøgd",
  	"venstre–høgre-panorering"
  ];
  var microbitWhen$p = [
  	"flytta",
  	"rista",
  	"hoppa"
  ];
  var osis$p = [
  	"andre skript i figuren"
  ];
  var definePrefix$p = [
  	"definer"
  ];
  var defineSuffix$p = [
  ];
  var palette$p = {
  	Motion: "Rørsle",
  	Looks: "Utsjånad",
  	Sound: "Lyd",
  	Events: "Hendingar",
  	Control: "Styring",
  	Sensing: "Sansing",
  	Operators: "Operatorar",
  	Variables: "Variablar",
  	"My Blocks": "Mine klossar"
  };
  var math$p = [
  	"abs",
  	"golv",
  	"tak",
  	"kvadratrot",
  	"sin",
  	"cos",
  	"tan",
  	"arcsin",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e^",
  	"10^"
  ];
  var aliases$p = {
  };
  var name$p = "Norsk Nynorsk";
  var percentTranslated$p = 100;
  var nn = {
  	commands: commands$p,
  	dropdowns: dropdowns$p,
  	ignorelt: ignorelt$p,
  	soundEffects: soundEffects$p,
  	microbitWhen: microbitWhen$p,
  	osis: osis$p,
  	definePrefix: definePrefix$p,
  	defineSuffix: defineSuffix$p,
  	palette: palette$p,
  	math: math$p,
  	aliases: aliases$p,
  	name: name$p,
  	percentTranslated: percentTranslated$p
  };

  var commands$o = {
  	MOTION_MOVESTEPS: "šutiša %1  ya dikgato",
  	MOTION_TURNRIGHT: "sokolla dikgato @turnRight %1",
  	MOTION_TURNLEFT: "sokololla dikgato @turnLeft %1",
  	MOTION_POINTINDIRECTION: "šupa ka thoko tša %1",
  	MOTION_POINTTOWARDS: "šupa go ya go %1",
  	MOTION_GOTOXY: "eya go x: %1 y: %2",
  	MOTION_GOTO: "eya go  %1",
  	MOTION_GLIDESECSTOXY: "thwetha metsotswana e %1 go ya go x: %2 y: %3",
  	MOTION_GLIDETO: "thwetha metsotswana e %1 go ya go %2",
  	MOTION_CHANGEXBY: "fetola x ka %1",
  	MOTION_SETX: "bea x go %1",
  	MOTION_CHANGEYBY: "fetola y ka %1",
  	MOTION_SETY: "bea y go %1",
  	MOTION_SETROTATIONSTYLE: "bea mokgwa wa go dikologa %1",
  	LOOKS_SAYFORSECS: "e re %1 ya %2 ya metsotswana",
  	LOOKS_SAY: "e re %1",
  	LOOKS_THINKFORSECS: "nagana %1 ya metsotswana e %2",
  	LOOKS_THINK: "nagana %1",
  	LOOKS_SHOW: "bontšha",
  	LOOKS_HIDE: "fihla",
  	LOOKS_SWITCHCOSTUMETO: "fetolela khosetšhumo go %1",
  	LOOKS_NEXTCOSTUME: "khosetšhumo ye e latelago",
  	LOOKS_NEXTBACKDROP_BLOCK: "bokamorago bjo bo latelago",
  	LOOKS_SWITCHBACKDROPTO: "fetola bokamorago go %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "fetola bokamorago go %1 gomme o lete",
  	LOOKS_CHANGEEFFECTBY: "fetola %1 khuetšo ka %2",
  	LOOKS_SETEFFECTTO: "bea %1 khuetšo go %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "tloša khuetšo ya diswantšho",
  	LOOKS_CHANGESIZEBY: "fetola bogolo ka %1",
  	LOOKS_SETSIZETO: "bea bogolo go %1 %",
  	LOOKS_GOTOFRONTBACK: "eya go %1  ya tlhatlagano",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "eya %1 %2 ya tlhatlagano",
  	SOUND_PLAY: "thoma modumo %1",
  	SOUND_CHANGEEFFECTBY: "fetola %1 khuetšo ka %2",
  	SOUND_SETEFFECTO: "bea %1 khuetšo go %2",
  	SOUND_CLEAREFFECTS: "tloša khuetšo ya modumo",
  	SOUND_PLAYUNTILDONE: "bapala modumo %1 go fihlela o fetša",
  	SOUND_STOPALLSOUNDS: "emiša medumo ka moka",
  	"music.playDrumForBeats": "bapala moropa %1 go dira %2 merethetho",
  	"music.restForBeats": "khuletša %1 merethetho",
  	"music.playNoteForBeats": "bapala noto %1 ya %2 merethetho",
  	"music.setInstrument": "bea seletšwa go %1",
  	SOUND_CHANGEVOLUMEBY: "fetola volume ka %1",
  	SOUND_SETVOLUMETO: "bea volume go %1%",
  	"music.changeTempo": "fetola tempo ka %1",
  	"music.setTempo": "bea lebelo go %1",
  	"pen.clear": "phumula ka moka",
  	"pen.stamp": "setempe",
  	"pen.penDown": "pene fase",
  	"pen.penUp": "emiša pene",
  	"pen.setColor": "bea mmala wa pene go %1",
  	"pen.changeHue": "fetola mmala wa pene ka %1",
  	"pen.setColorParam": "bea pene %1 GO %2",
  	"pen.changeColorParam": "fetola pene %1 ka %2",
  	"pen.setHue": "bea mmala wa pene go %1",
  	"pen.changeShade": "fetola mošidi wa pene ka %1",
  	"pen.setShade": "bea moriti wa pene go %1",
  	"pen.changeSize": "fetola bogolo bja pene ka %1",
  	"pen.setSize": "bea bogolo bja pene go %1",
  	EVENT_WHENFLAGCLICKED: "ge @greenFlag e tobetšwa",
  	EVENT_WHENKEYPRESSED: "ge konopi ya %1 e tobetšwa",
  	EVENT_WHENTHISSPRITECLICKED: "ge motšeakarolo wo a tobetšwa",
  	EVENT_WHENSTAGECLICKED: "ge sefala se tobetšwa",
  	EVENT_WHENBACKDROPSWITCHESTO: "ge bokamorago bo fetogela go %1",
  	EVENT_WHENGREATERTHAN: "ge %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ge ke amogela %1",
  	EVENT_BROADCAST: "kgašo %1",
  	EVENT_BROADCASTANDWAIT: "kgašo %1 o lete",
  	CONTROL_WAIT: "ema %1 metsotswana",
  	CONTROL_REPEAT: "bušeletša %1",
  	CONTROL_FOREVER: "ka go sa felego",
  	CONTROL_IF: "ge e le %1 kemoka",
  	CONTROL_WAITUNTIL: "ema go fihlela %1",
  	CONTROL_REPEATUNTIL: "bušeletša go fihlela %1",
  	CONTROL_STOP: "ema %1",
  	CONTROL_STARTASCLONE: "ge ke thoma popotshwano",
  	CONTROL_CREATECLONEOF: "hlama popotshwano %1",
  	CONTROL_DELETETHISCLONE: "phumula tshwantšho ye",
  	SENSING_ASKANDWAIT: "botšiša %1 o be o lete",
  	"videoSensing.videoToggle": "sotha video %1",
  	"videoSensing.setVideoTransparency": "bea ponagatšo ya video go %1",
  	"videoSensing.whenMotionGreaterThan": "ge mosepelo wa video > %1",
  	SENSING_RESETTIMER: "beakanya gape se ela nako",
  	DATA_SETVARIABLETO: "bea %1 go %2",
  	DATA_CHANGEVARIABLEBY: "fetola %1 ka %2",
  	DATA_SHOWVARIABLE: "laetša phetošo %1",
  	DATA_HIDEVARIABLE: "fihla phetošo %1",
  	DATA_ADDTOLIST: "kopanya %1 go %2",
  	DATA_DELETEOFLIST: "phumula %1 ya %2",
  	DATA_DELETEALLOFLIST: "phumula ka moka tša %1",
  	MOTION_IFONEDGEBOUNCE: "ge e le ntlheng, e fofafofiše",
  	DATA_INSERTATLIST: "tsenya %1 ka %2 ya %3",
  	DATA_REPLACEITEMOFLIST: "tšhentšha selo %1 ya %2 ka %3",
  	DATA_SHOWLIST: "laetša lenaneo %1",
  	DATA_HIDELIST: "fihla lenaneo %1",
  	SENSING_OF_XPOSITION: "boemo ba x",
  	SENSING_OF_YPOSITION: "boemo ba y",
  	SENSING_OF_DIRECTION: "thoko",
  	SENSING_OF_COSTUMENUMBER: "khosetšhumo #",
  	LOOKS_COSTUMENUMBERNAME: "khosetšhumo %1",
  	SENSING_OF_SIZE: "bogolo",
  	SENSING_OF_BACKDROPNAME: "leina la bokamorago",
  	LOOKS_BACKDROPNUMBERNAME: "bokamorago%1",
  	SENSING_OF_BACKDROPNUMBER: "bokamorago #",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "lebelo",
  	SENSING_TOUCHINGOBJECT: "e kgoma %1?",
  	SENSING_TOUCHINGCOLOR: "e kgoma mmala %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "mmala wa %1 o kgoma %2",
  	SENSING_DISTANCETO: "bokgole go ya go %1",
  	SENSING_ANSWER: "karabo",
  	SENSING_KEYPRESSED: "konopi %1 e tobeditšwe?",
  	SENSING_MOUSEDOWN: "maose o ye fase?",
  	SENSING_MOUSEX: "maose x",
  	SENSING_MOUSEY: "maose y",
  	SENSING_SETDRAGMODE: "Bea mokgwa wa go gogega %1",
  	SENSING_LOUDNESS: "lešata",
  	"videoSensing.videoOn": "video %1 go %2",
  	SENSING_TIMER: "se ela nako",
  	SENSING_OF: "%1 ya %2",
  	SENSING_CURRENT: "ya bjale %1",
  	SENSING_DAYSSINCE2000: "matšatši go tloga ka 2000",
  	SENSING_USERNAME: "leinatšhomišo",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "kgetha ka go se hlaole %1 go ya go %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 le %2",
  	OPERATORS_OR: "%1 goba %2",
  	OPERATORS_NOT: "e sego %1",
  	OPERATORS_JOIN: "tsenela %1 %2",
  	OPERATORS_LETTEROF: "leletere %1 la %2",
  	OPERATORS_LENGTH: "botelele bja %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "nkgokolo %1",
  	OPERATORS_MATHOP: "%1 ya %2",
  	OPERATORS_CONTAINS: "%1 e na le %2?",
  	DATA_ITEMOFLIST: "selo %1 sa %2",
  	DATA_ITEMNUMOFLIST: "selo # sa %1 go %2",
  	DATA_LENGTHOFLIST: "botelele bja %1",
  	DATA_LISTCONTAINSITEM: "%1 e na le %2",
  	CONTROL_ELSE: "enngwe",
  	SENSING_USERID: "boitsebišo bja tšhomišo",
  	SENSING_LOUD: "rasa?",
  	"text2speech.speakAndWaitBlock": "bolela %1",
  	"text2speech.setVoiceBlock": "bea lentšu go %1",
  	"text2speech.setLanguageBlock": "bea polelo go %1",
  	"translate.translateBlock": "fetolela %1 go %2",
  	"translate.viewerLanguage": "polelo",
  	"makeymakey.whenKeyPressed": "ge konope %1 e tobetšwa",
  	"makeymakey.whenKeysPressedInOrder": "ge %1 e tobetšwa ka mokgwa wa maleba",
  	"microbit.whenButtonPressed": "ge konopi %1 e tobeditšwe",
  	"microbit.isButtonPressed": "%1 konopi e tobeditšwe",
  	"microbit.whenGesture": "ge %1",
  	"microbit.displaySymbol": "bontšha %1",
  	"microbit.displayText": "bontšha sengwalwa %1",
  	"microbit.clearDisplay": "tloša taetšo",
  	"microbit.whenTilted": "ge e sekamišitšwe %1",
  	"microbit.isTilted": "e sekamišitšwe %1?",
  	"microbit.tiltAngle": "sekamiša khutlo %1",
  	"microbit.whenPinConnected": "ge nomoro ya sephiri %1 e kgokagantšwe",
  	"ev3.motorTurnClockwise": "mmotho %1 o retologela ka mo metsotswana ye %2",
  	"ev3.motorTurnCounterClockwise": "mmotho %1 o retologela ka mo metsotswana ye %2",
  	"ev3.motorSetPower": "mmotho %1 o bulela maatla %2 %",
  	"ev3.getMotorPosition": "boemo bja mmotho %1",
  	"ev3.whenButtonPressed": "ge konopi ya %1 e tobetšwa",
  	"ev3.whenDistanceLessThan": "ge bokgole < %1",
  	"ev3.whenBrightnessLessThan": "ge go tagile < %1",
  	"ev3.buttonPressed": "konopi %1 e tobeditšwe",
  	"ev3.getDistance": "bokgole",
  	"ev3.getBrightness": "go taga",
  	"ev3.beepNote": "letša noto %1 metsotswana ye %2",
  	"wedo2.motorOn": "tšhuma %1",
  	"wedo2.motorOff": "tima %1",
  	"wedo2.startMotorPower": "bea maatla a %1 go %2",
  	"wedo2.setMotorDirection": "bea taetšo ya %1 go %2",
  	"wedo2.whenDistance": "ge bo kgole %1 %2",
  	"wedo2.getDistance": "bokgole",
  	"wedo2.motorOnFor": "bulela  %1 metsotswana e %2",
  	"wedo2.setLightHue": "bea mmala wa seetša go %1",
  	"wedo2.playNoteFor": "bapala noto %1  metsotswana ye %2",
  	"wedo2.whenTilted": "ge e sekamišitše %1",
  	"wedo2.isTilted": "sekamišetša %1?",
  	"wedo2.getTiltAngle": "sekamiša sekhutlo %1",
  	"gdxfor.whenGesture": "ge %1",
  	"gdxfor.whenForcePushedOrPulled": "ge sekwi sa maatla se %1",
  	"gdxfor.getForce": "maatla",
  	"gdxfor.whenTilted": "ge e sekamišitšwe %1",
  	"gdxfor.isTilted": "sekamišitše %1?",
  	"gdxfor.getTilt": "sekamiša sekhutlo %1",
  	"gdxfor.isFreeFalling": "e a wa?",
  	"gdxfor.getSpin": "lebelo la go dikološa %1",
  	"gdxfor.getAcceleration": "oketša makhura %1",
  	"boost.motorOnFor": "Bulela mmotho %1 metsotswana ye %2",
  	"boost.motorOnForRotation": "bulela mmotho %1  medikologo ye %2",
  	"boost.motorOn": "Bulela mmotho %1",
  	"boost.motorOff": "Tima mmotho %1",
  	"boost.setMotorPower": "bea lebelo la mmotho %1 go %2 %",
  	"boost.setMotorDirection": "bea taetšo ya mmotho %1 go %2",
  	"boost.getMotorPosition": "boemo bja mmotho %1",
  	"boost.whenColor": "Ge o bona setena se se %1",
  	"boost.seeingColor": "go bona %1 wa setena?",
  	"boost.whenTilted": "ge o sekamišitše %1",
  	"boost.getTiltAngle": "sekamiša sekhutlo %1",
  	"boost.setLightHue": "bea mmala wa seetša go %1"
  };
  var dropdowns$o = {
  };
  var ignorelt$o = [
  ];
  var soundEffects$o = [
  	"tlhabelelo",
  	"hwidinyetša go la nngele/la go ja"
  ];
  var microbitWhen$o = [
  	"šutile",
  	"šikinyegile",
  	"fofile"
  ];
  var osis$o = [
  	"dingwalwa tše dingwe tša motšeakarolo"
  ];
  var definePrefix$o = [
  	"hlalosa"
  ];
  var defineSuffix$o = [
  ];
  var palette$o = {
  	Motion: "Mosepelo",
  	Looks: "Tebelelego",
  	Sound: "Modumo",
  	Events: "Ditiragalo",
  	Control: "Taolo",
  	Sensing: "Sekwi",
  	Operators: "Bašomiši",
  	Variables: "Diphetošo",
  	"My Blocks": "Dipoloko tša Ka"
  };
  var math$o = [
  	"abs",
  	"floor",
  	"ceiling",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"Ka gare",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$o = {
  };
  var name$o = "Sepedi";
  var percentTranslated$o = 100;
  var nso = {
  	commands: commands$o,
  	dropdowns: dropdowns$o,
  	ignorelt: ignorelt$o,
  	soundEffects: soundEffects$o,
  	microbitWhen: microbitWhen$o,
  	osis: osis$o,
  	definePrefix: definePrefix$o,
  	defineSuffix: defineSuffix$o,
  	palette: palette$o,
  	math: math$o,
  	aliases: aliases$o,
  	name: name$o,
  	percentTranslated: percentTranslated$o
  };

  var commands$n = {
  	MOTION_MOVESTEPS: "avançar %1 passes",
  	MOTION_TURNRIGHT: "virar @turnRight %1 grases",
  	MOTION_TURNLEFT: "virar @turnLeft %1 grases",
  	MOTION_POINTINDIRECTION: "puntat dins la direccion %1",
  	MOTION_POINTTOWARDS: "puntat cap a %1",
  	MOTION_GOTOXY: "anar a x: %1 y: %2",
  	MOTION_GOTO: "anar a %1",
  	MOTION_GLIDESECSTOXY: "lisar %1 s. cap a x%2 y: %3",
  	MOTION_GLIDETO: "lisar %1 s. cap a %2",
  	MOTION_CHANGEXBY: "cambiar x per %1",
  	MOTION_SETX: "reglar x a %1",
  	MOTION_CHANGEYBY: "cambiar y per %1",
  	MOTION_SETY: "reglar y a %1",
  	MOTION_SETROTATIONSTYLE: "reglar l'estil de rotation %1",
  	LOOKS_SAYFORSECS: "dire %1 pendent %2 segondas",
  	LOOKS_SAY: "dire %1",
  	LOOKS_THINKFORSECS: "pensar %1 pendent %2 segondas",
  	LOOKS_THINK: "pensar %1",
  	LOOKS_SHOW: "mostrar",
  	LOOKS_HIDE: "amagar",
  	LOOKS_SWITCHCOSTUMETO: "escambiar lo costum per %1",
  	LOOKS_NEXTCOSTUME: "costum seguent",
  	LOOKS_NEXTBACKDROP_BLOCK: "fons seguent",
  	LOOKS_SWITCHBACKDROPTO: "escambiar lo fons per %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "escambiar fons per %1 e esperar",
  	LOOKS_CHANGEEFFECTBY: "cambiar %1 efièch per %2",
  	LOOKS_SETEFFECTTO: "reglar %1 efièch sus %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "purgar los efièches grafics",
  	LOOKS_CHANGESIZEBY: "cambiar la talha per %1",
  	LOOKS_SETSIZETO: "reglar la talha a %1 %",
  	LOOKS_GOTOFRONTBACK: "anar al clac %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "anar %1 %2 calcs",
  	SOUND_PLAY: "començar son  %1",
  	SOUND_CHANGEEFFECTBY: "cambiar %1 efièch per %2",
  	SOUND_SETEFFECTO: "reglar %1 efièch sus %2",
  	SOUND_CLEAREFFECTS: "purgar los efièches de son",
  	SOUND_PLAYUNTILDONE: "jogar son %1 fins a que s'acabe",
  	SOUND_STOPALLSOUNDS: "arrestat totes los sons",
  	"music.playDrumForBeats": "jogar la percussion %1 al batèc %2",
  	"music.restForBeats": "pausa pendent %1 pulsacions",
  	"music.playNoteForBeats": "jogar la nòta %1 pendent %2 pulsacions",
  	"music.setInstrument": "reglar l'instrument sus %1",
  	SOUND_CHANGEVOLUMEBY: "cambiar volum per %1",
  	SOUND_SETVOLUMETO: "reglar volum a %1%",
  	"music.changeTempo": "cambiar lo tempò per %1",
  	"music.setTempo": "reglar lo tempò sus %1",
  	"pen.clear": "escafar tot",
  	"pen.stamp": "sagel",
  	"pen.penDown": "estilò pausat",
  	"pen.penUp": "estilò levat",
  	"pen.setColor": "reglar la color de l'estilò sus %1",
  	"pen.changeHue": "cambiar la color del estilò per %1",
  	"pen.setColorParam": "reglar %1 del estilò per %2",
  	"pen.changeColorParam": "cambiar %1 del estilò per %2",
  	"pen.setHue": "reglar la color del estilò per %1",
  	"pen.changeShade": "cambiar la nuança del estilò per %1",
  	"pen.setShade": "reglar la nuança del estilò per %1",
  	"pen.changeSize": "cambiar la talha del estilò per %1",
  	"pen.setSize": "reglar la talha del estilò per %1",
  	EVENT_WHENFLAGCLICKED: "quand @greenFlag es clicat",
  	EVENT_WHENKEYPRESSED: "quand la toca %1 es premsada",
  	EVENT_WHENTHISSPRITECLICKED: "quand aquela sprite es clicada",
  	EVENT_WHENSTAGECLICKED: "quand la scèna es clicada",
  	EVENT_WHENBACKDROPSWITCHESTO: "quand lo fon cambia per %1",
  	EVENT_WHENGREATERTHAN: "quand %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "quand recebi %1",
  	EVENT_BROADCAST: "difusir %1",
  	EVENT_BROADCASTANDWAIT: "difusir %1 e esperar",
  	CONTROL_WAIT: "esperar %1 segondas",
  	CONTROL_REPEAT: "repetir %1",
  	CONTROL_FOREVER: "per totjorn",
  	CONTROL_IF: "se %1 alara",
  	CONTROL_WAITUNTIL: "esperar fins a %1",
  	CONTROL_REPEATUNTIL: "repetir fins a %1",
  	CONTROL_STOP: "estòp %1",
  	CONTROL_STARTASCLONE: "quand comenci coma un clòn",
  	CONTROL_CREATECLONEOF: "crear clòn de %1",
  	CONTROL_DELETETHISCLONE: "suprimir aquel clòn",
  	SENSING_ASKANDWAIT: "demandar %1 e esperar",
  	"videoSensing.videoToggle": "Comutar la video sus %1",
  	"videoSensing.setVideoTransparency": "reglar la transparéncia sus %1",
  	"videoSensing.whenMotionGreaterThan": "quand lo moviment de video > %1",
  	SENSING_RESETTIMER: "purgar lo minutor",
  	DATA_SETVARIABLETO: "definir %1 a %2",
  	DATA_CHANGEVARIABLEBY: "cambiar %1 per %2",
  	DATA_SHOWVARIABLE: "mostrar variabla %1",
  	DATA_HIDEVARIABLE: "amagar variabla %1",
  	DATA_ADDTOLIST: "apondre %1 a %2",
  	DATA_DELETEOFLIST: "suprimir %1 de %2",
  	DATA_DELETEALLOFLIST: "suprimir tot de %1",
  	MOTION_IFONEDGEBOUNCE: "se al ras, rebombir",
  	DATA_INSERTATLIST: "inserir %1 a %2 de %3",
  	DATA_REPLACEITEMOFLIST: "remplaçar element %1 de %2 amb %3",
  	DATA_SHOWLIST: "mostrar tièra %1",
  	DATA_HIDELIST: "amagar tièra %1",
  	SENSING_OF_XPOSITION: "posicion x",
  	SENSING_OF_YPOSITION: "posicion y",
  	SENSING_OF_DIRECTION: "direccion",
  	SENSING_OF_COSTUMENUMBER: "costum #",
  	LOOKS_COSTUMENUMBERNAME: "costum %1",
  	SENSING_OF_SIZE: "talha",
  	SENSING_OF_BACKDROPNAME: "nom del fons",
  	LOOKS_BACKDROPNUMBERNAME: "fons %1",
  	SENSING_OF_BACKDROPNUMBER: "fons #",
  	SOUND_VOLUME: "volum",
  	"music.getTempo": "tempò",
  	SENSING_TOUCHINGOBJECT: "touching %1?",
  	SENSING_TOUCHINGCOLOR: "de tocar la color %1 ?",
  	SENSING_COLORISTOUCHINGCOLOR: "color %1 es a tocar %2",
  	SENSING_DISTANCETO: "distància a %1",
  	SENSING_ANSWER: "responsa",
  	SENSING_KEYPRESSED: "tòca %1 premsada ?",
  	SENSING_MOUSEDOWN: "mirga bassa ?",
  	SENSING_MOUSEX: "mirga x",
  	SENSING_MOUSEY: "mirga y",
  	SENSING_SETDRAGMODE: "reglar lo mòde de tirassar %1",
  	SENSING_LOUDNESS: "intensitat",
  	"videoSensing.videoOn": "%1 de la vidèo sus %2",
  	SENSING_TIMER: "minutor",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "corrent %1",
  	SENSING_DAYSSINCE2000: "jorns dempuèi 2000",
  	SENSING_USERNAME: "nom d'utilizator",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "causida aleatòria de %1 de %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 e %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "pas %1",
  	OPERATORS_JOIN: "juntar %1 %2",
  	OPERATORS_LETTEROF: "letra %1 de %2",
  	OPERATORS_LENGTH: "longor de %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "redond %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%1 conten %2 ?",
  	DATA_ITEMOFLIST: "element %1 de %2",
  	DATA_ITEMNUMOFLIST: "element # de %1 dins %2",
  	DATA_LENGTHOFLIST: "longor de %1",
  	DATA_LISTCONTAINSITEM: "%1 conten %2 ?",
  	CONTROL_ELSE: "senon",
  	SENSING_USERID: "id d'utilizator",
  	SENSING_LOUD: "fòrt ?",
  	"text2speech.speakAndWaitBlock": "dire %1",
  	"text2speech.setVoiceBlock": "reglar la votz sus %1",
  	"text2speech.setLanguageBlock": "reglar la lenga sus %1",
  	"translate.translateBlock": "traduire %1 en %2",
  	"translate.viewerLanguage": "lenga",
  	"makeymakey.whenKeyPressed": "quand la toca  %1 es premsada",
  	"makeymakey.whenKeysPressedInOrder": "quand %1 son premsadas dins l'òrdre",
  	"microbit.whenButtonPressed": "quand lo boton %1 es premsat",
  	"microbit.isButtonPressed": "boton %1 premsat ?",
  	"microbit.whenGesture": "quand %1",
  	"microbit.displaySymbol": "afichar %1",
  	"microbit.displayText": "afichar lo tèxt %1",
  	"microbit.clearDisplay": "escafar l'ecran",
  	"microbit.whenTilted": "qaund clinat %1",
  	"microbit.isTilted": "clinat %1 ?",
  	"microbit.tiltAngle": "enclinason %1",
  	"microbit.whenPinConnected": "quand lo pin %1 es connectat",
  	"ev3.motorTurnClockwise": "Motor %1 virant per aquí pendent %2 segondas",
  	"ev3.motorTurnCounterClockwise": "Motor %1 virant per ailà pendent %2 segondas",
  	"ev3.motorSetPower": "Poténcia del motor %1 reglat a %2 %",
  	"ev3.getMotorPosition": "posicion del motor %1",
  	"ev3.whenButtonPressed": "quand lo boton %1 es premsat",
  	"ev3.whenDistanceLessThan": "quand la distància < %1",
  	"ev3.whenBrightnessLessThan": "quand la luminositat < %1",
  	"ev3.buttonPressed": "boton %1 premsat ?",
  	"ev3.getDistance": "distància",
  	"ev3.getBrightness": "luminositat",
  	"ev3.beepNote": "tindar la nòta %1 pendent %2 s.",
  	"wedo2.motorOn": "Alucar lo motor %1",
  	"wedo2.motorOff": "Atudar lo motor %1",
  	"wedo2.startMotorPower": "reglar la poténcia del motor %1 sus %2",
  	"wedo2.setMotorDirection": "reglar la direccion del motor %1 cap a %2",
  	"wedo2.whenDistance": "quand la distància %1 %2",
  	"wedo2.getDistance": "distància",
  	"wedo2.motorOnFor": "Alucar lo motor %1 pendent %2 segondas",
  	"wedo2.setLightHue": "reglar la color del lum sus %1",
  	"wedo2.playNoteFor": "jogar la nòta %1 pendent %2 segondas",
  	"wedo2.whenTilted": "quand clinat  %1",
  	"wedo2.isTilted": "clinat %1 ?",
  	"wedo2.getTiltAngle": "Anle d'enclinason %1",
  	"gdxfor.whenGesture": "quand %1",
  	"gdxfor.whenForcePushedOrPulled": "quand lo captor de fòrça %1",
  	"gdxfor.getForce": "fòrça",
  	"gdxfor.whenTilted": "quand clinat %1",
  	"gdxfor.isTilted": "clinat %1 ?",
  	"gdxfor.getTilt": "Angle d'enclinason %1",
  	"gdxfor.isFreeFalling": "A tombar ?",
  	"gdxfor.getSpin": "Velocitat de rotacion  %1",
  	"gdxfor.getAcceleration": "acceleracion %1",
  	"boost.motorOnFor": "Alucar lo motor %1 pendent %2 segondas",
  	"boost.motorOnForRotation": "Alucar lo motor %1 pendent %2 rotacions",
  	"boost.motorOn": "alucar lo motor %1",
  	"boost.motorOff": "atudar lo motor %1",
  	"boost.setMotorPower": "Reglar la velocitat del motor %1 sus %2 %",
  	"boost.setMotorDirection": "Reglar la direccion del motor %1 sus %2",
  	"boost.getMotorPosition": "posicion del motor %1",
  	"boost.whenColor": "quand la brica de color %1 es vista",
  	"boost.seeingColor": "A veire la brica %1 ?",
  	"boost.whenTilted": "quand clinat  %1",
  	"boost.getTiltAngle": "Anle d'enclinason %1",
  	"boost.setLightHue": "reglar la color del lum sus %1"
  };
  var dropdowns$n = {
  };
  var ignorelt$n = [
  ];
  var soundEffects$n = [
  	"ton",
  	"equilibrar drecha/esquèrra"
  ];
  var microbitWhen$n = [
  	"bolegat",
  	"brandit",
  	"sautat"
  ];
  var osis$n = [
  	"autres escripts dins sprite"
  ];
  var definePrefix$n = [
  	"define"
  ];
  var defineSuffix$n = [
  ];
  var palette$n = {
  	Motion: "Moviment",
  	Looks: "Aparéncias",
  	Sound: "Son",
  	Events: "Eveniments",
  	Control: "Contraròtle",
  	Sensing: "Captors",
  	Operators: "Operators",
  	Variables: "Variablas",
  	"My Blocks": "Mos Blòcs"
  };
  var math$n = [
  	"abs",
  	"arredondit.inf",
  	"arredondit.sup",
  	"rasiga",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$n = {
  };
  var name$n = "Occitan";
  var percentTranslated$n = 100;
  var oc = {
  	commands: commands$n,
  	dropdowns: dropdowns$n,
  	ignorelt: ignorelt$n,
  	soundEffects: soundEffects$n,
  	microbitWhen: microbitWhen$n,
  	osis: osis$n,
  	definePrefix: definePrefix$n,
  	defineSuffix: defineSuffix$n,
  	palette: palette$n,
  	math: math$n,
  	aliases: aliases$n,
  	name: name$n,
  	percentTranslated: percentTranslated$n
  };

  var commands$m = {
  	MOTION_MOVESTEPS: "%1 ପାଦ ଆଗକୁ ଯାଅ",
  	MOTION_TURNRIGHT: "@turnRightକୁ  %1 ଡିଗ୍ରୀ ମୋଡ",
  	MOTION_TURNLEFT: "@turnLeft କୁ %1 ଡିଗ୍ରୀ ମୋଡ",
  	MOTION_POINTINDIRECTION: "%1 ଦିଗରେ ମୁହାଁଇ ଦିଅ",
  	MOTION_POINTTOWARDS: "%1 ଦିଗରେ ମୁହାଁଇ ଦିଅ",
  	MOTION_GOTOXY: "x: %1  y: %2 କୁ ଯାଅ",
  	MOTION_GOTO: "%1 କୁ ଯାଅ",
  	MOTION_GLIDESECSTOXY: "%1 ସେକେଣ୍ଡ  x: %2 y: %3 କୁ ଖସାଅ",
  	MOTION_GLIDETO: "%1 ସେକେଣ୍ଡ %2 କୁ ଖସାଅ",
  	MOTION_CHANGEXBY: "x କୁ %1 ଦ୍ବାରା ବଦଳାଅ",
  	MOTION_SETX: "x କୁ %1 କର",
  	MOTION_CHANGEYBY: "y କୁ %1 ଦ୍ବାରା ବଦଳ କର",
  	MOTION_SETY: "y କୁ %1 କର",
  	MOTION_SETROTATIONSTYLE: "%1 କୁ ଘୂରିବାର ଶୈଳୀ ବାଛ",
  	LOOKS_SAYFORSECS: "%1 କୁ %2 ସେକେଣ୍ଡ ପର୍ଯନ୍ତ କୁହ",
  	LOOKS_SAY: "%1 କୁହ",
  	LOOKS_THINKFORSECS: "%1 କୁ %2 ସେକେଣ୍ଡ ପର୍ଯନ୍ତ ଚିନ୍ତା କର",
  	LOOKS_THINK: "%1 ଭାବ",
  	LOOKS_SHOW: "ଦେଖାଅ",
  	LOOKS_HIDE: "ଲୁଚାଅ",
  	LOOKS_SWITCHCOSTUMETO: "ପୋଷାକ %1 କୁ ବଦଳାଇ ଦିଅ",
  	LOOKS_NEXTCOSTUME: "ପରବର୍ତୀ ପୋଷାକ",
  	LOOKS_NEXTBACKDROP_BLOCK: "ପରବର୍ତୀ ପୃଷ୍ଠଭୂମି",
  	LOOKS_SWITCHBACKDROPTO: "ପୃଷ୍ଠଭୂମି %1 କୁ ବଦଳାଅ",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "ପୃଷ୍ଠଭୂମି %1 କୁ ବଦଳାଅ ଓ ଅପେକ୍ଷା କର",
  	LOOKS_CHANGEEFFECTBY: "%1 ର ପ୍ରଭାବ କୁ %2 ଦ୍ବାରା ବଦଳାଅ",
  	LOOKS_SETEFFECTTO: "%1 ର ପ୍ରଭାବ କୁ %2 ରେ ବଦଳାଇ ଦିଅ",
  	LOOKS_CLEARGRAPHICEFFECTS: "ଚିତ୍ରରୂପ ର ପ୍ରଭାବ କୁ ବିଲୋପ କର",
  	LOOKS_CHANGESIZEBY: "ଆକାର କୁ %1 ବଦଳାଅ",
  	LOOKS_SETSIZETO: "ଆକାର କୁ  %1 % ରଖ",
  	LOOKS_GOTOFRONTBACK: "%1 ସ୍ତର କୁ ଯାଅ",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 ସ୍ତର କୁ ଯାଅ",
  	SOUND_PLAY: "ଶବ୍ଦ %1 ଆରମ୍ଭ କର",
  	SOUND_CHANGEEFFECTBY: "%1 ପ୍ରଭାବ କୁ %2 ରେ ବଦଳାଅ",
  	SOUND_SETEFFECTO: "%1 ପ୍ରଭାବ କୁ %2 ରେ ରଖ",
  	SOUND_CLEAREFFECTS: "ଶବ୍ଦ ର ପ୍ରଭାବ କୁ ବନ୍ଦ କର",
  	SOUND_PLAYUNTILDONE: "ଶବ୍ଦ %1 ଶେଷ ପର୍ଯ୍ୟନ୍ତ କର",
  	SOUND_STOPALLSOUNDS: "ସବୁ ଶବ୍ଦ ବନ୍ଦ କର",
  	"music.playDrumForBeats": "%2 ବିଟ୍ ପାଇଁ ଡ୍ରମ୍ %1 ବଜାନ୍ତୁ",
  	"music.restForBeats": "ଏତିକି %1 ତାଳ ପାଇଂ ରୁହ",
  	"music.playNoteForBeats": "%2 ବିଟ୍ ପାଇଁ %1 ଟିପ୍ପଣୀ ସ୍ବର ବଜାନ୍ତୁ",
  	"music.setInstrument": "ବାଦ୍ୟଯନ୍ତ୍ରକୁ %1 ରେ ରଖନ୍ତୁ",
  	SOUND_CHANGEVOLUMEBY: "%1 ରେ ତୀବ୍ରତା ବଦଳାଅ",
  	SOUND_SETVOLUMETO: "ଶବ୍ଦ ର ତୀବ୍ରତା କୁ %1% ରଖ",
  	"music.changeTempo": "ତାଳ କୁ %1 ରେ ବଦଳାନ୍ତୁ",
  	"music.setTempo": "%1 ଲୟକୁ ସେଟ୍ କରନ୍ତୁ",
  	"pen.clear": "ସବୁ ଲିଭାଇ ଦିଅ",
  	"pen.stamp": "ଷ୍ଟାମ୍ପ ଲଗାଅ",
  	"pen.penDown": "ପେନ୍ ତଳକୁ",
  	"pen.penUp": "ପେଁ ଉପରକୁ",
  	"pen.setColor": "କଲମ ର ରଙ୍ଗ କୁ %1 ରେ ରଖ",
  	"pen.changeHue": "କଲମ ରଙ୍ଗ %1 ଦ୍ୱାରା ପରିବର୍ତ୍ତନ କରନ୍ତୁ",
  	"pen.setColorParam": "କଲମ %1 କୁ  %2 ରେ ରଖ",
  	"pen.changeColorParam": "%1 କଲମ କୁ %2 ଦ୍ୱାରା ପରିବର୍ତ୍ତନ କରନ୍ତୁ",
  	"pen.setHue": "କଲମ ର ରଙ୍ଗ କୁ %1 ରେ ରଖ",
  	"pen.changeShade": "କଲମ ରଙ୍ଗର ଗଭୀରତା %1 ଦ୍ୱାରା ପରିବର୍ତ୍ତନ",
  	"pen.setShade": "କଲମ ର ଗଭୀରତା କୁ %1 ରେ ରଖ",
  	"pen.changeSize": "କାଲାମ ର ଆକାର %1 से ବଦଳାa",
  	"pen.setSize": "କଲମ ର ଆକାର କୁ  %1 ରେ ରଖ",
  	EVENT_WHENFLAGCLICKED: "ଯେବେ @greenFlag କୁ କ୍ଲିକ କରାଯିବ",
  	EVENT_WHENKEYPRESSED: "ଯେବେ %1 ଚାବି ଟି କୁ ଦାବି ଦିଆ ଯାଏ",
  	EVENT_WHENTHISSPRITECLICKED: "ଯେତେବେଳେ ଏହି ସ୍ପ୍ରାଇଟ କ୍ଲିକ କରାଯାଏ",
  	EVENT_WHENSTAGECLICKED: "ଯେତେବେଳେ ମଞ୍ଚ କୁ କ୍ଲିକ କରାଯାଏ",
  	EVENT_WHENBACKDROPSWITCHESTO: "ଯେତେବେଳେ ପୃଷ୍ଠଭୂମି %1 କୁ ବଦଳି ଯାଏ",
  	EVENT_WHENGREATERTHAN: "ଯେତେବେଳେ %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ଯେତେବେଳେ ମୋତେ %1 ମିଳେ",
  	EVENT_BROADCAST: "%1 କୁ ପ୍ରସାରଣ କର",
  	EVENT_BROADCASTANDWAIT: "%1 ପ୍ରସାରଣ କରି ଅପେକ୍ଷା କର",
  	CONTROL_WAIT: "%1 ସେକେଣ୍ଡ ଅପେକ୍ଷା କର",
  	CONTROL_REPEAT: "%1 ପୁନରାବୃତ୍ତି କର",
  	CONTROL_FOREVER: "ସବୁ ଦିନ ପାଇଁ",
  	CONTROL_IF: "ଯଦି %1 ତେବେ",
  	CONTROL_WAITUNTIL: "%1 ସେକେଣ୍ଡ ପର୍ଯନ୍ତ ଅପେକ୍ଷା କର",
  	CONTROL_REPEATUNTIL: "%1 ପର୍ଯନ୍ତ ପୁନରାବୃତ୍ତି କର",
  	CONTROL_STOP: "ବନ୍ଦ କର %1",
  	CONTROL_STARTASCLONE: "ମୋର ଏକ କ୍ଲୋନ ରୂପରେ ଆରମ୍ଭ ହେଲାପରେ",
  	CONTROL_CREATECLONEOF: "%1 ର କ୍ଲୋନ ତିଆର କର",
  	CONTROL_DELETETHISCLONE: "ଏହି କ୍ଲୋନ କୁ ଲିଭାଇ ଦିଅ",
  	SENSING_ASKANDWAIT: "%1 ପଚାର ଓ ଅପେକ୍ଷା କର",
  	"videoSensing.videoToggle": "ଭିଡିଓ କୁ ଘୂରାଅ %1",
  	"videoSensing.setVideoTransparency": "ଭିଡିଓ ପାରଦର୍ଶିତା କୁ %1 ରେ ରଖ",
  	"videoSensing.whenMotionGreaterThan": "ଯେବେ ଭିଡିଓ ର ଗତି > %1",
  	SENSING_RESETTIMER: "ଘଂଟା କୁ ରିସେଟ କର",
  	DATA_SETVARIABLETO: "%1 କୁ %2 ରେ ବଦଳାଇଦିଅ",
  	DATA_CHANGEVARIABLEBY: "%1 ରେ  %2 ମିଶାଇ ଦିଅ",
  	DATA_SHOWVARIABLE: "%1 ଭେରିଏବଲ୍ ଟି ଦର୍ଶାଅ",
  	DATA_HIDEVARIABLE: "ଭେରିଏବଲ୍ %1 କୁ ଲୁଚାଅ",
  	DATA_ADDTOLIST: "%2 ରେ %1 ମିଶାଅ",
  	DATA_DELETEOFLIST: "%2 ରୁ %1 ବିଲୋପ କର",
  	DATA_DELETEALLOFLIST: "%1 କୁ ପୁରା ବିଲୋପ କର",
  	MOTION_IFONEDGEBOUNCE: "ଯଦି ସୀମା ରେ ଅଛ ତାହେଲେ ଡିଆଁ ମାର",
  	DATA_INSERTATLIST: "%1 କୁ %3 ର %2 ଠାରେ ରଖ",
  	DATA_REPLACEITEMOFLIST: "%2 ର %1 ତମ ବସ୍ତୁ କୁ %3 ଦ୍ବାରା ବଦଳାଇ ଦିଅ",
  	DATA_SHOWLIST: "%1 ତାଲିକା ଦେଖାଅ",
  	DATA_HIDELIST: "%1 ତାଲିକା ଲୁଚାଅ",
  	SENSING_OF_XPOSITION: "x ସ୍ଥିତି",
  	SENSING_OF_YPOSITION: "y ସ୍ଥିତି",
  	SENSING_OF_DIRECTION: "ଦିଗ",
  	SENSING_OF_COSTUMENUMBER: "ପୋଷାକ #",
  	LOOKS_COSTUMENUMBERNAME: "%1 ପୋଷାକ",
  	SENSING_OF_SIZE: "ଆକାର",
  	SENSING_OF_BACKDROPNAME: "ପୃଷ୍ଠଭୂମି ର ନାମ",
  	LOOKS_BACKDROPNUMBERNAME: "%1 ପୃଷ୍ଠଭୂମି",
  	SENSING_OF_BACKDROPNUMBER: "ପୃଷ୍ଠଭୂମି #",
  	SOUND_VOLUME: "ତୀବ୍ରତା",
  	"music.getTempo": "ଲୟ",
  	SENSING_TOUCHINGOBJECT: "%1 ସ୍ପର୍ଶ କରୁଥିବା?",
  	SENSING_TOUCHINGCOLOR: "%1 ରଙ୍ଗ କୁ ସ୍ପର୍ଶ କରୁଛି?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 ରଙ୍ଗ %2 କୁ ସ୍ପର୍ଶ କରୁଛି?",
  	SENSING_DISTANCETO: "%1 ପର୍ଯ୍ୟନ୍ତ ଦୂରତା",
  	SENSING_ANSWER: "ଉତ୍ତର",
  	SENSING_KEYPRESSED: "ଯେବେ %1 ବୋତାମ ଦବା ଯିବ?",
  	SENSING_MOUSEDOWN: "ମାଉସ ତଳକୁ?",
  	SENSING_MOUSEX: "ମାଉସ x",
  	SENSING_MOUSEY: "ମାଉସ y",
  	SENSING_SETDRAGMODE: "ଟାଣିବାର ପ୍ରକାର %1 ରଖ",
  	SENSING_LOUDNESS: "ଶବ୍ଦ ର ତୀବ୍ରତା",
  	"videoSensing.videoOn": "ଭିଡିଓ %1  %2 ଉପରେ",
  	SENSING_TIMER: "ଘଣ୍ଟା",
  	SENSING_OF: "%2 ର %1",
  	SENSING_CURRENT: "ଏବର %1",
  	SENSING_DAYSSINCE2000: "ବର୍ଷ 2000 ପରଠାରୁ ଦିନ",
  	SENSING_USERNAME: "ବ୍ୟବହାରକାରୀ ର ନାମ",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 ରୁ %2 ପର୍ଯନ୍ତ ଯେକୌଣସି ସଂଖ୍ୟା ବାଛ",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 ଓ %2",
  	OPERATORS_OR: "%1 ବା %2",
  	OPERATORS_NOT: "%1 ନୁହେଁ",
  	OPERATORS_JOIN: "ଯୋଗ ଦିଅନ୍ତୁ %1 %2",
  	OPERATORS_LETTEROF: "%2 ରୁ  %1 ଅକ୍ଷର",
  	OPERATORS_LENGTH: "%1 ର ଦୈର୍ଘ୍ୟ",
  	OPERATORS_MOD: "%1 ମଡ଼ %2",
  	OPERATORS_ROUND: "ଗୋଲ %1",
  	OPERATORS_MATHOP: "%2 ରୁ %1",
  	OPERATORS_CONTAINS: "%1 ରେ %2 ଅନ୍ତର୍ଭୁକ୍ତ ?",
  	DATA_ITEMOFLIST: "%2 ର %1 ତମ ବସ୍ତୁ",
  	DATA_ITEMNUMOFLIST: "%2 ରେ %1 ତମ ବସ୍ତୁ",
  	DATA_LENGTHOFLIST: "%1 ର ଦୈର୍ଘ୍ୟ",
  	DATA_LISTCONTAINSITEM: "%1 ରେ %2 ଅଛି କି?",
  	CONTROL_ELSE: "ଅଥବା",
  	SENSING_USERID: "ବ୍ୟବହାରକାରୀ ର ଚିହ୍ନ",
  	SENSING_LOUD: "ଅଧିକ?",
  	"text2speech.speakAndWaitBlock": "କୁହ %1",
  	"text2speech.setVoiceBlock": "%1 ଉପରେ ସ୍ବର ରଖ",
  	"text2speech.setLanguageBlock": "%1 ରେ ଭାଷା କୁ ରଖ",
  	"translate.translateBlock": "%1 କୁ %2 ରେ ଅନୁବାଦ କର",
  	"translate.viewerLanguage": "ଭାଷା",
  	"makeymakey.whenKeyPressed": "ଯେତେବେଳେ %1 ଚାବି ଦବାଗଲା",
  	"makeymakey.whenKeysPressedInOrder": "ଯେତେବେଳେ %1 କ୍ରମରେ ଦବାଗଲା",
  	"microbit.whenButtonPressed": "ଯେତେବେଳେ %1 ବଟନ୍ ଦବାଗଲା",
  	"microbit.isButtonPressed": "କୌ ବଟନ %1 ଚିପିଲ?",
  	"microbit.whenGesture": "ଯେବେ %1",
  	"microbit.displaySymbol": "ସ୍କ୍ରିନ୍ %1",
  	"microbit.displayText": "ଦୃଶ୍ୟ ଅକ୍ଷର %1",
  	"microbit.clearDisplay": "ସ୍କ୍ରିନ୍ ସଫା କର",
  	"microbit.whenTilted": "ଯେବେ ଝୁଙ୍କିକି ଥିବ %1 दिशामे झुका हो",
  	"microbit.isTilted": "ଝୁଙ୍କିଛି %1 ?",
  	"microbit.tiltAngle": "ଝୁଙ୍କିବାର କୋଣ %1",
  	"microbit.whenPinConnected": "ଯେତେବେଳେ ପିନ୍ %1 ସଂଯୁକ୍ତ",
  	"ev3.motorTurnClockwise": "ମୋଟର କୁ %1 %2 ସେକେଣ୍ଡ ପାଇଁ ଏହି ପଟେ ବୁଲାନ୍ତୁ",
  	"ev3.motorTurnCounterClockwise": "ମୋଟର କୁ %1 %2 ସେକେଣ୍ଡ ପାଇଁ ସେହି ପଟେ ବୁଲାନ୍ତୁ",
  	"ev3.motorSetPower": "%1 ମୋଟର ଶକ୍ତି %2% ସେଟ୍ କରନ୍ତୁ",
  	"ev3.getMotorPosition": "%1 ମୋଟର ସ୍ଥିତି |",
  	"ev3.whenButtonPressed": "ଯେତେବେଳେ ବଟନ୍ %1 ଦବାଗଲା",
  	"ev3.whenDistanceLessThan": "ଯେତେବେଳେ ଦୂରତା < %1",
  	"ev3.whenBrightnessLessThan": "ଯେତେବେଳେ ଉଜ୍ଜ୍ୱଳ < %1",
  	"ev3.buttonPressed": "କେଉଁ %1 ବଟନ୍ ଦବେଇଲ?",
  	"ev3.getDistance": "ଦୂରତା",
  	"ev3.getBrightness": "ଉଜ୍ଜ୍ୱଳତା",
  	"ev3.beepNote": "%1 बीप लय को %2 क्षण तक चलाए",
  	"wedo2.motorOn": "%1 ଚଳାଅ",
  	"wedo2.motorOff": "%1 ବନ୍ଦ କର",
  	"wedo2.startMotorPower": "%1 ର କ୍ଷମତା %2 ରଖ",
  	"wedo2.setMotorDirection": "%1 ର ଦିଗ କୁ %2 ରଖ",
  	"wedo2.whenDistance": "ଯେବେ ଦୂରତା  %1%2",
  	"wedo2.getDistance": "ଦୂରତ୍ବ",
  	"wedo2.motorOnFor": "%1 କୁ %2 ସେକେଣ୍ଡ ପାଇଁ ଚଳାଅ",
  	"wedo2.setLightHue": "ଆଲୁଅ ର ରଙ୍ଗ %1 ରଖ",
  	"wedo2.playNoteFor": "%1 ସ୍ବର କୁ %2 ସେକେଣ୍ଡ ପାଇଁ ବଜାଅ",
  	"wedo2.whenTilted": "ଯେବେ ଝୁଙ୍କିକି ଥିବ %1",
  	"wedo2.isTilted": "ଝୁଙ୍କିବା %1?",
  	"wedo2.getTiltAngle": "ଝୁଙ୍କିବା ର ଦିଗ %1",
  	"gdxfor.whenGesture": "ଯେବେ %1",
  	"gdxfor.whenForcePushedOrPulled": "ଯେବେ ଫୋର୍ସ ସେନ୍ସର %1",
  	"gdxfor.getForce": "ବଳ",
  	"gdxfor.whenTilted": "ଯେତେବେଳେ ଝୁଂକିଛି %1",
  	"gdxfor.isTilted": "ଏହା କେତେ ଝୁଙ୍କିଛି %1?",
  	"gdxfor.getTilt": "ପ୍ଝୁଙ୍କିବା ର କୋଣ %1",
  	"gdxfor.isFreeFalling": "ପଡୁଛି?",
  	"gdxfor.getSpin": "ଘୂରିବା ଗତି %1",
  	"gdxfor.getAcceleration": "ତ୍ୱରଣ %1",
  	"boost.motorOnFor": "%1 ମୋଟର ଚଲାନ୍ତୁ %2 କ୍ଷଣ ପାଇଁ",
  	"boost.motorOnForRotation": "%1ମୋଟର ଚଲାନ୍ତୁ %2 ରାଉଣ୍ଡ ପାଇଁ",
  	"boost.motorOn": "%1 ମୋଟର ଟର୍ନ୍ ଅନ୍ କରନ୍ତୁ",
  	"boost.motorOff": "%1 ମୋଟର ବନ୍ଦ କର",
  	"boost.setMotorPower": "ମୋଟର  %1 ଗତି ସ୍ଥିର କରନ୍ତୁ %2 % ଯାଏଁ",
  	"boost.setMotorDirection": "ମୋଟର %1 ଦିଗ  %2 ସେଟ୍ କରନ୍ତୁ",
  	"boost.getMotorPosition": "ମୋଟର  %1 की स्थिति",
  	"boost.whenColor": "ଯେତେବେଳେ ତୁମେ %1 ଇଟା ଦେଖିବ",
  	"boost.seeingColor": "କେଉଁ %1 ଇଟା ଦେଖିଲ?",
  	"boost.whenTilted": "ଝୁଙ୍କି ଥିଲା ବେଳେ %1",
  	"boost.getTiltAngle": "ଝୁଙ୍କାଇବାର ଦିଗ %1",
  	"boost.setLightHue": "ଆଲୁଅ କଲଡର %1 ରଖ"
  };
  var dropdowns$m = {
  };
  var ignorelt$m = [
  ];
  var soundEffects$m = [
  	"ଧ୍ବନୀ ର ସ୍ତର",
  	"ବାମ-ଡାହାଣ କୁ ଦେଖାଅ"
  ];
  var microbitWhen$m = [
  	"ଘୁଞ୍ଚିଗଲା",
  	"ହଲିଗଲା",
  	"ଡେଇଁପଡ଼ିଲା"
  ];
  var osis$m = [
  	"ସ୍ପ୍ରାଇଟ ରେ ଥିବା ଅନ୍ୟ ଲିପି"
  ];
  var definePrefix$m = [
  ];
  var defineSuffix$m = [
  	"କୁ",
  	"ବୁଝାଅ"
  ];
  var palette$m = {
  	Motion: "ଗତି",
  	Looks: "ରୂପ",
  	Sound: "ଶବ୍ଦ",
  	Events: "ଘଟଣାକ୍ରମ",
  	Control: "ନିୟନ୍ତ୍ରଣ",
  	Sensing: "ଅନୁଭବ କରିବା",
  	Operators: "ଅପରେଟର ଗୁଡିକ",
  	Variables: "ଭେରିଏବଲ୍ ଗୁଡିକ",
  	"My Blocks": "ମୋ ବ୍ଲକ ଗୁଡି଼କ"
  };
  var math$m = [
  	"ଏବିଏସ",
  	"ତଳ",
  	"ଛାତ",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"cosec",
  	"cot",
  	"ln",
  	"log",
  	"e ^",
  	"10^"
  ];
  var aliases$m = {
  };
  var name$m = "ଓଡ଼ିଆ";
  var percentTranslated$m = 100;
  var or = {
  	commands: commands$m,
  	dropdowns: dropdowns$m,
  	ignorelt: ignorelt$m,
  	soundEffects: soundEffects$m,
  	microbitWhen: microbitWhen$m,
  	osis: osis$m,
  	definePrefix: definePrefix$m,
  	defineSuffix: defineSuffix$m,
  	palette: palette$m,
  	math: math$m,
  	aliases: aliases$m,
  	name: name$m,
  	percentTranslated: percentTranslated$m
  };

  var commands$l = {
  	MOTION_MOVESTEPS: "przesuń o %1 kroków",
  	MOTION_TURNRIGHT: "obróć @turnRight o %1 stopni",
  	MOTION_TURNLEFT: "obróć @turnLeft o %1 stopni",
  	MOTION_POINTINDIRECTION: "ustaw kierunek na %1",
  	MOTION_POINTTOWARDS: "ustaw w kierunku duszka %1",
  	MOTION_GOTOXY: "Idź do x: %1 y: %2",
  	MOTION_GOTO: "idź do %1",
  	MOTION_GLIDESECSTOXY: "leć przez %1 sekund do x: %2 y: %3",
  	MOTION_GLIDETO: "leć przez %1 sekund do %2",
  	MOTION_CHANGEXBY: "zmień x o %1",
  	MOTION_SETX: "ustaw x na %1",
  	MOTION_CHANGEYBY: "zmień y o %1",
  	MOTION_SETY: "ustaw y na %1",
  	MOTION_SETROTATIONSTYLE: "ustaw styl obrotu na %1",
  	LOOKS_SAYFORSECS: "powiedz %1 przez %2 sekund",
  	LOOKS_SAY: "powiedz %1",
  	LOOKS_THINKFORSECS: "pomyśl %1 przez %2 sekund",
  	LOOKS_THINK: "pomyśl %1",
  	LOOKS_SHOW: "pokaż",
  	LOOKS_HIDE: "ukryj",
  	LOOKS_SWITCHCOSTUMETO: "zmień kostium na %1",
  	LOOKS_NEXTCOSTUME: "następny kostium",
  	LOOKS_NEXTBACKDROP_BLOCK: "następne tło",
  	LOOKS_SWITCHBACKDROPTO: "zmień tło na %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "zmień tło na %1 i czekaj",
  	LOOKS_CHANGEEFFECTBY: "zmień efekt %1 o %2",
  	LOOKS_SETEFFECTTO: "ustaw efekt %1 na %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "wyczyść efekty graficzne",
  	LOOKS_CHANGESIZEBY: "zmień rozmiar o %1",
  	LOOKS_SETSIZETO: "ustaw rozmiar na %1 %",
  	LOOKS_GOTOFRONTBACK: "przesuń na %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "przesuń %1 o %2 warstw",
  	SOUND_PLAY: "zagraj dźwięk %1",
  	SOUND_CHANGEEFFECTBY: "zmień efekt %1 o %2",
  	SOUND_SETEFFECTO: "ustaw efekt %1 na %2",
  	SOUND_CLEAREFFECTS: "usuń efekty dźwiękowe",
  	SOUND_PLAYUNTILDONE: "graj dźwięk %1 aż się skończy",
  	SOUND_STOPALLSOUNDS: "zakończ wszystkie dźwięki",
  	"music.playDrumForBeats": "graj na %1 przez %2 taktów",
  	"music.restForBeats": "pauzuj przez %1 taktów",
  	"music.playNoteForBeats": "zagraj nutę %1 przez %2 taktów",
  	"music.setInstrument": "ustaw instrument na %1",
  	SOUND_CHANGEVOLUMEBY: "zmień głośność o %1",
  	SOUND_SETVOLUMETO: "ustaw głośność na %1%",
  	"music.changeTempo": "zmień tempo na %1",
  	"music.setTempo": "ustaw tempo na %1",
  	"pen.clear": "wyczyść wszystko",
  	"pen.stamp": "Stempluj",
  	"pen.penDown": "Przyłóż pisak",
  	"pen.penUp": "Podnieś pisak",
  	"pen.setColor": "Ustaw kolor pisaka na %1",
  	"pen.changeHue": "Zmień kolor pisaka o %1",
  	"pen.setColorParam": "Ustaw %1pisaka na %2",
  	"pen.changeColorParam": "Zmień %1pisaka o%2",
  	"pen.setHue": "Ustaw kolor pisaka na %1",
  	"pen.changeShade": "Zmień odcień pisaka o %1",
  	"pen.setShade": "Ustaw odcień pisaka na %1",
  	"pen.changeSize": "Zmień rozmiar pisaka o %1",
  	"pen.setSize": "Ustaw rozmiar pisaka na %1",
  	EVENT_WHENFLAGCLICKED: "kiedy kliknięto @greenFlag",
  	EVENT_WHENKEYPRESSED: "kiedy klawisz %1 naciśnięty",
  	EVENT_WHENTHISSPRITECLICKED: "kiedy ten duszek kliknięty",
  	EVENT_WHENSTAGECLICKED: "kiedy scena kliknięta",
  	EVENT_WHENBACKDROPSWITCHESTO: "kiedy tło zmieni się na %1",
  	EVENT_WHENGREATERTHAN: "kiedy %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "kiedy otrzymam %1",
  	EVENT_BROADCAST: "nadaj komunikat %1",
  	EVENT_BROADCASTANDWAIT: "nadaj komunikat %1 i czekaj",
  	CONTROL_WAIT: "czekaj %1 sekund",
  	CONTROL_REPEAT: "powtórz %1 razy",
  	CONTROL_FOREVER: "zawsze",
  	CONTROL_IF: "jeżeli %1 to",
  	CONTROL_WAITUNTIL: "czekaj aż %1",
  	CONTROL_REPEATUNTIL: "powtarzaj aż %1",
  	CONTROL_STOP: "zatrzymaj %1",
  	CONTROL_STARTASCLONE: "gdy zaczynam jako klon",
  	CONTROL_CREATECLONEOF: "utwórz klona z %1",
  	CONTROL_DELETETHISCLONE: "usuń tego klona",
  	SENSING_ASKANDWAIT: "zapytaj %1 i czekaj",
  	"videoSensing.videoToggle": "%1 nagranie wideo",
  	"videoSensing.setVideoTransparency": "ustaw transparentność wideo na %1",
  	"videoSensing.whenMotionGreaterThan": "kiedy ruch wideo > %1",
  	SENSING_RESETTIMER: "resetuj stoper",
  	DATA_SETVARIABLETO: "ustaw %1 na %2",
  	DATA_CHANGEVARIABLEBY: "zmień %1 o %2",
  	DATA_SHOWVARIABLE: "pokaż zmienną %1",
  	DATA_HIDEVARIABLE: "ukryj zmienną %1",
  	DATA_ADDTOLIST: "dodaj %1 do %2",
  	DATA_DELETEOFLIST: "usuń %1 z %2",
  	DATA_DELETEALLOFLIST: "usuń wszystko z %1",
  	MOTION_IFONEDGEBOUNCE: "jeżeli na brzegu, odbij się",
  	DATA_INSERTATLIST: "wstaw %1 na %2 pozycji z %3",
  	DATA_REPLACEITEMOFLIST: "zamień %1 z %2 na %3",
  	DATA_SHOWLIST: "pokaż listę %1",
  	DATA_HIDELIST: "ukryj listę %1",
  	SENSING_OF_XPOSITION: "pozycja x",
  	SENSING_OF_YPOSITION: "pozycja y",
  	SENSING_OF_DIRECTION: "kierunek",
  	SENSING_OF_COSTUMENUMBER: "indeks kostiumu",
  	LOOKS_COSTUMENUMBERNAME: "kostium %1",
  	SENSING_OF_SIZE: "rozmiar",
  	SENSING_OF_BACKDROPNAME: "nazwa tła",
  	LOOKS_BACKDROPNUMBERNAME: "tło %1",
  	SENSING_OF_BACKDROPNUMBER: "indeks tła",
  	SOUND_VOLUME: "głośność",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "dotyka %1 ?",
  	SENSING_TOUCHINGCOLOR: "dotyka koloru %1 ?",
  	SENSING_COLORISTOUCHINGCOLOR: "kolor %1 dotyka %2 ?",
  	SENSING_DISTANCETO: "odległość od %1",
  	SENSING_ANSWER: "odpowiedź",
  	SENSING_KEYPRESSED: "klawisz %1 naciśnięty ?",
  	SENSING_MOUSEDOWN: "kliknięto myszką?",
  	SENSING_MOUSEX: "x myszy",
  	SENSING_MOUSEY: "y myszy",
  	SENSING_SETDRAGMODE: "ustaw tryb przeciągania na %1",
  	SENSING_LOUDNESS: "głośność",
  	"videoSensing.videoOn": "nagranie wideo %1 na %2",
  	SENSING_TIMER: "stoper",
  	SENSING_OF: "%1 z %2",
  	SENSING_CURRENT: "obecny %1",
  	SENSING_DAYSSINCE2000: "dni od 2000",
  	SENSING_USERNAME: "nazwa użytkownika",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "losuj liczbę od %1 do %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 i %2",
  	OPERATORS_OR: "%1 lub %2",
  	OPERATORS_NOT: "nie %1",
  	OPERATORS_JOIN: "połącz %1 i %2",
  	OPERATORS_LETTEROF: "litera %1 z %2",
  	OPERATORS_LENGTH: "długość %1",
  	OPERATORS_MOD: "reszta z dzielenia %1 przez %2",
  	OPERATORS_ROUND: "zaokrąglij %1",
  	OPERATORS_MATHOP: "%1 z %2",
  	OPERATORS_CONTAINS: "Czy %1 zawiera %2 ?",
  	DATA_ITEMOFLIST: "element %1 z %2",
  	DATA_ITEMNUMOFLIST: "pozycja %1 na liście %2",
  	DATA_LENGTHOFLIST: "długość %1",
  	DATA_LISTCONTAINSITEM: "%1 zawiera %2?",
  	CONTROL_ELSE: "w przeciwnym razie",
  	SENSING_USERID: "ID użytkownika",
  	SENSING_LOUD: "głośno?",
  	"text2speech.speakAndWaitBlock": "Powiedz %1",
  	"text2speech.setVoiceBlock": "Ustaw głos na %1",
  	"text2speech.setLanguageBlock": "ustaw język na %1",
  	"translate.translateBlock": "tłumacz %1 na %2",
  	"translate.viewerLanguage": "język",
  	"makeymakey.whenKeyPressed": "kiedy naciśnięto klawisz %1",
  	"makeymakey.whenKeysPressedInOrder": "kiedy naciśnięto kolejno %1",
  	"microbit.whenButtonPressed": "Gdy %1naciśnięty",
  	"microbit.isButtonPressed": "%1 przycisk naciśnięty?",
  	"microbit.whenGesture": "kiedy %1",
  	"microbit.displaySymbol": "wyświetl %1",
  	"microbit.displayText": "wyświetl tekst %1",
  	"microbit.clearDisplay": "wyczyść wyświetlacz",
  	"microbit.whenTilted": "gdy nachylony%1",
  	"microbit.isTilted": "nachylony %1",
  	"microbit.tiltAngle": "kąt nachylenia %1",
  	"microbit.whenPinConnected": "kiedy pin%1połączony",
  	"ev3.motorTurnClockwise": "Obróć silnik %1 do ruchu wskazówek zegara na %2 sekund",
  	"ev3.motorTurnCounterClockwise": "motor %1 turn that way for %2 seconds",
  	"ev3.motorSetPower": "ustaw moc silnika %1 na %2 %",
  	"ev3.getMotorPosition": "pozycja silnika %1",
  	"ev3.whenButtonPressed": "Gdy klawisz %1 naciśnięty",
  	"ev3.whenDistanceLessThan": "Gdy odległość < %1",
  	"ev3.whenBrightnessLessThan": "Gdy jasność < %1",
  	"ev3.buttonPressed": "Klawisz %1 naciśnięty?",
  	"ev3.getDistance": "odległość",
  	"ev3.getBrightness": "jasność",
  	"ev3.beepNote": "graj nutę %1 przez %2 sekund",
  	"wedo2.motorOn": "Włącz silnik %1",
  	"wedo2.motorOff": "Wyłącz silnik %1",
  	"wedo2.startMotorPower": "Ustaw moc silnika %1 na %2",
  	"wedo2.setMotorDirection": "Ustaw kierunek silnika %1 na %2",
  	"wedo2.whenDistance": "Gdy dystans %1 %2",
  	"wedo2.getDistance": "odległość",
  	"wedo2.motorOnFor": "Włącz silnik %1 na %2 sekund",
  	"wedo2.setLightHue": "Ustaw kolor światła na %1",
  	"wedo2.playNoteFor": "Graj nutę %1 przez %2 sekund",
  	"wedo2.whenTilted": "Gdy pochylony %1",
  	"wedo2.isTilted": "Pochylony %1",
  	"wedo2.getTiltAngle": "Kąt pochylenia %1",
  	"gdxfor.whenGesture": "kiedy %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "siła",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "kąt nachylenia %1",
  	"gdxfor.isFreeFalling": "spada?",
  	"gdxfor.getSpin": "prędkość wirowania %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "włącz silnik %1 na %2 sekund",
  	"boost.motorOnForRotation": "włącz silnik %1 na %2 obrotów",
  	"boost.motorOn": "włącz silnik %1",
  	"boost.motorOff": "wyłącz silnik %1",
  	"boost.setMotorPower": "ustaw moc silnika %1 na %2 %",
  	"boost.setMotorDirection": "ustaw kierunek obrotu silnika %1 na %2",
  	"boost.getMotorPosition": "pozycja silnika %1",
  	"boost.whenColor": "kiedy widzi %1 klocek",
  	"boost.seeingColor": "widzi %1 klocek?",
  	"boost.whenTilted": "Gdy pochylony %1",
  	"boost.getTiltAngle": "Kąt pochylenia %1",
  	"boost.setLightHue": "Ustaw kolor światła na %1"
  };
  var dropdowns$l = {
  };
  var ignorelt$l = [
  ];
  var soundEffects$l = [
  	"płynność dźwięku",
  	"przesuń w lewo/prawo"
  ];
  var microbitWhen$l = [
  	"poruszony",
  	"potrząśnięty",
  	"podrzucony"
  ];
  var osis$l = [
  	"inne skrypty duszka"
  ];
  var definePrefix$l = [
  	"definiuj"
  ];
  var defineSuffix$l = [
  ];
  var palette$l = {
  	Motion: "Ruch",
  	Looks: "Wygląd",
  	Sound: "Dźwięk",
  	Events: "Zdarzenia",
  	Control: "Kontrola",
  	Sensing: "Czujniki",
  	Operators: "Wyrażenia",
  	Variables: "Zmienne",
  	"My Blocks": "Moje bloki"
  };
  var math$l = [
  	"wartość bezwzględna",
  	"podłoga",
  	"sufit",
  	"pierwiastek kwadratowy",
  	"sinus",
  	"cosinus",
  	"tangens",
  	"arcus sinus",
  	"arcus cosinus",
  	"arcus tangens",
  	"logarytm naturalny",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$l = {
  	"obróć w lewo o %1 stopni": "MOTION_TURNLEFT",
  	"obróć w prawo o %1 stopni": "MOTION_TURNRIGHT",
  	"kiedy kliknięto zieloną flagę": "EVENT_WHENFLAGCLICKED",
  	koniec: "scratchblocks:end"
  };
  var name$l = "Polski";
  var percentTranslated$l = 100;
  var pl = {
  	commands: commands$l,
  	dropdowns: dropdowns$l,
  	ignorelt: ignorelt$l,
  	soundEffects: soundEffects$l,
  	microbitWhen: microbitWhen$l,
  	osis: osis$l,
  	definePrefix: definePrefix$l,
  	defineSuffix: defineSuffix$l,
  	palette: palette$l,
  	math: math$l,
  	aliases: aliases$l,
  	name: name$l,
  	percentTranslated: percentTranslated$l
  };

  var commands$k = {
  	MOTION_MOVESTEPS: "anda %1 passos",
  	MOTION_TURNRIGHT: "gira @turnRight %1 °",
  	MOTION_TURNLEFT: "gira @turnLeft %1 °",
  	MOTION_POINTINDIRECTION: "altera a tua direcção para %1 °",
  	MOTION_POINTTOWARDS: "aponta em direcção a %1",
  	MOTION_GOTOXY: "vai para a posição x: %1 y: %2",
  	MOTION_GOTO: "vai para %1",
  	MOTION_GLIDESECSTOXY: "desliza em %1 s para a posição x: %2 y: %3",
  	MOTION_GLIDETO: "desliza em %1 s em direcção a%2",
  	MOTION_CHANGEXBY: "adiciona %1 ao teu x",
  	MOTION_SETX: "altera o teu x para %1",
  	MOTION_CHANGEYBY: "adiciona %1 ao teu y",
  	MOTION_SETY: "altera o teu y para %1",
  	MOTION_SETROTATIONSTYLE: "altera o teu estilo de rotação para %1",
  	LOOKS_SAYFORSECS: "diz %1 durante %2 s",
  	LOOKS_SAY: "diz %1",
  	LOOKS_THINKFORSECS: "pensa %1 durante %2 s",
  	LOOKS_THINK: "pensa %1",
  	LOOKS_SHOW: "mostra-te",
  	LOOKS_HIDE: "esconde-te",
  	LOOKS_SWITCHCOSTUMETO: "muda o teu traje para %1",
  	LOOKS_NEXTCOSTUME: "passa para o teu próximo traje",
  	LOOKS_NEXTBACKDROP_BLOCK: "passa para o teu próximo cenário",
  	LOOKS_SWITCHBACKDROPTO: "muda o cenário para %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "muda o cenário para %1 e espera",
  	LOOKS_CHANGEEFFECTBY: "adiciona ao teu efeito %1 o valor %2",
  	LOOKS_SETEFFECTTO: "altera o teu efeito %1 para %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "cancela os teus efeitos gráficos",
  	LOOKS_CHANGESIZEBY: "adiciona %1 ao teu tamanho",
  	LOOKS_SETSIZETO: "altera o teu tamanho para %1 %",
  	LOOKS_GOTOFRONTBACK: "vai para a camada %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 camadas",
  	SOUND_PLAY: "toca o som %1",
  	SOUND_CHANGEEFFECTBY: "adiciona ao teu efeito %1 o valor %2",
  	SOUND_SETEFFECTO: "altera o teu efeito %1 para %2",
  	SOUND_CLEAREFFECTS: "cancela todos os teus efeitos sonoros",
  	SOUND_PLAYUNTILDONE: "toca o som %1 até terminar",
  	SOUND_STOPALLSOUNDS: "pára todos os sons",
  	"music.playDrumForBeats": "toca a percussão %1 durante %2 tempos",
  	"music.restForBeats": "faz uma pausa de %1 tempos",
  	"music.playNoteForBeats": "toca a nota %1 durante %2 tempos",
  	"music.setInstrument": "altera a teu instrumento para %1",
  	SOUND_CHANGEVOLUMEBY: "adiciona %1 % ao teu volume",
  	SOUND_SETVOLUMETO: "altera o teu volume para %1%",
  	"music.changeTempo": "adiciona %1 bpm ao teu andamento",
  	"music.setTempo": "altera o teu andamento para %1 bpm",
  	"pen.clear": "apaga tudo do palco",
  	"pen.stamp": "carimba-te",
  	"pen.penDown": "baixa a tua caneta",
  	"pen.penUp": "levanta a tua caneta",
  	"pen.setColor": "altera a cor da tua caneta para %1",
  	"pen.changeHue": "adiciona %1 à cor da tua caneta",
  	"pen.setColorParam": "altera %1 da tua caneta para %2",
  	"pen.changeColorParam": "adiciona a %1 da tua caneta o valor %2",
  	"pen.setHue": "altera a cor da tua caneta para %1",
  	"pen.changeShade": "adiciona %1 ao tom da tua caneta",
  	"pen.setShade": "altera o tom da tua caneta para %1",
  	"pen.changeSize": "adiciona %1 à espessura da tua caneta",
  	"pen.setSize": "altera a espessura da tua caneta para %1",
  	EVENT_WHENFLAGCLICKED: "Quando alguém clicar em @greenFlag",
  	EVENT_WHENKEYPRESSED: "Quando alguém pressionar a tecla %1",
  	EVENT_WHENTHISSPRITECLICKED: "Quando alguém clicar em ti",
  	EVENT_WHENSTAGECLICKED: "Quando alguém clicar no palco",
  	EVENT_WHENBACKDROPSWITCHESTO: "Quando o cenário mudar para %1",
  	EVENT_WHENGREATERTHAN: "Quando o valor do sensor %1 exceder %2",
  	EVENT_WHENBROADCASTRECEIVED: "Quando receberes a mensagem %1",
  	EVENT_BROADCAST: "difunde a mensagem %1",
  	EVENT_BROADCASTANDWAIT: "difunde a mensagem %1 e espera",
  	CONTROL_WAIT: "espera %1 s",
  	CONTROL_REPEAT: "repete %1 vezes",
  	CONTROL_FOREVER: "repete para sempre",
  	CONTROL_IF: "se %1 , então",
  	CONTROL_WAITUNTIL: "espera até que %1",
  	CONTROL_REPEATUNTIL: "até que %1 , repete",
  	CONTROL_STOP: "pára %1",
  	CONTROL_STARTASCLONE: "Quando fores criado como um clone",
  	CONTROL_CREATECLONEOF: "cria um clone de %1",
  	CONTROL_DELETETHISCLONE: "remove-te como clone",
  	SENSING_ASKANDWAIT: "pergunta %1 e espera pela resposta",
  	"videoSensing.videoToggle": "altera o estado do vídeo para %1",
  	"videoSensing.setVideoTransparency": "altera a transparência do vídeo para %1 %",
  	"videoSensing.whenMotionGreaterThan": "Quando o movimento do vídeo exceder %1",
  	SENSING_RESETTIMER: "reinicia o cronómetro",
  	DATA_SETVARIABLETO: "altera %1 para %2",
  	DATA_CHANGEVARIABLEBY: "adiciona a %1 o valor %2",
  	DATA_SHOWVARIABLE: "mostra a variável %1",
  	DATA_HIDEVARIABLE: "esconde a variável %1",
  	DATA_ADDTOLIST: "acrescenta %1 a %2",
  	DATA_DELETEOFLIST: "remove %1 de %2",
  	DATA_DELETEALLOFLIST: "remove tudo de %1",
  	MOTION_IFONEDGEBOUNCE: "se estiveres a bater na borda, ressalta",
  	DATA_INSERTATLIST: "insere %1 como %2 de %3",
  	DATA_REPLACEITEMOFLIST: "substitui %1 de %2 por %3",
  	DATA_SHOWLIST: "mostra a lista %1",
  	DATA_HIDELIST: "esconde a lista %1",
  	SENSING_OF_XPOSITION: "o x da posição",
  	SENSING_OF_YPOSITION: "o y da posição",
  	SENSING_OF_DIRECTION: "a direcção",
  	SENSING_OF_COSTUMENUMBER: "o número do traje",
  	LOOKS_COSTUMENUMBERNAME: "%1 do traje",
  	SENSING_OF_SIZE: "o tamanho",
  	SENSING_OF_BACKDROPNAME: "o nome do cenário",
  	LOOKS_BACKDROPNUMBERNAME: "%1 do cenário",
  	SENSING_OF_BACKDROPNUMBER: "o número do cenário",
  	SOUND_VOLUME: "o volume",
  	"music.getTempo": "o andamento",
  	SENSING_TOUCHINGOBJECT: "estás a tocar em %1",
  	SENSING_TOUCHINGCOLOR: "estás a tocar na cor %1",
  	SENSING_COLORISTOUCHINGCOLOR: "a cor %1 está a tocar na cor %2",
  	SENSING_DISTANCETO: "a distância até %1",
  	SENSING_ANSWER: "a resposta",
  	SENSING_KEYPRESSED: "a tecla %1 está a ser pressionada",
  	SENSING_MOUSEDOWN: "o botão do rato está pressionado",
  	SENSING_MOUSEX: "o x da posição do rato",
  	SENSING_MOUSEY: "o y da posição do rato",
  	SENSING_SETDRAGMODE: "altera o teu modo de arrasto para %1",
  	SENSING_LOUDNESS: "o volume no microfone",
  	"videoSensing.videoOn": "%1 do vídeo em %2",
  	SENSING_TIMER: "o valor do cronómetro",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "%1 actual",
  	SENSING_DAYSSINCE2000: "o número de dias desde 2000",
  	SENSING_USERNAME: "o nome de utilizador",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 − %2",
  	OPERATORS_MULTIPLY: "%1 × %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "um valor ao acaso entre %1 e %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 e %2",
  	OPERATORS_OR: "%1 ou %2",
  	OPERATORS_NOT: "é falso que %1",
  	OPERATORS_JOIN: "a junção de %1 com %2",
  	OPERATORS_LETTEROF: "o caractere %1 de %2",
  	OPERATORS_LENGTH: "o comprimento de %1",
  	OPERATORS_MOD: "o resto de %1 a dividir por %2",
  	OPERATORS_ROUND: "o arredondamento de %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%1 contém %2",
  	DATA_ITEMOFLIST: "%1 de %2",
  	DATA_ITEMNUMOFLIST: "o número do item %1 em %2",
  	DATA_LENGTHOFLIST: "o comprimento de %1",
  	DATA_LISTCONTAINSITEM: "%1 contém %2",
  	CONTROL_ELSE: "senão,",
  	SENSING_USERID: "o ID de utilizador",
  	SENSING_LOUD: "o som é forte",
  	"text2speech.speakAndWaitBlock": "fala %1",
  	"text2speech.setVoiceBlock": "altera a voz para %1",
  	"text2speech.setLanguageBlock": "altera a língua para %1",
  	"translate.translateBlock": "a tradução de %1 para %2",
  	"translate.viewerLanguage": "a língua",
  	"makeymakey.whenKeyPressed": "Quando a tecla %1 for pressionada",
  	"makeymakey.whenKeysPressedInOrder": "Quando %1 forem pressionadas por ordem",
  	"microbit.whenButtonPressed": "Quando o botão %1 for pressionado",
  	"microbit.isButtonPressed": "o botão %1 está a ser pressionado",
  	"microbit.whenGesture": "Quando %1",
  	"microbit.displaySymbol": "mostra %1",
  	"microbit.displayText": "mostra o texto %1",
  	"microbit.clearDisplay": "apaga o ecrã",
  	"microbit.whenTilted": "Quando for inclinado %1",
  	"microbit.isTilted": "está inclinado %1",
  	"microbit.tiltAngle": "o ângulo da inclinação %1",
  	"microbit.whenPinConnected": "Quando o pino %1 for ligado",
  	"ev3.motorTurnClockwise": "roda o motor %1 para aqui durante %2 s",
  	"ev3.motorTurnCounterClockwise": "roda o motor %1para ali durante %2 s",
  	"ev3.motorSetPower": "altera a potência do motor %1 para %2%",
  	"ev3.getMotorPosition": "a posição do motor %1",
  	"ev3.whenButtonPressed": "Quando o botão %1 for pressionado",
  	"ev3.whenDistanceLessThan": "Quando a distância for menor que %1",
  	"ev3.whenBrightnessLessThan": "Quando o brilho for menor que %1",
  	"ev3.buttonPressed": "o botão %1 está a ser pressionado",
  	"ev3.getDistance": "a distância",
  	"ev3.getBrightness": "o brilho",
  	"ev3.beepNote": "toca a nota %1 durante %2s",
  	"wedo2.motorOn": "liga %1",
  	"wedo2.motorOff": "desliga %1",
  	"wedo2.startMotorPower": "altera a potência de %1 para %2",
  	"wedo2.setMotorDirection": "altera a direcção de %1 para %2",
  	"wedo2.whenDistance": "Quando a distância for %1 %2",
  	"wedo2.getDistance": "a distância",
  	"wedo2.motorOnFor": "liga %1 durante %2 s",
  	"wedo2.setLightHue": "altera a cor da luz para %1",
  	"wedo2.playNoteFor": "toca a nota %1 durante %2 s",
  	"wedo2.whenTilted": "Quando for inclinado %1",
  	"wedo2.isTilted": "está inclinado %1",
  	"wedo2.getTiltAngle": "o ângulo da inclinação %1",
  	"gdxfor.whenGesture": "Quando %1",
  	"gdxfor.whenForcePushedOrPulled": "Quando o sensor de força %1",
  	"gdxfor.getForce": "a força",
  	"gdxfor.whenTilted": "Quando for inclinado %1",
  	"gdxfor.isTilted": "está inclinado %1",
  	"gdxfor.getTilt": "o ângulo de inclinação %1",
  	"gdxfor.isFreeFalling": "a cair",
  	"gdxfor.getSpin": "a velocidade de rotação %1",
  	"gdxfor.getAcceleration": "a aceleração %1",
  	"boost.motorOnFor": "roda o motor %1 durante %2 s",
  	"boost.motorOnForRotation": "roda o motor %1 %2 rotações",
  	"boost.motorOn": "liga o motor %1",
  	"boost.motorOff": "desliga o motor %1",
  	"boost.setMotorPower": "altera a velocidade do motor %1 para %2 %",
  	"boost.setMotorDirection": "altera a direcção do motor %1 para %2",
  	"boost.getMotorPosition": "a posição do motor %1",
  	"boost.whenColor": "Quando vir o tijolo %1",
  	"boost.seeingColor": "está a ver um tijolo %1",
  	"boost.whenTilted": "Quando for inclinado %1",
  	"boost.getTiltAngle": "o ângulo da inclinação %1",
  	"boost.setLightHue": "altera a cor da luz para %1"
  };
  var dropdowns$k = {
  };
  var ignorelt$k = [
  ];
  var soundEffects$k = [
  	"tom",
  	"canal esquerdo/direito"
  ];
  var microbitWhen$k = [
  	"se mover",
  	"for abanado",
  	"saltar"
  ];
  var osis$k = [
  	"os teus outros guiões"
  ];
  var definePrefix$k = [
  	"Define"
  ];
  var defineSuffix$k = [
  ];
  var palette$k = {
  	Motion: "Movimento",
  	Looks: "Aparência",
  	Sound: "Som",
  	Events: "Eventos",
  	Control: "Controlo",
  	Sensing: "Sensores",
  	Operators: "Operadores",
  	Variables: "Variáveis",
  	"My Blocks": "Os Meus Blocos"
  };
  var math$k = [
  	"o valor absoluto",
  	"o chão (o maior inteiro não superior)",
  	"o tecto (menor inteiro não inferior)",
  	"a raiz quadrada",
  	"o seno",
  	"o cosseno",
  	"a tangente",
  	"o arco-seno",
  	"o arco-cosseno",
  	"o arco-tangente",
  	"o logaritmo natural",
  	"o logaritmo",
  	"a exponencial",
  	"10 ^"
  ];
  var aliases$k = {
  	"gira para a esquerda %1 º": "MOTION_TURNLEFT",
  	"gira para a direita %1 º": "MOTION_TURNRIGHT",
  	"Quando alguém clicar na bandeira verde": "EVENT_WHENFLAGCLICKED",
  	fim: "scratchblocks:end"
  };
  var name$k = "Português";
  var percentTranslated$k = 100;
  var pt = {
  	commands: commands$k,
  	dropdowns: dropdowns$k,
  	ignorelt: ignorelt$k,
  	soundEffects: soundEffects$k,
  	microbitWhen: microbitWhen$k,
  	osis: osis$k,
  	definePrefix: definePrefix$k,
  	defineSuffix: defineSuffix$k,
  	palette: palette$k,
  	math: math$k,
  	aliases: aliases$k,
  	name: name$k,
  	percentTranslated: percentTranslated$k
  };

  var commands$j = {
  	MOTION_MOVESTEPS: "mova %1 passos",
  	MOTION_TURNRIGHT: "gire @turnRight %1 graus",
  	MOTION_TURNLEFT: "gire @turnLeft %1 graus",
  	MOTION_POINTINDIRECTION: "aponte para a direção %1",
  	MOTION_POINTTOWARDS: "aponte para %1",
  	MOTION_GOTOXY: "vá para x: %1 y: %2",
  	MOTION_GOTO: "vá para %1",
  	MOTION_GLIDESECSTOXY: "deslize por %1 segs. até x: %2 y: %3",
  	MOTION_GLIDETO: "deslize por %1 segs. até %2",
  	MOTION_CHANGEXBY: "adicione %1 a x",
  	MOTION_SETX: "mude x para %1",
  	MOTION_CHANGEYBY: "adicione %1 a y",
  	MOTION_SETY: "mude y para %1",
  	MOTION_SETROTATIONSTYLE: "defina o estilo de rotação para %1",
  	LOOKS_SAYFORSECS: "diga %1 por %2 segundos",
  	LOOKS_SAY: "diga %1",
  	LOOKS_THINKFORSECS: "pense %1 por %2 segundos",
  	LOOKS_THINK: "pense %1",
  	LOOKS_SHOW: "mostre",
  	LOOKS_HIDE: "esconda",
  	LOOKS_SWITCHCOSTUMETO: "mude para a fantasia %1",
  	LOOKS_NEXTCOSTUME: "próxima fantasia",
  	LOOKS_NEXTBACKDROP_BLOCK: "próximo cenário",
  	LOOKS_SWITCHBACKDROPTO: "mude para o cenário %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "mude para o cenário %1 e espere",
  	LOOKS_CHANGEEFFECTBY: "mude %2 ao efeito %1",
  	LOOKS_SETEFFECTTO: "defina o efeito %1 como %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "remova os efeitos gráficos",
  	LOOKS_CHANGESIZEBY: "mude %1 no tamanho",
  	LOOKS_SETSIZETO: "defina o tamanho como %1 %",
  	LOOKS_GOTOFRONTBACK: "vá para a camada %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "vá para %1 %2 camadas",
  	SOUND_PLAY: "toque o som %1",
  	SOUND_CHANGEEFFECTBY: "mude  %2 no efeito %1",
  	SOUND_SETEFFECTO: "mude o efeito %1 para %2",
  	SOUND_CLEAREFFECTS: "remova os efeitos sonoros",
  	SOUND_PLAYUNTILDONE: "toque o som %1 até o fim",
  	SOUND_STOPALLSOUNDS: "pare todos os sons",
  	"music.playDrumForBeats": "toque instrumento %1 por %2 batidas",
  	"music.restForBeats": "pausa por %1 batidas",
  	"music.playNoteForBeats": "toque a nota %1 por %2 batidas",
  	"music.setInstrument": "mudar instrumento para %1",
  	SOUND_CHANGEVOLUMEBY: "mude volume em %1",
  	SOUND_SETVOLUMETO: "mude o volume para %1%",
  	"music.changeTempo": "alterar ritmo por %1",
  	"music.setTempo": "ajuste ritmo para %1",
  	"pen.clear": "apague tudo",
  	"pen.stamp": "carimbe",
  	"pen.penDown": "use a caneta",
  	"pen.penUp": "levante a caneta",
  	"pen.setColor": "mude a cor da caneta para %1",
  	"pen.changeHue": "adicione %1 a cor da caneta",
  	"pen.setColorParam": "mude %1 da caneta para %2",
  	"pen.changeColorParam": "adicione %2 %1 da caneta",
  	"pen.setHue": "mude a cor da caneta para %1",
  	"pen.changeShade": "adicione %1 a tonalidade da caneta",
  	"pen.setShade": "mude a tonalidade da caneta para %1",
  	"pen.changeSize": "adicione %1 ao tamanho da caneta",
  	"pen.setSize": "mude o tamanho da caneta para %1",
  	EVENT_WHENFLAGCLICKED: "quando @greenFlag for clicado",
  	EVENT_WHENKEYPRESSED: "quando a tecla %1 for pressionada",
  	EVENT_WHENTHISSPRITECLICKED: "quando este ator for clicado",
  	EVENT_WHENSTAGECLICKED: "quando o palco for clicado",
  	EVENT_WHENBACKDROPSWITCHESTO: "quando o cenário mudar para %1",
  	EVENT_WHENGREATERTHAN: "quando %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "quando eu receber %1",
  	EVENT_BROADCAST: "transmita %1",
  	EVENT_BROADCASTANDWAIT: "transmita %1 e espere",
  	CONTROL_WAIT: "espere %1 seg",
  	CONTROL_REPEAT: "repita %1 vezes",
  	CONTROL_FOREVER: "sempre",
  	CONTROL_IF: "se %1 então",
  	CONTROL_WAITUNTIL: "espere até que %1",
  	CONTROL_REPEATUNTIL: "repita até que %1",
  	CONTROL_STOP: "pare %1",
  	CONTROL_STARTASCLONE: "quando eu começar como um clone",
  	CONTROL_CREATECLONEOF: "crie clone de %1",
  	CONTROL_DELETETHISCLONE: "apague este clone",
  	SENSING_ASKANDWAIT: "pergunte %1 e espere",
  	"videoSensing.videoToggle": "mude vídeo para %1",
  	"videoSensing.setVideoTransparency": "ajuste transparência do vídeo para %1",
  	"videoSensing.whenMotionGreaterThan": "quando detectar sensor de vídeo > %1",
  	SENSING_RESETTIMER: "zere o cronômetro",
  	DATA_SETVARIABLETO: "mude %1 para %2",
  	DATA_CHANGEVARIABLEBY: "adicione %2 a %1",
  	DATA_SHOWVARIABLE: "mostre a variável %1",
  	DATA_HIDEVARIABLE: "esconda a variável %1",
  	DATA_ADDTOLIST: "adicione %1 a %2",
  	DATA_DELETEOFLIST: "apague %1 de %2",
  	DATA_DELETEALLOFLIST: "apague todos os itens de %1",
  	MOTION_IFONEDGEBOUNCE: "se tocar na borda, volte",
  	DATA_INSERTATLIST: "insira %1 na posição %2 de %3",
  	DATA_REPLACEITEMOFLIST: "substitua o item %1 de %2 por %3",
  	DATA_SHOWLIST: "mostre a lista %1",
  	DATA_HIDELIST: "esconda a lista %1",
  	SENSING_OF_XPOSITION: "posição x",
  	SENSING_OF_YPOSITION: "posição y",
  	SENSING_OF_DIRECTION: "direção",
  	SENSING_OF_COSTUMENUMBER: "n° da fantasia",
  	LOOKS_COSTUMENUMBERNAME: "fantasia %1",
  	SENSING_OF_SIZE: "tamanho",
  	SENSING_OF_BACKDROPNAME: "nome do cenário",
  	LOOKS_BACKDROPNUMBERNAME: "cenário %1",
  	SENSING_OF_BACKDROPNUMBER: "n° do cenário",
  	SOUND_VOLUME: "volume",
  	"music.getTempo": "ritmo",
  	SENSING_TOUCHINGOBJECT: "tocando em %1?",
  	SENSING_TOUCHINGCOLOR: "tocando na cor %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "a cor %1 está tocando na cor %2?",
  	SENSING_DISTANCETO: "distância até %1",
  	SENSING_ANSWER: "resposta",
  	SENSING_KEYPRESSED: "tecla %1 pressionada?",
  	SENSING_MOUSEDOWN: "mouse pressionado?",
  	SENSING_MOUSEX: "posição x do mouse",
  	SENSING_MOUSEY: "posição y do mouse",
  	SENSING_SETDRAGMODE: "defina modo de arrasto para %1",
  	SENSING_LOUDNESS: "ruído",
  	"videoSensing.videoOn": "vídeo %1 para %2",
  	SENSING_TIMER: "cronômetro",
  	SENSING_OF: "%1 de %2",
  	SENSING_CURRENT: "%1 atual",
  	SENSING_DAYSSINCE2000: "número de dias desde 2000",
  	SENSING_USERNAME: "nome de usuário",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "número aleatório entre %1 e %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 e %2",
  	OPERATORS_OR: "%1 ou %2",
  	OPERATORS_NOT: "não %1",
  	OPERATORS_JOIN: "junte %1 com %2",
  	OPERATORS_LETTEROF: "letra %1 de %2",
  	OPERATORS_LENGTH: "tamanho de %1",
  	OPERATORS_MOD: "resto de %1 por %2",
  	OPERATORS_ROUND: "arredondamento de %1",
  	OPERATORS_MATHOP: "%1 de %2",
  	OPERATORS_CONTAINS: "%1 contém %2?",
  	DATA_ITEMOFLIST: "item %1 de %2",
  	DATA_ITEMNUMOFLIST: "item # de %1 em %2",
  	DATA_LENGTHOFLIST: "tamanho de %1",
  	DATA_LISTCONTAINSITEM: "%1 contém %2?",
  	CONTROL_ELSE: "senão",
  	SENSING_USERID: "id do usuário",
  	SENSING_LOUD: "alto?",
  	"text2speech.speakAndWaitBlock": "falar %1",
  	"text2speech.setVoiceBlock": "defina a voz para %1",
  	"text2speech.setLanguageBlock": "defina o idioma como %1",
  	"translate.translateBlock": "traduza %1 para %2",
  	"translate.viewerLanguage": "idioma",
  	"makeymakey.whenKeyPressed": "quando a tecla %1 for pressionada",
  	"makeymakey.whenKeysPressedInOrder": "quando %1 forem pressionados em ordem",
  	"microbit.whenButtonPressed": "quando o botão %1 for pressionado",
  	"microbit.isButtonPressed": "botão %1 pressionado?",
  	"microbit.whenGesture": "quando %1",
  	"microbit.displaySymbol": "exiba %1",
  	"microbit.displayText": "exiba o texto %1",
  	"microbit.clearDisplay": "limpe a tela",
  	"microbit.whenTilted": "quando inclinado para %1",
  	"microbit.isTilted": "inclinado para %1?",
  	"microbit.tiltAngle": "ângulo de inclinação para %1",
  	"microbit.whenPinConnected": "quando o pino %1 for conectado",
  	"ev3.motorTurnClockwise": "gire o motor %1 nesse sentido por %2 segundos",
  	"ev3.motorTurnCounterClockwise": "gire o motor %1 naquele sentido por %2 segundos",
  	"ev3.motorSetPower": "defina potência do motor %1 em %2 %",
  	"ev3.getMotorPosition": "posição do motor %1",
  	"ev3.whenButtonPressed": "quando botão %1 for pressionado",
  	"ev3.whenDistanceLessThan": "quando distância < %1",
  	"ev3.whenBrightnessLessThan": "quando brilho < %1",
  	"ev3.buttonPressed": "botão %1 pressionado?",
  	"ev3.getDistance": "distância",
  	"ev3.getBrightness": "brilho",
  	"ev3.beepNote": "som de bip %1 por %2 segundos",
  	"wedo2.motorOn": "ligue o motor %1",
  	"wedo2.motorOff": "desligue o motor %1",
  	"wedo2.startMotorPower": "defina a potência de %1 como %2",
  	"wedo2.setMotorDirection": "defina a direção de %1 como %2",
  	"wedo2.whenDistance": "quando distância %1 %2",
  	"wedo2.getDistance": "distância",
  	"wedo2.motorOnFor": "ligue o motor %1 por %2 segundos",
  	"wedo2.setLightHue": "defina a cor como %1",
  	"wedo2.playNoteFor": "toque a nota %1 por %2 segundos",
  	"wedo2.whenTilted": "quando inclinado para %1",
  	"wedo2.isTilted": "inclinado para %1?",
  	"wedo2.getTiltAngle": "ângulo de inclinação %1",
  	"gdxfor.whenGesture": "quando %1",
  	"gdxfor.whenForcePushedOrPulled": "quando o sensor de força estiver sendo %1",
  	"gdxfor.getForce": "força",
  	"gdxfor.whenTilted": "quando inclinado para %1",
  	"gdxfor.isTilted": "inclinado para %1?",
  	"gdxfor.getTilt": "ângulo de inclinação para %1",
  	"gdxfor.isFreeFalling": "caindo?",
  	"gdxfor.getSpin": "velocidade de rotação %1",
  	"gdxfor.getAcceleration": "aceleração %1",
  	"boost.motorOnFor": "ligue o motor %1 por %2 segundos",
  	"boost.motorOnForRotation": "ligue o motor %1 por %2 rotações",
  	"boost.motorOn": "ligue o motor %1",
  	"boost.motorOff": "desligue o motor %1",
  	"boost.setMotorPower": "mude a velocidade do motor %1 para %2 %",
  	"boost.setMotorDirection": "mude a direção do motor %1 para %2",
  	"boost.getMotorPosition": "posição do motor %1",
  	"boost.whenColor": "quando um bloco %1 for visto",
  	"boost.seeingColor": "vendo bloco %1?",
  	"boost.whenTilted": "quando inclinado para %1",
  	"boost.getTiltAngle": "ângulo de inclinação %1",
  	"boost.setLightHue": "defina a cor como %1"
  };
  var dropdowns$j = {
  };
  var ignorelt$j = [
  ];
  var soundEffects$j = [
  	"tom",
  	"balanço esquerda/direita"
  ];
  var microbitWhen$j = [
  	"mover",
  	"agitar",
  	"pular"
  ];
  var osis$j = [
  	"outros scripts no ator"
  ];
  var definePrefix$j = [
  	"defina"
  ];
  var defineSuffix$j = [
  ];
  var palette$j = {
  	Motion: "Movimento",
  	Looks: "Aparência",
  	Sound: "Som",
  	Events: "Eventos",
  	Control: "Controle",
  	Sensing: "Sensores",
  	Operators: "Operadores",
  	Variables: "Variáveis",
  	"My Blocks": "Meus Blocos"
  };
  var math$j = [
  	"módulo",
  	"arredondamento para baixo de",
  	"arredondamento para cima de",
  	"raiz quadrada",
  	"sen",
  	"cos",
  	"tg",
  	"arcsen",
  	"arccos",
  	"arctg",
  	"ln",
  	"logaritmo",
  	"e elevado à",
  	"10 elevado à"
  ];
  var aliases$j = {
  };
  var name$j = "Português Brasileiro";
  var percentTranslated$j = 100;
  var pt_br = {
  	commands: commands$j,
  	dropdowns: dropdowns$j,
  	ignorelt: ignorelt$j,
  	soundEffects: soundEffects$j,
  	microbitWhen: microbitWhen$j,
  	osis: osis$j,
  	definePrefix: definePrefix$j,
  	defineSuffix: defineSuffix$j,
  	palette: palette$j,
  	math: math$j,
  	aliases: aliases$j,
  	name: name$j,
  	percentTranslated: percentTranslated$j
  };

  var commands$i = {
  	MOTION_MOVESTEPS: "muyuq %1 chankayta",
  	MOTION_TURNRIGHT: "muyuy @turnRight %1 gradukuna",
  	MOTION_TURNLEFT: "muyuy @turnLeft %1 gradukuna",
  	MOTION_POINTINDIRECTION: "rikuy kaylawman %1",
  	MOTION_POINTTOWARDS: "rikuy chayman %1",
  	MOTION_GOTOXY: "riy x: %1 chaymanta: %2",
  	MOTION_GOTO: "pasay %1",
  	MOTION_GLIDESECSTOXY: "muyuy %1 sigunduta x:%2 chaymanta y: %3",
  	MOTION_GLIDETO: "muyuy %1 segundukuna kayman %2",
  	MOTION_CHANGEXBY: "tikray x kaywan %1",
  	MOTION_SETX: "churay x %1",
  	MOTION_CHANGEYBY: "tikray y kaywan %1",
  	MOTION_SETY: "churay y %1",
  	MOTION_SETROTATIONSTYLE: "churay imayna muyunampaq %1",
  	LOOKS_SAYFORSECS: "niykuy %1 %2 sigundus unayman",
  	LOOKS_SAY: "niykuy %1",
  	LOOKS_THINKFORSECS: "umachay %1 %2 sigundus unayman",
  	LOOKS_THINK: "umachay %1",
  	LOOKS_SHOW: "qawanapaq",
  	LOOKS_HIDE: "pakay",
  	LOOKS_SWITCHCOSTUMETO: "tikray pachata %1",
  	LOOKS_NEXTCOSTUME: "huknin pacha",
  	LOOKS_NEXTBACKDROP_BLOCK: "huk uku lliklla",
  	LOOKS_SWITCHBACKDROPTO: "tikray ukuqillqayta %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "tikray ukuqillqayta %1 hinaspa suyay",
  	LOOKS_CHANGEEFFECTBY: "tikray %1 imayna rikuriqninta kaywan %2",
  	LOOKS_SETEFFECTTO: "churaykuy %1 imayna rikuriqninta %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "pichay llapa qillqaykunata",
  	LOOKS_CHANGESIZEBY: "tikray imayna hatunkarayninta %1",
  	LOOKS_SETSIZETO: "churay imayna hatunkarayninta %1 %",
  	LOOKS_GOTOFRONTBACK: "riy %1 chukuman",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "riy %1 %2 chukukunaman",
  	SOUND_PLAY: "tukayachi %1",
  	SOUND_CHANGEEFFECTBY: "tikray %1 imayna rikuriqninta kaywan %2",
  	SOUND_SETEFFECTO: "churaykuy %1 imayna rikuriqninta %2",
  	SOUND_CLEAREFFECTS: "pichay llapa tukachkaqta",
  	SOUND_PLAYUNTILDONE: "tukachi %1 tukunankama",
  	SOUND_STOPALLSOUNDS: "llapan tukachkaqta sayay",
  	"music.playDrumForBeats": "tukay tambur %1 chaypaq %2 luqluqyaqkuna",
  	"music.restForBeats": "samachiy %1 luqluqyaqkuna",
  	"music.playNoteForBeats": "pukllayta tukay %1 chayman %2 luqluqyaqkuna",
  	"music.setInstrument": "tiquy inkilltupa %1",
  	SOUND_CHANGEVOLUMEBY: "tikray uyarinata %1",
  	SOUND_SETVOLUMETO: "churay uyarinata %1%",
  	"music.changeTempo": "tikray pachata %1",
  	"music.setTempo": "churay pachata %1",
  	"pen.clear": "llapanta pichay",
  	"pen.stamp": "sello nisqan",
  	"pen.penDown": "qillqana uraypi",
  	"pen.penUp": "qillqay hanaypi",
  	"pen.setColor": "tikray qillqay kaspi Llimpiy-rayku %1",
  	"pen.changeHue": "tikray qillqay kaspi kulur-rayku %1",
  	"pen.setColorParam": "churay qillqay kaspita %1 rayku %2",
  	"pen.changeColorParam": "tikray qillqay kaspi %1 rayku %2",
  	"pen.setHue": "churaykuy llimpinman qillqaq kaspita %1",
  	"pen.changeShade": "tikray qillqay llantunninta %1",
  	"pen.setShade": "churaykuy qillqapa llantuyninta %1",
  	"pen.changeSize": "tikray qillqay hatunninta %1",
  	"pen.setSize": "churay qillqay kaspipa hatuyninta %1",
  	EVENT_WHENFLAGCLICKED: "haykapi @greenFlag ñitiypi",
  	EVENT_WHENKEYPRESSED: "ñitispa  kay %1 qillqanata",
  	EVENT_WHENTHISSPRITECLICKED: "kay muki ñitinqa",
  	EVENT_WHENSTAGECLICKED: "iscinario ñitinqa",
  	EVENT_WHENBACKDROPSWITCHESTO: "ukuchaknin hipaynin %1",
  	EVENT_WHENGREATERTHAN: "maypi %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ñuqa chaskispa %1",
  	EVENT_BROADCAST: "qawachinapaq %1",
  	EVENT_BROADCASTANDWAIT: "qawachinapaq %1 chaymanta suyay",
  	CONTROL_WAIT: "Suyay %1 kaq",
  	CONTROL_REPEAT: "musuqmanta %1",
  	CONTROL_FOREVER: "wiñaypaq",
  	CONTROL_IF: "icha %1 hinaptin",
  	CONTROL_WAITUNTIL: "suyaykuy askama %1",
  	CONTROL_REPEATUNTIL: "musuqmanta ruray askama %1",
  	CONTROL_STOP: "sayay %1",
  	CONTROL_STARTASCLONE: "Hayka qallarisaq huk ñuqahina",
  	CONTROL_CREATECLONEOF: "ruray huk hukhinata %1",
  	CONTROL_DELETETHISCLONE: "wañuchiy kay hukhina",
  	SENSING_ASKANDWAIT: "tapuy %1 chaymanta suyay",
  	"videoSensing.videoToggle": "muyuchiy widiuta %1",
  	"videoSensing.setVideoTransparency": "churay vidio chhuyaqniman %1",
  	"videoSensing.whenMotionGreaterThan": "hayka widiu muyuptin > %1",
  	SENSING_RESETTIMER: "qallari yupachaq",
  	DATA_SETVARIABLETO: "llapa kaymanta %1  kayman %2",
  	DATA_CHANGEVARIABLEBY: "tikray %1 kaywan %2",
  	DATA_SHOWVARIABLE: "qawachiy kayta %1",
  	DATA_HIDEVARIABLE: "pakay kayta %1",
  	DATA_ADDTOLIST: "yapay %1 kayman %2",
  	DATA_DELETEOFLIST: "anchuchiy %1 kaymanta %2",
  	DATA_DELETEALLOFLIST: "anchuchiy llapanta %1",
  	MOTION_IFONEDGEBOUNCE: "icha kachkan patapi, pinkin",
  	DATA_INSERTATLIST: "winay %1 chaymantapas %2 kaymanta %3",
  	DATA_REPLACEITEMOFLIST: "kikraykuy chayta %1 kaymanta %2 kaywan %3",
  	DATA_SHOWLIST: "qawachiy qillqayta %1",
  	DATA_HIDELIST: "pakay qillqayta %1",
  	SENSING_OF_XPOSITION: "x sayay",
  	SENSING_OF_YPOSITION: "y sayay",
  	SENSING_OF_DIRECTION: "maypi",
  	SENSING_OF_COSTUMENUMBER: "pacha #",
  	LOOKS_COSTUMENUMBERNAME: "pacha %1",
  	SENSING_OF_SIZE: "hatunin",
  	SENSING_OF_BACKDROPNAME: "hipaynin sutin",
  	LOOKS_BACKDROPNUMBERNAME: "uku lliklla %1",
  	SENSING_OF_BACKDROPNUMBER: "hipaynin",
  	SOUND_VOLUME: "ancha uyarina",
  	"music.getTempo": "pacha",
  	SENSING_TOUCHINGOBJECT: "tukay %1?",
  	SENSING_TOUCHINGCOLOR: "tukay kulur %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "kulur %1 tukachkan %2?",
  	SENSING_DISTANCETO: "karumanta %1",
  	SENSING_ANSWER: "kutichiy rimayta",
  	SENSING_KEYPRESSED: "tikla %1 ñitiy?",
  	SENSING_MOUSEDOWN: "ukucha urayman?",
  	SENSING_MOUSEX: "ukucha x",
  	SENSING_MOUSEY: "ukucha y",
  	SENSING_SETDRAGMODE: "churay aysanaman %1",
  	SENSING_LOUDNESS: "qapariknin",
  	"videoSensing.videoOn": "widiu %1 in %2",
  	SENSING_TIMER: "yupachaq",
  	SENSING_OF: "%1 kaymanta %2",
  	SENSING_CURRENT: "kunan %1",
  	SENSING_DAYSSINCE2000: "2000 wata punchawmanta",
  	SENSING_USERNAME: "llamkaqpa sutin",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%2 - %1",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%2 / %1",
  	OPERATORS_RANDOM: "mayqintapas akllay %1 kayman %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 chaymanta %2",
  	OPERATORS_OR: "%1 utaq %2",
  	OPERATORS_NOT: "manam %1",
  	OPERATORS_JOIN: "huqllachay %1 %2",
  	OPERATORS_LETTEROF: "qillqa %1 chaymanta %2",
  	OPERATORS_LENGTH: "sunin %1",
  	OPERATORS_MOD: "%1 awqa %2",
  	OPERATORS_ROUND: "muyunchay %1",
  	OPERATORS_MATHOP: "%1 kaymanta %2",
  	OPERATORS_CONTAINS: "%1  kachkanchu %2?",
  	DATA_ITEMOFLIST: "Imakuna %1 kaymanta %2",
  	DATA_ITEMNUMOFLIST: "Imakuna # kaypa %1 in %2",
  	DATA_LENGTHOFLIST: "sunin %1",
  	DATA_LISTCONTAINSITEM: "%1  kachkanchu %2?",
  	CONTROL_ELSE: "ñataq",
  	SENSING_USERID: "id llamkaqpa",
  	SENSING_LOUD: "qapari?",
  	"text2speech.speakAndWaitBlock": "rimay %1",
  	"text2speech.setVoiceBlock": "churay Rimaqman %1",
  	"text2speech.setLanguageBlock": "churay simiman %1",
  	"translate.translateBlock": "tikray %1 chaymanta %2",
  	"translate.viewerLanguage": "Simi",
  	"makeymakey.whenKeyPressed": "imayna %1 tikla ñitisqa",
  	"makeymakey.whenKeysPressedInOrder": "Hayka %1 nitisqa hukllamanta",
  	"microbit.whenButtonPressed": "imayna %1 butun ñitisqa",
  	"microbit.isButtonPressed": "%1 butun ñitisqa?",
  	"microbit.whenGesture": "imay %1",
  	"microbit.displaySymbol": "qawana %1",
  	"microbit.displayText": "qillqata qawarina %1",
  	"microbit.clearDisplay": "picahay qawanata",
  	"microbit.whenTilted": "chinrusqa kaptin %1",
  	"microbit.isTilted": "chinrusqa %1?",
  	"microbit.tiltAngle": "kuchusta chinru %1",
  	"microbit.whenPinConnected": "imayna tipi %1 tupachisqa",
  	"ev3.motorTurnClockwise": "Kallpanchaq %1 muyurichi waklawman %2 wawa pachapi",
  	"ev3.motorTurnCounterClockwise": "Kallpanchaq %1 muyurichi kaylawman %2 wawa pachapi",
  	"ev3.motorSetPower": "Kallpanchaq %1 churay kallpachaykuy %2 %",
  	"ev3.getMotorPosition": "Kallpanchachiq %1 churay",
  	"ev3.whenButtonPressed": "butun %1 ñitisqa kaptin",
  	"ev3.whenDistanceLessThan": "karu kaptin < %1",
  	"ev3.whenBrightnessLessThan": "akchiriq kaptin < %1",
  	"ev3.buttonPressed": "butun %1 nitisqa?",
  	"ev3.getDistance": "karuchan",
  	"ev3.getBrightness": "kanchiq",
  	"ev3.beepNote": "tukachi %1 kaywan %2 wawa pachawan",
  	"wedo2.motorOn": "qallarichiy %1",
  	"wedo2.motorOff": "muyuq %1 wañuchisqa",
  	"wedo2.startMotorPower": "churaykuy %1 kallapachiqninta %2",
  	"wedo2.setMotorDirection": "rinayta churaykuy %1 inpi %2",
  	"wedo2.whenDistance": "karu kaptin %1 %2",
  	"wedo2.getDistance": "karuchan",
  	"wedo2.motorOnFor": "qallariy %1 icha %2 siqundupi",
  	"wedo2.setLightHue": "akchiqpa llimpinta churay %1",
  	"wedo2.playNoteFor": "qillqay luqyay %1 icha %2 siqundupi",
  	"wedo2.whenTilted": "kinraykachisqa kaptin %1",
  	"wedo2.isTilted": "kinray %1?",
  	"wedo2.getTiltAngle": "Kuchuq kinraychasqa %1",
  	"gdxfor.whenGesture": "imay %1",
  	"gdxfor.whenForcePushedOrPulled": "kallpachaq musiaq kaptin %1",
  	"gdxfor.getForce": "kallpa",
  	"gdxfor.whenTilted": "chinrusqa kaptin %1",
  	"gdxfor.isTilted": "chinrusqachu %1?",
  	"gdxfor.getTilt": "kuchusta chinruri %1",
  	"gdxfor.isFreeFalling": "imam wichin?",
  	"gdxfor.getSpin": "utqayman muyuq %1",
  	"gdxfor.getAcceleration": "utqallaman %1",
  	"boost.motorOnFor": "mutur muyuq %1 icha %2 siqundupi",
  	"boost.motorOnForRotation": "mutur muyuq %1 icha %2 muyuriqnin",
  	"boost.motorOn": "Kallpanchaq qallarichisqa %1",
  	"boost.motorOff": "mutur wañuchisqa %1",
  	"boost.setMotorPower": "utqayllaman churay %1 muturpa %2%",
  	"boost.setMotorDirection": "muturta churaykuy %1 riqman %2",
  	"boost.getMotorPosition": "kallpanchaq churasqa %1",
  	"boost.whenColor": "imayna %1 champa qawakuptin",
  	"boost.seeingColor": "qawaspa %1 champa?",
  	"boost.whenTilted": "kinraykachisqa kaptin %1",
  	"boost.getTiltAngle": "Kuchuq kinraychasqa %1",
  	"boost.setLightHue": "akchiqpa llimpinta churay %1"
  };
  var dropdowns$i = {
  };
  var ignorelt$i = [
  ];
  var soundEffects$i = [
  	"luqyay",
  	"paniyay alliqman / ichuqman"
  ];
  var microbitWhen$i = [
  	"musuqmi",
  	"tapsiy",
  	"pawarqun"
  ];
  var osis$i = [
  	"huk qillqaykuna ipupi"
  ];
  var definePrefix$i = [
  	"nin"
  ];
  var defineSuffix$i = [
  ];
  var palette$i = {
  	Motion: "Muyuy",
  	Looks: "Qaway",
  	Sound: "qapariqnin",
  	Events: "llamka",
  	Control: "kamachiy",
  	Sensing: "musyay",
  	Operators: "Llamkaq",
  	Variables: "hukniraq",
  	"My Blocks": "champaykuna"
  };
  var math$i = [
  	"abs",
  	"allpa",
  	"qata",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"in",
  	"Qallarichiy",
  	"Y ^",
  	"10 ^"
  ];
  var aliases$i = {
  };
  var name$i = "Kichwa";
  var percentTranslated$i = 100;
  var qu = {
  	commands: commands$i,
  	dropdowns: dropdowns$i,
  	ignorelt: ignorelt$i,
  	soundEffects: soundEffects$i,
  	microbitWhen: microbitWhen$i,
  	osis: osis$i,
  	definePrefix: definePrefix$i,
  	defineSuffix: defineSuffix$i,
  	palette: palette$i,
  	math: math$i,
  	aliases: aliases$i,
  	name: name$i,
  	percentTranslated: percentTranslated$i
  };

  var commands$h = {
  	MOTION_MOVESTEPS: "e makenu %1 te vaʾe",
  	MOTION_TURNRIGHT: "e teka @turnRight %1 grados",
  	MOTION_TURNLEFT: "e teka @turnLeft %1 grados",
  	MOTION_POINTINDIRECTION: "ka tuhi ki te kona %1",
  	MOTION_POINTTOWARDS: "ka tuki ki %1",
  	MOTION_GOTOXY: "e oho ki te a x: %1 y: %2",
  	MOTION_GOTO: "e oho ki te %1",
  	MOTION_GLIDESECSTOXY: "haka nini ki te %1 piere ki te x:%2 y: %3",
  	MOTION_GLIDETO: "haka nini hai %1 piere ki te %2",
  	MOTION_CHANGEXBY: "haka rahi te a x %1",
  	MOTION_SETX: "ka vaʾai ki te x te mau %1",
  	MOTION_CHANGEYBY: "haka rahi te y %1",
  	MOTION_SETY: "ka vaʾai ki te a e ki te %1",
  	MOTION_SETROTATIONSTYLE: "fijar estilo de rotación a %1",
  	LOOKS_SAYFORSECS: "e ki %1 i te %2 segundos",
  	LOOKS_SAY: "e ki %1",
  	LOOKS_THINKFORSECS: "e manaʾu mmmm %1 i te %2",
  	LOOKS_THINK: "e manaʾu %1",
  	LOOKS_SHOW: "haka tikeʾa",
  	LOOKS_HIDE: "naʾa",
  	LOOKS_SWITCHCOSTUMETO: "ka kamiare te diseño ki te %1",
  	LOOKS_NEXTCOSTUME: "te rua diseño",
  	LOOKS_NEXTBACKDROP_BLOCK: "te rua tuʾa nui",
  	LOOKS_SWITCHBACKDROPTO: "ka kamiare te tuʾa nui ki te %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "kamiare te tuʾa nui ki te %1 e ka tiaki",
  	LOOKS_CHANGEEFFECTBY: "haka rahi te efecto %1 %2",
  	LOOKS_SETEFFECTTO: "ka vaʾai te efecto %1 te %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "haka kore te efectos graficos",
  	LOOKS_CHANGESIZEBY: "ka kamiare te nui nui hai %1",
  	LOOKS_SETSIZETO: "haka noho te nui nui ki te %1 %",
  	LOOKS_GOTOFRONTBACK: "e oho a capa %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "e oho %2 capas ki te %1",
  	SOUND_PLAY: "haʾamata te pakeke %1",
  	SOUND_CHANGEEFFECTBY: "haka rahi te efecto %1 %2",
  	SOUND_SETEFFECTO: "ka vaʾai te efecto %1 te %2",
  	SOUND_CLEAREFFECTS: "haka kore te  efecto  o te pakeke",
  	SOUND_PLAYUNTILDONE: "ka pakeke %1 ki te oti",
  	SOUND_STOPALLSOUNDS: "haka noho te pakeke taʾatoʾa",
  	"music.playDrumForBeats": "haka taŋi te tampuru %1 Aa rote %2 hora",
  	"music.restForBeats": "he mou o te %1 hora",
  	"music.playNoteForBeats": "haka taŋi te nota %1 a rote %2 hora",
  	"music.setInstrument": "haka tano te meʾe mo haka taŋi ki te %1",
  	SOUND_CHANGEVOLUMEBY: "ka kamiare te reʾo ki te %1",
  	SOUND_SETVOLUMETO: "haka tano te volumen al %1%",
  	"music.changeTempo": "change tempo by %1",
  	"music.setTempo": "ka vaʾai te tempo ki te mau %1",
  	"pen.clear": "haka kore tahi",
  	"pen.stamp": "tapa´o",
  	"pen.penDown": "haka turu te pentara",
  	"pen.penUp": "haka iri te pentara",
  	"pen.setColor": "haka tano te kiea o te pentara ko te %1",
  	"pen.changeHue": "ka kamiare te kiea o te pentara por %1",
  	"pen.setColorParam": "set pen %1 to %2",
  	"pen.changeColorParam": "change pen %1 by %2",
  	"pen.setHue": "haka tano te kiea o te pentara ko te %1",
  	"pen.changeShade": "ka kamiare te kohu o te pentara ki te %1",
  	"pen.setShade": "haka tano te kohu o te pentara ki te %1",
  	"pen.changeSize": "ka kamiare te nui nui o te pentara ki te %1",
  	"pen.setSize": "haka tano te nui nui o te pentara ki te %1",
  	EVENT_WHENFLAGCLICKED: "ki āŋa te clic i te @greenFlag",
  	EVENT_WHENKEYPRESSED: "mo ŋatu te pito pito %1",
  	EVENT_WHENTHISSPRITECLICKED: "ki āŋa te clic i te meʾe nei",
  	EVENT_WHENSTAGECLICKED: "mo ŋatu te clic i te ahu",
  	EVENT_WHENBACKDROPSWITCHESTO: "ki kamiare te tuʾa nui ki te %1",
  	EVENT_WHENGREATERTHAN: "a he %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ki vaʾai mai %1",
  	EVENT_BROADCAST: "haka oho %1",
  	EVENT_BROADCASTANDWAIT: "e haka oho %1 e tiaki",
  	CONTROL_WAIT: "e tiaki %1 piere",
  	CONTROL_REPEAT: "haka ʾou %1",
  	CONTROL_FOREVER: "mo āŋa paurō te hora",
  	CONTROL_IF: "eʾe %1 oira",
  	CONTROL_WAITUNTIL: "tiaki ki %1",
  	CONTROL_REPEATUNTIL: "hakaʾou ki %1",
  	CONTROL_STOP: "noho %1",
  	CONTROL_STARTASCLONE: "ki haʾamata pahe clon",
  	CONTROL_CREATECLONEOF: "e aŋa te ko tu meʾe a o te %1",
  	CONTROL_DELETETHISCLONE: "haka kore te clon nei",
  	SENSING_ASKANDWAIT: "e ʾui %1 e he tiaki",
  	"videoSensing.videoToggle": "turn video %1",
  	"videoSensing.setVideoTransparency": "haka tano te maeha o te teata ki te %1",
  	"videoSensing.whenMotionGreaterThan": "a he te makenu o te teata %1",
  	SENSING_RESETTIMER: "e haʾamata haka ʾou te cronómetro",
  	DATA_SETVARIABLETO: "e vaʾai ki te %1 te mau %2",
  	DATA_CHANGEVARIABLEBY: "haka rahi ki te %1 %2",
  	DATA_SHOWVARIABLE: "haka tikeʾa te variable %1",
  	DATA_HIDEVARIABLE: "e naʾa te variable %1",
  	DATA_ADDTOLIST: "ka hahaʾo te %1 ki te %2",
  	DATA_DELETEOFLIST: "haka kore %1 de %2",
  	DATA_DELETEALLOFLIST: "haka kore taʾa toʾa te %1",
  	MOTION_IFONEDGEBOUNCE: "ana hahine ki te titi, ka rere rere",
  	DATA_INSERTATLIST: "e hahaʾo te %1 ki te %2 o te %3",
  	DATA_REPLACEITEMOFLIST: "ka hahaʾo te rua meʾe %1 o te %2 hai %3",
  	DATA_SHOWLIST: "haka tikeʾa te parau o te meʾe %1",
  	DATA_HIDELIST: "naʾa te parau %1",
  	SENSING_OF_XPOSITION: "he noho o te x",
  	SENSING_OF_YPOSITION: "he noho o te y",
  	SENSING_OF_DIRECTION: "ara",
  	SENSING_OF_COSTUMENUMBER: "# o te diseño",
  	LOOKS_COSTUMENUMBERNAME: "%1 o te diseño",
  	SENSING_OF_SIZE: "he haito",
  	SENSING_OF_BACKDROPNAME: "iŋoa o te tuʾa nui",
  	LOOKS_BACKDROPNUMBERNAME: "%1 o te tuʾa nui",
  	SENSING_OF_BACKDROPNUMBER: "o te tuʾa nui",
  	SOUND_VOLUME: "re´o o te computador",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "¿e puʾa %1?",
  	SENSING_TOUCHINGCOLOR: "¿e puʾa te kiea %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "¿kiea %1 ē puʾa %2?",
  	SENSING_DISTANCETO: "roa ki %1",
  	SENSING_ANSWER: "pahono",
  	SENSING_KEYPRESSED: "¿pito pito %1 ko ŋatu ā?",
  	SENSING_MOUSEDOWN: "¿kioʾe ko te ŋatu hāŋa ā?",
  	SENSING_MOUSEX: "he kona noho x o te kioʾe",
  	SENSING_MOUSEY: "he kona noho y o te kioʾe",
  	SENSING_SETDRAGMODE: "haka titika te modo makenu ki te %1",
  	SENSING_LOUDNESS: "volumen o te pakeke",
  	"videoSensing.videoOn": "video %1 on %2",
  	SENSING_TIMER: "cronómetro",
  	SENSING_OF: "%1 o te %2",
  	SENSING_CURRENT: "%1 apī",
  	SENSING_DAYSSINCE2000: "he mahana mai te 2000",
  	SENSING_USERNAME: "iŋoa o te  usuario",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "numera aleatorio i a %1 e %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 e %2",
  	OPERATORS_OR: "%1 o %2",
  	OPERATORS_NOT: "ina %1",
  	OPERATORS_JOIN: "ka haka piri %1 %2",
  	OPERATORS_LETTEROF: "tiaraʾa %1 o te %2",
  	OPERATORS_LENGTH: "roa roa o te %1",
  	OPERATORS_MOD: "%1 módulo %2",
  	OPERATORS_ROUND: "haka taka taka %1",
  	OPERATORS_MATHOP: "%1 o te %2",
  	OPERATORS_CONTAINS: "¿%2 e ai era te %1?",
  	DATA_ITEMOFLIST: "meʾe %1 i te %2",
  	DATA_ITEMNUMOFLIST: "# o te meʾe he %1 i te %2",
  	DATA_LENGTHOFLIST: "roa roa o te %1",
  	DATA_LISTCONTAINSITEM: "¿%2 e ai era te %1?",
  	CONTROL_ELSE: "eʾe ina",
  	SENSING_USERID: "id o te kope kori",
  	SENSING_LOUD: "¿poŋeha?",
  	"text2speech.speakAndWaitBlock": "e ki %1",
  	"text2speech.setVoiceBlock": "ka hahaʾo te reʾo ki te %1",
  	"text2speech.setLanguageBlock": "haka tano te reʾo ki te %1",
  	"translate.translateBlock": "ka huri %1 ki te %2",
  	"translate.viewerLanguage": "reʾo",
  	"makeymakey.whenKeyPressed": "mo ŋatu te pito pito %1",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "mo ŋatu te pito pito %1",
  	"microbit.isButtonPressed": "%1 button pressed?",
  	"microbit.whenGesture": "when %1",
  	"microbit.displaySymbol": "display %1",
  	"microbit.displayText": "haka tikeʾa te papaʾi%1",
  	"microbit.clearDisplay": "miaitaki te teata",
  	"microbit.whenTilted": "mo haka taha ki te %1",
  	"microbit.isTilted": "tilted %1?",
  	"microbit.tiltAngle": "tilt angle %1",
  	"microbit.whenPinConnected": "mo hahaʾo te pin %1",
  	"ev3.motorTurnClockwise": "motor %1 turn this way for %2 seconds",
  	"ev3.motorTurnCounterClockwise": "motor %1 turn that way for %2 seconds",
  	"ev3.motorSetPower": "motor %1 set power %2 %",
  	"ev3.getMotorPosition": "te noho o te motor %1",
  	"ev3.whenButtonPressed": "ki ŋatu te pito pito %1",
  	"ev3.whenDistanceLessThan": "a he te roa haka tano < %1",
  	"ev3.whenBrightnessLessThan": "a he te uira < %1",
  	"ev3.buttonPressed": "button %1 pressed?",
  	"ev3.getDistance": "roa ki",
  	"ev3.getBrightness": "ʾuira",
  	"ev3.beepNote": "beep note %1 for %2 secs",
  	"wedo2.motorOn": "turn %1 on",
  	"wedo2.motorOff": "turn %1 off",
  	"wedo2.startMotorPower": "set %1 power to %2",
  	"wedo2.setMotorDirection": "set %1 direction to %2",
  	"wedo2.whenDistance": "a he te roa haka tano %1 %2",
  	"wedo2.getDistance": "roa ki",
  	"wedo2.motorOnFor": "turn %1 on for %2 seconds",
  	"wedo2.setLightHue": "haka tano te peni o te morī ki te %1",
  	"wedo2.playNoteFor": "ka haka taŋi%1 hai hora %2 piere",
  	"wedo2.whenTilted": "mo haka taha ki %1",
  	"wedo2.isTilted": "tilted %1?",
  	"wedo2.getTiltAngle": "tilt angle %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "ki he te sensor o te puai %1",
  	"gdxfor.getForce": "puai",
  	"gdxfor.whenTilted": "ki haka taha %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "¿e hiŋa?",
  	"gdxfor.getSpin": "te horou o te teka %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "mo haka taha ki %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "haka tano te peni o te morī ki te %1"
  };
  var dropdowns$h = {
  };
  var ignorelt$h = [
  ];
  var soundEffects$h = [
  	"roa roatano",
  	"haka iri te reʾo o a te maui o a te mataʾu"
  ];
  var microbitWhen$h = [
  	"moved",
  	"shaken",
  	"jumped"
  ];
  var osis$h = [
  	"te tahi programa i te sprite"
  ];
  var definePrefix$h = [
  	"haka",
  	"tano",
  	"te"
  ];
  var defineSuffix$h = [
  ];
  var palette$h = {
  	Motion: "makenu",
  	Looks: "pahe meʾe no e tahi",
  	Sound: "pakeke",
  	Events: "ŋoŋoro",
  	Control: "aʾaru",
  	Sensing: "sensores",
  	Operators: "operadores",
  	Variables: "variables",
  	"My Blocks": "taʾaku avhata poto roa mekera"
  };
  var math$h = [
  	"valor absoluto",
  	"suelo",
  	"techo",
  	"raíz cuadrada",
  	"sen",
  	"cos",
  	"tan",
  	"arcsen",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$h = {
  };
  var name$h = "Rapa Nui";
  var percentTranslated$h = 100;
  var rap = {
  	commands: commands$h,
  	dropdowns: dropdowns$h,
  	ignorelt: ignorelt$h,
  	soundEffects: soundEffects$h,
  	microbitWhen: microbitWhen$h,
  	osis: osis$h,
  	definePrefix: definePrefix$h,
  	defineSuffix: defineSuffix$h,
  	palette: palette$h,
  	math: math$h,
  	aliases: aliases$h,
  	name: name$h,
  	percentTranslated: percentTranslated$h
  };

  var commands$g = {
  	MOTION_MOVESTEPS: "mergi %1 pași",
  	MOTION_TURNRIGHT: "rotește-te @turnRight %1 grade",
  	MOTION_TURNLEFT: "rotește-te @turnLeft %1 grade",
  	MOTION_POINTINDIRECTION: "orientează-te în direcția %1",
  	MOTION_POINTTOWARDS: "orientează-te spre %1",
  	MOTION_GOTOXY: "mergi la x %1 y: %2",
  	MOTION_GOTO: "mergi la %1",
  	MOTION_GLIDESECSTOXY: "glisează în %1 secunde la x: %2 y: %3",
  	MOTION_GLIDETO: "glisează în %1 secunde la %2",
  	MOTION_CHANGEXBY: "modifică x cu %1",
  	MOTION_SETX: "setează x la %1",
  	MOTION_CHANGEYBY: "modifică y cu %1",
  	MOTION_SETY: "setează y la %1",
  	MOTION_SETROTATIONSTYLE: "setează stilul de rotație %1",
  	LOOKS_SAYFORSECS: "spune %1 pentru %2 secunde",
  	LOOKS_SAY: "spune %1",
  	LOOKS_THINKFORSECS: "gândește %1 pentru %2 secunde",
  	LOOKS_THINK: "gândește %1",
  	LOOKS_SHOW: "arată",
  	LOOKS_HIDE: "ascunde",
  	LOOKS_SWITCHCOSTUMETO: "schimbă costumul la %1",
  	LOOKS_NEXTCOSTUME: "costumul următor",
  	LOOKS_NEXTBACKDROP_BLOCK: "decorul următor",
  	LOOKS_SWITCHBACKDROPTO: "schimbă decorul la %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "schimbă decorul la %1 și așteaptă",
  	LOOKS_CHANGEEFFECTBY: "modifică efectul %1 cu %2",
  	LOOKS_SETEFFECTTO: "setează efectul %1 la %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "anulează efectele grafice",
  	LOOKS_CHANGESIZEBY: "modifică mărimea cu %1",
  	LOOKS_SETSIZETO: "setează mărimea la %1 %",
  	LOOKS_GOTOFRONTBACK: "mergi la stratul %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "mergi %1 %2 straturi",
  	SOUND_PLAY: "pornește sunetul %1",
  	SOUND_CHANGEEFFECTBY: "modifică efectul %1 cu %2",
  	SOUND_SETEFFECTO: "setează efectul %1 la %2",
  	SOUND_CLEAREFFECTS: "șterge efectele audio",
  	SOUND_PLAYUNTILDONE: "redă sunetul %1 până la final",
  	SOUND_STOPALLSOUNDS: "oprește toate sunetele",
  	"music.playDrumForBeats": "cântă la tobă %1 pentru %2 bătăi",
  	"music.restForBeats": "ia o pauză pentru  %1 bătăi",
  	"music.playNoteForBeats": "cântă nota  %1 pentru %2  bătăi",
  	"music.setInstrument": "setează instrument la %1",
  	SOUND_CHANGEVOLUMEBY: "modifică volumul cu %1",
  	SOUND_SETVOLUMETO: "setează volumul la %1%",
  	"music.changeTempo": "schimbă ritmul cu %1",
  	"music.setTempo": "setează viteaza la %1",
  	"pen.clear": "șterge tot",
  	"pen.stamp": "ștampila",
  	"pen.penDown": "stilou jos",
  	"pen.penUp": "stilou sus",
  	"pen.setColor": "setează culoarea stiloului la %1",
  	"pen.changeHue": "schimbă culoarea stiloului cu %1",
  	"pen.setColorParam": "setează %1 stiloului la %2",
  	"pen.changeColorParam": "schimbă %1 stiloului cu %2",
  	"pen.setHue": "setează culoarea stiloului la %1",
  	"pen.changeShade": "schimbă nuanța stiloului cu %1",
  	"pen.setShade": "setează nuanța stiloului la %1",
  	"pen.changeSize": "schimbă grosimea stiloului cu %1",
  	"pen.setSize": "setează grosimea stiloului la %1",
  	EVENT_WHENFLAGCLICKED: "când se dă click pe @greenFlag",
  	EVENT_WHENKEYPRESSED: "când tasta %1 este apăsată",
  	EVENT_WHENTHISSPRITECLICKED: "când se dă click pe acest personaj",
  	EVENT_WHENSTAGECLICKED: "când se dă clic pe scenă",
  	EVENT_WHENBACKDROPSWITCHESTO: "când decorul se schimbă la %1",
  	EVENT_WHENGREATERTHAN: "când %1>%2",
  	EVENT_WHENBROADCASTRECEIVED: "când primesc %1",
  	EVENT_BROADCAST: "difuzează %1",
  	EVENT_BROADCASTANDWAIT: "difuzează %1 și așteaptă",
  	CONTROL_WAIT: "așteaptă %1 secunde",
  	CONTROL_REPEAT: "repetă %1",
  	CONTROL_FOREVER: "la infinit",
  	CONTROL_IF: "dacă %1 atunci",
  	CONTROL_WAITUNTIL: "așteaptă până când %1",
  	CONTROL_REPEATUNTIL: "repetă până când %1",
  	CONTROL_STOP: "stop %1",
  	CONTROL_STARTASCLONE: "când încep ca și clonă",
  	CONTROL_CREATECLONEOF: "creează o clonă a %1",
  	CONTROL_DELETETHISCLONE: "șterge această clonă",
  	SENSING_ASKANDWAIT: "întreabă %1 și așteaptă",
  	"videoSensing.videoToggle": "setează video ca %1",
  	"videoSensing.setVideoTransparency": "setează transparența video la %1",
  	"videoSensing.whenMotionGreaterThan": "când mișcarea video > %1",
  	SENSING_RESETTIMER: "resetează cronometru",
  	DATA_SETVARIABLETO: "setează %1 la %2",
  	DATA_CHANGEVARIABLEBY: "modifică %1 cu %2",
  	DATA_SHOWVARIABLE: "arată variabila %1",
  	DATA_HIDEVARIABLE: "ascunde variabila %1",
  	DATA_ADDTOLIST: "adaugă %1 la %2",
  	DATA_DELETEOFLIST: "șterge %1 din %2",
  	DATA_DELETEALLOFLIST: "șterge tot din %1",
  	MOTION_IFONEDGEBOUNCE: "dacă atinge marginea, ricoșează",
  	DATA_INSERTATLIST: "inserează %1 la %2 din %3",
  	DATA_REPLACEITEMOFLIST: "înlocuiește item %1 din %2 cu %3",
  	DATA_SHOWLIST: "arată lista %1",
  	DATA_HIDELIST: "ascunde lista %1",
  	SENSING_OF_XPOSITION: "poziția x",
  	SENSING_OF_YPOSITION: "poziția y",
  	SENSING_OF_DIRECTION: "direcția",
  	SENSING_OF_COSTUMENUMBER: "nr. costum",
  	LOOKS_COSTUMENUMBERNAME: "costumul %1",
  	SENSING_OF_SIZE: "mărime",
  	SENSING_OF_BACKDROPNAME: "denumire decor",
  	LOOKS_BACKDROPNUMBERNAME: "decor %1",
  	SENSING_OF_BACKDROPNUMBER: "nr. decor",
  	SOUND_VOLUME: "volum",
  	"music.getTempo": "ritm",
  	SENSING_TOUCHINGOBJECT: "atinge %1?",
  	SENSING_TOUCHINGCOLOR: "atinge culoarea %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "culoarea %1 atinge %2?",
  	SENSING_DISTANCETO: "distanța până la %1",
  	SENSING_ANSWER: "răspuns",
  	SENSING_KEYPRESSED: "tasta %1 apăsată?",
  	SENSING_MOUSEDOWN: "butonul mouse-ului e apăsat?",
  	SENSING_MOUSEX: "mouse x",
  	SENSING_MOUSEY: "mouse y",
  	SENSING_SETDRAGMODE: "setează mod tragere %1",
  	SENSING_LOUDNESS: "intensitatea sunetului",
  	"videoSensing.videoOn": "%1 video față de %2",
  	SENSING_TIMER: "cronometru",
  	SENSING_OF: "%1 din %2",
  	SENSING_CURRENT: "%1 curent(ă)",
  	SENSING_DAYSSINCE2000: "zile din 2000",
  	SENSING_USERNAME: "nume utilizator",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1  - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "alege aleator între %1 și %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1  = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 și %2",
  	OPERATORS_OR: "%1 sau %2",
  	OPERATORS_NOT: "nu %1",
  	OPERATORS_JOIN: "alătură %1 %2",
  	OPERATORS_LETTEROF: "litera %1 din %2",
  	OPERATORS_LENGTH: "lungimea lui %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "rotunjește %1",
  	OPERATORS_MATHOP: "%1 din %2",
  	OPERATORS_CONTAINS: "%1 conține %2?",
  	DATA_ITEMOFLIST: "element %1 din %2",
  	DATA_ITEMNUMOFLIST: "nr. elementului %1 în %2",
  	DATA_LENGTHOFLIST: "lungimea lui %1",
  	DATA_LISTCONTAINSITEM: "%1 conține %2?",
  	CONTROL_ELSE: "altfel",
  	SENSING_USERID: "id utilizator",
  	SENSING_LOUD: "tare?",
  	"text2speech.speakAndWaitBlock": "spune %1",
  	"text2speech.setVoiceBlock": "setează vocea  %1",
  	"text2speech.setLanguageBlock": "setează limba %1",
  	"translate.translateBlock": "tradu %1 în %2",
  	"translate.viewerLanguage": "limbă",
  	"makeymakey.whenKeyPressed": "la apăsarea tastei %1",
  	"makeymakey.whenKeysPressedInOrder": "la apăsarea în ordine a %1",
  	"microbit.whenButtonPressed": "când butonul %1 este apăsat",
  	"microbit.isButtonPressed": "butonul %1 este apăsat?",
  	"microbit.whenGesture": "când e %1",
  	"microbit.displaySymbol": "afișează %1",
  	"microbit.displayText": "afișează textul %1",
  	"microbit.clearDisplay": "șterge ecran",
  	"microbit.whenTilted": "când este înclinat%1",
  	"microbit.isTilted": "înclinat %1?",
  	"microbit.tiltAngle": "unghiul de înclinare %1",
  	"microbit.whenPinConnected": "când pinul %1 este conectat",
  	"ev3.motorTurnClockwise": "motor %1 rotește înainte %2 secunde",
  	"ev3.motorTurnCounterClockwise": "motor %1 rotește înapoi %2 secunde",
  	"ev3.motorSetPower": "motor %1 setează putere la %2 %",
  	"ev3.getMotorPosition": "motor %1 poziția",
  	"ev3.whenButtonPressed": "când butonul %1 este apăsat",
  	"ev3.whenDistanceLessThan": "când distanța < %1",
  	"ev3.whenBrightnessLessThan": "când strălucirea  < %1",
  	"ev3.buttonPressed": "butonul %1este apăsat?",
  	"ev3.getDistance": "distanța",
  	"ev3.getBrightness": "strălucire",
  	"ev3.beepNote": "semnal sonor nota %1 pentru %2 secunde",
  	"wedo2.motorOn": "pornește %1",
  	"wedo2.motorOff": "oprește %1",
  	"wedo2.startMotorPower": "setează puterea %1 la %2",
  	"wedo2.setMotorDirection": "setează direcția %1 pe %2",
  	"wedo2.whenDistance": "când distanța %1 %2",
  	"wedo2.getDistance": "distanța",
  	"wedo2.motorOnFor": "pornește %1  pentru %2 secunde",
  	"wedo2.setLightHue": "setează culoare LED la %1",
  	"wedo2.playNoteFor": "cântă nota %1 pentru %2 secunde",
  	"wedo2.whenTilted": "când este înclinat %1",
  	"wedo2.isTilted": "este înclinat %1?",
  	"wedo2.getTiltAngle": "unghiul de înclinare %1",
  	"gdxfor.whenGesture": "când e %1",
  	"gdxfor.whenForcePushedOrPulled": "când senzorul de forță este %1",
  	"gdxfor.getForce": "forță",
  	"gdxfor.whenTilted": "la înclinarea %1",
  	"gdxfor.isTilted": "înclinat %1?",
  	"gdxfor.getTilt": "unghi de înclinare %1",
  	"gdxfor.isFreeFalling": "în cădere?",
  	"gdxfor.getSpin": "viteza rotației%1",
  	"gdxfor.getAcceleration": "accelerație%1",
  	"boost.motorOnFor": "pornește motorul %1 pentru %2 secunde",
  	"boost.motorOnForRotation": "pornește motorul %1 pentru %2 rotații",
  	"boost.motorOn": "pornește motorul %1",
  	"boost.motorOff": "oprește motorul %1",
  	"boost.setMotorPower": "setează viteza motorului %1 la %2 %",
  	"boost.setMotorDirection": "setează motorul %1 în direcția %2",
  	"boost.getMotorPosition": "poziția motorului %1",
  	"boost.whenColor": "când este vizibilă cărămida %1",
  	"boost.seeingColor": "vezi cărămida %1?",
  	"boost.whenTilted": "când este înclinat %1",
  	"boost.getTiltAngle": "unghiul de înclinare %1",
  	"boost.setLightHue": "setează culoare LED la %1"
  };
  var dropdowns$g = {
  };
  var ignorelt$g = [
  ];
  var soundEffects$g = [
  	"înălțimea sunetului",
  	"deplasare la stânga/dreapta"
  ];
  var microbitWhen$g = [
  	"mutat",
  	"scuturat",
  	"sărit"
  ];
  var osis$g = [
  	"alte scripturi pentru personaj"
  ];
  var definePrefix$g = [
  	"definește"
  ];
  var defineSuffix$g = [
  ];
  var palette$g = {
  	Motion: "Mișcare",
  	Looks: "Aspect",
  	Sound: "Sunet",
  	Events: "Evenimente",
  	Control: "Control",
  	Sensing: "Detectare",
  	Operators: "Operatori",
  	Variables: "Variabile",
  	"My Blocks": "Blocurile mele"
  };
  var math$g = [
  	"modul",
  	"partea întreagă",
  	"rotunjire prin adaos",
  	"radical",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$g = {
  	"rotește la stânga %1 grade": "MOTION_TURNLEFT",
  	"rotește la dreapta %1 grade": "MOTION_TURNRIGHT",
  	"când se face click pe stegulețul verde": "EVENT_WHENFLAGCLICKED",
  	terminare: "scratchblocks:end"
  };
  var name$g = "Română";
  var percentTranslated$g = 100;
  var ro = {
  	commands: commands$g,
  	dropdowns: dropdowns$g,
  	ignorelt: ignorelt$g,
  	soundEffects: soundEffects$g,
  	microbitWhen: microbitWhen$g,
  	osis: osis$g,
  	definePrefix: definePrefix$g,
  	defineSuffix: defineSuffix$g,
  	palette: palette$g,
  	math: math$g,
  	aliases: aliases$g,
  	name: name$g,
  	percentTranslated: percentTranslated$g
  };

  var commands$f = {
  	MOTION_MOVESTEPS: "идти %1 шагов",
  	MOTION_TURNRIGHT: "повернуть @turnRight на %1 градусов",
  	MOTION_TURNLEFT: "повернуть @turnLeft на %1 градусов",
  	MOTION_POINTINDIRECTION: "повернуться в направлении %1",
  	MOTION_POINTTOWARDS: "повернуться к %1",
  	MOTION_GOTOXY: "перейти в x: %1 y: %2",
  	MOTION_GOTO: "перейти на %1",
  	MOTION_GLIDESECSTOXY: "плыть %1 секунд в точку x: %2 y: %3",
  	MOTION_GLIDETO: "плыть %1 секунд к %2",
  	MOTION_CHANGEXBY: "изменить x на %1",
  	MOTION_SETX: "установить x в %1",
  	MOTION_CHANGEYBY: "изменить y на %1",
  	MOTION_SETY: "установить y в %1",
  	MOTION_SETROTATIONSTYLE: "установить способ вращения %1",
  	LOOKS_SAYFORSECS: "говорить %1 %2 секунд",
  	LOOKS_SAY: "сказать %1",
  	LOOKS_THINKFORSECS: "думать %1 %2 секунд",
  	LOOKS_THINK: "думать %1",
  	LOOKS_SHOW: "показаться",
  	LOOKS_HIDE: "спрятаться",
  	LOOKS_SWITCHCOSTUMETO: "изменить костюм на %1",
  	LOOKS_NEXTCOSTUME: "следующий костюм",
  	LOOKS_NEXTBACKDROP_BLOCK: "следующий фон",
  	LOOKS_SWITCHBACKDROPTO: "переключить фон на %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "переключить фон на %1 и ждать",
  	LOOKS_CHANGEEFFECTBY: "изменить эффект %1 на %2",
  	LOOKS_SETEFFECTTO: "установить эффект %1 %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "убрать графические эффекты",
  	LOOKS_CHANGESIZEBY: "изменить размер на %1 %",
  	LOOKS_SETSIZETO: "установить размер %1 %",
  	LOOKS_GOTOFRONTBACK: "перейти на %1 слой",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "перейти %1 на %2 слоя",
  	SOUND_PLAY: "включить звук %1",
  	SOUND_CHANGEEFFECTBY: "изменить %1 эффект на %2",
  	SOUND_SETEFFECTO: "установить эффект %1 в %2",
  	SOUND_CLEAREFFECTS: "убрать звуковые эффекты",
  	SOUND_PLAYUNTILDONE: "играть звук %1 до конца",
  	SOUND_STOPALLSOUNDS: "остановить все звуки",
  	"music.playDrumForBeats": "барабану играть %1  %2 бита",
  	"music.restForBeats": "пауза в течение %1 бит",
  	"music.playNoteForBeats": "играй ноту %1 %2 бита",
  	"music.setInstrument": "изменить инструмент на %1",
  	SOUND_CHANGEVOLUMEBY: "изменить громкость на %1",
  	SOUND_SETVOLUMETO: "установить громкость %1%",
  	"music.changeTempo": "изменить темп на %1",
  	"music.setTempo": "установить темп %1",
  	"pen.clear": "стереть всё",
  	"pen.stamp": "печать",
  	"pen.penDown": "опустить перо",
  	"pen.penUp": "поднять перо",
  	"pen.setColor": "установить для пера цвет %1",
  	"pen.changeHue": "изменить цвет пера на %1",
  	"pen.setColorParam": "установить %1 пера %2",
  	"pen.changeColorParam": "изменить %1 пера на %2",
  	"pen.setHue": "установить цвет пера %1",
  	"pen.changeShade": "изменить оттенок пера на %1",
  	"pen.setShade": "установить оттенок пера %1",
  	"pen.changeSize": "изменить размер пера на %1",
  	"pen.setSize": "установить размер пера %1",
  	EVENT_WHENFLAGCLICKED: "когда @greenFlag нажат",
  	EVENT_WHENKEYPRESSED: "когда клавиша %1 нажата",
  	EVENT_WHENTHISSPRITECLICKED: "когда спрайт нажат",
  	EVENT_WHENSTAGECLICKED: "когда кликнут по сцене",
  	EVENT_WHENBACKDROPSWITCHESTO: "когда фон сменился на %1",
  	EVENT_WHENGREATERTHAN: "когда %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "когда я получу %1",
  	EVENT_BROADCAST: "передать %1",
  	EVENT_BROADCASTANDWAIT: "передать %1 и ждать до конца",
  	CONTROL_WAIT: "ждать %1 секунд",
  	CONTROL_REPEAT: "повторить %1 раз",
  	CONTROL_FOREVER: "повторять всегда",
  	CONTROL_IF: "если %1 , то",
  	CONTROL_WAITUNTIL: "ждать до %1",
  	CONTROL_REPEATUNTIL: "повторять пока не %1",
  	CONTROL_STOP: "стоп %1",
  	CONTROL_STARTASCLONE: "когда я начинаю как клон",
  	CONTROL_CREATECLONEOF: "создать клон %1",
  	CONTROL_DELETETHISCLONE: "удалить клон",
  	SENSING_ASKANDWAIT: "спросить %1 и ждать",
  	"videoSensing.videoToggle": "включить видео %1",
  	"videoSensing.setVideoTransparency": "установить прозрачность видео  %1",
  	"videoSensing.whenMotionGreaterThan": "когда скорость видео > %1",
  	SENSING_RESETTIMER: "сбросить таймер",
  	DATA_SETVARIABLETO: "задать %1 значение %2",
  	DATA_CHANGEVARIABLEBY: "изменить %1 на %2",
  	DATA_SHOWVARIABLE: "показать переменную %1",
  	DATA_HIDEVARIABLE: "скрыть переменную %1",
  	DATA_ADDTOLIST: "добавить %1 к %2",
  	DATA_DELETEOFLIST: "удалить %1 из %2",
  	DATA_DELETEALLOFLIST: "удалить все из %1",
  	MOTION_IFONEDGEBOUNCE: "если касается края, оттолкнуться",
  	DATA_INSERTATLIST: "вставить %1 в %3 из %2",
  	DATA_REPLACEITEMOFLIST: "заменить элемент %1 в %2 на %3",
  	DATA_SHOWLIST: "показать список %1",
  	DATA_HIDELIST: "скрыть список %1",
  	SENSING_OF_XPOSITION: "положение x",
  	SENSING_OF_YPOSITION: "положение y",
  	SENSING_OF_DIRECTION: "направление",
  	SENSING_OF_COSTUMENUMBER: "костюм #",
  	LOOKS_COSTUMENUMBERNAME: "костюм %1",
  	SENSING_OF_SIZE: "размер",
  	SENSING_OF_BACKDROPNAME: "имя фона",
  	LOOKS_BACKDROPNUMBERNAME: "фон %1",
  	SENSING_OF_BACKDROPNUMBER: "фон #",
  	SOUND_VOLUME: "громкость звука",
  	"music.getTempo": "темп",
  	SENSING_TOUCHINGOBJECT: "касается %1?",
  	SENSING_TOUCHINGCOLOR: "касается цвета %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "цвет %1 касается цвета %2?",
  	SENSING_DISTANCETO: "расстояние до %1",
  	SENSING_ANSWER: "ответ",
  	SENSING_KEYPRESSED: "клавиша %1 нажата?",
  	SENSING_MOUSEDOWN: "мышь нажата?",
  	SENSING_MOUSEX: "x мыши",
  	SENSING_MOUSEY: "y мыши",
  	SENSING_SETDRAGMODE: "перетаскивать %1",
  	SENSING_LOUDNESS: "громкость",
  	"videoSensing.videoOn": "видео %1  на %2",
  	SENSING_TIMER: "таймер",
  	SENSING_OF: "%1 от %2",
  	SENSING_CURRENT: "текущий %1",
  	SENSING_DAYSSINCE2000: "дней с 2000 г",
  	SENSING_USERNAME: "имя пользователя",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "выдать случайное от %1 до %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 и %2",
  	OPERATORS_OR: "%1 или %2",
  	OPERATORS_NOT: "не %1",
  	OPERATORS_JOIN: "объединить %1 %2",
  	OPERATORS_LETTEROF: "буква %1 в %2",
  	OPERATORS_LENGTH: "длина %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "округлить %1",
  	OPERATORS_MATHOP: "%1 от %2",
  	OPERATORS_CONTAINS: "%1 содержит %2?",
  	DATA_ITEMOFLIST: "элемент %1 в %2",
  	DATA_ITEMNUMOFLIST: "№ элемента %1 в %2",
  	DATA_LENGTHOFLIST: "длина списка %1",
  	DATA_LISTCONTAINSITEM: "%1 содержит %2?",
  	CONTROL_ELSE: "иначе",
  	SENSING_USERID: "id пользователя",
  	SENSING_LOUD: "громко?",
  	"text2speech.speakAndWaitBlock": "сказать %1",
  	"text2speech.setVoiceBlock": "установить %1 голос",
  	"text2speech.setLanguageBlock": "установить %1 язык",
  	"translate.translateBlock": "перевести %1 на %2",
  	"translate.viewerLanguage": "язык",
  	"makeymakey.whenKeyPressed": "когда %1 клавиша нажата",
  	"makeymakey.whenKeysPressedInOrder": "при нажатии по порядку %1",
  	"microbit.whenButtonPressed": "когда %1 кнопка нажата",
  	"microbit.isButtonPressed": "%1 кнопка нажата?",
  	"microbit.whenGesture": "когда %1",
  	"microbit.displaySymbol": "отобразить %1",
  	"microbit.displayText": "показать текст %1",
  	"microbit.clearDisplay": "очистить дисплей",
  	"microbit.whenTilted": "когда наклонён %1",
  	"microbit.isTilted": "наклонён %1?",
  	"microbit.tiltAngle": "угол наклона %1",
  	"microbit.whenPinConnected": "когда подключён пин %1",
  	"ev3.motorTurnClockwise": "мотор %1 повернуть сюда на %2 секунд",
  	"ev3.motorTurnCounterClockwise": "мотор %1 повернуть туда на %2 секунд",
  	"ev3.motorSetPower": "мотор %1 установить мощность %2 %",
  	"ev3.getMotorPosition": "позиция мотора %1",
  	"ev3.whenButtonPressed": "когда кнопка %1 нажата",
  	"ev3.whenDistanceLessThan": "когда расстояние < %1",
  	"ev3.whenBrightnessLessThan": "когда яркость < %1",
  	"ev3.buttonPressed": "кнопка %1 нажата?",
  	"ev3.getDistance": "расстояние",
  	"ev3.getBrightness": "яркость",
  	"ev3.beepNote": "играть ноту %1 %2 секунд",
  	"wedo2.motorOn": "включить %1",
  	"wedo2.motorOff": "выключить %1",
  	"wedo2.startMotorPower": "установить мощность %1 в %2",
  	"wedo2.setMotorDirection": "установить направление %1 в %2",
  	"wedo2.whenDistance": "когда расстояние %1 %2",
  	"wedo2.getDistance": "расстояние",
  	"wedo2.motorOnFor": "включить %1 на %2 секунд",
  	"wedo2.setLightHue": "установить цвет лампочки %1",
  	"wedo2.playNoteFor": "играть ноту %1 %2 секунд",
  	"wedo2.whenTilted": "когда наклонён %1",
  	"wedo2.isTilted": "наклонён %1 ?",
  	"wedo2.getTiltAngle": "угол наклона%1",
  	"gdxfor.whenGesture": "когда %1",
  	"gdxfor.whenForcePushedOrPulled": "когда датчик приложения силы %1",
  	"gdxfor.getForce": "сила",
  	"gdxfor.whenTilted": "когда наклонён %1",
  	"gdxfor.isTilted": "наклонён %1?",
  	"gdxfor.getTilt": "угол наклона %1",
  	"gdxfor.isFreeFalling": "падение?",
  	"gdxfor.getSpin": "скорость вращения %1",
  	"gdxfor.getAcceleration": "ускорение %1",
  	"boost.motorOnFor": "включить мотор %1 на %2 секунд",
  	"boost.motorOnForRotation": "включить мотор %1 на %2 оборотов",
  	"boost.motorOn": "включить мотор %1",
  	"boost.motorOff": "выключить мотор %1",
  	"boost.setMotorPower": "установить скорость %1 в %2 %",
  	"boost.setMotorDirection": "установить направление мотора %1 в %2",
  	"boost.getMotorPosition": "позиция мотора %1",
  	"boost.whenColor": "когда виден %1 кирпич",
  	"boost.seeingColor": "виден %1 кирпич?",
  	"boost.whenTilted": "когда наклонён %1",
  	"boost.getTiltAngle": "угол наклона %1",
  	"boost.setLightHue": "установить цвет лампочки %1"
  };
  var dropdowns$f = {
  };
  var ignorelt$f = [
  ];
  var soundEffects$f = [
  	"высота тона",
  	"звучание слева/справа"
  ];
  var microbitWhen$f = [
  	"передвинулись",
  	"встряхнули",
  	"подпрыгнули"
  ];
  var osis$f = [
  	"другие скрипты спрайта"
  ];
  var definePrefix$f = [
  	"определить"
  ];
  var defineSuffix$f = [
  ];
  var palette$f = {
  	Motion: "Движение",
  	Looks: "Внешний вид",
  	Sound: "Звук",
  	Events: "События",
  	Control: "Управление",
  	Sensing: "Сенсоры",
  	Operators: "Операторы",
  	Variables: "Переменные",
  	"My Blocks": "Другие блоки"
  };
  var math$f = [
  	"модуль",
  	"целое меньшее",
  	"целое большее",
  	"квадратный корень",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$f = {
  	"повернуть влево на %1 градусов": "MOTION_TURNLEFT",
  	"повернуть вправо на %1 градусов": "MOTION_TURNRIGHT",
  	"когда щёлкнут по зелёному флагу": "EVENT_WHENFLAGCLICKED",
  	"конец": "scratchblocks:end"
  };
  var name$f = "Русский";
  var percentTranslated$f = 100;
  var ru = {
  	commands: commands$f,
  	dropdowns: dropdowns$f,
  	ignorelt: ignorelt$f,
  	soundEffects: soundEffects$f,
  	microbitWhen: microbitWhen$f,
  	osis: osis$f,
  	definePrefix: definePrefix$f,
  	defineSuffix: defineSuffix$f,
  	palette: palette$f,
  	math: math$f,
  	aliases: aliases$f,
  	name: name$f,
  	percentTranslated: percentTranslated$f
  };

  var commands$e = {
  	MOTION_MOVESTEPS: "dopredu %1",
  	MOTION_TURNRIGHT: "vpravo @turnRight %1",
  	MOTION_TURNLEFT: "vľavo @turnLeft %1",
  	MOTION_POINTINDIRECTION: "smerom %1",
  	MOTION_POINTTOWARDS: "smerom k %1",
  	MOTION_GOTOXY: "skoč na x: %1 y: %2",
  	MOTION_GOTO: "skoč na %1",
  	MOTION_GLIDESECSTOXY: "kĺž sa %1 s na x: %2 y: %3",
  	MOTION_GLIDETO: "kĺž sa %1 s na %2",
  	MOTION_CHANGEXBY: "zmeň x o %1",
  	MOTION_SETX: "skoč na x: %1",
  	MOTION_CHANGEYBY: "zmeň y o %1",
  	MOTION_SETY: "skoč na y: %1",
  	MOTION_SETROTATIONSTYLE: "nastav otáčanie %1",
  	LOOKS_SAYFORSECS: "bublina %1 %2 s",
  	LOOKS_SAY: "bublina %1",
  	LOOKS_THINKFORSECS: "myšlienka %1 %2 s",
  	LOOKS_THINK: "myšlienka %1",
  	LOOKS_SHOW: "ukáž sa",
  	LOOKS_HIDE: "skry sa",
  	LOOKS_SWITCHCOSTUMETO: "zmeň kostým na %1",
  	LOOKS_NEXTCOSTUME: "ďalší kostým",
  	LOOKS_NEXTBACKDROP_BLOCK: "ďalšie pozadie",
  	LOOKS_SWITCHBACKDROPTO: "zmeň pozadie na %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "zmeň pozadie na %1 a počkaj",
  	LOOKS_CHANGEEFFECTBY: "zmeň efekt %1 o %2",
  	LOOKS_SETEFFECTTO: "nastav efekt %1 na %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "zruš grafické efekty",
  	LOOKS_CHANGESIZEBY: "zmeň veľkosť o %1 %",
  	LOOKS_SETSIZETO: "nastav veľkosť na %1 %",
  	LOOKS_GOTOFRONTBACK: "prejdi na  %1 vrstvu",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "prejdi o %2 vrstiev %1",
  	SOUND_PLAY: "zahraj zvuk %1",
  	SOUND_CHANGEEFFECTBY: "zmeň efekt %1 o %2",
  	SOUND_SETEFFECTO: "nastav efekt %1 na %2",
  	SOUND_CLEAREFFECTS: "zruš zvukové efekty",
  	SOUND_PLAYUNTILDONE: "zahraj zvuk %1 až do konca",
  	SOUND_STOPALLSOUNDS: "zastav všetky zvuky",
  	"music.playDrumForBeats": "zabubnuj %1 taktov %2",
  	"music.restForBeats": "nehraj taktov %1",
  	"music.playNoteForBeats": "zahraj tón %1 taktov %2",
  	"music.setInstrument": "nastav nástroj na %1",
  	SOUND_CHANGEVOLUMEBY: "zmeň hlasitosť o %1 %",
  	SOUND_SETVOLUMETO: "nastav hlasitosť na %1% %",
  	"music.changeTempo": "zmeň tempo o %1",
  	"music.setTempo": "nastav tempo na %1",
  	"pen.clear": "zmaž",
  	"pen.stamp": "opečiatkuj",
  	"pen.penDown": "pero zapni",
  	"pen.penUp": "pero vypni",
  	"pen.setColor": "nastav farbu pera na %1",
  	"pen.changeHue": "zmeň farbu pera o %1",
  	"pen.setColorParam": "nastav %1 pera na %2",
  	"pen.changeColorParam": "zmeň %1 pera o %2",
  	"pen.setHue": "nastav farbu pera na%1",
  	"pen.changeShade": "zmeň odtieň pera o %1",
  	"pen.setShade": "nastav odtieň pera na %1",
  	"pen.changeSize": "zmeň hrúbku pera o %1",
  	"pen.setSize": "nastav hrúbku pera na %1",
  	EVENT_WHENFLAGCLICKED: "pri kliknutí na @greenFlag",
  	EVENT_WHENKEYPRESSED: "pri stlačení %1",
  	EVENT_WHENTHISSPRITECLICKED: "pri kliknutí na mňa",
  	EVENT_WHENSTAGECLICKED: "pri kliknutí na scénu",
  	EVENT_WHENBACKDROPSWITCHESTO: "pri zmene pozadia na %1",
  	EVENT_WHENGREATERTHAN: "pri %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "pri prijatí správy %1",
  	EVENT_BROADCAST: "vyšli správu %1",
  	EVENT_BROADCASTANDWAIT: "vyšli správu %1 a počkaj",
  	CONTROL_WAIT: "čakaj %1 s",
  	CONTROL_REPEAT: "opakuj %1",
  	CONTROL_FOREVER: "opakuj stále",
  	CONTROL_IF: "ak %1",
  	CONTROL_WAITUNTIL: "čakaj až kým %1",
  	CONTROL_REPEATUNTIL: "opakuj až kým %1",
  	CONTROL_STOP: "zastav %1",
  	CONTROL_STARTASCLONE: "pri štarte klonu",
  	CONTROL_CREATECLONEOF: "naklonuj %1",
  	CONTROL_DELETETHISCLONE: "zruš tento klon",
  	SENSING_ASKANDWAIT: "otázka %1",
  	"videoSensing.videoToggle": "%1 snímanie",
  	"videoSensing.setVideoTransparency": "nastav priehľadnosť snímania na %1",
  	"videoSensing.whenMotionGreaterThan": "pri snímanom pohybe > %1",
  	SENSING_RESETTIMER: "vynuluj časovač",
  	DATA_SETVARIABLETO: "nastav %1 na %2",
  	DATA_CHANGEVARIABLEBY: "zmeň %1 o %2",
  	DATA_SHOWVARIABLE: "ukáž premennú %1",
  	DATA_HIDEVARIABLE: "skry premennú %1",
  	DATA_ADDTOLIST: "pridaj %1 do %2",
  	DATA_DELETEOFLIST: "zruš %1 z %2",
  	DATA_DELETEALLOFLIST: "zruš všetko z %1",
  	MOTION_IFONEDGEBOUNCE: "ak na okraji, odraz sa",
  	DATA_INSERTATLIST: "vlož %1 na %2 v %3",
  	DATA_REPLACEITEMOFLIST: "nahraď %1 v %2 hodnotou %3",
  	DATA_SHOWLIST: "ukáž zoznam  %1",
  	DATA_HIDELIST: "skry zoznam  %1",
  	SENSING_OF_XPOSITION: "pozícia x",
  	SENSING_OF_YPOSITION: "pozícia y",
  	SENSING_OF_DIRECTION: "smer",
  	SENSING_OF_COSTUMENUMBER: "číslo kostýmu",
  	LOOKS_COSTUMENUMBERNAME: "kostým %1",
  	SENSING_OF_SIZE: "veľkosť",
  	SENSING_OF_BACKDROPNAME: "meno pozadia",
  	LOOKS_BACKDROPNUMBERNAME: "pozadie  %1",
  	SENSING_OF_BACKDROPNUMBER: "číslo pozadia",
  	SOUND_VOLUME: "hlasitosť",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "dotýkaš sa %1?",
  	SENSING_TOUCHINGCOLOR: "dotýkaš sa %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 sa dotýkaš %2?",
  	SENSING_DISTANCETO: "vzdialenosť k %1",
  	SENSING_ANSWER: "odpoveď",
  	SENSING_KEYPRESSED: "stlačené %1?",
  	SENSING_MOUSEDOWN: "stlačené tlačidlo myši?",
  	SENSING_MOUSEX: "myš x",
  	SENSING_MOUSEY: "myš y",
  	SENSING_SETDRAGMODE: "hráč môže presúvať %1",
  	SENSING_LOUDNESS: "hlasitosť",
  	"videoSensing.videoOn": "snímaný %1 na %2",
  	SENSING_TIMER: "časovač",
  	SENSING_OF: "%1 z %2",
  	SENSING_CURRENT: "teraz je %1",
  	SENSING_DAYSSINCE2000: "dní od roku 2000",
  	SENSING_USERNAME: "používateľ",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "náhodne od %1 do %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 a %2",
  	OPERATORS_OR: "%1 alebo %2",
  	OPERATORS_NOT: "nie je %1",
  	OPERATORS_JOIN: "spoj %1 %2",
  	OPERATORS_LETTEROF: "znak %1 z %2",
  	OPERATORS_LENGTH: "dĺžka %1",
  	OPERATORS_MOD: "zvyšok %1 / %2",
  	OPERATORS_ROUND: "zaokrúhli %1",
  	OPERATORS_MATHOP: "%1 z %2",
  	OPERATORS_CONTAINS: "%1 obsahuje %2?",
  	DATA_ITEMOFLIST: "prvok %1 z %2",
  	DATA_ITEMNUMOFLIST: "poradie prvku %1 v %2",
  	DATA_LENGTHOFLIST: "dĺžka %1",
  	DATA_LISTCONTAINSITEM: "%1 obsahuje %2?",
  	CONTROL_ELSE: "inak",
  	SENSING_USERID: "užívateľské id",
  	SENSING_LOUD: "hlasný?",
  	"text2speech.speakAndWaitBlock": "povedz %1",
  	"text2speech.setVoiceBlock": "nastav hlas na %1",
  	"text2speech.setLanguageBlock": "nastav jazyk na %1",
  	"translate.translateBlock": "prelož %1 do %2",
  	"translate.viewerLanguage": "jazyk",
  	"makeymakey.whenKeyPressed": "pri stlačení klávesu %1",
  	"makeymakey.whenKeysPressedInOrder": "pri stlačení postupnosti %1",
  	"microbit.whenButtonPressed": "pri stlačení tlačidla %1",
  	"microbit.isButtonPressed": "tlačidlo %1 stlačené?",
  	"microbit.whenGesture": "pri geste %1",
  	"microbit.displaySymbol": "zobraz %1",
  	"microbit.displayText": "zobraz text %1",
  	"microbit.clearDisplay": "zmaž displej",
  	"microbit.whenTilted": "pri náklone %1",
  	"microbit.isTilted": "náklon smerom %1?",
  	"microbit.tiltAngle": "uhol náklonu %1",
  	"microbit.whenPinConnected": "pri zapojení pinu %1",
  	"ev3.motorTurnClockwise": "motor %1 otáčaj vpravo %2 s",
  	"ev3.motorTurnCounterClockwise": "motor %1 otáčaj vľavo %2 s",
  	"ev3.motorSetPower": "nastav výkon motora %1 na %2 %",
  	"ev3.getMotorPosition": "pozícia motora %1",
  	"ev3.whenButtonPressed": "pri stlačení tlačidla %1",
  	"ev3.whenDistanceLessThan": "pri vzdialenosti < %1",
  	"ev3.whenBrightnessLessThan": "pri jase < %1",
  	"ev3.buttonPressed": "stlačené tlačidlo %1?",
  	"ev3.getDistance": "vzdialenosť",
  	"ev3.getBrightness": "jas",
  	"ev3.beepNote": "tón %1 hraj %2 s",
  	"wedo2.motorOn": "zapni motor %1",
  	"wedo2.motorOff": "vypni motor %1",
  	"wedo2.startMotorPower": "nastav rýchlosť motora %1 na %2",
  	"wedo2.setMotorDirection": "nastav smer %1 na %2",
  	"wedo2.whenDistance": "pri vzdialenosti %1 ako %2",
  	"wedo2.getDistance": "vzdialenosť",
  	"wedo2.motorOnFor": "zapni motor %1 na %2 s",
  	"wedo2.setLightHue": "nastav farbu svetla %1",
  	"wedo2.playNoteFor": "tón %1 hraj %2 s",
  	"wedo2.whenTilted": "pri naklonení %1",
  	"wedo2.isTilted": "náklon %1?",
  	"wedo2.getTiltAngle": "uhol náklonu %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "sila",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "zrýchenie %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$e = {
  };
  var ignorelt$e = [
  ];
  var soundEffects$e = [
  	"frekvencia",
  	"stereo"
  ];
  var microbitWhen$e = [
  	"pohybe",
  	"zatrasení",
  	"skoku"
  ];
  var osis$e = [
  	"moje iné scenáre"
  ];
  var definePrefix$e = [
  	"blok"
  ];
  var defineSuffix$e = [
  ];
  var palette$e = {
  	Motion: "Pohyb",
  	Looks: "Vzhľad",
  	Sound: "Zvuk",
  	Events: "Udalosti",
  	Control: "Riadenie",
  	Sensing: "Zisťovanie",
  	Operators: "Operácie",
  	Variables: "Premenné",
  	"My Blocks": "Nové bloky"
  };
  var math$e = [
  	"abs",
  	"zaokrúhli nadol",
  	"zaokrúhli nahor",
  	"odmocnina",
  	"sin",
  	"cos",
  	"tg",
  	"arcsin",
  	"arccos",
  	"arctg",
  	"ln",
  	"log",
  	"exp",
  	"10 ^"
  ];
  var aliases$e = {
  };
  var name$e = "Slovenčina";
  var percentTranslated$e = 100;
  var sk = {
  	commands: commands$e,
  	dropdowns: dropdowns$e,
  	ignorelt: ignorelt$e,
  	soundEffects: soundEffects$e,
  	microbitWhen: microbitWhen$e,
  	osis: osis$e,
  	definePrefix: definePrefix$e,
  	defineSuffix: defineSuffix$e,
  	palette: palette$e,
  	math: math$e,
  	aliases: aliases$e,
  	name: name$e,
  	percentTranslated: percentTranslated$e
  };

  var commands$d = {
  	MOTION_MOVESTEPS: "pojdi %1 korakov",
  	MOTION_TURNRIGHT: "obrni se za @turnRight %1 stopinj",
  	MOTION_TURNLEFT: "obrni se za @turnLeft %1 stopinj",
  	MOTION_POINTINDIRECTION: "obrni se v smer %1",
  	MOTION_POINTTOWARDS: "obrni se proti %1",
  	MOTION_GOTOXY: "pojdi na x: %1 y: %2",
  	MOTION_GOTO: "pojdi na %1",
  	MOTION_GLIDESECSTOXY: "drsi %1 sekund do x: %2 y: %3",
  	MOTION_GLIDETO: "drsi %1 sekund do %2",
  	MOTION_CHANGEXBY: "spremeni x za %1",
  	MOTION_SETX: "nastavi x na %1",
  	MOTION_CHANGEYBY: "spremeni y za %1",
  	MOTION_SETY: "nastavi y na %1",
  	MOTION_SETROTATIONSTYLE: "Način vrtenja %1",
  	LOOKS_SAYFORSECS: "reci %1 za %2 sekund",
  	LOOKS_SAY: "reci %1",
  	LOOKS_THINKFORSECS: "pomisli %1 za %2 sekund",
  	LOOKS_THINK: "pomisli %1",
  	LOOKS_SHOW: "pokaži",
  	LOOKS_HIDE: "skrij",
  	LOOKS_SWITCHCOSTUMETO: "spremeni videz v %1",
  	LOOKS_NEXTCOSTUME: "naslednji videz",
  	LOOKS_NEXTBACKDROP_BLOCK: "naslednje ozadje",
  	LOOKS_SWITCHBACKDROPTO: "zamenjaj ozadje na %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "zamenjaj ozadje na %1 in počakaj",
  	LOOKS_CHANGEEFFECTBY: "spremeni učinek %1 za %2",
  	LOOKS_SETEFFECTTO: "nastavi učinek %1 na %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "odstrani slikovne učinke",
  	LOOKS_CHANGESIZEBY: "spremeni velikost za %1",
  	LOOKS_SETSIZETO: "nastavi velikost na %1 %",
  	LOOKS_GOTOFRONTBACK: "pojdi na %1 plast",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "pojdi %1 %2 plasti",
  	SOUND_PLAY: "predvajaj zvok %1",
  	SOUND_CHANGEEFFECTBY: "spremeni učinek %1 za %2",
  	SOUND_SETEFFECTO: "nastavi učinek %1 na %2",
  	SOUND_CLEAREFFECTS: "izbriši zvočne učinke",
  	SOUND_PLAYUNTILDONE: "predvajaj zvok %1 do konca",
  	SOUND_STOPALLSOUNDS: "ustavi vse zvoke",
  	"music.playDrumForBeats": "zaigraj na boben %1 za %2 udarcev",
  	"music.restForBeats": "pavza za %1 udarcev",
  	"music.playNoteForBeats": "predvajaj noto %1 za%2 udarce",
  	"music.setInstrument": "nastavi inštrument na %1",
  	SOUND_CHANGEVOLUMEBY: "spremeni glasnost za %1",
  	SOUND_SETVOLUMETO: "nastavi glasnost na %1%",
  	"music.changeTempo": "spremeni tempo za %1",
  	"music.setTempo": "nastavi tempo na %1",
  	"pen.clear": "izbriši vse",
  	"pen.stamp": "žig",
  	"pen.penDown": "spusti pero",
  	"pen.penUp": "dvigni pero",
  	"pen.setColor": "nastavi barvo peresa na %1",
  	"pen.changeHue": "spremeni barvo peresa za %1",
  	"pen.setColorParam": "nastavi pero %1 na %2",
  	"pen.changeColorParam": "spremeni pero %1 za %2",
  	"pen.setHue": "nastavi barvo peresa na %1",
  	"pen.changeShade": "spremeni senco peresa za %1",
  	"pen.setShade": "nastavi senco peresa na %1",
  	"pen.changeSize": "spremeni velikost peresa za %1",
  	"pen.setSize": "nastavi velikost peresa na %1",
  	EVENT_WHENFLAGCLICKED: "ko kliknemo na @greenFlag",
  	EVENT_WHENKEYPRESSED: "ko je pritisnjena tipka %1",
  	EVENT_WHENTHISSPRITECLICKED: "ko kliknemo ta lik",
  	EVENT_WHENSTAGECLICKED: "ko kliknemo na oder",
  	EVENT_WHENBACKDROPSWITCHESTO: "ko se ozadje zamenja na %1",
  	EVENT_WHENGREATERTHAN: "ko je %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "ko prejmem %1",
  	EVENT_BROADCAST: "objavi %1",
  	EVENT_BROADCASTANDWAIT: "objavi %1 in čakaj",
  	CONTROL_WAIT: "počakaj %1 sekund",
  	CONTROL_REPEAT: "ponovi %1 krat",
  	CONTROL_FOREVER: "ponavljaj",
  	CONTROL_IF: "če %1 potem",
  	CONTROL_WAITUNTIL: "počakaj dokler ni %1",
  	CONTROL_REPEATUNTIL: "ponavljaj dokler ni %1",
  	CONTROL_STOP: "ustavi %1",
  	CONTROL_STARTASCLONE: "ko začnem kot dvojnik",
  	CONTROL_CREATECLONEOF: "ustvari dvojnika %1",
  	CONTROL_DELETETHISCLONE: "zbriši tega dvojnika",
  	SENSING_ASKANDWAIT: "vprašaj %1 in počakaj",
  	"videoSensing.videoToggle": "nastavi video %1",
  	"videoSensing.setVideoTransparency": "nastavi prosojnost videa na %1",
  	"videoSensing.whenMotionGreaterThan": "ko je video premik > %1",
  	SENSING_RESETTIMER: "ponastavi štoparico",
  	DATA_SETVARIABLETO: "nastavi %1 na %2",
  	DATA_CHANGEVARIABLEBY: "spremeni %1 za %2",
  	DATA_SHOWVARIABLE: "pokaži spremenljivko %1",
  	DATA_HIDEVARIABLE: "skrij spremenljivko %1",
  	DATA_ADDTOLIST: "dodaj %1 k %2",
  	DATA_DELETEOFLIST: "zbriši %1 v %2",
  	DATA_DELETEALLOFLIST: "izbriši vse v %1",
  	MOTION_IFONEDGEBOUNCE: "odbij se, če si na robu",
  	DATA_INSERTATLIST: "vstavi %1 na %2 v %3",
  	DATA_REPLACEITEMOFLIST: "zamenjaj %1 v %2 z %3",
  	DATA_SHOWLIST: "pokaži seznam %1",
  	DATA_HIDELIST: "skrij seznam %1",
  	SENSING_OF_XPOSITION: "položaj x",
  	SENSING_OF_YPOSITION: "položaj y",
  	SENSING_OF_DIRECTION: "smer",
  	SENSING_OF_COSTUMENUMBER: "videz #",
  	LOOKS_COSTUMENUMBERNAME: "videz %1",
  	SENSING_OF_SIZE: "velikost",
  	SENSING_OF_BACKDROPNAME: "ime ozadja",
  	LOOKS_BACKDROPNUMBERNAME: "ozadje %1",
  	SENSING_OF_BACKDROPNUMBER: "ozadje #",
  	SOUND_VOLUME: "glasnost",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "se dotika %1?",
  	SENSING_TOUCHINGCOLOR: "se dotika barve %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "se barva %1 dotika %2?",
  	SENSING_DISTANCETO: "razdalja do %1",
  	SENSING_ANSWER: "odgovor",
  	SENSING_KEYPRESSED: "je pritisnjena tipka %1?",
  	SENSING_MOUSEDOWN: "je miškin gumb pritisnjen?",
  	SENSING_MOUSEX: "miškin x",
  	SENSING_MOUSEY: "miškin y",
  	SENSING_SETDRAGMODE: "Možnost premika naj bo %1",
  	SENSING_LOUDNESS: "glasnost",
  	"videoSensing.videoOn": "video %1 pri %2",
  	SENSING_TIMER: "štoparica",
  	SENSING_OF: "%1 od %2",
  	SENSING_CURRENT: "trenutni %1",
  	SENSING_DAYSSINCE2000: "dni od leta 2000",
  	SENSING_USERNAME: "uporabniško ime",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "naključno število med %1 in %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 in %2",
  	OPERATORS_OR: "%1 ali %2",
  	OPERATORS_NOT: "ne %1",
  	OPERATORS_JOIN: "združi %1 %2",
  	OPERATORS_LETTEROF: "%1 črka v %2",
  	OPERATORS_LENGTH: "dolžina %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "zaokroži %1",
  	OPERATORS_MATHOP: "%1 od %2",
  	OPERATORS_CONTAINS: "%1 vsebuje %2?",
  	DATA_ITEMOFLIST: "element %1 v %2",
  	DATA_ITEMNUMOFLIST: "predmet # od %1 v %2",
  	DATA_LENGTHOFLIST: "dolžina %1",
  	DATA_LISTCONTAINSITEM: "Ali %1 vsebuje %2?",
  	CONTROL_ELSE: "sicer",
  	SENSING_USERID: "uporabnikova številka",
  	SENSING_LOUD: "glasno?",
  	"text2speech.speakAndWaitBlock": "reci %1",
  	"text2speech.setVoiceBlock": "nastavi glas na %1",
  	"text2speech.setLanguageBlock": "nastavi jezik na %1",
  	"translate.translateBlock": "prevedi %1 v %2",
  	"translate.viewerLanguage": "jezik",
  	"makeymakey.whenKeyPressed": "ko je pritisnjena tipka %1",
  	"makeymakey.whenKeysPressedInOrder": "ko so tipke %1 pritisnjene v določenem vrstnem redu",
  	"microbit.whenButtonPressed": "ko je gumb %1pritisnjen",
  	"microbit.isButtonPressed": "%1 gumb pritisnjen?",
  	"microbit.whenGesture": "ko je %1",
  	"microbit.displaySymbol": "prikaži %1",
  	"microbit.displayText": "prikaži besedilo %1",
  	"microbit.clearDisplay": "pobriši prikazovalnik",
  	"microbit.whenTilted": "ko je nagnjen %1",
  	"microbit.isTilted": "nagnjeno %1?",
  	"microbit.tiltAngle": "kot nagiba %1",
  	"microbit.whenPinConnected": "ko je pin %1 povezan",
  	"ev3.motorTurnClockwise": "motor na %1 obrni v smeri ure  %2 sekund",
  	"ev3.motorTurnCounterClockwise": "motor %1obrni v nasprotni smeri ure za  %2 sekund",
  	"ev3.motorSetPower": "motorju na %1 nastavi moč na %2 %",
  	"ev3.getMotorPosition": "položaj motorja na %1",
  	"ev3.whenButtonPressed": "ko je gumb na %1 pritisnjen",
  	"ev3.whenDistanceLessThan": "ko je razdalja < %1",
  	"ev3.whenBrightnessLessThan": "ko je svetlost < %1",
  	"ev3.buttonPressed": "je gumb na %1 pritisnjen?",
  	"ev3.getDistance": "razdalja",
  	"ev3.getBrightness": "svetlost",
  	"ev3.beepNote": "zapiskaj noto %1 za %2 sekund",
  	"wedo2.motorOn": "vključi %1",
  	"wedo2.motorOff": "izključi %1",
  	"wedo2.startMotorPower": "za %1 nastavi moč na %2",
  	"wedo2.setMotorDirection": "nastavi smer %1 na %2",
  	"wedo2.whenDistance": "ko je razdalja %1 %2",
  	"wedo2.getDistance": "razdalja",
  	"wedo2.motorOnFor": "vključi %1za %2 sekund",
  	"wedo2.setLightHue": "snastavi barvo svetlobe na %1",
  	"wedo2.playNoteFor": "predvajaj noto %1 za %2 sekund",
  	"wedo2.whenTilted": "ko je nagnjen %1",
  	"wedo2.isTilted": "nagnjen %1?",
  	"wedo2.getTiltAngle": "kot nagiba %1",
  	"gdxfor.whenGesture": "ko je %1",
  	"gdxfor.whenForcePushedOrPulled": "ko je senzor sile %1",
  	"gdxfor.getForce": "moč",
  	"gdxfor.whenTilted": "ko je nagnjeno %1",
  	"gdxfor.isTilted": "nagnjeno %1?",
  	"gdxfor.getTilt": "kot nagiba %1",
  	"gdxfor.isFreeFalling": "padajoč?",
  	"gdxfor.getSpin": "hitrost vrtenja %1",
  	"gdxfor.getAcceleration": "pospešek %1",
  	"boost.motorOnFor": "vklopi %1 za %2 sekund",
  	"boost.motorOnForRotation": "vklopi motor %1 za %2 obratov",
  	"boost.motorOn": "vklopi motor %1",
  	"boost.motorOff": "izklopi motor %1",
  	"boost.setMotorPower": "motorju %1 nastavi moč na %2 %",
  	"boost.setMotorDirection": "nastavi smer motorja %1 na %2",
  	"boost.getMotorPosition": "položaj motorja %1",
  	"boost.whenColor": "ko vidiš kocko, ki je %1",
  	"boost.seeingColor": "vidiš kocko, ki je %1 ?",
  	"boost.whenTilted": "ko je nagnjen %1",
  	"boost.getTiltAngle": "kot nagiba %1",
  	"boost.setLightHue": "nastavi barvo svetlobe na %1"
  };
  var dropdowns$d = {
  };
  var ignorelt$d = [
  ];
  var soundEffects$d = [
  	"višina tona",
  	"premik levo/desno"
  ];
  var microbitWhen$d = [
  	"premaknjeno",
  	"streseno",
  	"poskok"
  ];
  var osis$d = [
  	"ostale ukaze za ta lik"
  ];
  var definePrefix$d = [
  	"definiraj"
  ];
  var defineSuffix$d = [
  ];
  var palette$d = {
  	Motion: "Gibanje",
  	Looks: "Videzi",
  	Sound: "Zvok",
  	Events: "Dogodki",
  	Control: "Krmiljenje",
  	Sensing: "Zaznavanje",
  	Operators: "Operatorji",
  	Variables: "Spremenljivke",
  	"My Blocks": "Moji bloki"
  };
  var math$d = [
  	"absolutna vrednost",
  	"zaokroženo navzdol",
  	"zaokroženo navzgor",
  	"kvadratni koren",
  	"sin",
  	"cos",
  	"tg",
  	"arcsin",
  	"arccos",
  	"arctg",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$d = {
  	"obrni se za %1 stopinj v levo": "MOTION_TURNLEFT",
  	"obrni se za %1 stopinj v desno": "MOTION_TURNRIGHT",
  	"ko je kliknjena zelena zastavica": "EVENT_WHENFLAGCLICKED",
  	ustavi: "scratchblocks:end"
  };
  var name$d = "Slovenščina";
  var percentTranslated$d = 100;
  var sl = {
  	commands: commands$d,
  	dropdowns: dropdowns$d,
  	ignorelt: ignorelt$d,
  	soundEffects: soundEffects$d,
  	microbitWhen: microbitWhen$d,
  	osis: osis$d,
  	definePrefix: definePrefix$d,
  	defineSuffix: defineSuffix$d,
  	palette: palette$d,
  	math: math$d,
  	aliases: aliases$d,
  	name: name$d,
  	percentTranslated: percentTranslated$d
  };

  var commands$c = {
  	MOTION_MOVESTEPS: "иди %1 корака",
  	MOTION_TURNRIGHT: "окрет @turnRight за %1 степени",
  	MOTION_TURNLEFT: "окрет @turnLeft за %1 степени",
  	MOTION_POINTINDIRECTION: "усмери се ка %1",
  	MOTION_POINTTOWARDS: "усмери се ка %1",
  	MOTION_GOTOXY: "иди до x: %1 y: %2",
  	MOTION_GOTO: "иди до %1",
  	MOTION_GLIDESECSTOXY: "клизи %1 секунди до x: %2 y: %3",
  	MOTION_GLIDETO: "клизи %1 секунди до %2",
  	MOTION_CHANGEXBY: "промени x за %1",
  	MOTION_SETX: "нека x буде %1",
  	MOTION_CHANGEYBY: "промени y за %1",
  	MOTION_SETY: "нека y буде %1",
  	MOTION_SETROTATIONSTYLE: "подеси начин окретања %1",
  	LOOKS_SAYFORSECS: "изговори %1 током %2 секунде",
  	LOOKS_SAY: "изговори %1",
  	LOOKS_THINKFORSECS: "замисли %1 током %2 секунде",
  	LOOKS_THINK: "замисли %1",
  	LOOKS_SHOW: "прикажи",
  	LOOKS_HIDE: "сакриј",
  	LOOKS_SWITCHCOSTUMETO: "замени костим са %1",
  	LOOKS_NEXTCOSTUME: "следећи костим",
  	LOOKS_NEXTBACKDROP_BLOCK: "следећа позадина",
  	LOOKS_SWITCHBACKDROPTO: "промени позадину у %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "промени позадину у %1 и чекај",
  	LOOKS_CHANGEEFFECTBY: "промени ефекат %1 за %2",
  	LOOKS_SETEFFECTTO: "нека ефекат %1 буде %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "уклони графичке ефекте",
  	LOOKS_CHANGESIZEBY: "промени величину за %1",
  	LOOKS_SETSIZETO: "нека величина буде %1 %",
  	LOOKS_GOTOFRONTBACK: "иди на %1 слој",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "иди %1 %2 слоја",
  	SOUND_PLAY: "покрени звук %1",
  	SOUND_CHANGEEFFECTBY: "промени ефекат %1 за %2",
  	SOUND_SETEFFECTO: "нека ефекат %1 буде %2",
  	SOUND_CLEAREFFECTS: "уклони звучне ефекте",
  	SOUND_PLAYUNTILDONE: "репродукуј звук %1 до краја",
  	SOUND_STOPALLSOUNDS: "заустави све звукове",
  	"music.playDrumForBeats": "удараљка %1 током %2 откуцаја",
  	"music.restForBeats": "пауза %1 откуцаја",
  	"music.playNoteForBeats": "свирај ноту %1 током %2 откуцаја",
  	"music.setInstrument": "нека инструмент буде %1",
  	SOUND_CHANGEVOLUMEBY: "промени јачину звука за %1",
  	SOUND_SETVOLUMETO: "нека јачина звука буде %1%",
  	"music.changeTempo": "промени темпо за %1",
  	"music.setTempo": "нека темпо буде %1",
  	"pen.clear": "обриши све",
  	"pen.stamp": "печат",
  	"pen.penDown": "спусти оловку",
  	"pen.penUp": "подигни оловку",
  	"pen.setColor": "нека боја оловке буде %1",
  	"pen.changeHue": "промени боју оловке за %1",
  	"pen.setColorParam": "нека %1 оловке буде %2",
  	"pen.changeColorParam": "промени %1 оловке за %2",
  	"pen.setHue": "нека боја оловке буде %1",
  	"pen.changeShade": "промени сенку оловке за %1",
  	"pen.setShade": "нека сенка оловке буде %1",
  	"pen.changeSize": "промени дебљину оловке за %1",
  	"pen.setSize": "нека дебљина оловке буде %1",
  	EVENT_WHENFLAGCLICKED: "када је кликнуто на @greenFlag",
  	EVENT_WHENKEYPRESSED: "када је дирка %1 притиснута",
  	EVENT_WHENTHISSPRITECLICKED: "када је кликнуто на овај лик",
  	EVENT_WHENSTAGECLICKED: "када је кликнуто на позорницу",
  	EVENT_WHENBACKDROPSWITCHESTO: "када се позадина промени у %1",
  	EVENT_WHENGREATERTHAN: "када је %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "када примим %1",
  	EVENT_BROADCAST: "разгласи %1",
  	EVENT_BROADCASTANDWAIT: "разгласи %1 и чекај",
  	CONTROL_WAIT: "чекај %1 секунду",
  	CONTROL_REPEAT: "понови %1",
  	CONTROL_FOREVER: "понављај заувек",
  	CONTROL_IF: "ако је %1 онда",
  	CONTROL_WAITUNTIL: "чекај док не %1",
  	CONTROL_REPEATUNTIL: "понављај до %1",
  	CONTROL_STOP: "заустави %1",
  	CONTROL_STARTASCLONE: "када се појавим као умножак",
  	CONTROL_CREATECLONEOF: "направи дупликат од %1",
  	CONTROL_DELETETHISCLONE: "обриши овај умножак",
  	SENSING_ASKANDWAIT: "питај %1 и чекај",
  	"videoSensing.videoToggle": "нека видео буде %1",
  	"videoSensing.setVideoTransparency": "нека провидност видеа буде  %1",
  	"videoSensing.whenMotionGreaterThan": "када је кретање видеа > %1",
  	SENSING_RESETTIMER: "постави тајмер на 0",
  	DATA_SETVARIABLETO: "нека %1 буде %2",
  	DATA_CHANGEVARIABLEBY: "промени %1 за %2",
  	DATA_SHOWVARIABLE: "прикажи променљиву %1",
  	DATA_HIDEVARIABLE: "сакриј променљиву %1",
  	DATA_ADDTOLIST: "додај %1 у %2",
  	DATA_DELETEOFLIST: "обриши %1 из %2",
  	DATA_DELETEALLOFLIST: "обриши све из %1",
  	MOTION_IFONEDGEBOUNCE: "ако си на рубу, окрени се",
  	DATA_INSERTATLIST: "убаци %1 на %2 у %3",
  	DATA_REPLACEITEMOFLIST: "замени елемент %1 у %2 са %3",
  	DATA_SHOWLIST: "прикажи листу %1",
  	DATA_HIDELIST: "сакриј листу %1",
  	SENSING_OF_XPOSITION: "x положај",
  	SENSING_OF_YPOSITION: "y положај",
  	SENSING_OF_DIRECTION: "смер",
  	SENSING_OF_COSTUMENUMBER: "број костима",
  	LOOKS_COSTUMENUMBERNAME: "костим %1",
  	SENSING_OF_SIZE: "величина",
  	SENSING_OF_BACKDROPNAME: "име позадине",
  	LOOKS_BACKDROPNUMBERNAME: "позадина %1",
  	SENSING_OF_BACKDROPNUMBER: "број позадине",
  	SOUND_VOLUME: "јачина звука",
  	"music.getTempo": "темпо",
  	SENSING_TOUCHINGOBJECT: "додирује ли %1?",
  	SENSING_TOUCHINGCOLOR: "додирује ли боју %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "боја %1 додирује %2?",
  	SENSING_DISTANCETO: "удаљеност од %1",
  	SENSING_ANSWER: "одговор",
  	SENSING_KEYPRESSED: "дугме %1 је притиснуто?",
  	SENSING_MOUSEDOWN: "миш притиснут?",
  	SENSING_MOUSEX: "миш x",
  	SENSING_MOUSEY: "миш y",
  	SENSING_SETDRAGMODE: "нека начин превлачења буде %1",
  	SENSING_LOUDNESS: "јачина звука",
  	"videoSensing.videoOn": "видео %1 на %2",
  	SENSING_TIMER: "тајмер",
  	SENSING_OF: "%1 од %2",
  	SENSING_CURRENT: "тренутно %1",
  	SENSING_DAYSSINCE2000: "дана после 2000",
  	SENSING_USERNAME: "корисничко име",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "случајан број од %1 до %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 и %2",
  	OPERATORS_OR: "%1 или %2",
  	OPERATORS_NOT: "није %1",
  	OPERATORS_JOIN: "споји %1 и %2",
  	OPERATORS_LETTEROF: "%1 слово од %2",
  	OPERATORS_LENGTH: "дужина %1",
  	OPERATORS_MOD: "%1 мод %2",
  	OPERATORS_ROUND: "заокружи %1",
  	OPERATORS_MATHOP: "%1 од %2",
  	OPERATORS_CONTAINS: "%1 садржи %2",
  	DATA_ITEMOFLIST: "елемент %1 из %2",
  	DATA_ITEMNUMOFLIST: "место од %1 у %2",
  	DATA_LENGTHOFLIST: "дужина %1",
  	DATA_LISTCONTAINSITEM: "да ли %1 садржи %2?",
  	CONTROL_ELSE: "у супротном",
  	SENSING_USERID: "корисников ид",
  	SENSING_LOUD: "гласно?",
  	"text2speech.speakAndWaitBlock": "изговори %1",
  	"text2speech.setVoiceBlock": "нека глас буде %1",
  	"text2speech.setLanguageBlock": "нека језик буде %1",
  	"translate.translateBlock": "преведи %1 на %2",
  	"translate.viewerLanguage": "језик",
  	"makeymakey.whenKeyPressed": "када је дирка %1 притиснута",
  	"makeymakey.whenKeysPressedInOrder": "када је %1 притиснуто по реду",
  	"microbit.whenButtonPressed": "када је %1 дугме притиснуто",
  	"microbit.isButtonPressed": "%1 дугме притиснуто?",
  	"microbit.whenGesture": "када је %1",
  	"microbit.displaySymbol": "прикажи %1",
  	"microbit.displayText": "прикажи текст %1",
  	"microbit.clearDisplay": "обриши екран",
  	"microbit.whenTilted": "када је нагнуто %1",
  	"microbit.isTilted": "нагнуто %1?",
  	"microbit.tiltAngle": "угао нагиба %1",
  	"microbit.whenPinConnected": "када је пин %1 повезан",
  	"ev3.motorTurnClockwise": "мотор %1: окрени овако током %2 секунди",
  	"ev3.motorTurnCounterClockwise": "мотор %1: окрени овако током %2 секунди",
  	"ev3.motorSetPower": "мотор %1: подеси снагу %2 %",
  	"ev3.getMotorPosition": "мотор %1: место",
  	"ev3.whenButtonPressed": "када је дугме %1 притиснуто",
  	"ev3.whenDistanceLessThan": "када је растојање < %1",
  	"ev3.whenBrightnessLessThan": "кад је осветљеност < %1",
  	"ev3.buttonPressed": "дугме %1 је притиснуто?",
  	"ev3.getDistance": "растојање",
  	"ev3.getBrightness": "осветљеност",
  	"ev3.beepNote": "изведи ноту %1 током %2 секунди",
  	"wedo2.motorOn": "укључи %1",
  	"wedo2.motorOff": "искључи %1",
  	"wedo2.startMotorPower": "подеси снагу %1 на %2",
  	"wedo2.setMotorDirection": "подеси смер %1 у %2",
  	"wedo2.whenDistance": "када је растојање %1 од %2",
  	"wedo2.getDistance": "растојање",
  	"wedo2.motorOnFor": "укључи %1 током %2 секунди",
  	"wedo2.setLightHue": "подеси боју светлости на %1",
  	"wedo2.playNoteFor": "свирај ноту %1 током %2 секунди",
  	"wedo2.whenTilted": "када је нагнуто %1",
  	"wedo2.isTilted": "нагнуто %1?",
  	"wedo2.getTiltAngle": "угао нагиба %1",
  	"gdxfor.whenGesture": "када је %1",
  	"gdxfor.whenForcePushedOrPulled": "када је сензор силе %1",
  	"gdxfor.getForce": "сила",
  	"gdxfor.whenTilted": "када је нагнуто %1",
  	"gdxfor.isTilted": "нагнуто %1?",
  	"gdxfor.getTilt": "угао нагиба %1",
  	"gdxfor.isFreeFalling": "пада?",
  	"gdxfor.getSpin": "брзина обртања %1",
  	"gdxfor.getAcceleration": "убрзање %1",
  	"boost.motorOnFor": "укључи мотор %1 током %2 секунди",
  	"boost.motorOnForRotation": "укључи мотор %1 током %2 окрета",
  	"boost.motorOn": "укључи мотор %1",
  	"boost.motorOff": "искључи мотор %1",
  	"boost.setMotorPower": "подеси брзину мотора %1 на %2 %",
  	"boost.setMotorDirection": "подеси смер мотора %1: %2",
  	"boost.getMotorPosition": "место мотора %1",
  	"boost.whenColor": "када је цигла боје %1 виђена",
  	"boost.seeingColor": "виђена је %1 цигла?",
  	"boost.whenTilted": "када је нагнуто %1",
  	"boost.getTiltAngle": "угао нагиба %1",
  	"boost.setLightHue": "подеси боју светлости на %1"
  };
  var dropdowns$c = {
  };
  var ignorelt$c = [
  ];
  var soundEffects$c = [
  	"висина тона",
  	"померање лево/десно"
  ];
  var microbitWhen$c = [
  	"померен",
  	"протресен",
  	"скок"
  ];
  var osis$c = [
  	"друге програме лика"
  ];
  var definePrefix$c = [
  	"дефиниши"
  ];
  var defineSuffix$c = [
  ];
  var palette$c = {
  	Motion: "Кретање",
  	Looks: "Изглед",
  	Sound: "Звук",
  	Events: "Догађаји",
  	Control: "Управљање",
  	Sensing: "Осећаји",
  	Operators: "Оператори",
  	Variables: "Променљиве",
  	"My Blocks": "Моји блокови"
  };
  var math$c = [
  	"абс",
  	"цео део",
  	"цео+1",
  	"корен",
  	"sin",
  	"cos",
  	"tg",
  	"arcsin",
  	"arccos",
  	"arctan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$c = {
  };
  var name$c = "Српски";
  var percentTranslated$c = 100;
  var sr = {
  	commands: commands$c,
  	dropdowns: dropdowns$c,
  	ignorelt: ignorelt$c,
  	soundEffects: soundEffects$c,
  	microbitWhen: microbitWhen$c,
  	osis: osis$c,
  	definePrefix: definePrefix$c,
  	defineSuffix: defineSuffix$c,
  	palette: palette$c,
  	math: math$c,
  	aliases: aliases$c,
  	name: name$c,
  	percentTranslated: percentTranslated$c
  };

  var commands$b = {
  	MOTION_MOVESTEPS: "gå %1 steg",
  	MOTION_TURNRIGHT: "rotera @turnRight %1 grader",
  	MOTION_TURNLEFT: "rotera @turnLeft %1 grader",
  	MOTION_POINTINDIRECTION: "peka i riktning %1",
  	MOTION_POINTTOWARDS: "peka mot %1",
  	MOTION_GOTOXY: "gå till x: %1 y: %2",
  	MOTION_GOTO: "gå till %1",
  	MOTION_GLIDESECSTOXY: "glid %1 sek till x: %2 y: %3",
  	MOTION_GLIDETO: "glid %1 sekunder till %2",
  	MOTION_CHANGEXBY: "ändra x med %1",
  	MOTION_SETX: "sätt x till %1",
  	MOTION_CHANGEYBY: "ändra y med %1",
  	MOTION_SETY: "sätt y till %1",
  	MOTION_SETROTATIONSTYLE: "sätt rotationsstil %1",
  	LOOKS_SAYFORSECS: "säg %1 i %2 sekunder",
  	LOOKS_SAY: "säg %1",
  	LOOKS_THINKFORSECS: "tänk %1 i %2 sekunder",
  	LOOKS_THINK: "tänk %1",
  	LOOKS_SHOW: "visa",
  	LOOKS_HIDE: "göm",
  	LOOKS_SWITCHCOSTUMETO: "ändra klädsel till %1",
  	LOOKS_NEXTCOSTUME: "nästa klädsel",
  	LOOKS_NEXTBACKDROP_BLOCK: "nästa bakgrund",
  	LOOKS_SWITCHBACKDROPTO: "växla bakgrund till %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "byt bakgrund till %1 och vänta",
  	LOOKS_CHANGEEFFECTBY: "ändra %1 effekten med %2",
  	LOOKS_SETEFFECTTO: "sätt %1 effekten till %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "ta bort grafisk effekt",
  	LOOKS_CHANGESIZEBY: "ändra storlek med %1",
  	LOOKS_SETSIZETO: "sätt storleken till %1 %",
  	LOOKS_GOTOFRONTBACK: "gå till %1 lagret",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "gå %1 %2 lager",
  	SOUND_PLAY: "starta ljud %1",
  	SOUND_CHANGEEFFECTBY: "ändra %1 effekten med %2",
  	SOUND_SETEFFECTO: "sätt %1 effekten till %2",
  	SOUND_CLEAREFFECTS: "ta bort ljudeffekter",
  	SOUND_PLAYUNTILDONE: "spela ljudet %1 tills färdigt",
  	SOUND_STOPALLSOUNDS: "stoppa alla ljud",
  	"music.playDrumForBeats": "spela trumma %1i %2 takter",
  	"music.restForBeats": "pausa i %1takter",
  	"music.playNoteForBeats": "spela not %1i %2takter",
  	"music.setInstrument": "sätt instrument till %1",
  	SOUND_CHANGEVOLUMEBY: "ändra volymen med %1",
  	SOUND_SETVOLUMETO: "sätt volymen till %1%",
  	"music.changeTempo": "ändra tempo med %1",
  	"music.setTempo": "sätt tempo till %1",
  	"pen.clear": "radera allt",
  	"pen.stamp": "stämpla",
  	"pen.penDown": "penna ned",
  	"pen.penUp": "penna upp",
  	"pen.setColor": "sätt pennans färg %1",
  	"pen.changeHue": "ändra pennans färg med %1",
  	"pen.setColorParam": "sätt penna %1till %2",
  	"pen.changeColorParam": "ändra pennans %1med %2",
  	"pen.setHue": "sätt pennans färg till %1",
  	"pen.changeShade": "ändra pennans skugga med %1",
  	"pen.setShade": "sätt pennans skugga till %1",
  	"pen.changeSize": "ändra pennans storlek med %1",
  	"pen.setSize": "sätt pennans storlek %1",
  	EVENT_WHENFLAGCLICKED: "när @greenFlag klickas på",
  	EVENT_WHENKEYPRESSED: "när tangenten %1 trycks ned",
  	EVENT_WHENTHISSPRITECLICKED: "när denna sprajt klickas på",
  	EVENT_WHENSTAGECLICKED: "när scenen klickas på",
  	EVENT_WHENBACKDROPSWITCHESTO: "när bakgrunden växlar till %1",
  	EVENT_WHENGREATERTHAN: "när %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "när jag tar emot %1",
  	EVENT_BROADCAST: "skicka %1",
  	EVENT_BROADCASTANDWAIT: "skicka %1 och vänta",
  	CONTROL_WAIT: "vänta %1 sekunder",
  	CONTROL_REPEAT: "repetera %1",
  	CONTROL_FOREVER: "för alltid",
  	CONTROL_IF: "om %1 då",
  	CONTROL_WAITUNTIL: "vänta tills %1",
  	CONTROL_REPEATUNTIL: "repetera tills %1",
  	CONTROL_STOP: "stoppa %1",
  	CONTROL_STARTASCLONE: "när jag startar som klon",
  	CONTROL_CREATECLONEOF: "skapa klon av %1",
  	CONTROL_DELETETHISCLONE: "radera klonen",
  	SENSING_ASKANDWAIT: "fråga %1 och vänta",
  	"videoSensing.videoToggle": "sätt video till %1",
  	"videoSensing.setVideoTransparency": "sätt videotransparens till %1",
  	"videoSensing.whenMotionGreaterThan": "när videorörelse > %1",
  	SENSING_RESETTIMER: "nollställ timer",
  	DATA_SETVARIABLETO: "sätt %1 till %2",
  	DATA_CHANGEVARIABLEBY: "ändra %1 med %2",
  	DATA_SHOWVARIABLE: "visa variabel %1",
  	DATA_HIDEVARIABLE: "göm variabel %1",
  	DATA_ADDTOLIST: "lägg till %1 i %2",
  	DATA_DELETEOFLIST: "ta bort %1 från %2",
  	DATA_DELETEALLOFLIST: "ta bort alla %1",
  	MOTION_IFONEDGEBOUNCE: "om vid kanten, studsa",
  	DATA_INSERTATLIST: "infoga %1 vid %2 i %3",
  	DATA_REPLACEITEMOFLIST: "ersätt posten %1 i %2 med %3",
  	DATA_SHOWLIST: "visa listan %1",
  	DATA_HIDELIST: "göm listan %1",
  	SENSING_OF_XPOSITION: "x position",
  	SENSING_OF_YPOSITION: "y position",
  	SENSING_OF_DIRECTION: "riktning",
  	SENSING_OF_COSTUMENUMBER: "klädselnummer",
  	LOOKS_COSTUMENUMBERNAME: "klädsel %1",
  	SENSING_OF_SIZE: "storlek",
  	SENSING_OF_BACKDROPNAME: "bakgrundsnamn",
  	LOOKS_BACKDROPNUMBERNAME: "bakgrund %1",
  	SENSING_OF_BACKDROPNUMBER: "bakgrundsnummer",
  	SOUND_VOLUME: "volym",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "rör vid %1?",
  	SENSING_TOUCHINGCOLOR: "rör vid färgen %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "rör färgen %1 vid %2?",
  	SENSING_DISTANCETO: "avstånd till %1",
  	SENSING_ANSWER: "svar",
  	SENSING_KEYPRESSED: "tangent %1 nedtryckt?",
  	SENSING_MOUSEDOWN: "musknappen nedtryckt?",
  	SENSING_MOUSEX: "mus x",
  	SENSING_MOUSEY: "mus y",
  	SENSING_SETDRAGMODE: "sätt dragläge %1",
  	SENSING_LOUDNESS: "ljudstyrka",
  	"videoSensing.videoOn": "video %1på %2",
  	SENSING_TIMER: "timer",
  	SENSING_OF: "%1 av %2",
  	SENSING_CURRENT: "aktuell %1",
  	SENSING_DAYSSINCE2000: "dagar sedan år 2000",
  	SENSING_USERNAME: "användarnamn",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "slumptal %1 till %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 och %2",
  	OPERATORS_OR: "%1 eller %2",
  	OPERATORS_NOT: "inte %1",
  	OPERATORS_JOIN: "sammanfoga %1 %2",
  	OPERATORS_LETTEROF: "bokstav %1 av %2",
  	OPERATORS_LENGTH: "längden av %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "avrunda %1",
  	OPERATORS_MATHOP: "%1 av %2",
  	OPERATORS_CONTAINS: "%1 innehåller %2",
  	DATA_ITEMOFLIST: "post %1 i %2",
  	DATA_ITEMNUMOFLIST: "post # av %1 i %2",
  	DATA_LENGTHOFLIST: "längden av %1",
  	DATA_LISTCONTAINSITEM: "%1 innehåller %2",
  	CONTROL_ELSE: "annars",
  	SENSING_USERID: "användarnamn",
  	SENSING_LOUD: "högt ljud?",
  	"text2speech.speakAndWaitBlock": "säg %1",
  	"text2speech.setVoiceBlock": "sätt röst till %1",
  	"text2speech.setLanguageBlock": "sätt språk till %1",
  	"translate.translateBlock": "översätt %1 till %2",
  	"translate.viewerLanguage": "språk",
  	"makeymakey.whenKeyPressed": "när %1 tangenten trycks ned",
  	"makeymakey.whenKeysPressedInOrder": "när %1 trycks ned efter varandra",
  	"microbit.whenButtonPressed": "om knapp %1 trycks ned",
  	"microbit.isButtonPressed": "%1 knappen nedtryckt?",
  	"microbit.whenGesture": "om %1",
  	"microbit.displaySymbol": "visa %1",
  	"microbit.displayText": "visa text %1",
  	"microbit.clearDisplay": "rensa skärmen",
  	"microbit.whenTilted": "om lutar %1",
  	"microbit.isTilted": "luta %1?",
  	"microbit.tiltAngle": "luta riktning %1",
  	"microbit.whenPinConnected": "När pin %1 är kopplad",
  	"ev3.motorTurnClockwise": "motor %1 rotera medsols i %2 sekunder",
  	"ev3.motorTurnCounterClockwise": "motor %1 rotera motsols i %2 sekunder",
  	"ev3.motorSetPower": "motor %1 sätt kraft %2 %",
  	"ev3.getMotorPosition": "motor %1 position",
  	"ev3.whenButtonPressed": "när knapp %1 trycks ned",
  	"ev3.whenDistanceLessThan": "när avstånd < %1",
  	"ev3.whenBrightnessLessThan": "om ljusstyrka < %1",
  	"ev3.buttonPressed": "knapp %1 nedtryckt?",
  	"ev3.getDistance": "avstånd",
  	"ev3.getBrightness": "ljusstyrka",
  	"ev3.beepNote": "spela ton %1 i %2sekunder",
  	"wedo2.motorOn": "starta %1",
  	"wedo2.motorOff": "stoppa %1",
  	"wedo2.startMotorPower": "sätt kraften på %1 till %2",
  	"wedo2.setMotorDirection": "sätt %1 riktning till %2",
  	"wedo2.whenDistance": "om avstånd %1 %2",
  	"wedo2.getDistance": "avstånd",
  	"wedo2.motorOnFor": "starta %1 i %2 sekunder",
  	"wedo2.setLightHue": "sätt ljusets färg till %1",
  	"wedo2.playNoteFor": "spela ton %1 i %2 sekunder",
  	"wedo2.whenTilted": "om lutar %1",
  	"wedo2.isTilted": "lutar %1 ?",
  	"wedo2.getTiltAngle": "lutningsvinkel %1",
  	"gdxfor.whenGesture": "om %1",
  	"gdxfor.whenForcePushedOrPulled": "när kraftsensorn %1",
  	"gdxfor.getForce": "kraft",
  	"gdxfor.whenTilted": "när lutar %1",
  	"gdxfor.isTilted": "lutar %1?",
  	"gdxfor.getTilt": "lutningsvinkel %1",
  	"gdxfor.isFreeFalling": "fritt fall?",
  	"gdxfor.getSpin": "rotationshastighet %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "vrid motor %1 i %2 sekunder",
  	"boost.motorOnForRotation": "vrid motor %1 i %2 rotationer",
  	"boost.motorOn": "vrid motor %1 på",
  	"boost.motorOff": "vrid motor %1 av",
  	"boost.setMotorPower": "sätt motor %1 hastighet till %2 %",
  	"boost.setMotorDirection": "sätt motor %1 riktning %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "när %1 kloss upptäcks",
  	"boost.seeingColor": "ser %1 kloss?",
  	"boost.whenTilted": "om lutar %1",
  	"boost.getTiltAngle": "lutningsvinkel %1",
  	"boost.setLightHue": "sätt ljusets färg till %1"
  };
  var dropdowns$b = {
  };
  var ignorelt$b = [
  ];
  var soundEffects$b = [
  	"tonhöjd",
  	"panorera vänster/höger"
  ];
  var microbitWhen$b = [
  	"rör sig",
  	"skaka",
  	"hoppa"
  ];
  var osis$b = [
  	"andra skript i sprajten"
  ];
  var definePrefix$b = [
  	"definiera"
  ];
  var defineSuffix$b = [
  ];
  var palette$b = {
  	Motion: "Rörelse",
  	Looks: "Utseende",
  	Sound: "Ljud",
  	Events: "Händelser",
  	Control: "Kontroll",
  	Sensing: "Känna av",
  	Operators: "Operatorer",
  	Variables: "Variabler",
  	"My Blocks": "Mina block"
  };
  var math$b = [
  	"abs",
  	"golv",
  	"tak",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$b = {
  };
  var name$b = "Svenska";
  var percentTranslated$b = 100;
  var sv = {
  	commands: commands$b,
  	dropdowns: dropdowns$b,
  	ignorelt: ignorelt$b,
  	soundEffects: soundEffects$b,
  	microbitWhen: microbitWhen$b,
  	osis: osis$b,
  	definePrefix: definePrefix$b,
  	defineSuffix: defineSuffix$b,
  	palette: palette$b,
  	math: math$b,
  	aliases: aliases$b,
  	name: name$b,
  	percentTranslated: percentTranslated$b
  };

  var commands$a = {
  	MOTION_MOVESTEPS: "songa hatua %1",
  	MOTION_TURNRIGHT: "zunguka digrii @turnRight %1",
  	MOTION_TURNLEFT: "zunguka digrii @turnLeft %1",
  	MOTION_POINTINDIRECTION: "elekeza kwa mwelekeo %1",
  	MOTION_POINTTOWARDS: "elekea %1",
  	MOTION_GOTOXY: "enda kwa x: %1 y: %2",
  	MOTION_GOTO: "enda kwa %1",
  	MOTION_GLIDESECSTOXY: "teleza %1 sekunde hadi x: %2 y: %3",
  	MOTION_GLIDETO: "teleza sekunde %1 hadi %2",
  	MOTION_CHANGEXBY: "badilisha x kwa %1",
  	MOTION_SETX: "weka x kuwa %1",
  	MOTION_CHANGEYBY: "badilisha y kwa %1",
  	MOTION_SETY: "weka y kuwa %1",
  	MOTION_SETROTATIONSTYLE: "weka mtindo wa mzunguko %1",
  	LOOKS_SAYFORSECS: "sema %1 kwa sekunde %2",
  	LOOKS_SAY: "sema %1",
  	LOOKS_THINKFORSECS: "fikiria %1 kwa sekunde %2",
  	LOOKS_THINK: "fikiria %1",
  	LOOKS_SHOW: "onyesha",
  	LOOKS_HIDE: "ficha",
  	LOOKS_SWITCHCOSTUMETO: "badilisha mtindo kuwa %1",
  	LOOKS_NEXTCOSTUME: "mtindo ufuatao",
  	LOOKS_NEXTBACKDROP_BLOCK: "mandhari ya nyuma ifuatayo",
  	LOOKS_SWITCHBACKDROPTO: "badilisha mandhari ya nyuma iwe %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "badilisha mandhari ya nyuma kuwa %1 na subiri",
  	LOOKS_CHANGEEFFECTBY: "badilisha athari ya %1 kwa %2",
  	LOOKS_SETEFFECTTO: "weka athari ya %1 iwe %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "futa athari za picha",
  	LOOKS_CHANGESIZEBY: "badilisha ukubwa kwa %1",
  	LOOKS_SETSIZETO: "weka ukubwa uwe %1",
  	LOOKS_GOTOFRONTBACK: "enda kwa safu ya %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 kwa safu ya %2",
  	SOUND_PLAY: "anza sauti %1",
  	SOUND_CHANGEEFFECTBY: "badilisha athari ya %1 kwa %2",
  	SOUND_SETEFFECTO: "weka athari ya %1 kuwa %2",
  	SOUND_CLEAREFFECTS: "futa athari zote za sauti",
  	SOUND_PLAYUNTILDONE: "cheza sauti %1 hadi ikamilike",
  	SOUND_STOPALLSOUNDS: "komesha sauti zote",
  	"music.playDrumForBeats": "cheza ngoma %1 kwa midundo %2",
  	"music.restForBeats": "pumzika kwa midundo %1",
  	"music.playNoteForBeats": "cheza noti %1 kwa midundo %2",
  	"music.setInstrument": "weka ala ya muziki kuwa %1",
  	SOUND_CHANGEVOLUMEBY: "badilisha kiasi ya sauti kwa %1",
  	SOUND_SETVOLUMETO: "weka kiasi ya sauti kuwa %1%",
  	"music.changeTempo": "badilisha tempo kwa %1",
  	"music.setTempo": "weka tempo kuwa %1",
  	"pen.clear": "futa yote",
  	"pen.stamp": "muhuri",
  	"pen.penDown": "kalamu chini",
  	"pen.penUp": "kalamu juu",
  	"pen.setColor": "weka rangi ya kalamu kuwa %1",
  	"pen.changeHue": "badilisha rangi ya kalamu kwa %1",
  	"pen.setColorParam": "weka %1 kuwa %2",
  	"pen.changeColorParam": "badilisha %1 kwa %2",
  	"pen.setHue": "weka rangi ya kalamu kuwa %1",
  	"pen.changeShade": "badilisha namna ya rangi ya kalamu kwa %1",
  	"pen.setShade": "weka namna ya rangi ya kalamu kuwa %1",
  	"pen.changeSize": "badilisha ukubwa wa kalamu kwa %1",
  	"pen.setSize": "weka ukubwa wa kalamu kuwa %1",
  	EVENT_WHENFLAGCLICKED: "wakati @greenFlag inapobonyezwa",
  	EVENT_WHENKEYPRESSED: "wakati kitufe cha %1 kinapobonyezwa",
  	EVENT_WHENTHISSPRITECLICKED: "wakati kihusika hiki kinapobonyezwa",
  	EVENT_WHENSTAGECLICKED: "wakati jukwaa linapobonyezwa",
  	EVENT_WHENBACKDROPSWITCHESTO: "mandhari ya nyuma itakapobadilika kuwa %1",
  	EVENT_WHENGREATERTHAN: "wakati %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "wakati ninapopokea %1",
  	EVENT_BROADCAST: "tangaza %1",
  	EVENT_BROADCASTANDWAIT: "tangaza %1 na usubiri",
  	CONTROL_WAIT: "subiri sekunde %1",
  	CONTROL_REPEAT: "rudia %1",
  	CONTROL_FOREVER: "milele",
  	CONTROL_IF: "ikiwa %1 basi",
  	CONTROL_WAITUNTIL: "subiri hadi %1",
  	CONTROL_REPEATUNTIL: "rudia hadi %1",
  	CONTROL_STOP: "komesha %1",
  	CONTROL_STARTASCLONE: "nikianza kama kinakili",
  	CONTROL_CREATECLONEOF: "unda kinakili cha %1",
  	CONTROL_DELETETHISCLONE: "futa kinakili hiki",
  	SENSING_ASKANDWAIT: "uliza %1 na subiri",
  	"videoSensing.videoToggle": "video %1",
  	"videoSensing.setVideoTransparency": "weka upenyeko wa nuru kuwa %1",
  	"videoSensing.whenMotionGreaterThan": "wakati mwendo wa video > %1",
  	SENSING_RESETTIMER: "anzisha tena kitunza muda",
  	DATA_SETVARIABLETO: "weka %1 iwe %2",
  	DATA_CHANGEVARIABLEBY: "badilisha %1 kwa %2",
  	DATA_SHOWVARIABLE: "onyesha kibadilika %1",
  	DATA_HIDEVARIABLE: "ficha kibadilika %1",
  	DATA_ADDTOLIST: "ongeza %1 kwa %2",
  	DATA_DELETEOFLIST: "futa %1 kati ya %2",
  	DATA_DELETEALLOFLIST: "futa %1 zote",
  	MOTION_IFONEDGEBOUNCE: "ikiwa kwenye ukingo wa jukwaa, rejesha",
  	DATA_INSERTATLIST: "weka %1 kwa %2 kati ya %3",
  	DATA_REPLACEITEMOFLIST: "badilisha kipengee %1 kati ya %2 na %3",
  	DATA_SHOWLIST: "onyesha orodha %1",
  	DATA_HIDELIST: "ficha orodha %1",
  	SENSING_OF_XPOSITION: "nafasi ya x",
  	SENSING_OF_YPOSITION: "nafasi ya y",
  	SENSING_OF_DIRECTION: "mwelekeo",
  	SENSING_OF_COSTUMENUMBER: "mtindo #",
  	LOOKS_COSTUMENUMBERNAME: "mtindo %1",
  	SENSING_OF_SIZE: "ukubwa",
  	SENSING_OF_BACKDROPNAME: "jina la mandhari ya nyuma",
  	LOOKS_BACKDROPNUMBERNAME: "mandhari ya nyuma %1",
  	SENSING_OF_BACKDROPNUMBER: "mandhari ya nyuma #",
  	SOUND_VOLUME: "kiasi ya sauti",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "inashika %1?",
  	SENSING_TOUCHINGCOLOR: "inashika rangi %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "rangi %1 inashika %2?",
  	SENSING_DISTANCETO: "umbali hadi %1",
  	SENSING_ANSWER: "jibu",
  	SENSING_KEYPRESSED: "kitufe cha %1 kimebonyezwa?",
  	SENSING_MOUSEDOWN: "kipanya chini?",
  	SENSING_MOUSEX: "kipanya x",
  	SENSING_MOUSEY: "kipanya y",
  	SENSING_SETDRAGMODE: "kihusika %1 kuvutwa",
  	SENSING_LOUDNESS: "ukubwa wa sauti",
  	"videoSensing.videoOn": "%1 wa video uwe kwa %2",
  	SENSING_TIMER: "kitunza wakati",
  	SENSING_OF: "%1 kwa %2",
  	SENSING_CURRENT: "sasa hivi %1",
  	SENSING_DAYSSINCE2000: "siku tangu 2000",
  	SENSING_USERNAME: "jina la mtumiaji",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "chagua %1  yoyote hadi %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 na %2",
  	OPERATORS_OR: "%1 au %2",
  	OPERATORS_NOT: "si %1",
  	OPERATORS_JOIN: "unganisha %1 %2",
  	OPERATORS_LETTEROF: "herufi %1 kati ya %2",
  	OPERATORS_LENGTH: "urefu wa %1",
  	OPERATORS_MOD: "%1 mabaki %2",
  	OPERATORS_ROUND: "kadiria %1",
  	OPERATORS_MATHOP: "%1 kati ya %2",
  	OPERATORS_CONTAINS: "%1 ina %2?",
  	DATA_ITEMOFLIST: "kipengee %1 kati ya %2",
  	DATA_ITEMNUMOFLIST: "kipengee # kati ya %1 katika %2",
  	DATA_LENGTHOFLIST: "urefu wa %1",
  	DATA_LISTCONTAINSITEM: "%1 ina %2?",
  	CONTROL_ELSE: "isivyo",
  	SENSING_USERID: "kitambulisho cha mtumiaji",
  	SENSING_LOUD: "kuna sauti kubwa?",
  	"text2speech.speakAndWaitBlock": "sema %1",
  	"text2speech.setVoiceBlock": "weka sauti kuwa %1",
  	"text2speech.setLanguageBlock": "weka lugha kuwa %1",
  	"translate.translateBlock": "tafsiri %1 hadi %2",
  	"translate.viewerLanguage": "lugha",
  	"makeymakey.whenKeyPressed": "kitufe %1 kinapobonyezwa",
  	"makeymakey.whenKeysPressedInOrder": "vitufe vinapobonyezwa kwa utaratibu wa %1",
  	"microbit.whenButtonPressed": "kitufe %1 kinapobonyezwa",
  	"microbit.isButtonPressed": "kitufe %1 kimebonyezwa?",
  	"microbit.whenGesture": "wakati %1",
  	"microbit.displaySymbol": "onyesha %1",
  	"microbit.displayText": "onyesha maandishi %1",
  	"microbit.clearDisplay": "futa skrini",
  	"microbit.whenTilted": "inapoinamishwa %1",
  	"microbit.isTilted": "imeinamishwa %1?",
  	"microbit.tiltAngle": "pembe ya mwinamo %1",
  	"microbit.whenPinConnected": "pini %1 inapounganishwa",
  	"ev3.motorTurnClockwise": "mota %1 kuzunguka hivi kwa sekunde %2",
  	"ev3.motorTurnCounterClockwise": "mota %1 kuzunguka hivyo kwa sekunde %2",
  	"ev3.motorSetPower": "weka nguvu ya mota %1 kuwa %2 %",
  	"ev3.getMotorPosition": "nafasi ya mota %1",
  	"ev3.whenButtonPressed": "kitufe %1 kinapobonyezwa",
  	"ev3.whenDistanceLessThan": "mwelekeo unapokuwa < %1",
  	"ev3.whenBrightnessLessThan": "wakati mng'aro < %1",
  	"ev3.buttonPressed": "kitufe cha %1 kimebonyezwa?",
  	"ev3.getDistance": "umbali",
  	"ev3.getBrightness": "mng'aro",
  	"ev3.beepNote": "cheza noti %1 kwa sekunde %2",
  	"wedo2.motorOn": "washa %1",
  	"wedo2.motorOff": "zima %1",
  	"wedo2.startMotorPower": "weka nguvu ya %1 kuwa %2",
  	"wedo2.setMotorDirection": "weka mwelekeo wa %1 kuwa %2",
  	"wedo2.whenDistance": "wakati mwelekeo %1 %2",
  	"wedo2.getDistance": "umbali",
  	"wedo2.motorOnFor": "washa %1 kwa sekunde %2",
  	"wedo2.setLightHue": "weka rangi ya mwangaza kuwa %1",
  	"wedo2.playNoteFor": "cheza noti %1 kwa sekunde %2",
  	"wedo2.whenTilted": "inapoinamishwa %1",
  	"wedo2.isTilted": "imeinamishwa %1?",
  	"wedo2.getTiltAngle": "pembe ya mwinamo %1",
  	"gdxfor.whenGesture": "wakati %1",
  	"gdxfor.whenForcePushedOrPulled": "kihisia cha nguvu %1",
  	"gdxfor.getForce": "nguvu",
  	"gdxfor.whenTilted": "inapoinamishwa %1",
  	"gdxfor.isTilted": "imeinamishwa %1?",
  	"gdxfor.getTilt": "pembe ya mwinamo %1",
  	"gdxfor.isFreeFalling": "inaanguka?",
  	"gdxfor.getSpin": "kasi ya mzunguko %1",
  	"gdxfor.getAcceleration": "kasi %1",
  	"boost.motorOnFor": "washa mota %1 kwa sekunde %2",
  	"boost.motorOnForRotation": "washa mota %1 kwa mizunguko %2",
  	"boost.motorOn": "washa mota %1",
  	"boost.motorOff": "zima mota %1",
  	"boost.setMotorPower": "weka kasi ya mota %1 kuwa %2 %",
  	"boost.setMotorDirection": "weka mwelekeo wa mota %1 kuwa %2",
  	"boost.getMotorPosition": "nafasi ya mota %1",
  	"boost.whenColor": "tofali la %1 linapoonekana",
  	"boost.seeingColor": "tofali la %1 inaonekana?",
  	"boost.whenTilted": "inapoinamishwa %1",
  	"boost.getTiltAngle": "pembe ya mwinamo %1",
  	"boost.setLightHue": "weka rangi ya mwangaza kuwa %1"
  };
  var dropdowns$a = {
  };
  var ignorelt$a = [
  ];
  var soundEffects$a = [
  	"uzito wa sauti",
  	"peleka sauti kushoto/kulia"
  ];
  var microbitWhen$a = [
  	"inaposongwa",
  	"inapotikiswa",
  	"inaporushwa"
  ];
  var osis$a = [
  	"hati nyingine katika kihusika"
  ];
  var definePrefix$a = [
  	"fafanua"
  ];
  var defineSuffix$a = [
  ];
  var palette$a = {
  	Motion: "Mwendo",
  	Looks: "Muonekano",
  	Sound: "Sauti",
  	Events: "Matukio",
  	Control: "Kidhibiti",
  	Sensing: "Hisi",
  	Operators: "Opereta",
  	Variables: "Vibadilika",
  	"My Blocks": "Bloku Zangu"
  };
  var math$a = [
  	"abs",
  	"kadiria chini namba kamili",
  	"kadiria juu namba kamili",
  	"kipeo cha pili",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$a = {
  };
  var name$a = "Kiswahili";
  var percentTranslated$a = 100;
  var sw = {
  	commands: commands$a,
  	dropdowns: dropdowns$a,
  	ignorelt: ignorelt$a,
  	soundEffects: soundEffects$a,
  	microbitWhen: microbitWhen$a,
  	osis: osis$a,
  	definePrefix: definePrefix$a,
  	defineSuffix: defineSuffix$a,
  	palette: palette$a,
  	math: math$a,
  	aliases: aliases$a,
  	name: name$a,
  	percentTranslated: percentTranslated$a
  };

  var commands$9 = {
  	MOTION_MOVESTEPS: "เคลื่อนที่ %1 ก้าว",
  	MOTION_TURNRIGHT: "หัน @turnRight %1 องศา",
  	MOTION_TURNLEFT: "หัน @turnLeft %1 องศา",
  	MOTION_POINTINDIRECTION: "หันในทิศทาง %1",
  	MOTION_POINTTOWARDS: "หันไปทาง %1",
  	MOTION_GOTOXY: "ไปที่ x: %1 y: %2",
  	MOTION_GOTO: "ไปที่ %1",
  	MOTION_GLIDESECSTOXY: "เหิน %1 วินาที ไปยัง x: %2 y: %3",
  	MOTION_GLIDETO: "เหิน %1 วินาที ไปยัง %2",
  	MOTION_CHANGEXBY: "เปลี่ยน x ทีละ %1",
  	MOTION_SETX: "ตั้งค่า x เป็น %1",
  	MOTION_CHANGEYBY: "เปลี่ยน y ทีละ %1",
  	MOTION_SETY: "ตั้งค่า y เป็น %1",
  	MOTION_SETROTATIONSTYLE: "ตั้งรูปแบบการหมุนเป็น %1",
  	LOOKS_SAYFORSECS: "พูด %1   %2 วินาที",
  	LOOKS_SAY: "พูด %1",
  	LOOKS_THINKFORSECS: "คิด %1   %2 วินาที",
  	LOOKS_THINK: "คิด %1",
  	LOOKS_SHOW: "แสดง",
  	LOOKS_HIDE: "ซ่อน",
  	LOOKS_SWITCHCOSTUMETO: "เปลี่ยนคอสตูมเป็น %1",
  	LOOKS_NEXTCOSTUME: "ชุดถัดไป",
  	LOOKS_NEXTBACKDROP_BLOCK: "ฉากหลังต่อไป",
  	LOOKS_SWITCHBACKDROPTO: "เปลี่ยนฉากหลังเป็น %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "เปลี่ยนฉากหลังเป็น %1 และรอ",
  	LOOKS_CHANGEEFFECTBY: "เปลี่ยนเอฟเฟกต์ %1 ทีละ %2",
  	LOOKS_SETEFFECTTO: "ตั้งค่าเอฟเฟกต์ %1 เป็น %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "ล้างเอฟเฟคภาพ",
  	LOOKS_CHANGESIZEBY: "เปลี่ยนขนาดทีละ %1",
  	LOOKS_SETSIZETO: "กำหนดขนาดเป็น %1 %",
  	LOOKS_GOTOFRONTBACK: "ไปที่ระดับ %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "ไป %1 %2 ระดับ",
  	SOUND_PLAY: "เริ่มเสียง %1",
  	SOUND_CHANGEEFFECTBY: "เปลี่ยนเอฟเฟกต์ %1 ทีละ %2",
  	SOUND_SETEFFECTO: "ตั้งค่าเอฟเฟกต์ %1 เป็น %2",
  	SOUND_CLEAREFFECTS: "ล้างเอฟเฟกต์เสียง",
  	SOUND_PLAYUNTILDONE: "เล่นเสียง %1 จนจบ",
  	SOUND_STOPALLSOUNDS: "หยุดเสียงทั้งหมด",
  	"music.playDrumForBeats": "เล่น %1 %2 จังหวะ",
  	"music.restForBeats": "หยุด %1 จังหวะ",
  	"music.playNoteForBeats": "เล่นโน๊ต %1 %2 จังหวะ",
  	"music.setInstrument": "ตั้งเครื่องดนตรีเป็น %1",
  	SOUND_CHANGEVOLUMEBY: "เปลี่ยนระดับเสียงทีละ %1",
  	SOUND_SETVOLUMETO: "ตั้งระดับเสียงเป็น %1%",
  	"music.changeTempo": "เปลี่ยนความเร็วทีละ %1",
  	"music.setTempo": "ตั้งค่าความเร็วเป็น %1จังหวะต่อนาที",
  	"pen.clear": "ลบทั้งหมด",
  	"pen.stamp": "ประทับ",
  	"pen.penDown": "จรดปากกา",
  	"pen.penUp": "ยกปากกาขึ้น",
  	"pen.setColor": "ตั้งค่าสีปากกาเป็น %1",
  	"pen.changeHue": "เปลี่ยนสีปากกาทีละ %1",
  	"pen.setColorParam": "ตั้งค่า %1 ปากกาเป็น%2",
  	"pen.changeColorParam": "เปลี่ยน %1 ปากกาทีละ %2",
  	"pen.setHue": "ตั้งสีปากกาเป็น %1",
  	"pen.changeShade": "เปลี่ยนเฉดสีปากกาทีละ %1",
  	"pen.setShade": "ตั้งค่าเฉดสีเป็น %1",
  	"pen.changeSize": "เปลี่ยนขนาดปากกาทีละ %1",
  	"pen.setSize": "ตั้งขนาดปากกาเป็น %1",
  	EVENT_WHENFLAGCLICKED: "เมื่อคลิก @greenFlag",
  	EVENT_WHENKEYPRESSED: "เมื่อกดปุ่ม %1",
  	EVENT_WHENTHISSPRITECLICKED: "เมื่อตัวละครนี้ถูกคลิก",
  	EVENT_WHENSTAGECLICKED: "เมื่อคลิกเวที",
  	EVENT_WHENBACKDROPSWITCHESTO: "เมื่อฉากหลังเปลี่ยนเป็น %1",
  	EVENT_WHENGREATERTHAN: "เมื่อ %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "เมื่อฉันได้รับ %1",
  	EVENT_BROADCAST: "กระจาย %1",
  	EVENT_BROADCASTANDWAIT: "กระจาย %1 และรอ",
  	CONTROL_WAIT: "รอ %1 วินาที",
  	CONTROL_REPEAT: "ทำซ้ำ %1",
  	CONTROL_FOREVER: "วนซ้ำตลอด",
  	CONTROL_IF: "ถ้า %1 แล้ว",
  	CONTROL_WAITUNTIL: "รอจนกระทั่ง %1",
  	CONTROL_REPEATUNTIL: "ทำซ้ำจน %1",
  	CONTROL_STOP: "หยุด %1",
  	CONTROL_STARTASCLONE: "เมื่อฉันเริ่มในฐานะโคลน",
  	CONTROL_CREATECLONEOF: "สร้าง โคลน ของ %1",
  	CONTROL_DELETETHISCLONE: "ลบโคลนตัวนี้",
  	SENSING_ASKANDWAIT: "ถาม %1 และรอ",
  	"videoSensing.videoToggle": "%1 วิดีโอ",
  	"videoSensing.setVideoTransparency": "ตั้งค่าความโปร่งใสของวิดีโอเป็น %1",
  	"videoSensing.whenMotionGreaterThan": "เมื่อวิดีโอเคลื่อนไหว > %1",
  	SENSING_RESETTIMER: "จับเวลาใหม่",
  	DATA_SETVARIABLETO: "ตั้งค่า %1 เป็น %2",
  	DATA_CHANGEVARIABLEBY: "เปลี่ยน %1 ทีละ %2",
  	DATA_SHOWVARIABLE: "แสดงตัวแปร %1",
  	DATA_HIDEVARIABLE: "ซ่อนตัวแปร %1",
  	DATA_ADDTOLIST: "เพิ่ม %1 ไปยัง %2",
  	DATA_DELETEOFLIST: "ลบรายการที่ %1 ออกจาก %2",
  	DATA_DELETEALLOFLIST: "ลบทั้งหมดจาก %1",
  	MOTION_IFONEDGEBOUNCE: "ถ้าชนขอบให้สะท้อนกลับ",
  	DATA_INSERTATLIST: "แทรก %1 ที่ลำดับ %2 ของ %3",
  	DATA_REPLACEITEMOFLIST: "แทนที่รายการที่ %1 ของ %2 ด้วย %3",
  	DATA_SHOWLIST: "แสดงรายการ %1",
  	DATA_HIDELIST: "ซ่อนรายการ %1",
  	SENSING_OF_XPOSITION: "ตำแหน่ง x",
  	SENSING_OF_YPOSITION: "ตำแหน่ง y",
  	SENSING_OF_DIRECTION: "ทิศทาง",
  	SENSING_OF_COSTUMENUMBER: "คอสตูม #",
  	LOOKS_COSTUMENUMBERNAME: "คอสตูม %1",
  	SENSING_OF_SIZE: "ขนาด",
  	SENSING_OF_BACKDROPNAME: "ชื่อฉากหลัง",
  	LOOKS_BACKDROPNUMBERNAME: "ฉากหลัง %1",
  	SENSING_OF_BACKDROPNUMBER: "ฉากหลัง #",
  	SOUND_VOLUME: "ระดับเสียง",
  	"music.getTempo": "จังหวะ",
  	SENSING_TOUCHINGOBJECT: "แตะ %1?",
  	SENSING_TOUCHINGCOLOR: "แตะสี %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "สี %1 แตะกับสี %2?",
  	SENSING_DISTANCETO: "ระยะห่างไปยัง %1",
  	SENSING_ANSWER: "คำตอบ",
  	SENSING_KEYPRESSED: "ปุ่ม %1 ถูกกด?",
  	SENSING_MOUSEDOWN: "เมาส์ถูกกด?",
  	SENSING_MOUSEX: "ตำแหน่ง x ของเมาส์",
  	SENSING_MOUSEY: "ตำแหน่ง y ของเมาส์",
  	SENSING_SETDRAGMODE: "ตั้งค่าโหมดลาก %1",
  	SENSING_LOUDNESS: "ระดับความดัง",
  	"videoSensing.videoOn": "%1 วิดีโอ บน %2",
  	SENSING_TIMER: "จับเวลา",
  	SENSING_OF: "%1 ของ %2",
  	SENSING_CURRENT: "%1 ปัจจุบัน",
  	SENSING_DAYSSINCE2000: "จำนวนวันตั้งแต่ปี ค.ศ 2000",
  	SENSING_USERNAME: "ชื่อผู้ใช้",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "เลือกสุ่มจาก %1 ถึง %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 และ %2",
  	OPERATORS_OR: "%1 หรือ %2",
  	OPERATORS_NOT: "ไม่ %1",
  	OPERATORS_JOIN: "ต่อ %1 %2",
  	OPERATORS_LETTEROF: "อักษรที่ %1 ของ %2",
  	OPERATORS_LENGTH: "ความยาวของ %1",
  	OPERATORS_MOD: "%1 หารเอาเศษ %2",
  	OPERATORS_ROUND: "ปัดเศษ %1",
  	OPERATORS_MATHOP: "%1 ของ %2",
  	OPERATORS_CONTAINS: "%1 มี %2?",
  	DATA_ITEMOFLIST: "รายการที่ %1 ของ %2",
  	DATA_ITEMNUMOFLIST: "รายการ # ของ %1 จาก %2",
  	DATA_LENGTHOFLIST: "ความยาวของ %1",
  	DATA_LISTCONTAINSITEM: "%1 มี %2?",
  	CONTROL_ELSE: "มิฉะนั้น",
  	SENSING_USERID: "รหัสผู้ใช้",
  	SENSING_LOUD: "เสียงดัง?",
  	"text2speech.speakAndWaitBlock": "พูด %1",
  	"text2speech.setVoiceBlock": "ตั้งเสียงเป็น  %1",
  	"text2speech.setLanguageBlock": "ตั้งภาษาเป็น %1",
  	"translate.translateBlock": "แปล %1 เป็น %2",
  	"translate.viewerLanguage": "ภาษา",
  	"makeymakey.whenKeyPressed": "เมื่อคีย์ %1 ถูกกด",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "เมื่อปุ่ม %1 ถูกกด",
  	"microbit.isButtonPressed": "ปุ่ม %1 ถูกกด?",
  	"microbit.whenGesture": "เมื่อ %1",
  	"microbit.displaySymbol": "แสดง %1",
  	"microbit.displayText": "แสดงข้อความ %1",
  	"microbit.clearDisplay": "ล้างหน้าจอ",
  	"microbit.whenTilted": "เมื่อเอียง %1",
  	"microbit.isTilted": "เอียง %1?",
  	"microbit.tiltAngle": "มุมเอียง %1",
  	"microbit.whenPinConnected": "เมื่อขา %1 เชื่อมต่อแล้ว",
  	"ev3.motorTurnClockwise": "มอเตอร์ %1 หมุนทางนี้ เป็นเวลา %2 วินาที",
  	"ev3.motorTurnCounterClockwise": "มอเตอร์ %1 หมุนทางนั้น เป็นเวลา %2 วินาที",
  	"ev3.motorSetPower": "ตั้งค่ากำลังมอเตอร์ %1 เป็น %2 %",
  	"ev3.getMotorPosition": "ตำแหน่งมอเตอร์ %1",
  	"ev3.whenButtonPressed": "เมื่อกดปุ่ม %1",
  	"ev3.whenDistanceLessThan": "เมื่อระยะห่าง < %1",
  	"ev3.whenBrightnessLessThan": "เมื่อความสว่าง < %1",
  	"ev3.buttonPressed": "ปุ่ม %1 ถูกกด?",
  	"ev3.getDistance": "ระยะห่าง",
  	"ev3.getBrightness": "ความสว่าง",
  	"ev3.beepNote": "เล่นโน้ต %1 เป็นเวลา %2 วินาที",
  	"wedo2.motorOn": "เปิดมอเตอร์ %1",
  	"wedo2.motorOff": "ปิดมอเตอร์%1",
  	"wedo2.startMotorPower": "ตั้งค่ากำลังมอเตอร์ %1 เป็น %2",
  	"wedo2.setMotorDirection": "ตั้งทิศทางมอเตอร์ %1 เป็น %2",
  	"wedo2.whenDistance": "เมื่อระยะห่าง %1 %2",
  	"wedo2.getDistance": "ระยะทาง",
  	"wedo2.motorOnFor": "เปิดมอเตอร์ %1 เป็นเวลา %2 วินาที",
  	"wedo2.setLightHue": "ตั้งสีหลอดไฟเป็น %1",
  	"wedo2.playNoteFor": "เล่นโน้ต %1 เป็นเวลา %2 วินาที",
  	"wedo2.whenTilted": "เมื่อเอียง %1",
  	"wedo2.isTilted": "เอียง %1?",
  	"wedo2.getTiltAngle": "มุมเอียง %1",
  	"gdxfor.whenGesture": "เมื่อ %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "ตกไหม?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "เร่ง %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "เปิดมอเตอร์ %1",
  	"boost.motorOff": "ปิดมอเตอร์ %1",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "ตำแหน่งมอเตอร์ %1",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "เมื่อเอียง %1",
  	"boost.getTiltAngle": "มุมเอียง %1",
  	"boost.setLightHue": "ตั้งสีหลอดไฟเป็น %1"
  };
  var dropdowns$9 = {
  };
  var ignorelt$9 = [
  ];
  var soundEffects$9 = [
  	"เสียงสูงต่ำ",
  	"แพนเสียงซ้าย/ขวา"
  ];
  var microbitWhen$9 = [
  	"เคลื่อนไหว",
  	"เขย่า",
  	"กระโดด"
  ];
  var osis$9 = [
  	"สริปต์อื่นในตัวละคร"
  ];
  var definePrefix$9 = [
  	"กำหนด"
  ];
  var defineSuffix$9 = [
  ];
  var palette$9 = {
  	Motion: "เคลื่อนไหว",
  	Looks: "รูปลักษณ์",
  	Sound: "เสียง",
  	Events: "เหตุการณ์",
  	Control: "ควบคุม",
  	Sensing: "ตรวจจับ",
  	Operators: "ตัวดำเนินการ",
  	Variables: "ตัวแปร",
  	"My Blocks": "บล็อกของฉัน"
  };
  var math$9 = [
  	"ค่าสัมบูรณ์",
  	"พื้น",
  	"เพดาน",
  	"รากที่สอง",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$9 = {
  };
  var name$9 = "ไทย";
  var percentTranslated$9 = 100;
  var th = {
  	commands: commands$9,
  	dropdowns: dropdowns$9,
  	ignorelt: ignorelt$9,
  	soundEffects: soundEffects$9,
  	microbitWhen: microbitWhen$9,
  	osis: osis$9,
  	definePrefix: definePrefix$9,
  	defineSuffix: defineSuffix$9,
  	palette: palette$9,
  	math: math$9,
  	aliases: aliases$9,
  	name: name$9,
  	percentTranslated: percentTranslated$9
  };

  var commands$8 = {
  	MOTION_MOVESTEPS: "tsamaisa %1 dikgato",
  	MOTION_TURNRIGHT: "retolosa @turnRight %1 ka selekanyo",
  	MOTION_TURNLEFT: "retolosa @turnLeft %1 ka selekanyo",
  	MOTION_POINTINDIRECTION: "supa kaelo ya %1",
  	MOTION_POINTTOWARDS: "supa go ya go %1",
  	MOTION_GOTOXY: "e ya go x: %1 y: %2",
  	MOTION_GOTO: "e ya go %1",
  	MOTION_GLIDESECSTOXY: "reletsa %1 metsotswana go x: %2 y: %3",
  	MOTION_GLIDETO: "reletsa %1 metsotswana go %2",
  	MOTION_CHANGEXBY: "fetola x ka %1",
  	MOTION_SETX: "dira x go %1",
  	MOTION_CHANGEYBY: "fetola y ka %1",
  	MOTION_SETY: "dira y go %1",
  	MOTION_SETROTATIONSTYLE: "dira mokgwa wa go dikologa %1",
  	LOOKS_SAYFORSECS: "e re %1 ya %2 metsotswana",
  	LOOKS_SAY: "e re %1",
  	LOOKS_THINKFORSECS: "akanya %1 ya %2 metsotswana",
  	LOOKS_THINK: "akanya %1",
  	LOOKS_SHOW: "bontsha",
  	LOOKS_HIDE: "fitlha",
  	LOOKS_SWITCHCOSTUMETO: "fetolela diaparo go %1",
  	LOOKS_NEXTCOSTUME: "seaparo se se latelang",
  	LOOKS_NEXTBACKDROP_BLOCK: "tatlhelomorago e e latelang",
  	LOOKS_SWITCHBACKDROPTO: "fetolela tatlhelo morago go %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "fetolela tatlhelomorago go %1 mme o lete",
  	LOOKS_CHANGEEFFECTBY: "fetola %1 go simolola ka %2",
  	LOOKS_SETEFFECTTO: "dira %1 go simolola %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "phimola tebego ya dinepe",
  	LOOKS_CHANGESIZEBY: "fetola bogolo ka %1",
  	LOOKS_SETSIZETO: "dira bogolo go %1 %",
  	LOOKS_GOTOFRONTBACK: "e ya go %1 ya boalo",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "e ya go %1 %2 ya boalo",
  	SOUND_PLAY: "simolola modumo wa %1",
  	SOUND_CHANGEEFFECTBY: "fetola %1 go simolola ka %2",
  	SOUND_SETEFFECTO: "dira %1 go simolola  %2",
  	SOUND_CLEAREFFECTS: "tlosa medumo e e simololang",
  	SOUND_PLAYUNTILDONE: "tshameka modumo wa %1 go fitlhela o fetsa",
  	SOUND_STOPALLSOUNDS: "emisa medumo yotlhe",
  	"music.playDrumForBeats": "tshameka moropa %1 wa %2 meporo",
  	"music.restForBeats": "ikhuletse %1 meporo",
  	"music.playNoteForBeats": "tshameka noto %1 ya %2 meporo",
  	"music.setInstrument": "tlhagisa sediriswa go %1",
  	SOUND_CHANGEVOLUMEBY: "fetola maemo a modumo ka %1",
  	SOUND_SETVOLUMETO: "dira maemo a modumo go %1%",
  	"music.changeTempo": "fetola lebelo ka go %1",
  	"music.setTempo": "tlhagisa lebelo go %1",
  	"pen.clear": "phimola tsotlhe",
  	"pen.stamp": "setempe",
  	"pen.penDown": "pene fatshe",
  	"pen.penUp": "pene godimo",
  	"pen.setColor": "tlhagisa mmala wa pene go %1",
  	"pen.changeHue": "fetola mmala wa pene ka %1",
  	"pen.setColorParam": "tlhagisa pene %1 go %2",
  	"pen.changeColorParam": "fetola pene %1 ka %2",
  	"pen.setHue": "tlhagisa mmala wa pene go %1",
  	"pen.changeShade": "fetola mmala wa pene ka %1",
  	"pen.setShade": "tlhagisa mmala wa pene go %1",
  	"pen.changeSize": "fetola bogolo ba pene ka %1",
  	"pen.setSize": "tlhagisa bogolo ba pene go %1",
  	EVENT_WHENFLAGCLICKED: "fa @greenFlag e tobetswa",
  	EVENT_WHENKEYPRESSED: "fa %1 ya konopo e tobeditswe",
  	EVENT_WHENTHISSPRITECLICKED: "fa sprite se, se tobetswa",
  	EVENT_WHENSTAGECLICKED: "fa serala se tobetswa",
  	EVENT_WHENBACKDROPSWITCHESTO: "fa tatlhelomorago e fetogela go %1",
  	EVENT_WHENGREATERTHAN: "fa %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "fa ke amogela %1",
  	EVENT_BROADCAST: "gasa %1",
  	EVENT_BROADCASTANDWAIT: "gasa %1 mme o lete",
  	CONTROL_WAIT: "leta %1 metsotswana",
  	CONTROL_REPEAT: "boeletsa %1",
  	CONTROL_FOREVER: "gosafeleng",
  	CONTROL_IF: "fa %1 gona",
  	CONTROL_WAITUNTIL: "leta go fitlhela go %1",
  	CONTROL_REPEATUNTIL: "boeletsa go fitlhela go %1",
  	CONTROL_STOP: "ema %1",
  	CONTROL_STARTASCLONE: "fa ke simolola jaaka sebopapopego",
  	CONTROL_CREATECLONEOF: "dira sebopapopego sa %1",
  	CONTROL_DELETETHISCLONE: "phimola sebopapopego se",
  	SENSING_ASKANDWAIT: "botsa %1 mme o lete",
  	"videoSensing.videoToggle": "tshuma video %1",
  	"videoSensing.setVideoTransparency": "tlhagisa bosengbofitlha ba video %1",
  	"videoSensing.whenMotionGreaterThan": "fa video e tshameka > %1",
  	SENSING_RESETTIMER: "simolola sekayanako",
  	DATA_SETVARIABLETO: "dira %1 go %2",
  	DATA_CHANGEVARIABLEBY: "fetola %1 ka %2",
  	DATA_SHOWVARIABLE: "bontsha pharologano ya %1",
  	DATA_HIDEVARIABLE: "fitlha pharologano ya %1",
  	DATA_ADDTOLIST: "oketsa %1 go %2",
  	DATA_DELETEOFLIST: "tlosa %1 ya %2",
  	DATA_DELETEALLOFLIST: "tlosa tsotlhe tsa %1",
  	MOTION_IFONEDGEBOUNCE: "fa e le mo losing, tlola",
  	DATA_INSERTATLIST: "tsenya %1 go %2 ya %3",
  	DATA_REPLACEITEMOFLIST: "emisetsa selwana %1 ya %2 ka %3",
  	DATA_SHOWLIST: "bontsha lenaane %1",
  	DATA_HIDELIST: "fitlha lenaane %1",
  	SENSING_OF_XPOSITION: "boemo jwa x",
  	SENSING_OF_YPOSITION: "boemo jwa y",
  	SENSING_OF_DIRECTION: "kaelo",
  	SENSING_OF_COSTUMENUMBER: "seaparo #",
  	LOOKS_COSTUMENUMBERNAME: "seaparo %1",
  	SENSING_OF_SIZE: "bogolo",
  	SENSING_OF_BACKDROPNAME: "leina la tatlhelo morago",
  	LOOKS_BACKDROPNUMBERNAME: "tatlhelomorago %1",
  	SENSING_OF_BACKDROPNUMBER: "tatlhelo morago #",
  	SOUND_VOLUME: "maemo a modumo",
  	"music.getTempo": "lebelo",
  	SENSING_TOUCHINGOBJECT: "o kgoma %1?",
  	SENSING_TOUCHINGCOLOR: "o kgoma mmala wa %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "mmala wa %1 o kgoma %2?",
  	SENSING_DISTANCETO: "sekgala go %1",
  	SENSING_ANSWER: "karabo",
  	SENSING_KEYPRESSED: "konopo ya %1 e tobeditswe?",
  	SENSING_MOUSEDOWN: "maose kwa tlase?",
  	SENSING_MOUSEX: "maose x",
  	SENSING_MOUSEY: "maose y",
  	SENSING_SETDRAGMODE: "dira mokgwa wa go goga %1",
  	SENSING_LOUDNESS: "modumo",
  	"videoSensing.videoOn": "video %1 mo %2",
  	SENSING_TIMER: "sekayanako",
  	SENSING_OF: "%1 ya %2",
  	SENSING_CURRENT: "gompieno %1",
  	SENSING_DAYSSINCE2000: "malatsi go simolola ka 2000",
  	SENSING_USERNAME: "leinatiriso",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "tlhopha gongwe le gongwe %1 go %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 le %2",
  	OPERATORS_OR: "%1 kgotsa %2",
  	OPERATORS_NOT: "e seng %1",
  	OPERATORS_JOIN: "kopanya %1 %2",
  	OPERATORS_LETTEROF: "tlhaka %1 ya %2",
  	OPERATORS_LENGTH: "boleele jwa %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "tikologo ya %1",
  	OPERATORS_MATHOP: "%1 ya %2",
  	OPERATORS_CONTAINS: "%1 e tshotse %2?",
  	DATA_ITEMOFLIST: "selwana %1 sa %2",
  	DATA_ITEMNUMOFLIST: "selwana # sa %1 go %2",
  	DATA_LENGTHOFLIST: "boleele jwa %1",
  	DATA_LISTCONTAINSITEM: "%1 e tshotse %2?",
  	CONTROL_ELSE: "gongwe",
  	SENSING_USERID: "tiriso ya go ikitsise",
  	SENSING_LOUD: "modumo?",
  	"text2speech.speakAndWaitBlock": "bua %1",
  	"text2speech.setVoiceBlock": "tlhagisa lentswe go %1",
  	"text2speech.setLanguageBlock": "tlhagisa puo go %1",
  	"translate.translateBlock": "ranola %1 go %2",
  	"translate.viewerLanguage": "puo",
  	"makeymakey.whenKeyPressed": "fa %1 konopo e tobeditswe",
  	"makeymakey.whenKeysPressedInOrder": "fa %1 e tobeditswe ka tolamo",
  	"microbit.whenButtonPressed": "fa %1 konopo e tobeditswe",
  	"microbit.isButtonPressed": "%1 konopo e gateletswe?",
  	"microbit.whenGesture": "fa %1",
  	"microbit.displaySymbol": "bontsha %1",
  	"microbit.displayText": "bontsha setlhangwa %1",
  	"microbit.clearDisplay": "phepafatsa dipontsho",
  	"microbit.whenTilted": "fa le sekamisitswe %1",
  	"microbit.isTilted": "sekamisitswe %1?",
  	"microbit.tiltAngle": "sekamisa enkele %1",
  	"microbit.whenPinConnected": "fa lomapo %1 golagane",
  	"ev3.motorTurnClockwise": "motšhini %1 retologela ka fa %2 metsotswana",
  	"ev3.motorTurnCounterClockwise": "motšhini %1 retologela ka fale %2 metsotswana",
  	"ev3.motorSetPower": "motšhini %1 tlhagisa maatla %2 %",
  	"ev3.getMotorPosition": "motšhini %1 maemo",
  	"ev3.whenButtonPressed": "fa konopo %1 e gateletswe",
  	"ev3.whenDistanceLessThan": "fa sekgala < %1",
  	"ev3.whenBrightnessLessThan": "fa phatsimo < %1",
  	"ev3.buttonPressed": "konopo %1 tobeditswe?",
  	"ev3.getDistance": "sekgala",
  	"ev3.getBrightness": "phatshimo",
  	"ev3.beepNote": "letsa noto %1 ya %2 metsotswana",
  	"wedo2.motorOn": "tshuma %1",
  	"wedo2.motorOff": "tima %1",
  	"wedo2.startMotorPower": "tlhagisa %1 maatla go %2",
  	"wedo2.setMotorDirection": "tlhagisa %1 kaelo go %2",
  	"wedo2.whenDistance": "fa sekgala %1 %2",
  	"wedo2.getDistance": "sekgala",
  	"wedo2.motorOnFor": "tshuma %1 %2 metsotswana",
  	"wedo2.setLightHue": "tshuma lebone la mmala go %1",
  	"wedo2.playNoteFor": "tshameka noto %1 %2 metsotswana",
  	"wedo2.whenTilted": "fa e sekamisitswe %1",
  	"wedo2.isTilted": "sekametse %1?",
  	"wedo2.getTiltAngle": "sekamisa enkele %1",
  	"gdxfor.whenGesture": "fa %1",
  	"gdxfor.whenForcePushedOrPulled": "fa maatla a dupelela  %1",
  	"gdxfor.getForce": "maatla",
  	"gdxfor.whenTilted": "fa e sekamisitswe %1",
  	"gdxfor.isTilted": "sekametse %1?",
  	"gdxfor.getTilt": "sekamisa enkele %1",
  	"gdxfor.isFreeFalling": "a o a wa?",
  	"gdxfor.getSpin": "dikolosa lebelo %1",
  	"gdxfor.getAcceleration": "koketso %1",
  	"boost.motorOnFor": "tshuma motšhini %1 %2 metsotswana",
  	"boost.motorOnForRotation": "tshuma motšhini %1 %2 ditshekeletso",
  	"boost.motorOn": "tshuma motšhini %1",
  	"boost.motorOff": "tima motšhini %1",
  	"boost.setMotorPower": "tlhagisa motšhini %1 lebelo go %2 %",
  	"boost.setMotorDirection": "tlhagisa motšhini %1 kaelo %2",
  	"boost.getMotorPosition": "motšhini %1 maemo",
  	"boost.whenColor": "fa %1 wa setena o bonwe",
  	"boost.seeingColor": "a o bona %1 setena?",
  	"boost.whenTilted": "fa e sekamisitswe %1",
  	"boost.getTiltAngle": "sekamisa enkele %1",
  	"boost.setLightHue": "tshuma lebone la mmala go %1"
  };
  var dropdowns$8 = {
  };
  var ignorelt$8 = [
  ];
  var soundEffects$8 = [
  	"segalo",
  	"letswela la molema/moja"
  ];
  var microbitWhen$8 = [
  	"sutisitswe",
  	"reketlisiwa",
  	"tloletse"
  ];
  var osis$8 = [
  	"makwalo a mangwe mo go sprite"
  ];
  var definePrefix$8 = [
  	"tlhalosa"
  ];
  var defineSuffix$8 = [
  ];
  var palette$8 = {
  	Motion: "Motsamao",
  	Looks: "Ditebego",
  	Sound: "Modumo",
  	Events: "Ditiragalo",
  	Control: "Laola",
  	Sensing: "Dupelela",
  	Operators: "Badiri",
  	Variables: "Dipharologano",
  	"My Blocks": "Diboloko tsa me"
  };
  var math$8 = [
  	"abs",
  	"boalo",
  	"Ceiling",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"gare",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$8 = {
  };
  var name$8 = "Setswana";
  var percentTranslated$8 = 100;
  var tn = {
  	commands: commands$8,
  	dropdowns: dropdowns$8,
  	ignorelt: ignorelt$8,
  	soundEffects: soundEffects$8,
  	microbitWhen: microbitWhen$8,
  	osis: osis$8,
  	definePrefix: definePrefix$8,
  	defineSuffix: defineSuffix$8,
  	palette: palette$8,
  	math: math$8,
  	aliases: aliases$8,
  	name: name$8,
  	percentTranslated: percentTranslated$8
  };

  var commands$7 = {
  	MOTION_MOVESTEPS: "%1 adım git",
  	MOTION_TURNRIGHT: "@turnRight %1 derece dön",
  	MOTION_TURNLEFT: "@turnLeft %1 derece dön",
  	MOTION_POINTINDIRECTION: "%1 yönüne dön",
  	MOTION_POINTTOWARDS: "%1 e doğru yönel",
  	MOTION_GOTOXY: "x: %1 y: %2 konumuna git",
  	MOTION_GOTO: "%1 e git",
  	MOTION_GLIDESECSTOXY: "%1 saniyede x: %2 y: %3 konumuna git",
  	MOTION_GLIDETO: "%1 saniyede %2 git",
  	MOTION_CHANGEXBY: "x konumunu %1 değiştir",
  	MOTION_SETX: "x konumunu %1 yap",
  	MOTION_CHANGEYBY: "y konumunu %1 değiştir",
  	MOTION_SETY: "y konumunu %1 yap",
  	MOTION_SETROTATIONSTYLE: "dönüş stilini %1 yap",
  	LOOKS_SAYFORSECS: "%2 saniye boyunca %1 de",
  	LOOKS_SAY: "%1 de",
  	LOOKS_THINKFORSECS: "%2 saniye boyunca %1 diye düşün",
  	LOOKS_THINK: "%1 diye düşün",
  	LOOKS_SHOW: "göster",
  	LOOKS_HIDE: "gizle",
  	LOOKS_SWITCHCOSTUMETO: "%1 kılığına geç",
  	LOOKS_NEXTCOSTUME: "sonraki kostüm",
  	LOOKS_NEXTBACKDROP_BLOCK: "sonraki dekor",
  	LOOKS_SWITCHBACKDROPTO: "%1 dekoruna geç",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "%1 dekoruna geç ve bekle",
  	LOOKS_CHANGEEFFECTBY: "%1 etkisini %2 değiştir",
  	LOOKS_SETEFFECTTO: "%1 etkisini %2 yap",
  	LOOKS_CLEARGRAPHICEFFECTS: "görsel etkileri temizle",
  	LOOKS_CHANGESIZEBY: "boyutu %1 birim değiştir",
  	LOOKS_SETSIZETO: "boyutu % %1 yap",
  	LOOKS_GOTOFRONTBACK: "%1 katmanına git",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%2 katman %1 git",
  	SOUND_PLAY: "%1 sesini başlat",
  	SOUND_CHANGEEFFECTBY: "%1 etkisini %2 değiştir",
  	SOUND_SETEFFECTO: "%1 etkisini %2 yap",
  	SOUND_CLEAREFFECTS: "ses etkilerini temizle",
  	SOUND_PLAYUNTILDONE: "%1 sesini bitene kadar çal",
  	SOUND_STOPALLSOUNDS: "tüm sesleri durdur",
  	"music.playDrumForBeats": "%1 davulunu %2 vuruş çal",
  	"music.restForBeats": "%1 vuruş durakla",
  	"music.playNoteForBeats": "%1 notasını %2 vuruşunda çal",
  	"music.setInstrument": "Enstrümanı %1 yap",
  	SOUND_CHANGEVOLUMEBY: "ses düzeyini %1 değiştir",
  	SOUND_SETVOLUMETO: "ses düzeyini %1% yap",
  	"music.changeTempo": "tempoyu %1 yap",
  	"music.setTempo": "tempoyu %1 yap",
  	"pen.clear": "tümünü sil",
  	"pen.stamp": "damgala",
  	"pen.penDown": "kalemi bastır",
  	"pen.penUp": "kalemi kaldır",
  	"pen.setColor": "kalem rengini %1 yap",
  	"pen.changeHue": "kalem rengini %1 artır",
  	"pen.setColorParam": "kalem %1 %2 yap",
  	"pen.changeColorParam": "kalem %1 %2 artır",
  	"pen.setHue": "kalem rengini %1 yap",
  	"pen.changeShade": "kalem tonunu %1 artır",
  	"pen.setShade": "kalem tonunu %1 yap",
  	"pen.changeSize": "kalem kalınlığını %1 artır",
  	"pen.setSize": "kalem kalınlığını %1 yap",
  	EVENT_WHENFLAGCLICKED: "@greenFlag e tıklandığında",
  	EVENT_WHENKEYPRESSED: "%1 tuşuna basılınca",
  	EVENT_WHENTHISSPRITECLICKED: "bu kuklaya tıklandığında",
  	EVENT_WHENSTAGECLICKED: "sahneye tıklandığında",
  	EVENT_WHENBACKDROPSWITCHESTO: "dekor %1 olduğunda",
  	EVENT_WHENGREATERTHAN: "%1 > %2 olduğunda",
  	EVENT_WHENBROADCASTRECEIVED: "%1 haberini aldığımda",
  	EVENT_BROADCAST: "%1 haberini sal",
  	EVENT_BROADCASTANDWAIT: "%1 haberini sal ve bekle",
  	CONTROL_WAIT: "%1 saniye bekle",
  	CONTROL_REPEAT: "%1 defa tekrarla",
  	CONTROL_FOREVER: "sürekli tekrarla",
  	CONTROL_IF: "eğer %1 ise",
  	CONTROL_WAITUNTIL: "%1 olana kadar bekle",
  	CONTROL_REPEATUNTIL: "%1 olana kadar tekrarla",
  	CONTROL_STOP: "durdur %1",
  	CONTROL_STARTASCLONE: "ikiz olarak başladığımda",
  	CONTROL_CREATECLONEOF: "%1 in ikizini yarat",
  	CONTROL_DELETETHISCLONE: "bu ikizi sil",
  	SENSING_ASKANDWAIT: "%1 diye sor ve bekle",
  	"videoSensing.videoToggle": "videoyu %1",
  	"videoSensing.setVideoTransparency": "videonun saydamlığını %1 yap",
  	"videoSensing.whenMotionGreaterThan": "video hareketi > %1 olduğunda",
  	SENSING_RESETTIMER: "zamanlayıcıyı sıfırla",
  	DATA_SETVARIABLETO: "%1 değişkenini %2 yap",
  	DATA_CHANGEVARIABLEBY: "%1 i %2 kadar değiştir",
  	DATA_SHOWVARIABLE: "%1 değişkenini göster",
  	DATA_HIDEVARIABLE: "%1 değişkenini gizle",
  	DATA_ADDTOLIST: "%1 i %2 ye ekle",
  	DATA_DELETEOFLIST: "%2 in %1 ini sil",
  	DATA_DELETEALLOFLIST: "%1 in her şeyini sil",
  	MOTION_IFONEDGEBOUNCE: "kenara geldiyse sek",
  	DATA_INSERTATLIST: "%1 i %3 in %2 pozisyonuna ekle",
  	DATA_REPLACEITEMOFLIST: "%2 öğesinin %1 öğesini %3 ile değiştir",
  	DATA_SHOWLIST: "%1 listesini göster",
  	DATA_HIDELIST: "%1 listesini gizle",
  	SENSING_OF_XPOSITION: "x konumu",
  	SENSING_OF_YPOSITION: "y konumu",
  	SENSING_OF_DIRECTION: "yön",
  	SENSING_OF_COSTUMENUMBER: "kostüm #",
  	LOOKS_COSTUMENUMBERNAME: "kostüm %1",
  	SENSING_OF_SIZE: "büyüklük",
  	SENSING_OF_BACKDROPNAME: "dekorun adı",
  	LOOKS_BACKDROPNUMBERNAME: "dekor %1",
  	SENSING_OF_BACKDROPNUMBER: "dekor #",
  	SOUND_VOLUME: "ses düzeyi",
  	"music.getTempo": "tempo",
  	SENSING_TOUCHINGOBJECT: "%1 e değiyor mu?",
  	SENSING_TOUCHINGCOLOR: "%1 rengine değiyor mu?",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 rengi %2 rengine değiyor mu?",
  	SENSING_DISTANCETO: "%1 e mesafe",
  	SENSING_ANSWER: "yanıt",
  	SENSING_KEYPRESSED: "%1 tuşuna basıldı mı?",
  	SENSING_MOUSEDOWN: "fareye basılı mı?",
  	SENSING_MOUSEX: "farenin x i",
  	SENSING_MOUSEY: "farenin y si",
  	SENSING_SETDRAGMODE: "sürükleme modunu %1 yap",
  	SENSING_LOUDNESS: "ses yüksekliği",
  	"videoSensing.videoOn": "%2 video %1",
  	SENSING_TIMER: "zamanlayıcı",
  	SENSING_OF: "%2 in %1 i",
  	SENSING_CURRENT: "şu anki %1",
  	SENSING_DAYSSINCE2000: "2000 yılından beri geçen gün",
  	SENSING_USERNAME: "kullanıcı adı",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 ile %2 arasında rastgele bir sayı seç",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 ve %2",
  	OPERATORS_OR: "%1 veya %2",
  	OPERATORS_NOT: "%1 değil",
  	OPERATORS_JOIN: "%1 i ve %2 ile birleştir",
  	OPERATORS_LETTEROF: "%2 in %1. harfi",
  	OPERATORS_LENGTH: "%1 in uzunluğu",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "%1 i yuvarla",
  	OPERATORS_MATHOP: "%2 in %1 i",
  	OPERATORS_CONTAINS: "%1, %2 i içeriyor mu?",
  	DATA_ITEMOFLIST: "%2' in %1 öğesi",
  	DATA_ITEMNUMOFLIST: "%2 in %1 öğesinin # öğesi",
  	DATA_LENGTHOFLIST: "%1 in uzunluğu",
  	DATA_LISTCONTAINSITEM: "%1, %2 i içeriyor mu?",
  	CONTROL_ELSE: "değilse",
  	SENSING_USERID: "kullanıcı kimliği",
  	SENSING_LOUD: "gürültülü mü?",
  	"text2speech.speakAndWaitBlock": "konuş %1",
  	"text2speech.setVoiceBlock": "sesi %1e ayarla",
  	"text2speech.setLanguageBlock": "dili %1'ye ayarla",
  	"translate.translateBlock": "%1 metnini %2 diline çevir",
  	"translate.viewerLanguage": "dil",
  	"makeymakey.whenKeyPressed": "%1 tuşu basılınca",
  	"makeymakey.whenKeysPressedInOrder": "%1 dizisi sırayla basılınca",
  	"microbit.whenButtonPressed": "%1 düğmesi basıldığında",
  	"microbit.isButtonPressed": "%1 düğmesi basıldı mı?",
  	"microbit.whenGesture": "%1 olduğunda",
  	"microbit.displaySymbol": "%1göster",
  	"microbit.displayText": "%1 metnini göster",
  	"microbit.clearDisplay": "ekranı temizle",
  	"microbit.whenTilted": "%1 eğildiğinde",
  	"microbit.isTilted": "%1 eğildi mi?",
  	"microbit.tiltAngle": "%1 eğim açısı",
  	"microbit.whenPinConnected": "%1 pini bağlandığında",
  	"ev3.motorTurnClockwise": "%1 motorunu > yönünde %2 saniye döndür",
  	"ev3.motorTurnCounterClockwise": "%1 motorunu < yönünde %2 saniye döndür",
  	"ev3.motorSetPower": "%1 motor gücünü % %2 yap",
  	"ev3.getMotorPosition": "%1 motor konumu",
  	"ev3.whenButtonPressed": "%1 düğmesine basıldığında",
  	"ev3.whenDistanceLessThan": "mesafe < %1 olduğunda",
  	"ev3.whenBrightnessLessThan": "parlaklık < %1 olduğunda",
  	"ev3.buttonPressed": "%1 düğmesi basıldı mı?",
  	"ev3.getDistance": "mesafe",
  	"ev3.getBrightness": "parlaklık",
  	"ev3.beepNote": "%1 notasını %2 saniye çal",
  	"wedo2.motorOn": "%1 u aç",
  	"wedo2.motorOff": "%1 u kapat",
  	"wedo2.startMotorPower": "%1 gücünü %2'e ayarla",
  	"wedo2.setMotorDirection": "%1 yönünü %2'a ayarla",
  	"wedo2.whenDistance": "mesafe  %1 %2 olduğunda",
  	"wedo2.getDistance": "mesafe",
  	"wedo2.motorOnFor": "%1 u %2 saniye çalıştır",
  	"wedo2.setLightHue": "ışık rengini %1 'ye ayarla",
  	"wedo2.playNoteFor": "%1 notasını %2 saniye çal",
  	"wedo2.whenTilted": "%1 eğildiğinde",
  	"wedo2.isTilted": "%1 eğildi mi?",
  	"wedo2.getTiltAngle": "%1 eğim açısı",
  	"gdxfor.whenGesture": "%1 olduğunda",
  	"gdxfor.whenForcePushedOrPulled": "kuvvet sensörü %1",
  	"gdxfor.getForce": "güç",
  	"gdxfor.whenTilted": "Eğim %1 olduğunda",
  	"gdxfor.isTilted": "%1 eğimli mi?",
  	"gdxfor.getTilt": "eğim açısı %1",
  	"gdxfor.isFreeFalling": "düşüyor mu?",
  	"gdxfor.getSpin": "devir hızı %1",
  	"gdxfor.getAcceleration": "ivme %1",
  	"boost.motorOnFor": "%1 numaralı motoru %2 saniye çalıştır",
  	"boost.motorOnForRotation": "%1 numaralı motoru %2 tur çalıştır",
  	"boost.motorOn": "%1 numaralı motoru aç",
  	"boost.motorOff": "%1 numaralı motoru kapat",
  	"boost.setMotorPower": "motor %1 gücünü % %2 ayarla",
  	"boost.setMotorDirection": "motor %1 motorunun yönünü %2 olarak ayarla",
  	"boost.getMotorPosition": "motor %1 motorunun konumu",
  	"boost.whenColor": "parça, %1 renginde görüldüğünde",
  	"boost.seeingColor": "%1 parça görüyor musun?",
  	"boost.whenTilted": "%1 eğildiğinde",
  	"boost.getTiltAngle": "eğim açısı %1",
  	"boost.setLightHue": "ışık rengini %1 olarak ayarla"
  };
  var dropdowns$7 = {
  };
  var ignorelt$7 = [
  ];
  var soundEffects$7 = [
  	"ses perdesi",
  	"sağa-sola kaydır"
  ];
  var microbitWhen$7 = [
  	"taşınmış",
  	"sallanmış",
  	"atlanmış"
  ];
  var osis$7 = [
  	"kukladaki diğer dizileri"
  ];
  var definePrefix$7 = [
  ];
  var defineSuffix$7 = [
  	"i",
  	"tanımla"
  ];
  var palette$7 = {
  	Motion: "Hareket",
  	Looks: "Görünüm",
  	Sound: "Ses",
  	Events: "Olaylar",
  	Control: "Kontrol",
  	Sensing: "Algılama",
  	Operators: "Operatörler",
  	Variables: "Değişkenler",
  	"My Blocks": "Bloklarım"
  };
  var math$7 = [
  	"mutlak değer",
  	"aşağı yuvarla",
  	"yukarı yuvarla",
  	"karekök",
  	"sinüs",
  	"kosinüs",
  	"tanjant",
  	"arcsinüs",
  	"arckosinüs",
  	"arctanjant",
  	"ln",
  	"logaritma",
  	"e ^",
  	"10 ^"
  ];
  var aliases$7 = {
  	"_ derece sola dön": "MOTION_TURNLEFT",
  	"_ derece sağa dön": "MOTION_TURNRIGHT",
  	"_ derece saatin tersi yönde dön": "MOTION_TURNLEFT",
  	"_ derece saat yönünde dön": "MOTION_TURNRIGHT",
  	"yeşil bayrak tıklandığında": "EVENT_WHENFLAGCLICKED",
  	son: "scratchblocks:end"
  };
  var name$7 = "Türkçe";
  var percentTranslated$7 = 100;
  var tr = {
  	commands: commands$7,
  	dropdowns: dropdowns$7,
  	ignorelt: ignorelt$7,
  	soundEffects: soundEffects$7,
  	microbitWhen: microbitWhen$7,
  	osis: osis$7,
  	definePrefix: definePrefix$7,
  	defineSuffix: defineSuffix$7,
  	palette: palette$7,
  	math: math$7,
  	aliases: aliases$7,
  	name: name$7,
  	percentTranslated: percentTranslated$7
  };

  var commands$6 = {
  	MOTION_MOVESTEPS: "перемістити на %1 кроків",
  	MOTION_TURNRIGHT: "поворот @turnRight на %1 градусів",
  	MOTION_TURNLEFT: "поворот @turnLeft на %1 градусів",
  	MOTION_POINTINDIRECTION: "повернути в напрямку %1",
  	MOTION_POINTTOWARDS: "слідувати за %1",
  	MOTION_GOTOXY: "перемістити в x: %1 y: %2",
  	MOTION_GOTO: "перейти до %1",
  	MOTION_GLIDESECSTOXY: "ковзати %1 сек до x: %2 y: %3",
  	MOTION_GLIDETO: "ковзати %1 сек до %2",
  	MOTION_CHANGEXBY: "змінити x на %1",
  	MOTION_SETX: "задати x %1",
  	MOTION_CHANGEYBY: "змінити y на %1",
  	MOTION_SETY: "задати y %1",
  	MOTION_SETROTATIONSTYLE: "стиль обертання %1",
  	LOOKS_SAYFORSECS: "говорити %1 %2 сек",
  	LOOKS_SAY: "говорити %1",
  	LOOKS_THINKFORSECS: "подумати %1 %2 сек",
  	LOOKS_THINK: "подумати %1",
  	LOOKS_SHOW: "показати",
  	LOOKS_HIDE: "сховати",
  	LOOKS_SWITCHCOSTUMETO: "змінити образ на %1",
  	LOOKS_NEXTCOSTUME: "наступний образ",
  	LOOKS_NEXTBACKDROP_BLOCK: "наступне тло",
  	LOOKS_SWITCHBACKDROPTO: "змінити тло на %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "змінити тло на %1 та чекати",
  	LOOKS_CHANGEEFFECTBY: "змінити ефект %1 на %2",
  	LOOKS_SETEFFECTTO: "встановити ефект %1 в %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "очистити графічні ефекти",
  	LOOKS_CHANGESIZEBY: "змінити розмір на %1",
  	LOOKS_SETSIZETO: "задати розмір %1",
  	LOOKS_GOTOFRONTBACK: "помістити на %1 план",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "перемістити %1 на %2 шар",
  	SOUND_PLAY: "відтворити звук %1",
  	SOUND_CHANGEEFFECTBY: "змінити ефект %1 на %2",
  	SOUND_SETEFFECTO: "встановити ефект %1 в %2",
  	SOUND_CLEAREFFECTS: "очистити звукові ефекти",
  	SOUND_PLAYUNTILDONE: "відтворити звук %1 до кінця",
  	SOUND_STOPALLSOUNDS: "зупинити всі звуки",
  	"music.playDrumForBeats": "програти на барабані %1 %2 ударів",
  	"music.restForBeats": "пауза %1 тактів",
  	"music.playNoteForBeats": "програти ноту %1 %2 тактів",
  	"music.setInstrument": "грати інструментом %1",
  	SOUND_CHANGEVOLUMEBY: "змінити гучність на %1",
  	SOUND_SETVOLUMETO: "встановити гучність %1%",
  	"music.changeTempo": "змінити темп на %1",
  	"music.setTempo": "встановити темп в %1",
  	"pen.clear": "очистити все",
  	"pen.stamp": "штамп",
  	"pen.penDown": "опустити олівець",
  	"pen.penUp": "підняти олівець",
  	"pen.setColor": "надати олівцю колір %1",
  	"pen.changeHue": "змінити колір олівця на %1",
  	"pen.setColorParam": "надати %1 олівця значення %2",
  	"pen.changeColorParam": "змінити %1 олівця на %2",
  	"pen.setHue": "задати колір олівця %1",
  	"pen.changeShade": "змінити тінь олівця на %1",
  	"pen.setShade": "задати тінь олівця %1",
  	"pen.changeSize": "змінити розмір олівця на %1",
  	"pen.setSize": "задати розмір олівця %1",
  	EVENT_WHENFLAGCLICKED: "коли @greenFlag натиснуто",
  	EVENT_WHENKEYPRESSED: "коли клавішу %1 натиснуто",
  	EVENT_WHENTHISSPRITECLICKED: "коли спрайт натиснуто",
  	EVENT_WHENSTAGECLICKED: "коли сцену натиснуто",
  	EVENT_WHENBACKDROPSWITCHESTO: "коли тло зміниться на %1",
  	EVENT_WHENGREATERTHAN: "коли %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "коли я отримую %1",
  	EVENT_BROADCAST: "оповістити %1",
  	EVENT_BROADCASTANDWAIT: "оповістити %1 і чекати",
  	CONTROL_WAIT: "чекати %1 секунд",
  	CONTROL_REPEAT: "повторити %1",
  	CONTROL_FOREVER: "завжди",
  	CONTROL_IF: "якщо %1 то",
  	CONTROL_WAITUNTIL: "чекати поки %1",
  	CONTROL_REPEATUNTIL: "повторити до %1",
  	CONTROL_STOP: "зупинити %1",
  	CONTROL_STARTASCLONE: "коли я починаю як клон",
  	CONTROL_CREATECLONEOF: "створити клон з %1",
  	CONTROL_DELETETHISCLONE: "вилучити цей клон",
  	SENSING_ASKANDWAIT: "запитати %1 і чекати",
  	"videoSensing.videoToggle": "перемкнути відео %1",
  	"videoSensing.setVideoTransparency": "встановити прозорість відео в %1",
  	"videoSensing.whenMotionGreaterThan": "коли рух відео > %1",
  	SENSING_RESETTIMER: "перезапустити таймер",
  	DATA_SETVARIABLETO: "надати %1 значення %2",
  	DATA_CHANGEVARIABLEBY: "змінити %1 на %2",
  	DATA_SHOWVARIABLE: "показати змінну %1",
  	DATA_HIDEVARIABLE: "сховати змінну %1",
  	DATA_ADDTOLIST: "додати %1 до %2",
  	DATA_DELETEOFLIST: "вилучити %1 з %2",
  	DATA_DELETEALLOFLIST: "вилучити все з %1",
  	MOTION_IFONEDGEBOUNCE: "якщо на межі, відбити",
  	DATA_INSERTATLIST: "вставити %1 на місці %2 списку %3",
  	DATA_REPLACEITEMOFLIST: "замінити елемент %1 в %2 на %3",
  	DATA_SHOWLIST: "показати список %1",
  	DATA_HIDELIST: "сховати список %1",
  	SENSING_OF_XPOSITION: "значення x",
  	SENSING_OF_YPOSITION: "значення y",
  	SENSING_OF_DIRECTION: "напрям",
  	SENSING_OF_COSTUMENUMBER: "образ #",
  	LOOKS_COSTUMENUMBERNAME: "образ %1",
  	SENSING_OF_SIZE: "розмір",
  	SENSING_OF_BACKDROPNAME: "ім’я тла",
  	LOOKS_BACKDROPNUMBERNAME: "тло %1",
  	SENSING_OF_BACKDROPNUMBER: "тло #",
  	SOUND_VOLUME: "гучність",
  	"music.getTempo": "темп",
  	SENSING_TOUCHINGOBJECT: "торкається %1?",
  	SENSING_TOUCHINGCOLOR: "торкається кольору %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "колір %1 торкається %2?",
  	SENSING_DISTANCETO: "відстань до %1",
  	SENSING_ANSWER: "відповідь",
  	SENSING_KEYPRESSED: "клавішу %1 натиснуто?",
  	SENSING_MOUSEDOWN: "мишку натиснуто?",
  	SENSING_MOUSEX: "мишка x",
  	SENSING_MOUSEY: "мишка y",
  	SENSING_SETDRAGMODE: "перетягувати %1",
  	SENSING_LOUDNESS: "гучність",
  	"videoSensing.videoOn": "відео %1 на %2",
  	SENSING_TIMER: "таймер",
  	SENSING_OF: "%1 з %2",
  	SENSING_CURRENT: "сьогодні %1",
  	SENSING_DAYSSINCE2000: "днів після 2000",
  	SENSING_USERNAME: "користувач",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "випадкове від %1 до %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 і %2",
  	OPERATORS_OR: "%1 або %2",
  	OPERATORS_NOT: "не %1",
  	OPERATORS_JOIN: "з'єднати %1 %2",
  	OPERATORS_LETTEROF: "символ %1 у %2",
  	OPERATORS_LENGTH: "довжина %1",
  	OPERATORS_MOD: "остача %1 на %2",
  	OPERATORS_ROUND: "округлити %1",
  	OPERATORS_MATHOP: "%1 з %2",
  	OPERATORS_CONTAINS: "%1 містить %2?",
  	DATA_ITEMOFLIST: "елемент %1 з %2",
  	DATA_ITEMNUMOFLIST: "елемент # %1 з %2",
  	DATA_LENGTHOFLIST: "довжина %1",
  	DATA_LISTCONTAINSITEM: "%1 містить %2?",
  	CONTROL_ELSE: "інакше",
  	SENSING_USERID: "користувач ID",
  	SENSING_LOUD: "гучно?",
  	"text2speech.speakAndWaitBlock": "говорити %1",
  	"text2speech.setVoiceBlock": "встановити голос як %1",
  	"text2speech.setLanguageBlock": "встановити мову %1",
  	"translate.translateBlock": "перекласти %1 на %2",
  	"translate.viewerLanguage": "мова",
  	"makeymakey.whenKeyPressed": "поки клавішу %1 натиснуто",
  	"makeymakey.whenKeysPressedInOrder": "поки натиснуто по порядку %1",
  	"microbit.whenButtonPressed": "коли кнопку %1 натиснуто",
  	"microbit.isButtonPressed": "кнопку %1 натиснуто?",
  	"microbit.whenGesture": "коли %1",
  	"microbit.displaySymbol": "показати %1",
  	"microbit.displayText": "показати текст %1",
  	"microbit.clearDisplay": "очистити дисплей",
  	"microbit.whenTilted": "коли нахил %1",
  	"microbit.isTilted": "нахил %1?",
  	"microbit.tiltAngle": "кут нахилу %1",
  	"microbit.whenPinConnected": "коли контакт %1 приєднано",
  	"ev3.motorTurnClockwise": "увімкнути двигун %1 у такому напрямі на %2 секунд",
  	"ev3.motorTurnCounterClockwise": "увімкнути двигун %1 у  зворотньому напрямі на %2 секунд",
  	"ev3.motorSetPower": "встановити потужність %1 в %2 %",
  	"ev3.getMotorPosition": "позиція двигуна %1",
  	"ev3.whenButtonPressed": "якщо кнопку %1 натиснуто",
  	"ev3.whenDistanceLessThan": "якщо дистанція < %1",
  	"ev3.whenBrightnessLessThan": "якщо яскравість < %1",
  	"ev3.buttonPressed": "кнопку %1 натиснуто?",
  	"ev3.getDistance": "відстань",
  	"ev3.getBrightness": "яскравість",
  	"ev3.beepNote": "пищати %1 %2 секунд",
  	"wedo2.motorOn": "%1 увімкнути",
  	"wedo2.motorOff": "%1 вимкнути",
  	"wedo2.startMotorPower": "встановити потужність %1 %2",
  	"wedo2.setMotorDirection": "встановити напрям %1 %2",
  	"wedo2.whenDistance": "коли дистанція %1 %2",
  	"wedo2.getDistance": "відстань",
  	"wedo2.motorOnFor": "увімкнути %1 на %2 секунд",
  	"wedo2.setLightHue": "встановити колір світла в %1",
  	"wedo2.playNoteFor": "грати ноту %1 %2 секунд",
  	"wedo2.whenTilted": "коли нахил %1",
  	"wedo2.isTilted": "нахилено %1?",
  	"wedo2.getTiltAngle": "кут нахилу %1",
  	"gdxfor.whenGesture": "коли %1",
  	"gdxfor.whenForcePushedOrPulled": "поки сенсор сили %1",
  	"gdxfor.getForce": "сила",
  	"gdxfor.whenTilted": "коли нахилено %1",
  	"gdxfor.isTilted": "нахил %1?",
  	"gdxfor.getTilt": "кут нахилу %1",
  	"gdxfor.isFreeFalling": "падає?",
  	"gdxfor.getSpin": "швидкість обертання %1",
  	"gdxfor.getAcceleration": "прискорення %1",
  	"boost.motorOnFor": "увімкнути %1 на %2 секунд",
  	"boost.motorOnForRotation": "увімкнути %1 на %2 оборотів",
  	"boost.motorOn": "увімкнути %1",
  	"boost.motorOff": "вимкнути %1",
  	"boost.setMotorPower": "встановити %1 швидкість в %2 %",
  	"boost.setMotorDirection": "встановити %1 напрям %2",
  	"boost.getMotorPosition": "позиція %1",
  	"boost.whenColor": "якщо бачить кубик кольору %1 то",
  	"boost.seeingColor": "бачить кубик кольору %1 ?",
  	"boost.whenTilted": "коли нахил %1",
  	"boost.getTiltAngle": "кут нахилу %1",
  	"boost.setLightHue": "встановити колір світла в %1"
  };
  var dropdowns$6 = {
  };
  var ignorelt$6 = [
  ];
  var soundEffects$6 = [
  	"висота",
  	"панорама"
  ];
  var microbitWhen$6 = [
  	"рухається",
  	"струснуто",
  	"підкинуто"
  ];
  var osis$6 = [
  	"інші скрипти цього спрайту"
  ];
  var definePrefix$6 = [
  	"визначити"
  ];
  var defineSuffix$6 = [
  ];
  var palette$6 = {
  	Motion: "Рух",
  	Looks: "Вигляд",
  	Sound: "Звук",
  	Events: "Події",
  	Control: "Керування",
  	Sensing: "Датчики",
  	Operators: "Оператори",
  	Variables: "Змінні",
  	"My Blocks": "Мої блоки"
  };
  var math$6 = [
  	"abs",
  	"менше ціле",
  	"більше ціле",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$6 = {
  };
  var name$6 = "Українська";
  var percentTranslated$6 = 100;
  var uk = {
  	commands: commands$6,
  	dropdowns: dropdowns$6,
  	ignorelt: ignorelt$6,
  	soundEffects: soundEffects$6,
  	microbitWhen: microbitWhen$6,
  	osis: osis$6,
  	definePrefix: definePrefix$6,
  	defineSuffix: defineSuffix$6,
  	palette: palette$6,
  	math: math$6,
  	aliases: aliases$6,
  	name: name$6,
  	percentTranslated: percentTranslated$6
  };

  var commands$5 = {
  	MOTION_MOVESTEPS: "%1 qadam yurish",
  	MOTION_TURNRIGHT: "@turnRight %1 darajaga burilish",
  	MOTION_TURNLEFT: "@turnLeft %1 darajaga burilish",
  	MOTION_POINTINDIRECTION: "%1 harakat yo'nalishi",
  	MOTION_POINTTOWARDS: "%1 tomonga qarash",
  	MOTION_GOTOXY: "x: %1 y: %2 ga borish",
  	MOTION_GOTO: "%1 ga borish",
  	MOTION_GLIDESECSTOXY: "%1 soniyada x: %2 y: %3 ga borish",
  	MOTION_GLIDETO: "%1 soniyada %2 ga borish",
  	MOTION_CHANGEXBY: "X o'qini %1 ga o'zgartirish",
  	MOTION_SETX: "X o'qini %1 ga sozlash",
  	MOTION_CHANGEYBY: "Y o'qini %1 ga o'zgartirish",
  	MOTION_SETY: "Y o'qini %1 ga sozlash",
  	MOTION_SETROTATIONSTYLE: "burilishni %1 ga sozlash",
  	LOOKS_SAYFORSECS: "%1 ni %2 soniya aytish",
  	LOOKS_SAY: "%1 aytish",
  	LOOKS_THINKFORSECS: "%1 ni %2 soniya o'ylash",
  	LOOKS_THINK: "%1 o'ylash",
  	LOOKS_SHOW: "ko'rsatish",
  	LOOKS_HIDE: "yashirish",
  	LOOKS_SWITCHCOSTUMETO: "ko'rinishni %1 ga o'zgartir",
  	LOOKS_NEXTCOSTUME: "keyingi ko'rinish",
  	LOOKS_NEXTBACKDROP_BLOCK: "keyingi fon",
  	LOOKS_SWITCHBACKDROPTO: "fonni %1 ga o'zgartir",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "%1 fonga o'zgartirib kutish",
  	LOOKS_CHANGEEFFECTBY: "%1 effektni %2 ga o'zgartir",
  	LOOKS_SETEFFECTTO: "%1 effektni %2 ga sozlash",
  	LOOKS_CLEARGRAPHICEFFECTS: "grafik effektlarni tozalsh",
  	LOOKS_CHANGESIZEBY: "o'lchamni %1 ga o'zgartir",
  	LOOKS_SETSIZETO: "o'lchamni %1 ga sozlash",
  	LOOKS_GOTOFRONTBACK: "eng %1 ga o'tkazish",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 ga %2 qatlam o'tkazish",
  	SOUND_PLAY: "%1 ni ijro etish",
  	SOUND_CHANGEEFFECTBY: "%1 effektni %2 ga o'zgartir",
  	SOUND_SETEFFECTO: "%1 effektni %2 ga sozlash",
  	SOUND_CLEAREFFECTS: "ovos effektini o'chirish",
  	SOUND_PLAYUNTILDONE: "%1 ni tugaguncha ijro etish",
  	SOUND_STOPALLSOUNDS: "hamma ovozlarni to'xtat",
  	"music.playDrumForBeats": "%1 asbobda %2 zarbada ijro etish",
  	"music.restForBeats": "%1 zarba kutish",
  	"music.playNoteForBeats": "%1 ni %2 zarbada ijro etish",
  	"music.setInstrument": "asbobni %1 ga sozlash",
  	SOUND_CHANGEVOLUMEBY: "ovozni %1 ga o'zgartirish",
  	SOUND_SETVOLUMETO: "ovozni %1% ga sozlash",
  	"music.changeTempo": "tezlikni %1 o'zgartirish",
  	"music.setTempo": "tezlikni %1 ga sozlash",
  	"pen.clear": "tozalash",
  	"pen.stamp": "pechat qo'yish",
  	"pen.penDown": "qalamni tushirish",
  	"pen.penUp": "qalamni ko'tarish",
  	"pen.setColor": "qalam rangini %1 ga sozlash",
  	"pen.changeHue": "qalam rangini %1 ga o'zgartirish",
  	"pen.setColorParam": "qalamni %1 %2 ga sozlash",
  	"pen.changeColorParam": "qalamni %1 %2 ga o'zgartirish",
  	"pen.setHue": "qalam rangini %1 ga sozlash",
  	"pen.changeShade": "%1 tomonidan qalam shadi o'zgarishi",
  	"pen.setShade": "%1 ga sozlamalarni joylashtirish",
  	"pen.changeSize": "qalam o'lchamini %1 ga o'zgartirish",
  	"pen.setSize": "qalam o'lchamini %1 ga sozlash",
  	EVENT_WHENFLAGCLICKED: "@greenFlag bosilganda",
  	EVENT_WHENKEYPRESSED: "%1 bosilganda",
  	EVENT_WHENTHISSPRITECLICKED: "shu sprayt bosilganda",
  	EVENT_WHENSTAGECLICKED: "sahna bosilganda",
  	EVENT_WHENBACKDROPSWITCHESTO: "%1 fon o'zgarganda",
  	EVENT_WHENGREATERTHAN: "%1 > %2 bo'lganda",
  	EVENT_WHENBROADCASTRECEIVED: "%1 ga teginganda",
  	EVENT_BROADCAST: "%1 ni tarqatish",
  	EVENT_BROADCASTANDWAIT: "%1 ni tarqatib kutish",
  	CONTROL_WAIT: "%1 soniya kutish",
  	CONTROL_REPEAT: "%1 marta takrorlash",
  	CONTROL_FOREVER: "har doim",
  	CONTROL_IF: "agar %1 bo'lsa",
  	CONTROL_WAITUNTIL: "%1 gacha kutish",
  	CONTROL_REPEATUNTIL: "%1 gacha takrorlash",
  	CONTROL_STOP: "to'xtatish %1",
  	CONTROL_STARTASCLONE: "nusxani qabul qilganda",
  	CONTROL_CREATECLONEOF: "%1 o'zidan nusxa yaratish",
  	CONTROL_DELETETHISCLONE: "bu nusxani o'chirish",
  	SENSING_ASKANDWAIT: "%1 ni so'rab kutish",
  	"videoSensing.videoToggle": "video %1 yoqing",
  	"videoSensing.setVideoTransparency": "vidio shaffofligini %1 ga sozlash",
  	"videoSensing.whenMotionGreaterThan": "vidio harakati > %1 bo'lganda",
  	SENSING_RESETTIMER: "taymerni qaytarish",
  	DATA_SETVARIABLETO: "%1 ni %2 ga sozlash",
  	DATA_CHANGEVARIABLEBY: "%1 ni %2 ga o'zgartirish",
  	DATA_SHOWVARIABLE: "%1 o'zgaruvchini ko'rsatish",
  	DATA_HIDEVARIABLE: "%1 o'zgaruvchini yashirish",
  	DATA_ADDTOLIST: "%1 ni %2 ga qo'shish",
  	DATA_DELETEOFLIST: "%1 ni %2 dan o'chirish",
  	DATA_DELETEALLOFLIST: "%1 hammasini o'chirish",
  	MOTION_IFONEDGEBOUNCE: "agar devorga urilsa qaytish",
  	DATA_INSERTATLIST: "%1 ni %2 dan %3 ga qo'shish",
  	DATA_REPLACEITEMOFLIST: "%2 ro'yxatning %1 chi mavzusini %3 ga o'zgartirish",
  	DATA_SHOWLIST: "%1 ro'yxatni ko'rsatish",
  	DATA_HIDELIST: "%1 ro'yxatni yashirish",
  	SENSING_OF_XPOSITION: "X koordinatasi",
  	SENSING_OF_YPOSITION: "Y koordinatasi",
  	SENSING_OF_DIRECTION: "yo'nalish",
  	SENSING_OF_COSTUMENUMBER: "kostyum #",
  	LOOKS_COSTUMENUMBERNAME: "ko'rinish %1",
  	SENSING_OF_SIZE: "o'lcham",
  	SENSING_OF_BACKDROPNAME: "fonning nomi",
  	LOOKS_BACKDROPNUMBERNAME: "fon %1",
  	SENSING_OF_BACKDROPNUMBER: "fonning soni",
  	SOUND_VOLUME: "ovoz",
  	"music.getTempo": "tezlik",
  	SENSING_TOUCHINGOBJECT: "%1 ga teginganda",
  	SENSING_TOUCHINGCOLOR: "%1 ga teginganda",
  	SENSING_COLORISTOUCHINGCOLOR: "%1 rang %2 rangga tegdimi?",
  	SENSING_DISTANCETO: "%1 gacha masofa",
  	SENSING_ANSWER: "javob",
  	SENSING_KEYPRESSED: "%1 tugmasini bosdingizmi?",
  	SENSING_MOUSEDOWN: "Sichqonchani bosdingizmi?",
  	SENSING_MOUSEX: "sichiqoncha X koordinatasi",
  	SENSING_MOUSEY: "sichiqoncha Y koordinatasi",
  	SENSING_SETDRAGMODE: "Drag rejimni sudrab %1 ga sozlash",
  	SENSING_LOUDNESS: "tovush",
  	"videoSensing.videoOn": "vidio %1 da %2",
  	SENSING_TIMER: "taymer",
  	SENSING_OF: "%1 dan %2",
  	SENSING_CURRENT: "hozirgi %1",
  	SENSING_DAYSSINCE2000: "2000-yildan keyingi kunlar",
  	SENSING_USERNAME: "foydalanuvchi ismi",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "%1 dan %2 gacha taxminiy",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 va %2",
  	OPERATORS_OR: "%1 yoki %2",
  	OPERATORS_NOT: "%1 bo'lmasa",
  	OPERATORS_JOIN: "%1 va %2 ni qo'shish",
  	OPERATORS_LETTEROF: "%1 %2 xat",
  	OPERATORS_LENGTH: "uzunligi %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "%1 atrofida",
  	OPERATORS_MATHOP: "%1 dan %2",
  	OPERATORS_CONTAINS: "%1 tarkibida %2 mavjudmi?",
  	DATA_ITEMOFLIST: "%2 ro'yxatning %1 chi mavzusi",
  	DATA_ITEMNUMOFLIST: "%2 ro'yxatda %1 mavzuning joylashuvi",
  	DATA_LENGTHOFLIST: "uzunligidan %1",
  	DATA_LISTCONTAINSITEM: "%1 %2 ni ichiga oladimi?",
  	CONTROL_ELSE: "aks holda",
  	SENSING_USERID: "foydalanuvchi ID",
  	SENSING_LOUD: "baland ovoz?",
  	"text2speech.speakAndWaitBlock": "gapirish %1",
  	"text2speech.setVoiceBlock": "ovozni %1 ga sozlash",
  	"text2speech.setLanguageBlock": "tilni %1ga sozlash",
  	"translate.translateBlock": "%1 ni %2 ga tarjima qilish",
  	"translate.viewerLanguage": "til",
  	"makeymakey.whenKeyPressed": "%1 tugma bosilganda",
  	"makeymakey.whenKeysPressedInOrder": "%1 tartibda bosilganda",
  	"microbit.whenButtonPressed": "%1 tugmasi bosilganda",
  	"microbit.isButtonPressed": "%1 tugmasini bosdingizmi?",
  	"microbit.whenGesture": "%1 bo'lganda",
  	"microbit.displaySymbol": "ekran %1",
  	"microbit.displayText": "ekran yozuvi %1",
  	"microbit.clearDisplay": "aniq ko'rsatiladi",
  	"microbit.whenTilted": "egilib %1",
  	"microbit.isTilted": "%1 tomoniga egilish?",
  	"microbit.tiltAngle": "burilish burchagi %1",
  	"microbit.whenPinConnected": "pin %1 ulanganda",
  	"ev3.motorTurnClockwise": "%1 Motorni %2 soniya davomida ushbu tomonga aylantiring",
  	"ev3.motorTurnCounterClockwise": "%1 Motorni %2 soniya davomida u er tomonga aylantiring",
  	"ev3.motorSetPower": "motor %1 kuchini %2 % sozlash",
  	"ev3.getMotorPosition": "motor %1 holatiga o'tish",
  	"ev3.whenButtonPressed": "%1 tugmasi bosilganda",
  	"ev3.whenDistanceLessThan": "masofa < %1",
  	"ev3.whenBrightnessLessThan": "Yorqinligi < %1 bo'lganda",
  	"ev3.buttonPressed": "tugma %1 bosildimi?",
  	"ev3.getDistance": "masofa",
  	"ev3.getBrightness": "yorqinlik",
  	"ev3.beepNote": "%2 soniya davomida %1 ta ovozli signal eshitiladi",
  	"wedo2.motorOn": "%1 ni yoqing",
  	"wedo2.motorOff": "%1 ni o'chiring",
  	"wedo2.startMotorPower": "%1 kuchini %2 ga qo'ying",
  	"wedo2.setMotorDirection": "%1 yo'nalishini %2 tomonga o'rnatish",
  	"wedo2.whenDistance": "%1 %2 ga yetganingizda",
  	"wedo2.getDistance": "masofa",
  	"wedo2.motorOnFor": "%2 soniya uchun %1 yoqing",
  	"wedo2.setLightHue": "ochiq rangni %1 ga o'rnatish",
  	"wedo2.playNoteFor": "%2 soniya uchun %1 eslatmasini ijro eting",
  	"wedo2.whenTilted": "%1 o'girildikda",
  	"wedo2.isTilted": "tilga olingan %1?",
  	"wedo2.getTiltAngle": "%1 burilish burchagi",
  	"gdxfor.whenGesture": "%1 bo'lganda",
  	"gdxfor.whenForcePushedOrPulled": "Majburiy sensor %1",
  	"gdxfor.getForce": "kuch",
  	"gdxfor.whenTilted": "%1 yiqilganida",
  	"gdxfor.isTilted": "egilish burchagi %1?",
  	"gdxfor.getTilt": "%1 egilish",
  	"gdxfor.isFreeFalling": "tushganmi?",
  	"gdxfor.getSpin": "siqish tezligi %1",
  	"gdxfor.getAcceleration": "tezlashtirish %1",
  	"boost.motorOnFor": "motorni %1 soniyalar %2 davomida aylantiring",
  	"boost.motorOnForRotation": "motorni aylantiring %1 aylanishi %2 uchun",
  	"boost.motorOn": "motor %1 ni yoqing",
  	"boost.motorOff": "motor %1  ni ochiring",
  	"boost.setMotorPower": "motorni %1 tezligini %2 ga qo'ying",
  	"boost.setMotorDirection": "motorni joylashtirish %1 yo'nalishi %2",
  	"boost.getMotorPosition": "motor %1 positsiyasi",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "%1 rangdagi g'ishtni ko'ryapsizmi?",
  	"boost.whenTilted": "%1 o'girildikda",
  	"boost.getTiltAngle": "%1 burilish burchagi",
  	"boost.setLightHue": "ochiq rangni %1 ga o'rnatish"
  };
  var dropdowns$5 = {
  };
  var ignorelt$5 = [
  ];
  var soundEffects$5 = [
  	"ovoz balandligi",
  	"ovoz manzili o'ng-chap"
  ];
  var microbitWhen$5 = [
  	"harakatlangan",
  	"silkingan",
  	"sakragan"
  ];
  var osis$5 = [
  	"boshqa spraytlardagi skriptlar"
  ];
  var definePrefix$5 = [
  ];
  var defineSuffix$5 = [
  	"ni",
  	"belgilash"
  ];
  var palette$5 = {
  	Motion: "Harakatlar",
  	Looks: "Ko'rinishlar",
  	Sound: "Ovozlar",
  	Events: "Hodisalar",
  	Control: "Boshqaruvchi",
  	Sensing: "Sezgirlik",
  	Operators: "Amallar",
  	Variables: "O'zgaruvchi",
  	"My Blocks": "Mening bloklarim"
  };
  var math$5 = [
  	"modul",
  	"pol",
  	"ship",
  	"sqrt",
  	"sinus qiymati",
  	"kosinus qiymati",
  	"tan qiymati",
  	"asinus qiymati",
  	"akosinus qiymati",
  	"atan qiymati",
  	"Ichida",
  	"logarifm",
  	"e ^",
  	"10 ^"
  ];
  var aliases$5 = {
  };
  var name$5 = "Oʻzbekcha";
  var percentTranslated$5 = 100;
  var uz = {
  	commands: commands$5,
  	dropdowns: dropdowns$5,
  	ignorelt: ignorelt$5,
  	soundEffects: soundEffects$5,
  	microbitWhen: microbitWhen$5,
  	osis: osis$5,
  	definePrefix: definePrefix$5,
  	defineSuffix: defineSuffix$5,
  	palette: palette$5,
  	math: math$5,
  	aliases: aliases$5,
  	name: name$5,
  	percentTranslated: percentTranslated$5
  };

  var commands$4 = {
  	MOTION_MOVESTEPS: "di chuyển %1 bước",
  	MOTION_TURNRIGHT: "xoay @turnRight %1 độ",
  	MOTION_TURNLEFT: "xoay @turnLeft %1 độ",
  	MOTION_POINTINDIRECTION: "đặt hướng bằng %1",
  	MOTION_POINTTOWARDS: "hướng về phía đối tượng %1",
  	MOTION_GOTOXY: "đi tới điểm x: %1 y: %2",
  	MOTION_GOTO: "đi tới %1",
  	MOTION_GLIDESECSTOXY: "lướt trong %1 giây tới điểm x: %2 y: %3",
  	MOTION_GLIDETO: "lướt trong %1 giây tới %2",
  	MOTION_CHANGEXBY: "thay đổi x một lượng %1",
  	MOTION_SETX: "đặt x bằng %1",
  	MOTION_CHANGEYBY: "thay đổi y một lượng%1",
  	MOTION_SETY: "đặt y bằng %1",
  	MOTION_SETROTATIONSTYLE: "đặt kiểu xoay %1",
  	LOOKS_SAYFORSECS: "nói %1 trong %2 giây",
  	LOOKS_SAY: "nói %1",
  	LOOKS_THINKFORSECS: "nghĩ %1 trong %2 giây",
  	LOOKS_THINK: "nghĩ %1",
  	LOOKS_SHOW: "hiện",
  	LOOKS_HIDE: "ẩn",
  	LOOKS_SWITCHCOSTUMETO: "chuyển sang trang phục %1",
  	LOOKS_NEXTCOSTUME: "trang phục kế tiếp",
  	LOOKS_NEXTBACKDROP_BLOCK: "phông nền tiếp theo",
  	LOOKS_SWITCHBACKDROPTO: "đổi phông nền thành %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "đổi phông nền thành %1 và đợi",
  	LOOKS_CHANGEEFFECTBY: "thay đổi hiệu ứng %1 một lượng %2",
  	LOOKS_SETEFFECTTO: "đặt hiệu ứng %1 bằng %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "bỏ các hiệu ứng đồ họa",
  	LOOKS_CHANGESIZEBY: "đổi kích thước một lượng %1",
  	LOOKS_SETSIZETO: "đặt kích thước thành %1 %",
  	LOOKS_GOTOFRONTBACK: "đi tới lớp %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "đi %1 %2 lớp",
  	SOUND_PLAY: "bắt đầu âm thanh %1",
  	SOUND_CHANGEEFFECTBY: "thay đổi hiệu ứng %1 một lượng %2",
  	SOUND_SETEFFECTO: "đặt hiệu ứng %1 bằng %2",
  	SOUND_CLEAREFFECTS: "xóa hiệu ứng âm thanh",
  	SOUND_PLAYUNTILDONE: "phát âm thanh %1 đến hết",
  	SOUND_STOPALLSOUNDS: "ngừng mọi âm thanh",
  	"music.playDrumForBeats": "chơi trống %1 trong %2 nhịp",
  	"music.restForBeats": "nghỉ trong %1 nhịp",
  	"music.playNoteForBeats": "chơi nốt nhạc %1 trong %2 nhịp",
  	"music.setInstrument": "đặt nhạc cụ là %1",
  	SOUND_CHANGEVOLUMEBY: "thay đổi âm lượng một lượng %1",
  	SOUND_SETVOLUMETO: "đặt âm lượng %1%",
  	"music.changeTempo": "thay đổi nhịp độ một lượng %1",
  	"music.setTempo": "thay đổi nhịp độ thành %1",
  	"pen.clear": "Xóa tất cả",
  	"pen.stamp": "in hình",
  	"pen.penDown": "đặt bút",
  	"pen.penUp": "nhấc bút",
  	"pen.setColor": "chọn bút màu %1",
  	"pen.changeHue": "thay đổi màu bút vẽ bằng %1",
  	"pen.setColorParam": "đặt %1 bút bằng %2",
  	"pen.changeColorParam": "thay đổi %1 bút một lượng %2",
  	"pen.setHue": "chọn bút màu %1",
  	"pen.changeShade": "đổi độ đậm bút vẽ bằng %1",
  	"pen.setShade": "đặt độ đậm của bút vẽ thành %1",
  	"pen.changeSize": "thay đổi độ dày của nét bút %1",
  	"pen.setSize": "đặt kích thước bút vẽ bằng %1",
  	EVENT_WHENFLAGCLICKED: "Khi bấm vào @greenFlag",
  	EVENT_WHENKEYPRESSED: "khi bấm phím %1",
  	EVENT_WHENTHISSPRITECLICKED: "Khi bấm vào nhân vật này",
  	EVENT_WHENSTAGECLICKED: "khi bấm vào phông nền",
  	EVENT_WHENBACKDROPSWITCHESTO: "khi phông nền chuyển thành %1",
  	EVENT_WHENGREATERTHAN: "khi %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "khi nhận %1",
  	EVENT_BROADCAST: "phát tin %1",
  	EVENT_BROADCASTANDWAIT: "phát tin %1 và đợi",
  	CONTROL_WAIT: "đợi %1 giây",
  	CONTROL_REPEAT: "lặp lại %1",
  	CONTROL_FOREVER: "liên tục",
  	CONTROL_IF: "nếu %1 thì",
  	CONTROL_WAITUNTIL: "đợi đến khi %1",
  	CONTROL_REPEATUNTIL: "lặp lại cho đến khi %1",
  	CONTROL_STOP: "dừng lại %1",
  	CONTROL_STARTASCLONE: "khi tôi bắt đầu là một bản sao",
  	CONTROL_CREATECLONEOF: "tạo bản sao của %1",
  	CONTROL_DELETETHISCLONE: "xóa bản sao này",
  	SENSING_ASKANDWAIT: "hỏi %1 và đợi",
  	"videoSensing.videoToggle": "mở video %1",
  	"videoSensing.setVideoTransparency": "đặt độ trong suốt của video thành %1",
  	"videoSensing.whenMotionGreaterThan": "khi chuyển động của video > %1",
  	SENSING_RESETTIMER: "đặt lại đống hồ bấm giờ",
  	DATA_SETVARIABLETO: "đặt %1 thành %2",
  	DATA_CHANGEVARIABLEBY: "thay đổi %1 một lượng %2",
  	DATA_SHOWVARIABLE: "hiện biến số %1",
  	DATA_HIDEVARIABLE: "ẩn biến số %1",
  	DATA_ADDTOLIST: "thêm phần tử %1 vào trong %2",
  	DATA_DELETEOFLIST: "xóa phần tử thứ %1 của %2",
  	DATA_DELETEALLOFLIST: "Xóa hết tất cả trong liệt kê %1",
  	MOTION_IFONEDGEBOUNCE: "bật lại nếu chạm cạnh",
  	DATA_INSERTATLIST: "thêm phần tử %1 tại vị trí %2 của %3",
  	DATA_REPLACEITEMOFLIST: "thay thế phần tử thứ %1 của danh sách %2 bằng %3",
  	DATA_SHOWLIST: "hiện danh sách %1",
  	DATA_HIDELIST: "ẩn danh sách %1",
  	SENSING_OF_XPOSITION: "tọa độ x",
  	SENSING_OF_YPOSITION: "tọa độ y",
  	SENSING_OF_DIRECTION: "hướng",
  	SENSING_OF_COSTUMENUMBER: "trang phục #",
  	LOOKS_COSTUMENUMBERNAME: "trang phục %1",
  	SENSING_OF_SIZE: "kích thước",
  	SENSING_OF_BACKDROPNAME: "tên phông nền",
  	LOOKS_BACKDROPNUMBERNAME: "phông nền %1",
  	SENSING_OF_BACKDROPNUMBER: "phông nền #",
  	SOUND_VOLUME: "âm lượng",
  	"music.getTempo": "nhịp độ",
  	SENSING_TOUCHINGOBJECT: "đang chạm %1?",
  	SENSING_TOUCHINGCOLOR: "đang chạm màu %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "màu %1 đang chạm %2?",
  	SENSING_DISTANCETO: "khoảng cách đến %1",
  	SENSING_ANSWER: "trả lời",
  	SENSING_KEYPRESSED: "phím %1 được bấm?",
  	SENSING_MOUSEDOWN: "chuột được nhấn?",
  	SENSING_MOUSEX: "tọa độ x con trỏ chuột",
  	SENSING_MOUSEY: "tọa độ y con trỏ chuột",
  	SENSING_SETDRAGMODE: "đặt chế độ kéo %1",
  	SENSING_LOUDNESS: "độ ồn",
  	"videoSensing.videoOn": "mở %1 trên %2",
  	SENSING_TIMER: "đồng hồ bấm giờ",
  	SENSING_OF: "%1 của %2",
  	SENSING_CURRENT: "%1 hiện tại",
  	SENSING_DAYSSINCE2000: "số ngày từ năm 2000",
  	SENSING_USERNAME: "tên đăng nhập",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "lấy ngẫu nhiên từ %1 đến %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 và %2",
  	OPERATORS_OR: "%1 hoặc %2",
  	OPERATORS_NOT: "không phải %1",
  	OPERATORS_JOIN: "kết hợp %1 %2",
  	OPERATORS_LETTEROF: "ký tự thứ %1 của chuỗi %2",
  	OPERATORS_LENGTH: "độ dài của %1",
  	OPERATORS_MOD: "%1 chia lấy dư %2",
  	OPERATORS_ROUND: "làm tròn %1",
  	OPERATORS_MATHOP: "%1 của %2",
  	OPERATORS_CONTAINS: "%1 chứa ký tự %2?",
  	DATA_ITEMOFLIST: "phần tử thứ %1 của %2",
  	DATA_ITEMNUMOFLIST: "số thứ tự của %1 trong %2",
  	DATA_LENGTHOFLIST: "kích thước của %1",
  	DATA_LISTCONTAINSITEM: "%1 chứa phần tử %2?",
  	CONTROL_ELSE: "nếu không thì",
  	SENSING_USERID: "id người dùng",
  	SENSING_LOUD: "tiếng to?",
  	"text2speech.speakAndWaitBlock": "nói %1",
  	"text2speech.setVoiceBlock": "set voice to %1",
  	"text2speech.setLanguageBlock": "set language to %1",
  	"translate.translateBlock": "dịch %1 sang ngôn ngữ %2",
  	"translate.viewerLanguage": "language",
  	"makeymakey.whenKeyPressed": "when %1 key pressed",
  	"makeymakey.whenKeysPressedInOrder": "when %1 pressed in order",
  	"microbit.whenButtonPressed": "when %1 button pressed",
  	"microbit.isButtonPressed": "%1 được bấm?",
  	"microbit.whenGesture": "when %1",
  	"microbit.displaySymbol": "hiển thị %1",
  	"microbit.displayText": "hiển thị văn bản %1",
  	"microbit.clearDisplay": "xóa hiển thị",
  	"microbit.whenTilted": "when tilted %1",
  	"microbit.isTilted": "tilted %1?",
  	"microbit.tiltAngle": "tilt angle %1",
  	"microbit.whenPinConnected": "when pin %1 connected",
  	"ev3.motorTurnClockwise": "Đặt mô-tơ của đầu ra %1 xoay chiều kim đồng hồ trong vòng %2 giây",
  	"ev3.motorTurnCounterClockwise": "Đặt mô-tơ của đầu ra %1 xoay ngược chiều kim đồng hồ trong vòng %2 giây",
  	"ev3.motorSetPower": "Đặt mô-tơ của đầu ra %1với sức mạnh %2%",
  	"ev3.getMotorPosition": "Đặt mô-tơ của đầu ra%1 đo độ xoay tổng cộng",
  	"ev3.whenButtonPressed": "khi nút %1 được bấm",
  	"ev3.whenDistanceLessThan": "khi khoảng cách < %1",
  	"ev3.whenBrightnessLessThan": "khi độ sáng < %1",
  	"ev3.buttonPressed": "Nút %1 đã được ấn?",
  	"ev3.getDistance": "khoảng cách",
  	"ev3.getBrightness": "độ sáng",
  	"ev3.beepNote": "Phát nốt %1 trong vòng %2 giây",
  	"wedo2.motorOn": "turn %1 on",
  	"wedo2.motorOff": "turn %1 off",
  	"wedo2.startMotorPower": "set %1 power to %2",
  	"wedo2.setMotorDirection": "set %1 direction to %2",
  	"wedo2.whenDistance": "when distance %1 %2",
  	"wedo2.getDistance": "khoảng cách",
  	"wedo2.motorOnFor": "turn %1 on for %2 seconds",
  	"wedo2.setLightHue": "set light color to %1",
  	"wedo2.playNoteFor": "chơi nốt nhạc trong %1 trong %2 giây",
  	"wedo2.whenTilted": "when tilted %1",
  	"wedo2.isTilted": "tilted %1?",
  	"wedo2.getTiltAngle": "tilt angle %1",
  	"gdxfor.whenGesture": "when %1",
  	"gdxfor.whenForcePushedOrPulled": "when force sensor %1",
  	"gdxfor.getForce": "force",
  	"gdxfor.whenTilted": "when tilted %1",
  	"gdxfor.isTilted": "tilted %1?",
  	"gdxfor.getTilt": "tilt angle %1",
  	"gdxfor.isFreeFalling": "falling?",
  	"gdxfor.getSpin": "spin speed %1",
  	"gdxfor.getAcceleration": "acceleration %1",
  	"boost.motorOnFor": "turn motor %1 for %2 seconds",
  	"boost.motorOnForRotation": "turn motor %1 for %2 rotations",
  	"boost.motorOn": "turn motor %1 on",
  	"boost.motorOff": "turn motor %1 off",
  	"boost.setMotorPower": "set motor %1 speed to %2 %",
  	"boost.setMotorDirection": "set motor %1 direction %2",
  	"boost.getMotorPosition": "motor %1 position",
  	"boost.whenColor": "when %1 brick seen",
  	"boost.seeingColor": "seeing %1 brick?",
  	"boost.whenTilted": "when tilted %1",
  	"boost.getTiltAngle": "tilt angle %1",
  	"boost.setLightHue": "set light color to %1"
  };
  var dropdowns$4 = {
  };
  var ignorelt$4 = [
  ];
  var soundEffects$4 = [
  	"cao độ",
  	"pan trái/phải"
  ];
  var microbitWhen$4 = [
  	"moved",
  	"shaken",
  	"jumped"
  ];
  var osis$4 = [
  	"other scripts in sprite"
  ];
  var definePrefix$4 = [
  	"định",
  	"nghĩa"
  ];
  var defineSuffix$4 = [
  ];
  var palette$4 = {
  	Motion: "Chuyển động",
  	Looks: "Hiển thị",
  	Sound: "Âm thanh",
  	Events: "Sự kiện",
  	Control: "Điều khiển",
  	Sensing: "Cảm biến",
  	Operators: "Các phép toán",
  	Variables: "Các biến số",
  	"My Blocks": "Khối của tôi"
  };
  var math$4 = [
  	"giá trị tuyệt đối",
  	"làm tròn xuống",
  	"trần",
  	"căn bậc hai",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"trong",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$4 = {
  };
  var name$4 = "Tiếng Việt";
  var percentTranslated$4 = 100;
  var vi = {
  	commands: commands$4,
  	dropdowns: dropdowns$4,
  	ignorelt: ignorelt$4,
  	soundEffects: soundEffects$4,
  	microbitWhen: microbitWhen$4,
  	osis: osis$4,
  	definePrefix: definePrefix$4,
  	defineSuffix: defineSuffix$4,
  	palette: palette$4,
  	math: math$4,
  	aliases: aliases$4,
  	name: name$4,
  	percentTranslated: percentTranslated$4
  };

  var commands$3 = {
  	MOTION_MOVESTEPS: "hamba %1 amanyathelo",
  	MOTION_TURNRIGHT: "guqula @turnRight %1 iidigri",
  	MOTION_TURNLEFT: "guqula @turnLeft %1 iidigri",
  	MOTION_POINTINDIRECTION: "yolatha kwicala %1",
  	MOTION_POINTTOWARDS: "yolatha ngaku %1",
  	MOTION_GOTOXY: "yiya ku x: %1 y: %2",
  	MOTION_GOTO: "yiya ku %1",
  	MOTION_GLIDESECSTOXY: "tyibilikela %1 umzuzwana ku x: %2 y: %3",
  	MOTION_GLIDETO: "tyibilikela %1 imizuzwana ku %2",
  	MOTION_CHANGEXBY: "guqula x ngo %1",
  	MOTION_SETX: "ngqamanisa x no %1",
  	MOTION_CHANGEYBY: "guqula y ngo %1",
  	MOTION_SETY: "ngqamanisa y no %1",
  	MOTION_SETROTATIONSTYLE: "lungisa uhlobo lojikelezo %1",
  	LOOKS_SAYFORSECS: "yithi %1 i %2 imizuzwana",
  	LOOKS_SAY: "yithi %1",
  	LOOKS_THINKFORSECS: "cinga %1 i %2 yemizuzwana",
  	LOOKS_THINK: "cinga %1",
  	LOOKS_SHOW: "bonisa",
  	LOOKS_HIDE: "fihla",
  	LOOKS_SWITCHCOSTUMETO: "guqulela ikhostyum ku %1",
  	LOOKS_NEXTCOSTUME: "elandelayo ikhostyum",
  	LOOKS_NEXTBACKDROP_BLOCK: "umva olandelayo",
  	LOOKS_SWITCHBACKDROPTO: "guqulelaa umva ku %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "guqula umva %1 ulinde",
  	LOOKS_CHANGEEFFECTBY: "guqula %1 ifuthe ngo %2",
  	LOOKS_SETEFFECTTO: "lungisa %1 ifuthe ku %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "imizobo ecacileyo",
  	LOOKS_CHANGESIZEBY: "guqula ubungakanani %1",
  	LOOKS_SETSIZETO: "lungiselela ubungakanani bube %1 %",
  	LOOKS_GOTOFRONTBACK: "yiya ku %1 leya",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "yiya kwii %1 %2 leya",
  	SOUND_PLAY: "qala isandi%1",
  	SOUND_CHANGEEFFECTBY: "tshintsha %1 ifuthe ngo %2",
  	SOUND_SETEFFECTO: "lungiselela %1 ifuthe ku %2",
  	SOUND_CLEAREFFECTS: "ifuthe lesandi esicacileyo",
  	SOUND_PLAYUNTILDONE: "dlala isandi %1 side siphele",
  	SOUND_STOPALLSOUNDS: "cima zonke izandi",
  	"music.playDrumForBeats": "dlala igubu %1 kule %2",
  	"music.restForBeats": "phumza i %1",
  	"music.playNoteForBeats": "dlala isandi %1 kule %2",
  	"music.setInstrument": "lungiselela isixhobo kwi %1",
  	SOUND_CHANGEVOLUMEBY: "guqula ubungakanani besandingo %1",
  	SOUND_SETVOLUMETO: "lungiselela ubungakanani besandi ku %1%",
  	"music.changeTempo": "guqula isantya nge %1",
  	"music.setTempo": "lungiselela isantya %1",
  	"pen.clear": "cima konke",
  	"pen.stamp": "ngqisha",
  	"pen.penDown": "usiba phantsi",
  	"pen.penUp": "usiba phezulu",
  	"pen.setColor": "lungiselela umbala wosiba ube %1",
  	"pen.changeHue": "guqula umbala wesiba nge %1",
  	"pen.setColorParam": "lungiselela usiba %1 ku %2",
  	"pen.changeColorParam": "guqula usiba %1 nge %2",
  	"pen.setHue": "lungiselela umbala wosiba ube %1",
  	"pen.changeShade": "guqula usiba ngesithunzi %1",
  	"pen.setShade": "lungiselela isithinzi sosiba sibe %1",
  	"pen.changeSize": "guqula usiba ngobungakanani %1",
  	"pen.setSize": "lungiselela ubungakanani bosiba bube %1",
  	EVENT_WHENFLAGCLICKED: "xa @greenFlag ecofiwe",
  	EVENT_WHENKEYPRESSED: "xa %1 iqhosha licinezelwe",
  	EVENT_WHENTHISSPRITECLICKED: "ukuba ucofe i-sprite",
  	EVENT_WHENSTAGECLICKED: "xa ucofe iqonga",
  	EVENT_WHENBACKDROPSWITCHESTO: "xa umva utshintshela ku %1",
  	EVENT_WHENGREATERTHAN: "xa %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "xa ndifumana %1",
  	EVENT_BROADCAST: "usasazo %1",
  	EVENT_BROADCASTANDWAIT: "sasaza %1 ulinde",
  	CONTROL_WAIT: "yima %1 umzuzwana",
  	CONTROL_REPEAT: "phinda %1",
  	CONTROL_FOREVER: "naphakade",
  	CONTROL_IF: "if %1 then",
  	CONTROL_WAITUNTIL: "linda kude kube %1",
  	CONTROL_REPEATUNTIL: "pinda kude kube %1",
  	CONTROL_STOP: "yima %1",
  	CONTROL_STARTASCLONE: "xa ndiqala njengomfanekiso",
  	CONTROL_CREATECLONEOF: "yenza umfanekiso %1",
  	CONTROL_DELETETHISCLONE: "cima lomfanekiso",
  	SENSING_ASKANDWAIT: "buza %1 ulinde",
  	"videoSensing.videoToggle": "guqula ividyo %1",
  	"videoSensing.setVideoTransparency": "lungiselela ukubonisa kwelinye icala kwevidyo %1",
  	"videoSensing.whenMotionGreaterThan": "xa ukushukuma kwevidyo > %1",
  	SENSING_RESETTIMER: "lungiselela isibali xesha okutsha",
  	DATA_SETVARIABLETO: "lungiselela %1 ukuya %2",
  	DATA_CHANGEVARIABLEBY: "guqula %1 ngo %2",
  	DATA_SHOWVARIABLE: "bonakalisa i-variable %1",
  	DATA_HIDEVARIABLE: "fihla i-variable %1",
  	DATA_ADDTOLIST: "yongeza %1 ku %2",
  	DATA_DELETEOFLIST: "cima %1 ka %2",
  	DATA_DELETEALLOFLIST: "cima konke okuka %1",
  	MOTION_IFONEDGEBOUNCE: "ukuba ucuphekile, taka",
  	DATA_INSERTATLIST: "faka %1 ku %2 ka %3",
  	DATA_REPLACEITEMOFLIST: "beka endaweni yento %1 ka %2 u %3",
  	DATA_SHOWLIST: "bonisa uluhlu %1",
  	DATA_HIDELIST: "fihla uluhlu %1",
  	SENSING_OF_XPOSITION: "indawo x",
  	SENSING_OF_YPOSITION: "indawo y",
  	SENSING_OF_DIRECTION: "ikhondo",
  	SENSING_OF_COSTUMENUMBER: "ikhostyum #",
  	LOOKS_COSTUMENUMBERNAME: "ikhostyum %1",
  	SENSING_OF_SIZE: "ubungakanani",
  	SENSING_OF_BACKDROPNAME: "ingama lomva",
  	LOOKS_BACKDROPNUMBERNAME: "umva %1",
  	SENSING_OF_BACKDROPNUMBER: "umva",
  	SOUND_VOLUME: "ubungakanani besandi",
  	"music.getTempo": "isantya",
  	SENSING_TOUCHINGOBJECT: "ukubamba %1?",
  	SENSING_TOUCHINGCOLOR: "ukubamba umbala %1?",
  	SENSING_COLORISTOUCHINGCOLOR: "umbala %1 ukubamba %2?",
  	SENSING_DISTANCETO: "umgama %1",
  	SENSING_ANSWER: "phendula",
  	SENSING_KEYPRESSED: "iqhosha %1 licofiwe?",
  	SENSING_MOUSEDOWN: "impuku phantsi?",
  	SENSING_MOUSEX: "impuku x",
  	SENSING_MOUSEY: "impuku y",
  	SENSING_SETDRAGMODE: "lungiselela ubume bokurhuqa %1",
  	SENSING_LOUDNESS: "ingxolo",
  	"videoSensing.videoOn": "ividiyo %1 malunga ne %2",
  	SENSING_TIMER: "isibali xesha",
  	SENSING_OF: "%1 ka %2",
  	SENSING_CURRENT: "eyangoku %1",
  	SENSING_DAYSSINCE2000: "intsuku ususela ku 2000",
  	SENSING_USERNAME: "igama lomsebenzisi",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "khetha ngokungacwangciswanga %1 ku %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 kunye %2",
  	OPERATORS_OR: "%1 okanye %2",
  	OPERATORS_NOT: "hayi %1",
  	OPERATORS_JOIN: "dibanisa %1 %2",
  	OPERATORS_LETTEROF: "unobumba %1 ku %2",
  	OPERATORS_LENGTH: "Ubude be %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "umjikelo %1",
  	OPERATORS_MATHOP: "%1 ka %2",
  	OPERATORS_CONTAINS: "%1 iqulathe %2?",
  	DATA_ITEMOFLIST: "into %1 ye %2",
  	DATA_ITEMNUMOFLIST: "into # ye %1 kwi %2",
  	DATA_LENGTHOFLIST: "Ubude be %1",
  	DATA_LISTCONTAINSITEM: "%1 iqulathe %2",
  	CONTROL_ELSE: "okunye",
  	SENSING_USERID: "isazisi somsebenzisi",
  	SENSING_LOUD: "ingxolo?",
  	"text2speech.speakAndWaitBlock": "thetha %1",
  	"text2speech.setVoiceBlock": "lungiselela ilizwi libe %1",
  	"text2speech.setLanguageBlock": "lungisa ulwimi lube %1",
  	"translate.translateBlock": "tolika %1 abe %2",
  	"translate.viewerLanguage": "ulwimi",
  	"makeymakey.whenKeyPressed": "xa %1 licofiwe",
  	"makeymakey.whenKeysPressedInOrder": "xa %1 licofwe ngendlela",
  	"microbit.whenButtonPressed": "xa %1 iqhosha licofiwe",
  	"microbit.isButtonPressed": "%1 qhosha licofiwe?",
  	"microbit.whenGesture": "xa %1",
  	"microbit.displaySymbol": "Bonisa %1",
  	"microbit.displayText": "bonisa umbhalo %1",
  	"microbit.clearDisplay": "ukubonisa okucacileyo",
  	"microbit.whenTilted": "xa ikekele %1",
  	"microbit.isTilted": "kekele %1?",
  	"microbit.tiltAngle": "kekele i-engile %1",
  	"microbit.whenPinConnected": "xa i-pini %1 Iqhagashelanisiwe",
  	"ev3.motorTurnClockwise": "imoto %1 jonga ngapha %2 imizuzwana",
  	"ev3.motorTurnCounterClockwise": "imoto %1 jongisa ngaphaya %2 mizuzwana",
  	"ev3.motorSetPower": "imoto %1 lungiselela amadla %2 %",
  	"ev3.getMotorPosition": "imoto %1 indawo",
  	"ev3.whenButtonPressed": "xa iqosha %1 licofiwe",
  	"ev3.whenDistanceLessThan": "xa umgama < %1",
  	"ev3.whenBrightnessLessThan": "xa ukuqaqamba < %1",
  	"ev3.buttonPressed": "iqosha %1 lIcofiwe?",
  	"ev3.getDistance": "umgama",
  	"ev3.getBrightness": "Ukuqaqamba",
  	"ev3.beepNote": "ukuqaphle iBEEP %1 kanga %2 mizuzwana",
  	"wedo2.motorOn": "jija %1 idume",
  	"wedo2.motorOff": "jija %1 icime",
  	"wedo2.startMotorPower": "lungiselela i %1 amandla abe %2",
  	"wedo2.setMotorDirection": "lungiselela i %1 isalathiso sibe %2",
  	"wedo2.whenDistance": "xa umgama %1 %2",
  	"wedo2.getDistance": "umgama",
  	"wedo2.motorOnFor": "jijaa %1 idume %2 yemizuzwana",
  	"wedo2.setLightHue": "lungiselela ukukhanya kombala kube %1",
  	"wedo2.playNoteFor": "dlala isandi %1 ixesha %2 mizuzwana",
  	"wedo2.whenTilted": "xa ikekele %1",
  	"wedo2.isTilted": "ikekele %1?",
  	"wedo2.getTiltAngle": "kwekelisa i-engile %1",
  	"gdxfor.whenGesture": "xa %1",
  	"gdxfor.whenForcePushedOrPulled": "xa isivo sinyanzeliso %1",
  	"gdxfor.getForce": "nyanzelisa",
  	"gdxfor.whenTilted": "xa ikekelisiwe %1",
  	"gdxfor.isTilted": "kekele %1?",
  	"gdxfor.getTilt": "kekelisa iengile %1",
  	"gdxfor.isFreeFalling": "iyawa?",
  	"gdxfor.getSpin": "jikelezisa isantya %1",
  	"gdxfor.getAcceleration": "ukwanda kwesantya %1",
  	"boost.motorOnFor": "cima imoto %1 idume %2 yemizuzwana",
  	"boost.motorOnForRotation": "guqula motor %1 eyenzelwe %2 ijikeleze",
  	"boost.motorOn": "jika imoto %1 idume",
  	"boost.motorOff": "jika imoto %1 icime",
  	"boost.setMotorPower": "lungiselela motor %1 isatya sibe %2 %",
  	"boost.setMotorDirection": "lungiselela motor %1 isalathiso %2",
  	"boost.getMotorPosition": "imoto %1 indawo",
  	"boost.whenColor": "xa %1 isitena siboniwe",
  	"boost.seeingColor": "ubona %1 isitena?",
  	"boost.whenTilted": "xa ikekelisiwe %1",
  	"boost.getTiltAngle": "kekelisaa iengile %1",
  	"boost.setLightHue": "lungiselela umbala wokukhanya %1"
  };
  var dropdowns$3 = {
  };
  var ignorelt$3 = [
  ];
  var soundEffects$3 = [
  	"inqanaba",
  	"bhala ekhohlo/ekunene"
  ];
  var microbitWhen$3 = [
  	"isuile",
  	"shukunyisiwe",
  	"yatsiba"
  ];
  var osis$3 = [
  	"eminye imibhalo kwispraythi"
  ];
  var definePrefix$3 = [
  	"chaza"
  ];
  var defineSuffix$3 = [
  ];
  var palette$3 = {
  	Motion: "intshukumo",
  	Looks: "ujonga",
  	Sound: "isandi",
  	Events: "Iziganeko",
  	Control: "Lawula",
  	Sensing: "ukuva",
  	Operators: "ababhexeshi",
  	Variables: "iiveriyebhl",
  	"My Blocks": "Ibhloko zam"
  };
  var math$3 = [
  	"abs",
  	"umgangatho",
  	"isilingi",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"phakathi",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$3 = {
  };
  var name$3 = "isiXhosa";
  var percentTranslated$3 = 100;
  var xh = {
  	commands: commands$3,
  	dropdowns: dropdowns$3,
  	ignorelt: ignorelt$3,
  	soundEffects: soundEffects$3,
  	microbitWhen: microbitWhen$3,
  	osis: osis$3,
  	definePrefix: definePrefix$3,
  	defineSuffix: defineSuffix$3,
  	palette: palette$3,
  	math: math$3,
  	aliases: aliases$3,
  	name: name$3,
  	percentTranslated: percentTranslated$3
  };

  var commands$2 = {
  	MOTION_MOVESTEPS: "移动 %1 步",
  	MOTION_TURNRIGHT: "右转 @turnRight %1 度",
  	MOTION_TURNLEFT: "左转 @turnLeft %1 度",
  	MOTION_POINTINDIRECTION: "面向 %1 方向",
  	MOTION_POINTTOWARDS: "面向 %1",
  	MOTION_GOTOXY: "移到 x: %1 y: %2",
  	MOTION_GOTO: "移到 %1",
  	MOTION_GLIDESECSTOXY: "在 %1 秒内滑行到 x: %2 y: %3",
  	MOTION_GLIDETO: "在 %1 秒内滑行到 %2",
  	MOTION_CHANGEXBY: "将x坐标增加 %1",
  	MOTION_SETX: "将x坐标设为 %1",
  	MOTION_CHANGEYBY: "将y坐标增加 %1",
  	MOTION_SETY: "将y坐标设为 %1",
  	MOTION_SETROTATIONSTYLE: "将旋转方式设为 %1",
  	LOOKS_SAYFORSECS: "说 %1 %2 秒",
  	LOOKS_SAY: "说 %1",
  	LOOKS_THINKFORSECS: "思考 %1 %2 秒",
  	LOOKS_THINK: "思考 %1",
  	LOOKS_SHOW: "显示",
  	LOOKS_HIDE: "隐藏",
  	LOOKS_SWITCHCOSTUMETO: "换成 %1 造型",
  	LOOKS_NEXTCOSTUME: "下一个造型",
  	LOOKS_NEXTBACKDROP_BLOCK: "下一个背景",
  	LOOKS_SWITCHBACKDROPTO: "换成 %1 背景",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "换成 %1 背景并等待",
  	LOOKS_CHANGEEFFECTBY: "将 %1 特效增加 %2",
  	LOOKS_SETEFFECTTO: "将 %1 特效设定为 %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "清除图形特效",
  	LOOKS_CHANGESIZEBY: "将大小增加 %1",
  	LOOKS_SETSIZETO: "将大小设为 %1",
  	LOOKS_GOTOFRONTBACK: "移到最 %1",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "%1 %2 层",
  	SOUND_PLAY: "播放声音 %1",
  	SOUND_CHANGEEFFECTBY: "将 %1 音效增加 %2",
  	SOUND_SETEFFECTO: "将 %1 音效设为 %2",
  	SOUND_CLEAREFFECTS: "清除音效",
  	SOUND_PLAYUNTILDONE: "播放声音 %1 等待播完",
  	SOUND_STOPALLSOUNDS: "停止所有声音",
  	"music.playDrumForBeats": "击打 %1 %2 拍",
  	"music.restForBeats": "休止%1拍",
  	"music.playNoteForBeats": "演奏音符%1%2拍",
  	"music.setInstrument": "将乐器设为 %1",
  	SOUND_CHANGEVOLUMEBY: "将音量增加 %1",
  	SOUND_SETVOLUMETO: "将音量设为 %1%",
  	"music.changeTempo": "将演奏速度增加%1",
  	"music.setTempo": "将演奏速度设定为%1",
  	"pen.clear": "全部擦除",
  	"pen.stamp": "图章",
  	"pen.penDown": "落笔",
  	"pen.penUp": "抬笔",
  	"pen.setColor": "将笔的颜色设为%1",
  	"pen.changeHue": "将笔的颜色增加%1",
  	"pen.setColorParam": "将笔的 %1 设为%2",
  	"pen.changeColorParam": "将笔的 %1 增加%2",
  	"pen.setHue": "将笔的颜色设为%1",
  	"pen.changeShade": "将笔的亮度增加%1",
  	"pen.setShade": "将笔的亮度设为%1",
  	"pen.changeSize": "将笔的粗细增加%1",
  	"pen.setSize": "将笔的粗细设为%1",
  	EVENT_WHENFLAGCLICKED: "当 @greenFlag 被点击",
  	EVENT_WHENKEYPRESSED: "当按下 %1 键",
  	EVENT_WHENTHISSPRITECLICKED: "当角色被点击",
  	EVENT_WHENSTAGECLICKED: "当舞台被点击",
  	EVENT_WHENBACKDROPSWITCHESTO: "当背景换成 %1",
  	EVENT_WHENGREATERTHAN: "当 %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "当接收到 %1",
  	EVENT_BROADCAST: "广播 %1",
  	EVENT_BROADCASTANDWAIT: "广播 %1 并等待",
  	CONTROL_WAIT: "等待 %1 秒",
  	CONTROL_REPEAT: "重复执行 %1 次",
  	CONTROL_FOREVER: "重复执行",
  	CONTROL_IF: "如果 %1 那么",
  	CONTROL_WAITUNTIL: "等待 %1",
  	CONTROL_REPEATUNTIL: "重复执行直到 %1",
  	CONTROL_STOP: "停止 %1",
  	CONTROL_STARTASCLONE: "当作为克隆体启动时",
  	CONTROL_CREATECLONEOF: "克隆 %1",
  	CONTROL_DELETETHISCLONE: "删除此克隆体",
  	SENSING_ASKANDWAIT: "询问 %1 并等待",
  	"videoSensing.videoToggle": "%1摄像头",
  	"videoSensing.setVideoTransparency": "将视频透明度设为%1",
  	"videoSensing.whenMotionGreaterThan": "当视频运动 > %1",
  	SENSING_RESETTIMER: "计时器归零",
  	DATA_SETVARIABLETO: "将 %1 设为 %2",
  	DATA_CHANGEVARIABLEBY: "将 %1 增加 %2",
  	DATA_SHOWVARIABLE: "显示变量 %1",
  	DATA_HIDEVARIABLE: "隐藏变量 %1",
  	DATA_ADDTOLIST: "将 %1 加入 %2",
  	DATA_DELETEOFLIST: "删除 %2 的第 %1 项",
  	DATA_DELETEALLOFLIST: "删除 %1 的全部项目",
  	MOTION_IFONEDGEBOUNCE: "碰到边缘就反弹",
  	DATA_INSERTATLIST: "在 %3 的第 %2 项前插入 %1",
  	DATA_REPLACEITEMOFLIST: "将 %2 的第 %1 项替换为 %3",
  	DATA_SHOWLIST: "显示列表 %1",
  	DATA_HIDELIST: "隐藏列表 %1",
  	SENSING_OF_XPOSITION: "x 坐标",
  	SENSING_OF_YPOSITION: "y 坐标",
  	SENSING_OF_DIRECTION: "方向",
  	SENSING_OF_COSTUMENUMBER: "造型编号",
  	LOOKS_COSTUMENUMBERNAME: "造型 %1",
  	SENSING_OF_SIZE: "大小",
  	SENSING_OF_BACKDROPNAME: "背景名称",
  	LOOKS_BACKDROPNUMBERNAME: "背景 %1",
  	SENSING_OF_BACKDROPNUMBER: "背景编号",
  	SOUND_VOLUME: "音量",
  	"music.getTempo": "演奏速度",
  	SENSING_TOUCHINGOBJECT: "碰到 %1 ?",
  	SENSING_TOUCHINGCOLOR: "碰到颜色 %1 ?",
  	SENSING_COLORISTOUCHINGCOLOR: "颜色 %1 碰到 %2 ?",
  	SENSING_DISTANCETO: "到 %1 的距离",
  	SENSING_ANSWER: "回答",
  	SENSING_KEYPRESSED: "按下 %1 键?",
  	SENSING_MOUSEDOWN: "按下鼠标?",
  	SENSING_MOUSEX: "鼠标的x坐标",
  	SENSING_MOUSEY: "鼠标的y坐标",
  	SENSING_SETDRAGMODE: "将拖动模式设为 %1",
  	SENSING_LOUDNESS: "响度",
  	"videoSensing.videoOn": "相对于%2的视频%1",
  	SENSING_TIMER: "计时器",
  	SENSING_OF: "%2 的 %1",
  	SENSING_CURRENT: "当前时间的 %1",
  	SENSING_DAYSSINCE2000: "2000年至今的天数",
  	SENSING_USERNAME: "用户名",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "在 %1 和 %2 之间取随机数",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 与 %2",
  	OPERATORS_OR: "%1 或 %2",
  	OPERATORS_NOT: "%1 不成立",
  	OPERATORS_JOIN: "连接 %1 和 %2",
  	OPERATORS_LETTEROF: "%2 的第 %1 个字符",
  	OPERATORS_LENGTH: "%1 的字符数",
  	OPERATORS_MOD: "%1 除以 %2 的余数",
  	OPERATORS_ROUND: "四舍五入 %1",
  	OPERATORS_MATHOP: "%1 %2",
  	OPERATORS_CONTAINS: "%1 包含 %2 ?",
  	DATA_ITEMOFLIST: "%2 的第 %1 项",
  	DATA_ITEMNUMOFLIST: "%2 中第一个 %1 的编号",
  	DATA_LENGTHOFLIST: "%1 的项目数",
  	DATA_LISTCONTAINSITEM: "%1 包含 %2 ?",
  	CONTROL_ELSE: "否则",
  	SENSING_USERID: "用户id",
  	SENSING_LOUD: "响声？",
  	"text2speech.speakAndWaitBlock": "朗读 %1",
  	"text2speech.setVoiceBlock": "使用 %1 嗓音",
  	"text2speech.setLanguageBlock": "将朗读语言设置为%1",
  	"translate.translateBlock": "将 %1 译为 %2",
  	"translate.viewerLanguage": "访客语言",
  	"makeymakey.whenKeyPressed": "当按下 %1 键",
  	"makeymakey.whenKeysPressedInOrder": "当依次按下%1键时",
  	"microbit.whenButtonPressed": "当按下%1按钮",
  	"microbit.isButtonPressed": "按下%1按钮？",
  	"microbit.whenGesture": "当被%1",
  	"microbit.displaySymbol": "显示%1",
  	"microbit.displayText": "显示文本%1",
  	"microbit.clearDisplay": "清空屏幕",
  	"microbit.whenTilted": "当向%1倾斜",
  	"microbit.isTilted": "向%1倾斜？",
  	"microbit.tiltAngle": "向%1倾角",
  	"microbit.whenPinConnected": "当引脚%1接地",
  	"ev3.motorTurnClockwise": "马达%1正转%2秒",
  	"ev3.motorTurnCounterClockwise": "马达%1反转%2秒",
  	"ev3.motorSetPower": "马达%1功率设为%2%",
  	"ev3.getMotorPosition": "马达%1的位置",
  	"ev3.whenButtonPressed": "当按下按钮%1",
  	"ev3.whenDistanceLessThan": "当距离 < %1",
  	"ev3.whenBrightnessLessThan": "当亮度 < %1",
  	"ev3.buttonPressed": "按下按钮%1？",
  	"ev3.getDistance": "距离",
  	"ev3.getBrightness": "亮度",
  	"ev3.beepNote": "鸣笛%1%2秒",
  	"wedo2.motorOn": "开启%1",
  	"wedo2.motorOff": "关闭%1",
  	"wedo2.startMotorPower": "将%1功率设为%2",
  	"wedo2.setMotorDirection": "将%1转向设为%2",
  	"wedo2.whenDistance": "当距离%1%2",
  	"wedo2.getDistance": "距离",
  	"wedo2.motorOnFor": "开启%1%2秒",
  	"wedo2.setLightHue": "将灯光颜色设为%1",
  	"wedo2.playNoteFor": "演奏音符%1%2秒",
  	"wedo2.whenTilted": "当向%1倾斜",
  	"wedo2.isTilted": "向%1倾斜？",
  	"wedo2.getTiltAngle": "向%1倾角",
  	"gdxfor.whenGesture": "当传感器%1",
  	"gdxfor.whenForcePushedOrPulled": "当力传感器被%1",
  	"gdxfor.getForce": "受力",
  	"gdxfor.whenTilted": "当向%1倾斜",
  	"gdxfor.isTilted": "向%1倾斜？",
  	"gdxfor.getTilt": "向%1倾角",
  	"gdxfor.isFreeFalling": "自由落体？",
  	"gdxfor.getSpin": "向%1的旋转速度",
  	"gdxfor.getAcceleration": "向%1的加速度",
  	"boost.motorOnFor": "使马达 %1转动 %2 秒",
  	"boost.motorOnForRotation": "使马达 %1转动 %2 圈",
  	"boost.motorOn": "开启马达 %1",
  	"boost.motorOff": "关闭马达 %1",
  	"boost.setMotorPower": "将马达 %1 速度设为 %2%",
  	"boost.setMotorDirection": "将马达%1 方向设为 %2",
  	"boost.getMotorPosition": "马达 %1 位置",
  	"boost.whenColor": "当看到%1积木",
  	"boost.seeingColor": "看到 %1积木 ?",
  	"boost.whenTilted": "当向%1倾斜",
  	"boost.getTiltAngle": "向%1倾角",
  	"boost.setLightHue": "将灯光颜色设为%1"
  };
  var dropdowns$2 = {
  };
  var ignorelt$2 = [
  ];
  var soundEffects$2 = [
  	"音调",
  	"左右平衡"
  ];
  var microbitWhen$2 = [
  	"移动",
  	"晃动",
  	"抛起"
  ];
  var osis$2 = [
  	"该角色的其他脚本"
  ];
  var definePrefix$2 = [
  	"定义"
  ];
  var defineSuffix$2 = [
  ];
  var palette$2 = {
  	Motion: "运动",
  	Looks: "外观",
  	Sound: "声音",
  	Events: "事件",
  	Control: "控制",
  	Sensing: "侦测",
  	Operators: "运算",
  	Variables: "变量",
  	"My Blocks": "自制积木"
  };
  var math$2 = [
  	"绝对值",
  	"向下取整",
  	"向上取整",
  	"平方根",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$2 = {
  	"左转 %1 度": "MOTION_TURNLEFT",
  	"右转 %1 度": "MOTION_TURNRIGHT",
  	"点击绿旗时": "EVENT_WHENFLAGCLICKED",
  	"结束": "scratchblocks:end"
  };
  var name$2 = "简体中文";
  var percentTranslated$2 = 100;
  var zh_cn = {
  	commands: commands$2,
  	dropdowns: dropdowns$2,
  	ignorelt: ignorelt$2,
  	soundEffects: soundEffects$2,
  	microbitWhen: microbitWhen$2,
  	osis: osis$2,
  	definePrefix: definePrefix$2,
  	defineSuffix: defineSuffix$2,
  	palette: palette$2,
  	math: math$2,
  	aliases: aliases$2,
  	name: name$2,
  	percentTranslated: percentTranslated$2
  };

  var commands$1 = {
  	MOTION_MOVESTEPS: "移動 %1 點",
  	MOTION_TURNRIGHT: "右轉 @turnRight %1 度",
  	MOTION_TURNLEFT: "左轉 @turnLeft %1 度",
  	MOTION_POINTINDIRECTION: "面朝 %1 度",
  	MOTION_POINTTOWARDS: "面朝 %1 向",
  	MOTION_GOTOXY: "定位到 x:%1 y:%2",
  	MOTION_GOTO: "定位到 %1 位置",
  	MOTION_GLIDESECSTOXY: "滑行 %1 秒到 x:%2 y:%3",
  	MOTION_GLIDETO: "滑行 %1 秒到 %2 位置",
  	MOTION_CHANGEXBY: "x 改變 %1",
  	MOTION_SETX: "x 設為 %1",
  	MOTION_CHANGEYBY: "y 改變 %1",
  	MOTION_SETY: "y 設為 %1",
  	MOTION_SETROTATIONSTYLE: "迴轉方式設為 %1",
  	LOOKS_SAYFORSECS: "說出 %1 持續 %2 秒",
  	LOOKS_SAY: "說出 %1",
  	LOOKS_THINKFORSECS: "想著 %1 持續 %2 秒",
  	LOOKS_THINK: "想著 %1",
  	LOOKS_SHOW: "顯示",
  	LOOKS_HIDE: "隱藏",
  	LOOKS_SWITCHCOSTUMETO: "造型換成 %1",
  	LOOKS_NEXTCOSTUME: "造型換成下一個",
  	LOOKS_NEXTBACKDROP_BLOCK: "背景換成下一個",
  	LOOKS_SWITCHBACKDROPTO: "背景換成 %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "背景換成 %1 並等待",
  	LOOKS_CHANGEEFFECTBY: "圖像效果 %1 改變 %2",
  	LOOKS_SETEFFECTTO: "圖像效果 %1 設為 %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "圖像效果清除",
  	LOOKS_CHANGESIZEBY: "尺寸改變 %1",
  	LOOKS_SETSIZETO: "尺寸設為 %1 %",
  	LOOKS_GOTOFRONTBACK: "圖層移到 %1 層",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "圖層 %1 移 %2 層",
  	SOUND_PLAY: "播放音效 %1",
  	SOUND_CHANGEEFFECTBY: "聲音效果 %1 改變 %2",
  	SOUND_SETEFFECTO: "聲音效果 %1 設為 %2",
  	SOUND_CLEAREFFECTS: "聲音效果清除",
  	SOUND_PLAYUNTILDONE: "播放音效 %1 直到結束",
  	SOUND_STOPALLSOUNDS: "停播所有音效",
  	"music.playDrumForBeats": "演奏節拍 %1 %2 拍",
  	"music.restForBeats": "演奏休息 %1 拍",
  	"music.playNoteForBeats": "演奏音階 %1 %2 拍",
  	"music.setInstrument": "演奏樂器設為 %1",
  	SOUND_CHANGEVOLUMEBY: "音量改變 %1",
  	SOUND_SETVOLUMETO: "音量設為 %1%",
  	"music.changeTempo": "演奏速度改變 %1",
  	"music.setTempo": "演奏速度設為 %1",
  	"pen.clear": "筆跡全部清除",
  	"pen.stamp": "蓋章",
  	"pen.penDown": "下筆",
  	"pen.penUp": "停筆",
  	"pen.setColor": "筆跡顏色設為 %1",
  	"pen.changeHue": "筆跡顏色改變 %1",
  	"pen.setColorParam": "筆跡 %1 設為 %2",
  	"pen.changeColorParam": "筆跡 %1 改變 %2",
  	"pen.setHue": "筆跡顏色設為 %1",
  	"pen.changeShade": "筆跡亮度改變 %1",
  	"pen.setShade": "筆跡亮度設為 %1",
  	"pen.changeSize": "筆跡寬度改變 %1",
  	"pen.setSize": "筆跡寬度設為 %1",
  	EVENT_WHENFLAGCLICKED: "當 @greenFlag 被點擊",
  	EVENT_WHENKEYPRESSED: "當 %1 鍵被按下",
  	EVENT_WHENTHISSPRITECLICKED: "當角色被點擊",
  	EVENT_WHENSTAGECLICKED: "當舞台被點擊",
  	EVENT_WHENBACKDROPSWITCHESTO: "當背景換成 %1",
  	EVENT_WHENGREATERTHAN: "當 %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "當收到訊息 %1",
  	EVENT_BROADCAST: "廣播訊息 %1",
  	EVENT_BROADCASTANDWAIT: "廣播訊息 %1 並等待",
  	CONTROL_WAIT: "等待 %1 秒",
  	CONTROL_REPEAT: "重複 %1 次",
  	CONTROL_FOREVER: "重複無限次",
  	CONTROL_IF: "如果 %1 那麼",
  	CONTROL_WAITUNTIL: "等待直到 %1",
  	CONTROL_REPEATUNTIL: "重複直到 %1",
  	CONTROL_STOP: "停止 %1",
  	CONTROL_STARTASCLONE: "當分身產生",
  	CONTROL_CREATECLONEOF: "建立 %1 的分身",
  	CONTROL_DELETETHISCLONE: "分身刪除",
  	SENSING_ASKANDWAIT: "詢問 %1 並等待",
  	"videoSensing.videoToggle": "視訊設為 %1",
  	"videoSensing.setVideoTransparency": "視訊透明度設為 %1",
  	"videoSensing.whenMotionGreaterThan": "當視訊動作 > %1",
  	SENSING_RESETTIMER: "計時器重置",
  	DATA_SETVARIABLETO: "變數 %1 設為 %2",
  	DATA_CHANGEVARIABLEBY: "變數 %1 改變 %2",
  	DATA_SHOWVARIABLE: "變數 %1 顯示",
  	DATA_HIDEVARIABLE: "變數 %1 隱藏",
  	DATA_ADDTOLIST: "添加 %1 到 %2",
  	DATA_DELETEOFLIST: "刪除 %2 的第 %1 項",
  	DATA_DELETEALLOFLIST: "刪除 %1 的所有項目",
  	MOTION_IFONEDGEBOUNCE: "碰到邊緣就反彈",
  	DATA_INSERTATLIST: "插入 %1 到 %3 的第 %2 項",
  	DATA_REPLACEITEMOFLIST: "替換 %2 的第 %1 項為 %3",
  	DATA_SHOWLIST: "清單 %1 顯示",
  	DATA_HIDELIST: "清單 %1 隱藏",
  	SENSING_OF_XPOSITION: "x 座標",
  	SENSING_OF_YPOSITION: "y 座標",
  	SENSING_OF_DIRECTION: "方向",
  	SENSING_OF_COSTUMENUMBER: "造型編號",
  	LOOKS_COSTUMENUMBERNAME: "造型 %1",
  	SENSING_OF_SIZE: "尺寸",
  	SENSING_OF_BACKDROPNAME: "背景名稱",
  	LOOKS_BACKDROPNUMBERNAME: "背景 %1",
  	SENSING_OF_BACKDROPNUMBER: "背景編號",
  	SOUND_VOLUME: "音量",
  	"music.getTempo": "演奏速度",
  	SENSING_TOUCHINGOBJECT: "碰到 %1？",
  	SENSING_TOUCHINGCOLOR: "碰到顏色 %1？",
  	SENSING_COLORISTOUCHINGCOLOR: "顏色 %1 碰到 顏色 %2？",
  	SENSING_DISTANCETO: "與 %1 的間距",
  	SENSING_ANSWER: "詢問的答案",
  	SENSING_KEYPRESSED: "%1 鍵被按下？",
  	SENSING_MOUSEDOWN: "滑鼠鍵被按下？",
  	SENSING_MOUSEX: "鼠標的 x",
  	SENSING_MOUSEY: "鼠標的 y",
  	SENSING_SETDRAGMODE: "拖曳方式設為 %1",
  	SENSING_LOUDNESS: "聲音響度",
  	"videoSensing.videoOn": "%2 的視訊 %1",
  	SENSING_TIMER: "計時器",
  	SENSING_OF: "%2 的 %1",
  	SENSING_CURRENT: "目前時間的 %1",
  	SENSING_DAYSSINCE2000: "2000年迄今日數",
  	SENSING_USERNAME: "用戶名稱",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "隨機取數 %1 到 %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 且 %2",
  	OPERATORS_OR: "%1 或 %2",
  	OPERATORS_NOT: "%1 不成立",
  	OPERATORS_JOIN: "字串組合 %1 %2",
  	OPERATORS_LETTEROF: "字串 %2 的第 %1 字",
  	OPERATORS_LENGTH: "字串 %1 的長度",
  	OPERATORS_MOD: "%1 除以 %2 的餘數",
  	OPERATORS_ROUND: "四捨五入數值 %1",
  	OPERATORS_MATHOP: "%1 數值 %2",
  	OPERATORS_CONTAINS: "字串 %1 包含 %2？",
  	DATA_ITEMOFLIST: "%2 的第 %1 項",
  	DATA_ITEMNUMOFLIST: "%1 在 %2 裡的項目編號",
  	DATA_LENGTHOFLIST: "清單 %1 的長度",
  	DATA_LISTCONTAINSITEM: "清單 %1 包含 %2？",
  	CONTROL_ELSE: "否則",
  	SENSING_USERID: "用戶 ID",
  	SENSING_LOUD: "大聲？",
  	"text2speech.speakAndWaitBlock": "唸出 %1",
  	"text2speech.setVoiceBlock": "語音設為 %1",
  	"text2speech.setLanguageBlock": "語言設為 %1",
  	"translate.translateBlock": "文字 %1 翻譯成 %2",
  	"translate.viewerLanguage": "瀏覽者的語言",
  	"makeymakey.whenKeyPressed": "當 %1 按鈕被按下",
  	"makeymakey.whenKeysPressedInOrder": "當 %1 按鈕被依序按下",
  	"microbit.whenButtonPressed": "當按鈕 %1 被按下",
  	"microbit.isButtonPressed": "按鈕 %1 被按下？",
  	"microbit.whenGesture": "當 %1",
  	"microbit.displaySymbol": "顯示圖示 %1",
  	"microbit.displayText": "顯示文字 %1",
  	"microbit.clearDisplay": "清空畫面",
  	"microbit.whenTilted": "當傾斜 %1",
  	"microbit.isTilted": "傾斜 %1？",
  	"microbit.tiltAngle": "傾斜角度 %1",
  	"microbit.whenPinConnected": "當引腳 %1 接地",
  	"ev3.motorTurnClockwise": "馬達 埠%1 順時針旋轉 %2 秒",
  	"ev3.motorTurnCounterClockwise": "馬達 埠%1 逆時針旋轉 %2 秒",
  	"ev3.motorSetPower": "馬達 埠%1 動力設為 %2 %",
  	"ev3.getMotorPosition": "馬達 埠%1 轉向角度",
  	"ev3.whenButtonPressed": "當按鈕 %1 被按下",
  	"ev3.whenDistanceLessThan": "當距離 < %1",
  	"ev3.whenBrightnessLessThan": "當亮度 < %1",
  	"ev3.buttonPressed": "按鈕 %1 被按下？",
  	"ev3.getDistance": "距離",
  	"ev3.getBrightness": "亮度",
  	"ev3.beepNote": "演奏音階 %1 持續 %2 秒",
  	"wedo2.motorOn": "%1 啟動",
  	"wedo2.motorOff": "%1 停止",
  	"wedo2.startMotorPower": "%1 動力設為 %2",
  	"wedo2.setMotorDirection": "%1 方向設為 %2",
  	"wedo2.whenDistance": "當距離 %1 %2",
  	"wedo2.getDistance": "距離",
  	"wedo2.motorOnFor": "%1 啟動 持續 %2 秒",
  	"wedo2.setLightHue": "LED 顏色設為 %1",
  	"wedo2.playNoteFor": "演奏音階 %1 持續 %2 秒",
  	"wedo2.whenTilted": "當傾斜 %1",
  	"wedo2.isTilted": "傾斜 %1？",
  	"wedo2.getTiltAngle": "傾斜角度 %1",
  	"gdxfor.whenGesture": "當 %1",
  	"gdxfor.whenForcePushedOrPulled": "當重力感測器%1",
  	"gdxfor.getForce": "力量",
  	"gdxfor.whenTilted": "當傾斜 %1",
  	"gdxfor.isTilted": "傾斜 %1？",
  	"gdxfor.getTilt": "傾斜角度 %1",
  	"gdxfor.isFreeFalling": "自由掉落？",
  	"gdxfor.getSpin": "旋轉速度 %1",
  	"gdxfor.getAcceleration": "加速度 %1",
  	"boost.motorOnFor": "%1 啟動 持續 %2 秒",
  	"boost.motorOnForRotation": "%1 啟動 持續 %2 圈",
  	"boost.motorOn": "%1 啟動",
  	"boost.motorOff": "%1 停止",
  	"boost.setMotorPower": "%1 動力設為 %2 %",
  	"boost.setMotorDirection": "%1 方向設為 %2",
  	"boost.getMotorPosition": "%1 轉向角度",
  	"boost.whenColor": "當顏色 %1  被看到",
  	"boost.seeingColor": "看到顏色 %1？",
  	"boost.whenTilted": "當傾斜 %1",
  	"boost.getTiltAngle": "傾斜角度 %1",
  	"boost.setLightHue": "LED 顏色設為 %1"
  };
  var dropdowns$1 = {
  };
  var ignorelt$1 = [
  ];
  var soundEffects$1 = [
  	"音高",
  	"聲道左/右"
  ];
  var microbitWhen$1 = [
  	"移動",
  	"晃動",
  	"跳動"
  ];
  var osis$1 = [
  	"這個物件的其它程式"
  ];
  var definePrefix$1 = [
  	"定義"
  ];
  var defineSuffix$1 = [
  ];
  var palette$1 = {
  	Motion: "動作",
  	Looks: "外觀",
  	Sound: "音效",
  	Events: "事件",
  	Control: "控制",
  	Sensing: "偵測",
  	Operators: "運算",
  	Variables: "變數",
  	"My Blocks": "函式積木"
  };
  var math$1 = [
  	"絕對值",
  	"無條件捨去",
  	"無條件進位",
  	"平方根",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases$1 = {
  	"左轉 %1 度": "MOTION_TURNLEFT",
  	"右轉 %1 度": "MOTION_TURNRIGHT",
  	"當綠旗被點擊時": "EVENT_WHENFLAGCLICKED",
  	"結束": "scratchblocks:end"
  };
  var name$1 = "繁體中文";
  var percentTranslated$1 = 100;
  var zh_tw = {
  	commands: commands$1,
  	dropdowns: dropdowns$1,
  	ignorelt: ignorelt$1,
  	soundEffects: soundEffects$1,
  	microbitWhen: microbitWhen$1,
  	osis: osis$1,
  	definePrefix: definePrefix$1,
  	defineSuffix: defineSuffix$1,
  	palette: palette$1,
  	math: math$1,
  	aliases: aliases$1,
  	name: name$1,
  	percentTranslated: percentTranslated$1
  };

  var commands = {
  	MOTION_MOVESTEPS: "hambisa isinyathelo esingu %1",
  	MOTION_TURNRIGHT: "Phenduka @turnRight %1 ibanga",
  	MOTION_TURNLEFT: "Phenduka @turnLeft %1 ibanga",
  	MOTION_POINTINDIRECTION: "khomba ohlangothini %1",
  	MOTION_POINTTOWARDS: "khomba ubhekise %1",
  	MOTION_GOTOXY: "hamba uyeku x: %1 y: %2",
  	MOTION_GOTO: "hamba uyeku  %1",
  	MOTION_GLIDESECSTOXY: "ukushibilika %1 umzuzuwana kwi x: %2 y: %3",
  	MOTION_GLIDETO: "ukushibilika %1 umzuzuwana kwi %2",
  	MOTION_CHANGEXBY: "shintsha u-x ngoku %1",
  	MOTION_SETX: "lungisa u-x umbeke ku %1",
  	MOTION_CHANGEYBY: "shintsha u-y ngokuthi %1",
  	MOTION_SETY: "lungisa u-y ukuze %1",
  	MOTION_SETROTATIONSTYLE: "lungisa isitayela sokuzungezisa %1",
  	LOOKS_SAYFORSECS: "ithi %1 imizuzwana %2",
  	LOOKS_SAY: "ithi %1",
  	LOOKS_THINKFORSECS: "Cabanga %1 okwemizuzwana %2",
  	LOOKS_THINK: "cabanga %1",
  	LOOKS_SHOW: "khombisa",
  	LOOKS_HIDE: "fihla",
  	LOOKS_SWITCHCOSTUMETO: "shintsha impahla iyeku %1",
  	LOOKS_NEXTCOSTUME: "impahla elandelayo",
  	LOOKS_NEXTBACKDROP_BLOCK: "okwasemuva okulandelayo",
  	LOOKS_SWITCHBACKDROPTO: "shintsha okwasemuva ukuyise kwi %1",
  	LOOKS_SWITCHBACKDROPTOANDWAIT: "shintsha okwasemuva ukuse ku %1 besulinda",
  	LOOKS_CHANGEEFFECTBY: "shintsha  umphumela ongu %1 ngo  %2",
  	LOOKS_SETEFFECTTO: "beka  imiphumela ye %1 uye ku %2",
  	LOOKS_CLEARGRAPHICEFFECTS: "sula imiphumela yokuqhafaza",
  	LOOKS_CHANGESIZEBY: "shintsha ubukhulu nge %1",
  	LOOKS_SETSIZETO: "Lungisa ubukhulu ubuyise ku %1",
  	LOOKS_GOTOFRONTBACK: "hamba ku %1 ngesendlalelo",
  	LOOKS_GOFORWARDBACKWARDLAYERS: "buyela %1 %2 ngesendlalelo",
  	SOUND_PLAY: "qala umsindo %1",
  	SOUND_CHANGEEFFECTBY: "Shintsha %1 womthelela ngo %2",
  	SOUND_SETEFFECTO: "Lungisa %1 umthelela ngo %2",
  	SOUND_CLEAREFFECTS: "susa umthelela womsindo",
  	SOUND_PLAYUNTILDONE: "dlala umsindo %1 uze uqede",
  	SOUND_STOPALLSOUNDS: "misa yonke imisindo",
  	"music.playDrumForBeats": "dlala idilamu %1 le %2 ibhithi",
  	"music.restForBeats": "okuseleyo nge %1 bhithi",
  	"music.playNoteForBeats": "dlala inothi %1 le %2 bhithi",
  	"music.setInstrument": "hlela isikhali sokusebenza %1",
  	SOUND_CHANGEVOLUMEBY: "shintsha umsindo ngokuthi %1",
  	SOUND_SETVOLUMETO: "lungisa inani lo msindo ukuze %1%",
  	"music.changeTempo": "shintsha iThempo nge %1",
  	"music.setTempo": "hlela ithempo ku %1",
  	"pen.clear": "kususe konke",
  	"pen.stamp": "isitembu",
  	"pen.penDown": "ipeni phansi",
  	"pen.penUp": "ipeni phezulu",
  	"pen.setColor": "hlela umbala wepeni %1",
  	"pen.changeHue": "shintsha umbala wepeni nge %1",
  	"pen.setColorParam": "hlela ipeni %1 uliyise kwi %2",
  	"pen.changeColorParam": "shintsha ipeni %1 nge %2",
  	"pen.setHue": "hlela umbala wepeni uwuyise %1",
  	"pen.changeShade": "shintsha ipeni usithe nge %1",
  	"pen.setShade": "hlela ukusitha ngepeni ukuyise %1",
  	"pen.changeSize": "shintsha usayizi wepeni ngo %1",
  	"pen.setSize": "hlela ubukhulu bepeni ubuyise %1",
  	EVENT_WHENFLAGCLICKED: "uma @greenFlag kuchofoziwe",
  	EVENT_WHENKEYPRESSED: "uma sekucindezelwe ukhiye %1",
  	EVENT_WHENTHISSPRITECLICKED: "Uma lomlingisi echofoziwe",
  	EVENT_WHENSTAGECLICKED: "uma isiteji ichofoziwe",
  	EVENT_WHENBACKDROPSWITCHESTO: "lapho okwasemuva kushintshela ku %1",
  	EVENT_WHENGREATERTHAN: "uma %1 > %2",
  	EVENT_WHENBROADCASTRECEIVED: "lapho ngithola %1",
  	EVENT_BROADCAST: "sakaza %1",
  	EVENT_BROADCASTANDWAIT: "sakaza %1 bese ulinda",
  	CONTROL_WAIT: "linda %1 umzuzuwana",
  	CONTROL_REPEAT: "phinda %1",
  	CONTROL_FOREVER: "phakade",
  	CONTROL_IF: "uma %1 lapho ke",
  	CONTROL_WAITUNTIL: "linda kuze kube  %1",
  	CONTROL_REPEATUNTIL: "phinda kuze kube %1",
  	CONTROL_STOP: "ima %1",
  	CONTROL_STARTASCLONE: "lapho ngiqala njengo mfanekiso",
  	CONTROL_CREATECLONEOF: "akha okufanayo %1",
  	CONTROL_DELETETHISCLONE: "Susa lumfanekiso",
  	SENSING_ASKANDWAIT: "buza %1 futhi linda",
  	"videoSensing.videoToggle": "phendula ividiyo %1",
  	"videoSensing.setVideoTransparency": "hlela ukubonakala kweVidiyo ukuyise %1",
  	"videoSensing.whenMotionGreaterThan": "umakunyakaza ividiyo > %1",
  	SENSING_RESETTIMER: "qalakabusha isibali sikhathi",
  	DATA_SETVARIABLETO: "lungisa %1 sibe ku %2",
  	DATA_CHANGEVARIABLEBY: "shintsha %1 ngoku %2",
  	DATA_SHOWVARIABLE: "khombisa okuguqukayo nge %1",
  	DATA_HIDEVARIABLE: "fihla okuguqukayo ngokwe %1",
  	DATA_ADDTOLIST: "engeza %1 kuya %2",
  	DATA_DELETEOFLIST: "susa %1 ka %2",
  	DATA_DELETEALLOFLIST: "susa konke %1",
  	MOTION_IFONEDGEBOUNCE: "uma isenigcupheni, gxuma",
  	DATA_INSERTATLIST: "faka  u %1 ku %2 ka %3",
  	DATA_REPLACEITEMOFLIST: "faka okunye esikhundleni %1 ku %2 ngo %3",
  	DATA_SHOWLIST: "khombisa uhlu %1",
  	DATA_HIDELIST: "fihla uluhlu le %1",
  	SENSING_OF_XPOSITION: "indawo ka-x",
  	SENSING_OF_YPOSITION: "Indawo ka-y",
  	SENSING_OF_DIRECTION: "indlela",
  	SENSING_OF_COSTUMENUMBER: "impahla #",
  	LOOKS_COSTUMENUMBERNAME: "impahla %1",
  	SENSING_OF_SIZE: "ubukhulu",
  	SENSING_OF_BACKDROPNAME: "igama lokwasemuva",
  	LOOKS_BACKDROPNUMBERNAME: "okwasemuva %1",
  	SENSING_OF_BACKDROPNUMBER: "okwasemuva #",
  	SOUND_VOLUME: "umsindo",
  	"music.getTempo": "izinsimbi",
  	SENSING_TOUCHINGOBJECT: "ethinta%1?",
  	SENSING_TOUCHINGCOLOR: "kuthinta umbala %1 ?",
  	SENSING_COLORISTOUCHINGCOLOR: "umbala %1 uthinta %2?",
  	SENSING_DISTANCETO: "ibanga eliya %1",
  	SENSING_ANSWER: "phendula / Impendulo",
  	SENSING_KEYPRESSED: "ukhiye %1 ucindezelwe?",
  	SENSING_MOUSEDOWN: "phansi i mouse",
  	SENSING_MOUSEX: "mouse x",
  	SENSING_MOUSEY: "mouse y",
  	SENSING_SETDRAGMODE: "lungisa isimo sokuhudula %1",
  	SENSING_LOUDNESS: "ubukhulu bomsindo",
  	"videoSensing.videoOn": "vidiyo %1 ku %2",
  	SENSING_TIMER: "Isibali sikhathi",
  	SENSING_OF: "%1 kwa%2",
  	SENSING_CURRENT: "manje  %1",
  	SENSING_DAYSSINCE2000: "izinsuku kusukela 2000",
  	SENSING_USERNAME: "igama elisebenzile",
  	OPERATORS_ADD: "%1 + %2",
  	OPERATORS_SUBTRACT: "%1 - %2",
  	OPERATORS_MULTIPLY: "%1 * %2",
  	OPERATORS_DIVIDE: "%1 / %2",
  	OPERATORS_RANDOM: "khetha noma ikuphi %1 kuya %2",
  	OPERATORS_LT: "%1 < %2",
  	OPERATORS_EQUALS: "%1 = %2",
  	OPERATORS_GT: "%1 > %2",
  	OPERATORS_AND: "%1 futhi %2",
  	OPERATORS_OR: "%1 noma %2",
  	OPERATORS_NOT: "hhayi %1",
  	OPERATORS_JOIN: "hlanganisa %1 %2 / xhuma/ bandakanya",
  	OPERATORS_LETTEROF: "usonhlamvu %1  ka %2",
  	OPERATORS_LENGTH: "ubude be %1",
  	OPERATORS_MOD: "%1 mod %2",
  	OPERATORS_ROUND: "yingiliza %1",
  	OPERATORS_MATHOP: "%1 kwa %2",
  	OPERATORS_CONTAINS: "%1 iqukethe %2",
  	DATA_ITEMOFLIST: "into %1 ye %2",
  	DATA_ITEMNUMOFLIST: "into # yaku %1 ku %2",
  	DATA_LENGTHOFLIST: "ubude be %1",
  	DATA_LISTCONTAINSITEM: "%1 iqukethe %2",
  	CONTROL_ELSE: "noma",
  	SENSING_USERID: "umsebenzisi ID",
  	SENSING_LOUD: "kukhulu umsindo? / Umsindo uphezulu?",
  	"text2speech.speakAndWaitBlock": "khuluma %1",
  	"text2speech.setVoiceBlock": "hlela izwi uliyise %1",
  	"text2speech.setLanguageBlock": "hlela ulimi uliyise %1",
  	"translate.translateBlock": "humusha %1 uyise %2",
  	"translate.viewerLanguage": "ulimi",
  	"makeymakey.whenKeyPressed": "Uma %1kucindezeliwe",
  	"makeymakey.whenKeysPressedInOrder": "Uma %1kucindezeliwe ngendlela",
  	"microbit.whenButtonPressed": "Inkinobho %1 mayicindezeliwe",
  	"microbit.isButtonPressed": "%1 inkinobho icindezelwe?",
  	"microbit.whenGesture": "uma %1",
  	"microbit.displaySymbol": "Isibonisi %1",
  	"microbit.displayText": "Isibonisi samagama abhaliwe %1",
  	"microbit.clearDisplay": "isiboniso esicacile",
  	"microbit.whenTilted": "uma kutshesiwe %1",
  	"microbit.isTilted": "Itshekile %1?",
  	"microbit.tiltAngle": "tshekisa engeli %1",
  	"microbit.whenPinConnected": "uma uphini %1 uxhunyiwe",
  	"ev3.motorTurnClockwise": "Imotho %1 ayijike ngalendlela isikhathi %2Imizuzwana",
  	"ev3.motorTurnCounterClockwise": "imotho %1 ayijike ngaleyandlela isikhathi %2 imizuzwana",
  	"ev3.motorSetPower": "hlela amandla %2% eMotho %1",
  	"ev3.getMotorPosition": "indawo yemotho %1",
  	"ev3.whenButtonPressed": "Inkinobho %1 mayicindezeliwe",
  	"ev3.whenDistanceLessThan": "uma ibanga < %1",
  	"ev3.whenBrightnessLessThan": "uma ukukhanya <%1",
  	"ev3.buttonPressed": "inkinobho %1 ecindezeliwe?",
  	"ev3.getDistance": "ibanga",
  	"ev3.getBrightness": "ukukhanya",
  	"ev3.beepNote": "Inothi beep %1 isikhathi %2 imizuzwana",
  	"wedo2.motorOn": "yivule %1",
  	"wedo2.motorOff": "yicishe %1",
  	"wedo2.startMotorPower": "hlela %1 amandla uwayise %2",
  	"wedo2.setMotorDirection": "hlela indlela ye %1 ukuyise %2",
  	"wedo2.whenDistance": "uma ibanga %1 %2",
  	"wedo2.getDistance": "ibanga",
  	"wedo2.motorOnFor": "yivule %1 isikhathi %2 imizuzwana",
  	"wedo2.setLightHue": "hlela ukhanya kombala ukuyise %1",
  	"wedo2.playNoteFor": "dlala inothi %1 isikathi %2 imizuzwana",
  	"wedo2.whenTilted": "Umakutshekisiwe %1",
  	"wedo2.isTilted": "itshekile %1?",
  	"wedo2.getTiltAngle": "tshekisa engeli  %1",
  	"gdxfor.whenGesture": "uma %1",
  	"gdxfor.whenForcePushedOrPulled": "Uma kuphushwe isensor %1",
  	"gdxfor.getForce": "Ngamandla",
  	"gdxfor.whenTilted": "Makutshekisiwe %1",
  	"gdxfor.isTilted": "Kutshekisiwe %1?",
  	"gdxfor.getTilt": "Tshekisa engeli %1",
  	"gdxfor.isFreeFalling": "Kuyawa ?",
  	"gdxfor.getSpin": "ukuphenduka ngejubane %1",
  	"gdxfor.getAcceleration": "Ukusheshisa %1",
  	"boost.motorOnFor": "Jikisa imoto %1 isikhathi %2 imizuzwana",
  	"boost.motorOnForRotation": "Jikisa imoto%1 Uku %2 Ukuphendukisa",
  	"boost.motorOn": "Jikisa imoto %1 uyivule",
  	"boost.motorOff": "Jikisa imoto %1 Uyivale",
  	"boost.setMotorPower": "Lungisa imotor %1 ijubane uliyise %2",
  	"boost.setMotorDirection": "lungisa imoto %1 indlela %2",
  	"boost.getMotorPosition": "Moto %1 indawo",
  	"boost.whenColor": "Uma %1 ukubonakala kwe brick",
  	"boost.seeingColor": "Ukubona %1 Brick?",
  	"boost.whenTilted": "Umakutshekisiwe %1",
  	"boost.getTiltAngle": "tshekisa engeli  %1",
  	"boost.setLightHue": "hlela ukhanya kombala ukuyise %1"
  };
  var dropdowns = {
  };
  var ignorelt = [
  ];
  var soundEffects = [
  	"izinga elidlulele / iphimbo",
  	"jikisa isinxele-nangakwesokudla"
  ];
  var microbitWhen = [
  	"nyakazile",
  	"ukunyakaziswa",
  	"gxumile"
  ];
  var osis = [
  	"eminye imibhalo kumlingisi"
  ];
  var definePrefix = [
  	"chaza"
  ];
  var defineSuffix = [
  ];
  var palette = {
  	Motion: "Ukunyakaza",
  	Looks: "Ukubukeka",
  	Sound: "Umsindo",
  	Events: "Izehlakalo",
  	Control: "Lawula",
  	Sensing: "Ukuzwa",
  	Operators: "Abahambisayo",
  	Variables: "okuguqukayo",
  	"My Blocks": "Amabhulokisi ami"
  };
  var math = [
  	"abs",
  	"phansi",
  	"uphahla",
  	"sqrt",
  	"sin",
  	"cos",
  	"tan",
  	"asin",
  	"acos",
  	"atan",
  	"ln",
  	"log",
  	"e ^",
  	"10 ^"
  ];
  var aliases = {
  };
  var name = "isiZulu";
  var percentTranslated = 100;
  var zu = {
  	commands: commands,
  	dropdowns: dropdowns,
  	ignorelt: ignorelt,
  	soundEffects: soundEffects,
  	microbitWhen: microbitWhen,
  	osis: osis,
  	definePrefix: definePrefix,
  	defineSuffix: defineSuffix,
  	palette: palette,
  	math: math,
  	aliases: aliases,
  	name: name,
  	percentTranslated: percentTranslated
  };

  var languages = {
    ab: ab,
    af: af,
    am: am,
    an: an,
    ar: ar,
    ast: ast,
    az: az,
    be: be,
    bg: bg,
    bn: bn,
    ca: ca,
    ckb: ckb,
    cs: cs,
    cy: cy,
    da: da,
    de: de,
    el: el,
    eo: eo,
    es: es,
    es_419: es_419,
    et: et,
    eu: eu,
    fa: fa,
    fi: fi,
    fil: fil,
    fr: fr,
    fy: fy,
    ga: ga,
    gd: gd,
    gl: gl,
    ha: ha,
    he: he,
    hr: hr,
    ht: ht,
    hu: hu,
    hy: hy,
    id: id,
    is: is,
    it: it,
    ja: ja,
    ja_Hira: ja_Hira,
    ka: ka,
    kk: kk,
    km: km,
    ko: ko,
    ku: ku,
    lt: lt,
    lv: lv,
    mi: mi,
    mn: mn,
    nb: nb,
    nl: nl,
    nn: nn,
    nso: nso,
    oc: oc,
    or: or,
    pl: pl,
    pt: pt,
    pt_br: pt_br,
    qu: qu,
    rap: rap,
    ro: ro,
    ru: ru,
    sk: sk,
    sl: sl,
    sr: sr,
    sv: sv,
    sw: sw,
    th: th,
    tn: tn,
    tr: tr,
    uk: uk,
    uz: uz,
    vi: vi,
    xh: xh,
    zh_cn: zh_cn,
    zh_tw: zh_tw,
    zu: zu
  };

  window.scratchblocks.loadLanguages(languages);

})();
//# sourceMappingURL=translations-all.js.map
